#line 1 "ad_x86.cpp"
//
// Copyright (c) 2003, 2024, Oracle and/or its affiliates. All rights reserved.
// DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
//
// This code is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License version 2 only, as
// published by the Free Software Foundation.
//
// This code is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// version 2 for more details (a copy is included in the LICENSE file that
// accompanied this code).
//
// You should have received a copy of the GNU General Public License version
// 2 along with this work; if not, write to the Free Software Foundation,
// Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
//
// Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
// or visit www.oracle.com if you need additional information or have any
// questions.
//
//

// Machine Generated File.  Do Not Edit!

#include "precompiled.hpp"
#include "adfiles/adGlobals_x86.hpp"
#include "adfiles/ad_x86.hpp"
#include "memory/allocation.inline.hpp"
#include "code/codeCache.hpp"
#include "code/compiledIC.hpp"
#include "code/nativeInst.hpp"
#include "code/vmreg.inline.hpp"
#include "gc/shared/collectedHeap.inline.hpp"
#include "oops/compressedOops.hpp"
#include "oops/markWord.hpp"
#include "oops/method.hpp"
#include "oops/oop.inline.hpp"
#include "opto/c2_MacroAssembler.hpp"
#include "opto/cfgnode.hpp"
#include "opto/intrinsicnode.hpp"
#include "opto/locknode.hpp"
#include "opto/opcodes.hpp"
#include "opto/regalloc.hpp"
#include "opto/regmask.hpp"
#include "opto/runtime.hpp"
#include "runtime/safepointMechanism.hpp"
#include "runtime/sharedRuntime.hpp"
#include "runtime/stubRoutines.hpp"
#include "utilities/growableArray.hpp"
#include "utilities/powerOfTwo.hpp"

//SourceForm

#line 455 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

#define   RELOC_IMM64    Assembler::imm_operand
#define   RELOC_DISP32   Assembler::disp32_operand

#define __ masm->

RegMask _ANY_REG_mask;
RegMask _PTR_REG_mask;
RegMask _PTR_REG_NO_RBP_mask;
RegMask _PTR_NO_RAX_REG_mask;
RegMask _PTR_NO_RAX_RBX_REG_mask;
RegMask _LONG_REG_mask;
RegMask _LONG_NO_RAX_RDX_REG_mask;
RegMask _LONG_NO_RCX_REG_mask;
RegMask _LONG_NO_RBP_R13_REG_mask;
RegMask _INT_REG_mask;
RegMask _INT_NO_RAX_RDX_REG_mask;
RegMask _INT_NO_RCX_REG_mask;
RegMask _INT_NO_RBP_R13_REG_mask;
RegMask _FLOAT_REG_mask;
RegMask _STACK_OR_PTR_REG_mask;
RegMask _STACK_OR_LONG_REG_mask;
RegMask _STACK_OR_INT_REG_mask;

static bool need_r12_heapbase() {
  return UseCompressedOops;
}

void reg_mask_init() {
  constexpr Register egprs[] = {r16, r17, r18, r19, r20, r21, r22, r23, r24, r25, r26, r27, r28, r29, r30, r31};

  // _ALL_REG_mask is generated by adlc from the all_reg register class below.
  // We derive a number of subsets from it.
  _ANY_REG_mask = _ALL_REG_mask;

  if (PreserveFramePointer) {
    _ANY_REG_mask.Remove(OptoReg::as_OptoReg(rbp->as_VMReg()));
    _ANY_REG_mask.Remove(OptoReg::as_OptoReg(rbp->as_VMReg()->next()));
  }
  if (need_r12_heapbase()) {
    _ANY_REG_mask.Remove(OptoReg::as_OptoReg(r12->as_VMReg()));
    _ANY_REG_mask.Remove(OptoReg::as_OptoReg(r12->as_VMReg()->next()));
  }

  _PTR_REG_mask = _ANY_REG_mask;
  _PTR_REG_mask.Remove(OptoReg::as_OptoReg(rsp->as_VMReg()));
  _PTR_REG_mask.Remove(OptoReg::as_OptoReg(rsp->as_VMReg()->next()));
  _PTR_REG_mask.Remove(OptoReg::as_OptoReg(r15->as_VMReg()));
  _PTR_REG_mask.Remove(OptoReg::as_OptoReg(r15->as_VMReg()->next()));
  if (!UseAPX) {
    for (uint i = 0; i < sizeof(egprs)/sizeof(Register); i++) {
      _PTR_REG_mask.Remove(OptoReg::as_OptoReg(egprs[i]->as_VMReg()));
      _PTR_REG_mask.Remove(OptoReg::as_OptoReg(egprs[i]->as_VMReg()->next()));
    }
  }

  _STACK_OR_PTR_REG_mask = _PTR_REG_mask;
  _STACK_OR_PTR_REG_mask.OR(STACK_OR_STACK_SLOTS_mask());

  _PTR_REG_NO_RBP_mask = _PTR_REG_mask;
  _PTR_REG_NO_RBP_mask.Remove(OptoReg::as_OptoReg(rbp->as_VMReg()));
  _PTR_REG_NO_RBP_mask.Remove(OptoReg::as_OptoReg(rbp->as_VMReg()->next()));

  _PTR_NO_RAX_REG_mask = _PTR_REG_mask;
  _PTR_NO_RAX_REG_mask.Remove(OptoReg::as_OptoReg(rax->as_VMReg()));
  _PTR_NO_RAX_REG_mask.Remove(OptoReg::as_OptoReg(rax->as_VMReg()->next()));

  _PTR_NO_RAX_RBX_REG_mask = _PTR_NO_RAX_REG_mask;
  _PTR_NO_RAX_RBX_REG_mask.Remove(OptoReg::as_OptoReg(rbx->as_VMReg()));
  _PTR_NO_RAX_RBX_REG_mask.Remove(OptoReg::as_OptoReg(rbx->as_VMReg()->next()));


  _LONG_REG_mask = _PTR_REG_mask;
  _STACK_OR_LONG_REG_mask = _LONG_REG_mask;
  _STACK_OR_LONG_REG_mask.OR(STACK_OR_STACK_SLOTS_mask());

  _LONG_NO_RAX_RDX_REG_mask = _LONG_REG_mask;
  _LONG_NO_RAX_RDX_REG_mask.Remove(OptoReg::as_OptoReg(rax->as_VMReg()));
  _LONG_NO_RAX_RDX_REG_mask.Remove(OptoReg::as_OptoReg(rax->as_VMReg()->next()));
  _LONG_NO_RAX_RDX_REG_mask.Remove(OptoReg::as_OptoReg(rdx->as_VMReg()));
  _LONG_NO_RAX_RDX_REG_mask.Remove(OptoReg::as_OptoReg(rdx->as_VMReg()->next()));

  _LONG_NO_RCX_REG_mask = _LONG_REG_mask;
  _LONG_NO_RCX_REG_mask.Remove(OptoReg::as_OptoReg(rcx->as_VMReg()));
  _LONG_NO_RCX_REG_mask.Remove(OptoReg::as_OptoReg(rcx->as_VMReg()->next()));

  _LONG_NO_RBP_R13_REG_mask = _LONG_REG_mask;
  _LONG_NO_RBP_R13_REG_mask.Remove(OptoReg::as_OptoReg(rbp->as_VMReg()));
  _LONG_NO_RBP_R13_REG_mask.Remove(OptoReg::as_OptoReg(rbp->as_VMReg()->next()));
  _LONG_NO_RBP_R13_REG_mask.Remove(OptoReg::as_OptoReg(r13->as_VMReg()));
  _LONG_NO_RBP_R13_REG_mask.Remove(OptoReg::as_OptoReg(r13->as_VMReg()->next()));

  _INT_REG_mask = _ALL_INT_REG_mask;
  if (!UseAPX) {
    for (uint i = 0; i < sizeof(egprs)/sizeof(Register); i++) {
      _INT_REG_mask.Remove(OptoReg::as_OptoReg(egprs[i]->as_VMReg()));
    }
  }

  if (PreserveFramePointer) {
    _INT_REG_mask.Remove(OptoReg::as_OptoReg(rbp->as_VMReg()));
  }
  if (need_r12_heapbase()) {
    _INT_REG_mask.Remove(OptoReg::as_OptoReg(r12->as_VMReg()));
  }

  _STACK_OR_INT_REG_mask = _INT_REG_mask;
  _STACK_OR_INT_REG_mask.OR(STACK_OR_STACK_SLOTS_mask());

  _INT_NO_RAX_RDX_REG_mask = _INT_REG_mask;
  _INT_NO_RAX_RDX_REG_mask.Remove(OptoReg::as_OptoReg(rax->as_VMReg()));
  _INT_NO_RAX_RDX_REG_mask.Remove(OptoReg::as_OptoReg(rdx->as_VMReg()));

  _INT_NO_RCX_REG_mask = _INT_REG_mask;
  _INT_NO_RCX_REG_mask.Remove(OptoReg::as_OptoReg(rcx->as_VMReg()));

  _INT_NO_RBP_R13_REG_mask = _INT_REG_mask;
  _INT_NO_RBP_R13_REG_mask.Remove(OptoReg::as_OptoReg(rbp->as_VMReg()));
  _INT_NO_RBP_R13_REG_mask.Remove(OptoReg::as_OptoReg(r13->as_VMReg()));

  // _FLOAT_REG_LEGACY_mask/_FLOAT_REG_EVEX_mask is generated by adlc
  // from the float_reg_legacy/float_reg_evex register class.
  _FLOAT_REG_mask = VM_Version::supports_evex() ? _FLOAT_REG_EVEX_mask : _FLOAT_REG_LEGACY_mask;
}

static bool generate_vzeroupper(Compile* C) {
  return (VM_Version::supports_vzeroupper() && (C->max_vector_size() > 16 || C->clear_upper_avx() == true)) ? true: false;  // Generate vzeroupper
}

static int clear_avx_size() {
  return generate_vzeroupper(Compile::current()) ? 3: 0;  // vzeroupper
}

// !!!!! Special hack to get all types of calls to specify the byte offset
//       from the start of the call to the point where the return address
//       will point.
int MachCallStaticJavaNode::ret_addr_offset()
{
  int offset = 5; // 5 bytes from start of call to where return address points
  offset += clear_avx_size();
  return offset;
}

int MachCallDynamicJavaNode::ret_addr_offset()
{
  int offset = 15; // 15 bytes from start of call to where return address points
  offset += clear_avx_size();
  return offset;
}

int MachCallRuntimeNode::ret_addr_offset() {
  int offset = 13; // movq r10,#addr; callq (r10)
  if (this->ideal_Opcode() != Op_CallLeafVector) {
    offset += clear_avx_size();
  }
  return offset;
}
//
// Compute padding required for nodes which need alignment
//

// The address of the call instruction needs to be 4-byte aligned to
// ensure that it does not span a cache line so that it can be patched.
int CallStaticJavaDirectNode::compute_padding(int current_offset) const
{
  current_offset += clear_avx_size(); // skip vzeroupper
  current_offset += 1; // skip call opcode byte
  return align_up(current_offset, alignment_required()) - current_offset;
}

// The address of the call instruction needs to be 4-byte aligned to
// ensure that it does not span a cache line so that it can be patched.
int CallDynamicJavaDirectNode::compute_padding(int current_offset) const
{
  current_offset += clear_avx_size(); // skip vzeroupper
  current_offset += 11; // skip movq instruction + call opcode byte
  return align_up(current_offset, alignment_required()) - current_offset;
}

// This could be in MacroAssembler but it's fairly C2 specific
static void emit_cmpfp_fixup(MacroAssembler* masm) {
  Label exit;
  __ jccb(Assembler::noParity, exit);
  __ pushf();
  //
  // comiss/ucomiss instructions set ZF,PF,CF flags and
  // zero OF,AF,SF for NaN values.
  // Fixup flags by zeroing ZF,PF so that compare of NaN
  // values returns 'less than' result (CF is set).
  // Leave the rest of flags unchanged.
  //
  //    7 6 5 4 3 2 1 0
  //   |S|Z|r|A|r|P|r|C|  (r - reserved bit)
  //    0 0 1 0 1 0 1 1   (0x2B)
  //
  __ andq(Address(rsp, 0), 0xffffff2b);
  __ popf();
  __ bind(exit);
}

static void emit_cmpfp3(MacroAssembler* masm, Register dst) {
  Label done;
  __ movl(dst, -1);
  __ jcc(Assembler::parity, done);
  __ jcc(Assembler::below, done);
  __ setcc(Assembler::notEqual, dst);
  __ bind(done);
}

// Math.min()    # Math.max()
// --------------------------
// ucomis[s/d]   #
// ja   -> b     # a
// jp   -> NaN   # NaN
// jb   -> a     # b
// je            #
// |-jz -> a | b # a & b
// |    -> a     #
static void emit_fp_min_max(MacroAssembler* masm, XMMRegister dst,
                            XMMRegister a, XMMRegister b,
                            XMMRegister xmmt, Register rt,
                            bool min, bool single) {

  Label nan, zero, below, above, done;

  if (single)
    __ ucomiss(a, b);
  else
    __ ucomisd(a, b);

  if (dst->encoding() != (min ? b : a)->encoding())
    __ jccb(Assembler::above, above); // CF=0 & ZF=0
  else
    __ jccb(Assembler::above, done);

  __ jccb(Assembler::parity, nan);  // PF=1
  __ jccb(Assembler::below, below); // CF=1

  // equal
  __ vpxor(xmmt, xmmt, xmmt, Assembler::AVX_128bit);
  if (single) {
    __ ucomiss(a, xmmt);
    __ jccb(Assembler::equal, zero);

    __ movflt(dst, a);
    __ jmp(done);
  }
  else {
    __ ucomisd(a, xmmt);
    __ jccb(Assembler::equal, zero);

    __ movdbl(dst, a);
    __ jmp(done);
  }

  __ bind(zero);
  if (min)
    __ vpor(dst, a, b, Assembler::AVX_128bit);
  else
    __ vpand(dst, a, b, Assembler::AVX_128bit);

  __ jmp(done);

  __ bind(above);
  if (single)
    __ movflt(dst, min ? b : a);
  else
    __ movdbl(dst, min ? b : a);

  __ jmp(done);

  __ bind(nan);
  if (single) {
    __ movl(rt, 0x7fc00000); // Float.NaN
    __ movdl(dst, rt);
  }
  else {
    __ mov64(rt, 0x7ff8000000000000L); // Double.NaN
    __ movdq(dst, rt);
  }
  __ jmp(done);

  __ bind(below);
  if (single)
    __ movflt(dst, min ? a : b);
  else
    __ movdbl(dst, min ? a : b);

  __ bind(done);
}

//=============================================================================
const RegMask& MachConstantBaseNode::_out_RegMask = RegMask::Empty;

int ConstantTable::calculate_table_base_offset() const {
  return 0;  // absolute addressing, no offset
}

bool MachConstantBaseNode::requires_postalloc_expand() const { return false; }
void MachConstantBaseNode::postalloc_expand(GrowableArray <Node *> *nodes, PhaseRegAlloc *ra_) {
  ShouldNotReachHere();
}

void MachConstantBaseNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Empty encoding
}

uint MachConstantBaseNode::size(PhaseRegAlloc* ra_) const {
  return 0;
}

#ifndef PRODUCT
void MachConstantBaseNode::format(PhaseRegAlloc* ra_, outputStream* st) const {
  st->print("# MachConstantBaseNode (empty encoding)");
}
#endif


//=============================================================================
#ifndef PRODUCT
void MachPrologNode::format(PhaseRegAlloc* ra_, outputStream* st) const {
  Compile* C = ra_->C;

  int framesize = C->output()->frame_size_in_bytes();
  int bangsize = C->output()->bang_size_in_bytes();
  assert((framesize & (StackAlignmentInBytes-1)) == 0, "frame size not aligned");
  // Remove wordSize for return addr which is already pushed.
  framesize -= wordSize;

  if (C->output()->need_stack_bang(bangsize)) {
    framesize -= wordSize;
    st->print("# stack bang (%d bytes)", bangsize);
    st->print("\n\t");
    st->print("pushq   rbp\t# Save rbp");
    if (PreserveFramePointer) {
        st->print("\n\t");
        st->print("movq    rbp, rsp\t# Save the caller's SP into rbp");
    }
    if (framesize) {
      st->print("\n\t");
      st->print("subq    rsp, #%d\t# Create frame",framesize);
    }
  } else {
    st->print("subq    rsp, #%d\t# Create frame",framesize);
    st->print("\n\t");
    framesize -= wordSize;
    st->print("movq    [rsp + #%d], rbp\t# Save rbp",framesize);
    if (PreserveFramePointer) {
      st->print("\n\t");
      st->print("movq    rbp, rsp\t# Save the caller's SP into rbp");
      if (framesize > 0) {
        st->print("\n\t");
        st->print("addq    rbp, #%d", framesize);
      }
    }
  }

  if (VerifyStackAtCalls) {
    st->print("\n\t");
    framesize -= wordSize;
    st->print("movq    [rsp + #%d], 0xbadb100d\t# Majik cookie for stack depth check",framesize);
#ifdef ASSERT
    st->print("\n\t");
    st->print("# stack alignment check");
#endif
  }
  if (C->stub_function() != nullptr && BarrierSet::barrier_set()->barrier_set_nmethod() != nullptr) {
    st->print("\n\t");
    st->print("cmpl    [r15_thread + #disarmed_guard_value_offset], #disarmed_guard_value\t");
    st->print("\n\t");
    st->print("je      fast_entry\t");
    st->print("\n\t");
    st->print("call    #nmethod_entry_barrier_stub\t");
    st->print("\n\tfast_entry:");
  }
  st->cr();
}
#endif

void MachPrologNode::emit(C2_MacroAssembler *masm, PhaseRegAlloc *ra_) const {
  Compile* C = ra_->C;

  int framesize = C->output()->frame_size_in_bytes();
  int bangsize = C->output()->bang_size_in_bytes();

  if (C->clinit_barrier_on_entry()) {
    assert(VM_Version::supports_fast_class_init_checks(), "sanity");
    assert(!C->method()->holder()->is_not_initialized(), "initialization should have been started");

    Label L_skip_barrier;
    Register klass = rscratch1;

    __ mov_metadata(klass, C->method()->holder()->constant_encoding());
    __ clinit_barrier(klass, r15_thread, &L_skip_barrier /*L_fast_path*/);

    __ jump(RuntimeAddress(SharedRuntime::get_handle_wrong_method_stub())); // slow path

    __ bind(L_skip_barrier);
  }

  __ verified_entry(framesize, C->output()->need_stack_bang(bangsize)?bangsize:0, false, C->stub_function() != nullptr);

  C->output()->set_frame_complete(__ offset());

  if (C->has_mach_constant_base_node()) {
    // NOTE: We set the table base offset here because users might be
    // emitted before MachConstantBaseNode.
    ConstantTable& constant_table = C->output()->constant_table();
    constant_table.set_table_base_offset(constant_table.calculate_table_base_offset());
  }
}

uint MachPrologNode::size(PhaseRegAlloc* ra_) const
{
  return MachNode::size(ra_); // too many variables; just compute it
                              // the hard way
}

int MachPrologNode::reloc() const
{
  return 0; // a large enough number
}

//=============================================================================
#ifndef PRODUCT
void MachEpilogNode::format(PhaseRegAlloc* ra_, outputStream* st) const
{
  Compile* C = ra_->C;
  if (generate_vzeroupper(C)) {
    st->print("vzeroupper");
    st->cr(); st->print("\t");
  }

  int framesize = C->output()->frame_size_in_bytes();
  assert((framesize & (StackAlignmentInBytes-1)) == 0, "frame size not aligned");
  // Remove word for return adr already pushed
  // and RBP
  framesize -= 2*wordSize;

  if (framesize) {
    st->print_cr("addq    rsp, %d\t# Destroy frame", framesize);
    st->print("\t");
  }

  st->print_cr("popq    rbp");
  if (do_polling() && C->is_method_compilation()) {
    st->print("\t");
    st->print_cr("cmpq    rsp, poll_offset[r15_thread] \n\t"
                 "ja      #safepoint_stub\t"
                 "# Safepoint: poll for GC");
  }
}
#endif

void MachEpilogNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const
{
  Compile* C = ra_->C;

  if (generate_vzeroupper(C)) {
    // Clear upper bits of YMM registers when current compiled code uses
    // wide vectors to avoid AVX <-> SSE transition penalty during call.
    __ vzeroupper();
  }

  int framesize = C->output()->frame_size_in_bytes();
  assert((framesize & (StackAlignmentInBytes-1)) == 0, "frame size not aligned");
  // Remove word for return adr already pushed
  // and RBP
  framesize -= 2*wordSize;

  // Note that VerifyStackAtCalls' Majik cookie does not change the frame size popped here

  if (framesize) {
    __ addq(rsp, framesize);
  }

  __ popq(rbp);

  if (StackReservedPages > 0 && C->has_reserved_stack_access()) {
    __ reserved_stack_check();
  }

  if (do_polling() && C->is_method_compilation()) {
    Label dummy_label;
    Label* code_stub = &dummy_label;
    if (!C->output()->in_scratch_emit_size()) {
      C2SafepointPollStub* stub = new (C->comp_arena()) C2SafepointPollStub(__ offset());
      C->output()->add_stub(stub);
      code_stub = &stub->entry();
    }
    __ relocate(relocInfo::poll_return_type);
    __ safepoint_poll(*code_stub, r15_thread, true /* at_return */, true /* in_nmethod */);
  }
}

uint MachEpilogNode::size(PhaseRegAlloc* ra_) const
{
  return MachNode::size(ra_); // too many variables; just compute it
                              // the hard way
}

int MachEpilogNode::reloc() const
{
  return 2; // a large enough number
}

const Pipeline* MachEpilogNode::pipeline() const
{
  return MachNode::pipeline_class();
}

//=============================================================================

enum RC {
  rc_bad,
  rc_int,
  rc_kreg,
  rc_float,
  rc_stack
};

static enum RC rc_class(OptoReg::Name reg)
{
  if( !OptoReg::is_valid(reg)  ) return rc_bad;

  if (OptoReg::is_stack(reg)) return rc_stack;

  VMReg r = OptoReg::as_VMReg(reg);

  if (r->is_Register()) return rc_int;

  if (r->is_KRegister()) return rc_kreg;

  assert(r->is_XMMRegister(), "must be");
  return rc_float;
}

// Next two methods are shared by 32- and 64-bit VM. They are defined in x86.ad.
static void vec_mov_helper(C2_MacroAssembler *masm, int src_lo, int dst_lo,
                          int src_hi, int dst_hi, uint ireg, outputStream* st);

void vec_spill_helper(C2_MacroAssembler *masm, bool is_load,
                     int stack_offset, int reg, uint ireg, outputStream* st);

static void vec_stack_to_stack_helper(C2_MacroAssembler *masm, int src_offset,
                                      int dst_offset, uint ireg, outputStream* st) {
  if (masm) {
    switch (ireg) {
    case Op_VecS:
      __ movq(Address(rsp, -8), rax);
      __ movl(rax, Address(rsp, src_offset));
      __ movl(Address(rsp, dst_offset), rax);
      __ movq(rax, Address(rsp, -8));
      break;
    case Op_VecD:
      __ pushq(Address(rsp, src_offset));
      __ popq (Address(rsp, dst_offset));
      break;
    case Op_VecX:
      __ pushq(Address(rsp, src_offset));
      __ popq (Address(rsp, dst_offset));
      __ pushq(Address(rsp, src_offset+8));
      __ popq (Address(rsp, dst_offset+8));
      break;
    case Op_VecY:
      __ vmovdqu(Address(rsp, -32), xmm0);
      __ vmovdqu(xmm0, Address(rsp, src_offset));
      __ vmovdqu(Address(rsp, dst_offset), xmm0);
      __ vmovdqu(xmm0, Address(rsp, -32));
      break;
    case Op_VecZ:
      __ evmovdquq(Address(rsp, -64), xmm0, 2);
      __ evmovdquq(xmm0, Address(rsp, src_offset), 2);
      __ evmovdquq(Address(rsp, dst_offset), xmm0, 2);
      __ evmovdquq(xmm0, Address(rsp, -64), 2);
      break;
    default:
      ShouldNotReachHere();
    }
#ifndef PRODUCT
  } else {
    switch (ireg) {
    case Op_VecS:
      st->print("movq    [rsp - #8], rax\t# 32-bit mem-mem spill\n\t"
                "movl    rax, [rsp + #%d]\n\t"
                "movl    [rsp + #%d], rax\n\t"
                "movq    rax, [rsp - #8]",
                src_offset, dst_offset);
      break;
    case Op_VecD:
      st->print("pushq   [rsp + #%d]\t# 64-bit mem-mem spill\n\t"
                "popq    [rsp + #%d]",
                src_offset, dst_offset);
      break;
     case Op_VecX:
      st->print("pushq   [rsp + #%d]\t# 128-bit mem-mem spill\n\t"
                "popq    [rsp + #%d]\n\t"
                "pushq   [rsp + #%d]\n\t"
                "popq    [rsp + #%d]",
                src_offset, dst_offset, src_offset+8, dst_offset+8);
      break;
    case Op_VecY:
      st->print("vmovdqu [rsp - #32], xmm0\t# 256-bit mem-mem spill\n\t"
                "vmovdqu xmm0, [rsp + #%d]\n\t"
                "vmovdqu [rsp + #%d], xmm0\n\t"
                "vmovdqu xmm0, [rsp - #32]",
                src_offset, dst_offset);
      break;
    case Op_VecZ:
      st->print("vmovdqu [rsp - #64], xmm0\t# 512-bit mem-mem spill\n\t"
                "vmovdqu xmm0, [rsp + #%d]\n\t"
                "vmovdqu [rsp + #%d], xmm0\n\t"
                "vmovdqu xmm0, [rsp - #64]",
                src_offset, dst_offset);
      break;
    default:
      ShouldNotReachHere();
    }
#endif
  }
}

uint MachSpillCopyNode::implementation(C2_MacroAssembler* masm,
                                       PhaseRegAlloc* ra_,
                                       bool do_size,
                                       outputStream* st) const {
  assert(masm != nullptr || st  != nullptr, "sanity");
  // Get registers to move
  OptoReg::Name src_second = ra_->get_reg_second(in(1));
  OptoReg::Name src_first = ra_->get_reg_first(in(1));
  OptoReg::Name dst_second = ra_->get_reg_second(this);
  OptoReg::Name dst_first = ra_->get_reg_first(this);

  enum RC src_second_rc = rc_class(src_second);
  enum RC src_first_rc = rc_class(src_first);
  enum RC dst_second_rc = rc_class(dst_second);
  enum RC dst_first_rc = rc_class(dst_first);

  assert(OptoReg::is_valid(src_first) && OptoReg::is_valid(dst_first),
         "must move at least 1 register" );

  if (src_first == dst_first && src_second == dst_second) {
    // Self copy, no move
    return 0;
  }
  if (bottom_type()->isa_vect() != nullptr && bottom_type()->isa_vectmask() == nullptr) {
    uint ireg = ideal_reg();
    assert((src_first_rc != rc_int && dst_first_rc != rc_int), "sanity");
    assert((ireg == Op_VecS || ireg == Op_VecD || ireg == Op_VecX || ireg == Op_VecY || ireg == Op_VecZ ), "sanity");
    if( src_first_rc == rc_stack && dst_first_rc == rc_stack ) {
      // mem -> mem
      int src_offset = ra_->reg2offset(src_first);
      int dst_offset = ra_->reg2offset(dst_first);
      vec_stack_to_stack_helper(masm, src_offset, dst_offset, ireg, st);
    } else if (src_first_rc == rc_float && dst_first_rc == rc_float ) {
      vec_mov_helper(masm, src_first, dst_first, src_second, dst_second, ireg, st);
    } else if (src_first_rc == rc_float && dst_first_rc == rc_stack ) {
      int stack_offset = ra_->reg2offset(dst_first);
      vec_spill_helper(masm, false, stack_offset, src_first, ireg, st);
    } else if (src_first_rc == rc_stack && dst_first_rc == rc_float ) {
      int stack_offset = ra_->reg2offset(src_first);
      vec_spill_helper(masm, true,  stack_offset, dst_first, ireg, st);
    } else {
      ShouldNotReachHere();
    }
    return 0;
  }
  if (src_first_rc == rc_stack) {
    // mem ->
    if (dst_first_rc == rc_stack) {
      // mem -> mem
      assert(src_second != dst_first, "overlap");
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        int src_offset = ra_->reg2offset(src_first);
        int dst_offset = ra_->reg2offset(dst_first);
        if (masm) {
          __ pushq(Address(rsp, src_offset));
          __ popq (Address(rsp, dst_offset));
#ifndef PRODUCT
        } else {
          st->print("pushq   [rsp + #%d]\t# 64-bit mem-mem spill\n\t"
                    "popq    [rsp + #%d]",
                     src_offset, dst_offset);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        // No pushl/popl, so:
        int src_offset = ra_->reg2offset(src_first);
        int dst_offset = ra_->reg2offset(dst_first);
        if (masm) {
          __ movq(Address(rsp, -8), rax);
          __ movl(rax, Address(rsp, src_offset));
          __ movl(Address(rsp, dst_offset), rax);
          __ movq(rax, Address(rsp, -8));
#ifndef PRODUCT
        } else {
          st->print("movq    [rsp - #8], rax\t# 32-bit mem-mem spill\n\t"
                    "movl    rax, [rsp + #%d]\n\t"
                    "movl    [rsp + #%d], rax\n\t"
                    "movq    rax, [rsp - #8]",
                     src_offset, dst_offset);
#endif
        }
      }
      return 0;
    } else if (dst_first_rc == rc_int) {
      // mem -> gpr
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        int offset = ra_->reg2offset(src_first);
        if (masm) {
          __ movq(as_Register(Matcher::_regEncode[dst_first]), Address(rsp, offset));
#ifndef PRODUCT
        } else {
          st->print("movq    %s, [rsp + #%d]\t# spill",
                     Matcher::regName[dst_first],
                     offset);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        int offset = ra_->reg2offset(src_first);
        if (masm) {
          __ movl(as_Register(Matcher::_regEncode[dst_first]), Address(rsp, offset));
#ifndef PRODUCT
        } else {
          st->print("movl    %s, [rsp + #%d]\t# spill",
                     Matcher::regName[dst_first],
                     offset);
#endif
        }
      }
      return 0;
    } else if (dst_first_rc == rc_float) {
      // mem-> xmm
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        int offset = ra_->reg2offset(src_first);
        if (masm) {
          __ movdbl( as_XMMRegister(Matcher::_regEncode[dst_first]), Address(rsp, offset));
#ifndef PRODUCT
        } else {
          st->print("%s  %s, [rsp + #%d]\t# spill",
                     UseXmmLoadAndClearUpper ? "movsd " : "movlpd",
                     Matcher::regName[dst_first],
                     offset);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        int offset = ra_->reg2offset(src_first);
        if (masm) {
          __ movflt( as_XMMRegister(Matcher::_regEncode[dst_first]), Address(rsp, offset));
#ifndef PRODUCT
        } else {
          st->print("movss   %s, [rsp + #%d]\t# spill",
                     Matcher::regName[dst_first],
                     offset);
#endif
        }
      }
      return 0;
    } else if (dst_first_rc == rc_kreg) {
      // mem -> kreg
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        int offset = ra_->reg2offset(src_first);
        if (masm) {
          __ kmov(as_KRegister(Matcher::_regEncode[dst_first]), Address(rsp, offset));
#ifndef PRODUCT
        } else {
          st->print("kmovq   %s, [rsp + #%d]\t# spill",
                     Matcher::regName[dst_first],
                     offset);
#endif
        }
      }
      return 0;
    }
  } else if (src_first_rc == rc_int) {
    // gpr ->
    if (dst_first_rc == rc_stack) {
      // gpr -> mem
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        int offset = ra_->reg2offset(dst_first);
        if (masm) {
          __ movq(Address(rsp, offset), as_Register(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("movq    [rsp + #%d], %s\t# spill",
                     offset,
                     Matcher::regName[src_first]);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        int offset = ra_->reg2offset(dst_first);
        if (masm) {
          __ movl(Address(rsp, offset), as_Register(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("movl    [rsp + #%d], %s\t# spill",
                     offset,
                     Matcher::regName[src_first]);
#endif
        }
      }
      return 0;
    } else if (dst_first_rc == rc_int) {
      // gpr -> gpr
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        if (masm) {
          __ movq(as_Register(Matcher::_regEncode[dst_first]),
                  as_Register(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("movq    %s, %s\t# spill",
                     Matcher::regName[dst_first],
                     Matcher::regName[src_first]);
#endif
        }
        return 0;
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        if (masm) {
          __ movl(as_Register(Matcher::_regEncode[dst_first]),
                  as_Register(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("movl    %s, %s\t# spill",
                     Matcher::regName[dst_first],
                     Matcher::regName[src_first]);
#endif
        }
        return 0;
      }
    } else if (dst_first_rc == rc_float) {
      // gpr -> xmm
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        if (masm) {
          __ movdq( as_XMMRegister(Matcher::_regEncode[dst_first]), as_Register(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("movdq   %s, %s\t# spill",
                     Matcher::regName[dst_first],
                     Matcher::regName[src_first]);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        if (masm) {
          __ movdl( as_XMMRegister(Matcher::_regEncode[dst_first]), as_Register(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("movdl   %s, %s\t# spill",
                     Matcher::regName[dst_first],
                     Matcher::regName[src_first]);
#endif
        }
      }
      return 0;
    } else if (dst_first_rc == rc_kreg) {
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        if (masm) {
          __ kmov(as_KRegister(Matcher::_regEncode[dst_first]), as_Register(Matcher::_regEncode[src_first]));
  #ifndef PRODUCT
        } else {
           st->print("kmovq   %s, %s\t# spill",
                       Matcher::regName[dst_first],
                       Matcher::regName[src_first]);
  #endif
        }
      }
      Unimplemented();
      return 0;
    }
  } else if (src_first_rc == rc_float) {
    // xmm ->
    if (dst_first_rc == rc_stack) {
      // xmm -> mem
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        int offset = ra_->reg2offset(dst_first);
        if (masm) {
          __ movdbl( Address(rsp, offset), as_XMMRegister(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("movsd   [rsp + #%d], %s\t# spill",
                     offset,
                     Matcher::regName[src_first]);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        int offset = ra_->reg2offset(dst_first);
        if (masm) {
          __ movflt(Address(rsp, offset), as_XMMRegister(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("movss   [rsp + #%d], %s\t# spill",
                     offset,
                     Matcher::regName[src_first]);
#endif
        }
      }
      return 0;
    } else if (dst_first_rc == rc_int) {
      // xmm -> gpr
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        if (masm) {
          __ movdq( as_Register(Matcher::_regEncode[dst_first]), as_XMMRegister(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("movdq   %s, %s\t# spill",
                     Matcher::regName[dst_first],
                     Matcher::regName[src_first]);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        if (masm) {
          __ movdl( as_Register(Matcher::_regEncode[dst_first]), as_XMMRegister(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("movdl   %s, %s\t# spill",
                     Matcher::regName[dst_first],
                     Matcher::regName[src_first]);
#endif
        }
      }
      return 0;
    } else if (dst_first_rc == rc_float) {
      // xmm -> xmm
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        if (masm) {
          __ movdbl( as_XMMRegister(Matcher::_regEncode[dst_first]), as_XMMRegister(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("%s  %s, %s\t# spill",
                     UseXmmRegToRegMoveAll ? "movapd" : "movsd ",
                     Matcher::regName[dst_first],
                     Matcher::regName[src_first]);
#endif
        }
      } else {
        // 32-bit
        assert(!((src_first & 1) == 0 && src_first + 1 == src_second), "no transform");
        assert(!((dst_first & 1) == 0 && dst_first + 1 == dst_second), "no transform");
        if (masm) {
          __ movflt( as_XMMRegister(Matcher::_regEncode[dst_first]), as_XMMRegister(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("%s  %s, %s\t# spill",
                     UseXmmRegToRegMoveAll ? "movaps" : "movss ",
                     Matcher::regName[dst_first],
                     Matcher::regName[src_first]);
#endif
        }
      }
      return 0;
    } else if (dst_first_rc == rc_kreg) {
      assert(false, "Illegal spilling");
      return 0;
    }
  } else if (src_first_rc == rc_kreg) {
    if (dst_first_rc == rc_stack) {
      // mem -> kreg
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        int offset = ra_->reg2offset(dst_first);
        if (masm) {
          __ kmov(Address(rsp, offset), as_KRegister(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
          st->print("kmovq   [rsp + #%d] , %s\t# spill",
                     offset,
                     Matcher::regName[src_first]);
#endif
        }
      }
      return 0;
    } else if (dst_first_rc == rc_int) {
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        if (masm) {
          __ kmov(as_Register(Matcher::_regEncode[dst_first]), as_KRegister(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
         st->print("kmovq   %s, %s\t# spill",
                     Matcher::regName[dst_first],
                     Matcher::regName[src_first]);
#endif
        }
      }
      Unimplemented();
      return 0;
    } else if (dst_first_rc == rc_kreg) {
      if ((src_first & 1) == 0 && src_first + 1 == src_second &&
          (dst_first & 1) == 0 && dst_first + 1 == dst_second) {
        // 64-bit
        if (masm) {
          __ kmov(as_KRegister(Matcher::_regEncode[dst_first]), as_KRegister(Matcher::_regEncode[src_first]));
#ifndef PRODUCT
        } else {
         st->print("kmovq   %s, %s\t# spill",
                     Matcher::regName[dst_first],
                     Matcher::regName[src_first]);
#endif
        }
      }
      return 0;
    } else if (dst_first_rc == rc_float) {
      assert(false, "Illegal spill");
      return 0;
    }
  }

  assert(0," foo ");
  Unimplemented();
  return 0;
}

#ifndef PRODUCT
void MachSpillCopyNode::format(PhaseRegAlloc *ra_, outputStream* st) const {
  implementation(nullptr, ra_, false, st);
}
#endif

void MachSpillCopyNode::emit(C2_MacroAssembler *masm, PhaseRegAlloc *ra_) const {
  implementation(masm, ra_, false, nullptr);
}

uint MachSpillCopyNode::size(PhaseRegAlloc *ra_) const {
  return MachNode::size(ra_);
}

//=============================================================================
#ifndef PRODUCT
void BoxLockNode::format(PhaseRegAlloc* ra_, outputStream* st) const
{
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg = ra_->get_reg_first(this);
  st->print("leaq    %s, [rsp + #%d]\t# box lock",
            Matcher::regName[reg], offset);
}
#endif

void BoxLockNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const
{
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  int reg = ra_->get_encode(this);

  __ lea(as_Register(reg), Address(rsp, offset));
}

uint BoxLockNode::size(PhaseRegAlloc *ra_) const
{
  int offset = ra_->reg2offset(in_RegMask(0).find_first_elem());
  return (offset < 0x80) ? 5 : 8; // REX
}

//=============================================================================
#ifndef PRODUCT
void MachUEPNode::format(PhaseRegAlloc* ra_, outputStream* st) const
{
  if (UseCompressedClassPointers) {
    st->print_cr("movl    rscratch1, [j_rarg0 + oopDesc::klass_offset_in_bytes()]\t# compressed klass");
    st->print_cr("\tcmpl    rscratch1, [rax + CompiledICData::speculated_klass_offset()]\t # Inline cache check");
  } else {
    st->print_cr("movq    rscratch1, [j_rarg0 + oopDesc::klass_offset_in_bytes()]\t# compressed klass");
    st->print_cr("\tcmpq    rscratch1, [rax + CompiledICData::speculated_klass_offset()]\t # Inline cache check");
  }
  st->print_cr("\tjne     SharedRuntime::_ic_miss_stub");
}
#endif

void MachUEPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const
{
  __ ic_check(InteriorEntryAlignment);
}

uint MachUEPNode::size(PhaseRegAlloc* ra_) const
{
  return MachNode::size(ra_); // too many variables; just compute it
                              // the hard way
}


//=============================================================================

bool Matcher::supports_vector_calling_convention(void) {
  if (EnableVectorSupport && UseVectorStubs) {
    return true;
  }
  return false;
}

OptoRegPair Matcher::vector_return_value(uint ideal_reg) {
  assert(EnableVectorSupport && UseVectorStubs, "sanity");
  int lo = XMM0_num;
  int hi = XMM0b_num;
  if (ideal_reg == Op_VecX) hi = XMM0d_num;
  else if (ideal_reg == Op_VecY) hi = XMM0h_num;
  else if (ideal_reg == Op_VecZ) hi = XMM0p_num;
  return OptoRegPair(hi, lo);
}

// Is this branch offset short enough that a short branch can be used?
//
// NOTE: If the platform does not provide any short branch variants, then
//       this method should return false for offset 0.
bool Matcher::is_short_branch_offset(int rule, int br_size, int offset) {
  // The passed offset is relative to address of the branch.
  // On 86 a branch displacement is calculated relative to address
  // of a next instruction.
  offset -= br_size;

  // the short version of jmpConUCF2 contains multiple branches,
  // making the reach slightly less
  if (rule == jmpConUCF2_rule)
    return (-126 <= offset && offset <= 125);
  return (-128 <= offset && offset <= 127);
}

// Return whether or not this register is ever used as an argument.
// This function is used on startup to build the trampoline stubs in
// generateOptoStub.  Registers not mentioned will be killed by the VM
// call in the trampoline, and arguments in those registers not be
// available to the callee.
bool Matcher::can_be_java_arg(int reg)
{
  return
    reg ==  RDI_num || reg == RDI_H_num ||
    reg ==  RSI_num || reg == RSI_H_num ||
    reg ==  RDX_num || reg == RDX_H_num ||
    reg ==  RCX_num || reg == RCX_H_num ||
    reg ==   R8_num || reg ==  R8_H_num ||
    reg ==   R9_num || reg ==  R9_H_num ||
    reg ==  R12_num || reg == R12_H_num ||
    reg == XMM0_num || reg == XMM0b_num ||
    reg == XMM1_num || reg == XMM1b_num ||
    reg == XMM2_num || reg == XMM2b_num ||
    reg == XMM3_num || reg == XMM3b_num ||
    reg == XMM4_num || reg == XMM4b_num ||
    reg == XMM5_num || reg == XMM5b_num ||
    reg == XMM6_num || reg == XMM6b_num ||
    reg == XMM7_num || reg == XMM7b_num;
}

bool Matcher::is_spillable_arg(int reg)
{
  return can_be_java_arg(reg);
}

uint Matcher::int_pressure_limit()
{
  return (INTPRESSURE == -1) ? _INT_REG_mask.Size() : INTPRESSURE;
}

uint Matcher::float_pressure_limit()
{
  // After experiment around with different values, the following default threshold
  // works best for LCM's register pressure scheduling on x64.
  uint dec_count  = VM_Version::supports_evex() ? 4 : 2;
  uint default_float_pressure_threshold = _FLOAT_REG_mask.Size() - dec_count;
  return (FLOATPRESSURE == -1) ? default_float_pressure_threshold : FLOATPRESSURE;
}

bool Matcher::use_asm_for_ldiv_by_con( jlong divisor ) {
  // In 64 bit mode a code which use multiply when
  // devisor is constant is faster than hardware
  // DIV instruction (it uses MulHiL).
  return false;
}

// Register for DIVI projection of divmodI
RegMask Matcher::divI_proj_mask() {
  return INT_RAX_REG_mask();
}

// Register for MODI projection of divmodI
RegMask Matcher::modI_proj_mask() {
  return INT_RDX_REG_mask();
}

// Register for DIVL projection of divmodL
RegMask Matcher::divL_proj_mask() {
  return LONG_RAX_REG_mask();
}

// Register for MODL projection of divmodL
RegMask Matcher::modL_proj_mask() {
  return LONG_RDX_REG_mask();
}

// Register for saving SP into on method handle invokes. Not used on x86_64.
const RegMask Matcher::method_handle_invoke_SP_save_mask() {
    return NO_REG_mask();
}


#line 1296 "ad_x86.cpp"


//SourceForm

#line 1274 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"


#include "opto/addnode.hpp"
#include "c2_intelJccErratum_x86.hpp"

void PhaseOutput::pd_perform_mach_node_analysis() {
  if (VM_Version::has_intel_jcc_erratum()) {
    int extra_padding = IntelJccErratum::tag_affected_machnodes(C, C->cfg(), C->regalloc());
    _buf_sizes._code += extra_padding;
  }
}

int MachNode::pd_alignment_required() const {
  if (VM_Version::has_intel_jcc_erratum() && IntelJccErratum::is_jcc_erratum_branch(this)) {
    // Conservatively add worst case padding. We assume that relocInfo::addr_unit() is 1 on x86.
    return IntelJccErratum::largest_jcc_size() + 1;
  } else {
    return 1;
  }
}

int MachNode::compute_padding(int current_offset) const {
  if (flags() & Node::PD::Flag_intel_jcc_erratum) {
    Compile* C = Compile::current();
    PhaseOutput* output = C->output();
    Block* block = output->block();
    int index = output->index();
    return IntelJccErratum::compute_padding(current_offset, this, block, index, C->regalloc());
  } else {
    return 0;
  }
}

// Emit exception handler code.
// Stuff framesize into a register and call a VM stub routine.
int HandlerImpl::emit_exception_handler(C2_MacroAssembler* masm) {

  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  address base = __ start_a_stub(size_exception_handler());
  if (base == nullptr) {
    ciEnv::current()->record_failure("CodeCache is full");
    return 0;  // CodeBuffer::expand failed
  }
  int offset = __ offset();
  __ jump(RuntimeAddress(OptoRuntime::exception_blob()->entry_point()));
  assert(__ offset() - offset <= (int) size_exception_handler(), "overflow");
  __ end_a_stub();
  return offset;
}

// Emit deopt handler code.
int HandlerImpl::emit_deopt_handler(C2_MacroAssembler* masm) {

  // Note that the code buffer's insts_mark is always relative to insts.
  // That's why we must use the macroassembler to generate a handler.
  address base = __ start_a_stub(size_deopt_handler());
  if (base == nullptr) {
    ciEnv::current()->record_failure("CodeCache is full");
    return 0;  // CodeBuffer::expand failed
  }
  int offset = __ offset();

#ifdef _LP64
  address the_pc = (address) __ pc();
  Label next;
  // push a "the_pc" on the stack without destroying any registers
  // as they all may be live.

  // push address of "next"
  __ call(next, relocInfo::none); // reloc none is fine since it is a disp32
  __ bind(next);
  // adjust it so it matches "the_pc"
  __ subptr(Address(rsp, 0), __ offset() - offset);
#else
  InternalAddress here(__ pc());
  __ pushptr(here.addr(), noreg);
#endif

  __ jump(RuntimeAddress(SharedRuntime::deopt_blob()->unpack()));
  assert(__ offset() - offset <= (int) size_deopt_handler(), "overflow %d", (__ offset() - offset));
  __ end_a_stub();
  return offset;
}

static Assembler::Width widthForType(BasicType bt) {
  if (bt == T_BYTE) {
    return Assembler::B;
  } else if (bt == T_SHORT) {
    return Assembler::W;
  } else if (bt == T_INT) {
    return Assembler::D;
  } else {
    assert(bt == T_LONG, "not a long: %s", type2name(bt));
    return Assembler::Q;
  }
}

//=============================================================================

  // Float masks come from different places depending on platform.
#ifdef _LP64
  static address float_signmask()  { return StubRoutines::x86::float_sign_mask(); }
  static address float_signflip()  { return StubRoutines::x86::float_sign_flip(); }
  static address double_signmask() { return StubRoutines::x86::double_sign_mask(); }
  static address double_signflip() { return StubRoutines::x86::double_sign_flip(); }
#else
  static address float_signmask()  { return (address)float_signmask_pool; }
  static address float_signflip()  { return (address)float_signflip_pool; }
  static address double_signmask() { return (address)double_signmask_pool; }
  static address double_signflip() { return (address)double_signflip_pool; }
#endif
  static address vector_short_to_byte_mask() { return StubRoutines::x86::vector_short_to_byte_mask(); }
  static address vector_int_to_byte_mask() { return StubRoutines::x86::vector_int_to_byte_mask(); }
  static address vector_byte_perm_mask() { return StubRoutines::x86::vector_byte_perm_mask(); }
  static address vector_long_sign_mask() { return StubRoutines::x86::vector_long_sign_mask(); }
  static address vector_all_bits_set() { return StubRoutines::x86::vector_all_bits_set(); }
  static address vector_int_mask_cmp_bits() { return StubRoutines::x86::vector_int_mask_cmp_bits(); }
  static address vector_int_to_short_mask() { return StubRoutines::x86::vector_int_to_short_mask(); }
  static address vector_byte_shufflemask() { return StubRoutines::x86::vector_byte_shuffle_mask(); }
  static address vector_short_shufflemask() { return StubRoutines::x86::vector_short_shuffle_mask(); }
  static address vector_int_shufflemask() { return StubRoutines::x86::vector_int_shuffle_mask(); }
  static address vector_long_shufflemask() { return StubRoutines::x86::vector_long_shuffle_mask(); }
  static address vector_32_bit_mask() { return StubRoutines::x86::vector_32_bit_mask(); }
  static address vector_64_bit_mask() { return StubRoutines::x86::vector_64_bit_mask(); }
  static address vector_float_signflip() { return StubRoutines::x86::vector_float_sign_flip();}
  static address vector_double_signflip() { return StubRoutines::x86::vector_double_sign_flip();}

//=============================================================================
bool Matcher::match_rule_supported(int opcode) {
  if (!has_match_rule(opcode)) {
    return false; // no match rule present
  }
  const bool is_LP64 = LP64_ONLY(true) NOT_LP64(false);
  switch (opcode) {
    case Op_AbsVL:
    case Op_StoreVectorScatter:
      if (UseAVX < 3) {
        return false;
      }
      break;
    case Op_PopCountI:
    case Op_PopCountL:
      if (!UsePopCountInstruction) {
        return false;
      }
      break;
    case Op_PopCountVI:
      if (UseAVX < 2) {
        return false;
      }
      break;
    case Op_CompressV:
    case Op_ExpandV:
    case Op_PopCountVL:
      if (UseAVX < 2) {
        return false;
      }
      break;
    case Op_MulVI:
      if ((UseSSE < 4) && (UseAVX < 1)) { // only with SSE4_1 or AVX
        return false;
      }
      break;
    case Op_MulVL:
      if (UseSSE < 4) { // only with SSE4_1 or AVX
        return false;
      }
      break;
    case Op_MulReductionVL:
      if (VM_Version::supports_avx512dq() == false) {
        return false;
      }
      break;
    case Op_AddReductionVL:
      if (UseSSE < 2) { // requires at least SSE2
        return false;
      }
      break;
    case Op_AbsVB:
    case Op_AbsVS:
    case Op_AbsVI:
    case Op_AddReductionVI:
    case Op_AndReductionV:
    case Op_OrReductionV:
    case Op_XorReductionV:
      if (UseSSE < 3) { // requires at least SSSE3
        return false;
      }
      break;
    case Op_VectorLoadShuffle:
    case Op_VectorRearrange:
    case Op_MulReductionVI:
      if (UseSSE < 4) { // requires at least SSE4
        return false;
      }
      break;
    case Op_IsInfiniteF:
    case Op_IsInfiniteD:
      if (!VM_Version::supports_avx512dq()) {
        return false;
      }
      break;
    case Op_SqrtVD:
    case Op_SqrtVF:
    case Op_VectorMaskCmp:
    case Op_VectorCastB2X:
    case Op_VectorCastS2X:
    case Op_VectorCastI2X:
    case Op_VectorCastL2X:
    case Op_VectorCastF2X:
    case Op_VectorCastD2X:
    case Op_VectorUCastB2X:
    case Op_VectorUCastS2X:
    case Op_VectorUCastI2X:
    case Op_VectorMaskCast:
      if (UseAVX < 1) { // enabled for AVX only
        return false;
      }
      break;
    case Op_PopulateIndex:
      if (!is_LP64 || (UseAVX < 2)) {
        return false;
      }
      break;
    case Op_RoundVF:
      if (UseAVX < 2) { // enabled for AVX2 only
        return false;
      }
      break;
    case Op_RoundVD:
      if (UseAVX < 3) {
        return false;  // enabled for AVX3 only
      }
      break;
    case Op_CompareAndSwapL:
#ifdef _LP64
    case Op_CompareAndSwapP:
#endif
      break;
    case Op_StrIndexOf:
      if (!UseSSE42Intrinsics) {
        return false;
      }
      break;
    case Op_StrIndexOfChar:
      if (!UseSSE42Intrinsics) {
        return false;
      }
      break;
    case Op_OnSpinWait:
      if (VM_Version::supports_on_spin_wait() == false) {
        return false;
      }
      break;
    case Op_MulVB:
    case Op_LShiftVB:
    case Op_RShiftVB:
    case Op_URShiftVB:
    case Op_VectorInsert:
    case Op_VectorLoadMask:
    case Op_VectorStoreMask:
    case Op_VectorBlend:
      if (UseSSE < 4) {
        return false;
      }
      break;
#ifdef _LP64
    case Op_MaxD:
    case Op_MaxF:
    case Op_MinD:
    case Op_MinF:
      if (UseAVX < 1) { // enabled for AVX only
        return false;
      }
      break;
#endif
    case Op_CacheWB:
    case Op_CacheWBPreSync:
    case Op_CacheWBPostSync:
      if (!VM_Version::supports_data_cache_line_flush()) {
        return false;
      }
      break;
    case Op_ExtractB:
    case Op_ExtractL:
    case Op_ExtractI:
    case Op_RoundDoubleMode:
      if (UseSSE < 4) {
        return false;
      }
      break;
    case Op_RoundDoubleModeV:
      if (VM_Version::supports_avx() == false) {
        return false; // 128bit vroundpd is not available
      }
      break;
    case Op_LoadVectorGather:
    case Op_LoadVectorGatherMasked:
      if (UseAVX < 2) {
        return false;
      }
      break;
    case Op_FmaF:
    case Op_FmaD:
    case Op_FmaVD:
    case Op_FmaVF:
      if (!UseFMA) {
        return false;
      }
      break;
    case Op_MacroLogicV:
      if (UseAVX < 3 || !UseVectorMacroLogic) {
        return false;
      }
      break;

    case Op_VectorCmpMasked:
    case Op_VectorMaskGen:
      if (!is_LP64  || UseAVX < 3 || !VM_Version::supports_bmi2()) {
        return false;
      }
      break;
    case Op_VectorMaskFirstTrue:
    case Op_VectorMaskLastTrue:
    case Op_VectorMaskTrueCount:
    case Op_VectorMaskToLong:
      if (!is_LP64 || UseAVX < 1) {
         return false;
      }
      break;
    case Op_RoundF:
    case Op_RoundD:
      if (!is_LP64) {
        return false;
      }
      break;
    case Op_CopySignD:
    case Op_CopySignF:
      if (UseAVX < 3 || !is_LP64)  {
        return false;
      }
      if (!VM_Version::supports_avx512vl()) {
        return false;
      }
      break;
#ifndef _LP64
    case Op_AddReductionVF:
    case Op_AddReductionVD:
    case Op_MulReductionVF:
    case Op_MulReductionVD:
      if (UseSSE < 1) { // requires at least SSE
        return false;
      }
      break;
    case Op_MulAddVS2VI:
    case Op_RShiftVL:
    case Op_AbsVD:
    case Op_NegVD:
      if (UseSSE < 2) {
        return false;
      }
      break;
#endif // !LP64
    case Op_CompressBits:
      if (!VM_Version::supports_bmi2() || (!is_LP64 && UseSSE < 2)) {
        return false;
      }
      break;
    case Op_ExpandBits:
      if (!VM_Version::supports_bmi2() || (!is_LP64 && (UseSSE < 2 || !VM_Version::supports_bmi1()))) {
        return false;
      }
      break;
    case Op_SignumF:
      if (UseSSE < 1) {
        return false;
      }
      break;
    case Op_SignumD:
      if (UseSSE < 2) {
        return false;
      }
      break;
    case Op_CompressM:
      if (!VM_Version::supports_avx512vl() || !VM_Version::supports_bmi2()) {
        return false;
      }
      break;
    case Op_SqrtF:
      if (UseSSE < 1) {
        return false;
      }
      break;
    case Op_SqrtD:
#ifdef _LP64
      if (UseSSE < 2) {
        return false;
      }
#else
      // x86_32.ad has a special match rule for SqrtD.
      // Together with common x86 rules, this handles all UseSSE cases.
#endif
      break;
    case Op_ConvF2HF:
    case Op_ConvHF2F:
      if (!VM_Version::supports_float16()) {
        return false;
      }
      break;
    case Op_VectorCastF2HF:
    case Op_VectorCastHF2F:
      if (!VM_Version::supports_f16c() && !VM_Version::supports_evex()) {
        return false;
      }
      break;
  }
  return true;  // Match rules are supported by default.
}

//------------------------------------------------------------------------

static inline bool is_pop_count_instr_target(BasicType bt) {
  return (is_subword_type(bt) && VM_Version::supports_avx512_bitalg()) ||
         (is_non_subword_integral_type(bt) && VM_Version::supports_avx512_vpopcntdq());
}

bool Matcher::match_rule_supported_auto_vectorization(int opcode, int vlen, BasicType bt) {
  return match_rule_supported_vector(opcode, vlen, bt);
}

// Identify extra cases that we might want to provide match rules for vector nodes and
// other intrinsics guarded with vector length (vlen) and element type (bt).
bool Matcher::match_rule_supported_vector(int opcode, int vlen, BasicType bt) {
  const bool is_LP64 = LP64_ONLY(true) NOT_LP64(false);
  if (!match_rule_supported(opcode)) {
    return false;
  }
  // Matcher::vector_size_supported() restricts vector sizes in the following way (see Matcher::vector_width_in_bytes):
  //   * SSE2 supports 128bit vectors for all types;
  //   * AVX1 supports 256bit vectors only for FLOAT and DOUBLE types;
  //   * AVX2 supports 256bit vectors for all types;
  //   * AVX512F supports 512bit vectors only for INT, FLOAT, and DOUBLE types;
  //   * AVX512BW supports 512bit vectors for BYTE, SHORT, and CHAR types.
  // There's also a limit on minimum vector size supported: 2 elements (or 4 bytes for BYTE).
  // And MaxVectorSize is taken into account as well.
  if (!vector_size_supported(bt, vlen)) {
    return false;
  }
  // Special cases which require vector length follow:
  //   * implementation limitations
  //   * some 512bit vector operations on FLOAT and DOUBLE types require AVX512DQ
  //   * 128bit vroundpd instruction is present only in AVX1
  int size_in_bits = vlen * type2aelembytes(bt) * BitsPerByte;
  switch (opcode) {
    case Op_AbsVF:
    case Op_NegVF:
      if ((vlen == 16) && (VM_Version::supports_avx512dq() == false)) {
        return false; // 512bit vandps and vxorps are not available
      }
      break;
    case Op_AbsVD:
    case Op_NegVD:
      if ((vlen == 8) && (VM_Version::supports_avx512dq() == false)) {
        return false; // 512bit vpmullq, vandpd and vxorpd are not available
      }
      break;
    case Op_RotateRightV:
    case Op_RotateLeftV:
      if (bt != T_INT && bt != T_LONG) {
        return false;
      } // fallthrough
    case Op_MacroLogicV:
      if (!VM_Version::supports_evex() ||
          ((size_in_bits != 512) && !VM_Version::supports_avx512vl())) {
        return false;
      }
      break;
    case Op_ClearArray:
    case Op_VectorMaskGen:
    case Op_VectorCmpMasked:
      if (!is_LP64 || !VM_Version::supports_avx512bw()) {
        return false;
      }
      if ((size_in_bits != 512) && !VM_Version::supports_avx512vl()) {
        return false;
      }
      break;
    case Op_LoadVectorMasked:
    case Op_StoreVectorMasked:
      if (!VM_Version::supports_avx512bw() && (is_subword_type(bt) || UseAVX < 1)) {
        return false;
      }
      break;
    case Op_UMinV:
    case Op_UMaxV:
      if (UseAVX == 0) {
        return false;
      }
      break;
    case Op_MaxV:
    case Op_MinV:
      if (UseSSE < 4 && is_integral_type(bt)) {
        return false;
      }
      if ((bt == T_FLOAT || bt == T_DOUBLE)) {
          // Float/Double intrinsics are enabled for AVX family currently.
          if (UseAVX == 0) {
            return false;
          }
          if (UseAVX > 2 && (!VM_Version::supports_avx512dq() && size_in_bits == 512)) { // 512 bit Float/Double intrinsics need AVX512DQ
            return false;
          }
      }
      break;
    case Op_CallLeafVector:
      if (size_in_bits == 512 && !VM_Version::supports_avx512vlbwdq()) {
        return false;
      }
      break;
    case Op_AddReductionVI:
      if (bt == T_INT && (UseSSE < 3 || !VM_Version::supports_ssse3())) {
        return false;
      }
      // fallthrough
    case Op_AndReductionV:
    case Op_OrReductionV:
    case Op_XorReductionV:
      if (is_subword_type(bt) && (UseSSE < 4)) {
        return false;
      }
#ifndef _LP64
      if (bt == T_BYTE || bt == T_LONG) {
        return false;
      }
#endif
      break;
#ifndef _LP64
    case Op_VectorInsert:
      if (bt == T_LONG || bt == T_DOUBLE) {
        return false;
      }
      break;
#endif
    case Op_MinReductionV:
    case Op_MaxReductionV:
      if ((bt == T_INT || is_subword_type(bt)) && UseSSE < 4) {
        return false;
      } else if (bt == T_LONG && (UseAVX < 3 || !VM_Version::supports_avx512vlbwdq())) {
        return false;
      }
      // Float/Double intrinsics enabled for AVX family.
      if (UseAVX == 0 && (bt == T_FLOAT || bt == T_DOUBLE)) {
        return false;
      }
      if (UseAVX > 2 && (!VM_Version::supports_avx512dq() && size_in_bits == 512)) {
        return false;
      }
#ifndef _LP64
      if (bt == T_BYTE || bt == T_LONG) {
        return false;
      }
#endif
      break;
    case Op_VectorTest:
      if (UseSSE < 4) {
        return false; // Implementation limitation
      } else if (size_in_bits < 32) {
        return false; // Implementation limitation
      }
      break;
    case Op_VectorLoadShuffle:
    case Op_VectorRearrange:
      if(vlen == 2) {
        return false; // Implementation limitation due to how shuffle is loaded
      } else if (size_in_bits == 256 && UseAVX < 2) {
        return false; // Implementation limitation
      }
      break;
    case Op_VectorLoadMask:
    case Op_VectorMaskCast:
      if (size_in_bits == 256 && UseAVX < 2) {
        return false; // Implementation limitation
      }
      // fallthrough
    case Op_VectorStoreMask:
      if (vlen == 2) {
        return false; // Implementation limitation
      }
      break;
    case Op_PopulateIndex:
      if (size_in_bits > 256 && !VM_Version::supports_avx512bw()) {
        return false;
      }
      break;
    case Op_VectorCastB2X:
    case Op_VectorCastS2X:
    case Op_VectorCastI2X:
      if (bt != T_DOUBLE && size_in_bits == 256 && UseAVX < 2) {
        return false;
      }
      break;
    case Op_VectorCastL2X:
      if (is_integral_type(bt) && size_in_bits == 256 && UseAVX < 2) {
        return false;
      } else if (!is_integral_type(bt) && !VM_Version::supports_avx512dq()) {
        return false;
      }
      break;
    case Op_VectorCastF2X: {
        // As per JLS section 5.1.3 narrowing conversion to sub-word types
        // happen after intermediate conversion to integer and special handling
        // code needs AVX2 vpcmpeqd instruction for 256 bit vectors.
        int src_size_in_bits = type2aelembytes(T_FLOAT) * vlen * BitsPerByte;
        if (is_integral_type(bt) && src_size_in_bits == 256 && UseAVX < 2) {
          return false;
        }
      }
      // fallthrough
    case Op_VectorCastD2X:
      if (bt == T_LONG && !VM_Version::supports_avx512dq()) {
        return false;
      }
      break;
    case Op_VectorCastF2HF:
    case Op_VectorCastHF2F:
      if (!VM_Version::supports_f16c() &&
         ((!VM_Version::supports_evex() ||
         ((size_in_bits != 512) && !VM_Version::supports_avx512vl())))) {
        return false;
      }
      break;
    case Op_RoundVD:
      if (!VM_Version::supports_avx512dq()) {
        return false;
      }
      break;
    case Op_MulReductionVI:
      if (bt == T_BYTE && size_in_bits == 512 && !VM_Version::supports_avx512bw()) {
        return false;
      }
      break;
    case Op_LoadVectorGatherMasked:
      if (!is_subword_type(bt) && size_in_bits < 512 && !VM_Version::supports_avx512vl()) {
        return false;
      }
      if (is_subword_type(bt) &&
         (!is_LP64                                                ||
         (size_in_bits > 256 && !VM_Version::supports_avx512bw()) ||
         (size_in_bits < 64)                                      ||
         (bt == T_SHORT && !VM_Version::supports_bmi2()))) {
        return false;
      }
      break;
    case Op_StoreVectorScatterMasked:
    case Op_StoreVectorScatter:
      if (is_subword_type(bt)) {
        return false;
      } else if (size_in_bits < 512 && !VM_Version::supports_avx512vl()) {
        return false;
      }
      // fallthrough
    case Op_LoadVectorGather:
      if (!is_subword_type(bt) && size_in_bits == 64) {
        return false;
      }
      if (is_subword_type(bt) && size_in_bits < 64) {
        return false;
      }
      break;
    case Op_SaturatingAddV:
    case Op_SaturatingSubV:
      if (UseAVX < 1) {
        return false; // Implementation limitation
      }
      if (is_subword_type(bt) && size_in_bits == 512 && !VM_Version::supports_avx512bw()) {
        return false;
      }
      break;
    case Op_SelectFromTwoVector:
       if (size_in_bits < 128 || (size_in_bits < 512 && !VM_Version::supports_avx512vl())) {
         return false;
       }
       if (bt == T_SHORT && !VM_Version::supports_avx512bw()) {
         return false;
       }
       if (bt == T_BYTE && !VM_Version::supports_avx512_vbmi()) {
         return false;
       }
       if ((bt == T_INT || bt == T_FLOAT || bt == T_DOUBLE) && !VM_Version::supports_evex()) {
         return false;
       }
       break;
    case Op_MaskAll:
      if (!VM_Version::supports_evex()) {
        return false;
      }
      if ((vlen > 16 || is_subword_type(bt)) && !VM_Version::supports_avx512bw()) {
        return false;
      }
      if (size_in_bits < 512 && !VM_Version::supports_avx512vl()) {
        return false;
      }
      break;
    case Op_VectorMaskCmp:
      if (vlen < 2 || size_in_bits < 32) {
        return false;
      }
      break;
    case Op_CompressM:
      if (UseAVX < 3 || !VM_Version::supports_bmi2()) {
        return false;
      }
      break;
    case Op_CompressV:
    case Op_ExpandV:
      if (is_subword_type(bt) && !VM_Version::supports_avx512_vbmi2()) {
        return false;
      }
      if (!is_LP64 && !VM_Version::supports_avx512vl() && size_in_bits < 512) {
        return false;
      }
      if (size_in_bits < 128 ) {
        return false;
      }
    case Op_VectorLongToMask:
      if (UseAVX < 1 || !is_LP64) {
        return false;
      }
      if (UseAVX < 3 && !VM_Version::supports_bmi2()) {
        return false;
      }
      break;
    case Op_SignumVD:
    case Op_SignumVF:
      if (UseAVX < 1) {
        return false;
      }
      break;
    case Op_PopCountVI:
    case Op_PopCountVL: {
        if (!is_pop_count_instr_target(bt) &&
            (size_in_bits == 512) && !VM_Version::supports_avx512bw()) {
          return false;
        }
      }
      break;
    case Op_ReverseV:
    case Op_ReverseBytesV:
      if (UseAVX < 2) {
        return false;
      }
      break;
    case Op_CountTrailingZerosV:
    case Op_CountLeadingZerosV:
      if (UseAVX < 2) {
        return false;
      }
      break;
  }
  return true;  // Per default match rules are supported.
}

bool Matcher::match_rule_supported_vector_masked(int opcode, int vlen, BasicType bt) {
  // ADLC based match_rule_supported routine checks for the existence of pattern based
  // on IR opcode. Most of the unary/binary/ternary masked operation share the IR nodes
  // of their non-masked counterpart with mask edge being the differentiator.
  // This routine does a strict check on the existence of masked operation patterns
  // by returning a default false value for all the other opcodes apart from the
  // ones whose masked instruction patterns are defined in this file.
  if (!match_rule_supported_vector(opcode, vlen, bt)) {
    return false;
  }

  const bool is_LP64 = LP64_ONLY(true) NOT_LP64(false);
  int size_in_bits = vlen * type2aelembytes(bt) * BitsPerByte;
  if (size_in_bits != 512 && !VM_Version::supports_avx512vl()) {
    return false;
  }
  switch(opcode) {
    // Unary masked operations
    case Op_AbsVB:
    case Op_AbsVS:
      if(!VM_Version::supports_avx512bw()) {
        return false;  // Implementation limitation
      }
    case Op_AbsVI:
    case Op_AbsVL:
      return true;

    // Ternary masked operations
    case Op_FmaVF:
    case Op_FmaVD:
      return true;

    case Op_MacroLogicV:
      if(bt != T_INT && bt != T_LONG) {
        return false;
      }
      return true;

    // Binary masked operations
    case Op_AddVB:
    case Op_AddVS:
    case Op_SubVB:
    case Op_SubVS:
    case Op_MulVS:
    case Op_LShiftVS:
    case Op_RShiftVS:
    case Op_URShiftVS:
      assert(size_in_bits == 512 || VM_Version::supports_avx512vl(), "");
      if (!VM_Version::supports_avx512bw()) {
        return false;  // Implementation limitation
      }
      return true;

    case Op_MulVL:
      assert(size_in_bits == 512 || VM_Version::supports_avx512vl(), "");
      if (!VM_Version::supports_avx512dq()) {
        return false;  // Implementation limitation
      }
      return true;

    case Op_AndV:
    case Op_OrV:
    case Op_XorV:
    case Op_RotateRightV:
    case Op_RotateLeftV:
      if (bt != T_INT && bt != T_LONG) {
        return false; // Implementation limitation
      }
      return true;

    case Op_VectorLoadMask:
      assert(size_in_bits == 512 || VM_Version::supports_avx512vl(), "");
      if (is_subword_type(bt) && !VM_Version::supports_avx512bw()) {
        return false;
      }
      return true;

    case Op_AddVI:
    case Op_AddVL:
    case Op_AddVF:
    case Op_AddVD:
    case Op_SubVI:
    case Op_SubVL:
    case Op_SubVF:
    case Op_SubVD:
    case Op_MulVI:
    case Op_MulVF:
    case Op_MulVD:
    case Op_DivVF:
    case Op_DivVD:
    case Op_SqrtVF:
    case Op_SqrtVD:
    case Op_LShiftVI:
    case Op_LShiftVL:
    case Op_RShiftVI:
    case Op_RShiftVL:
    case Op_URShiftVI:
    case Op_URShiftVL:
    case Op_LoadVectorMasked:
    case Op_StoreVectorMasked:
    case Op_LoadVectorGatherMasked:
    case Op_StoreVectorScatterMasked:
      return true;

    case Op_UMinV:
    case Op_UMaxV:
      if (size_in_bits < 512 && !VM_Version::supports_avx512vl()) {
        return false;
      } // fallthrough
    case Op_MaxV:
    case Op_MinV:
      if (is_subword_type(bt) && !VM_Version::supports_avx512bw()) {
        return false; // Implementation limitation
      }
      if (is_floating_point_type(bt)) {
        return false; // Implementation limitation
      }
      return true;
    case Op_SaturatingAddV:
    case Op_SaturatingSubV:
      if (!is_subword_type(bt)) {
        return false;
      }
      if (size_in_bits < 128 || !VM_Version::supports_avx512bw()) {
        return false; // Implementation limitation
      }
      return true;

    case Op_VectorMaskCmp:
      if (is_subword_type(bt) && !VM_Version::supports_avx512bw()) {
        return false; // Implementation limitation
      }
      return true;

    case Op_VectorRearrange:
      if (bt == T_SHORT && !VM_Version::supports_avx512bw()) {
        return false; // Implementation limitation
      }
      if (bt == T_BYTE && !VM_Version::supports_avx512_vbmi()) {
        return false; // Implementation limitation
      } else if ((bt == T_INT || bt == T_FLOAT) && size_in_bits < 256) {
        return false; // Implementation limitation
      }
      return true;

    // Binary Logical operations
    case Op_AndVMask:
    case Op_OrVMask:
    case Op_XorVMask:
      if (vlen > 16 && !VM_Version::supports_avx512bw()) {
        return false; // Implementation limitation
      }
      return true;

    case Op_PopCountVI:
    case Op_PopCountVL:
      if (!is_pop_count_instr_target(bt)) {
        return false;
      }
      return true;

    case Op_MaskAll:
      return true;

    case Op_CountLeadingZerosV:
      if (is_non_subword_integral_type(bt) && VM_Version::supports_avx512cd()) {
        return true;
      }
    default:
      return false;
  }
}

bool Matcher::vector_needs_partial_operations(Node* node, const TypeVect* vt) {
  return false;
}

MachOper* Matcher::pd_specialize_generic_vector_operand(MachOper* generic_opnd, uint ideal_reg, bool is_temp) {
  assert(Matcher::is_generic_vector(generic_opnd), "not generic");
  bool legacy = (generic_opnd->opcode() == LEGVEC);
  if (!VM_Version::supports_avx512vlbwdq() && // KNL
      is_temp && !legacy && (ideal_reg == Op_VecZ)) {
    // Conservatively specialize 512bit vec TEMP operands to legVecZ (zmm0-15) on KNL.
    return new legVecZOper();
  }
  if (legacy) {
    switch (ideal_reg) {
      case Op_VecS: return new legVecSOper();
      case Op_VecD: return new legVecDOper();
      case Op_VecX: return new legVecXOper();
      case Op_VecY: return new legVecYOper();
      case Op_VecZ: return new legVecZOper();
    }
  } else {
    switch (ideal_reg) {
      case Op_VecS: return new vecSOper();
      case Op_VecD: return new vecDOper();
      case Op_VecX: return new vecXOper();
      case Op_VecY: return new vecYOper();
      case Op_VecZ: return new vecZOper();
    }
  }
  ShouldNotReachHere();
  return nullptr;
}

bool Matcher::is_reg2reg_move(MachNode* m) {
  switch (m->rule()) {
    case MoveVec2Leg_rule:
    case MoveLeg2Vec_rule:
    case MoveF2VL_rule:
    case MoveF2LEG_rule:
    case MoveVL2F_rule:
    case MoveLEG2F_rule:
    case MoveD2VL_rule:
    case MoveD2LEG_rule:
    case MoveVL2D_rule:
    case MoveLEG2D_rule:
      return true;
    default:
      return false;
  }
}

bool Matcher::is_generic_vector(MachOper* opnd) {
  switch (opnd->opcode()) {
    case VEC:
    case LEGVEC:
      return true;
    default:
      return false;
  }
}

//------------------------------------------------------------------------

const RegMask* Matcher::predicate_reg_mask(void) {
  return &_VECTMASK_REG_mask;
}

// Max vector size in bytes. 0 if not supported.
int Matcher::vector_width_in_bytes(BasicType bt) {
  assert(is_java_primitive(bt), "only primitive type vectors");
  if (UseSSE < 2) return 0;
  // SSE2 supports 128bit vectors for all types.
  // AVX2 supports 256bit vectors for all types.
  // AVX2/EVEX supports 512bit vectors for all types.
  int size = (UseAVX > 1) ? (1 << UseAVX) * 8 : 16;
  // AVX1 supports 256bit vectors only for FLOAT and DOUBLE.
  if (UseAVX > 0 && (bt == T_FLOAT || bt == T_DOUBLE))
    size = (UseAVX > 2) ? 64 : 32;
  if (UseAVX > 2 && (bt == T_BYTE || bt == T_SHORT || bt == T_CHAR))
    size = (VM_Version::supports_avx512bw()) ? 64 : 32;
  // Use flag to limit vector size.
  size = MIN2(size,(int)MaxVectorSize);
  // Minimum 2 values in vector (or 4 for bytes).
  switch (bt) {
  case T_DOUBLE:
  case T_LONG:
    if (size < 16) return 0;
    break;
  case T_FLOAT:
  case T_INT:
    if (size < 8) return 0;
    break;
  case T_BOOLEAN:
    if (size < 4) return 0;
    break;
  case T_CHAR:
    if (size < 4) return 0;
    break;
  case T_BYTE:
    if (size < 4) return 0;
    break;
  case T_SHORT:
    if (size < 4) return 0;
    break;
  default:
    ShouldNotReachHere();
  }
  return size;
}

// Limits on vector size (number of elements) loaded into vector.
int Matcher::max_vector_size(const BasicType bt) {
  return vector_width_in_bytes(bt)/type2aelembytes(bt);
}
int Matcher::min_vector_size(const BasicType bt) {
  int max_size = max_vector_size(bt);
  // Min size which can be loaded into vector is 4 bytes.
  int size = (type2aelembytes(bt) == 1) ? 4 : 2;
  // Support for calling svml double64 vectors
  if (bt == T_DOUBLE) {
    size = 1;
  }
  return MIN2(size,max_size);
}

int Matcher::max_vector_size_auto_vectorization(const BasicType bt) {
  // Limit the max vector size for auto vectorization to 256 bits (32 bytes)
  // by default on Cascade Lake
  if (VM_Version::is_default_intel_cascade_lake()) {
    return MIN2(Matcher::max_vector_size(bt), 32 / type2aelembytes(bt));
  }
  return Matcher::max_vector_size(bt);
}

int Matcher::scalable_vector_reg_size(const BasicType bt) {
  return -1;
}

// Vector ideal reg corresponding to specified size in bytes
uint Matcher::vector_ideal_reg(int size) {
  assert(MaxVectorSize >= size, "");
  switch(size) {
    case  4: return Op_VecS;
    case  8: return Op_VecD;
    case 16: return Op_VecX;
    case 32: return Op_VecY;
    case 64: return Op_VecZ;
  }
  ShouldNotReachHere();
  return 0;
}

// Check for shift by small constant as well
static bool clone_shift(Node* shift, Matcher* matcher, Matcher::MStack& mstack, VectorSet& address_visited) {
  if (shift->Opcode() == Op_LShiftX && shift->in(2)->is_Con() &&
      shift->in(2)->get_int() <= 3 &&
      // Are there other uses besides address expressions?
      !matcher->is_visited(shift)) {
    address_visited.set(shift->_idx); // Flag as address_visited
    mstack.push(shift->in(2), Matcher::Visit);
    Node *conv = shift->in(1);
#ifdef _LP64
    // Allow Matcher to match the rule which bypass
    // ConvI2L operation for an array index on LP64
    // if the index value is positive.
    if (conv->Opcode() == Op_ConvI2L &&
        conv->as_Type()->type()->is_long()->_lo >= 0 &&
        // Are there other uses besides address expressions?
        !matcher->is_visited(conv)) {
      address_visited.set(conv->_idx); // Flag as address_visited
      mstack.push(conv->in(1), Matcher::Pre_Visit);
    } else
#endif
      mstack.push(conv, Matcher::Pre_Visit);
    return true;
  }
  return false;
}

// This function identifies sub-graphs in which a 'load' node is
// input to two different nodes, and such that it can be matched
// with BMI instructions like blsi, blsr, etc.
// Example : for b = -a[i] & a[i] can be matched to blsi r32, m32.
// The graph is (AndL (SubL Con0 LoadL*) LoadL*), where LoadL*
// refers to the same node.
//
// Match the generic fused operations pattern (op1 (op2 Con{ConType} mop) mop)
// This is a temporary solution until we make DAGs expressible in ADL.
template<typename ConType>
class FusedPatternMatcher {
  Node* _op1_node;
  Node* _mop_node;
  int _con_op;

  static int match_next(Node* n, int next_op, int next_op_idx) {
    if (n->in(1) == nullptr || n->in(2) == nullptr) {
      return -1;
    }

    if (next_op_idx == -1) { // n is commutative, try rotations
      if (n->in(1)->Opcode() == next_op) {
        return 1;
      } else if (n->in(2)->Opcode() == next_op) {
        return 2;
      }
    } else {
      assert(next_op_idx > 0 && next_op_idx <= 2, "Bad argument index");
      if (n->in(next_op_idx)->Opcode() == next_op) {
        return next_op_idx;
      }
    }
    return -1;
  }

 public:
  FusedPatternMatcher(Node* op1_node, Node* mop_node, int con_op) :
    _op1_node(op1_node), _mop_node(mop_node), _con_op(con_op) { }

  bool match(int op1, int op1_op2_idx,  // op1 and the index of the op1->op2 edge, -1 if op1 is commutative
             int op2, int op2_con_idx,  // op2 and the index of the op2->con edge, -1 if op2 is commutative
             typename ConType::NativeType con_value) {
    if (_op1_node->Opcode() != op1) {
      return false;
    }
    if (_mop_node->outcnt() > 2) {
      return false;
    }
    op1_op2_idx = match_next(_op1_node, op2, op1_op2_idx);
    if (op1_op2_idx == -1) {
      return false;
    }
    // Memory operation must be the other edge
    int op1_mop_idx = (op1_op2_idx & 1) + 1;

    // Check that the mop node is really what we want
    if (_op1_node->in(op1_mop_idx) == _mop_node) {
      Node* op2_node = _op1_node->in(op1_op2_idx);
      if (op2_node->outcnt() > 1) {
        return false;
      }
      assert(op2_node->Opcode() == op2, "Should be");
      op2_con_idx = match_next(op2_node, _con_op, op2_con_idx);
      if (op2_con_idx == -1) {
        return false;
      }
      // Memory operation must be the other edge
      int op2_mop_idx = (op2_con_idx & 1) + 1;
      // Check that the memory operation is the same node
      if (op2_node->in(op2_mop_idx) == _mop_node) {
        // Now check the constant
        const Type* con_type = op2_node->in(op2_con_idx)->bottom_type();
        if (con_type != Type::TOP && ConType::as_self(con_type)->get_con() == con_value) {
          return true;
        }
      }
    }
    return false;
  }
};

static bool is_bmi_pattern(Node* n, Node* m) {
  assert(UseBMI1Instructions, "sanity");
  if (n != nullptr && m != nullptr) {
    if (m->Opcode() == Op_LoadI) {
      FusedPatternMatcher<TypeInt> bmii(n, m, Op_ConI);
      return bmii.match(Op_AndI, -1, Op_SubI,  1,  0)  ||
             bmii.match(Op_AndI, -1, Op_AddI, -1, -1)  ||
             bmii.match(Op_XorI, -1, Op_AddI, -1, -1);
    } else if (m->Opcode() == Op_LoadL) {
      FusedPatternMatcher<TypeLong> bmil(n, m, Op_ConL);
      return bmil.match(Op_AndL, -1, Op_SubL,  1,  0) ||
             bmil.match(Op_AndL, -1, Op_AddL, -1, -1) ||
             bmil.match(Op_XorL, -1, Op_AddL, -1, -1);
    }
  }
  return false;
}

// Should the matcher clone input 'm' of node 'n'?
bool Matcher::pd_clone_node(Node* n, Node* m, Matcher::MStack& mstack) {
  // If 'n' and 'm' are part of a graph for BMI instruction, clone the input 'm'.
  if (UseBMI1Instructions && is_bmi_pattern(n, m)) {
    mstack.push(m, Visit);
    return true;
  }
  if (is_vshift_con_pattern(n, m)) { // ShiftV src (ShiftCntV con)
    mstack.push(m, Visit);           // m = ShiftCntV
    return true;
  }
  if (is_encode_and_store_pattern(n, m)) {
    mstack.push(m, Visit);
    return true;
  }
  return false;
}

// Should the Matcher clone shifts on addressing modes, expecting them
// to be subsumed into complex addressing expressions or compute them
// into registers?
bool Matcher::pd_clone_address_expressions(AddPNode* m, Matcher::MStack& mstack, VectorSet& address_visited) {
  Node *off = m->in(AddPNode::Offset);
  if (off->is_Con()) {
    address_visited.test_set(m->_idx); // Flag as address_visited
    Node *adr = m->in(AddPNode::Address);

    // Intel can handle 2 adds in addressing mode, with one of them using an immediate offset.
    // AtomicAdd is not an addressing expression.
    // Cheap to find it by looking for screwy base.
    if (adr->is_AddP() &&
        !adr->in(AddPNode::Base)->is_top() &&
        !adr->in(AddPNode::Offset)->is_Con() &&
        LP64_ONLY( off->get_long() == (int) (off->get_long()) && ) // immL32
        // Are there other uses besides address expressions?
        !is_visited(adr)) {
      address_visited.set(adr->_idx); // Flag as address_visited
      Node *shift = adr->in(AddPNode::Offset);
      if (!clone_shift(shift, this, mstack, address_visited)) {
        mstack.push(shift, Pre_Visit);
      }
      mstack.push(adr->in(AddPNode::Address), Pre_Visit);
      mstack.push(adr->in(AddPNode::Base), Pre_Visit);
    } else {
      mstack.push(adr, Pre_Visit);
    }

    // Clone X+offset as it also folds into most addressing expressions
    mstack.push(off, Visit);
    mstack.push(m->in(AddPNode::Base), Pre_Visit);
    return true;
  } else if (clone_shift(off, this, mstack, address_visited)) {
    address_visited.test_set(m->_idx); // Flag as address_visited
    mstack.push(m->in(AddPNode::Address), Pre_Visit);
    mstack.push(m->in(AddPNode::Base), Pre_Visit);
    return true;
  }
  return false;
}

static inline Assembler::ComparisonPredicate booltest_pred_to_comparison_pred(int bt) {
  switch (bt) {
    case BoolTest::eq:
      return Assembler::eq;
    case BoolTest::ne:
      return Assembler::neq;
    case BoolTest::le:
    case BoolTest::ule:
      return Assembler::le;
    case BoolTest::ge:
    case BoolTest::uge:
      return Assembler::nlt;
    case BoolTest::lt:
    case BoolTest::ult:
      return Assembler::lt;
    case BoolTest::gt:
    case BoolTest::ugt:
      return Assembler::nle;
    default : ShouldNotReachHere(); return Assembler::_false;
  }
}

static inline Assembler::ComparisonPredicateFP booltest_pred_to_comparison_pred_fp(int bt) {
  switch (bt) {
  case BoolTest::eq: return Assembler::EQ_OQ;  // ordered non-signaling
  // As per JLS 15.21.1, != of NaNs is true. Thus use unordered compare.
  case BoolTest::ne: return Assembler::NEQ_UQ; // unordered non-signaling
  case BoolTest::le: return Assembler::LE_OQ;  // ordered non-signaling
  case BoolTest::ge: return Assembler::GE_OQ;  // ordered non-signaling
  case BoolTest::lt: return Assembler::LT_OQ;  // ordered non-signaling
  case BoolTest::gt: return Assembler::GT_OQ;  // ordered non-signaling
  default: ShouldNotReachHere(); return Assembler::FALSE_OS;
  }
}

// Helper methods for MachSpillCopyNode::implementation().
static void vec_mov_helper(C2_MacroAssembler *masm, int src_lo, int dst_lo,
                          int src_hi, int dst_hi, uint ireg, outputStream* st) {
  assert(ireg == Op_VecS || // 32bit vector
         ((src_lo & 1) == 0 && (src_lo + 1) == src_hi &&
          (dst_lo & 1) == 0 && (dst_lo + 1) == dst_hi),
         "no non-adjacent vector moves" );
  if (masm) {
    switch (ireg) {
    case Op_VecS: // copy whole register
    case Op_VecD:
    case Op_VecX:
#ifndef _LP64
      __ movdqu(as_XMMRegister(Matcher::_regEncode[dst_lo]), as_XMMRegister(Matcher::_regEncode[src_lo]));
#else
      if ((UseAVX < 3) || VM_Version::supports_avx512vl()) {
        __ movdqu(as_XMMRegister(Matcher::_regEncode[dst_lo]), as_XMMRegister(Matcher::_regEncode[src_lo]));
      } else {
        __ vextractf32x4(as_XMMRegister(Matcher::_regEncode[dst_lo]), as_XMMRegister(Matcher::_regEncode[src_lo]), 0x0);
     }
#endif
      break;
    case Op_VecY:
#ifndef _LP64
      __ vmovdqu(as_XMMRegister(Matcher::_regEncode[dst_lo]), as_XMMRegister(Matcher::_regEncode[src_lo]));
#else
      if ((UseAVX < 3) || VM_Version::supports_avx512vl()) {
        __ vmovdqu(as_XMMRegister(Matcher::_regEncode[dst_lo]), as_XMMRegister(Matcher::_regEncode[src_lo]));
      } else {
        __ vextractf64x4(as_XMMRegister(Matcher::_regEncode[dst_lo]), as_XMMRegister(Matcher::_regEncode[src_lo]), 0x0);
     }
#endif
      break;
    case Op_VecZ:
      __ evmovdquq(as_XMMRegister(Matcher::_regEncode[dst_lo]), as_XMMRegister(Matcher::_regEncode[src_lo]), 2);
      break;
    default:
      ShouldNotReachHere();
    }
#ifndef PRODUCT
  } else {
    switch (ireg) {
    case Op_VecS:
    case Op_VecD:
    case Op_VecX:
      st->print("movdqu  %s,%s\t# spill",Matcher::regName[dst_lo],Matcher::regName[src_lo]);
      break;
    case Op_VecY:
    case Op_VecZ:
      st->print("vmovdqu %s,%s\t# spill",Matcher::regName[dst_lo],Matcher::regName[src_lo]);
      break;
    default:
      ShouldNotReachHere();
    }
#endif
  }
}

void vec_spill_helper(C2_MacroAssembler *masm, bool is_load,
                     int stack_offset, int reg, uint ireg, outputStream* st) {
  if (masm) {
    if (is_load) {
      switch (ireg) {
      case Op_VecS:
        __ movdl(as_XMMRegister(Matcher::_regEncode[reg]), Address(rsp, stack_offset));
        break;
      case Op_VecD:
        __ movq(as_XMMRegister(Matcher::_regEncode[reg]), Address(rsp, stack_offset));
        break;
      case Op_VecX:
#ifndef _LP64
        __ movdqu(as_XMMRegister(Matcher::_regEncode[reg]), Address(rsp, stack_offset));
#else
        if ((UseAVX < 3) || VM_Version::supports_avx512vl()) {
          __ movdqu(as_XMMRegister(Matcher::_regEncode[reg]), Address(rsp, stack_offset));
        } else {
          __ vpxor(as_XMMRegister(Matcher::_regEncode[reg]), as_XMMRegister(Matcher::_regEncode[reg]), as_XMMRegister(Matcher::_regEncode[reg]), 2);
          __ vinsertf32x4(as_XMMRegister(Matcher::_regEncode[reg]), as_XMMRegister(Matcher::_regEncode[reg]), Address(rsp, stack_offset),0x0);
        }
#endif
        break;
      case Op_VecY:
#ifndef _LP64
        __ vmovdqu(as_XMMRegister(Matcher::_regEncode[reg]), Address(rsp, stack_offset));
#else
        if ((UseAVX < 3) || VM_Version::supports_avx512vl()) {
          __ vmovdqu(as_XMMRegister(Matcher::_regEncode[reg]), Address(rsp, stack_offset));
        } else {
          __ vpxor(as_XMMRegister(Matcher::_regEncode[reg]), as_XMMRegister(Matcher::_regEncode[reg]), as_XMMRegister(Matcher::_regEncode[reg]), 2);
          __ vinsertf64x4(as_XMMRegister(Matcher::_regEncode[reg]), as_XMMRegister(Matcher::_regEncode[reg]), Address(rsp, stack_offset),0x0);
        }
#endif
        break;
      case Op_VecZ:
        __ evmovdquq(as_XMMRegister(Matcher::_regEncode[reg]), Address(rsp, stack_offset), 2);
        break;
      default:
        ShouldNotReachHere();
      }
    } else { // store
      switch (ireg) {
      case Op_VecS:
        __ movdl(Address(rsp, stack_offset), as_XMMRegister(Matcher::_regEncode[reg]));
        break;
      case Op_VecD:
        __ movq(Address(rsp, stack_offset), as_XMMRegister(Matcher::_regEncode[reg]));
        break;
      case Op_VecX:
#ifndef _LP64
        __ movdqu(Address(rsp, stack_offset), as_XMMRegister(Matcher::_regEncode[reg]));
#else
        if ((UseAVX < 3) || VM_Version::supports_avx512vl()) {
          __ movdqu(Address(rsp, stack_offset), as_XMMRegister(Matcher::_regEncode[reg]));
        }
        else {
          __ vextractf32x4(Address(rsp, stack_offset), as_XMMRegister(Matcher::_regEncode[reg]), 0x0);
        }
#endif
        break;
      case Op_VecY:
#ifndef _LP64
        __ vmovdqu(Address(rsp, stack_offset), as_XMMRegister(Matcher::_regEncode[reg]));
#else
        if ((UseAVX < 3) || VM_Version::supports_avx512vl()) {
          __ vmovdqu(Address(rsp, stack_offset), as_XMMRegister(Matcher::_regEncode[reg]));
        }
        else {
          __ vextractf64x4(Address(rsp, stack_offset), as_XMMRegister(Matcher::_regEncode[reg]), 0x0);
        }
#endif
        break;
      case Op_VecZ:
        __ evmovdquq(Address(rsp, stack_offset), as_XMMRegister(Matcher::_regEncode[reg]), 2);
        break;
      default:
        ShouldNotReachHere();
      }
    }
#ifndef PRODUCT
  } else {
    if (is_load) {
      switch (ireg) {
      case Op_VecS:
        st->print("movd    %s,[rsp + %d]\t# spill", Matcher::regName[reg], stack_offset);
        break;
      case Op_VecD:
        st->print("movq    %s,[rsp + %d]\t# spill", Matcher::regName[reg], stack_offset);
        break;
       case Op_VecX:
        st->print("movdqu  %s,[rsp + %d]\t# spill", Matcher::regName[reg], stack_offset);
        break;
      case Op_VecY:
      case Op_VecZ:
        st->print("vmovdqu %s,[rsp + %d]\t# spill", Matcher::regName[reg], stack_offset);
        break;
      default:
        ShouldNotReachHere();
      }
    } else { // store
      switch (ireg) {
      case Op_VecS:
        st->print("movd    [rsp + %d],%s\t# spill", stack_offset, Matcher::regName[reg]);
        break;
      case Op_VecD:
        st->print("movq    [rsp + %d],%s\t# spill", stack_offset, Matcher::regName[reg]);
        break;
       case Op_VecX:
        st->print("movdqu  [rsp + %d],%s\t# spill", stack_offset, Matcher::regName[reg]);
        break;
      case Op_VecY:
      case Op_VecZ:
        st->print("vmovdqu [rsp + %d],%s\t# spill", stack_offset, Matcher::regName[reg]);
        break;
      default:
        ShouldNotReachHere();
      }
    }
#endif
  }
}

template <class T>
static inline GrowableArray<jvalue>* vreplicate_imm(BasicType bt, T con, int len) {
  GrowableArray<jvalue>* val = new GrowableArray<jvalue>(len);
  jvalue ele;
  switch (bt) {
    case T_BYTE:   ele.b = con; break;
    case T_SHORT:  ele.s = con; break;
    case T_INT:    ele.i = con; break;
    case T_LONG:   ele.j = con; break;
    case T_FLOAT:  ele.f = con; break;
    case T_DOUBLE: ele.d = con; break;
    default: ShouldNotReachHere();
  }
  for (int i = 0; i < len; i++) {
    val->append(ele);
  }
  return val;
}

static inline jlong high_bit_set(BasicType bt) {
  switch (bt) {
    case T_BYTE:  return 0x8080808080808080;
    case T_SHORT: return 0x8000800080008000;
    case T_INT:   return 0x8000000080000000;
    case T_LONG:  return 0x8000000000000000;
    default:
      ShouldNotReachHere();
      return 0;
  }
}

#ifndef PRODUCT
  void MachNopNode::format(PhaseRegAlloc*, outputStream* st) const {
    st->print("nop \t# %d bytes pad for loops and calls", _count);
  }
#endif

  void MachNopNode::emit(C2_MacroAssembler *masm, PhaseRegAlloc*) const {
    __ nop(_count);
  }

  uint MachNopNode::size(PhaseRegAlloc*) const {
    return _count;
  }

#ifndef PRODUCT
  void MachBreakpointNode::format(PhaseRegAlloc*, outputStream* st) const {
    st->print("# breakpoint");
  }
#endif

  void MachBreakpointNode::emit(C2_MacroAssembler *masm, PhaseRegAlloc* ra_) const {
    __ int3();
  }

  uint MachBreakpointNode::size(PhaseRegAlloc* ra_) const {
    return MachNode::size(ra_);
  }


#line 2852 "ad_x86.cpp"


//SourceForm

#line 32 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/z/z_x86_64.ad"


#include "c2_intelJccErratum_x86.hpp"
#include "gc/z/zBarrierSetAssembler.hpp"

static void z_color(MacroAssembler* masm, const MachNode* node, Register ref) {
  __ relocate(barrier_Relocation::spec(), ZBarrierRelocationFormatLoadGoodBeforeShl);
  __ shlq(ref, barrier_Relocation::unpatched);
  __ orq_imm32(ref, barrier_Relocation::unpatched);
  __ relocate(barrier_Relocation::spec(), ZBarrierRelocationFormatStoreGoodAfterOr);
}

static void z_uncolor(MacroAssembler* masm, const MachNode* node, Register ref) {
  __ relocate(barrier_Relocation::spec(), ZBarrierRelocationFormatLoadGoodBeforeShl);
  __ shrq(ref, barrier_Relocation::unpatched);
}

static void z_keep_alive_load_barrier(MacroAssembler* masm, const MachNode* node, Address ref_addr, Register ref) {
  __ Assembler::testl(ref, barrier_Relocation::unpatched);
  __ relocate(barrier_Relocation::spec(), ZBarrierRelocationFormatMarkBadAfterTest);

  ZLoadBarrierStubC2* const stub = ZLoadBarrierStubC2::create(node, ref_addr, ref);
  __ jcc(Assembler::notEqual, *stub->entry());

  z_uncolor(masm, node, ref);

  __ bind(*stub->continuation());
}

static void z_load_barrier(MacroAssembler* masm, const MachNode* node, Address ref_addr, Register ref) {
  Assembler::InlineSkippedInstructionsCounter skipped_counter(masm);
  const bool on_non_strong =
      ((node->barrier_data() & ZBarrierWeak) != 0) ||
      ((node->barrier_data() & ZBarrierPhantom) != 0);

  if (on_non_strong) {
    z_keep_alive_load_barrier(masm, node, ref_addr, ref);
    return;
  }

  z_uncolor(masm, node, ref);
  if (node->barrier_data() == ZBarrierElided) {
    return;
  }
  ZLoadBarrierStubC2* const stub = ZLoadBarrierStubC2::create(node, ref_addr, ref);
  {
    IntelJccErratumAlignment intel_alignment(masm, 6);
    __ jcc(Assembler::above, *stub->entry());
  }
  __ bind(*stub->continuation());
}

static void z_store_barrier(MacroAssembler* masm, const MachNode* node, Address ref_addr, Register rnew_zaddress, Register rnew_zpointer, bool is_atomic) {
  Assembler::InlineSkippedInstructionsCounter skipped_counter(masm);
  if (node->barrier_data() == ZBarrierElided) {
    if (rnew_zaddress != noreg) {
      // noreg means null; no need to color
      __ movptr(rnew_zpointer, rnew_zaddress);
      z_color(masm, node, rnew_zpointer);
    }
  } else {
    bool is_native = (node->barrier_data() & ZBarrierNative) != 0;
    bool is_nokeepalive = (node->barrier_data() & ZBarrierNoKeepalive) != 0;
    ZStoreBarrierStubC2* const stub = ZStoreBarrierStubC2::create(node, ref_addr, rnew_zaddress, rnew_zpointer, is_native, is_atomic, is_nokeepalive);
    ZBarrierSetAssembler* bs_asm = ZBarrierSet::assembler();
    bs_asm->store_barrier_fast(masm, ref_addr, rnew_zaddress, rnew_zpointer, true /* in_nmethod */, is_atomic, *stub->entry(), *stub->continuation());
  }
}


#line 2928 "ad_x86.cpp"


//SourceForm

#line 31 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/g1/g1_x86_64.ad"


#include "gc/g1/g1BarrierSetAssembler_x86.hpp"
#include "gc/g1/g1BarrierSetRuntime.hpp"

static void write_barrier_pre(MacroAssembler* masm,
                              const MachNode* node,
                              Register obj,
                              Register pre_val,
                              Register tmp,
                              RegSet preserve = RegSet(),
                              RegSet no_preserve = RegSet()) {
  if (!G1PreBarrierStubC2::needs_barrier(node)) {
    return;
  }
  Assembler::InlineSkippedInstructionsCounter skip_counter(masm);
  G1BarrierSetAssembler* g1_asm = static_cast<G1BarrierSetAssembler*>(BarrierSet::barrier_set()->barrier_set_assembler());
  G1PreBarrierStubC2* const stub = G1PreBarrierStubC2::create(node);
  for (RegSetIterator<Register> reg = preserve.begin(); *reg != noreg; ++reg) {
    stub->preserve(*reg);
  }
  for (RegSetIterator<Register> reg = no_preserve.begin(); *reg != noreg; ++reg) {
    stub->dont_preserve(*reg);
  }
  g1_asm->g1_write_barrier_pre_c2(masm, obj, pre_val, r15_thread, tmp, stub);
}

static void write_barrier_post(MacroAssembler* masm,
                               const MachNode* node,
                               Register store_addr,
                               Register new_val,
                               Register tmp1,
                               Register tmp2) {
  if (!G1PostBarrierStubC2::needs_barrier(node)) {
    return;
  }
  Assembler::InlineSkippedInstructionsCounter skip_counter(masm);
  G1BarrierSetAssembler* g1_asm = static_cast<G1BarrierSetAssembler*>(BarrierSet::barrier_set()->barrier_set_assembler());
  G1PostBarrierStubC2* const stub = G1PostBarrierStubC2::create(node);
  g1_asm->g1_write_barrier_post_c2(masm, store_addr, new_val, r15_thread, tmp1, tmp2, stub);
}


#line 2977 "ad_x86.cpp"


#ifndef PRODUCT
void Compile::adlc_verification() {

  // Following assertions generated from definition section
}
#endif

// Map from machine-independent register number to register_save_policy
const        char register_save_policy[] = {
  'C', // R10
  'C', // R10_H
  'C', // R11
  'C', // R11_H
  'C', // R8
  'C', // R8_H
  'C', // R9
  'C', // R9_H
  'C', // R12
  'C', // R12_H
  'C', // RCX
  'C', // RCX_H
  'C', // RBX
  'C', // RBX_H
  'C', // RDI
  'C', // RDI_H
  'C', // RDX
  'C', // RDX_H
  'C', // RSI
  'C', // RSI_H
  'C', // RAX
  'C', // RAX_H
  'N', // RBP
  'N', // RBP_H
  'C', // R13
  'C', // R13_H
  'C', // R14
  'C', // R14_H
  'C', // R15
  'C', // R15_H
  'C', // R16
  'C', // R16_H
  'C', // R17
  'C', // R17_H
  'C', // R18
  'C', // R18_H
  'C', // R19
  'C', // R19_H
  'C', // R20
  'C', // R20_H
  'C', // R21
  'C', // R21_H
  'C', // R22
  'C', // R22_H
  'C', // R23
  'C', // R23_H
  'C', // R24
  'C', // R24_H
  'C', // R25
  'C', // R25_H
  'C', // R26
  'C', // R26_H
  'C', // R27
  'C', // R27_H
  'C', // R28
  'C', // R28_H
  'C', // R29
  'C', // R29_H
  'C', // R30
  'C', // R30_H
  'C', // R31
  'C', // R31_H
  'N', // RSP
  'N', // RSP_H
  'C', // XMM0
  'C', // XMM0b
  'C', // XMM0c
  'C', // XMM0d
  'C', // XMM0e
  'C', // XMM0f
  'C', // XMM0g
  'C', // XMM0h
  'C', // XMM0i
  'C', // XMM0j
  'C', // XMM0k
  'C', // XMM0l
  'C', // XMM0m
  'C', // XMM0n
  'C', // XMM0o
  'C', // XMM0p
  'C', // XMM1
  'C', // XMM1b
  'C', // XMM1c
  'C', // XMM1d
  'C', // XMM1e
  'C', // XMM1f
  'C', // XMM1g
  'C', // XMM1h
  'C', // XMM1i
  'C', // XMM1j
  'C', // XMM1k
  'C', // XMM1l
  'C', // XMM1m
  'C', // XMM1n
  'C', // XMM1o
  'C', // XMM1p
  'C', // XMM2
  'C', // XMM2b
  'C', // XMM2c
  'C', // XMM2d
  'C', // XMM2e
  'C', // XMM2f
  'C', // XMM2g
  'C', // XMM2h
  'C', // XMM2i
  'C', // XMM2j
  'C', // XMM2k
  'C', // XMM2l
  'C', // XMM2m
  'C', // XMM2n
  'C', // XMM2o
  'C', // XMM2p
  'C', // XMM3
  'C', // XMM3b
  'C', // XMM3c
  'C', // XMM3d
  'C', // XMM3e
  'C', // XMM3f
  'C', // XMM3g
  'C', // XMM3h
  'C', // XMM3i
  'C', // XMM3j
  'C', // XMM3k
  'C', // XMM3l
  'C', // XMM3m
  'C', // XMM3n
  'C', // XMM3o
  'C', // XMM3p
  'C', // XMM4
  'C', // XMM4b
  'C', // XMM4c
  'C', // XMM4d
  'C', // XMM4e
  'C', // XMM4f
  'C', // XMM4g
  'C', // XMM4h
  'C', // XMM4i
  'C', // XMM4j
  'C', // XMM4k
  'C', // XMM4l
  'C', // XMM4m
  'C', // XMM4n
  'C', // XMM4o
  'C', // XMM4p
  'C', // XMM5
  'C', // XMM5b
  'C', // XMM5c
  'C', // XMM5d
  'C', // XMM5e
  'C', // XMM5f
  'C', // XMM5g
  'C', // XMM5h
  'C', // XMM5i
  'C', // XMM5j
  'C', // XMM5k
  'C', // XMM5l
  'C', // XMM5m
  'C', // XMM5n
  'C', // XMM5o
  'C', // XMM5p
  'C', // XMM6
  'C', // XMM6b
  'C', // XMM6c
  'C', // XMM6d
  'C', // XMM6e
  'C', // XMM6f
  'C', // XMM6g
  'C', // XMM6h
  'C', // XMM6i
  'C', // XMM6j
  'C', // XMM6k
  'C', // XMM6l
  'C', // XMM6m
  'C', // XMM6n
  'C', // XMM6o
  'C', // XMM6p
  'C', // XMM7
  'C', // XMM7b
  'C', // XMM7c
  'C', // XMM7d
  'C', // XMM7e
  'C', // XMM7f
  'C', // XMM7g
  'C', // XMM7h
  'C', // XMM7i
  'C', // XMM7j
  'C', // XMM7k
  'C', // XMM7l
  'C', // XMM7m
  'C', // XMM7n
  'C', // XMM7o
  'C', // XMM7p
  'C', // XMM8
  'C', // XMM8b
  'C', // XMM8c
  'C', // XMM8d
  'C', // XMM8e
  'C', // XMM8f
  'C', // XMM8g
  'C', // XMM8h
  'C', // XMM8i
  'C', // XMM8j
  'C', // XMM8k
  'C', // XMM8l
  'C', // XMM8m
  'C', // XMM8n
  'C', // XMM8o
  'C', // XMM8p
  'C', // XMM9
  'C', // XMM9b
  'C', // XMM9c
  'C', // XMM9d
  'C', // XMM9e
  'C', // XMM9f
  'C', // XMM9g
  'C', // XMM9h
  'C', // XMM9i
  'C', // XMM9j
  'C', // XMM9k
  'C', // XMM9l
  'C', // XMM9m
  'C', // XMM9n
  'C', // XMM9o
  'C', // XMM9p
  'C', // XMM10
  'C', // XMM10b
  'C', // XMM10c
  'C', // XMM10d
  'C', // XMM10e
  'C', // XMM10f
  'C', // XMM10g
  'C', // XMM10h
  'C', // XMM10i
  'C', // XMM10j
  'C', // XMM10k
  'C', // XMM10l
  'C', // XMM10m
  'C', // XMM10n
  'C', // XMM10o
  'C', // XMM10p
  'C', // XMM11
  'C', // XMM11b
  'C', // XMM11c
  'C', // XMM11d
  'C', // XMM11e
  'C', // XMM11f
  'C', // XMM11g
  'C', // XMM11h
  'C', // XMM11i
  'C', // XMM11j
  'C', // XMM11k
  'C', // XMM11l
  'C', // XMM11m
  'C', // XMM11n
  'C', // XMM11o
  'C', // XMM11p
  'C', // XMM12
  'C', // XMM12b
  'C', // XMM12c
  'C', // XMM12d
  'C', // XMM12e
  'C', // XMM12f
  'C', // XMM12g
  'C', // XMM12h
  'C', // XMM12i
  'C', // XMM12j
  'C', // XMM12k
  'C', // XMM12l
  'C', // XMM12m
  'C', // XMM12n
  'C', // XMM12o
  'C', // XMM12p
  'C', // XMM13
  'C', // XMM13b
  'C', // XMM13c
  'C', // XMM13d
  'C', // XMM13e
  'C', // XMM13f
  'C', // XMM13g
  'C', // XMM13h
  'C', // XMM13i
  'C', // XMM13j
  'C', // XMM13k
  'C', // XMM13l
  'C', // XMM13m
  'C', // XMM13n
  'C', // XMM13o
  'C', // XMM13p
  'C', // XMM14
  'C', // XMM14b
  'C', // XMM14c
  'C', // XMM14d
  'C', // XMM14e
  'C', // XMM14f
  'C', // XMM14g
  'C', // XMM14h
  'C', // XMM14i
  'C', // XMM14j
  'C', // XMM14k
  'C', // XMM14l
  'C', // XMM14m
  'C', // XMM14n
  'C', // XMM14o
  'C', // XMM14p
  'C', // XMM15
  'C', // XMM15b
  'C', // XMM15c
  'C', // XMM15d
  'C', // XMM15e
  'C', // XMM15f
  'C', // XMM15g
  'C', // XMM15h
  'C', // XMM15i
  'C', // XMM15j
  'C', // XMM15k
  'C', // XMM15l
  'C', // XMM15m
  'C', // XMM15n
  'C', // XMM15o
  'C', // XMM15p
  'C', // XMM16
  'C', // XMM16b
  'C', // XMM16c
  'C', // XMM16d
  'C', // XMM16e
  'C', // XMM16f
  'C', // XMM16g
  'C', // XMM16h
  'C', // XMM16i
  'C', // XMM16j
  'C', // XMM16k
  'C', // XMM16l
  'C', // XMM16m
  'C', // XMM16n
  'C', // XMM16o
  'C', // XMM16p
  'C', // XMM17
  'C', // XMM17b
  'C', // XMM17c
  'C', // XMM17d
  'C', // XMM17e
  'C', // XMM17f
  'C', // XMM17g
  'C', // XMM17h
  'C', // XMM17i
  'C', // XMM17j
  'C', // XMM17k
  'C', // XMM17l
  'C', // XMM17m
  'C', // XMM17n
  'C', // XMM17o
  'C', // XMM17p
  'C', // XMM18
  'C', // XMM18b
  'C', // XMM18c
  'C', // XMM18d
  'C', // XMM18e
  'C', // XMM18f
  'C', // XMM18g
  'C', // XMM18h
  'C', // XMM18i
  'C', // XMM18j
  'C', // XMM18k
  'C', // XMM18l
  'C', // XMM18m
  'C', // XMM18n
  'C', // XMM18o
  'C', // XMM18p
  'C', // XMM19
  'C', // XMM19b
  'C', // XMM19c
  'C', // XMM19d
  'C', // XMM19e
  'C', // XMM19f
  'C', // XMM19g
  'C', // XMM19h
  'C', // XMM19i
  'C', // XMM19j
  'C', // XMM19k
  'C', // XMM19l
  'C', // XMM19m
  'C', // XMM19n
  'C', // XMM19o
  'C', // XMM19p
  'C', // XMM20
  'C', // XMM20b
  'C', // XMM20c
  'C', // XMM20d
  'C', // XMM20e
  'C', // XMM20f
  'C', // XMM20g
  'C', // XMM20h
  'C', // XMM20i
  'C', // XMM20j
  'C', // XMM20k
  'C', // XMM20l
  'C', // XMM20m
  'C', // XMM20n
  'C', // XMM20o
  'C', // XMM20p
  'C', // XMM21
  'C', // XMM21b
  'C', // XMM21c
  'C', // XMM21d
  'C', // XMM21e
  'C', // XMM21f
  'C', // XMM21g
  'C', // XMM21h
  'C', // XMM21i
  'C', // XMM21j
  'C', // XMM21k
  'C', // XMM21l
  'C', // XMM21m
  'C', // XMM21n
  'C', // XMM21o
  'C', // XMM21p
  'C', // XMM22
  'C', // XMM22b
  'C', // XMM22c
  'C', // XMM22d
  'C', // XMM22e
  'C', // XMM22f
  'C', // XMM22g
  'C', // XMM22h
  'C', // XMM22i
  'C', // XMM22j
  'C', // XMM22k
  'C', // XMM22l
  'C', // XMM22m
  'C', // XMM22n
  'C', // XMM22o
  'C', // XMM22p
  'C', // XMM23
  'C', // XMM23b
  'C', // XMM23c
  'C', // XMM23d
  'C', // XMM23e
  'C', // XMM23f
  'C', // XMM23g
  'C', // XMM23h
  'C', // XMM23i
  'C', // XMM23j
  'C', // XMM23k
  'C', // XMM23l
  'C', // XMM23m
  'C', // XMM23n
  'C', // XMM23o
  'C', // XMM23p
  'C', // XMM24
  'C', // XMM24b
  'C', // XMM24c
  'C', // XMM24d
  'C', // XMM24e
  'C', // XMM24f
  'C', // XMM24g
  'C', // XMM24h
  'C', // XMM24i
  'C', // XMM24j
  'C', // XMM24k
  'C', // XMM24l
  'C', // XMM24m
  'C', // XMM24n
  'C', // XMM24o
  'C', // XMM24p
  'C', // XMM25
  'C', // XMM25b
  'C', // XMM25c
  'C', // XMM25d
  'C', // XMM25e
  'C', // XMM25f
  'C', // XMM25g
  'C', // XMM25h
  'C', // XMM25i
  'C', // XMM25j
  'C', // XMM25k
  'C', // XMM25l
  'C', // XMM25m
  'C', // XMM25n
  'C', // XMM25o
  'C', // XMM25p
  'C', // XMM26
  'C', // XMM26b
  'C', // XMM26c
  'C', // XMM26d
  'C', // XMM26e
  'C', // XMM26f
  'C', // XMM26g
  'C', // XMM26h
  'C', // XMM26i
  'C', // XMM26j
  'C', // XMM26k
  'C', // XMM26l
  'C', // XMM26m
  'C', // XMM26n
  'C', // XMM26o
  'C', // XMM26p
  'C', // XMM27
  'C', // XMM27b
  'C', // XMM27c
  'C', // XMM27d
  'C', // XMM27e
  'C', // XMM27f
  'C', // XMM27g
  'C', // XMM27h
  'C', // XMM27i
  'C', // XMM27j
  'C', // XMM27k
  'C', // XMM27l
  'C', // XMM27m
  'C', // XMM27n
  'C', // XMM27o
  'C', // XMM27p
  'C', // XMM28
  'C', // XMM28b
  'C', // XMM28c
  'C', // XMM28d
  'C', // XMM28e
  'C', // XMM28f
  'C', // XMM28g
  'C', // XMM28h
  'C', // XMM28i
  'C', // XMM28j
  'C', // XMM28k
  'C', // XMM28l
  'C', // XMM28m
  'C', // XMM28n
  'C', // XMM28o
  'C', // XMM28p
  'C', // XMM29
  'C', // XMM29b
  'C', // XMM29c
  'C', // XMM29d
  'C', // XMM29e
  'C', // XMM29f
  'C', // XMM29g
  'C', // XMM29h
  'C', // XMM29i
  'C', // XMM29j
  'C', // XMM29k
  'C', // XMM29l
  'C', // XMM29m
  'C', // XMM29n
  'C', // XMM29o
  'C', // XMM29p
  'C', // XMM30
  'C', // XMM30b
  'C', // XMM30c
  'C', // XMM30d
  'C', // XMM30e
  'C', // XMM30f
  'C', // XMM30g
  'C', // XMM30h
  'C', // XMM30i
  'C', // XMM30j
  'C', // XMM30k
  'C', // XMM30l
  'C', // XMM30m
  'C', // XMM30n
  'C', // XMM30o
  'C', // XMM30p
  'C', // XMM31
  'C', // XMM31b
  'C', // XMM31c
  'C', // XMM31d
  'C', // XMM31e
  'C', // XMM31f
  'C', // XMM31g
  'C', // XMM31h
  'C', // XMM31i
  'C', // XMM31j
  'C', // XMM31k
  'C', // XMM31l
  'C', // XMM31m
  'C', // XMM31n
  'C', // XMM31o
  'C', // XMM31p
  'C', // K7
  'C', // K7_H
  'C', // K6
  'C', // K6_H
  'C', // K5
  'C', // K5_H
  'C', // K4
  'C', // K4_H
  'C', // K3
  'C', // K3_H
  'C', // K2
  'C', // K2_H
  'C', // K1
  'C', // K1_H
  'C' // no trailing comma // RFLAGS
};

// Map from machine-independent register number to c_reg_save_policy
const        char c_reg_save_policy[] = {
  'C', // R10
  'C', // R10_H
  'C', // R11
  'C', // R11_H
  'C', // R8
  'C', // R8_H
  'C', // R9
  'C', // R9_H
  'E', // R12
  'E', // R12_H
  'C', // RCX
  'C', // RCX_H
  'E', // RBX
  'E', // RBX_H
  'C', // RDI
  'C', // RDI_H
  'C', // RDX
  'C', // RDX_H
  'C', // RSI
  'C', // RSI_H
  'C', // RAX
  'C', // RAX_H
  'E', // RBP
  'E', // RBP_H
  'E', // R13
  'E', // R13_H
  'E', // R14
  'E', // R14_H
  'E', // R15
  'E', // R15_H
  'C', // R16
  'C', // R16_H
  'C', // R17
  'C', // R17_H
  'C', // R18
  'C', // R18_H
  'C', // R19
  'C', // R19_H
  'C', // R20
  'C', // R20_H
  'C', // R21
  'C', // R21_H
  'C', // R22
  'C', // R22_H
  'C', // R23
  'C', // R23_H
  'C', // R24
  'C', // R24_H
  'C', // R25
  'C', // R25_H
  'C', // R26
  'C', // R26_H
  'C', // R27
  'C', // R27_H
  'C', // R28
  'C', // R28_H
  'C', // R29
  'C', // R29_H
  'C', // R30
  'C', // R30_H
  'C', // R31
  'C', // R31_H
  'N', // RSP
  'N', // RSP_H
  'C', // XMM0
  'C', // XMM0b
  'C', // XMM0c
  'C', // XMM0d
  'C', // XMM0e
  'C', // XMM0f
  'C', // XMM0g
  'C', // XMM0h
  'C', // XMM0i
  'C', // XMM0j
  'C', // XMM0k
  'C', // XMM0l
  'C', // XMM0m
  'C', // XMM0n
  'C', // XMM0o
  'C', // XMM0p
  'C', // XMM1
  'C', // XMM1b
  'C', // XMM1c
  'C', // XMM1d
  'C', // XMM1e
  'C', // XMM1f
  'C', // XMM1g
  'C', // XMM1h
  'C', // XMM1i
  'C', // XMM1j
  'C', // XMM1k
  'C', // XMM1l
  'C', // XMM1m
  'C', // XMM1n
  'C', // XMM1o
  'C', // XMM1p
  'C', // XMM2
  'C', // XMM2b
  'C', // XMM2c
  'C', // XMM2d
  'C', // XMM2e
  'C', // XMM2f
  'C', // XMM2g
  'C', // XMM2h
  'C', // XMM2i
  'C', // XMM2j
  'C', // XMM2k
  'C', // XMM2l
  'C', // XMM2m
  'C', // XMM2n
  'C', // XMM2o
  'C', // XMM2p
  'C', // XMM3
  'C', // XMM3b
  'C', // XMM3c
  'C', // XMM3d
  'C', // XMM3e
  'C', // XMM3f
  'C', // XMM3g
  'C', // XMM3h
  'C', // XMM3i
  'C', // XMM3j
  'C', // XMM3k
  'C', // XMM3l
  'C', // XMM3m
  'C', // XMM3n
  'C', // XMM3o
  'C', // XMM3p
  'C', // XMM4
  'C', // XMM4b
  'C', // XMM4c
  'C', // XMM4d
  'C', // XMM4e
  'C', // XMM4f
  'C', // XMM4g
  'C', // XMM4h
  'C', // XMM4i
  'C', // XMM4j
  'C', // XMM4k
  'C', // XMM4l
  'C', // XMM4m
  'C', // XMM4n
  'C', // XMM4o
  'C', // XMM4p
  'C', // XMM5
  'C', // XMM5b
  'C', // XMM5c
  'C', // XMM5d
  'C', // XMM5e
  'C', // XMM5f
  'C', // XMM5g
  'C', // XMM5h
  'C', // XMM5i
  'C', // XMM5j
  'C', // XMM5k
  'C', // XMM5l
  'C', // XMM5m
  'C', // XMM5n
  'C', // XMM5o
  'C', // XMM5p
  'C', // XMM6
  'C', // XMM6b
  'C', // XMM6c
  'C', // XMM6d
  'C', // XMM6e
  'C', // XMM6f
  'C', // XMM6g
  'C', // XMM6h
  'C', // XMM6i
  'C', // XMM6j
  'C', // XMM6k
  'C', // XMM6l
  'C', // XMM6m
  'C', // XMM6n
  'C', // XMM6o
  'C', // XMM6p
  'C', // XMM7
  'C', // XMM7b
  'C', // XMM7c
  'C', // XMM7d
  'C', // XMM7e
  'C', // XMM7f
  'C', // XMM7g
  'C', // XMM7h
  'C', // XMM7i
  'C', // XMM7j
  'C', // XMM7k
  'C', // XMM7l
  'C', // XMM7m
  'C', // XMM7n
  'C', // XMM7o
  'C', // XMM7p
  'C', // XMM8
  'C', // XMM8b
  'C', // XMM8c
  'C', // XMM8d
  'C', // XMM8e
  'C', // XMM8f
  'C', // XMM8g
  'C', // XMM8h
  'C', // XMM8i
  'C', // XMM8j
  'C', // XMM8k
  'C', // XMM8l
  'C', // XMM8m
  'C', // XMM8n
  'C', // XMM8o
  'C', // XMM8p
  'C', // XMM9
  'C', // XMM9b
  'C', // XMM9c
  'C', // XMM9d
  'C', // XMM9e
  'C', // XMM9f
  'C', // XMM9g
  'C', // XMM9h
  'C', // XMM9i
  'C', // XMM9j
  'C', // XMM9k
  'C', // XMM9l
  'C', // XMM9m
  'C', // XMM9n
  'C', // XMM9o
  'C', // XMM9p
  'C', // XMM10
  'C', // XMM10b
  'C', // XMM10c
  'C', // XMM10d
  'C', // XMM10e
  'C', // XMM10f
  'C', // XMM10g
  'C', // XMM10h
  'C', // XMM10i
  'C', // XMM10j
  'C', // XMM10k
  'C', // XMM10l
  'C', // XMM10m
  'C', // XMM10n
  'C', // XMM10o
  'C', // XMM10p
  'C', // XMM11
  'C', // XMM11b
  'C', // XMM11c
  'C', // XMM11d
  'C', // XMM11e
  'C', // XMM11f
  'C', // XMM11g
  'C', // XMM11h
  'C', // XMM11i
  'C', // XMM11j
  'C', // XMM11k
  'C', // XMM11l
  'C', // XMM11m
  'C', // XMM11n
  'C', // XMM11o
  'C', // XMM11p
  'C', // XMM12
  'C', // XMM12b
  'C', // XMM12c
  'C', // XMM12d
  'C', // XMM12e
  'C', // XMM12f
  'C', // XMM12g
  'C', // XMM12h
  'C', // XMM12i
  'C', // XMM12j
  'C', // XMM12k
  'C', // XMM12l
  'C', // XMM12m
  'C', // XMM12n
  'C', // XMM12o
  'C', // XMM12p
  'C', // XMM13
  'C', // XMM13b
  'C', // XMM13c
  'C', // XMM13d
  'C', // XMM13e
  'C', // XMM13f
  'C', // XMM13g
  'C', // XMM13h
  'C', // XMM13i
  'C', // XMM13j
  'C', // XMM13k
  'C', // XMM13l
  'C', // XMM13m
  'C', // XMM13n
  'C', // XMM13o
  'C', // XMM13p
  'C', // XMM14
  'C', // XMM14b
  'C', // XMM14c
  'C', // XMM14d
  'C', // XMM14e
  'C', // XMM14f
  'C', // XMM14g
  'C', // XMM14h
  'C', // XMM14i
  'C', // XMM14j
  'C', // XMM14k
  'C', // XMM14l
  'C', // XMM14m
  'C', // XMM14n
  'C', // XMM14o
  'C', // XMM14p
  'C', // XMM15
  'C', // XMM15b
  'C', // XMM15c
  'C', // XMM15d
  'C', // XMM15e
  'C', // XMM15f
  'C', // XMM15g
  'C', // XMM15h
  'C', // XMM15i
  'C', // XMM15j
  'C', // XMM15k
  'C', // XMM15l
  'C', // XMM15m
  'C', // XMM15n
  'C', // XMM15o
  'C', // XMM15p
  'C', // XMM16
  'C', // XMM16b
  'C', // XMM16c
  'C', // XMM16d
  'C', // XMM16e
  'C', // XMM16f
  'C', // XMM16g
  'C', // XMM16h
  'C', // XMM16i
  'C', // XMM16j
  'C', // XMM16k
  'C', // XMM16l
  'C', // XMM16m
  'C', // XMM16n
  'C', // XMM16o
  'C', // XMM16p
  'C', // XMM17
  'C', // XMM17b
  'C', // XMM17c
  'C', // XMM17d
  'C', // XMM17e
  'C', // XMM17f
  'C', // XMM17g
  'C', // XMM17h
  'C', // XMM17i
  'C', // XMM17j
  'C', // XMM17k
  'C', // XMM17l
  'C', // XMM17m
  'C', // XMM17n
  'C', // XMM17o
  'C', // XMM17p
  'C', // XMM18
  'C', // XMM18b
  'C', // XMM18c
  'C', // XMM18d
  'C', // XMM18e
  'C', // XMM18f
  'C', // XMM18g
  'C', // XMM18h
  'C', // XMM18i
  'C', // XMM18j
  'C', // XMM18k
  'C', // XMM18l
  'C', // XMM18m
  'C', // XMM18n
  'C', // XMM18o
  'C', // XMM18p
  'C', // XMM19
  'C', // XMM19b
  'C', // XMM19c
  'C', // XMM19d
  'C', // XMM19e
  'C', // XMM19f
  'C', // XMM19g
  'C', // XMM19h
  'C', // XMM19i
  'C', // XMM19j
  'C', // XMM19k
  'C', // XMM19l
  'C', // XMM19m
  'C', // XMM19n
  'C', // XMM19o
  'C', // XMM19p
  'C', // XMM20
  'C', // XMM20b
  'C', // XMM20c
  'C', // XMM20d
  'C', // XMM20e
  'C', // XMM20f
  'C', // XMM20g
  'C', // XMM20h
  'C', // XMM20i
  'C', // XMM20j
  'C', // XMM20k
  'C', // XMM20l
  'C', // XMM20m
  'C', // XMM20n
  'C', // XMM20o
  'C', // XMM20p
  'C', // XMM21
  'C', // XMM21b
  'C', // XMM21c
  'C', // XMM21d
  'C', // XMM21e
  'C', // XMM21f
  'C', // XMM21g
  'C', // XMM21h
  'C', // XMM21i
  'C', // XMM21j
  'C', // XMM21k
  'C', // XMM21l
  'C', // XMM21m
  'C', // XMM21n
  'C', // XMM21o
  'C', // XMM21p
  'C', // XMM22
  'C', // XMM22b
  'C', // XMM22c
  'C', // XMM22d
  'C', // XMM22e
  'C', // XMM22f
  'C', // XMM22g
  'C', // XMM22h
  'C', // XMM22i
  'C', // XMM22j
  'C', // XMM22k
  'C', // XMM22l
  'C', // XMM22m
  'C', // XMM22n
  'C', // XMM22o
  'C', // XMM22p
  'C', // XMM23
  'C', // XMM23b
  'C', // XMM23c
  'C', // XMM23d
  'C', // XMM23e
  'C', // XMM23f
  'C', // XMM23g
  'C', // XMM23h
  'C', // XMM23i
  'C', // XMM23j
  'C', // XMM23k
  'C', // XMM23l
  'C', // XMM23m
  'C', // XMM23n
  'C', // XMM23o
  'C', // XMM23p
  'C', // XMM24
  'C', // XMM24b
  'C', // XMM24c
  'C', // XMM24d
  'C', // XMM24e
  'C', // XMM24f
  'C', // XMM24g
  'C', // XMM24h
  'C', // XMM24i
  'C', // XMM24j
  'C', // XMM24k
  'C', // XMM24l
  'C', // XMM24m
  'C', // XMM24n
  'C', // XMM24o
  'C', // XMM24p
  'C', // XMM25
  'C', // XMM25b
  'C', // XMM25c
  'C', // XMM25d
  'C', // XMM25e
  'C', // XMM25f
  'C', // XMM25g
  'C', // XMM25h
  'C', // XMM25i
  'C', // XMM25j
  'C', // XMM25k
  'C', // XMM25l
  'C', // XMM25m
  'C', // XMM25n
  'C', // XMM25o
  'C', // XMM25p
  'C', // XMM26
  'C', // XMM26b
  'C', // XMM26c
  'C', // XMM26d
  'C', // XMM26e
  'C', // XMM26f
  'C', // XMM26g
  'C', // XMM26h
  'C', // XMM26i
  'C', // XMM26j
  'C', // XMM26k
  'C', // XMM26l
  'C', // XMM26m
  'C', // XMM26n
  'C', // XMM26o
  'C', // XMM26p
  'C', // XMM27
  'C', // XMM27b
  'C', // XMM27c
  'C', // XMM27d
  'C', // XMM27e
  'C', // XMM27f
  'C', // XMM27g
  'C', // XMM27h
  'C', // XMM27i
  'C', // XMM27j
  'C', // XMM27k
  'C', // XMM27l
  'C', // XMM27m
  'C', // XMM27n
  'C', // XMM27o
  'C', // XMM27p
  'C', // XMM28
  'C', // XMM28b
  'C', // XMM28c
  'C', // XMM28d
  'C', // XMM28e
  'C', // XMM28f
  'C', // XMM28g
  'C', // XMM28h
  'C', // XMM28i
  'C', // XMM28j
  'C', // XMM28k
  'C', // XMM28l
  'C', // XMM28m
  'C', // XMM28n
  'C', // XMM28o
  'C', // XMM28p
  'C', // XMM29
  'C', // XMM29b
  'C', // XMM29c
  'C', // XMM29d
  'C', // XMM29e
  'C', // XMM29f
  'C', // XMM29g
  'C', // XMM29h
  'C', // XMM29i
  'C', // XMM29j
  'C', // XMM29k
  'C', // XMM29l
  'C', // XMM29m
  'C', // XMM29n
  'C', // XMM29o
  'C', // XMM29p
  'C', // XMM30
  'C', // XMM30b
  'C', // XMM30c
  'C', // XMM30d
  'C', // XMM30e
  'C', // XMM30f
  'C', // XMM30g
  'C', // XMM30h
  'C', // XMM30i
  'C', // XMM30j
  'C', // XMM30k
  'C', // XMM30l
  'C', // XMM30m
  'C', // XMM30n
  'C', // XMM30o
  'C', // XMM30p
  'C', // XMM31
  'C', // XMM31b
  'C', // XMM31c
  'C', // XMM31d
  'C', // XMM31e
  'C', // XMM31f
  'C', // XMM31g
  'C', // XMM31h
  'C', // XMM31i
  'C', // XMM31j
  'C', // XMM31k
  'C', // XMM31l
  'C', // XMM31m
  'C', // XMM31n
  'C', // XMM31o
  'C', // XMM31p
  'C', // K7
  'C', // K7_H
  'C', // K6
  'C', // K6_H
  'C', // K5
  'C', // K5_H
  'C', // K4
  'C', // K4_H
  'C', // K3
  'C', // K3_H
  'C', // K2
  'C', // K2_H
  'C', // K1
  'C', // K1_H
  'C' // no trailing comma // RFLAGS
};

// Map from machine-independent register number to register_save_type
const        int register_save_type[] = {
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegF,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  Op_RegI,
  0 // no trailing comma
};


const        int   reduceOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  immI_rule,
  /*    9 */  immI_0_rule,
  /*   10 */  immI_1_rule,
  /*   11 */  immI_M1_rule,
  /*   12 */  immI_2_rule,
  /*   13 */  immI_4_rule,
  /*   14 */  immI_8_rule,
  /*   15 */  immI2_rule,
  /*   16 */  immU7_rule,
  /*   17 */  immI8_rule,
  /*   18 */  immU8_rule,
  /*   19 */  immI16_rule,
  /*   20 */  immU31_rule,
  /*   21 */  immP_rule,
  /*   22 */  immP0_rule,
  /*   23 */  immN_rule,
  /*   24 */  immNKlass_rule,
  /*   25 */  immN0_rule,
  /*   26 */  immP31_rule,
  /*   27 */  immL_rule,
  /*   28 */  immL8_rule,
  /*   29 */  immUL32_rule,
  /*   30 */  immL32_rule,
  /*   31 */  immL_Pow2_rule,
  /*   32 */  immL_NotPow2_rule,
  /*   33 */  immL0_rule,
  /*   34 */  immL1_rule,
  /*   35 */  immL_M1_rule,
  /*   36 */  immL_32bits_rule,
  /*   37 */  immI_Pow2M1_rule,
  /*   38 */  immF0_rule,
  /*   39 */  immF_rule,
  /*   40 */  immD0_rule,
  /*   41 */  immD_rule,
  /*   42 */  immI_16_rule,
  /*   43 */  immI_24_rule,
  /*   44 */  immI_255_rule,
  /*   45 */  immI_65535_rule,
  /*   46 */  immL_255_rule,
  /*   47 */  immL_65535_rule,
  /*   48 */  kReg_rule,
  /*   49 */  rRegI_rule,
  /*   50 */  rax_RegI_rule,
  /*   51 */  rbx_RegI_rule,
  /*   52 */  rcx_RegI_rule,
  /*   53 */  rdx_RegI_rule,
  /*   54 */  rdi_RegI_rule,
  /*   55 */  no_rax_rdx_RegI_rule,
  /*   56 */  no_rbp_r13_RegI_rule,
  /*   57 */  any_RegP_rule,
  /*   58 */  rRegP_rule,
  /*   59 */  rRegN_rule,
  /*   60 */  no_rbp_RegP_rule,
  /*   61 */  rax_RegP_rule,
  /*   62 */  rax_RegN_rule,
  /*   63 */  rbx_RegP_rule,
  /*   64 */  rsi_RegP_rule,
  /*   65 */  rbp_RegP_rule,
  /*   66 */  rdi_RegP_rule,
  /*   67 */  r15_RegP_rule,
  /*   68 */  rRegL_rule,
  /*   69 */  no_rax_rdx_RegL_rule,
  /*   70 */  rax_RegL_rule,
  /*   71 */  rcx_RegL_rule,
  /*   72 */  rdx_RegL_rule,
  /*   73 */  r11_RegL_rule,
  /*   74 */  no_rbp_r13_RegL_rule,
  /*   75 */  rFlagsReg_rule,
  /*   76 */  rFlagsRegU_rule,
  /*   77 */  rFlagsRegUCF_rule,
  /*   78 */  regF_rule,
  /*   79 */  legRegF_rule,
  /*   80 */  vlRegF_rule,
  /*   81 */  regD_rule,
  /*   82 */  legRegD_rule,
  /*   83 */  vlRegD_rule,
  /*   84 */  indirect_rule,
  /*   85 */  indOffset8_rule,
  /*   86 */  indOffset32_rule,
  /*   87 */  indIndexOffset_rule,
  /*   88 */  indIndex_rule,
  /*   89 */  indIndexScale_rule,
  /*   90 */  indPosIndexScale_rule,
  /*   91 */  indIndexScaleOffset_rule,
  /*   92 */  indPosIndexOffset_rule,
  /*   93 */  indPosIndexScaleOffset_rule,
  /*   94 */  indCompressedOopOffset_rule,
  /*   95 */  indirectNarrow_rule,
  /*   96 */  indOffset8Narrow_rule,
  /*   97 */  indOffset32Narrow_rule,
  /*   98 */  indIndexOffsetNarrow_rule,
  /*   99 */  indIndexNarrow_rule,
  /*  100 */  indIndexScaleNarrow_rule,
  /*  101 */  indIndexScaleOffsetNarrow_rule,
  /*  102 */  indPosIndexOffsetNarrow_rule,
  /*  103 */  indPosIndexScaleOffsetNarrow_rule,
  /*  104 */  stackSlotP_rule,
  /*  105 */  stackSlotI_rule,
  /*  106 */  stackSlotF_rule,
  /*  107 */  stackSlotD_rule,
  /*  108 */  stackSlotL_rule,
  /*  109 */  cmpOp_rule,
  /*  110 */  cmpOpU_rule,
  /*  111 */  cmpOpUCF_rule,
  /*  112 */  cmpOpUCF2_rule,
  /*  113 */  rxmm0_rule,
  /*  114 */  vec_rule,
  /*  115 */  legVec_rule,
  /*  116 */  vecS_rule,
  /*  117 */  legVecS_rule,
  /*  118 */  vecD_rule,
  /*  119 */  legVecD_rule,
  /*  120 */  vecX_rule,
  /*  121 */  legVecX_rule,
  /*  122 */  vecY_rule,
  /*  123 */  legVecY_rule,
  /*  124 */  vecZ_rule,
  /*  125 */  legVecZ_rule,
  /*  126 */  no_rax_RegP_rule,
  // last operand
  /*  127 */  memory_rule,
  // last operand class
  /*  128 */  _AddP_any_RegP_rRegL_rule,
  /*  129 */  _LShiftL_rRegL_immI2_rule,
  /*  130 */  _ConvI2L_rRegI__rule,
  /*  131 */  _LShiftL__ConvI2L_rRegI__immI2_rule,
  /*  132 */  _AddP_any_RegP__LShiftL_rRegL_immI2_rule,
  /*  133 */  _AddP_any_RegP__ConvI2L_rRegI__rule,
  /*  134 */  _AddP_any_RegP__LShiftL__ConvI2L_rRegI__immI2_rule,
  /*  135 */  _DecodeN_rRegN__rule,
  /*  136 */  _AddP__DecodeN_rRegN__rRegL_rule,
  /*  137 */  _AddP__DecodeN_rRegN___LShiftL_rRegL_immI2_rule,
  /*  138 */  _AddP__DecodeN_rRegN___ConvI2L_rRegI__rule,
  /*  139 */  _AddP__DecodeN_rRegN___LShiftL__ConvI2L_rRegI__immI2_rule,
  /*  140 */  _LoadB_memory__rule,
  /*  141 */  _LoadUB_memory__rule,
  /*  142 */  _AndI__LoadUB_memory__immI_rule,
  /*  143 */  _LoadS_memory__rule,
  /*  144 */  _LShiftI__LoadS_memory__immI_24_rule,
  /*  145 */  _LoadUS_memory__rule,
  /*  146 */  _LShiftI__LoadUS_memory__immI_24_rule,
  /*  147 */  _AndI__LoadUS_memory__immI_255_rule,
  /*  148 */  _AndI__LoadUS_memory__immI_rule,
  /*  149 */  _LoadI_memory__rule,
  /*  150 */  _LShiftI__LoadI_memory__immI_24_rule,
  /*  151 */  _LShiftI__LoadI_memory__immI_16_rule,
  /*  152 */  _AndI__LoadI_memory__immI_255_rule,
  /*  153 */  _AndI__LoadI_memory__immI_65535_rule,
  /*  154 */  _AndI__LoadI_memory__immU31_rule,
  /*  155 */  _ConvI2L__LoadI_memory___rule,
  /*  156 */  _LoadL_memory__rule,
  /*  157 */  _CastP2X_rRegP__rule,
  /*  158 */  _CastP2X__DecodeN_rRegN___rule,
  /*  159 */  _AddL__LShiftL_rRegL_immI2_immL32_rule,
  /*  160 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  161 */  _Binary_immI_1_rRegI_rule,
  /*  162 */  _Binary_rRegI_rRegI_rule,
  /*  163 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  164 */  _Binary_cmpOpUCF_rFlagsRegUCF_rule,
  /*  165 */  _Binary_cmpOpUCF2_rFlagsRegUCF_rule,
  /*  166 */  _Binary_rRegI__LoadI_memory__rule,
  /*  167 */  _Binary_rRegN_rRegN_rule,
  /*  168 */  _Binary_rRegP_rRegP_rule,
  /*  169 */  _Binary_immL1_rRegL_rule,
  /*  170 */  _Binary_rRegL_rRegL_rule,
  /*  171 */  _Binary_rRegL__LoadL_memory__rule,
  /*  172 */  _Binary_regF_regF_rule,
  /*  173 */  _Binary_regD_regD_rule,
  /*  174 */  _AddI__LoadI_memory__rRegI_rule,
  /*  175 */  _AddI_rRegI__LoadI_memory__rule,
  /*  176 */  _AddI__LoadI_memory__immI_rule,
  /*  177 */  _AddI__LoadI_memory__immI_1_rule,
  /*  178 */  _AddI__LoadI_memory__immI_M1_rule,
  /*  179 */  _LShiftI_rRegI_immI2_rule,
  /*  180 */  _AddI_rRegI_rRegI_rule,
  /*  181 */  _AddI_rRegI__LShiftI_rRegI_immI2_rule,
  /*  182 */  _AddI__LShiftI_rRegI_immI2_rRegI_rule,
  /*  183 */  _AddL__LoadL_memory__rRegL_rule,
  /*  184 */  _AddL_rRegL__LoadL_memory__rule,
  /*  185 */  _AddL__LoadL_memory__immL32_rule,
  /*  186 */  _AddL__LoadL_memory__immL1_rule,
  /*  187 */  _AddL__LoadL_memory__immL_M1_rule,
  /*  188 */  _AddL_rRegL_rRegL_rule,
  /*  189 */  _AddL_rRegL__LShiftL_rRegL_immI2_rule,
  /*  190 */  _AddL__LShiftL_rRegL_immI2_rRegL_rule,
  /*  191 */  _Binary_rax_RegP_rRegP_rule,
  /*  192 */  _Binary_rax_RegL_rRegL_rule,
  /*  193 */  _Binary_rax_RegI_rRegI_rule,
  /*  194 */  _Binary_rax_RegN_rRegN_rule,
  /*  195 */  _SubI__LoadI_memory__rRegI_rule,
  /*  196 */  _SubL__LoadL_memory__rRegL_rule,
  /*  197 */  _SubI_immI_0_rRegI_rule,
  /*  198 */  _SubI_immI_0__LoadI_memory__rule,
  /*  199 */  _SubL_immL0__LoadL_memory__rule,
  /*  200 */  _LShiftI__LoadI_memory__immI8_rule,
  /*  201 */  _LShiftI__LoadI_memory__rcx_RegI_rule,
  /*  202 */  _RShiftI__LoadI_memory__immI8_rule,
  /*  203 */  _RShiftI__LoadI_memory__rcx_RegI_rule,
  /*  204 */  _URShiftI__LoadI_memory__immI8_rule,
  /*  205 */  _URShiftI__LoadI_memory__rcx_RegI_rule,
  /*  206 */  _LShiftL__LoadL_memory__immI8_rule,
  /*  207 */  _LShiftL__LoadL_memory__rcx_RegI_rule,
  /*  208 */  _RShiftL__LoadL_memory__immI_rule,
  /*  209 */  _RShiftL__LoadL_memory__rcx_RegI_rule,
  /*  210 */  _URShiftL__LoadL_memory__immI8_rule,
  /*  211 */  _URShiftL__LoadL_memory__rcx_RegI_rule,
  /*  212 */  _LShiftI_rRegI_immI_24_rule,
  /*  213 */  _LShiftI_rRegI_immI_16_rule,
  /*  214 */  _AndI_rRegI_immI_255_rule,
  /*  215 */  _AndI_rRegI_immI_65535_rule,
  /*  216 */  _AndI_rRegI_immI_Pow2M1_rule,
  /*  217 */  _AndI__LoadB_memory__rRegI_rule,
  /*  218 */  _AndI_rRegI__LoadB_memory__rule,
  /*  219 */  _AndI__LoadI_memory__rRegI_rule,
  /*  220 */  _AndI_rRegI__LoadI_memory__rule,
  /*  221 */  _AndI__LoadI_memory__immI_rule,
  /*  222 */  _XorI_rRegI_immI_M1_rule,
  /*  223 */  _AddI_rRegI_immI_M1_rule,
  /*  224 */  _OrI__LoadB_memory__rRegI_rule,
  /*  225 */  _OrI_rRegI__LoadB_memory__rule,
  /*  226 */  _OrI__LoadI_memory__rRegI_rule,
  /*  227 */  _OrI_rRegI__LoadI_memory__rule,
  /*  228 */  _OrI__LoadI_memory__immI_rule,
  /*  229 */  _XorI__LoadB_memory__rRegI_rule,
  /*  230 */  _XorI_rRegI__LoadB_memory__rule,
  /*  231 */  _XorI__LoadI_memory__rRegI_rule,
  /*  232 */  _XorI_rRegI__LoadI_memory__rule,
  /*  233 */  _XorI__LoadI_memory__immI_rule,
  /*  234 */  _AndL__LoadL_memory__rRegL_rule,
  /*  235 */  _AndL_rRegL__LoadL_memory__rule,
  /*  236 */  _AndL__LoadL_memory__immL32_rule,
  /*  237 */  _AndL__LoadL_memory__immL_NotPow2_rule,
  /*  238 */  _XorL_rRegL_immL_M1_rule,
  /*  239 */  _SubL_immL0_rRegL_rule,
  /*  240 */  _AddL_rRegL_immL_M1_rule,
  /*  241 */  _CastP2X_any_RegP__rule,
  /*  242 */  _OrL__LoadL_memory__rRegL_rule,
  /*  243 */  _OrL_rRegL__LoadL_memory__rule,
  /*  244 */  _OrL__LoadL_memory__immL32_rule,
  /*  245 */  _OrL__LoadL_memory__immL_Pow2_rule,
  /*  246 */  _XorL__LoadL_memory__rRegL_rule,
  /*  247 */  _XorL_rRegL__LoadL_memory__rule,
  /*  248 */  _XorL__LoadL_memory__immL32_rule,
  /*  249 */  _CmpLTMask_rRegI_rRegI_rule,
  /*  250 */  _AndI__CmpLTMask_rRegI_rRegI_rRegI_rule,
  /*  251 */  _SubI_rRegI_rRegI_rule,
  /*  252 */  _AndI_rRegI__CmpLTMask_rRegI_rRegI_rule,
  /*  253 */  _LoadF_memory__rule,
  /*  254 */  _LoadD_memory__rule,
  /*  255 */  _Binary_rdi_RegP_rcx_RegI_rule,
  /*  256 */  _Binary_rsi_RegP_rdx_RegI_rule,
  /*  257 */  _Binary_rdi_RegP_rdx_RegI_rule,
  /*  258 */  _Binary_rsi_RegP_immI_rule,
  /*  259 */  _Binary_rsi_RegP_rax_RegI_rule,
  /*  260 */  _Binary_rdi_RegP_rsi_RegP_rule,
  /*  261 */  _Binary_rbx_RegI_immU8_rule,
  /*  262 */  _AndI_rRegI_immI_rule,
  /*  263 */  _AndI_rRegI_rRegI_rule,
  /*  264 */  _LoadP_memory__rule,
  /*  265 */  _LoadN_memory__rule,
  /*  266 */  _LoadNKlass_memory__rule,
  /*  267 */  _AndL_rRegL_immL32_rule,
  /*  268 */  _AndL_rRegL_rRegL_rule,
  /*  269 */  _AndL__CastP2X_rRegP___LoadL_memory__rule,
  /*  270 */  _AndL__LoadL_memory___CastP2X_rRegP__rule,
  /*  271 */  _AndI__LoadUB_memory__immU7_rule,
  /*  272 */  _AndI__LoadB_memory__immI8_rule,
  /*  273 */  _Binary_rax_RegP_immP_rule,
  /*  274 */  _ConvF2HF_regF__rule,
  /*  275 */  _VectorCastF2HF_vec__rule,
  /*  276 */  _LoadVector_memory__rule,
  /*  277 */  _Binary_vec_kReg_rule,
  /*  278 */  _Binary_rRegP_immI_0_rule,
  /*  279 */  _Binary_rRegP_rRegI_rule,
  /*  280 */  _Binary_kReg_immI_0_rule,
  /*  281 */  _Binary_rRegP__Binary_kReg_immI_0_rule,
  /*  282 */  _Binary_kReg_rRegI_rule,
  /*  283 */  _Binary_rRegP__Binary_kReg_rRegI_rule,
  /*  284 */  _Binary_vec_immI_0_rule,
  /*  285 */  _Binary_rRegP__Binary_vec_immI_0_rule,
  /*  286 */  _Binary_vec_rRegI_rule,
  /*  287 */  _Binary_rRegP__Binary_vec_rRegI_rule,
  /*  288 */  _Binary_vec_vec_rule,
  /*  289 */  _Binary_vec__Binary_vec_kReg_rule,
  /*  290 */  _Binary_vec_rRegL_rule,
  /*  291 */  _Binary_vec_regF_rule,
  /*  292 */  _Binary_vec_regD_rule,
  /*  293 */  _Binary_vec__LoadVector_memory__rule,
  /*  294 */  _Binary_regD_immD_rule,
  /*  295 */  _LShiftCntV_immI8__rule,
  /*  296 */  _RShiftCntV_immI8__rule,
  /*  297 */  _Binary_legVec_legVec_rule,
  /*  298 */  _MulAddVS2VI_vec_vec_rule,
  /*  299 */  _Binary_vec_immU8_rule,
  /*  300 */  _Binary__LoadVector_memory__immU8_rule,
  /*  301 */  _VectorStoreMask_vec_immI_rule,
  /*  302 */  _Binary_vec_immI8_rule,
  /*  303 */  _Binary_vec__LShiftCntV_immI8__rule,
  /*  304 */  _Binary_vec__RShiftCntV_immI8__rule,
  /*  305 */  _Binary__LoadVector_memory__kReg_rule,
  /*  306 */  _Binary_immI8_kReg_rule,
  /*  307 */  _MaskAll_immI_M1__rule,
  /*  308 */  _Binary_immU8_kReg_rule,
  /*  309 */  _Binary_vec__Binary_immU8_kReg_rule,
  /*  310 */  _Binary_vec__Binary_vec__Binary_immU8_kReg_rule,
  /*  311 */  _Binary_memory__Binary_immU8_kReg_rule,
  /*  312 */  _Binary_vec__Binary_memory__Binary_immU8_kReg_rule,
  /*  313 */  _Binary_rax_RegP_no_rax_RegP_rule,
  /*  314 */  _EncodeP_any_RegP__rule,
  // last internally defined operand
  /*  315 */  stackSlotI_rule,
  /*  316 */  stackSlotL_rule,
  /*  317 */  stackSlotP_rule,
  /*  318 */  stackSlotF_rule,
  /*  319 */  stackSlotD_rule,
  /*  320 */  vlRegF_rule,
  /*  321 */  legRegF_rule,
  /*  322 */  regF_rule,
  /*  323 */  regF_rule,
  /*  324 */  vlRegD_rule,
  /*  325 */  legRegD_rule,
  /*  326 */  regD_rule,
  /*  327 */  regD_rule,
  /*  328 */  rRegP_rule,
  /*  329 */  rRegP_rule,
  /*  330 */  rRegP_rule,
  /*  331 */  rRegP_rule,
  /*  332 */  rRegP_rule,
  /*  333 */  rRegP_rule,
  /*  334 */  rRegP_rule,
  /*  335 */  rRegP_rule,
  /*  336 */  rRegP_rule,
  /*  337 */  rRegP_rule,
  /*  338 */  rRegP_rule,
  /*  339 */  rRegP_rule,
  /*  340 */  rRegP_rule,
  /*  341 */  rRegP_rule,
  /*  342 */  rRegP_rule,
  /*  343 */  rRegP_rule,
  /*  344 */  rRegI_rule,
  /*  345 */  rRegI_rule,
  /*  346 */  rRegL_rule,
  /*  347 */  rRegL_rule,
  /*  348 */  rRegL_rule,
  /*  349 */  rRegL_rule,
  /*  350 */  rRegP_rule,
  /*  351 */  rRegP_rule,
  /*  352 */  rRegP_rule,
  /*  353 */  regF_rule,
  /*  354 */  rRegN_rule,
  /*  355 */  rRegN_rule,
  /*  356 */  rRegN_rule,
  /*  357 */  regF_rule,
  /*  358 */  regD_rule,
  /*  359 */  regD_rule,
  /*  360 */  rRegI_rule,
  /*  361 */  rRegL_rule,
  /*  362 */  rRegP_rule,
  /*  363 */  regF_rule,
  /*  364 */  regD_rule,
  /*  365 */  legVec_rule,
  /*  366 */  vec_rule,
  /*  367 */  Universe_rule,
  /*  368 */  rRegP_rule,
  /*  369 */  rRegL_rule,
  /*  370 */  rRegP_rule,
  /*  371 */  rRegP_rule,
  /*  372 */  rRegI_rule,
  /*  373 */  rRegL_rule,
  /*  374 */  regF_rule,
  /*  375 */  regD_rule,
  /*  376 */  rFlagsRegU_rule,
  /*  377 */  rFlagsRegUCF_rule,
  /*  378 */  rFlagsRegUCF_rule,
  /*  379 */  rFlagsRegUCF_rule,
  /*  380 */  rFlagsRegU_rule,
  /*  381 */  rFlagsRegUCF_rule,
  /*  382 */  rFlagsRegUCF_rule,
  /*  383 */  rFlagsRegUCF_rule,
  /*  384 */  rRegI_rule,
  /*  385 */  regF_rule,
  /*  386 */  rRegL_rule,
  /*  387 */  regD_rule,
  /*  388 */  regD_rule,
  /*  389 */  rRegI_rule,
  /*  390 */  rRegL_rule,
  /*  391 */  regF_rule,
  /*  392 */  regD_rule,
  /*  393 */  rFlagsReg_rule,
  /*  394 */  rFlagsReg_rule,
  /*  395 */  rFlagsReg_rule,
  /*  396 */  rFlagsReg_rule,
  /*  397 */  rFlagsReg_rule,
  /*  398 */  rFlagsReg_rule,
  /*  399 */  rFlagsReg_rule,
  /*  400 */  rFlagsReg_rule,
  /*  401 */  rFlagsReg_rule,
  /*  402 */  rFlagsReg_rule,
  /*  403 */  rFlagsReg_rule,
  /*  404 */  rFlagsReg_rule,
  /*  405 */  rFlagsReg_rule,
  /*  406 */  rFlagsReg_rule,
  /*  407 */  rFlagsReg_rule,
  /*  408 */  rFlagsReg_rule,
  /*  409 */  rFlagsReg_rule,
  /*  410 */  rFlagsReg_rule,
  /*  411 */  rFlagsReg_rule,
  /*  412 */  rFlagsReg_rule,
  /*  413 */  rFlagsReg_rule,
  /*  414 */  rFlagsReg_rule,
  /*  415 */  rFlagsRegU_rule,
  /*  416 */  rFlagsRegU_rule,
  /*  417 */  rFlagsRegU_rule,
  /*  418 */  rFlagsRegU_rule,
  /*  419 */  rFlagsRegU_rule,
  /*  420 */  rFlagsRegU_rule,
  /*  421 */  rFlagsRegU_rule,
  /*  422 */  rFlagsReg_rule,
  /*  423 */  rFlagsReg_rule,
  /*  424 */  rFlagsReg_rule,
  /*  425 */  rFlagsRegU_rule,
  /*  426 */  rFlagsRegU_rule,
  /*  427 */  rFlagsRegU_rule,
  /*  428 */  rFlagsRegU_rule,
  /*  429 */  rFlagsRegU_rule,
  /*  430 */  rFlagsRegU_rule,
  /*  431 */  rFlagsReg_rule,
  /*  432 */  rFlagsReg_rule,
  /*  433 */  rFlagsReg_rule,
  /*  434 */  rFlagsReg_rule,
  /*  435 */  rFlagsReg_rule,
  /*  436 */  rFlagsReg_rule,
  /*  437 */  rFlagsReg_rule,
  /*  438 */  rFlagsReg_rule,
  /*  439 */  rFlagsReg_rule,
  /*  440 */  rFlagsReg_rule,
  /*  441 */  rFlagsReg_rule,
  /*  442 */  rFlagsReg_rule,
  /*  443 */  rFlagsReg_rule,
  /*  444 */  rFlagsRegU_rule,
  /*  445 */  rFlagsRegU_rule,
  /*  446 */  rFlagsRegU_rule,
  /*  447 */  rFlagsRegU_rule,
  /*  448 */  rFlagsReg_rule,
  /*  449 */  rFlagsReg_rule,
  /*  450 */  rFlagsReg_rule,
  /*  451 */  rFlagsReg_rule,
  /*  452 */  rFlagsReg_rule,
  /*  453 */  rFlagsReg_rule,
  /*  454 */  rFlagsReg_rule,
  /*  455 */  r15_RegP_rule,
  /*  456 */  regF_rule,
  /*  457 */  vlRegF_rule,
  /*  458 */  regD_rule,
  /*  459 */  vlRegD_rule,
  /*  460 */  regF_rule,
  /*  461 */  vlRegF_rule,
  /*  462 */  regD_rule,
  /*  463 */  vlRegD_rule,
  /*  464 */  vec_rule,
  /*  465 */  vlRegF_rule,
  /*  466 */  vec_rule,
  /*  467 */  vec_rule,
  /*  468 */  kReg_rule,
  /*  469 */  vec_rule,
  /*  470 */  legVec_rule,
  /*  471 */  legVec_rule,
  /*  472 */  vec_rule,
  /*  473 */  vec_rule,
  /*  474 */  vec_rule,
  /*  475 */  vec_rule,
  /*  476 */  vec_rule,
  /*  477 */  vec_rule,
  /*  478 */  vec_rule,
  /*  479 */  vec_rule,
  /*  480 */  vec_rule,
  /*  481 */  vec_rule,
  /*  482 */  vec_rule,
  /*  483 */  vec_rule,
  /*  484 */  vec_rule,
  /*  485 */  vec_rule,
  /*  486 */  vec_rule,
  /*  487 */  vec_rule,
  /*  488 */  vec_rule,
  /*  489 */  vec_rule,
  /*  490 */  vec_rule,
  /*  491 */  vec_rule,
  /*  492 */  vec_rule,
  /*  493 */  vec_rule,
  /*  494 */  vec_rule,
  /*  495 */  vec_rule,
  /*  496 */  vec_rule,
  /*  497 */  vec_rule,
  /*  498 */  vec_rule,
  /*  499 */  vec_rule,
  /*  500 */  vec_rule,
  /*  501 */  vec_rule,
  /*  502 */  vec_rule,
  /*  503 */  vec_rule,
  /*  504 */  legVec_rule,
  /*  505 */  vec_rule,
  /*  506 */  vec_rule,
  /*  507 */  vec_rule,
  /*  508 */  vec_rule,
  /*  509 */  vec_rule,
  /*  510 */  vec_rule,
  /*  511 */  vec_rule,
  /*  512 */  vec_rule,
  /*  513 */  vec_rule,
  /*  514 */  vec_rule,
  /*  515 */  vec_rule,
  /*  516 */  vec_rule,
  /*  517 */  vec_rule,
  /*  518 */  vec_rule,
  /*  519 */  vec_rule,
  /*  520 */  vec_rule,
  /*  521 */  vec_rule,
  /*  522 */  vec_rule,
  /*  523 */  vec_rule,
  /*  524 */  vec_rule,
  /*  525 */  vec_rule,
  /*  526 */  rFlagsRegU_rule,
  /*  527 */  rFlagsRegU_rule,
  /*  528 */  rFlagsRegU_rule,
  /*  529 */  rFlagsRegU_rule,
  /*  530 */  rFlagsRegU_rule,
  /*  531 */  kReg_rule,
  /*  532 */  vec_rule,
  /*  533 */  vec_rule,
  /*  534 */  vec_rule,
  /*  535 */  vec_rule,
  /*  536 */  vec_rule,
  /*  537 */  vec_rule,
  /*  538 */  vec_rule,
  /*  539 */  vec_rule,
  /*  540 */  vec_rule,
  /*  541 */  vec_rule,
  /*  542 */  kReg_rule,
  /*  543 */  kReg_rule,
  /*  544 */  vec_rule,
  /*  545 */  legVec_rule,
  /*  546 */  rFlagsReg_rule,
  /*  547 */  rRegI_rule,
  /*  548 */  rRegL_rule,
  /*  549 */  rRegI_rule,
  /*  550 */  rRegL_rule,
  /*  551 */  rRegL_rule,
  /*  552 */  rRegI_rule,
  /*  553 */  rRegI_rule,
  /*  554 */  rRegL_rule,
  /*  555 */  rRegI_rule,
  /*  556 */  rRegI_rule,
  /*  557 */  rRegL_rule,
  /*  558 */  rRegL_rule,
  /*  559 */  rRegL_rule,
  /*  560 */  rRegI_rule,
  /*  561 */  rRegI_rule,
  /*  562 */  rRegI_rule,
  /*  563 */  rRegI_rule,
  /*  564 */  rRegI_rule,
  /*  565 */  rRegL_rule,
  /*  566 */  rRegL_rule,
  /*  567 */  rRegL_rule,
  /*  568 */  rRegL_rule,
  /*  569 */  rRegL_rule,
  /*  570 */  rRegL_rule,
  /*  571 */  rRegI_rule,
  /*  572 */  rRegP_rule,
  /*  573 */  rRegN_rule,
  /*  574 */  rRegP_rule,
  /*  575 */  rRegN_rule,
  /*  576 */  rRegN_rule,
  /*  577 */  regF_rule,
  /*  578 */  regD_rule,
  /*  579 */  regD_rule,
  /*  580 */  legRegF_rule,
  /*  581 */  legRegF_rule,
  /*  582 */  legRegD_rule,
  /*  583 */  legRegD_rule,
  /*  584 */  legRegF_rule,
  /*  585 */  legRegF_rule,
  /*  586 */  legRegD_rule,
  /*  587 */  legRegD_rule,
  /*  588 */  Universe_rule,
  /*  589 */  Universe_rule,
  /*  590 */  Universe_rule,
  /*  591 */  Universe_rule,
  /*  592 */  Universe_rule,
  /*  593 */  Universe_rule,
  /*  594 */  Universe_rule,
  /*  595 */  Universe_rule,
  /*  596 */  Universe_rule,
  /*  597 */  Universe_rule,
  /*  598 */  Universe_rule,
  /*  599 */  Universe_rule,
  /*  600 */  Universe_rule,
  /*  601 */  Universe_rule,
  /*  602 */  Universe_rule,
  /*  603 */  Universe_rule,
  /*  604 */  Universe_rule,
  /*  605 */  Universe_rule,
  /*  606 */  Universe_rule,
  /*  607 */  Universe_rule,
  /*  608 */  Universe_rule,
  /*  609 */  Universe_rule,
  /*  610 */  Universe_rule,
  /*  611 */  Universe_rule,
  /*  612 */  Universe_rule,
  /*  613 */  Universe_rule,
  /*  614 */  Universe_rule,
  /*  615 */  Universe_rule,
  /*  616 */  Universe_rule,
  /*  617 */  Universe_rule,
  /*  618 */  Universe_rule,
  /*  619 */  Universe_rule,
  /*  620 */  Universe_rule,
  /*  621 */  rRegI_rule,
  /*  622 */  rRegL_rule,
  /*  623 */  rRegI_rule,
  /*  624 */  rRegI_rule,
  /*  625 */  rRegI_rule,
  /*  626 */  rRegI_rule,
  /*  627 */  rRegI_rule,
  /*  628 */  rRegI_rule,
  /*  629 */  rRegI_rule,
  /*  630 */  rRegI_rule,
  /*  631 */  rRegI_rule,
  /*  632 */  rRegI_rule,
  /*  633 */  rRegI_rule,
  /*  634 */  rRegI_rule,
  /*  635 */  rRegI_rule,
  /*  636 */  rRegI_rule,
  /*  637 */  rRegI_rule,
  /*  638 */  rRegI_rule,
  /*  639 */  rRegL_rule,
  /*  640 */  rRegL_rule,
  /*  641 */  rRegI_rule,
  /*  642 */  rRegI_rule,
  /*  643 */  rRegI_rule,
  /*  644 */  rRegI_rule,
  /*  645 */  Universe_rule,
  /*  646 */  Universe_rule,
  /*  647 */  Universe_rule,
  /*  648 */  Universe_rule,
  /*  649 */  Universe_rule,
  /*  650 */  Universe_rule,
  /*  651 */  Universe_rule,
  /*  652 */  Universe_rule,
  /*  653 */  Universe_rule,
  /*  654 */  rRegI_rule,
  /*  655 */  rRegI_rule,
  /*  656 */  rRegN_rule,
  /*  657 */  rRegN_rule,
  /*  658 */  rRegP_rule,
  /*  659 */  rRegP_rule,
  /*  660 */  rRegN_rule,
  /*  661 */  rRegP_rule,
  /*  662 */  Universe_rule,
  /*  663 */  Universe_rule,
  /*  664 */  Universe_rule,
  /*  665 */  rRegI_rule,
  /*  666 */  rRegI_rule,
  /*  667 */  rRegI_rule,
  /*  668 */  rRegI_rule,
  /*  669 */  rRegI_rule,
  /*  670 */  rRegI_rule,
  /*  671 */  rRegI_rule,
  /*  672 */  rRegI_rule,
  /*  673 */  rRegI_rule,
  /*  674 */  rRegI_rule,
  /*  675 */  rRegI_rule,
  /*  676 */  rRegN_rule,
  /*  677 */  rRegN_rule,
  /*  678 */  rRegN_rule,
  /*  679 */  rRegN_rule,
  /*  680 */  rRegN_rule,
  /*  681 */  rRegP_rule,
  /*  682 */  rRegP_rule,
  /*  683 */  rRegP_rule,
  /*  684 */  rRegP_rule,
  /*  685 */  rRegP_rule,
  /*  686 */  rRegL_rule,
  /*  687 */  rRegL_rule,
  /*  688 */  rRegL_rule,
  /*  689 */  rRegL_rule,
  /*  690 */  rRegL_rule,
  /*  691 */  rRegL_rule,
  /*  692 */  rRegL_rule,
  /*  693 */  rRegL_rule,
  /*  694 */  rRegL_rule,
  /*  695 */  rRegL_rule,
  /*  696 */  rRegL_rule,
  /*  697 */  regF_rule,
  /*  698 */  regF_rule,
  /*  699 */  regF_rule,
  /*  700 */  regD_rule,
  /*  701 */  regD_rule,
  /*  702 */  regD_rule,
  /*  703 */  rRegI_rule,
  /*  704 */  rRegI_rule,
  /*  705 */  rRegI_rule,
  /*  706 */  rRegI_rule,
  /*  707 */  Universe_rule,
  /*  708 */  Universe_rule,
  /*  709 */  Universe_rule,
  /*  710 */  rRegI_rule,
  /*  711 */  Universe_rule,
  /*  712 */  rRegI_rule,
  /*  713 */  Universe_rule,
  /*  714 */  rRegI_rule,
  /*  715 */  rRegI_rule,
  /*  716 */  rRegI_rule,
  /*  717 */  rRegI_rule,
  /*  718 */  rRegI_rule,
  /*  719 */  rRegI_rule,
  /*  720 */  rRegL_rule,
  /*  721 */  rRegL_rule,
  /*  722 */  rRegL_rule,
  /*  723 */  rRegL_rule,
  /*  724 */  Universe_rule,
  /*  725 */  Universe_rule,
  /*  726 */  Universe_rule,
  /*  727 */  rRegI_rule,
  /*  728 */  Universe_rule,
  /*  729 */  rRegL_rule,
  /*  730 */  Universe_rule,
  /*  731 */  rRegL_rule,
  /*  732 */  rRegL_rule,
  /*  733 */  rRegL_rule,
  /*  734 */  rRegL_rule,
  /*  735 */  rRegL_rule,
  /*  736 */  rRegL_rule,
  /*  737 */  rRegP_rule,
  /*  738 */  rRegP_rule,
  /*  739 */  rRegI_rule,
  /*  740 */  rRegI_rule,
  /*  741 */  rRegI_rule,
  /*  742 */  rRegI_rule,
  /*  743 */  rRegI_rule,
  /*  744 */  rRegI_rule,
  /*  745 */  rRegI_rule,
  /*  746 */  rRegI_rule,
  /*  747 */  rRegI_rule,
  /*  748 */  rRegI_rule,
  /*  749 */  rRegI_rule,
  /*  750 */  rRegI_rule,
  /*  751 */  rax_RegI_rule,
  /*  752 */  rax_RegI_rule,
  /*  753 */  rax_RegI_rule,
  /*  754 */  rax_RegL_rule,
  /*  755 */  rax_RegN_rule,
  /*  756 */  rax_RegP_rule,
  /*  757 */  Universe_rule,
  /*  758 */  Universe_rule,
  /*  759 */  rRegI_rule,
  /*  760 */  Universe_rule,
  /*  761 */  Universe_rule,
  /*  762 */  rRegI_rule,
  /*  763 */  Universe_rule,
  /*  764 */  Universe_rule,
  /*  765 */  rRegI_rule,
  /*  766 */  Universe_rule,
  /*  767 */  Universe_rule,
  /*  768 */  rRegL_rule,
  /*  769 */  rRegI_rule,
  /*  770 */  rRegI_rule,
  /*  771 */  rRegI_rule,
  /*  772 */  rRegL_rule,
  /*  773 */  rRegP_rule,
  /*  774 */  rRegN_rule,
  /*  775 */  rRegI_rule,
  /*  776 */  rRegL_rule,
  /*  777 */  rRegI_rule,
  /*  778 */  rRegI_rule,
  /*  779 */  Universe_rule,
  /*  780 */  rRegL_rule,
  /*  781 */  rRegL_rule,
  /*  782 */  Universe_rule,
  /*  783 */  rRegP_rule,
  /*  784 */  rRegI_rule,
  /*  785 */  rRegI_rule,
  /*  786 */  Universe_rule,
  /*  787 */  rRegL_rule,
  /*  788 */  rRegL_rule,
  /*  789 */  Universe_rule,
  /*  790 */  rRegI_rule,
  /*  791 */  rRegI_rule,
  /*  792 */  rRegI_rule,
  /*  793 */  rRegI_rule,
  /*  794 */  rRegI_rule,
  /*  795 */  rRegI_rule,
  /*  796 */  rRegL_rule,
  /*  797 */  rRegL_rule,
  /*  798 */  rRegL_rule,
  /*  799 */  rRegL_rule,
  /*  800 */  rRegL_rule,
  /*  801 */  rdx_RegL_rule,
  /*  802 */  rdx_RegL_rule,
  /*  803 */  rax_RegI_rule,
  /*  804 */  rax_RegL_rule,
  /*  805 */  rax_RegI_rule,
  /*  806 */  rax_RegL_rule,
  /*  807 */  Universe_rule,
  /*  808 */  Universe_rule,
  /*  809 */  Universe_rule,
  /*  810 */  Universe_rule,
  /*  811 */  rdx_RegI_rule,
  /*  812 */  rdx_RegL_rule,
  /*  813 */  rdx_RegI_rule,
  /*  814 */  rdx_RegL_rule,
  /*  815 */  rRegI_rule,
  /*  816 */  rRegI_rule,
  /*  817 */  Universe_rule,
  /*  818 */  rRegI_rule,
  /*  819 */  Universe_rule,
  /*  820 */  rRegI_rule,
  /*  821 */  rRegI_rule,
  /*  822 */  rRegI_rule,
  /*  823 */  Universe_rule,
  /*  824 */  rRegI_rule,
  /*  825 */  Universe_rule,
  /*  826 */  rRegI_rule,
  /*  827 */  rRegI_rule,
  /*  828 */  rRegI_rule,
  /*  829 */  Universe_rule,
  /*  830 */  rRegI_rule,
  /*  831 */  Universe_rule,
  /*  832 */  rRegI_rule,
  /*  833 */  rRegI_rule,
  /*  834 */  rRegL_rule,
  /*  835 */  rRegL_rule,
  /*  836 */  Universe_rule,
  /*  837 */  rRegL_rule,
  /*  838 */  Universe_rule,
  /*  839 */  rRegL_rule,
  /*  840 */  rRegL_rule,
  /*  841 */  rRegL_rule,
  /*  842 */  Universe_rule,
  /*  843 */  rRegL_rule,
  /*  844 */  Universe_rule,
  /*  845 */  rRegL_rule,
  /*  846 */  rRegL_rule,
  /*  847 */  rRegL_rule,
  /*  848 */  Universe_rule,
  /*  849 */  rRegL_rule,
  /*  850 */  Universe_rule,
  /*  851 */  rRegL_rule,
  /*  852 */  rRegL_rule,
  /*  853 */  rRegI_rule,
  /*  854 */  rRegI_rule,
  /*  855 */  rRegI_rule,
  /*  856 */  rRegI_rule,
  /*  857 */  rRegI_rule,
  /*  858 */  rRegI_rule,
  /*  859 */  rRegI_rule,
  /*  860 */  rRegI_rule,
  /*  861 */  rRegI_rule,
  /*  862 */  rRegI_rule,
  /*  863 */  rRegL_rule,
  /*  864 */  rRegL_rule,
  /*  865 */  rRegL_rule,
  /*  866 */  rRegL_rule,
  /*  867 */  rRegL_rule,
  /*  868 */  rRegL_rule,
  /*  869 */  rRegL_rule,
  /*  870 */  rRegL_rule,
  /*  871 */  rRegL_rule,
  /*  872 */  rRegL_rule,
  /*  873 */  rRegL_rule,
  /*  874 */  rRegL_rule,
  /*  875 */  rRegI_rule,
  /*  876 */  rRegI_rule,
  /*  877 */  rRegL_rule,
  /*  878 */  rRegI_rule,
  /*  879 */  rRegL_rule,
  /*  880 */  rRegL_rule,
  /*  881 */  rRegI_rule,
  /*  882 */  rRegI_rule,
  /*  883 */  rRegI_rule,
  /*  884 */  Universe_rule,
  /*  885 */  Universe_rule,
  /*  886 */  Universe_rule,
  /*  887 */  Universe_rule,
  /*  888 */  Universe_rule,
  /*  889 */  rRegI_rule,
  /*  890 */  rRegI_rule,
  /*  891 */  rRegI_rule,
  /*  892 */  rRegI_rule,
  /*  893 */  rRegI_rule,
  /*  894 */  rRegI_rule,
  /*  895 */  rRegI_rule,
  /*  896 */  rRegI_rule,
  /*  897 */  rRegI_rule,
  /*  898 */  rRegI_rule,
  /*  899 */  rRegI_rule,
  /*  900 */  rRegI_rule,
  /*  901 */  rRegI_rule,
  /*  902 */  rRegI_rule,
  /*  903 */  rRegI_rule,
  /*  904 */  rRegI_rule,
  /*  905 */  rRegI_rule,
  /*  906 */  rRegI_rule,
  /*  907 */  rRegI_rule,
  /*  908 */  rRegI_rule,
  /*  909 */  Universe_rule,
  /*  910 */  Universe_rule,
  /*  911 */  Universe_rule,
  /*  912 */  Universe_rule,
  /*  913 */  Universe_rule,
  /*  914 */  rRegI_rule,
  /*  915 */  rRegI_rule,
  /*  916 */  rRegI_rule,
  /*  917 */  rRegI_rule,
  /*  918 */  rRegI_rule,
  /*  919 */  Universe_rule,
  /*  920 */  Universe_rule,
  /*  921 */  Universe_rule,
  /*  922 */  Universe_rule,
  /*  923 */  Universe_rule,
  /*  924 */  rRegL_rule,
  /*  925 */  rRegL_rule,
  /*  926 */  rRegL_rule,
  /*  927 */  rRegL_rule,
  /*  928 */  rRegL_rule,
  /*  929 */  rRegL_rule,
  /*  930 */  Universe_rule,
  /*  931 */  Universe_rule,
  /*  932 */  Universe_rule,
  /*  933 */  Universe_rule,
  /*  934 */  rRegL_rule,
  /*  935 */  rRegL_rule,
  /*  936 */  rRegL_rule,
  /*  937 */  rRegL_rule,
  /*  938 */  rRegL_rule,
  /*  939 */  rRegL_rule,
  /*  940 */  rRegL_rule,
  /*  941 */  rRegL_rule,
  /*  942 */  rRegL_rule,
  /*  943 */  rRegL_rule,
  /*  944 */  rRegL_rule,
  /*  945 */  rRegL_rule,
  /*  946 */  rRegL_rule,
  /*  947 */  rRegL_rule,
  /*  948 */  rRegL_rule,
  /*  949 */  rRegL_rule,
  /*  950 */  rRegL_rule,
  /*  951 */  rRegL_rule,
  /*  952 */  rRegL_rule,
  /*  953 */  rRegL_rule,
  /*  954 */  rRegL_rule,
  /*  955 */  rRegL_rule,
  /*  956 */  Universe_rule,
  /*  957 */  Universe_rule,
  /*  958 */  Universe_rule,
  /*  959 */  Universe_rule,
  /*  960 */  rRegL_rule,
  /*  961 */  rRegL_rule,
  /*  962 */  rRegL_rule,
  /*  963 */  rRegL_rule,
  /*  964 */  rRegL_rule,
  /*  965 */  Universe_rule,
  /*  966 */  Universe_rule,
  /*  967 */  Universe_rule,
  /*  968 */  rRegI_rule,
  /*  969 */  rRegI_rule,
  /*  970 */  rRegI_rule,
  /*  971 */  rRegI_rule,
  /*  972 */  rRegI_rule,
  /*  973 */  rRegI_rule,
  /*  974 */  rRegI_rule,
  /*  975 */  rRegI_rule,
  /*  976 */  rRegI_rule,
  /*  977 */  rRegI_rule,
  /*  978 */  rRegI_rule,
  /*  979 */  rRegI_rule,
  /*  980 */  rRegI_rule,
  /*  981 */  rRegI_rule,
  /*  982 */  regD_rule,
  /*  983 */  regD_rule,
  /*  984 */  regF_rule,
  /*  985 */  regF_rule,
  /*  986 */  rRegI_rule,
  /*  987 */  rRegL_rule,
  /*  988 */  rRegI_rule,
  /*  989 */  rRegL_rule,
  /*  990 */  rRegL_rule,
  /*  991 */  rRegI_rule,
  /*  992 */  vlRegF_rule,
  /*  993 */  regF_rule,
  /*  994 */  vlRegD_rule,
  /*  995 */  regD_rule,
  /*  996 */  regF_rule,
  /*  997 */  regD_rule,
  /*  998 */  vlRegF_rule,
  /*  999 */  regF_rule,
  /* 1000 */  vlRegD_rule,
  /* 1001 */  regD_rule,
  /* 1002 */  rRegL_rule,
  /* 1003 */  rRegL_rule,
  /* 1004 */  rRegL_rule,
  /* 1005 */  rRegL_rule,
  /* 1006 */  rRegI_rule,
  /* 1007 */  stackSlotI_rule,
  /* 1008 */  stackSlotF_rule,
  /* 1009 */  stackSlotL_rule,
  /* 1010 */  stackSlotD_rule,
  /* 1011 */  Universe_rule,
  /* 1012 */  Universe_rule,
  /* 1013 */  Universe_rule,
  /* 1014 */  Universe_rule,
  /* 1015 */  Universe_rule,
  /* 1016 */  rax_RegI_rule,
  /* 1017 */  rax_RegI_rule,
  /* 1018 */  rax_RegI_rule,
  /* 1019 */  rax_RegI_rule,
  /* 1020 */  rax_RegI_rule,
  /* 1021 */  rax_RegI_rule,
  /* 1022 */  rax_RegI_rule,
  /* 1023 */  rax_RegI_rule,
  /* 1024 */  rbx_RegI_rule,
  /* 1025 */  rbx_RegI_rule,
  /* 1026 */  rbx_RegI_rule,
  /* 1027 */  rbx_RegI_rule,
  /* 1028 */  rbx_RegI_rule,
  /* 1029 */  rbx_RegI_rule,
  /* 1030 */  rbx_RegI_rule,
  /* 1031 */  rbx_RegI_rule,
  /* 1032 */  rax_RegI_rule,
  /* 1033 */  rax_RegI_rule,
  /* 1034 */  rax_RegI_rule,
  /* 1035 */  rax_RegI_rule,
  /* 1036 */  rax_RegI_rule,
  /* 1037 */  rax_RegI_rule,
  /* 1038 */  rbx_RegI_rule,
  /* 1039 */  rax_RegI_rule,
  /* 1040 */  rax_RegI_rule,
  /* 1041 */  rax_RegI_rule,
  /* 1042 */  rax_RegI_rule,
  /* 1043 */  Universe_rule,
  /* 1044 */  Universe_rule,
  /* 1045 */  rax_RegI_rule,
  /* 1046 */  rax_RegI_rule,
  /* 1047 */  rRegI_rule,
  /* 1048 */  rRegI_rule,
  /* 1049 */  rRegI_rule,
  /* 1050 */  0,
  /* 1051 */  rRegI_rule,
  /* 1052 */  0,
  /* 1053 */  rRegI_rule,
  /* 1054 */  Universe_rule,
  /* 1055 */  Universe_rule,
  /* 1056 */  Universe_rule,
  /* 1057 */  Universe_rule,
  /* 1058 */  Universe_rule,
  /* 1059 */  Universe_rule,
  /* 1060 */  rdi_RegP_rule,
  /* 1061 */  rdi_RegP_rule,
  /* 1062 */  rdi_RegP_rule,
  /* 1063 */  Universe_rule,
  /* 1064 */  Universe_rule,
  /* 1065 */  Universe_rule,
  /* 1066 */  Universe_rule,
  /* 1067 */  Universe_rule,
  /* 1068 */  Universe_rule,
  /* 1069 */  Universe_rule,
  /* 1070 */  kReg_rule,
  /* 1071 */  kReg_rule,
  /* 1072 */  Universe_rule,
  /* 1073 */  Universe_rule,
  /* 1074 */  Universe_rule,
  /* 1075 */  Universe_rule,
  /* 1076 */  Universe_rule,
  /* 1077 */  Universe_rule,
  /* 1078 */  Universe_rule,
  /* 1079 */  Universe_rule,
  /* 1080 */  Universe_rule,
  /* 1081 */  Universe_rule,
  /* 1082 */  rax_RegP_rule,
  /* 1083 */  Universe_rule,
  /* 1084 */  rRegI_rule,
  /* 1085 */  rRegI_rule,
  /* 1086 */  rRegI_rule,
  /* 1087 */  rRegL_rule,
  /* 1088 */  rRegL_rule,
  /* 1089 */  rRegL_rule,
  /* 1090 */  Universe_rule,
  /* 1091 */  regF_rule,
  /* 1092 */  regF_rule,
  /* 1093 */  regF_rule,
  /* 1094 */  regF_rule,
  /* 1095 */  regF_rule,
  /* 1096 */  regF_rule,
  /* 1097 */  regF_rule,
  /* 1098 */  regF_rule,
  /* 1099 */  regD_rule,
  /* 1100 */  regD_rule,
  /* 1101 */  regD_rule,
  /* 1102 */  regD_rule,
  /* 1103 */  regD_rule,
  /* 1104 */  regD_rule,
  /* 1105 */  regD_rule,
  /* 1106 */  regD_rule,
  /* 1107 */  regF_rule,
  /* 1108 */  regF_rule,
  /* 1109 */  regF_rule,
  /* 1110 */  regF_rule,
  /* 1111 */  regF_rule,
  /* 1112 */  regF_rule,
  /* 1113 */  regD_rule,
  /* 1114 */  regD_rule,
  /* 1115 */  regD_rule,
  /* 1116 */  regD_rule,
  /* 1117 */  regD_rule,
  /* 1118 */  regD_rule,
  /* 1119 */  regF_rule,
  /* 1120 */  regF_rule,
  /* 1121 */  regF_rule,
  /* 1122 */  regF_rule,
  /* 1123 */  regF_rule,
  /* 1124 */  regF_rule,
  /* 1125 */  regF_rule,
  /* 1126 */  regF_rule,
  /* 1127 */  regD_rule,
  /* 1128 */  regD_rule,
  /* 1129 */  regD_rule,
  /* 1130 */  regD_rule,
  /* 1131 */  regD_rule,
  /* 1132 */  regD_rule,
  /* 1133 */  regD_rule,
  /* 1134 */  regD_rule,
  /* 1135 */  regF_rule,
  /* 1136 */  regF_rule,
  /* 1137 */  regF_rule,
  /* 1138 */  regF_rule,
  /* 1139 */  regF_rule,
  /* 1140 */  regF_rule,
  /* 1141 */  regD_rule,
  /* 1142 */  regD_rule,
  /* 1143 */  regD_rule,
  /* 1144 */  regD_rule,
  /* 1145 */  regD_rule,
  /* 1146 */  regD_rule,
  /* 1147 */  regF_rule,
  /* 1148 */  regD_rule,
  /* 1149 */  rRegI_rule,
  /* 1150 */  Universe_rule,
  /* 1151 */  Universe_rule,
  /* 1152 */  kReg_rule,
  /* 1153 */  kReg_rule,
  /* 1154 */  kReg_rule,
  /* 1155 */  vec_rule,
  /* 1156 */  legRegD_rule,
  /* 1157 */  legRegD_rule,
  /* 1158 */  legVec_rule,
  /* 1159 */  vec_rule,
  /* 1160 */  legVec_rule,
  /* 1161 */  vec_rule,
  /* 1162 */  Universe_rule,
  /* 1163 */  regD_rule,
  /* 1164 */  regF_rule,
  /* 1165 */  vec_rule,
  /* 1166 */  Universe_rule,
  /* 1167 */  legVec_rule,
  /* 1168 */  vec_rule,
  /* 1169 */  vec_rule,
  /* 1170 */  vec_rule,
  /* 1171 */  vec_rule,
  /* 1172 */  vec_rule,
  /* 1173 */  vec_rule,
  /* 1174 */  vec_rule,
  /* 1175 */  vec_rule,
  /* 1176 */  vec_rule,
  /* 1177 */  vec_rule,
  /* 1178 */  vec_rule,
  /* 1179 */  vec_rule,
  /* 1180 */  vec_rule,
  /* 1181 */  vec_rule,
  /* 1182 */  Universe_rule,
  /* 1183 */  Universe_rule,
  /* 1184 */  vec_rule,
  /* 1185 */  vec_rule,
  /* 1186 */  vec_rule,
  /* 1187 */  vec_rule,
  /* 1188 */  vec_rule,
  /* 1189 */  vec_rule,
  /* 1190 */  vec_rule,
  /* 1191 */  vec_rule,
  /* 1192 */  vec_rule,
  /* 1193 */  vec_rule,
  /* 1194 */  vec_rule,
  /* 1195 */  rRegI_rule,
  /* 1196 */  rRegI_rule,
  /* 1197 */  rRegI_rule,
  /* 1198 */  rRegI_rule,
  /* 1199 */  rRegI_rule,
  /* 1200 */  rRegI_rule,
  /* 1201 */  rRegI_rule,
  /* 1202 */  rRegL_rule,
  /* 1203 */  rRegL_rule,
  /* 1204 */  rRegL_rule,
  /* 1205 */  rRegL_rule,
  /* 1206 */  rRegL_rule,
  /* 1207 */  rRegL_rule,
  /* 1208 */  rRegL_rule,
  /* 1209 */  rRegL_rule,
  /* 1210 */  rRegL_rule,
  /* 1211 */  rRegL_rule,
  /* 1212 */  rRegL_rule,
  /* 1213 */  rRegL_rule,
  /* 1214 */  rRegL_rule,
  /* 1215 */  rRegL_rule,
  /* 1216 */  regF_rule,
  /* 1217 */  regF_rule,
  /* 1218 */  regF_rule,
  /* 1219 */  regF_rule,
  /* 1220 */  regF_rule,
  /* 1221 */  regF_rule,
  /* 1222 */  regF_rule,
  /* 1223 */  regF_rule,
  /* 1224 */  regF_rule,
  /* 1225 */  regF_rule,
  /* 1226 */  regF_rule,
  /* 1227 */  regF_rule,
  /* 1228 */  regF_rule,
  /* 1229 */  regF_rule,
  /* 1230 */  regD_rule,
  /* 1231 */  regD_rule,
  /* 1232 */  regD_rule,
  /* 1233 */  regD_rule,
  /* 1234 */  regD_rule,
  /* 1235 */  regD_rule,
  /* 1236 */  regD_rule,
  /* 1237 */  regD_rule,
  /* 1238 */  regD_rule,
  /* 1239 */  regD_rule,
  /* 1240 */  regD_rule,
  /* 1241 */  regD_rule,
  /* 1242 */  rRegI_rule,
  /* 1243 */  rRegI_rule,
  /* 1244 */  rRegI_rule,
  /* 1245 */  rRegI_rule,
  /* 1246 */  rRegI_rule,
  /* 1247 */  rRegI_rule,
  /* 1248 */  rRegI_rule,
  /* 1249 */  rRegI_rule,
  /* 1250 */  rRegI_rule,
  /* 1251 */  rRegI_rule,
  /* 1252 */  rRegI_rule,
  /* 1253 */  rRegI_rule,
  /* 1254 */  rRegI_rule,
  /* 1255 */  rRegI_rule,
  /* 1256 */  rRegI_rule,
  /* 1257 */  rRegI_rule,
  /* 1258 */  rRegI_rule,
  /* 1259 */  rRegI_rule,
  /* 1260 */  rRegI_rule,
  /* 1261 */  rRegI_rule,
  /* 1262 */  rRegI_rule,
  /* 1263 */  legRegF_rule,
  /* 1264 */  legRegF_rule,
  /* 1265 */  legRegF_rule,
  /* 1266 */  legRegF_rule,
  /* 1267 */  legRegF_rule,
  /* 1268 */  legRegF_rule,
  /* 1269 */  legRegF_rule,
  /* 1270 */  legRegF_rule,
  /* 1271 */  legRegD_rule,
  /* 1272 */  legRegD_rule,
  /* 1273 */  legRegD_rule,
  /* 1274 */  legRegD_rule,
  /* 1275 */  legRegD_rule,
  /* 1276 */  legRegD_rule,
  /* 1277 */  legRegD_rule,
  /* 1278 */  legRegD_rule,
  /* 1279 */  vec_rule,
  /* 1280 */  vec_rule,
  /* 1281 */  vec_rule,
  /* 1282 */  vec_rule,
  /* 1283 */  vec_rule,
  /* 1284 */  vec_rule,
  /* 1285 */  vec_rule,
  /* 1286 */  vec_rule,
  /* 1287 */  vec_rule,
  /* 1288 */  vec_rule,
  /* 1289 */  vec_rule,
  /* 1290 */  vec_rule,
  /* 1291 */  vec_rule,
  /* 1292 */  vec_rule,
  /* 1293 */  vec_rule,
  /* 1294 */  vec_rule,
  /* 1295 */  vec_rule,
  /* 1296 */  vec_rule,
  /* 1297 */  vec_rule,
  /* 1298 */  vec_rule,
  /* 1299 */  vec_rule,
  /* 1300 */  vec_rule,
  /* 1301 */  vec_rule,
  /* 1302 */  vec_rule,
  /* 1303 */  vec_rule,
  /* 1304 */  vec_rule,
  /* 1305 */  vec_rule,
  /* 1306 */  vec_rule,
  /* 1307 */  vec_rule,
  /* 1308 */  vec_rule,
  /* 1309 */  vec_rule,
  /* 1310 */  vec_rule,
  /* 1311 */  vec_rule,
  /* 1312 */  vec_rule,
  /* 1313 */  vec_rule,
  /* 1314 */  vec_rule,
  /* 1315 */  vec_rule,
  /* 1316 */  vec_rule,
  /* 1317 */  vec_rule,
  /* 1318 */  vec_rule,
  /* 1319 */  vec_rule,
  /* 1320 */  vec_rule,
  /* 1321 */  vec_rule,
  /* 1322 */  vec_rule,
  /* 1323 */  vec_rule,
  /* 1324 */  vec_rule,
  /* 1325 */  vec_rule,
  /* 1326 */  vec_rule,
  /* 1327 */  vec_rule,
  /* 1328 */  vec_rule,
  /* 1329 */  vec_rule,
  /* 1330 */  vec_rule,
  /* 1331 */  vec_rule,
  /* 1332 */  vec_rule,
  /* 1333 */  vec_rule,
  /* 1334 */  vec_rule,
  /* 1335 */  vec_rule,
  /* 1336 */  vec_rule,
  /* 1337 */  vec_rule,
  /* 1338 */  vec_rule,
  /* 1339 */  vec_rule,
  /* 1340 */  vec_rule,
  /* 1341 */  vec_rule,
  /* 1342 */  vec_rule,
  /* 1343 */  vec_rule,
  /* 1344 */  vec_rule,
  /* 1345 */  vec_rule,
  /* 1346 */  vec_rule,
  /* 1347 */  vec_rule,
  /* 1348 */  vec_rule,
  /* 1349 */  vec_rule,
  /* 1350 */  vec_rule,
  /* 1351 */  vec_rule,
  /* 1352 */  vec_rule,
  /* 1353 */  vec_rule,
  /* 1354 */  vec_rule,
  /* 1355 */  vec_rule,
  /* 1356 */  vec_rule,
  /* 1357 */  vec_rule,
  /* 1358 */  vec_rule,
  /* 1359 */  legVec_rule,
  /* 1360 */  legVec_rule,
  /* 1361 */  vec_rule,
  /* 1362 */  vec_rule,
  /* 1363 */  legVec_rule,
  /* 1364 */  legVec_rule,
  /* 1365 */  vec_rule,
  /* 1366 */  vec_rule,
  /* 1367 */  vec_rule,
  /* 1368 */  vec_rule,
  /* 1369 */  vec_rule,
  /* 1370 */  vec_rule,
  /* 1371 */  vec_rule,
  /* 1372 */  vec_rule,
  /* 1373 */  vec_rule,
  /* 1374 */  vec_rule,
  /* 1375 */  vec_rule,
  /* 1376 */  vec_rule,
  /* 1377 */  regF_rule,
  /* 1378 */  regD_rule,
  /* 1379 */  vec_rule,
  /* 1380 */  vec_rule,
  /* 1381 */  vec_rule,
  /* 1382 */  vec_rule,
  /* 1383 */  regF_rule,
  /* 1384 */  regD_rule,
  /* 1385 */  rRegI_rule,
  /* 1386 */  rRegI_rule,
  /* 1387 */  rRegI_rule,
  /* 1388 */  rRegI_rule,
  /* 1389 */  vec_rule,
  /* 1390 */  vec_rule,
  /* 1391 */  vec_rule,
  /* 1392 */  vec_rule,
  /* 1393 */  vec_rule,
  /* 1394 */  vec_rule,
  /* 1395 */  vec_rule,
  /* 1396 */  vec_rule,
  /* 1397 */  vec_rule,
  /* 1398 */  vec_rule,
  /* 1399 */  vec_rule,
  /* 1400 */  vec_rule,
  /* 1401 */  vec_rule,
  /* 1402 */  vec_rule,
  /* 1403 */  vec_rule,
  /* 1404 */  vec_rule,
  /* 1405 */  vec_rule,
  /* 1406 */  vec_rule,
  /* 1407 */  vec_rule,
  /* 1408 */  vec_rule,
  /* 1409 */  vec_rule,
  /* 1410 */  vec_rule,
  /* 1411 */  vec_rule,
  /* 1412 */  vec_rule,
  /* 1413 */  vec_rule,
  /* 1414 */  vec_rule,
  /* 1415 */  vec_rule,
  /* 1416 */  vec_rule,
  /* 1417 */  vec_rule,
  /* 1418 */  vec_rule,
  /* 1419 */  vec_rule,
  /* 1420 */  vec_rule,
  /* 1421 */  vec_rule,
  /* 1422 */  vec_rule,
  /* 1423 */  vec_rule,
  /* 1424 */  vec_rule,
  /* 1425 */  vec_rule,
  /* 1426 */  vec_rule,
  /* 1427 */  vec_rule,
  /* 1428 */  vec_rule,
  /* 1429 */  vec_rule,
  /* 1430 */  vec_rule,
  /* 1431 */  vec_rule,
  /* 1432 */  vec_rule,
  /* 1433 */  vec_rule,
  /* 1434 */  vec_rule,
  /* 1435 */  vec_rule,
  /* 1436 */  vec_rule,
  /* 1437 */  vec_rule,
  /* 1438 */  vec_rule,
  /* 1439 */  vec_rule,
  /* 1440 */  vec_rule,
  /* 1441 */  vec_rule,
  /* 1442 */  vec_rule,
  /* 1443 */  vec_rule,
  /* 1444 */  vec_rule,
  /* 1445 */  vec_rule,
  /* 1446 */  vec_rule,
  /* 1447 */  vec_rule,
  /* 1448 */  vec_rule,
  /* 1449 */  vec_rule,
  /* 1450 */  vec_rule,
  /* 1451 */  vec_rule,
  /* 1452 */  vec_rule,
  /* 1453 */  vec_rule,
  /* 1454 */  vec_rule,
  /* 1455 */  vec_rule,
  /* 1456 */  vec_rule,
  /* 1457 */  vec_rule,
  /* 1458 */  vec_rule,
  /* 1459 */  vec_rule,
  /* 1460 */  vec_rule,
  /* 1461 */  vec_rule,
  /* 1462 */  vec_rule,
  /* 1463 */  vec_rule,
  /* 1464 */  vec_rule,
  /* 1465 */  vec_rule,
  /* 1466 */  vec_rule,
  /* 1467 */  vec_rule,
  /* 1468 */  vec_rule,
  /* 1469 */  vec_rule,
  /* 1470 */  vec_rule,
  /* 1471 */  legVec_rule,
  /* 1472 */  vec_rule,
  /* 1473 */  kReg_rule,
  /* 1474 */  legVec_rule,
  /* 1475 */  legVec_rule,
  /* 1476 */  legVec_rule,
  /* 1477 */  vec_rule,
  /* 1478 */  kReg_rule,
  /* 1479 */  rRegI_rule,
  /* 1480 */  rRegI_rule,
  /* 1481 */  rRegI_rule,
  /* 1482 */  rRegI_rule,
  /* 1483 */  rRegI_rule,
  /* 1484 */  rRegI_rule,
  /* 1485 */  rRegL_rule,
  /* 1486 */  rRegL_rule,
  /* 1487 */  legRegF_rule,
  /* 1488 */  legRegF_rule,
  /* 1489 */  legRegD_rule,
  /* 1490 */  legRegD_rule,
  /* 1491 */  vec_rule,
  /* 1492 */  legVec_rule,
  /* 1493 */  legVec_rule,
  /* 1494 */  legVec_rule,
  /* 1495 */  vec_rule,
  /* 1496 */  vec_rule,
  /* 1497 */  legVec_rule,
  /* 1498 */  kReg_rule,
  /* 1499 */  kReg_rule,
  /* 1500 */  vec_rule,
  /* 1501 */  vec_rule,
  /* 1502 */  vec_rule,
  /* 1503 */  vec_rule,
  /* 1504 */  vec_rule,
  /* 1505 */  vec_rule,
  /* 1506 */  vec_rule,
  /* 1507 */  vec_rule,
  /* 1508 */  vec_rule,
  /* 1509 */  vec_rule,
  /* 1510 */  vec_rule,
  /* 1511 */  vec_rule,
  /* 1512 */  legVec_rule,
  /* 1513 */  vec_rule,
  /* 1514 */  vec_rule,
  /* 1515 */  vec_rule,
  /* 1516 */  vec_rule,
  /* 1517 */  legVec_rule,
  /* 1518 */  vec_rule,
  /* 1519 */  vec_rule,
  /* 1520 */  vec_rule,
  /* 1521 */  vec_rule,
  /* 1522 */  vec_rule,
  /* 1523 */  vec_rule,
  /* 1524 */  vec_rule,
  /* 1525 */  vec_rule,
  /* 1526 */  vec_rule,
  /* 1527 */  vec_rule,
  /* 1528 */  vec_rule,
  /* 1529 */  vec_rule,
  /* 1530 */  vec_rule,
  /* 1531 */  vec_rule,
  /* 1532 */  vec_rule,
  /* 1533 */  vec_rule,
  /* 1534 */  vec_rule,
  /* 1535 */  vec_rule,
  /* 1536 */  vec_rule,
  /* 1537 */  vec_rule,
  /* 1538 */  vec_rule,
  /* 1539 */  vec_rule,
  /* 1540 */  vec_rule,
  /* 1541 */  vec_rule,
  /* 1542 */  vec_rule,
  /* 1543 */  vec_rule,
  /* 1544 */  vec_rule,
  /* 1545 */  vec_rule,
  /* 1546 */  vec_rule,
  /* 1547 */  vec_rule,
  /* 1548 */  vec_rule,
  /* 1549 */  Universe_rule,
  /* 1550 */  Universe_rule,
  /* 1551 */  rRegP_rule,
  /* 1552 */  rRegI_rule,
  /* 1553 */  kReg_rule,
  /* 1554 */  kReg_rule,
  /* 1555 */  rRegL_rule,
  /* 1556 */  rRegL_rule,
  /* 1557 */  rRegL_rule,
  /* 1558 */  rRegI_rule,
  /* 1559 */  rRegI_rule,
  /* 1560 */  rRegI_rule,
  /* 1561 */  rRegI_rule,
  /* 1562 */  rRegI_rule,
  /* 1563 */  rRegI_rule,
  /* 1564 */  rRegI_rule,
  /* 1565 */  rRegI_rule,
  /* 1566 */  rRegI_rule,
  /* 1567 */  vec_rule,
  /* 1568 */  vec_rule,
  /* 1569 */  vec_rule,
  /* 1570 */  vec_rule,
  /* 1571 */  kReg_rule,
  /* 1572 */  vec_rule,
  /* 1573 */  vec_rule,
  /* 1574 */  vec_rule,
  /* 1575 */  vec_rule,
  /* 1576 */  vec_rule,
  /* 1577 */  vec_rule,
  /* 1578 */  vec_rule,
  /* 1579 */  vec_rule,
  /* 1580 */  vec_rule,
  /* 1581 */  vec_rule,
  /* 1582 */  vec_rule,
  /* 1583 */  vec_rule,
  /* 1584 */  vec_rule,
  /* 1585 */  vec_rule,
  /* 1586 */  vec_rule,
  /* 1587 */  vec_rule,
  /* 1588 */  vec_rule,
  /* 1589 */  vec_rule,
  /* 1590 */  vec_rule,
  /* 1591 */  vec_rule,
  /* 1592 */  vec_rule,
  /* 1593 */  vec_rule,
  /* 1594 */  vec_rule,
  /* 1595 */  vec_rule,
  /* 1596 */  vec_rule,
  /* 1597 */  vec_rule,
  /* 1598 */  vec_rule,
  /* 1599 */  vec_rule,
  /* 1600 */  vec_rule,
  /* 1601 */  vec_rule,
  /* 1602 */  vec_rule,
  /* 1603 */  vec_rule,
  /* 1604 */  vec_rule,
  /* 1605 */  vec_rule,
  /* 1606 */  vec_rule,
  /* 1607 */  vec_rule,
  /* 1608 */  vec_rule,
  /* 1609 */  vec_rule,
  /* 1610 */  vec_rule,
  /* 1611 */  vec_rule,
  /* 1612 */  vec_rule,
  /* 1613 */  vec_rule,
  /* 1614 */  vec_rule,
  /* 1615 */  vec_rule,
  /* 1616 */  vec_rule,
  /* 1617 */  vec_rule,
  /* 1618 */  vec_rule,
  /* 1619 */  vec_rule,
  /* 1620 */  vec_rule,
  /* 1621 */  vec_rule,
  /* 1622 */  vec_rule,
  /* 1623 */  vec_rule,
  /* 1624 */  vec_rule,
  /* 1625 */  vec_rule,
  /* 1626 */  vec_rule,
  /* 1627 */  vec_rule,
  /* 1628 */  vec_rule,
  /* 1629 */  vec_rule,
  /* 1630 */  vec_rule,
  /* 1631 */  vec_rule,
  /* 1632 */  vec_rule,
  /* 1633 */  vec_rule,
  /* 1634 */  vec_rule,
  /* 1635 */  vec_rule,
  /* 1636 */  vec_rule,
  /* 1637 */  vec_rule,
  /* 1638 */  vec_rule,
  /* 1639 */  vec_rule,
  /* 1640 */  vec_rule,
  /* 1641 */  vec_rule,
  /* 1642 */  vec_rule,
  /* 1643 */  vec_rule,
  /* 1644 */  vec_rule,
  /* 1645 */  vec_rule,
  /* 1646 */  vec_rule,
  /* 1647 */  vec_rule,
  /* 1648 */  vec_rule,
  /* 1649 */  vec_rule,
  /* 1650 */  vec_rule,
  /* 1651 */  vec_rule,
  /* 1652 */  vec_rule,
  /* 1653 */  vec_rule,
  /* 1654 */  vec_rule,
  /* 1655 */  vec_rule,
  /* 1656 */  vec_rule,
  /* 1657 */  vec_rule,
  /* 1658 */  vec_rule,
  /* 1659 */  vec_rule,
  /* 1660 */  vec_rule,
  /* 1661 */  vec_rule,
  /* 1662 */  vec_rule,
  /* 1663 */  vec_rule,
  /* 1664 */  vec_rule,
  /* 1665 */  vec_rule,
  /* 1666 */  vec_rule,
  /* 1667 */  vec_rule,
  /* 1668 */  vec_rule,
  /* 1669 */  vec_rule,
  /* 1670 */  vec_rule,
  /* 1671 */  kReg_rule,
  /* 1672 */  kReg_rule,
  /* 1673 */  kReg_rule,
  /* 1674 */  kReg_rule,
  /* 1675 */  vec_rule,
  /* 1676 */  vec_rule,
  /* 1677 */  kReg_rule,
  /* 1678 */  kReg_rule,
  /* 1679 */  kReg_rule,
  /* 1680 */  vec_rule,
  /* 1681 */  vec_rule,
  /* 1682 */  rRegI_rule,
  /* 1683 */  rRegI_rule,
  /* 1684 */  vec_rule,
  /* 1685 */  vec_rule,
  /* 1686 */  vec_rule,
  /* 1687 */  vec_rule,
  /* 1688 */  vec_rule,
  /* 1689 */  vec_rule,
  /* 1690 */  vec_rule,
  /* 1691 */  vec_rule,
  /* 1692 */  vec_rule,
  /* 1693 */  vec_rule,
  /* 1694 */  vec_rule,
  /* 1695 */  vec_rule,
  /* 1696 */  vec_rule,
  /* 1697 */  vec_rule,
  /* 1698 */  vec_rule,
  /* 1699 */  vec_rule,
  /* 1700 */  vec_rule,
  /* 1701 */  vec_rule,
  /* 1702 */  vec_rule,
  /* 1703 */  vec_rule,
  /* 1704 */  vec_rule,
  /* 1705 */  vec_rule,
  /* 1706 */  vec_rule,
  /* 1707 */  vec_rule,
  /* 1708 */  vec_rule,
  /* 1709 */  rRegI_rule,
  /* 1710 */  rRegI_rule,
  /* 1711 */  rRegI_rule,
  /* 1712 */  rRegI_rule,
  /* 1713 */  rax_RegN_rule,
  /* 1714 */  rax_RegP_rule,
  /* 1715 */  rRegP_rule,
  /* 1716 */  Universe_rule,
  /* 1717 */  Universe_rule,
  /* 1718 */  rax_RegP_rule,
  /* 1719 */  rRegI_rule,
  /* 1720 */  rRegI_rule,
  /* 1721 */  rRegP_rule,
  /* 1722 */  Universe_rule,
  /* 1723 */  Universe_rule,
  /* 1724 */  Universe_rule,
  /* 1725 */  rax_RegP_rule,
  /* 1726 */  rax_RegN_rule,
  /* 1727 */  rRegI_rule,
  /* 1728 */  rRegI_rule,
  /* 1729 */  rRegI_rule,
  /* 1730 */  rRegI_rule,
  /* 1731 */  rRegP_rule,
  /* 1732 */  rRegN_rule,
  /* 1733 */  rRegP_rule,
  /* 1734 */  rRegN_rule,
  // last instruction
  0 // no trailing comma
};

const        int   leftOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  any_RegP_rule,
  /*   86 */  any_RegP_rule,
  /*   87 */  _AddP_any_RegP_rRegL_rule,
  /*   88 */  any_RegP_rule,
  /*   89 */  any_RegP_rule,
  /*   90 */  any_RegP_rule,
  /*   91 */  _AddP_any_RegP__LShiftL_rRegL_immI2_rule,
  /*   92 */  _AddP_any_RegP__ConvI2L_rRegI__rule,
  /*   93 */  _AddP_any_RegP__LShiftL__ConvI2L_rRegI__immI2_rule,
  /*   94 */  _DecodeN_rRegN__rule,
  /*   95 */  rRegN_rule,
  /*   96 */  _DecodeN_rRegN__rule,
  /*   97 */  _DecodeN_rRegN__rule,
  /*   98 */  _AddP__DecodeN_rRegN__rRegL_rule,
  /*   99 */  _DecodeN_rRegN__rule,
  /*  100 */  _DecodeN_rRegN__rule,
  /*  101 */  _AddP__DecodeN_rRegN___LShiftL_rRegL_immI2_rule,
  /*  102 */  _AddP__DecodeN_rRegN___ConvI2L_rRegI__rule,
  /*  103 */  _AddP__DecodeN_rRegN___LShiftL__ConvI2L_rRegI__immI2_rule,
  /*  104 */  0,
  /*  105 */  0,
  /*  106 */  0,
  /*  107 */  0,
  /*  108 */  0,
  /*  109 */  0,
  /*  110 */  0,
  /*  111 */  0,
  /*  112 */  0,
  /*  113 */  0,
  /*  114 */  0,
  /*  115 */  0,
  /*  116 */  0,
  /*  117 */  0,
  /*  118 */  0,
  /*  119 */  0,
  /*  120 */  0,
  /*  121 */  0,
  /*  122 */  0,
  /*  123 */  0,
  /*  124 */  0,
  /*  125 */  0,
  /*  126 */  0,
  // last operand
  /*  127 */  0,
  // last operand class
  /*  128 */  any_RegP_rule,
  /*  129 */  rRegL_rule,
  /*  130 */  rRegI_rule,
  /*  131 */  _ConvI2L_rRegI__rule,
  /*  132 */  any_RegP_rule,
  /*  133 */  any_RegP_rule,
  /*  134 */  any_RegP_rule,
  /*  135 */  rRegN_rule,
  /*  136 */  _DecodeN_rRegN__rule,
  /*  137 */  _DecodeN_rRegN__rule,
  /*  138 */  _DecodeN_rRegN__rule,
  /*  139 */  _DecodeN_rRegN__rule,
  /*  140 */  memory_rule,
  /*  141 */  memory_rule,
  /*  142 */  _LoadUB_memory__rule,
  /*  143 */  memory_rule,
  /*  144 */  _LoadS_memory__rule,
  /*  145 */  memory_rule,
  /*  146 */  _LoadUS_memory__rule,
  /*  147 */  _LoadUS_memory__rule,
  /*  148 */  _LoadUS_memory__rule,
  /*  149 */  memory_rule,
  /*  150 */  _LoadI_memory__rule,
  /*  151 */  _LoadI_memory__rule,
  /*  152 */  _LoadI_memory__rule,
  /*  153 */  _LoadI_memory__rule,
  /*  154 */  _LoadI_memory__rule,
  /*  155 */  _LoadI_memory__rule,
  /*  156 */  memory_rule,
  /*  157 */  rRegP_rule,
  /*  158 */  _DecodeN_rRegN__rule,
  /*  159 */  _LShiftL_rRegL_immI2_rule,
  /*  160 */  cmpOp_rule,
  /*  161 */  immI_1_rule,
  /*  162 */  rRegI_rule,
  /*  163 */  cmpOpU_rule,
  /*  164 */  cmpOpUCF_rule,
  /*  165 */  cmpOpUCF2_rule,
  /*  166 */  rRegI_rule,
  /*  167 */  rRegN_rule,
  /*  168 */  rRegP_rule,
  /*  169 */  immL1_rule,
  /*  170 */  rRegL_rule,
  /*  171 */  rRegL_rule,
  /*  172 */  regF_rule,
  /*  173 */  regD_rule,
  /*  174 */  _LoadI_memory__rule,
  /*  175 */  rRegI_rule,
  /*  176 */  _LoadI_memory__rule,
  /*  177 */  _LoadI_memory__rule,
  /*  178 */  _LoadI_memory__rule,
  /*  179 */  rRegI_rule,
  /*  180 */  rRegI_rule,
  /*  181 */  rRegI_rule,
  /*  182 */  _LShiftI_rRegI_immI2_rule,
  /*  183 */  _LoadL_memory__rule,
  /*  184 */  rRegL_rule,
  /*  185 */  _LoadL_memory__rule,
  /*  186 */  _LoadL_memory__rule,
  /*  187 */  _LoadL_memory__rule,
  /*  188 */  rRegL_rule,
  /*  189 */  rRegL_rule,
  /*  190 */  _LShiftL_rRegL_immI2_rule,
  /*  191 */  rax_RegP_rule,
  /*  192 */  rax_RegL_rule,
  /*  193 */  rax_RegI_rule,
  /*  194 */  rax_RegN_rule,
  /*  195 */  _LoadI_memory__rule,
  /*  196 */  _LoadL_memory__rule,
  /*  197 */  immI_0_rule,
  /*  198 */  immI_0_rule,
  /*  199 */  immL0_rule,
  /*  200 */  _LoadI_memory__rule,
  /*  201 */  _LoadI_memory__rule,
  /*  202 */  _LoadI_memory__rule,
  /*  203 */  _LoadI_memory__rule,
  /*  204 */  _LoadI_memory__rule,
  /*  205 */  _LoadI_memory__rule,
  /*  206 */  _LoadL_memory__rule,
  /*  207 */  _LoadL_memory__rule,
  /*  208 */  _LoadL_memory__rule,
  /*  209 */  _LoadL_memory__rule,
  /*  210 */  _LoadL_memory__rule,
  /*  211 */  _LoadL_memory__rule,
  /*  212 */  rRegI_rule,
  /*  213 */  rRegI_rule,
  /*  214 */  rRegI_rule,
  /*  215 */  rRegI_rule,
  /*  216 */  rRegI_rule,
  /*  217 */  _LoadB_memory__rule,
  /*  218 */  rRegI_rule,
  /*  219 */  _LoadI_memory__rule,
  /*  220 */  rRegI_rule,
  /*  221 */  _LoadI_memory__rule,
  /*  222 */  rRegI_rule,
  /*  223 */  rRegI_rule,
  /*  224 */  _LoadB_memory__rule,
  /*  225 */  rRegI_rule,
  /*  226 */  _LoadI_memory__rule,
  /*  227 */  rRegI_rule,
  /*  228 */  _LoadI_memory__rule,
  /*  229 */  _LoadB_memory__rule,
  /*  230 */  rRegI_rule,
  /*  231 */  _LoadI_memory__rule,
  /*  232 */  rRegI_rule,
  /*  233 */  _LoadI_memory__rule,
  /*  234 */  _LoadL_memory__rule,
  /*  235 */  rRegL_rule,
  /*  236 */  _LoadL_memory__rule,
  /*  237 */  _LoadL_memory__rule,
  /*  238 */  rRegL_rule,
  /*  239 */  immL0_rule,
  /*  240 */  rRegL_rule,
  /*  241 */  any_RegP_rule,
  /*  242 */  _LoadL_memory__rule,
  /*  243 */  rRegL_rule,
  /*  244 */  _LoadL_memory__rule,
  /*  245 */  _LoadL_memory__rule,
  /*  246 */  _LoadL_memory__rule,
  /*  247 */  rRegL_rule,
  /*  248 */  _LoadL_memory__rule,
  /*  249 */  rRegI_rule,
  /*  250 */  _CmpLTMask_rRegI_rRegI_rule,
  /*  251 */  rRegI_rule,
  /*  252 */  rRegI_rule,
  /*  253 */  memory_rule,
  /*  254 */  memory_rule,
  /*  255 */  rdi_RegP_rule,
  /*  256 */  rsi_RegP_rule,
  /*  257 */  rdi_RegP_rule,
  /*  258 */  rsi_RegP_rule,
  /*  259 */  rsi_RegP_rule,
  /*  260 */  rdi_RegP_rule,
  /*  261 */  rbx_RegI_rule,
  /*  262 */  rRegI_rule,
  /*  263 */  rRegI_rule,
  /*  264 */  memory_rule,
  /*  265 */  memory_rule,
  /*  266 */  memory_rule,
  /*  267 */  rRegL_rule,
  /*  268 */  rRegL_rule,
  /*  269 */  _CastP2X_rRegP__rule,
  /*  270 */  _LoadL_memory__rule,
  /*  271 */  _LoadUB_memory__rule,
  /*  272 */  _LoadB_memory__rule,
  /*  273 */  rax_RegP_rule,
  /*  274 */  regF_rule,
  /*  275 */  vec_rule,
  /*  276 */  memory_rule,
  /*  277 */  vec_rule,
  /*  278 */  rRegP_rule,
  /*  279 */  rRegP_rule,
  /*  280 */  kReg_rule,
  /*  281 */  rRegP_rule,
  /*  282 */  kReg_rule,
  /*  283 */  rRegP_rule,
  /*  284 */  vec_rule,
  /*  285 */  rRegP_rule,
  /*  286 */  vec_rule,
  /*  287 */  rRegP_rule,
  /*  288 */  vec_rule,
  /*  289 */  vec_rule,
  /*  290 */  vec_rule,
  /*  291 */  vec_rule,
  /*  292 */  vec_rule,
  /*  293 */  vec_rule,
  /*  294 */  regD_rule,
  /*  295 */  immI8_rule,
  /*  296 */  immI8_rule,
  /*  297 */  legVec_rule,
  /*  298 */  vec_rule,
  /*  299 */  vec_rule,
  /*  300 */  _LoadVector_memory__rule,
  /*  301 */  vec_rule,
  /*  302 */  vec_rule,
  /*  303 */  vec_rule,
  /*  304 */  vec_rule,
  /*  305 */  _LoadVector_memory__rule,
  /*  306 */  immI8_rule,
  /*  307 */  immI_M1_rule,
  /*  308 */  immU8_rule,
  /*  309 */  vec_rule,
  /*  310 */  vec_rule,
  /*  311 */  memory_rule,
  /*  312 */  vec_rule,
  /*  313 */  rax_RegP_rule,
  /*  314 */  any_RegP_rule,
  // last internally defined operand
  /*  315 */  rRegI_rule,
  /*  316 */  rRegL_rule,
  /*  317 */  rRegP_rule,
  /*  318 */  regF_rule,
  /*  319 */  regD_rule,
  /*  320 */  regF_rule,
  /*  321 */  regF_rule,
  /*  322 */  vlRegF_rule,
  /*  323 */  legRegF_rule,
  /*  324 */  regD_rule,
  /*  325 */  regD_rule,
  /*  326 */  vlRegD_rule,
  /*  327 */  legRegD_rule,
  /*  328 */  indOffset8_rule,
  /*  329 */  indOffset32_rule,
  /*  330 */  indIndexOffset_rule,
  /*  331 */  indIndexScale_rule,
  /*  332 */  indPosIndexScale_rule,
  /*  333 */  indIndexScaleOffset_rule,
  /*  334 */  indPosIndexOffset_rule,
  /*  335 */  indPosIndexScaleOffset_rule,
  /*  336 */  indCompressedOopOffset_rule,
  /*  337 */  indOffset8Narrow_rule,
  /*  338 */  indOffset32Narrow_rule,
  /*  339 */  indIndexOffsetNarrow_rule,
  /*  340 */  indIndexScaleNarrow_rule,
  /*  341 */  indIndexScaleOffsetNarrow_rule,
  /*  342 */  indPosIndexOffsetNarrow_rule,
  /*  343 */  indPosIndexScaleOffsetNarrow_rule,
  /*  344 */  immI_rule,
  /*  345 */  immI_0_rule,
  /*  346 */  immL_rule,
  /*  347 */  immL0_rule,
  /*  348 */  immUL32_rule,
  /*  349 */  immL32_rule,
  /*  350 */  immP_rule,
  /*  351 */  immP0_rule,
  /*  352 */  immP31_rule,
  /*  353 */  immF_rule,
  /*  354 */  immN0_rule,
  /*  355 */  immN_rule,
  /*  356 */  immNKlass_rule,
  /*  357 */  immF0_rule,
  /*  358 */  immD_rule,
  /*  359 */  immD0_rule,
  /*  360 */  stackSlotI_rule,
  /*  361 */  stackSlotL_rule,
  /*  362 */  stackSlotP_rule,
  /*  363 */  stackSlotF_rule,
  /*  364 */  stackSlotD_rule,
  /*  365 */  vec_rule,
  /*  366 */  legVec_rule,
  /*  367 */  0,
  /*  368 */  rRegL_rule,
  /*  369 */  rRegP_rule,
  /*  370 */  rRegP_rule,
  /*  371 */  rRegP_rule,
  /*  372 */  rRegI_rule,
  /*  373 */  rRegL_rule,
  /*  374 */  regF_rule,
  /*  375 */  regD_rule,
  /*  376 */  regF_rule,
  /*  377 */  regF_rule,
  /*  378 */  regF_rule,
  /*  379 */  regF_rule,
  /*  380 */  regD_rule,
  /*  381 */  regD_rule,
  /*  382 */  regD_rule,
  /*  383 */  regD_rule,
  /*  384 */  stackSlotF_rule,
  /*  385 */  stackSlotI_rule,
  /*  386 */  stackSlotD_rule,
  /*  387 */  stackSlotL_rule,
  /*  388 */  stackSlotL_rule,
  /*  389 */  regF_rule,
  /*  390 */  regD_rule,
  /*  391 */  rRegI_rule,
  /*  392 */  rRegL_rule,
  /*  393 */  rax_RegI_rule,
  /*  394 */  rax_RegI_rule,
  /*  395 */  rax_RegL_rule,
  /*  396 */  rax_RegL_rule,
  /*  397 */  rRegI_rule,
  /*  398 */  rRegI_rule,
  /*  399 */  rRegL_rule,
  /*  400 */  rRegL_rule,
  /*  401 */  immI_0_rule,
  /*  402 */  immL0_rule,
  /*  403 */  rax_RegI_rule,
  /*  404 */  rRegI_rule,
  /*  405 */  rax_RegL_rule,
  /*  406 */  rRegL_rule,
  /*  407 */  rRegI_rule,
  /*  408 */  rRegI_rule,
  /*  409 */  rRegI_rule,
  /*  410 */  rRegI_rule,
  /*  411 */  _AndI_rRegI_immI_rule,
  /*  412 */  _AndI_rRegI_rRegI_rule,
  /*  413 */  _AndI_rRegI__LoadI_memory__rule,
  /*  414 */  _AndI__LoadI_memory__rRegI_rule,
  /*  415 */  rRegI_rule,
  /*  416 */  rRegI_rule,
  /*  417 */  rRegI_rule,
  /*  418 */  rRegI_rule,
  /*  419 */  rRegP_rule,
  /*  420 */  rRegP_rule,
  /*  421 */  rRegP_rule,
  /*  422 */  rRegP_rule,
  /*  423 */  _LoadP_memory__rule,
  /*  424 */  _LoadP_memory__rule,
  /*  425 */  rRegN_rule,
  /*  426 */  rRegN_rule,
  /*  427 */  rRegN_rule,
  /*  428 */  immN_rule,
  /*  429 */  rRegN_rule,
  /*  430 */  immNKlass_rule,
  /*  431 */  rRegN_rule,
  /*  432 */  _LoadN_memory__rule,
  /*  433 */  _LoadN_memory__rule,
  /*  434 */  rRegL_rule,
  /*  435 */  rRegL_rule,
  /*  436 */  rRegL_rule,
  /*  437 */  rRegL_rule,
  /*  438 */  _AndL_rRegL_immL32_rule,
  /*  439 */  _AndL_rRegL_rRegL_rule,
  /*  440 */  _AndL_rRegL__LoadL_memory__rule,
  /*  441 */  _AndL__LoadL_memory__rRegL_rule,
  /*  442 */  _AndL__CastP2X_rRegP___LoadL_memory__rule,
  /*  443 */  _AndL__LoadL_memory___CastP2X_rRegP__rule,
  /*  444 */  rRegL_rule,
  /*  445 */  rRegL_rule,
  /*  446 */  rRegL_rule,
  /*  447 */  rRegL_rule,
  /*  448 */  _LoadB_memory__rule,
  /*  449 */  _AndI__LoadUB_memory__immU7_rule,
  /*  450 */  _AndI__LoadB_memory__immI8_rule,
  /*  451 */  rRegP_rule,
  /*  452 */  rRegP_rule,
  /*  453 */  rRegP_rule,
  /*  454 */  rRegP_rule,
  /*  455 */  0,
  /*  456 */  regF_rule,
  /*  457 */  vlRegF_rule,
  /*  458 */  regD_rule,
  /*  459 */  vlRegD_rule,
  /*  460 */  regF_rule,
  /*  461 */  vlRegF_rule,
  /*  462 */  regD_rule,
  /*  463 */  vlRegD_rule,
  /*  464 */  vec_rule,
  /*  465 */  rRegI_rule,
  /*  466 */  _LoadVector_memory__rule,
  /*  467 */  vec_rule,
  /*  468 */  kReg_rule,
  /*  469 */  vec_rule,
  /*  470 */  vec_rule,
  /*  471 */  vec_rule,
  /*  472 */  legVec_rule,
  /*  473 */  rRegI_rule,
  /*  474 */  _LoadB_memory__rule,
  /*  475 */  rRegI_rule,
  /*  476 */  _LoadS_memory__rule,
  /*  477 */  rRegI_rule,
  /*  478 */  _LoadI_memory__rule,
  /*  479 */  immI_rule,
  /*  480 */  immI_0_rule,
  /*  481 */  immI_M1_rule,
  /*  482 */  rRegL_rule,
  /*  483 */  _LoadL_memory__rule,
  /*  484 */  immL_rule,
  /*  485 */  immL0_rule,
  /*  486 */  immL_M1_rule,
  /*  487 */  vlRegF_rule,
  /*  488 */  vlRegF_rule,
  /*  489 */  _LoadF_memory__rule,
  /*  490 */  immF_rule,
  /*  491 */  immF0_rule,
  /*  492 */  vlRegD_rule,
  /*  493 */  vlRegD_rule,
  /*  494 */  _LoadD_memory__rule,
  /*  495 */  immD_rule,
  /*  496 */  immD0_rule,
  /*  497 */  vec_rule,
  /*  498 */  _LoadVector_memory__rule,
  /*  499 */  vec_rule,
  /*  500 */  _LoadVector_memory__rule,
  /*  501 */  rRegI_rule,
  /*  502 */  rRegI_rule,
  /*  503 */  vec_rule,
  /*  504 */  legVec_rule,
  /*  505 */  vec_rule,
  /*  506 */  vec_rule,
  /*  507 */  vec_rule,
  /*  508 */  vec_rule,
  /*  509 */  vec_rule,
  /*  510 */  vec_rule,
  /*  511 */  vec_rule,
  /*  512 */  vec_rule,
  /*  513 */  vec_rule,
  /*  514 */  vec_rule,
  /*  515 */  vec_rule,
  /*  516 */  vec_rule,
  /*  517 */  vec_rule,
  /*  518 */  vec_rule,
  /*  519 */  vec_rule,
  /*  520 */  vec_rule,
  /*  521 */  vec_rule,
  /*  522 */  vec_rule,
  /*  523 */  vec_rule,
  /*  524 */  vec_rule,
  /*  525 */  vec_rule,
  /*  526 */  legVec_rule,
  /*  527 */  legVec_rule,
  /*  528 */  kReg_rule,
  /*  529 */  kReg_rule,
  /*  530 */  kReg_rule,
  /*  531 */  kReg_rule,
  /*  532 */  vec_rule,
  /*  533 */  vec_rule,
  /*  534 */  immI_0_rule,
  /*  535 */  vec_rule,
  /*  536 */  vec_rule,
  /*  537 */  vec_rule,
  /*  538 */  vec_rule,
  /*  539 */  vec_rule,
  /*  540 */  vec_rule,
  /*  541 */  vec_rule,
  /*  542 */  rRegL_rule,
  /*  543 */  kReg_rule,
  /*  544 */  vec_rule,
  /*  545 */  legVec_rule,
  /*  546 */  _LoadP_memory__rule,
  /*  547 */  memory_rule,
  /*  548 */  _LoadB_memory__rule,
  /*  549 */  memory_rule,
  /*  550 */  _LoadUB_memory__rule,
  /*  551 */  _AndI__LoadUB_memory__immI_rule,
  /*  552 */  memory_rule,
  /*  553 */  _LShiftI__LoadS_memory__immI_24_rule,
  /*  554 */  _LoadS_memory__rule,
  /*  555 */  memory_rule,
  /*  556 */  _LShiftI__LoadUS_memory__immI_24_rule,
  /*  557 */  _LoadUS_memory__rule,
  /*  558 */  _AndI__LoadUS_memory__immI_255_rule,
  /*  559 */  _AndI__LoadUS_memory__immI_rule,
  /*  560 */  memory_rule,
  /*  561 */  _LShiftI__LoadI_memory__immI_24_rule,
  /*  562 */  _LoadI_memory__rule,
  /*  563 */  _LShiftI__LoadI_memory__immI_16_rule,
  /*  564 */  _LoadI_memory__rule,
  /*  565 */  _LoadI_memory__rule,
  /*  566 */  _AndI__LoadI_memory__immI_255_rule,
  /*  567 */  _AndI__LoadI_memory__immI_65535_rule,
  /*  568 */  _AndI__LoadI_memory__immU31_rule,
  /*  569 */  _ConvI2L__LoadI_memory___rule,
  /*  570 */  memory_rule,
  /*  571 */  memory_rule,
  /*  572 */  memory_rule,
  /*  573 */  memory_rule,
  /*  574 */  memory_rule,
  /*  575 */  memory_rule,
  /*  576 */  memory_rule,
  /*  577 */  memory_rule,
  /*  578 */  memory_rule,
  /*  579 */  memory_rule,
  /*  580 */  legRegF_rule,
  /*  581 */  legRegF_rule,
  /*  582 */  legRegD_rule,
  /*  583 */  legRegD_rule,
  /*  584 */  legRegF_rule,
  /*  585 */  legRegF_rule,
  /*  586 */  legRegD_rule,
  /*  587 */  legRegD_rule,
  /*  588 */  memory_rule,
  /*  589 */  memory_rule,
  /*  590 */  memory_rule,
  /*  591 */  memory_rule,
  /*  592 */  memory_rule,
  /*  593 */  memory_rule,
  /*  594 */  memory_rule,
  /*  595 */  memory_rule,
  /*  596 */  memory_rule,
  /*  597 */  memory_rule,
  /*  598 */  memory_rule,
  /*  599 */  memory_rule,
  /*  600 */  memory_rule,
  /*  601 */  memory_rule,
  /*  602 */  memory_rule,
  /*  603 */  memory_rule,
  /*  604 */  memory_rule,
  /*  605 */  memory_rule,
  /*  606 */  memory_rule,
  /*  607 */  memory_rule,
  /*  608 */  memory_rule,
  /*  609 */  memory_rule,
  /*  610 */  memory_rule,
  /*  611 */  memory_rule,
  /*  612 */  memory_rule,
  /*  613 */  memory_rule,
  /*  614 */  memory_rule,
  /*  615 */  memory_rule,
  /*  616 */  memory_rule,
  /*  617 */  memory_rule,
  /*  618 */  indirect_rule,
  /*  619 */  0,
  /*  620 */  0,
  /*  621 */  rRegI_rule,
  /*  622 */  rRegL_rule,
  /*  623 */  rRegI_rule,
  /*  624 */  rRegI_rule,
  /*  625 */  rRegI_rule,
  /*  626 */  _LoadI_memory__rule,
  /*  627 */  rRegI_rule,
  /*  628 */  rRegL_rule,
  /*  629 */  _LoadL_memory__rule,
  /*  630 */  rRegL_rule,
  /*  631 */  rRegI_rule,
  /*  632 */  _LoadI_memory__rule,
  /*  633 */  rRegI_rule,
  /*  634 */  rRegL_rule,
  /*  635 */  _LoadL_memory__rule,
  /*  636 */  rRegL_rule,
  /*  637 */  rRegI_rule,
  /*  638 */  rRegI_rule,
  /*  639 */  rRegL_rule,
  /*  640 */  rRegL_rule,
  /*  641 */  rRegI_rule,
  /*  642 */  _LoadI_memory__rule,
  /*  643 */  rRegL_rule,
  /*  644 */  _LoadL_memory__rule,
  /*  645 */  0,
  /*  646 */  0,
  /*  647 */  0,
  /*  648 */  0,
  /*  649 */  0,
  /*  650 */  0,
  /*  651 */  0,
  /*  652 */  0,
  /*  653 */  0,
  /*  654 */  _CastP2X_rRegP__rule,
  /*  655 */  _CastP2X__DecodeN_rRegN___rule,
  /*  656 */  rRegP_rule,
  /*  657 */  rRegP_rule,
  /*  658 */  rRegN_rule,
  /*  659 */  rRegN_rule,
  /*  660 */  rRegP_rule,
  /*  661 */  rRegN_rule,
  /*  662 */  _LShiftL_rRegL_immI2_rule,
  /*  663 */  _AddL__LShiftL_rRegL_immI2_immL32_rule,
  /*  664 */  rRegL_rule,
  /*  665 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  666 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  667 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  668 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  669 */  _Binary_cmpOpUCF_rFlagsRegUCF_rule,
  /*  670 */  _Binary_cmpOpUCF_rFlagsRegUCF_rule,
  /*  671 */  _Binary_cmpOpUCF2_rFlagsRegUCF_rule,
  /*  672 */  _Binary_cmpOpUCF2_rFlagsRegUCF_rule,
  /*  673 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  674 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  675 */  _Binary_cmpOpUCF_rFlagsRegUCF_rule,
  /*  676 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  677 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  678 */  _Binary_cmpOpUCF_rFlagsRegUCF_rule,
  /*  679 */  _Binary_cmpOpUCF2_rFlagsRegUCF_rule,
  /*  680 */  _Binary_cmpOpUCF2_rFlagsRegUCF_rule,
  /*  681 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  682 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  683 */  _Binary_cmpOpUCF_rFlagsRegUCF_rule,
  /*  684 */  _Binary_cmpOpUCF2_rFlagsRegUCF_rule,
  /*  685 */  _Binary_cmpOpUCF2_rFlagsRegUCF_rule,
  /*  686 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  687 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  688 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  689 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  690 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  691 */  _Binary_cmpOpUCF_rFlagsRegUCF_rule,
  /*  692 */  _Binary_cmpOpUCF_rFlagsRegUCF_rule,
  /*  693 */  _Binary_cmpOpUCF2_rFlagsRegUCF_rule,
  /*  694 */  _Binary_cmpOpUCF2_rFlagsRegUCF_rule,
  /*  695 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  696 */  _Binary_cmpOpUCF_rFlagsRegUCF_rule,
  /*  697 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  698 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  699 */  _Binary_cmpOpUCF_rFlagsRegUCF_rule,
  /*  700 */  _Binary_cmpOp_rFlagsReg_rule,
  /*  701 */  _Binary_cmpOpU_rFlagsRegU_rule,
  /*  702 */  _Binary_cmpOpUCF_rFlagsRegUCF_rule,
  /*  703 */  rRegI_rule,
  /*  704 */  rRegI_rule,
  /*  705 */  rRegI_rule,
  /*  706 */  _LoadI_memory__rule,
  /*  707 */  memory_rule,
  /*  708 */  memory_rule,
  /*  709 */  memory_rule,
  /*  710 */  rRegI_rule,
  /*  711 */  memory_rule,
  /*  712 */  rRegI_rule,
  /*  713 */  memory_rule,
  /*  714 */  _LShiftI_rRegI_immI2_rule,
  /*  715 */  _AddI_rRegI_rRegI_rule,
  /*  716 */  no_rbp_r13_RegI_rule,
  /*  717 */  _LShiftI_rRegI_immI2_rule,
  /*  718 */  _AddI_rRegI__LShiftI_rRegI_immI2_rule,
  /*  719 */  _AddI__LShiftI_rRegI_immI2_rRegI_rule,
  /*  720 */  rRegL_rule,
  /*  721 */  rRegL_rule,
  /*  722 */  rRegL_rule,
  /*  723 */  _LoadL_memory__rule,
  /*  724 */  memory_rule,
  /*  725 */  memory_rule,
  /*  726 */  memory_rule,
  /*  727 */  rRegI_rule,
  /*  728 */  memory_rule,
  /*  729 */  rRegL_rule,
  /*  730 */  memory_rule,
  /*  731 */  _LShiftL_rRegL_immI2_rule,
  /*  732 */  _AddL_rRegL_rRegL_rule,
  /*  733 */  no_rbp_r13_RegL_rule,
  /*  734 */  _LShiftL_rRegL_immI2_rule,
  /*  735 */  _AddL_rRegL__LShiftL_rRegL_immI2_rule,
  /*  736 */  _AddL__LShiftL_rRegL_immI2_rRegL_rule,
  /*  737 */  rRegP_rule,
  /*  738 */  rRegP_rule,
  /*  739 */  memory_rule,
  /*  740 */  memory_rule,
  /*  741 */  memory_rule,
  /*  742 */  memory_rule,
  /*  743 */  memory_rule,
  /*  744 */  memory_rule,
  /*  745 */  memory_rule,
  /*  746 */  memory_rule,
  /*  747 */  memory_rule,
  /*  748 */  memory_rule,
  /*  749 */  memory_rule,
  /*  750 */  memory_rule,
  /*  751 */  memory_rule,
  /*  752 */  memory_rule,
  /*  753 */  memory_rule,
  /*  754 */  memory_rule,
  /*  755 */  memory_rule,
  /*  756 */  memory_rule,
  /*  757 */  memory_rule,
  /*  758 */  memory_rule,
  /*  759 */  memory_rule,
  /*  760 */  memory_rule,
  /*  761 */  memory_rule,
  /*  762 */  memory_rule,
  /*  763 */  memory_rule,
  /*  764 */  memory_rule,
  /*  765 */  memory_rule,
  /*  766 */  memory_rule,
  /*  767 */  memory_rule,
  /*  768 */  memory_rule,
  /*  769 */  memory_rule,
  /*  770 */  memory_rule,
  /*  771 */  memory_rule,
  /*  772 */  memory_rule,
  /*  773 */  memory_rule,
  /*  774 */  memory_rule,
  /*  775 */  rRegI_rule,
  /*  776 */  rRegL_rule,
  /*  777 */  rRegI_rule,
  /*  778 */  rRegI_rule,
  /*  779 */  memory_rule,
  /*  780 */  rRegL_rule,
  /*  781 */  rRegL_rule,
  /*  782 */  memory_rule,
  /*  783 */  rRegP_rule,
  /*  784 */  immI_0_rule,
  /*  785 */  rRegI_rule,
  /*  786 */  memory_rule,
  /*  787 */  immL0_rule,
  /*  788 */  rRegL_rule,
  /*  789 */  memory_rule,
  /*  790 */  rRegI_rule,
  /*  791 */  rRegI_rule,
  /*  792 */  rRegI_rule,
  /*  793 */  _LoadI_memory__rule,
  /*  794 */  _LoadI_memory__rule,
  /*  795 */  _Binary_rRegI_rRegI_rule,
  /*  796 */  rRegL_rule,
  /*  797 */  rRegL_rule,
  /*  798 */  rRegL_rule,
  /*  799 */  _LoadL_memory__rule,
  /*  800 */  _LoadL_memory__rule,
  /*  801 */  rRegL_rule,
  /*  802 */  rRegL_rule,
  /*  803 */  rax_RegI_rule,
  /*  804 */  rax_RegL_rule,
  /*  805 */  rax_RegI_rule,
  /*  806 */  rax_RegL_rule,
  /*  807 */  rax_RegI_rule,
  /*  808 */  rax_RegL_rule,
  /*  809 */  rax_RegI_rule,
  /*  810 */  rax_RegL_rule,
  /*  811 */  rax_RegI_rule,
  /*  812 */  rax_RegL_rule,
  /*  813 */  rax_RegI_rule,
  /*  814 */  rax_RegL_rule,
  /*  815 */  rRegI_rule,
  /*  816 */  rRegI_rule,
  /*  817 */  memory_rule,
  /*  818 */  rRegI_rule,
  /*  819 */  memory_rule,
  /*  820 */  rRegI_rule,
  /*  821 */  _LoadI_memory__rule,
  /*  822 */  rRegI_rule,
  /*  823 */  memory_rule,
  /*  824 */  rRegI_rule,
  /*  825 */  memory_rule,
  /*  826 */  rRegI_rule,
  /*  827 */  _LoadI_memory__rule,
  /*  828 */  rRegI_rule,
  /*  829 */  memory_rule,
  /*  830 */  rRegI_rule,
  /*  831 */  memory_rule,
  /*  832 */  rRegI_rule,
  /*  833 */  _LoadI_memory__rule,
  /*  834 */  rRegL_rule,
  /*  835 */  rRegL_rule,
  /*  836 */  memory_rule,
  /*  837 */  rRegL_rule,
  /*  838 */  memory_rule,
  /*  839 */  rRegL_rule,
  /*  840 */  _LoadL_memory__rule,
  /*  841 */  rRegL_rule,
  /*  842 */  memory_rule,
  /*  843 */  rRegL_rule,
  /*  844 */  memory_rule,
  /*  845 */  rRegL_rule,
  /*  846 */  _LoadL_memory__rule,
  /*  847 */  rRegL_rule,
  /*  848 */  memory_rule,
  /*  849 */  rRegL_rule,
  /*  850 */  memory_rule,
  /*  851 */  rRegL_rule,
  /*  852 */  _LoadL_memory__rule,
  /*  853 */  _LShiftI_rRegI_immI_24_rule,
  /*  854 */  _LShiftI_rRegI_immI_16_rule,
  /*  855 */  rRegI_rule,
  /*  856 */  rRegI_rule,
  /*  857 */  _LoadI_memory__rule,
  /*  858 */  rRegI_rule,
  /*  859 */  rRegI_rule,
  /*  860 */  rRegI_rule,
  /*  861 */  _LoadI_memory__rule,
  /*  862 */  rRegI_rule,
  /*  863 */  rRegL_rule,
  /*  864 */  rRegL_rule,
  /*  865 */  _LoadL_memory__rule,
  /*  866 */  rRegL_rule,
  /*  867 */  rRegL_rule,
  /*  868 */  rRegL_rule,
  /*  869 */  _LoadL_memory__rule,
  /*  870 */  rRegL_rule,
  /*  871 */  rRegL_rule,
  /*  872 */  rRegL_rule,
  /*  873 */  rRegL_rule,
  /*  874 */  rRegL_rule,
  /*  875 */  rRegI_rule,
  /*  876 */  rRegI_rule,
  /*  877 */  _AndI_rRegI_immI_255_rule,
  /*  878 */  rRegI_rule,
  /*  879 */  _AndI_rRegI_immI_65535_rule,
  /*  880 */  _AndI_rRegI_immI_Pow2M1_rule,
  /*  881 */  rRegI_rule,
  /*  882 */  rRegI_rule,
  /*  883 */  _LoadI_memory__rule,
  /*  884 */  memory_rule,
  /*  885 */  memory_rule,
  /*  886 */  memory_rule,
  /*  887 */  memory_rule,
  /*  888 */  memory_rule,
  /*  889 */  _XorI_rRegI_immI_M1_rule,
  /*  890 */  _LoadI_memory__rule,
  /*  891 */  _XorI_rRegI_immI_M1_rule,
  /*  892 */  rRegI_rule,
  /*  893 */  _SubI_immI_0_rRegI_rule,
  /*  894 */  rRegI_rule,
  /*  895 */  _SubI_immI_0__LoadI_memory__rule,
  /*  896 */  _LoadI_memory__rule,
  /*  897 */  _AddI__LoadI_memory__immI_M1_rule,
  /*  898 */  _LoadI_memory__rule,
  /*  899 */  _AddI_rRegI_immI_M1_rule,
  /*  900 */  rRegI_rule,
  /*  901 */  _AddI_rRegI_immI_M1_rule,
  /*  902 */  rRegI_rule,
  /*  903 */  _AddI__LoadI_memory__immI_M1_rule,
  /*  904 */  _LoadI_memory__rule,
  /*  905 */  rRegI_rule,
  /*  906 */  rRegI_rule,
  /*  907 */  rRegI_rule,
  /*  908 */  _LoadI_memory__rule,
  /*  909 */  memory_rule,
  /*  910 */  memory_rule,
  /*  911 */  memory_rule,
  /*  912 */  memory_rule,
  /*  913 */  memory_rule,
  /*  914 */  rRegI_rule,
  /*  915 */  rRegI_rule,
  /*  916 */  rRegI_rule,
  /*  917 */  rRegI_rule,
  /*  918 */  _LoadI_memory__rule,
  /*  919 */  memory_rule,
  /*  920 */  memory_rule,
  /*  921 */  memory_rule,
  /*  922 */  memory_rule,
  /*  923 */  memory_rule,
  /*  924 */  rRegL_rule,
  /*  925 */  rRegL_rule,
  /*  926 */  rRegL_rule,
  /*  927 */  rRegL_rule,
  /*  928 */  rRegL_rule,
  /*  929 */  _LoadL_memory__rule,
  /*  930 */  memory_rule,
  /*  931 */  memory_rule,
  /*  932 */  memory_rule,
  /*  933 */  memory_rule,
  /*  934 */  _XorL_rRegL_immL_M1_rule,
  /*  935 */  _LoadL_memory__rule,
  /*  936 */  _XorL_rRegL_immL_M1_rule,
  /*  937 */  rRegL_rule,
  /*  938 */  _SubL_immL0_rRegL_rule,
  /*  939 */  rRegL_rule,
  /*  940 */  _SubL_immL0__LoadL_memory__rule,
  /*  941 */  _LoadL_memory__rule,
  /*  942 */  _AddL__LoadL_memory__immL_M1_rule,
  /*  943 */  _LoadL_memory__rule,
  /*  944 */  _AddL_rRegL_immL_M1_rule,
  /*  945 */  rRegL_rule,
  /*  946 */  _AddL_rRegL_immL_M1_rule,
  /*  947 */  rRegL_rule,
  /*  948 */  _AddL__LoadL_memory__immL_M1_rule,
  /*  949 */  _LoadL_memory__rule,
  /*  950 */  rRegL_rule,
  /*  951 */  rRegL_rule,
  /*  952 */  _CastP2X_any_RegP__rule,
  /*  953 */  rRegL_rule,
  /*  954 */  rRegL_rule,
  /*  955 */  _LoadL_memory__rule,
  /*  956 */  memory_rule,
  /*  957 */  memory_rule,
  /*  958 */  memory_rule,
  /*  959 */  memory_rule,
  /*  960 */  rRegL_rule,
  /*  961 */  rRegL_rule,
  /*  962 */  rRegL_rule,
  /*  963 */  rRegL_rule,
  /*  964 */  _LoadL_memory__rule,
  /*  965 */  memory_rule,
  /*  966 */  memory_rule,
  /*  967 */  memory_rule,
  /*  968 */  rRegI_rule,
  /*  969 */  rRegI_rule,
  /*  970 */  _AndI__CmpLTMask_rRegI_rRegI_rRegI_rule,
  /*  971 */  _SubI_rRegI_rRegI_rule,
  /*  972 */  _AndI_rRegI__CmpLTMask_rRegI_rRegI_rule,
  /*  973 */  _SubI_rRegI_rRegI_rule,
  /*  974 */  _CmpLTMask_rRegI_rRegI_rule,
  /*  975 */  rRegI_rule,
  /*  976 */  regF_rule,
  /*  977 */  regF_rule,
  /*  978 */  regF_rule,
  /*  979 */  regD_rule,
  /*  980 */  regD_rule,
  /*  981 */  regD_rule,
  /*  982 */  regF_rule,
  /*  983 */  _LoadF_memory__rule,
  /*  984 */  regD_rule,
  /*  985 */  _LoadD_memory__rule,
  /*  986 */  regF_rule,
  /*  987 */  regF_rule,
  /*  988 */  regD_rule,
  /*  989 */  regD_rule,
  /*  990 */  regD_rule,
  /*  991 */  regF_rule,
  /*  992 */  rRegI_rule,
  /*  993 */  _LoadI_memory__rule,
  /*  994 */  rRegI_rule,
  /*  995 */  _LoadI_memory__rule,
  /*  996 */  rRegI_rule,
  /*  997 */  rRegI_rule,
  /*  998 */  rRegL_rule,
  /*  999 */  _LoadL_memory__rule,
  /* 1000 */  rRegL_rule,
  /* 1001 */  _LoadL_memory__rule,
  /* 1002 */  rRegI_rule,
  /* 1003 */  _ConvI2L_rRegI__rule,
  /* 1004 */  _ConvI2L__LoadI_memory___rule,
  /* 1005 */  rRegL_rule,
  /* 1006 */  rRegL_rule,
  /* 1007 */  regF_rule,
  /* 1008 */  rRegI_rule,
  /* 1009 */  regD_rule,
  /* 1010 */  rRegL_rule,
  /* 1011 */  rcx_RegL_rule,
  /* 1012 */  rcx_RegL_rule,
  /* 1013 */  rcx_RegL_rule,
  /* 1014 */  rcx_RegL_rule,
  /* 1015 */  immL_rule,
  /* 1016 */  _Binary_rdi_RegP_rcx_RegI_rule,
  /* 1017 */  _Binary_rdi_RegP_rcx_RegI_rule,
  /* 1018 */  _Binary_rdi_RegP_rcx_RegI_rule,
  /* 1019 */  _Binary_rdi_RegP_rcx_RegI_rule,
  /* 1020 */  _Binary_rdi_RegP_rcx_RegI_rule,
  /* 1021 */  _Binary_rdi_RegP_rcx_RegI_rule,
  /* 1022 */  _Binary_rsi_RegP_rdx_RegI_rule,
  /* 1023 */  _Binary_rsi_RegP_rdx_RegI_rule,
  /* 1024 */  _Binary_rdi_RegP_rdx_RegI_rule,
  /* 1025 */  _Binary_rdi_RegP_rdx_RegI_rule,
  /* 1026 */  _Binary_rdi_RegP_rdx_RegI_rule,
  /* 1027 */  _Binary_rdi_RegP_rdx_RegI_rule,
  /* 1028 */  _Binary_rdi_RegP_rdx_RegI_rule,
  /* 1029 */  _Binary_rdi_RegP_rdx_RegI_rule,
  /* 1030 */  _Binary_rdi_RegP_rdx_RegI_rule,
  /* 1031 */  _Binary_rdi_RegP_rdx_RegI_rule,
  /* 1032 */  _Binary_rdi_RegP_rsi_RegP_rule,
  /* 1033 */  _Binary_rdi_RegP_rsi_RegP_rule,
  /* 1034 */  rdi_RegP_rule,
  /* 1035 */  rdi_RegP_rule,
  /* 1036 */  rdi_RegP_rule,
  /* 1037 */  rdi_RegP_rule,
  /* 1038 */  _Binary_rdi_RegP_rdx_RegI_rule,
  /* 1039 */  rsi_RegP_rule,
  /* 1040 */  rsi_RegP_rule,
  /* 1041 */  rsi_RegP_rule,
  /* 1042 */  rsi_RegP_rule,
  /* 1043 */  rsi_RegP_rule,
  /* 1044 */  rsi_RegP_rule,
  /* 1045 */  rsi_RegP_rule,
  /* 1046 */  rsi_RegP_rule,
  /* 1047 */  rRegI_rule,
  /* 1048 */  rRegL_rule,
  /* 1049 */  rRegL_rule,
  /* 1050 */  0,
  /* 1051 */  rRegI_rule,
  /* 1052 */  0,
  /* 1053 */  rRegI_rule,
  /* 1054 */  0,
  /* 1055 */  cmpOp_rule,
  /* 1056 */  cmpOp_rule,
  /* 1057 */  cmpOpU_rule,
  /* 1058 */  cmpOpUCF_rule,
  /* 1059 */  cmpOpUCF2_rule,
  /* 1060 */  rsi_RegP_rule,
  /* 1061 */  rsi_RegP_rule,
  /* 1062 */  rsi_RegP_rule,
  /* 1063 */  0,
  /* 1064 */  cmpOp_rule,
  /* 1065 */  cmpOp_rule,
  /* 1066 */  cmpOpU_rule,
  /* 1067 */  cmpOpUCF_rule,
  /* 1068 */  cmpOpUCF2_rule,
  /* 1069 */  rRegP_rule,
  /* 1070 */  rRegL_rule,
  /* 1071 */  rRegI_rule,
  /* 1072 */  0,
  /* 1073 */  0,
  /* 1074 */  0,
  /* 1075 */  0,
  /* 1076 */  0,
  /* 1077 */  0,
  /* 1078 */  0,
  /* 1079 */  no_rbp_RegP_rule,
  /* 1080 */  no_rbp_RegP_rule,
  /* 1081 */  0,
  /* 1082 */  0,
  /* 1083 */  0,
  /* 1084 */  rRegI_rule,
  /* 1085 */  rRegI_rule,
  /* 1086 */  rRegI_rule,
  /* 1087 */  rRegL_rule,
  /* 1088 */  rRegL_rule,
  /* 1089 */  rRegL_rule,
  /* 1090 */  0,
  /* 1091 */  regF_rule,
  /* 1092 */  regF_rule,
  /* 1093 */  _LoadF_memory__rule,
  /* 1094 */  regF_rule,
  /* 1095 */  regF_rule,
  /* 1096 */  regF_rule,
  /* 1097 */  _LoadF_memory__rule,
  /* 1098 */  regF_rule,
  /* 1099 */  regD_rule,
  /* 1100 */  regD_rule,
  /* 1101 */  _LoadD_memory__rule,
  /* 1102 */  regD_rule,
  /* 1103 */  regD_rule,
  /* 1104 */  regD_rule,
  /* 1105 */  _LoadD_memory__rule,
  /* 1106 */  regD_rule,
  /* 1107 */  regF_rule,
  /* 1108 */  regF_rule,
  /* 1109 */  regF_rule,
  /* 1110 */  regF_rule,
  /* 1111 */  regF_rule,
  /* 1112 */  regF_rule,
  /* 1113 */  regD_rule,
  /* 1114 */  regD_rule,
  /* 1115 */  regD_rule,
  /* 1116 */  regD_rule,
  /* 1117 */  regD_rule,
  /* 1118 */  regD_rule,
  /* 1119 */  regF_rule,
  /* 1120 */  regF_rule,
  /* 1121 */  _LoadF_memory__rule,
  /* 1122 */  regF_rule,
  /* 1123 */  regF_rule,
  /* 1124 */  regF_rule,
  /* 1125 */  _LoadF_memory__rule,
  /* 1126 */  regF_rule,
  /* 1127 */  regD_rule,
  /* 1128 */  regD_rule,
  /* 1129 */  _LoadD_memory__rule,
  /* 1130 */  regD_rule,
  /* 1131 */  regD_rule,
  /* 1132 */  regD_rule,
  /* 1133 */  _LoadD_memory__rule,
  /* 1134 */  regD_rule,
  /* 1135 */  regF_rule,
  /* 1136 */  regF_rule,
  /* 1137 */  regF_rule,
  /* 1138 */  regF_rule,
  /* 1139 */  regF_rule,
  /* 1140 */  regF_rule,
  /* 1141 */  regD_rule,
  /* 1142 */  regD_rule,
  /* 1143 */  regD_rule,
  /* 1144 */  regD_rule,
  /* 1145 */  regD_rule,
  /* 1146 */  regD_rule,
  /* 1147 */  regF_rule,
  /* 1148 */  regD_rule,
  /* 1149 */  vlRegF_rule,
  /* 1150 */  memory_rule,
  /* 1151 */  memory_rule,
  /* 1152 */  kReg_rule,
  /* 1153 */  kReg_rule,
  /* 1154 */  kReg_rule,
  /* 1155 */  vec_rule,
  /* 1156 */  legRegD_rule,
  /* 1157 */  immD_rule,
  /* 1158 */  legVec_rule,
  /* 1159 */  vec_rule,
  /* 1160 */  _LoadVector_memory__rule,
  /* 1161 */  _LoadVector_memory__rule,
  /* 1162 */  0,
  /* 1163 */  regD_rule,
  /* 1164 */  regF_rule,
  /* 1165 */  memory_rule,
  /* 1166 */  memory_rule,
  /* 1167 */  memory_rule,
  /* 1168 */  memory_rule,
  /* 1169 */  memory_rule,
  /* 1170 */  memory_rule,
  /* 1171 */  memory_rule,
  /* 1172 */  memory_rule,
  /* 1173 */  memory_rule,
  /* 1174 */  memory_rule,
  /* 1175 */  memory_rule,
  /* 1176 */  memory_rule,
  /* 1177 */  memory_rule,
  /* 1178 */  memory_rule,
  /* 1179 */  memory_rule,
  /* 1180 */  memory_rule,
  /* 1181 */  memory_rule,
  /* 1182 */  memory_rule,
  /* 1183 */  memory_rule,
  /* 1184 */  _Binary_vec_rRegI_rule,
  /* 1185 */  _Binary_vec_rRegI_rule,
  /* 1186 */  _Binary_vec_rRegI_rule,
  /* 1187 */  _Binary_vec_rRegL_rule,
  /* 1188 */  _Binary_vec_rRegL_rule,
  /* 1189 */  _Binary_vec_rRegL_rule,
  /* 1190 */  _Binary_vec_regF_rule,
  /* 1191 */  _Binary_vec_regF_rule,
  /* 1192 */  _Binary_vec_regD_rule,
  /* 1193 */  _Binary_vec_regD_rule,
  /* 1194 */  _Binary_vec_regD_rule,
  /* 1195 */  rRegI_rule,
  /* 1196 */  rRegI_rule,
  /* 1197 */  rRegI_rule,
  /* 1198 */  rRegI_rule,
  /* 1199 */  rRegI_rule,
  /* 1200 */  rRegI_rule,
  /* 1201 */  rRegI_rule,
  /* 1202 */  rRegL_rule,
  /* 1203 */  rRegL_rule,
  /* 1204 */  rRegL_rule,
  /* 1205 */  rRegL_rule,
  /* 1206 */  rRegL_rule,
  /* 1207 */  rRegL_rule,
  /* 1208 */  rRegL_rule,
  /* 1209 */  rRegL_rule,
  /* 1210 */  rRegL_rule,
  /* 1211 */  rRegL_rule,
  /* 1212 */  rRegL_rule,
  /* 1213 */  rRegL_rule,
  /* 1214 */  rRegL_rule,
  /* 1215 */  rRegL_rule,
  /* 1216 */  regF_rule,
  /* 1217 */  regF_rule,
  /* 1218 */  regF_rule,
  /* 1219 */  regF_rule,
  /* 1220 */  regF_rule,
  /* 1221 */  regF_rule,
  /* 1222 */  regF_rule,
  /* 1223 */  regF_rule,
  /* 1224 */  regF_rule,
  /* 1225 */  regF_rule,
  /* 1226 */  regF_rule,
  /* 1227 */  regF_rule,
  /* 1228 */  regF_rule,
  /* 1229 */  regF_rule,
  /* 1230 */  regD_rule,
  /* 1231 */  regD_rule,
  /* 1232 */  regD_rule,
  /* 1233 */  regD_rule,
  /* 1234 */  regD_rule,
  /* 1235 */  regD_rule,
  /* 1236 */  regD_rule,
  /* 1237 */  regD_rule,
  /* 1238 */  regD_rule,
  /* 1239 */  regD_rule,
  /* 1240 */  regD_rule,
  /* 1241 */  regD_rule,
  /* 1242 */  rRegI_rule,
  /* 1243 */  rRegI_rule,
  /* 1244 */  rRegI_rule,
  /* 1245 */  rRegI_rule,
  /* 1246 */  rRegI_rule,
  /* 1247 */  rRegI_rule,
  /* 1248 */  rRegI_rule,
  /* 1249 */  rRegI_rule,
  /* 1250 */  rRegI_rule,
  /* 1251 */  rRegI_rule,
  /* 1252 */  rRegI_rule,
  /* 1253 */  rRegI_rule,
  /* 1254 */  rRegI_rule,
  /* 1255 */  rRegI_rule,
  /* 1256 */  rRegI_rule,
  /* 1257 */  rRegI_rule,
  /* 1258 */  rRegI_rule,
  /* 1259 */  rRegI_rule,
  /* 1260 */  rRegI_rule,
  /* 1261 */  rRegI_rule,
  /* 1262 */  rRegI_rule,
  /* 1263 */  immF_rule,
  /* 1264 */  immF_rule,
  /* 1265 */  immF_rule,
  /* 1266 */  immF_rule,
  /* 1267 */  legRegF_rule,
  /* 1268 */  legRegF_rule,
  /* 1269 */  legRegF_rule,
  /* 1270 */  legRegF_rule,
  /* 1271 */  immD_rule,
  /* 1272 */  immD_rule,
  /* 1273 */  immD_rule,
  /* 1274 */  immD_rule,
  /* 1275 */  legRegD_rule,
  /* 1276 */  legRegD_rule,
  /* 1277 */  legRegD_rule,
  /* 1278 */  legRegD_rule,
  /* 1279 */  vec_rule,
  /* 1280 */  vec_rule,
  /* 1281 */  vec_rule,
  /* 1282 */  _LoadVector_memory__rule,
  /* 1283 */  vec_rule,
  /* 1284 */  vec_rule,
  /* 1285 */  vec_rule,
  /* 1286 */  _LoadVector_memory__rule,
  /* 1287 */  vec_rule,
  /* 1288 */  vec_rule,
  /* 1289 */  vec_rule,
  /* 1290 */  _LoadVector_memory__rule,
  /* 1291 */  vec_rule,
  /* 1292 */  vec_rule,
  /* 1293 */  vec_rule,
  /* 1294 */  _LoadVector_memory__rule,
  /* 1295 */  vec_rule,
  /* 1296 */  vec_rule,
  /* 1297 */  vec_rule,
  /* 1298 */  _LoadVector_memory__rule,
  /* 1299 */  vec_rule,
  /* 1300 */  vec_rule,
  /* 1301 */  vec_rule,
  /* 1302 */  _LoadVector_memory__rule,
  /* 1303 */  vec_rule,
  /* 1304 */  vec_rule,
  /* 1305 */  vec_rule,
  /* 1306 */  vec_rule,
  /* 1307 */  vec_rule,
  /* 1308 */  vec_rule,
  /* 1309 */  vec_rule,
  /* 1310 */  vec_rule,
  /* 1311 */  vec_rule,
  /* 1312 */  vec_rule,
  /* 1313 */  vec_rule,
  /* 1314 */  vec_rule,
  /* 1315 */  vec_rule,
  /* 1316 */  vec_rule,
  /* 1317 */  vec_rule,
  /* 1318 */  vec_rule,
  /* 1319 */  vec_rule,
  /* 1320 */  vec_rule,
  /* 1321 */  vec_rule,
  /* 1322 */  vec_rule,
  /* 1323 */  vec_rule,
  /* 1324 */  vec_rule,
  /* 1325 */  vec_rule,
  /* 1326 */  vec_rule,
  /* 1327 */  _LoadVector_memory__rule,
  /* 1328 */  vec_rule,
  /* 1329 */  vec_rule,
  /* 1330 */  vec_rule,
  /* 1331 */  _LoadVector_memory__rule,
  /* 1332 */  vec_rule,
  /* 1333 */  vec_rule,
  /* 1334 */  _LoadVector_memory__rule,
  /* 1335 */  vec_rule,
  /* 1336 */  vec_rule,
  /* 1337 */  vec_rule,
  /* 1338 */  vec_rule,
  /* 1339 */  vec_rule,
  /* 1340 */  vec_rule,
  /* 1341 */  vec_rule,
  /* 1342 */  _LoadVector_memory__rule,
  /* 1343 */  vec_rule,
  /* 1344 */  vec_rule,
  /* 1345 */  vec_rule,
  /* 1346 */  _LoadVector_memory__rule,
  /* 1347 */  vec_rule,
  /* 1348 */  vec_rule,
  /* 1349 */  vec_rule,
  /* 1350 */  vec_rule,
  /* 1351 */  vec_rule,
  /* 1352 */  vec_rule,
  /* 1353 */  vec_rule,
  /* 1354 */  vec_rule,
  /* 1355 */  vec_rule,
  /* 1356 */  vec_rule,
  /* 1357 */  vec_rule,
  /* 1358 */  vec_rule,
  /* 1359 */  legVec_rule,
  /* 1360 */  legVec_rule,
  /* 1361 */  vec_rule,
  /* 1362 */  vec_rule,
  /* 1363 */  legVec_rule,
  /* 1364 */  legVec_rule,
  /* 1365 */  vec_rule,
  /* 1366 */  vec_rule,
  /* 1367 */  vec_rule,
  /* 1368 */  vec_rule,
  /* 1369 */  vec_rule,
  /* 1370 */  vec_rule,
  /* 1371 */  vec_rule,
  /* 1372 */  vec_rule,
  /* 1373 */  _Binary_vec_vec_rule,
  /* 1374 */  _Binary_vec_vec_rule,
  /* 1375 */  _Binary_vec__LoadVector_memory__rule,
  /* 1376 */  _Binary_vec__LoadVector_memory__rule,
  /* 1377 */  regF_rule,
  /* 1378 */  regD_rule,
  /* 1379 */  vec_rule,
  /* 1380 */  vec_rule,
  /* 1381 */  vec_rule,
  /* 1382 */  vec_rule,
  /* 1383 */  regF_rule,
  /* 1384 */  regD_rule,
  /* 1385 */  rRegI_rule,
  /* 1386 */  rRegI_rule,
  /* 1387 */  rRegI_rule,
  /* 1388 */  rRegI_rule,
  /* 1389 */  vec_rule,
  /* 1390 */  vec_rule,
  /* 1391 */  vec_rule,
  /* 1392 */  vec_rule,
  /* 1393 */  vec_rule,
  /* 1394 */  vec_rule,
  /* 1395 */  vec_rule,
  /* 1396 */  vec_rule,
  /* 1397 */  vec_rule,
  /* 1398 */  vec_rule,
  /* 1399 */  vec_rule,
  /* 1400 */  vec_rule,
  /* 1401 */  vec_rule,
  /* 1402 */  vec_rule,
  /* 1403 */  vec_rule,
  /* 1404 */  vec_rule,
  /* 1405 */  vec_rule,
  /* 1406 */  vec_rule,
  /* 1407 */  vec_rule,
  /* 1408 */  vec_rule,
  /* 1409 */  vec_rule,
  /* 1410 */  vec_rule,
  /* 1411 */  vec_rule,
  /* 1412 */  vec_rule,
  /* 1413 */  vec_rule,
  /* 1414 */  vec_rule,
  /* 1415 */  vec_rule,
  /* 1416 */  vec_rule,
  /* 1417 */  vec_rule,
  /* 1418 */  vec_rule,
  /* 1419 */  vec_rule,
  /* 1420 */  vec_rule,
  /* 1421 */  vec_rule,
  /* 1422 */  vec_rule,
  /* 1423 */  vec_rule,
  /* 1424 */  vec_rule,
  /* 1425 */  vec_rule,
  /* 1426 */  vec_rule,
  /* 1427 */  vec_rule,
  /* 1428 */  vec_rule,
  /* 1429 */  vec_rule,
  /* 1430 */  vec_rule,
  /* 1431 */  vec_rule,
  /* 1432 */  vec_rule,
  /* 1433 */  vec_rule,
  /* 1434 */  vec_rule,
  /* 1435 */  vec_rule,
  /* 1436 */  vec_rule,
  /* 1437 */  vec_rule,
  /* 1438 */  vec_rule,
  /* 1439 */  vec_rule,
  /* 1440 */  vec_rule,
  /* 1441 */  vec_rule,
  /* 1442 */  vec_rule,
  /* 1443 */  vec_rule,
  /* 1444 */  vec_rule,
  /* 1445 */  vec_rule,
  /* 1446 */  vec_rule,
  /* 1447 */  vec_rule,
  /* 1448 */  vec_rule,
  /* 1449 */  vec_rule,
  /* 1450 */  vec_rule,
  /* 1451 */  vec_rule,
  /* 1452 */  vec_rule,
  /* 1453 */  _LoadVector_memory__rule,
  /* 1454 */  vec_rule,
  /* 1455 */  vec_rule,
  /* 1456 */  vec_rule,
  /* 1457 */  _LoadVector_memory__rule,
  /* 1458 */  vec_rule,
  /* 1459 */  vec_rule,
  /* 1460 */  vec_rule,
  /* 1461 */  _LoadVector_memory__rule,
  /* 1462 */  vec_rule,
  /* 1463 */  vec_rule,
  /* 1464 */  vec_rule,
  /* 1465 */  vec_rule,
  /* 1466 */  vec_rule,
  /* 1467 */  vec_rule,
  /* 1468 */  vec_rule,
  /* 1469 */  vec_rule,
  /* 1470 */  vec_rule,
  /* 1471 */  _Binary_legVec_legVec_rule,
  /* 1472 */  _Binary_vec_vec_rule,
  /* 1473 */  _Binary_vec_vec_rule,
  /* 1474 */  _Binary_legVec_legVec_rule,
  /* 1475 */  _Binary_legVec_legVec_rule,
  /* 1476 */  _Binary_legVec_legVec_rule,
  /* 1477 */  _Binary_vec_vec_rule,
  /* 1478 */  _Binary_vec_vec_rule,
  /* 1479 */  legVec_rule,
  /* 1480 */  legVec_rule,
  /* 1481 */  legVec_rule,
  /* 1482 */  legVec_rule,
  /* 1483 */  legVec_rule,
  /* 1484 */  legVec_rule,
  /* 1485 */  legVec_rule,
  /* 1486 */  legVec_rule,
  /* 1487 */  legVec_rule,
  /* 1488 */  legVec_rule,
  /* 1489 */  legVec_rule,
  /* 1490 */  legVec_rule,
  /* 1491 */  _Binary_vec_vec_rule,
  /* 1492 */  _Binary_legVec_legVec_rule,
  /* 1493 */  _Binary_legVec_legVec_rule,
  /* 1494 */  _Binary_legVec_legVec_rule,
  /* 1495 */  _Binary_vec_vec_rule,
  /* 1496 */  _Binary_vec_vec_rule,
  /* 1497 */  legVec_rule,
  /* 1498 */  vec_rule,
  /* 1499 */  vec_rule,
  /* 1500 */  vec_rule,
  /* 1501 */  vec_rule,
  /* 1502 */  vec_rule,
  /* 1503 */  vec_rule,
  /* 1504 */  vec_rule,
  /* 1505 */  vec_rule,
  /* 1506 */  vec_rule,
  /* 1507 */  kReg_rule,
  /* 1508 */  kReg_rule,
  /* 1509 */  rRegI_rule,
  /* 1510 */  rRegL_rule,
  /* 1511 */  vec_rule,
  /* 1512 */  legVec_rule,
  /* 1513 */  vec_rule,
  /* 1514 */  vec_rule,
  /* 1515 */  vec_rule,
  /* 1516 */  vec_rule,
  /* 1517 */  legVec_rule,
  /* 1518 */  vec_rule,
  /* 1519 */  vec_rule,
  /* 1520 */  vec_rule,
  /* 1521 */  vec_rule,
  /* 1522 */  vec_rule,
  /* 1523 */  vec_rule,
  /* 1524 */  vec_rule,
  /* 1525 */  vec_rule,
  /* 1526 */  vec_rule,
  /* 1527 */  vec_rule,
  /* 1528 */  vec_rule,
  /* 1529 */  vec_rule,
  /* 1530 */  vec_rule,
  /* 1531 */  _MulAddVS2VI_vec_vec_rule,
  /* 1532 */  vec_rule,
  /* 1533 */  vec_rule,
  /* 1534 */  vec_rule,
  /* 1535 */  vec_rule,
  /* 1536 */  vec_rule,
  /* 1537 */  vec_rule,
  /* 1538 */  vec_rule,
  /* 1539 */  vec_rule,
  /* 1540 */  vec_rule,
  /* 1541 */  _Binary_vec_vec_rule,
  /* 1542 */  _Binary_vec_vec_rule,
  /* 1543 */  vec_rule,
  /* 1544 */  vec_rule,
  /* 1545 */  vec_rule,
  /* 1546 */  vec_rule,
  /* 1547 */  memory_rule,
  /* 1548 */  memory_rule,
  /* 1549 */  memory_rule,
  /* 1550 */  memory_rule,
  /* 1551 */  rRegP_rule,
  /* 1552 */  vec_rule,
  /* 1553 */  rRegL_rule,
  /* 1554 */  immL_rule,
  /* 1555 */  kReg_rule,
  /* 1556 */  vec_rule,
  /* 1557 */  _VectorStoreMask_vec_immI_rule,
  /* 1558 */  kReg_rule,
  /* 1559 */  vec_rule,
  /* 1560 */  _VectorStoreMask_vec_immI_rule,
  /* 1561 */  kReg_rule,
  /* 1562 */  kReg_rule,
  /* 1563 */  vec_rule,
  /* 1564 */  vec_rule,
  /* 1565 */  _VectorStoreMask_vec_immI_rule,
  /* 1566 */  _VectorStoreMask_vec_immI_rule,
  /* 1567 */  vec_rule,
  /* 1568 */  vec_rule,
  /* 1569 */  vec_rule,
  /* 1570 */  vec_rule,
  /* 1571 */  kReg_rule,
  /* 1572 */  vec_rule,
  /* 1573 */  vec_rule,
  /* 1574 */  vec_rule,
  /* 1575 */  vec_rule,
  /* 1576 */  vec_rule,
  /* 1577 */  vec_rule,
  /* 1578 */  vec_rule,
  /* 1579 */  vec_rule,
  /* 1580 */  vec_rule,
  /* 1581 */  _Binary_vec_vec_rule,
  /* 1582 */  _Binary_vec_vec_rule,
  /* 1583 */  _Binary_vec_vec_rule,
  /* 1584 */  _Binary_vec_vec_rule,
  /* 1585 */  _Binary_vec_vec_rule,
  /* 1586 */  _Binary_vec_vec_rule,
  /* 1587 */  _Binary_vec__LoadVector_memory__rule,
  /* 1588 */  _Binary_vec__LoadVector_memory__rule,
  /* 1589 */  _Binary_vec__LoadVector_memory__rule,
  /* 1590 */  _Binary_vec__LoadVector_memory__rule,
  /* 1591 */  _Binary_vec__LoadVector_memory__rule,
  /* 1592 */  _Binary_vec__LoadVector_memory__rule,
  /* 1593 */  _Binary_vec_vec_rule,
  /* 1594 */  _Binary_vec__LoadVector_memory__rule,
  /* 1595 */  _Binary_vec_vec_rule,
  /* 1596 */  _Binary_vec__LoadVector_memory__rule,
  /* 1597 */  _Binary_vec_vec_rule,
  /* 1598 */  _Binary_vec__LoadVector_memory__rule,
  /* 1599 */  _Binary_vec_vec_rule,
  /* 1600 */  _Binary_vec_vec_rule,
  /* 1601 */  _Binary_vec_vec_rule,
  /* 1602 */  _Binary_vec_vec_rule,
  /* 1603 */  _Binary_vec_vec_rule,
  /* 1604 */  _Binary_vec_vec_rule,
  /* 1605 */  _Binary_vec__LoadVector_memory__rule,
  /* 1606 */  _Binary_vec__LoadVector_memory__rule,
  /* 1607 */  _Binary_vec__LoadVector_memory__rule,
  /* 1608 */  _Binary_vec__LoadVector_memory__rule,
  /* 1609 */  _Binary_vec__LoadVector_memory__rule,
  /* 1610 */  _Binary_vec__LoadVector_memory__rule,
  /* 1611 */  _Binary_vec_vec_rule,
  /* 1612 */  _Binary_vec_vec_rule,
  /* 1613 */  _Binary_vec_vec_rule,
  /* 1614 */  _Binary_vec_vec_rule,
  /* 1615 */  _Binary_vec_vec_rule,
  /* 1616 */  _Binary_vec__LoadVector_memory__rule,
  /* 1617 */  _Binary_vec__LoadVector_memory__rule,
  /* 1618 */  _Binary_vec__LoadVector_memory__rule,
  /* 1619 */  _Binary_vec__LoadVector_memory__rule,
  /* 1620 */  _Binary_vec__LoadVector_memory__rule,
  /* 1621 */  vec_rule,
  /* 1622 */  vec_rule,
  /* 1623 */  _Binary_vec_vec_rule,
  /* 1624 */  _Binary_vec_vec_rule,
  /* 1625 */  _Binary_vec__LoadVector_memory__rule,
  /* 1626 */  _Binary_vec__LoadVector_memory__rule,
  /* 1627 */  _Binary_vec_immI8_rule,
  /* 1628 */  _Binary_vec_immI8_rule,
  /* 1629 */  _Binary_vec_vec_rule,
  /* 1630 */  _Binary_vec_vec_rule,
  /* 1631 */  _Binary_vec__LShiftCntV_immI8__rule,
  /* 1632 */  _Binary_vec__LShiftCntV_immI8__rule,
  /* 1633 */  _Binary_vec__LShiftCntV_immI8__rule,
  /* 1634 */  _Binary_vec_vec_rule,
  /* 1635 */  _Binary_vec_vec_rule,
  /* 1636 */  _Binary_vec_vec_rule,
  /* 1637 */  _Binary_vec_vec_rule,
  /* 1638 */  _Binary_vec_vec_rule,
  /* 1639 */  _Binary_vec_vec_rule,
  /* 1640 */  _Binary_vec__RShiftCntV_immI8__rule,
  /* 1641 */  _Binary_vec__RShiftCntV_immI8__rule,
  /* 1642 */  _Binary_vec__RShiftCntV_immI8__rule,
  /* 1643 */  _Binary_vec_vec_rule,
  /* 1644 */  _Binary_vec_vec_rule,
  /* 1645 */  _Binary_vec_vec_rule,
  /* 1646 */  _Binary_vec_vec_rule,
  /* 1647 */  _Binary_vec_vec_rule,
  /* 1648 */  _Binary_vec_vec_rule,
  /* 1649 */  _Binary_vec__RShiftCntV_immI8__rule,
  /* 1650 */  _Binary_vec__RShiftCntV_immI8__rule,
  /* 1651 */  _Binary_vec__RShiftCntV_immI8__rule,
  /* 1652 */  _Binary_vec_vec_rule,
  /* 1653 */  _Binary_vec_vec_rule,
  /* 1654 */  _Binary_vec_vec_rule,
  /* 1655 */  _Binary_vec_vec_rule,
  /* 1656 */  _Binary_vec_vec_rule,
  /* 1657 */  _Binary_vec_vec_rule,
  /* 1658 */  _Binary_vec_vec_rule,
  /* 1659 */  _Binary_vec__LoadVector_memory__rule,
  /* 1660 */  _Binary_vec_vec_rule,
  /* 1661 */  _Binary_vec__LoadVector_memory__rule,
  /* 1662 */  _Binary_vec_vec_rule,
  /* 1663 */  vec_rule,
  /* 1664 */  vec_rule,
  /* 1665 */  vec_rule,
  /* 1666 */  vec_rule,
  /* 1667 */  _Binary_vec_vec_rule,
  /* 1668 */  _Binary_vec_vec_rule,
  /* 1669 */  _Binary_vec_vec_rule,
  /* 1670 */  _Binary_vec_vec_rule,
  /* 1671 */  _Binary_vec_vec_rule,
  /* 1672 */  rRegI_rule,
  /* 1673 */  kReg_rule,
  /* 1674 */  kReg_rule,
  /* 1675 */  rRegL_rule,
  /* 1676 */  rRegL_rule,
  /* 1677 */  kReg_rule,
  /* 1678 */  kReg_rule,
  /* 1679 */  kReg_rule,
  /* 1680 */  vec_rule,
  /* 1681 */  vec_rule,
  /* 1682 */  regF_rule,
  /* 1683 */  regD_rule,
  /* 1684 */  vec_rule,
  /* 1685 */  vec_rule,
  /* 1686 */  vec_rule,
  /* 1687 */  vec_rule,
  /* 1688 */  vec_rule,
  /* 1689 */  vec_rule,
  /* 1690 */  vec_rule,
  /* 1691 */  vec_rule,
  /* 1692 */  vec_rule,
  /* 1693 */  vec_rule,
  /* 1694 */  vec_rule,
  /* 1695 */  vec_rule,
  /* 1696 */  vec_rule,
  /* 1697 */  vec_rule,
  /* 1698 */  vec_rule,
  /* 1699 */  vec_rule,
  /* 1700 */  _Binary_vec_vec_rule,
  /* 1701 */  _Binary_vec_vec_rule,
  /* 1702 */  _Binary_vec_vec_rule,
  /* 1703 */  _Binary_vec_vec_rule,
  /* 1704 */  _Binary_vec__LoadVector_memory__rule,
  /* 1705 */  _Binary_vec__LoadVector_memory__rule,
  /* 1706 */  _Binary_vec__LoadVector_memory__rule,
  /* 1707 */  _Binary_vec__LoadVector_memory__rule,
  /* 1708 */  _Binary_vec_vec_rule,
  /* 1709 */  memory_rule,
  /* 1710 */  memory_rule,
  /* 1711 */  memory_rule,
  /* 1712 */  memory_rule,
  /* 1713 */  memory_rule,
  /* 1714 */  memory_rule,
  /* 1715 */  memory_rule,
  /* 1716 */  memory_rule,
  /* 1717 */  memory_rule,
  /* 1718 */  indirect_rule,
  /* 1719 */  indirect_rule,
  /* 1720 */  indirect_rule,
  /* 1721 */  indirect_rule,
  /* 1722 */  memory_rule,
  /* 1723 */  memory_rule,
  /* 1724 */  memory_rule,
  /* 1725 */  indirect_rule,
  /* 1726 */  indirect_rule,
  /* 1727 */  indirect_rule,
  /* 1728 */  indirect_rule,
  /* 1729 */  indirect_rule,
  /* 1730 */  indirect_rule,
  /* 1731 */  indirect_rule,
  /* 1732 */  indirect_rule,
  /* 1733 */  memory_rule,
  /* 1734 */  memory_rule,
  // last instruction
  0 // no trailing comma
};

const        int   rightOp[] = {
  /*    0 */  0,
  /*    1 */  0,
  /*    2 */  0,
  /*    3 */  0,
  /*    4 */  0,
  /*    5 */  0,
  /*    6 */  0,
  /*    7 */  0,
  /*    8 */  0,
  /*    9 */  0,
  /*   10 */  0,
  /*   11 */  0,
  /*   12 */  0,
  /*   13 */  0,
  /*   14 */  0,
  /*   15 */  0,
  /*   16 */  0,
  /*   17 */  0,
  /*   18 */  0,
  /*   19 */  0,
  /*   20 */  0,
  /*   21 */  0,
  /*   22 */  0,
  /*   23 */  0,
  /*   24 */  0,
  /*   25 */  0,
  /*   26 */  0,
  /*   27 */  0,
  /*   28 */  0,
  /*   29 */  0,
  /*   30 */  0,
  /*   31 */  0,
  /*   32 */  0,
  /*   33 */  0,
  /*   34 */  0,
  /*   35 */  0,
  /*   36 */  0,
  /*   37 */  0,
  /*   38 */  0,
  /*   39 */  0,
  /*   40 */  0,
  /*   41 */  0,
  /*   42 */  0,
  /*   43 */  0,
  /*   44 */  0,
  /*   45 */  0,
  /*   46 */  0,
  /*   47 */  0,
  /*   48 */  0,
  /*   49 */  0,
  /*   50 */  0,
  /*   51 */  0,
  /*   52 */  0,
  /*   53 */  0,
  /*   54 */  0,
  /*   55 */  0,
  /*   56 */  0,
  /*   57 */  0,
  /*   58 */  0,
  /*   59 */  0,
  /*   60 */  0,
  /*   61 */  0,
  /*   62 */  0,
  /*   63 */  0,
  /*   64 */  0,
  /*   65 */  0,
  /*   66 */  0,
  /*   67 */  0,
  /*   68 */  0,
  /*   69 */  0,
  /*   70 */  0,
  /*   71 */  0,
  /*   72 */  0,
  /*   73 */  0,
  /*   74 */  0,
  /*   75 */  0,
  /*   76 */  0,
  /*   77 */  0,
  /*   78 */  0,
  /*   79 */  0,
  /*   80 */  0,
  /*   81 */  0,
  /*   82 */  0,
  /*   83 */  0,
  /*   84 */  0,
  /*   85 */  immL8_rule,
  /*   86 */  immL32_rule,
  /*   87 */  immL32_rule,
  /*   88 */  rRegL_rule,
  /*   89 */  _LShiftL_rRegL_immI2_rule,
  /*   90 */  _LShiftL__ConvI2L_rRegI__immI2_rule,
  /*   91 */  immL32_rule,
  /*   92 */  immL32_rule,
  /*   93 */  immL32_rule,
  /*   94 */  immL32_rule,
  /*   95 */  0,
  /*   96 */  immL8_rule,
  /*   97 */  immL32_rule,
  /*   98 */  immL32_rule,
  /*   99 */  rRegL_rule,
  /*  100 */  _LShiftL_rRegL_immI2_rule,
  /*  101 */  immL32_rule,
  /*  102 */  immL32_rule,
  /*  103 */  immL32_rule,
  /*  104 */  0,
  /*  105 */  0,
  /*  106 */  0,
  /*  107 */  0,
  /*  108 */  0,
  /*  109 */  0,
  /*  110 */  0,
  /*  111 */  0,
  /*  112 */  0,
  /*  113 */  0,
  /*  114 */  0,
  /*  115 */  0,
  /*  116 */  0,
  /*  117 */  0,
  /*  118 */  0,
  /*  119 */  0,
  /*  120 */  0,
  /*  121 */  0,
  /*  122 */  0,
  /*  123 */  0,
  /*  124 */  0,
  /*  125 */  0,
  /*  126 */  0,
  // last operand
  /*  127 */  0,
  // last operand class
  /*  128 */  rRegL_rule,
  /*  129 */  immI2_rule,
  /*  130 */  0,
  /*  131 */  immI2_rule,
  /*  132 */  _LShiftL_rRegL_immI2_rule,
  /*  133 */  _ConvI2L_rRegI__rule,
  /*  134 */  _LShiftL__ConvI2L_rRegI__immI2_rule,
  /*  135 */  0,
  /*  136 */  rRegL_rule,
  /*  137 */  _LShiftL_rRegL_immI2_rule,
  /*  138 */  _ConvI2L_rRegI__rule,
  /*  139 */  _LShiftL__ConvI2L_rRegI__immI2_rule,
  /*  140 */  0,
  /*  141 */  0,
  /*  142 */  immI_rule,
  /*  143 */  0,
  /*  144 */  immI_24_rule,
  /*  145 */  0,
  /*  146 */  immI_24_rule,
  /*  147 */  immI_255_rule,
  /*  148 */  immI_rule,
  /*  149 */  0,
  /*  150 */  immI_24_rule,
  /*  151 */  immI_16_rule,
  /*  152 */  immI_255_rule,
  /*  153 */  immI_65535_rule,
  /*  154 */  immU31_rule,
  /*  155 */  0,
  /*  156 */  0,
  /*  157 */  0,
  /*  158 */  0,
  /*  159 */  immL32_rule,
  /*  160 */  rFlagsReg_rule,
  /*  161 */  rRegI_rule,
  /*  162 */  rRegI_rule,
  /*  163 */  rFlagsRegU_rule,
  /*  164 */  rFlagsRegUCF_rule,
  /*  165 */  rFlagsRegUCF_rule,
  /*  166 */  _LoadI_memory__rule,
  /*  167 */  rRegN_rule,
  /*  168 */  rRegP_rule,
  /*  169 */  rRegL_rule,
  /*  170 */  rRegL_rule,
  /*  171 */  _LoadL_memory__rule,
  /*  172 */  regF_rule,
  /*  173 */  regD_rule,
  /*  174 */  rRegI_rule,
  /*  175 */  _LoadI_memory__rule,
  /*  176 */  immI_rule,
  /*  177 */  immI_1_rule,
  /*  178 */  immI_M1_rule,
  /*  179 */  immI2_rule,
  /*  180 */  rRegI_rule,
  /*  181 */  _LShiftI_rRegI_immI2_rule,
  /*  182 */  rRegI_rule,
  /*  183 */  rRegL_rule,
  /*  184 */  _LoadL_memory__rule,
  /*  185 */  immL32_rule,
  /*  186 */  immL1_rule,
  /*  187 */  immL_M1_rule,
  /*  188 */  rRegL_rule,
  /*  189 */  _LShiftL_rRegL_immI2_rule,
  /*  190 */  rRegL_rule,
  /*  191 */  rRegP_rule,
  /*  192 */  rRegL_rule,
  /*  193 */  rRegI_rule,
  /*  194 */  rRegN_rule,
  /*  195 */  rRegI_rule,
  /*  196 */  rRegL_rule,
  /*  197 */  rRegI_rule,
  /*  198 */  _LoadI_memory__rule,
  /*  199 */  _LoadL_memory__rule,
  /*  200 */  immI8_rule,
  /*  201 */  rcx_RegI_rule,
  /*  202 */  immI8_rule,
  /*  203 */  rcx_RegI_rule,
  /*  204 */  immI8_rule,
  /*  205 */  rcx_RegI_rule,
  /*  206 */  immI8_rule,
  /*  207 */  rcx_RegI_rule,
  /*  208 */  immI_rule,
  /*  209 */  rcx_RegI_rule,
  /*  210 */  immI8_rule,
  /*  211 */  rcx_RegI_rule,
  /*  212 */  immI_24_rule,
  /*  213 */  immI_16_rule,
  /*  214 */  immI_255_rule,
  /*  215 */  immI_65535_rule,
  /*  216 */  immI_Pow2M1_rule,
  /*  217 */  rRegI_rule,
  /*  218 */  _LoadB_memory__rule,
  /*  219 */  rRegI_rule,
  /*  220 */  _LoadI_memory__rule,
  /*  221 */  immI_rule,
  /*  222 */  immI_M1_rule,
  /*  223 */  immI_M1_rule,
  /*  224 */  rRegI_rule,
  /*  225 */  _LoadB_memory__rule,
  /*  226 */  rRegI_rule,
  /*  227 */  _LoadI_memory__rule,
  /*  228 */  immI_rule,
  /*  229 */  rRegI_rule,
  /*  230 */  _LoadB_memory__rule,
  /*  231 */  rRegI_rule,
  /*  232 */  _LoadI_memory__rule,
  /*  233 */  immI_rule,
  /*  234 */  rRegL_rule,
  /*  235 */  _LoadL_memory__rule,
  /*  236 */  immL32_rule,
  /*  237 */  immL_NotPow2_rule,
  /*  238 */  immL_M1_rule,
  /*  239 */  rRegL_rule,
  /*  240 */  immL_M1_rule,
  /*  241 */  0,
  /*  242 */  rRegL_rule,
  /*  243 */  _LoadL_memory__rule,
  /*  244 */  immL32_rule,
  /*  245 */  immL_Pow2_rule,
  /*  246 */  rRegL_rule,
  /*  247 */  _LoadL_memory__rule,
  /*  248 */  immL32_rule,
  /*  249 */  rRegI_rule,
  /*  250 */  rRegI_rule,
  /*  251 */  rRegI_rule,
  /*  252 */  _CmpLTMask_rRegI_rRegI_rule,
  /*  253 */  0,
  /*  254 */  0,
  /*  255 */  rcx_RegI_rule,
  /*  256 */  rdx_RegI_rule,
  /*  257 */  rdx_RegI_rule,
  /*  258 */  immI_rule,
  /*  259 */  rax_RegI_rule,
  /*  260 */  rsi_RegP_rule,
  /*  261 */  immU8_rule,
  /*  262 */  immI_rule,
  /*  263 */  rRegI_rule,
  /*  264 */  0,
  /*  265 */  0,
  /*  266 */  0,
  /*  267 */  immL32_rule,
  /*  268 */  rRegL_rule,
  /*  269 */  _LoadL_memory__rule,
  /*  270 */  _CastP2X_rRegP__rule,
  /*  271 */  immU7_rule,
  /*  272 */  immI8_rule,
  /*  273 */  immP_rule,
  /*  274 */  0,
  /*  275 */  0,
  /*  276 */  0,
  /*  277 */  kReg_rule,
  /*  278 */  immI_0_rule,
  /*  279 */  rRegI_rule,
  /*  280 */  immI_0_rule,
  /*  281 */  _Binary_kReg_immI_0_rule,
  /*  282 */  rRegI_rule,
  /*  283 */  _Binary_kReg_rRegI_rule,
  /*  284 */  immI_0_rule,
  /*  285 */  _Binary_vec_immI_0_rule,
  /*  286 */  rRegI_rule,
  /*  287 */  _Binary_vec_rRegI_rule,
  /*  288 */  vec_rule,
  /*  289 */  _Binary_vec_kReg_rule,
  /*  290 */  rRegL_rule,
  /*  291 */  regF_rule,
  /*  292 */  regD_rule,
  /*  293 */  _LoadVector_memory__rule,
  /*  294 */  immD_rule,
  /*  295 */  0,
  /*  296 */  0,
  /*  297 */  legVec_rule,
  /*  298 */  vec_rule,
  /*  299 */  immU8_rule,
  /*  300 */  immU8_rule,
  /*  301 */  immI_rule,
  /*  302 */  immI8_rule,
  /*  303 */  _LShiftCntV_immI8__rule,
  /*  304 */  _RShiftCntV_immI8__rule,
  /*  305 */  kReg_rule,
  /*  306 */  kReg_rule,
  /*  307 */  0,
  /*  308 */  kReg_rule,
  /*  309 */  _Binary_immU8_kReg_rule,
  /*  310 */  _Binary_vec__Binary_immU8_kReg_rule,
  /*  311 */  _Binary_immU8_kReg_rule,
  /*  312 */  _Binary_memory__Binary_immU8_kReg_rule,
  /*  313 */  no_rax_RegP_rule,
  /*  314 */  0,
  // last internally defined operand
  /*  315 */  0,
  /*  316 */  0,
  /*  317 */  0,
  /*  318 */  0,
  /*  319 */  0,
  /*  320 */  0,
  /*  321 */  0,
  /*  322 */  0,
  /*  323 */  0,
  /*  324 */  0,
  /*  325 */  0,
  /*  326 */  0,
  /*  327 */  0,
  /*  328 */  0,
  /*  329 */  0,
  /*  330 */  0,
  /*  331 */  0,
  /*  332 */  0,
  /*  333 */  0,
  /*  334 */  0,
  /*  335 */  0,
  /*  336 */  0,
  /*  337 */  0,
  /*  338 */  0,
  /*  339 */  0,
  /*  340 */  0,
  /*  341 */  0,
  /*  342 */  0,
  /*  343 */  0,
  /*  344 */  0,
  /*  345 */  0,
  /*  346 */  0,
  /*  347 */  0,
  /*  348 */  0,
  /*  349 */  0,
  /*  350 */  0,
  /*  351 */  0,
  /*  352 */  0,
  /*  353 */  0,
  /*  354 */  0,
  /*  355 */  0,
  /*  356 */  0,
  /*  357 */  0,
  /*  358 */  0,
  /*  359 */  0,
  /*  360 */  0,
  /*  361 */  0,
  /*  362 */  0,
  /*  363 */  0,
  /*  364 */  0,
  /*  365 */  0,
  /*  366 */  0,
  /*  367 */  0,
  /*  368 */  0,
  /*  369 */  0,
  /*  370 */  0,
  /*  371 */  0,
  /*  372 */  0,
  /*  373 */  0,
  /*  374 */  0,
  /*  375 */  0,
  /*  376 */  regF_rule,
  /*  377 */  regF_rule,
  /*  378 */  _LoadF_memory__rule,
  /*  379 */  immF_rule,
  /*  380 */  regD_rule,
  /*  381 */  regD_rule,
  /*  382 */  _LoadD_memory__rule,
  /*  383 */  immD_rule,
  /*  384 */  0,
  /*  385 */  0,
  /*  386 */  0,
  /*  387 */  0,
  /*  388 */  0,
  /*  389 */  0,
  /*  390 */  0,
  /*  391 */  0,
  /*  392 */  0,
  /*  393 */  rRegI_rule,
  /*  394 */  immI_rule,
  /*  395 */  rRegL_rule,
  /*  396 */  immL32_rule,
  /*  397 */  rRegI_rule,
  /*  398 */  immI_rule,
  /*  399 */  rRegL_rule,
  /*  400 */  immL32_rule,
  /*  401 */  rax_RegI_rule,
  /*  402 */  rax_RegL_rule,
  /*  403 */  rRegI_rule,
  /*  404 */  immI_rule,
  /*  405 */  rRegL_rule,
  /*  406 */  immL32_rule,
  /*  407 */  rRegI_rule,
  /*  408 */  immI_rule,
  /*  409 */  _LoadI_memory__rule,
  /*  410 */  immI_0_rule,
  /*  411 */  immI_0_rule,
  /*  412 */  immI_0_rule,
  /*  413 */  immI_0_rule,
  /*  414 */  immI_0_rule,
  /*  415 */  rRegI_rule,
  /*  416 */  immI_rule,
  /*  417 */  _LoadI_memory__rule,
  /*  418 */  immI_0_rule,
  /*  419 */  rRegP_rule,
  /*  420 */  _LoadP_memory__rule,
  /*  421 */  _LoadP_memory__rule,
  /*  422 */  immP0_rule,
  /*  423 */  immP0_rule,
  /*  424 */  immP0_rule,
  /*  425 */  rRegN_rule,
  /*  426 */  _LoadN_memory__rule,
  /*  427 */  immN_rule,
  /*  428 */  _LoadN_memory__rule,
  /*  429 */  immNKlass_rule,
  /*  430 */  _LoadNKlass_memory__rule,
  /*  431 */  immN0_rule,
  /*  432 */  immN0_rule,
  /*  433 */  immN0_rule,
  /*  434 */  rRegL_rule,
  /*  435 */  immL32_rule,
  /*  436 */  _LoadL_memory__rule,
  /*  437 */  immL0_rule,
  /*  438 */  immL0_rule,
  /*  439 */  immL0_rule,
  /*  440 */  immL0_rule,
  /*  441 */  immL0_rule,
  /*  442 */  immL0_rule,
  /*  443 */  immL0_rule,
  /*  444 */  rRegL_rule,
  /*  445 */  immL32_rule,
  /*  446 */  _LoadL_memory__rule,
  /*  447 */  immL0_rule,
  /*  448 */  immI8_rule,
  /*  449 */  immI_0_rule,
  /*  450 */  immI_0_rule,
  /*  451 */  rbx_RegP_rule,
  /*  452 */  rax_RegP_rule,
  /*  453 */  rbx_RegP_rule,
  /*  454 */  rax_RegP_rule,
  /*  455 */  0,
  /*  456 */  0,
  /*  457 */  0,
  /*  458 */  0,
  /*  459 */  0,
  /*  460 */  0,
  /*  461 */  0,
  /*  462 */  0,
  /*  463 */  0,
  /*  464 */  0,
  /*  465 */  0,
  /*  466 */  0,
  /*  467 */  0,
  /*  468 */  0,
  /*  469 */  0,
  /*  470 */  0,
  /*  471 */  0,
  /*  472 */  0,
  /*  473 */  0,
  /*  474 */  0,
  /*  475 */  0,
  /*  476 */  0,
  /*  477 */  0,
  /*  478 */  0,
  /*  479 */  0,
  /*  480 */  0,
  /*  481 */  0,
  /*  482 */  0,
  /*  483 */  0,
  /*  484 */  0,
  /*  485 */  0,
  /*  486 */  0,
  /*  487 */  0,
  /*  488 */  0,
  /*  489 */  0,
  /*  490 */  0,
  /*  491 */  0,
  /*  492 */  0,
  /*  493 */  0,
  /*  494 */  0,
  /*  495 */  0,
  /*  496 */  0,
  /*  497 */  0,
  /*  498 */  0,
  /*  499 */  0,
  /*  500 */  0,
  /*  501 */  0,
  /*  502 */  0,
  /*  503 */  0,
  /*  504 */  0,
  /*  505 */  0,
  /*  506 */  0,
  /*  507 */  0,
  /*  508 */  0,
  /*  509 */  0,
  /*  510 */  0,
  /*  511 */  0,
  /*  512 */  0,
  /*  513 */  0,
  /*  514 */  0,
  /*  515 */  0,
  /*  516 */  0,
  /*  517 */  0,
  /*  518 */  0,
  /*  519 */  0,
  /*  520 */  0,
  /*  521 */  0,
  /*  522 */  0,
  /*  523 */  0,
  /*  524 */  0,
  /*  525 */  0,
  /*  526 */  legVec_rule,
  /*  527 */  legVec_rule,
  /*  528 */  kReg_rule,
  /*  529 */  kReg_rule,
  /*  530 */  kReg_rule,
  /*  531 */  0,
  /*  532 */  0,
  /*  533 */  0,
  /*  534 */  0,
  /*  535 */  0,
  /*  536 */  0,
  /*  537 */  0,
  /*  538 */  0,
  /*  539 */  0,
  /*  540 */  0,
  /*  541 */  0,
  /*  542 */  0,
  /*  543 */  0,
  /*  544 */  0,
  /*  545 */  0,
  /*  546 */  immP0_rule,
  /*  547 */  0,
  /*  548 */  0,
  /*  549 */  0,
  /*  550 */  0,
  /*  551 */  0,
  /*  552 */  0,
  /*  553 */  immI_24_rule,
  /*  554 */  0,
  /*  555 */  0,
  /*  556 */  immI_24_rule,
  /*  557 */  0,
  /*  558 */  0,
  /*  559 */  0,
  /*  560 */  0,
  /*  561 */  immI_24_rule,
  /*  562 */  immI_255_rule,
  /*  563 */  immI_16_rule,
  /*  564 */  immI_65535_rule,
  /*  565 */  0,
  /*  566 */  0,
  /*  567 */  0,
  /*  568 */  0,
  /*  569 */  immL_32bits_rule,
  /*  570 */  0,
  /*  571 */  0,
  /*  572 */  0,
  /*  573 */  0,
  /*  574 */  0,
  /*  575 */  0,
  /*  576 */  0,
  /*  577 */  0,
  /*  578 */  0,
  /*  579 */  0,
  /*  580 */  legRegF_rule,
  /*  581 */  legRegF_rule,
  /*  582 */  legRegD_rule,
  /*  583 */  legRegD_rule,
  /*  584 */  legRegF_rule,
  /*  585 */  legRegF_rule,
  /*  586 */  legRegD_rule,
  /*  587 */  legRegD_rule,
  /*  588 */  0,
  /*  589 */  0,
  /*  590 */  0,
  /*  591 */  0,
  /*  592 */  rRegI_rule,
  /*  593 */  rRegI_rule,
  /*  594 */  rRegI_rule,
  /*  595 */  rRegL_rule,
  /*  596 */  any_RegP_rule,
  /*  597 */  immP0_rule,
  /*  598 */  immP31_rule,
  /*  599 */  rRegN_rule,
  /*  600 */  rRegN_rule,
  /*  601 */  immN0_rule,
  /*  602 */  immN_rule,
  /*  603 */  immNKlass_rule,
  /*  604 */  immI_0_rule,
  /*  605 */  immI_rule,
  /*  606 */  immL0_rule,
  /*  607 */  immL32_rule,
  /*  608 */  immI_0_rule,
  /*  609 */  immI16_rule,
  /*  610 */  immI_0_rule,
  /*  611 */  immI8_rule,
  /*  612 */  regF_rule,
  /*  613 */  immF0_rule,
  /*  614 */  immF_rule,
  /*  615 */  regD_rule,
  /*  616 */  immD0_rule,
  /*  617 */  immD0_rule,
  /*  618 */  0,
  /*  619 */  0,
  /*  620 */  0,
  /*  621 */  0,
  /*  622 */  0,
  /*  623 */  0,
  /*  624 */  0,
  /*  625 */  0,
  /*  626 */  0,
  /*  627 */  0,
  /*  628 */  0,
  /*  629 */  0,
  /*  630 */  0,
  /*  631 */  0,
  /*  632 */  0,
  /*  633 */  0,
  /*  634 */  0,
  /*  635 */  0,
  /*  636 */  0,
  /*  637 */  0,
  /*  638 */  0,
  /*  639 */  0,
  /*  640 */  0,
  /*  641 */  0,
  /*  642 */  0,
  /*  643 */  0,
  /*  644 */  0,
  /*  645 */  0,
  /*  646 */  0,
  /*  647 */  0,
  /*  648 */  0,
  /*  649 */  0,
  /*  650 */  0,
  /*  651 */  0,
  /*  652 */  0,
  /*  653 */  0,
  /*  654 */  0,
  /*  655 */  0,
  /*  656 */  0,
  /*  657 */  0,
  /*  658 */  0,
  /*  659 */  0,
  /*  660 */  0,
  /*  661 */  0,
  /*  662 */  0,
  /*  663 */  0,
  /*  664 */  0,
  /*  665 */  _Binary_immI_1_rRegI_rule,
  /*  666 */  _Binary_rRegI_rRegI_rule,
  /*  667 */  _Binary_immI_1_rRegI_rule,
  /*  668 */  _Binary_rRegI_rRegI_rule,
  /*  669 */  _Binary_immI_1_rRegI_rule,
  /*  670 */  _Binary_rRegI_rRegI_rule,
  /*  671 */  _Binary_rRegI_rRegI_rule,
  /*  672 */  _Binary_rRegI_rRegI_rule,
  /*  673 */  _Binary_rRegI__LoadI_memory__rule,
  /*  674 */  _Binary_rRegI__LoadI_memory__rule,
  /*  675 */  _Binary_rRegI__LoadI_memory__rule,
  /*  676 */  _Binary_rRegN_rRegN_rule,
  /*  677 */  _Binary_rRegN_rRegN_rule,
  /*  678 */  _Binary_rRegN_rRegN_rule,
  /*  679 */  _Binary_rRegN_rRegN_rule,
  /*  680 */  _Binary_rRegN_rRegN_rule,
  /*  681 */  _Binary_rRegP_rRegP_rule,
  /*  682 */  _Binary_rRegP_rRegP_rule,
  /*  683 */  _Binary_rRegP_rRegP_rule,
  /*  684 */  _Binary_rRegP_rRegP_rule,
  /*  685 */  _Binary_rRegP_rRegP_rule,
  /*  686 */  _Binary_immL1_rRegL_rule,
  /*  687 */  _Binary_rRegL_rRegL_rule,
  /*  688 */  _Binary_rRegL__LoadL_memory__rule,
  /*  689 */  _Binary_immL1_rRegL_rule,
  /*  690 */  _Binary_rRegL_rRegL_rule,
  /*  691 */  _Binary_immL1_rRegL_rule,
  /*  692 */  _Binary_rRegL_rRegL_rule,
  /*  693 */  _Binary_rRegL_rRegL_rule,
  /*  694 */  _Binary_rRegL_rRegL_rule,
  /*  695 */  _Binary_rRegL__LoadL_memory__rule,
  /*  696 */  _Binary_rRegL__LoadL_memory__rule,
  /*  697 */  _Binary_regF_regF_rule,
  /*  698 */  _Binary_regF_regF_rule,
  /*  699 */  _Binary_regF_regF_rule,
  /*  700 */  _Binary_regD_regD_rule,
  /*  701 */  _Binary_regD_regD_rule,
  /*  702 */  _Binary_regD_regD_rule,
  /*  703 */  rRegI_rule,
  /*  704 */  immI_rule,
  /*  705 */  _LoadI_memory__rule,
  /*  706 */  rRegI_rule,
  /*  707 */  _AddI__LoadI_memory__rRegI_rule,
  /*  708 */  _AddI_rRegI__LoadI_memory__rule,
  /*  709 */  _AddI__LoadI_memory__immI_rule,
  /*  710 */  immI_1_rule,
  /*  711 */  _AddI__LoadI_memory__immI_1_rule,
  /*  712 */  immI_M1_rule,
  /*  713 */  _AddI__LoadI_memory__immI_M1_rule,
  /*  714 */  immI_rule,
  /*  715 */  immI_rule,
  /*  716 */  _LShiftI_rRegI_immI2_rule,
  /*  717 */  no_rbp_r13_RegI_rule,
  /*  718 */  immI_rule,
  /*  719 */  immI_rule,
  /*  720 */  rRegL_rule,
  /*  721 */  immL32_rule,
  /*  722 */  _LoadL_memory__rule,
  /*  723 */  rRegL_rule,
  /*  724 */  _AddL__LoadL_memory__rRegL_rule,
  /*  725 */  _AddL_rRegL__LoadL_memory__rule,
  /*  726 */  _AddL__LoadL_memory__immL32_rule,
  /*  727 */  immL1_rule,
  /*  728 */  _AddL__LoadL_memory__immL1_rule,
  /*  729 */  immL_M1_rule,
  /*  730 */  _AddL__LoadL_memory__immL_M1_rule,
  /*  731 */  immL32_rule,
  /*  732 */  immL32_rule,
  /*  733 */  _LShiftL_rRegL_immI2_rule,
  /*  734 */  no_rbp_r13_RegL_rule,
  /*  735 */  immL32_rule,
  /*  736 */  immL32_rule,
  /*  737 */  rRegL_rule,
  /*  738 */  immL32_rule,
  /*  739 */  _Binary_rax_RegP_rRegP_rule,
  /*  740 */  _Binary_rax_RegP_rRegP_rule,
  /*  741 */  _Binary_rax_RegL_rRegL_rule,
  /*  742 */  _Binary_rax_RegL_rRegL_rule,
  /*  743 */  _Binary_rax_RegI_rRegI_rule,
  /*  744 */  _Binary_rax_RegI_rRegI_rule,
  /*  745 */  _Binary_rax_RegI_rRegI_rule,
  /*  746 */  _Binary_rax_RegI_rRegI_rule,
  /*  747 */  _Binary_rax_RegI_rRegI_rule,
  /*  748 */  _Binary_rax_RegI_rRegI_rule,
  /*  749 */  _Binary_rax_RegN_rRegN_rule,
  /*  750 */  _Binary_rax_RegN_rRegN_rule,
  /*  751 */  _Binary_rax_RegI_rRegI_rule,
  /*  752 */  _Binary_rax_RegI_rRegI_rule,
  /*  753 */  _Binary_rax_RegI_rRegI_rule,
  /*  754 */  _Binary_rax_RegL_rRegL_rule,
  /*  755 */  _Binary_rax_RegN_rRegN_rule,
  /*  756 */  _Binary_rax_RegP_rRegP_rule,
  /*  757 */  rRegI_rule,
  /*  758 */  immI_rule,
  /*  759 */  rRegI_rule,
  /*  760 */  rRegI_rule,
  /*  761 */  immI_rule,
  /*  762 */  rRegI_rule,
  /*  763 */  rRegI_rule,
  /*  764 */  immI_rule,
  /*  765 */  rRegI_rule,
  /*  766 */  rRegL_rule,
  /*  767 */  immL32_rule,
  /*  768 */  rRegL_rule,
  /*  769 */  rRegI_rule,
  /*  770 */  rRegI_rule,
  /*  771 */  rRegI_rule,
  /*  772 */  rRegL_rule,
  /*  773 */  rRegP_rule,
  /*  774 */  rRegN_rule,
  /*  775 */  0,
  /*  776 */  0,
  /*  777 */  rRegI_rule,
  /*  778 */  _LoadI_memory__rule,
  /*  779 */  _SubI__LoadI_memory__rRegI_rule,
  /*  780 */  rRegL_rule,
  /*  781 */  _LoadL_memory__rule,
  /*  782 */  _SubL__LoadL_memory__rRegL_rule,
  /*  783 */  _SubI_immI_0_rRegI_rule,
  /*  784 */  rRegI_rule,
  /*  785 */  0,
  /*  786 */  _SubI_immI_0__LoadI_memory__rule,
  /*  787 */  rRegL_rule,
  /*  788 */  0,
  /*  789 */  _SubL_immL0__LoadL_memory__rule,
  /*  790 */  rRegI_rule,
  /*  791 */  immI_rule,
  /*  792 */  _LoadI_memory__rule,
  /*  793 */  rRegI_rule,
  /*  794 */  immI_rule,
  /*  795 */  _Binary_rRegI_rRegI_rule,
  /*  796 */  rRegL_rule,
  /*  797 */  immL32_rule,
  /*  798 */  _LoadL_memory__rule,
  /*  799 */  rRegL_rule,
  /*  800 */  immL32_rule,
  /*  801 */  rax_RegL_rule,
  /*  802 */  rax_RegL_rule,
  /*  803 */  no_rax_rdx_RegI_rule,
  /*  804 */  no_rax_rdx_RegL_rule,
  /*  805 */  no_rax_rdx_RegI_rule,
  /*  806 */  no_rax_rdx_RegL_rule,
  /*  807 */  no_rax_rdx_RegI_rule,
  /*  808 */  no_rax_rdx_RegL_rule,
  /*  809 */  no_rax_rdx_RegI_rule,
  /*  810 */  no_rax_rdx_RegL_rule,
  /*  811 */  no_rax_rdx_RegI_rule,
  /*  812 */  no_rax_rdx_RegL_rule,
  /*  813 */  no_rax_rdx_RegI_rule,
  /*  814 */  no_rax_rdx_RegL_rule,
  /*  815 */  immI2_rule,
  /*  816 */  immI8_rule,
  /*  817 */  _LShiftI__LoadI_memory__immI8_rule,
  /*  818 */  rcx_RegI_rule,
  /*  819 */  _LShiftI__LoadI_memory__rcx_RegI_rule,
  /*  820 */  rRegI_rule,
  /*  821 */  rRegI_rule,
  /*  822 */  immI8_rule,
  /*  823 */  _RShiftI__LoadI_memory__immI8_rule,
  /*  824 */  rcx_RegI_rule,
  /*  825 */  _RShiftI__LoadI_memory__rcx_RegI_rule,
  /*  826 */  rRegI_rule,
  /*  827 */  rRegI_rule,
  /*  828 */  immI8_rule,
  /*  829 */  _URShiftI__LoadI_memory__immI8_rule,
  /*  830 */  rcx_RegI_rule,
  /*  831 */  _URShiftI__LoadI_memory__rcx_RegI_rule,
  /*  832 */  rRegI_rule,
  /*  833 */  rRegI_rule,
  /*  834 */  immI2_rule,
  /*  835 */  immI8_rule,
  /*  836 */  _LShiftL__LoadL_memory__immI8_rule,
  /*  837 */  rcx_RegI_rule,
  /*  838 */  _LShiftL__LoadL_memory__rcx_RegI_rule,
  /*  839 */  rRegI_rule,
  /*  840 */  rRegI_rule,
  /*  841 */  immI_rule,
  /*  842 */  _RShiftL__LoadL_memory__immI_rule,
  /*  843 */  rcx_RegI_rule,
  /*  844 */  _RShiftL__LoadL_memory__rcx_RegI_rule,
  /*  845 */  rRegI_rule,
  /*  846 */  rRegI_rule,
  /*  847 */  immI8_rule,
  /*  848 */  _URShiftL__LoadL_memory__immI8_rule,
  /*  849 */  rcx_RegI_rule,
  /*  850 */  _URShiftL__LoadL_memory__rcx_RegI_rule,
  /*  851 */  rRegI_rule,
  /*  852 */  rRegI_rule,
  /*  853 */  immI_24_rule,
  /*  854 */  immI_16_rule,
  /*  855 */  immI8_rule,
  /*  856 */  immI8_rule,
  /*  857 */  immI8_rule,
  /*  858 */  rcx_RegI_rule,
  /*  859 */  immI8_rule,
  /*  860 */  immI8_rule,
  /*  861 */  immI8_rule,
  /*  862 */  rcx_RegI_rule,
  /*  863 */  immI8_rule,
  /*  864 */  immI8_rule,
  /*  865 */  immI8_rule,
  /*  866 */  rcx_RegI_rule,
  /*  867 */  immI8_rule,
  /*  868 */  immI8_rule,
  /*  869 */  immI8_rule,
  /*  870 */  rcx_RegI_rule,
  /*  871 */  rRegL_rule,
  /*  872 */  rRegL_rule,
  /*  873 */  _LoadL_memory__rule,
  /*  874 */  _LoadL_memory__rule,
  /*  875 */  rRegI_rule,
  /*  876 */  immI_255_rule,
  /*  877 */  0,
  /*  878 */  immI_65535_rule,
  /*  879 */  0,
  /*  880 */  0,
  /*  881 */  immI_rule,
  /*  882 */  _LoadI_memory__rule,
  /*  883 */  rRegI_rule,
  /*  884 */  _AndI__LoadB_memory__rRegI_rule,
  /*  885 */  _AndI_rRegI__LoadB_memory__rule,
  /*  886 */  _AndI__LoadI_memory__rRegI_rule,
  /*  887 */  _AndI_rRegI__LoadI_memory__rule,
  /*  888 */  _AndI__LoadI_memory__immI_rule,
  /*  889 */  _LoadI_memory__rule,
  /*  890 */  _XorI_rRegI_immI_M1_rule,
  /*  891 */  rRegI_rule,
  /*  892 */  _XorI_rRegI_immI_M1_rule,
  /*  893 */  rRegI_rule,
  /*  894 */  _SubI_immI_0_rRegI_rule,
  /*  895 */  _LoadI_memory__rule,
  /*  896 */  _SubI_immI_0__LoadI_memory__rule,
  /*  897 */  _LoadI_memory__rule,
  /*  898 */  _AddI__LoadI_memory__immI_M1_rule,
  /*  899 */  rRegI_rule,
  /*  900 */  _AddI_rRegI_immI_M1_rule,
  /*  901 */  rRegI_rule,
  /*  902 */  _AddI_rRegI_immI_M1_rule,
  /*  903 */  _LoadI_memory__rule,
  /*  904 */  _AddI__LoadI_memory__immI_M1_rule,
  /*  905 */  rRegI_rule,
  /*  906 */  immI_rule,
  /*  907 */  _LoadI_memory__rule,
  /*  908 */  rRegI_rule,
  /*  909 */  _OrI__LoadB_memory__rRegI_rule,
  /*  910 */  _OrI_rRegI__LoadB_memory__rule,
  /*  911 */  _OrI__LoadI_memory__rRegI_rule,
  /*  912 */  _OrI_rRegI__LoadI_memory__rule,
  /*  913 */  _OrI__LoadI_memory__immI_rule,
  /*  914 */  rRegI_rule,
  /*  915 */  immI_M1_rule,
  /*  916 */  immI_rule,
  /*  917 */  _LoadI_memory__rule,
  /*  918 */  rRegI_rule,
  /*  919 */  _XorI__LoadB_memory__rRegI_rule,
  /*  920 */  _XorI_rRegI__LoadB_memory__rule,
  /*  921 */  _XorI__LoadI_memory__rRegI_rule,
  /*  922 */  _XorI_rRegI__LoadI_memory__rule,
  /*  923 */  _XorI__LoadI_memory__immI_rule,
  /*  924 */  rRegL_rule,
  /*  925 */  immL_255_rule,
  /*  926 */  immL_65535_rule,
  /*  927 */  immL32_rule,
  /*  928 */  _LoadL_memory__rule,
  /*  929 */  rRegL_rule,
  /*  930 */  _AndL__LoadL_memory__rRegL_rule,
  /*  931 */  _AndL_rRegL__LoadL_memory__rule,
  /*  932 */  _AndL__LoadL_memory__immL32_rule,
  /*  933 */  _AndL__LoadL_memory__immL_NotPow2_rule,
  /*  934 */  _LoadL_memory__rule,
  /*  935 */  _XorL_rRegL_immL_M1_rule,
  /*  936 */  rRegL_rule,
  /*  937 */  _XorL_rRegL_immL_M1_rule,
  /*  938 */  rRegL_rule,
  /*  939 */  _SubL_immL0_rRegL_rule,
  /*  940 */  _LoadL_memory__rule,
  /*  941 */  _SubL_immL0__LoadL_memory__rule,
  /*  942 */  _LoadL_memory__rule,
  /*  943 */  _AddL__LoadL_memory__immL_M1_rule,
  /*  944 */  rRegL_rule,
  /*  945 */  _AddL_rRegL_immL_M1_rule,
  /*  946 */  rRegL_rule,
  /*  947 */  _AddL_rRegL_immL_M1_rule,
  /*  948 */  _LoadL_memory__rule,
  /*  949 */  _AddL__LoadL_memory__immL_M1_rule,
  /*  950 */  rRegL_rule,
  /*  951 */  _CastP2X_any_RegP__rule,
  /*  952 */  rRegL_rule,
  /*  953 */  immL32_rule,
  /*  954 */  _LoadL_memory__rule,
  /*  955 */  rRegL_rule,
  /*  956 */  _OrL__LoadL_memory__rRegL_rule,
  /*  957 */  _OrL_rRegL__LoadL_memory__rule,
  /*  958 */  _OrL__LoadL_memory__immL32_rule,
  /*  959 */  _OrL__LoadL_memory__immL_Pow2_rule,
  /*  960 */  rRegL_rule,
  /*  961 */  immL_M1_rule,
  /*  962 */  immL32_rule,
  /*  963 */  _LoadL_memory__rule,
  /*  964 */  rRegL_rule,
  /*  965 */  _XorL__LoadL_memory__rRegL_rule,
  /*  966 */  _XorL_rRegL__LoadL_memory__rule,
  /*  967 */  _XorL__LoadL_memory__immL32_rule,
  /*  968 */  rRegI_rule,
  /*  969 */  immI_0_rule,
  /*  970 */  _SubI_rRegI_rRegI_rule,
  /*  971 */  _AndI__CmpLTMask_rRegI_rRegI_rRegI_rule,
  /*  972 */  _SubI_rRegI_rRegI_rule,
  /*  973 */  _AndI_rRegI__CmpLTMask_rRegI_rRegI_rule,
  /*  974 */  rRegI_rule,
  /*  975 */  _CmpLTMask_rRegI_rRegI_rule,
  /*  976 */  regF_rule,
  /*  977 */  _LoadF_memory__rule,
  /*  978 */  immF_rule,
  /*  979 */  regD_rule,
  /*  980 */  _LoadD_memory__rule,
  /*  981 */  immD_rule,
  /*  982 */  0,
  /*  983 */  0,
  /*  984 */  0,
  /*  985 */  0,
  /*  986 */  0,
  /*  987 */  0,
  /*  988 */  0,
  /*  989 */  0,
  /*  990 */  0,
  /*  991 */  0,
  /*  992 */  0,
  /*  993 */  0,
  /*  994 */  0,
  /*  995 */  0,
  /*  996 */  0,
  /*  997 */  0,
  /*  998 */  0,
  /*  999 */  0,
  /* 1000 */  0,
  /* 1001 */  0,
  /* 1002 */  0,
  /* 1003 */  immL_32bits_rule,
  /* 1004 */  immL_32bits_rule,
  /* 1005 */  immL_32bits_rule,
  /* 1006 */  0,
  /* 1007 */  0,
  /* 1008 */  0,
  /* 1009 */  0,
  /* 1010 */  0,
  /* 1011 */  rdi_RegP_rule,
  /* 1012 */  rdi_RegP_rule,
  /* 1013 */  rdi_RegP_rule,
  /* 1014 */  rdi_RegP_rule,
  /* 1015 */  rRegP_rule,
  /* 1016 */  _Binary_rsi_RegP_rdx_RegI_rule,
  /* 1017 */  _Binary_rsi_RegP_rdx_RegI_rule,
  /* 1018 */  _Binary_rsi_RegP_rdx_RegI_rule,
  /* 1019 */  _Binary_rsi_RegP_rdx_RegI_rule,
  /* 1020 */  _Binary_rsi_RegP_rdx_RegI_rule,
  /* 1021 */  _Binary_rsi_RegP_rdx_RegI_rule,
  /* 1022 */  _Binary_rdi_RegP_rcx_RegI_rule,
  /* 1023 */  _Binary_rdi_RegP_rcx_RegI_rule,
  /* 1024 */  _Binary_rsi_RegP_immI_rule,
  /* 1025 */  _Binary_rsi_RegP_immI_rule,
  /* 1026 */  _Binary_rsi_RegP_immI_rule,
  /* 1027 */  _Binary_rsi_RegP_rax_RegI_rule,
  /* 1028 */  _Binary_rsi_RegP_rax_RegI_rule,
  /* 1029 */  _Binary_rsi_RegP_rax_RegI_rule,
  /* 1030 */  rax_RegI_rule,
  /* 1031 */  rax_RegI_rule,
  /* 1032 */  rcx_RegI_rule,
  /* 1033 */  rcx_RegI_rule,
  /* 1034 */  rsi_RegP_rule,
  /* 1035 */  rsi_RegP_rule,
  /* 1036 */  rsi_RegP_rule,
  /* 1037 */  rsi_RegP_rule,
  /* 1038 */  _Binary_rbx_RegI_immU8_rule,
  /* 1039 */  rcx_RegI_rule,
  /* 1040 */  rcx_RegI_rule,
  /* 1041 */  _Binary_rdi_RegP_rdx_RegI_rule,
  /* 1042 */  _Binary_rdi_RegP_rdx_RegI_rule,
  /* 1043 */  _Binary_rdi_RegP_rdx_RegI_rule,
  /* 1044 */  _Binary_rdi_RegP_rdx_RegI_rule,
  /* 1045 */  _Binary_rdi_RegP_rdx_RegI_rule,
  /* 1046 */  _Binary_rdi_RegP_rdx_RegI_rule,
  /* 1047 */  rRegI_rule,
  /* 1048 */  rRegL_rule,
  /* 1049 */  rRegL_rule,
  /* 1050 */  0,
  /* 1051 */  rRegI_rule,
  /* 1052 */  0,
  /* 1053 */  rRegI_rule,
  /* 1054 */  0,
  /* 1055 */  rFlagsReg_rule,
  /* 1056 */  rFlagsReg_rule,
  /* 1057 */  rFlagsRegU_rule,
  /* 1058 */  rFlagsRegUCF_rule,
  /* 1059 */  rFlagsRegUCF_rule,
  /* 1060 */  rax_RegP_rule,
  /* 1061 */  rax_RegP_rule,
  /* 1062 */  _Binary_rax_RegP_immP_rule,
  /* 1063 */  0,
  /* 1064 */  rFlagsReg_rule,
  /* 1065 */  rFlagsReg_rule,
  /* 1066 */  rFlagsRegU_rule,
  /* 1067 */  rFlagsRegUCF_rule,
  /* 1068 */  rFlagsRegUCF_rule,
  /* 1069 */  0,
  /* 1070 */  0,
  /* 1071 */  0,
  /* 1072 */  0,
  /* 1073 */  0,
  /* 1074 */  0,
  /* 1075 */  0,
  /* 1076 */  0,
  /* 1077 */  0,
  /* 1078 */  0,
  /* 1079 */  rbx_RegP_rule,
  /* 1080 */  rax_RegP_rule,
  /* 1081 */  0,
  /* 1082 */  0,
  /* 1083 */  0,
  /* 1084 */  rRegI_rule,
  /* 1085 */  immI_rule,
  /* 1086 */  immI2_rule,
  /* 1087 */  rRegL_rule,
  /* 1088 */  immL32_rule,
  /* 1089 */  immI2_rule,
  /* 1090 */  0,
  /* 1091 */  regF_rule,
  /* 1092 */  _LoadF_memory__rule,
  /* 1093 */  regF_rule,
  /* 1094 */  immF_rule,
  /* 1095 */  regF_rule,
  /* 1096 */  _LoadF_memory__rule,
  /* 1097 */  regF_rule,
  /* 1098 */  immF_rule,
  /* 1099 */  regD_rule,
  /* 1100 */  _LoadD_memory__rule,
  /* 1101 */  regD_rule,
  /* 1102 */  immD_rule,
  /* 1103 */  regD_rule,
  /* 1104 */  _LoadD_memory__rule,
  /* 1105 */  regD_rule,
  /* 1106 */  immD_rule,
  /* 1107 */  regF_rule,
  /* 1108 */  _LoadF_memory__rule,
  /* 1109 */  immF_rule,
  /* 1110 */  regF_rule,
  /* 1111 */  _LoadF_memory__rule,
  /* 1112 */  immF_rule,
  /* 1113 */  regD_rule,
  /* 1114 */  _LoadD_memory__rule,
  /* 1115 */  immD_rule,
  /* 1116 */  regD_rule,
  /* 1117 */  _LoadD_memory__rule,
  /* 1118 */  immD_rule,
  /* 1119 */  regF_rule,
  /* 1120 */  _LoadF_memory__rule,
  /* 1121 */  regF_rule,
  /* 1122 */  immF_rule,
  /* 1123 */  regF_rule,
  /* 1124 */  _LoadF_memory__rule,
  /* 1125 */  regF_rule,
  /* 1126 */  immF_rule,
  /* 1127 */  regD_rule,
  /* 1128 */  _LoadD_memory__rule,
  /* 1129 */  regD_rule,
  /* 1130 */  immD_rule,
  /* 1131 */  regD_rule,
  /* 1132 */  _LoadD_memory__rule,
  /* 1133 */  regD_rule,
  /* 1134 */  immD_rule,
  /* 1135 */  regF_rule,
  /* 1136 */  _LoadF_memory__rule,
  /* 1137 */  immF_rule,
  /* 1138 */  regF_rule,
  /* 1139 */  _LoadF_memory__rule,
  /* 1140 */  immF_rule,
  /* 1141 */  regD_rule,
  /* 1142 */  _LoadD_memory__rule,
  /* 1143 */  immD_rule,
  /* 1144 */  regD_rule,
  /* 1145 */  _LoadD_memory__rule,
  /* 1146 */  immD_rule,
  /* 1147 */  0,
  /* 1148 */  0,
  /* 1149 */  0,
  /* 1150 */  _ConvF2HF_regF__rule,
  /* 1151 */  _VectorCastF2HF_vec__rule,
  /* 1152 */  0,
  /* 1153 */  0,
  /* 1154 */  0,
  /* 1155 */  0,
  /* 1156 */  immU8_rule,
  /* 1157 */  immU8_rule,
  /* 1158 */  immU8_rule,
  /* 1159 */  immU8_rule,
  /* 1160 */  immU8_rule,
  /* 1161 */  immU8_rule,
  /* 1162 */  0,
  /* 1163 */  _Binary_regD_regD_rule,
  /* 1164 */  _Binary_regF_regF_rule,
  /* 1165 */  0,
  /* 1166 */  vec_rule,
  /* 1167 */  legVec_rule,
  /* 1168 */  vec_rule,
  /* 1169 */  _Binary_vec_kReg_rule,
  /* 1170 */  _Binary_rRegP_immI_0_rule,
  /* 1171 */  _Binary_rRegP_immI_0_rule,
  /* 1172 */  _Binary_rRegP_rRegI_rule,
  /* 1173 */  _Binary_rRegP_rRegI_rule,
  /* 1174 */  _Binary_rRegP__Binary_kReg_immI_0_rule,
  /* 1175 */  _Binary_rRegP__Binary_kReg_immI_0_rule,
  /* 1176 */  _Binary_rRegP__Binary_kReg_rRegI_rule,
  /* 1177 */  _Binary_rRegP__Binary_kReg_rRegI_rule,
  /* 1178 */  _Binary_rRegP__Binary_vec_immI_0_rule,
  /* 1179 */  _Binary_rRegP__Binary_vec_immI_0_rule,
  /* 1180 */  _Binary_rRegP__Binary_vec_rRegI_rule,
  /* 1181 */  _Binary_rRegP__Binary_vec_rRegI_rule,
  /* 1182 */  _Binary_vec_vec_rule,
  /* 1183 */  _Binary_vec__Binary_vec_kReg_rule,
  /* 1184 */  immU8_rule,
  /* 1185 */  immU8_rule,
  /* 1186 */  immU8_rule,
  /* 1187 */  immU8_rule,
  /* 1188 */  immU8_rule,
  /* 1189 */  immU8_rule,
  /* 1190 */  immU8_rule,
  /* 1191 */  immU8_rule,
  /* 1192 */  immU8_rule,
  /* 1193 */  immU8_rule,
  /* 1194 */  immI_rule,
  /* 1195 */  legVec_rule,
  /* 1196 */  legVec_rule,
  /* 1197 */  legVec_rule,
  /* 1198 */  legVec_rule,
  /* 1199 */  legVec_rule,
  /* 1200 */  legVec_rule,
  /* 1201 */  legVec_rule,
  /* 1202 */  legVec_rule,
  /* 1203 */  legVec_rule,
  /* 1204 */  legVec_rule,
  /* 1205 */  legVec_rule,
  /* 1206 */  legVec_rule,
  /* 1207 */  legVec_rule,
  /* 1208 */  legVec_rule,
  /* 1209 */  vec_rule,
  /* 1210 */  vec_rule,
  /* 1211 */  vec_rule,
  /* 1212 */  vec_rule,
  /* 1213 */  vec_rule,
  /* 1214 */  vec_rule,
  /* 1215 */  vec_rule,
  /* 1216 */  vec_rule,
  /* 1217 */  vec_rule,
  /* 1218 */  vec_rule,
  /* 1219 */  vec_rule,
  /* 1220 */  legVec_rule,
  /* 1221 */  legVec_rule,
  /* 1222 */  vec_rule,
  /* 1223 */  vec_rule,
  /* 1224 */  vec_rule,
  /* 1225 */  vec_rule,
  /* 1226 */  vec_rule,
  /* 1227 */  vec_rule,
  /* 1228 */  legVec_rule,
  /* 1229 */  legVec_rule,
  /* 1230 */  vec_rule,
  /* 1231 */  vec_rule,
  /* 1232 */  vec_rule,
  /* 1233 */  vec_rule,
  /* 1234 */  legVec_rule,
  /* 1235 */  legVec_rule,
  /* 1236 */  vec_rule,
  /* 1237 */  vec_rule,
  /* 1238 */  vec_rule,
  /* 1239 */  vec_rule,
  /* 1240 */  legVec_rule,
  /* 1241 */  legVec_rule,
  /* 1242 */  legVec_rule,
  /* 1243 */  legVec_rule,
  /* 1244 */  legVec_rule,
  /* 1245 */  legVec_rule,
  /* 1246 */  legVec_rule,
  /* 1247 */  legVec_rule,
  /* 1248 */  vec_rule,
  /* 1249 */  vec_rule,
  /* 1250 */  vec_rule,
  /* 1251 */  vec_rule,
  /* 1252 */  vec_rule,
  /* 1253 */  vec_rule,
  /* 1254 */  legVec_rule,
  /* 1255 */  legVec_rule,
  /* 1256 */  legVec_rule,
  /* 1257 */  legVec_rule,
  /* 1258 */  legVec_rule,
  /* 1259 */  legVec_rule,
  /* 1260 */  legVec_rule,
  /* 1261 */  vec_rule,
  /* 1262 */  legVec_rule,
  /* 1263 */  legVec_rule,
  /* 1264 */  legVec_rule,
  /* 1265 */  legVec_rule,
  /* 1266 */  legVec_rule,
  /* 1267 */  legVec_rule,
  /* 1268 */  legVec_rule,
  /* 1269 */  legVec_rule,
  /* 1270 */  legVec_rule,
  /* 1271 */  legVec_rule,
  /* 1272 */  legVec_rule,
  /* 1273 */  legVec_rule,
  /* 1274 */  legVec_rule,
  /* 1275 */  legVec_rule,
  /* 1276 */  legVec_rule,
  /* 1277 */  legVec_rule,
  /* 1278 */  legVec_rule,
  /* 1279 */  vec_rule,
  /* 1280 */  vec_rule,
  /* 1281 */  _LoadVector_memory__rule,
  /* 1282 */  vec_rule,
  /* 1283 */  vec_rule,
  /* 1284 */  vec_rule,
  /* 1285 */  _LoadVector_memory__rule,
  /* 1286 */  vec_rule,
  /* 1287 */  vec_rule,
  /* 1288 */  vec_rule,
  /* 1289 */  _LoadVector_memory__rule,
  /* 1290 */  vec_rule,
  /* 1291 */  vec_rule,
  /* 1292 */  vec_rule,
  /* 1293 */  _LoadVector_memory__rule,
  /* 1294 */  vec_rule,
  /* 1295 */  vec_rule,
  /* 1296 */  vec_rule,
  /* 1297 */  _LoadVector_memory__rule,
  /* 1298 */  vec_rule,
  /* 1299 */  vec_rule,
  /* 1300 */  vec_rule,
  /* 1301 */  _LoadVector_memory__rule,
  /* 1302 */  vec_rule,
  /* 1303 */  vec_rule,
  /* 1304 */  vec_rule,
  /* 1305 */  _LoadVector_memory__rule,
  /* 1306 */  vec_rule,
  /* 1307 */  vec_rule,
  /* 1308 */  _LoadVector_memory__rule,
  /* 1309 */  vec_rule,
  /* 1310 */  vec_rule,
  /* 1311 */  _LoadVector_memory__rule,
  /* 1312 */  vec_rule,
  /* 1313 */  vec_rule,
  /* 1314 */  _LoadVector_memory__rule,
  /* 1315 */  vec_rule,
  /* 1316 */  vec_rule,
  /* 1317 */  _LoadVector_memory__rule,
  /* 1318 */  vec_rule,
  /* 1319 */  vec_rule,
  /* 1320 */  _LoadVector_memory__rule,
  /* 1321 */  vec_rule,
  /* 1322 */  vec_rule,
  /* 1323 */  vec_rule,
  /* 1324 */  vec_rule,
  /* 1325 */  vec_rule,
  /* 1326 */  _LoadVector_memory__rule,
  /* 1327 */  vec_rule,
  /* 1328 */  vec_rule,
  /* 1329 */  vec_rule,
  /* 1330 */  _LoadVector_memory__rule,
  /* 1331 */  vec_rule,
  /* 1332 */  vec_rule,
  /* 1333 */  _LoadVector_memory__rule,
  /* 1334 */  vec_rule,
  /* 1335 */  vec_rule,
  /* 1336 */  vec_rule,
  /* 1337 */  vec_rule,
  /* 1338 */  vec_rule,
  /* 1339 */  vec_rule,
  /* 1340 */  vec_rule,
  /* 1341 */  _LoadVector_memory__rule,
  /* 1342 */  vec_rule,
  /* 1343 */  vec_rule,
  /* 1344 */  vec_rule,
  /* 1345 */  _LoadVector_memory__rule,
  /* 1346 */  vec_rule,
  /* 1347 */  vec_rule,
  /* 1348 */  vec_rule,
  /* 1349 */  _LoadVector_memory__rule,
  /* 1350 */  vec_rule,
  /* 1351 */  vec_rule,
  /* 1352 */  _LoadVector_memory__rule,
  /* 1353 */  vec_rule,
  /* 1354 */  vec_rule,
  /* 1355 */  vec_rule,
  /* 1356 */  vec_rule,
  /* 1357 */  vec_rule,
  /* 1358 */  vec_rule,
  /* 1359 */  legVec_rule,
  /* 1360 */  legVec_rule,
  /* 1361 */  vec_rule,
  /* 1362 */  vec_rule,
  /* 1363 */  legVec_rule,
  /* 1364 */  legVec_rule,
  /* 1365 */  vec_rule,
  /* 1366 */  vec_rule,
  /* 1367 */  vec_rule,
  /* 1368 */  vec_rule,
  /* 1369 */  _LoadVector_memory__rule,
  /* 1370 */  _LoadVector_memory__rule,
  /* 1371 */  vec_rule,
  /* 1372 */  vec_rule,
  /* 1373 */  kReg_rule,
  /* 1374 */  kReg_rule,
  /* 1375 */  kReg_rule,
  /* 1376 */  kReg_rule,
  /* 1377 */  _Binary_regF_regF_rule,
  /* 1378 */  _Binary_regD_regD_rule,
  /* 1379 */  _Binary_vec_vec_rule,
  /* 1380 */  _Binary_vec_vec_rule,
  /* 1381 */  _Binary_vec_vec_rule,
  /* 1382 */  _Binary_vec_vec_rule,
  /* 1383 */  regF_rule,
  /* 1384 */  _Binary_regD_immD_rule,
  /* 1385 */  rRegI_rule,
  /* 1386 */  rRegI_rule,
  /* 1387 */  _LoadI_memory__rule,
  /* 1388 */  _LoadI_memory__rule,
  /* 1389 */  vec_rule,
  /* 1390 */  vec_rule,
  /* 1391 */  vec_rule,
  /* 1392 */  vec_rule,
  /* 1393 */  vec_rule,
  /* 1394 */  vec_rule,
  /* 1395 */  vec_rule,
  /* 1396 */  vec_rule,
  /* 1397 */  vec_rule,
  /* 1398 */  vec_rule,
  /* 1399 */  vec_rule,
  /* 1400 */  vec_rule,
  /* 1401 */  vec_rule,
  /* 1402 */  vec_rule,
  /* 1403 */  vec_rule,
  /* 1404 */  vec_rule,
  /* 1405 */  vec_rule,
  /* 1406 */  vec_rule,
  /* 1407 */  vec_rule,
  /* 1408 */  vec_rule,
  /* 1409 */  vec_rule,
  /* 1410 */  _LShiftCntV_immI8__rule,
  /* 1411 */  _RShiftCntV_immI8__rule,
  /* 1412 */  _RShiftCntV_immI8__rule,
  /* 1413 */  vec_rule,
  /* 1414 */  vec_rule,
  /* 1415 */  _LShiftCntV_immI8__rule,
  /* 1416 */  _RShiftCntV_immI8__rule,
  /* 1417 */  vec_rule,
  /* 1418 */  vec_rule,
  /* 1419 */  vec_rule,
  /* 1420 */  vec_rule,
  /* 1421 */  vec_rule,
  /* 1422 */  vec_rule,
  /* 1423 */  vec_rule,
  /* 1424 */  vec_rule,
  /* 1425 */  vec_rule,
  /* 1426 */  vec_rule,
  /* 1427 */  vec_rule,
  /* 1428 */  vec_rule,
  /* 1429 */  vec_rule,
  /* 1430 */  vec_rule,
  /* 1431 */  vec_rule,
  /* 1432 */  vec_rule,
  /* 1433 */  vec_rule,
  /* 1434 */  vec_rule,
  /* 1435 */  vec_rule,
  /* 1436 */  vec_rule,
  /* 1437 */  vec_rule,
  /* 1438 */  vec_rule,
  /* 1439 */  vec_rule,
  /* 1440 */  vec_rule,
  /* 1441 */  vec_rule,
  /* 1442 */  vec_rule,
  /* 1443 */  vec_rule,
  /* 1444 */  vec_rule,
  /* 1445 */  vec_rule,
  /* 1446 */  vec_rule,
  /* 1447 */  vec_rule,
  /* 1448 */  vec_rule,
  /* 1449 */  vec_rule,
  /* 1450 */  vec_rule,
  /* 1451 */  vec_rule,
  /* 1452 */  _LoadVector_memory__rule,
  /* 1453 */  vec_rule,
  /* 1454 */  vec_rule,
  /* 1455 */  vec_rule,
  /* 1456 */  _LoadVector_memory__rule,
  /* 1457 */  vec_rule,
  /* 1458 */  vec_rule,
  /* 1459 */  vec_rule,
  /* 1460 */  _LoadVector_memory__rule,
  /* 1461 */  vec_rule,
  /* 1462 */  0,
  /* 1463 */  0,
  /* 1464 */  0,
  /* 1465 */  0,
  /* 1466 */  0,
  /* 1467 */  0,
  /* 1468 */  0,
  /* 1469 */  0,
  /* 1470 */  0,
  /* 1471 */  immI8_rule,
  /* 1472 */  immI8_rule,
  /* 1473 */  immI8_rule,
  /* 1474 */  immI8_rule,
  /* 1475 */  immI8_rule,
  /* 1476 */  immI8_rule,
  /* 1477 */  immI8_rule,
  /* 1478 */  immI8_rule,
  /* 1479 */  immU8_rule,
  /* 1480 */  immU8_rule,
  /* 1481 */  immU8_rule,
  /* 1482 */  immI_rule,
  /* 1483 */  immI_rule,
  /* 1484 */  immI_rule,
  /* 1485 */  immU8_rule,
  /* 1486 */  immU8_rule,
  /* 1487 */  immU8_rule,
  /* 1488 */  immU8_rule,
  /* 1489 */  immU8_rule,
  /* 1490 */  immU8_rule,
  /* 1491 */  vec_rule,
  /* 1492 */  legVec_rule,
  /* 1493 */  legVec_rule,
  /* 1494 */  legVec_rule,
  /* 1495 */  vec_rule,
  /* 1496 */  kReg_rule,
  /* 1497 */  0,
  /* 1498 */  0,
  /* 1499 */  0,
  /* 1500 */  immI_1_rule,
  /* 1501 */  immI_2_rule,
  /* 1502 */  immI_4_rule,
  /* 1503 */  immI_8_rule,
  /* 1504 */  immI_8_rule,
  /* 1505 */  immI_4_rule,
  /* 1506 */  immI_8_rule,
  /* 1507 */  immI_rule,
  /* 1508 */  immI_rule,
  /* 1509 */  immI_1_rule,
  /* 1510 */  immI_1_rule,
  /* 1511 */  vec_rule,
  /* 1512 */  vec_rule,
  /* 1513 */  vec_rule,
  /* 1514 */  vec_rule,
  /* 1515 */  0,
  /* 1516 */  vec_rule,
  /* 1517 */  vec_rule,
  /* 1518 */  vec_rule,
  /* 1519 */  0,
  /* 1520 */  vec_rule,
  /* 1521 */  vec_rule,
  /* 1522 */  0,
  /* 1523 */  vec_rule,
  /* 1524 */  vec_rule,
  /* 1525 */  _Binary_vec_vec_rule,
  /* 1526 */  _Binary_vec__LoadVector_memory__rule,
  /* 1527 */  _Binary_vec_vec_rule,
  /* 1528 */  _Binary_vec__LoadVector_memory__rule,
  /* 1529 */  vec_rule,
  /* 1530 */  vec_rule,
  /* 1531 */  vec_rule,
  /* 1532 */  _MulAddVS2VI_vec_vec_rule,
  /* 1533 */  kReg_rule,
  /* 1534 */  kReg_rule,
  /* 1535 */  0,
  /* 1536 */  0,
  /* 1537 */  0,
  /* 1538 */  0,
  /* 1539 */  0,
  /* 1540 */  0,
  /* 1541 */  _Binary_vec_immU8_rule,
  /* 1542 */  _Binary__LoadVector_memory__immU8_rule,
  /* 1543 */  immI8_rule,
  /* 1544 */  immI8_rule,
  /* 1545 */  vec_rule,
  /* 1546 */  vec_rule,
  /* 1547 */  vec_rule,
  /* 1548 */  kReg_rule,
  /* 1549 */  _Binary_vec_vec_rule,
  /* 1550 */  _Binary_vec_kReg_rule,
  /* 1551 */  immL32_rule,
  /* 1552 */  _Binary_vec_kReg_rule,
  /* 1553 */  0,
  /* 1554 */  0,
  /* 1555 */  0,
  /* 1556 */  0,
  /* 1557 */  0,
  /* 1558 */  0,
  /* 1559 */  0,
  /* 1560 */  0,
  /* 1561 */  0,
  /* 1562 */  0,
  /* 1563 */  0,
  /* 1564 */  0,
  /* 1565 */  0,
  /* 1566 */  0,
  /* 1567 */  vec_rule,
  /* 1568 */  vec_rule,
  /* 1569 */  kReg_rule,
  /* 1570 */  kReg_rule,
  /* 1571 */  0,
  /* 1572 */  0,
  /* 1573 */  0,
  /* 1574 */  0,
  /* 1575 */  0,
  /* 1576 */  kReg_rule,
  /* 1577 */  0,
  /* 1578 */  0,
  /* 1579 */  0,
  /* 1580 */  0,
  /* 1581 */  kReg_rule,
  /* 1582 */  kReg_rule,
  /* 1583 */  kReg_rule,
  /* 1584 */  kReg_rule,
  /* 1585 */  kReg_rule,
  /* 1586 */  kReg_rule,
  /* 1587 */  kReg_rule,
  /* 1588 */  kReg_rule,
  /* 1589 */  kReg_rule,
  /* 1590 */  kReg_rule,
  /* 1591 */  kReg_rule,
  /* 1592 */  kReg_rule,
  /* 1593 */  kReg_rule,
  /* 1594 */  kReg_rule,
  /* 1595 */  kReg_rule,
  /* 1596 */  kReg_rule,
  /* 1597 */  kReg_rule,
  /* 1598 */  kReg_rule,
  /* 1599 */  kReg_rule,
  /* 1600 */  kReg_rule,
  /* 1601 */  kReg_rule,
  /* 1602 */  kReg_rule,
  /* 1603 */  kReg_rule,
  /* 1604 */  kReg_rule,
  /* 1605 */  kReg_rule,
  /* 1606 */  kReg_rule,
  /* 1607 */  kReg_rule,
  /* 1608 */  kReg_rule,
  /* 1609 */  kReg_rule,
  /* 1610 */  kReg_rule,
  /* 1611 */  kReg_rule,
  /* 1612 */  kReg_rule,
  /* 1613 */  kReg_rule,
  /* 1614 */  kReg_rule,
  /* 1615 */  kReg_rule,
  /* 1616 */  kReg_rule,
  /* 1617 */  kReg_rule,
  /* 1618 */  kReg_rule,
  /* 1619 */  kReg_rule,
  /* 1620 */  kReg_rule,
  /* 1621 */  kReg_rule,
  /* 1622 */  kReg_rule,
  /* 1623 */  kReg_rule,
  /* 1624 */  kReg_rule,
  /* 1625 */  kReg_rule,
  /* 1626 */  kReg_rule,
  /* 1627 */  kReg_rule,
  /* 1628 */  kReg_rule,
  /* 1629 */  kReg_rule,
  /* 1630 */  kReg_rule,
  /* 1631 */  kReg_rule,
  /* 1632 */  kReg_rule,
  /* 1633 */  kReg_rule,
  /* 1634 */  kReg_rule,
  /* 1635 */  kReg_rule,
  /* 1636 */  kReg_rule,
  /* 1637 */  kReg_rule,
  /* 1638 */  kReg_rule,
  /* 1639 */  kReg_rule,
  /* 1640 */  kReg_rule,
  /* 1641 */  kReg_rule,
  /* 1642 */  kReg_rule,
  /* 1643 */  kReg_rule,
  /* 1644 */  kReg_rule,
  /* 1645 */  kReg_rule,
  /* 1646 */  kReg_rule,
  /* 1647 */  kReg_rule,
  /* 1648 */  kReg_rule,
  /* 1649 */  kReg_rule,
  /* 1650 */  kReg_rule,
  /* 1651 */  kReg_rule,
  /* 1652 */  kReg_rule,
  /* 1653 */  kReg_rule,
  /* 1654 */  kReg_rule,
  /* 1655 */  kReg_rule,
  /* 1656 */  kReg_rule,
  /* 1657 */  kReg_rule,
  /* 1658 */  kReg_rule,
  /* 1659 */  kReg_rule,
  /* 1660 */  kReg_rule,
  /* 1661 */  kReg_rule,
  /* 1662 */  kReg_rule,
  /* 1663 */  kReg_rule,
  /* 1664 */  kReg_rule,
  /* 1665 */  kReg_rule,
  /* 1666 */  kReg_rule,
  /* 1667 */  _Binary_vec_kReg_rule,
  /* 1668 */  _Binary_vec_kReg_rule,
  /* 1669 */  _Binary__LoadVector_memory__kReg_rule,
  /* 1670 */  _Binary__LoadVector_memory__kReg_rule,
  /* 1671 */  _Binary_immI8_kReg_rule,
  /* 1672 */  0,
  /* 1673 */  _MaskAll_immI_M1__rule,
  /* 1674 */  _MaskAll_immI_M1__rule,
  /* 1675 */  0,
  /* 1676 */  0,
  /* 1677 */  kReg_rule,
  /* 1678 */  kReg_rule,
  /* 1679 */  kReg_rule,
  /* 1680 */  _Binary_vec__Binary_vec__Binary_immU8_kReg_rule,
  /* 1681 */  _Binary_vec__Binary_memory__Binary_immU8_kReg_rule,
  /* 1682 */  0,
  /* 1683 */  0,
  /* 1684 */  vec_rule,
  /* 1685 */  vec_rule,
  /* 1686 */  vec_rule,
  /* 1687 */  vec_rule,
  /* 1688 */  vec_rule,
  /* 1689 */  vec_rule,
  /* 1690 */  vec_rule,
  /* 1691 */  vec_rule,
  /* 1692 */  vec_rule,
  /* 1693 */  vec_rule,
  /* 1694 */  vec_rule,
  /* 1695 */  vec_rule,
  /* 1696 */  _LoadVector_memory__rule,
  /* 1697 */  _LoadVector_memory__rule,
  /* 1698 */  _LoadVector_memory__rule,
  /* 1699 */  _LoadVector_memory__rule,
  /* 1700 */  kReg_rule,
  /* 1701 */  kReg_rule,
  /* 1702 */  kReg_rule,
  /* 1703 */  kReg_rule,
  /* 1704 */  kReg_rule,
  /* 1705 */  kReg_rule,
  /* 1706 */  kReg_rule,
  /* 1707 */  kReg_rule,
  /* 1708 */  vec_rule,
  /* 1709 */  _Binary_rax_RegP_rRegP_rule,
  /* 1710 */  _Binary_rax_RegP_rRegP_rule,
  /* 1711 */  _Binary_rax_RegN_rRegN_rule,
  /* 1712 */  _Binary_rax_RegN_rRegN_rule,
  /* 1713 */  _Binary_rax_RegN_rRegN_rule,
  /* 1714 */  _Binary_rax_RegP_rRegP_rule,
  /* 1715 */  0,
  /* 1716 */  any_RegP_rule,
  /* 1717 */  immP0_rule,
  /* 1718 */  _Binary_rax_RegP_no_rax_RegP_rule,
  /* 1719 */  _Binary_rax_RegP_rRegP_rule,
  /* 1720 */  _Binary_rax_RegP_rRegP_rule,
  /* 1721 */  rRegP_rule,
  /* 1722 */  any_RegP_rule,
  /* 1723 */  rRegN_rule,
  /* 1724 */  _EncodeP_any_RegP__rule,
  /* 1725 */  _Binary_rax_RegP_rRegP_rule,
  /* 1726 */  _Binary_rax_RegN_rRegN_rule,
  /* 1727 */  _Binary_rax_RegP_rRegP_rule,
  /* 1728 */  _Binary_rax_RegP_rRegP_rule,
  /* 1729 */  _Binary_rax_RegN_rRegN_rule,
  /* 1730 */  _Binary_rax_RegN_rRegN_rule,
  /* 1731 */  rRegP_rule,
  /* 1732 */  rRegN_rule,
  /* 1733 */  0,
  /* 1734 */  0,
  // last instruction
  0 // no trailing comma
};

const char        *ruleName[] = {
  /*    0 */  "UNIVERSE",
  /*    1 */  "LABEL",
  /*    2 */  "SREGI",
  /*    3 */  "SREGP",
  /*    4 */  "SREGF",
  /*    5 */  "SREGD",
  /*    6 */  "SREGL",
  /*    7 */  "METHOD",
  /*    8 */  "IMMI",
  /*    9 */  "IMMI_0",
  /*   10 */  "IMMI_1",
  /*   11 */  "IMMI_M1",
  /*   12 */  "IMMI_2",
  /*   13 */  "IMMI_4",
  /*   14 */  "IMMI_8",
  /*   15 */  "IMMI2",
  /*   16 */  "IMMU7",
  /*   17 */  "IMMI8",
  /*   18 */  "IMMU8",
  /*   19 */  "IMMI16",
  /*   20 */  "IMMU31",
  /*   21 */  "IMMP",
  /*   22 */  "IMMP0",
  /*   23 */  "IMMN",
  /*   24 */  "IMMNKLASS",
  /*   25 */  "IMMN0",
  /*   26 */  "IMMP31",
  /*   27 */  "IMML",
  /*   28 */  "IMML8",
  /*   29 */  "IMMUL32",
  /*   30 */  "IMML32",
  /*   31 */  "IMML_POW2",
  /*   32 */  "IMML_NOTPOW2",
  /*   33 */  "IMML0",
  /*   34 */  "IMML1",
  /*   35 */  "IMML_M1",
  /*   36 */  "IMML_32BITS",
  /*   37 */  "IMMI_POW2M1",
  /*   38 */  "IMMF0",
  /*   39 */  "IMMF",
  /*   40 */  "IMMD0",
  /*   41 */  "IMMD",
  /*   42 */  "IMMI_16",
  /*   43 */  "IMMI_24",
  /*   44 */  "IMMI_255",
  /*   45 */  "IMMI_65535",
  /*   46 */  "IMML_255",
  /*   47 */  "IMML_65535",
  /*   48 */  "KREG",
  /*   49 */  "RREGI",
  /*   50 */  "RAX_REGI",
  /*   51 */  "RBX_REGI",
  /*   52 */  "RCX_REGI",
  /*   53 */  "RDX_REGI",
  /*   54 */  "RDI_REGI",
  /*   55 */  "NO_RAX_RDX_REGI",
  /*   56 */  "NO_RBP_R13_REGI",
  /*   57 */  "ANY_REGP",
  /*   58 */  "RREGP",
  /*   59 */  "RREGN",
  /*   60 */  "NO_RBP_REGP",
  /*   61 */  "RAX_REGP",
  /*   62 */  "RAX_REGN",
  /*   63 */  "RBX_REGP",
  /*   64 */  "RSI_REGP",
  /*   65 */  "RBP_REGP",
  /*   66 */  "RDI_REGP",
  /*   67 */  "R15_REGP",
  /*   68 */  "RREGL",
  /*   69 */  "NO_RAX_RDX_REGL",
  /*   70 */  "RAX_REGL",
  /*   71 */  "RCX_REGL",
  /*   72 */  "RDX_REGL",
  /*   73 */  "R11_REGL",
  /*   74 */  "NO_RBP_R13_REGL",
  /*   75 */  "RFLAGSREG",
  /*   76 */  "RFLAGSREGU",
  /*   77 */  "RFLAGSREGUCF",
  /*   78 */  "REGF",
  /*   79 */  "LEGREGF",
  /*   80 */  "VLREGF",
  /*   81 */  "REGD",
  /*   82 */  "LEGREGD",
  /*   83 */  "VLREGD",
  /*   84 */  "INDIRECT",
  /*   85 */  "INDOFFSET8",
  /*   86 */  "INDOFFSET32",
  /*   87 */  "INDINDEXOFFSET",
  /*   88 */  "INDINDEX",
  /*   89 */  "INDINDEXSCALE",
  /*   90 */  "INDPOSINDEXSCALE",
  /*   91 */  "INDINDEXSCALEOFFSET",
  /*   92 */  "INDPOSINDEXOFFSET",
  /*   93 */  "INDPOSINDEXSCALEOFFSET",
  /*   94 */  "INDCOMPRESSEDOOPOFFSET",
  /*   95 */  "INDIRECTNARROW",
  /*   96 */  "INDOFFSET8NARROW",
  /*   97 */  "INDOFFSET32NARROW",
  /*   98 */  "INDINDEXOFFSETNARROW",
  /*   99 */  "INDINDEXNARROW",
  /*  100 */  "INDINDEXSCALENARROW",
  /*  101 */  "INDINDEXSCALEOFFSETNARROW",
  /*  102 */  "INDPOSINDEXOFFSETNARROW",
  /*  103 */  "INDPOSINDEXSCALEOFFSETNARROW",
  /*  104 */  "STACKSLOTP",
  /*  105 */  "STACKSLOTI",
  /*  106 */  "STACKSLOTF",
  /*  107 */  "STACKSLOTD",
  /*  108 */  "STACKSLOTL",
  /*  109 */  "CMPOP",
  /*  110 */  "CMPOPU",
  /*  111 */  "CMPOPUCF",
  /*  112 */  "CMPOPUCF2",
  /*  113 */  "RXMM0",
  /*  114 */  "VEC",
  /*  115 */  "LEGVEC",
  /*  116 */  "VECS",
  /*  117 */  "LEGVECS",
  /*  118 */  "VECD",
  /*  119 */  "LEGVECD",
  /*  120 */  "VECX",
  /*  121 */  "LEGVECX",
  /*  122 */  "VECY",
  /*  123 */  "LEGVECY",
  /*  124 */  "VECZ",
  /*  125 */  "LEGVECZ",
  /*  126 */  "NO_RAX_REGP",
  // last operand
  /*  127 */  "MEMORY",
  // last operand class
  /*  128 */  "_AddP_any_RegP_rRegL",
  /*  129 */  "_LShiftL_rRegL_immI2",
  /*  130 */  "_ConvI2L_rRegI_",
  /*  131 */  "_LShiftL__ConvI2L_rRegI__immI2",
  /*  132 */  "_AddP_any_RegP__LShiftL_rRegL_immI2",
  /*  133 */  "_AddP_any_RegP__ConvI2L_rRegI_",
  /*  134 */  "_AddP_any_RegP__LShiftL__ConvI2L_rRegI__immI2",
  /*  135 */  "_DecodeN_rRegN_",
  /*  136 */  "_AddP__DecodeN_rRegN__rRegL",
  /*  137 */  "_AddP__DecodeN_rRegN___LShiftL_rRegL_immI2",
  /*  138 */  "_AddP__DecodeN_rRegN___ConvI2L_rRegI_",
  /*  139 */  "_AddP__DecodeN_rRegN___LShiftL__ConvI2L_rRegI__immI2",
  /*  140 */  "_LoadB_memory_",
  /*  141 */  "_LoadUB_memory_",
  /*  142 */  "_AndI__LoadUB_memory__immI",
  /*  143 */  "_LoadS_memory_",
  /*  144 */  "_LShiftI__LoadS_memory__immI_24",
  /*  145 */  "_LoadUS_memory_",
  /*  146 */  "_LShiftI__LoadUS_memory__immI_24",
  /*  147 */  "_AndI__LoadUS_memory__immI_255",
  /*  148 */  "_AndI__LoadUS_memory__immI",
  /*  149 */  "_LoadI_memory_",
  /*  150 */  "_LShiftI__LoadI_memory__immI_24",
  /*  151 */  "_LShiftI__LoadI_memory__immI_16",
  /*  152 */  "_AndI__LoadI_memory__immI_255",
  /*  153 */  "_AndI__LoadI_memory__immI_65535",
  /*  154 */  "_AndI__LoadI_memory__immU31",
  /*  155 */  "_ConvI2L__LoadI_memory__",
  /*  156 */  "_LoadL_memory_",
  /*  157 */  "_CastP2X_rRegP_",
  /*  158 */  "_CastP2X__DecodeN_rRegN__",
  /*  159 */  "_AddL__LShiftL_rRegL_immI2_immL32",
  /*  160 */  "_Binary_cmpOp_rFlagsReg",
  /*  161 */  "_Binary_immI_1_rRegI",
  /*  162 */  "_Binary_rRegI_rRegI",
  /*  163 */  "_Binary_cmpOpU_rFlagsRegU",
  /*  164 */  "_Binary_cmpOpUCF_rFlagsRegUCF",
  /*  165 */  "_Binary_cmpOpUCF2_rFlagsRegUCF",
  /*  166 */  "_Binary_rRegI__LoadI_memory_",
  /*  167 */  "_Binary_rRegN_rRegN",
  /*  168 */  "_Binary_rRegP_rRegP",
  /*  169 */  "_Binary_immL1_rRegL",
  /*  170 */  "_Binary_rRegL_rRegL",
  /*  171 */  "_Binary_rRegL__LoadL_memory_",
  /*  172 */  "_Binary_regF_regF",
  /*  173 */  "_Binary_regD_regD",
  /*  174 */  "_AddI__LoadI_memory__rRegI",
  /*  175 */  "_AddI_rRegI__LoadI_memory_",
  /*  176 */  "_AddI__LoadI_memory__immI",
  /*  177 */  "_AddI__LoadI_memory__immI_1",
  /*  178 */  "_AddI__LoadI_memory__immI_M1",
  /*  179 */  "_LShiftI_rRegI_immI2",
  /*  180 */  "_AddI_rRegI_rRegI",
  /*  181 */  "_AddI_rRegI__LShiftI_rRegI_immI2",
  /*  182 */  "_AddI__LShiftI_rRegI_immI2_rRegI",
  /*  183 */  "_AddL__LoadL_memory__rRegL",
  /*  184 */  "_AddL_rRegL__LoadL_memory_",
  /*  185 */  "_AddL__LoadL_memory__immL32",
  /*  186 */  "_AddL__LoadL_memory__immL1",
  /*  187 */  "_AddL__LoadL_memory__immL_M1",
  /*  188 */  "_AddL_rRegL_rRegL",
  /*  189 */  "_AddL_rRegL__LShiftL_rRegL_immI2",
  /*  190 */  "_AddL__LShiftL_rRegL_immI2_rRegL",
  /*  191 */  "_Binary_rax_RegP_rRegP",
  /*  192 */  "_Binary_rax_RegL_rRegL",
  /*  193 */  "_Binary_rax_RegI_rRegI",
  /*  194 */  "_Binary_rax_RegN_rRegN",
  /*  195 */  "_SubI__LoadI_memory__rRegI",
  /*  196 */  "_SubL__LoadL_memory__rRegL",
  /*  197 */  "_SubI_immI_0_rRegI",
  /*  198 */  "_SubI_immI_0__LoadI_memory_",
  /*  199 */  "_SubL_immL0__LoadL_memory_",
  /*  200 */  "_LShiftI__LoadI_memory__immI8",
  /*  201 */  "_LShiftI__LoadI_memory__rcx_RegI",
  /*  202 */  "_RShiftI__LoadI_memory__immI8",
  /*  203 */  "_RShiftI__LoadI_memory__rcx_RegI",
  /*  204 */  "_URShiftI__LoadI_memory__immI8",
  /*  205 */  "_URShiftI__LoadI_memory__rcx_RegI",
  /*  206 */  "_LShiftL__LoadL_memory__immI8",
  /*  207 */  "_LShiftL__LoadL_memory__rcx_RegI",
  /*  208 */  "_RShiftL__LoadL_memory__immI",
  /*  209 */  "_RShiftL__LoadL_memory__rcx_RegI",
  /*  210 */  "_URShiftL__LoadL_memory__immI8",
  /*  211 */  "_URShiftL__LoadL_memory__rcx_RegI",
  /*  212 */  "_LShiftI_rRegI_immI_24",
  /*  213 */  "_LShiftI_rRegI_immI_16",
  /*  214 */  "_AndI_rRegI_immI_255",
  /*  215 */  "_AndI_rRegI_immI_65535",
  /*  216 */  "_AndI_rRegI_immI_Pow2M1",
  /*  217 */  "_AndI__LoadB_memory__rRegI",
  /*  218 */  "_AndI_rRegI__LoadB_memory_",
  /*  219 */  "_AndI__LoadI_memory__rRegI",
  /*  220 */  "_AndI_rRegI__LoadI_memory_",
  /*  221 */  "_AndI__LoadI_memory__immI",
  /*  222 */  "_XorI_rRegI_immI_M1",
  /*  223 */  "_AddI_rRegI_immI_M1",
  /*  224 */  "_OrI__LoadB_memory__rRegI",
  /*  225 */  "_OrI_rRegI__LoadB_memory_",
  /*  226 */  "_OrI__LoadI_memory__rRegI",
  /*  227 */  "_OrI_rRegI__LoadI_memory_",
  /*  228 */  "_OrI__LoadI_memory__immI",
  /*  229 */  "_XorI__LoadB_memory__rRegI",
  /*  230 */  "_XorI_rRegI__LoadB_memory_",
  /*  231 */  "_XorI__LoadI_memory__rRegI",
  /*  232 */  "_XorI_rRegI__LoadI_memory_",
  /*  233 */  "_XorI__LoadI_memory__immI",
  /*  234 */  "_AndL__LoadL_memory__rRegL",
  /*  235 */  "_AndL_rRegL__LoadL_memory_",
  /*  236 */  "_AndL__LoadL_memory__immL32",
  /*  237 */  "_AndL__LoadL_memory__immL_NotPow2",
  /*  238 */  "_XorL_rRegL_immL_M1",
  /*  239 */  "_SubL_immL0_rRegL",
  /*  240 */  "_AddL_rRegL_immL_M1",
  /*  241 */  "_CastP2X_any_RegP_",
  /*  242 */  "_OrL__LoadL_memory__rRegL",
  /*  243 */  "_OrL_rRegL__LoadL_memory_",
  /*  244 */  "_OrL__LoadL_memory__immL32",
  /*  245 */  "_OrL__LoadL_memory__immL_Pow2",
  /*  246 */  "_XorL__LoadL_memory__rRegL",
  /*  247 */  "_XorL_rRegL__LoadL_memory_",
  /*  248 */  "_XorL__LoadL_memory__immL32",
  /*  249 */  "_CmpLTMask_rRegI_rRegI",
  /*  250 */  "_AndI__CmpLTMask_rRegI_rRegI_rRegI",
  /*  251 */  "_SubI_rRegI_rRegI",
  /*  252 */  "_AndI_rRegI__CmpLTMask_rRegI_rRegI",
  /*  253 */  "_LoadF_memory_",
  /*  254 */  "_LoadD_memory_",
  /*  255 */  "_Binary_rdi_RegP_rcx_RegI",
  /*  256 */  "_Binary_rsi_RegP_rdx_RegI",
  /*  257 */  "_Binary_rdi_RegP_rdx_RegI",
  /*  258 */  "_Binary_rsi_RegP_immI",
  /*  259 */  "_Binary_rsi_RegP_rax_RegI",
  /*  260 */  "_Binary_rdi_RegP_rsi_RegP",
  /*  261 */  "_Binary_rbx_RegI_immU8",
  /*  262 */  "_AndI_rRegI_immI",
  /*  263 */  "_AndI_rRegI_rRegI",
  /*  264 */  "_LoadP_memory_",
  /*  265 */  "_LoadN_memory_",
  /*  266 */  "_LoadNKlass_memory_",
  /*  267 */  "_AndL_rRegL_immL32",
  /*  268 */  "_AndL_rRegL_rRegL",
  /*  269 */  "_AndL__CastP2X_rRegP___LoadL_memory_",
  /*  270 */  "_AndL__LoadL_memory___CastP2X_rRegP_",
  /*  271 */  "_AndI__LoadUB_memory__immU7",
  /*  272 */  "_AndI__LoadB_memory__immI8",
  /*  273 */  "_Binary_rax_RegP_immP",
  /*  274 */  "_ConvF2HF_regF_",
  /*  275 */  "_VectorCastF2HF_vec_",
  /*  276 */  "_LoadVector_memory_",
  /*  277 */  "_Binary_vec_kReg",
  /*  278 */  "_Binary_rRegP_immI_0",
  /*  279 */  "_Binary_rRegP_rRegI",
  /*  280 */  "_Binary_kReg_immI_0",
  /*  281 */  "_Binary_rRegP__Binary_kReg_immI_0",
  /*  282 */  "_Binary_kReg_rRegI",
  /*  283 */  "_Binary_rRegP__Binary_kReg_rRegI",
  /*  284 */  "_Binary_vec_immI_0",
  /*  285 */  "_Binary_rRegP__Binary_vec_immI_0",
  /*  286 */  "_Binary_vec_rRegI",
  /*  287 */  "_Binary_rRegP__Binary_vec_rRegI",
  /*  288 */  "_Binary_vec_vec",
  /*  289 */  "_Binary_vec__Binary_vec_kReg",
  /*  290 */  "_Binary_vec_rRegL",
  /*  291 */  "_Binary_vec_regF",
  /*  292 */  "_Binary_vec_regD",
  /*  293 */  "_Binary_vec__LoadVector_memory_",
  /*  294 */  "_Binary_regD_immD",
  /*  295 */  "_LShiftCntV_immI8_",
  /*  296 */  "_RShiftCntV_immI8_",
  /*  297 */  "_Binary_legVec_legVec",
  /*  298 */  "_MulAddVS2VI_vec_vec",
  /*  299 */  "_Binary_vec_immU8",
  /*  300 */  "_Binary__LoadVector_memory__immU8",
  /*  301 */  "_VectorStoreMask_vec_immI",
  /*  302 */  "_Binary_vec_immI8",
  /*  303 */  "_Binary_vec__LShiftCntV_immI8_",
  /*  304 */  "_Binary_vec__RShiftCntV_immI8_",
  /*  305 */  "_Binary__LoadVector_memory__kReg",
  /*  306 */  "_Binary_immI8_kReg",
  /*  307 */  "_MaskAll_immI_M1_",
  /*  308 */  "_Binary_immU8_kReg",
  /*  309 */  "_Binary_vec__Binary_immU8_kReg",
  /*  310 */  "_Binary_vec__Binary_vec__Binary_immU8_kReg",
  /*  311 */  "_Binary_memory__Binary_immU8_kReg",
  /*  312 */  "_Binary_vec__Binary_memory__Binary_immU8_kReg",
  /*  313 */  "_Binary_rax_RegP_no_rax_RegP",
  /*  314 */  "_EncodeP_any_RegP_",
  // last internally defined operand
  /*  315 */  "storeSSI",
  /*  316 */  "storeSSL",
  /*  317 */  "storeSSP",
  /*  318 */  "storeSSF",
  /*  319 */  "storeSSD",
  /*  320 */  "MoveF2VL",
  /*  321 */  "MoveF2LEG",
  /*  322 */  "MoveVL2F",
  /*  323 */  "MoveLEG2F",
  /*  324 */  "MoveD2VL",
  /*  325 */  "MoveD2LEG",
  /*  326 */  "MoveVL2D",
  /*  327 */  "MoveLEG2D",
  /*  328 */  "leaP8",
  /*  329 */  "leaP32",
  /*  330 */  "leaPIdxOff",
  /*  331 */  "leaPIdxScale",
  /*  332 */  "leaPPosIdxScale",
  /*  333 */  "leaPIdxScaleOff",
  /*  334 */  "leaPPosIdxOff",
  /*  335 */  "leaPPosIdxScaleOff",
  /*  336 */  "leaPCompressedOopOffset",
  /*  337 */  "leaP8Narrow",
  /*  338 */  "leaP32Narrow",
  /*  339 */  "leaPIdxOffNarrow",
  /*  340 */  "leaPIdxScaleNarrow",
  /*  341 */  "leaPIdxScaleOffNarrow",
  /*  342 */  "leaPPosIdxOffNarrow",
  /*  343 */  "leaPPosIdxScaleOffNarrow",
  /*  344 */  "loadConI",
  /*  345 */  "loadConI0",
  /*  346 */  "loadConL",
  /*  347 */  "loadConL0",
  /*  348 */  "loadConUL32",
  /*  349 */  "loadConL32",
  /*  350 */  "loadConP",
  /*  351 */  "loadConP0",
  /*  352 */  "loadConP31",
  /*  353 */  "loadConF",
  /*  354 */  "loadConN0",
  /*  355 */  "loadConN",
  /*  356 */  "loadConNKlass",
  /*  357 */  "loadConF0",
  /*  358 */  "loadConD",
  /*  359 */  "loadConD0",
  /*  360 */  "loadSSI",
  /*  361 */  "loadSSL",
  /*  362 */  "loadSSP",
  /*  363 */  "loadSSF",
  /*  364 */  "loadSSD",
  /*  365 */  "MoveVec2Leg",
  /*  366 */  "MoveLeg2Vec",
  /*  367 */  "membar_volatile",
  /*  368 */  "castX2P",
  /*  369 */  "castP2X",
  /*  370 */  "checkCastPP",
  /*  371 */  "castPP",
  /*  372 */  "castII",
  /*  373 */  "castLL",
  /*  374 */  "castFF",
  /*  375 */  "castDD",
  /*  376 */  "cmpF_cc_reg",
  /*  377 */  "cmpF_cc_reg_CF",
  /*  378 */  "cmpF_cc_memCF",
  /*  379 */  "cmpF_cc_immCF",
  /*  380 */  "cmpD_cc_reg",
  /*  381 */  "cmpD_cc_reg_CF",
  /*  382 */  "cmpD_cc_memCF",
  /*  383 */  "cmpD_cc_immCF",
  /*  384 */  "MoveF2I_stack_reg",
  /*  385 */  "MoveI2F_stack_reg",
  /*  386 */  "MoveD2L_stack_reg",
  /*  387 */  "MoveL2D_stack_reg_partial",
  /*  388 */  "MoveL2D_stack_reg",
  /*  389 */  "MoveF2I_reg_reg",
  /*  390 */  "MoveD2L_reg_reg",
  /*  391 */  "MoveI2F_reg_reg",
  /*  392 */  "MoveL2D_reg_reg",
  /*  393 */  "overflowAddI_rReg",
  /*  394 */  "overflowAddI_rReg_imm",
  /*  395 */  "overflowAddL_rReg",
  /*  396 */  "overflowAddL_rReg_imm",
  /*  397 */  "overflowSubI_rReg",
  /*  398 */  "overflowSubI_rReg_imm",
  /*  399 */  "overflowSubL_rReg",
  /*  400 */  "overflowSubL_rReg_imm",
  /*  401 */  "overflowNegI_rReg",
  /*  402 */  "overflowNegL_rReg",
  /*  403 */  "overflowMulI_rReg",
  /*  404 */  "overflowMulI_rReg_imm",
  /*  405 */  "overflowMulL_rReg",
  /*  406 */  "overflowMulL_rReg_imm",
  /*  407 */  "compI_rReg",
  /*  408 */  "compI_rReg_imm",
  /*  409 */  "compI_rReg_mem",
  /*  410 */  "testI_reg",
  /*  411 */  "testI_reg_imm",
  /*  412 */  "testI_reg_reg",
  /*  413 */  "testI_reg_mem",
  /*  414 */  "testI_reg_mem_0",
  /*  415 */  "compU_rReg",
  /*  416 */  "compU_rReg_imm",
  /*  417 */  "compU_rReg_mem",
  /*  418 */  "testU_reg",
  /*  419 */  "compP_rReg",
  /*  420 */  "compP_rReg_mem",
  /*  421 */  "compP_mem_rReg",
  /*  422 */  "testP_reg",
  /*  423 */  "testP_mem",
  /*  424 */  "testP_mem_reg0",
  /*  425 */  "compN_rReg",
  /*  426 */  "compN_rReg_mem",
  /*  427 */  "compN_rReg_imm",
  /*  428 */  "compN_mem_imm",
  /*  429 */  "compN_rReg_imm_klass",
  /*  430 */  "compN_mem_imm_klass",
  /*  431 */  "testN_reg",
  /*  432 */  "testN_mem",
  /*  433 */  "testN_mem_reg0",
  /*  434 */  "compL_rReg",
  /*  435 */  "compL_rReg_imm",
  /*  436 */  "compL_rReg_mem",
  /*  437 */  "testL_reg",
  /*  438 */  "testL_reg_imm",
  /*  439 */  "testL_reg_reg",
  /*  440 */  "testL_reg_mem",
  /*  441 */  "testL_reg_mem_0",
  /*  442 */  "testL_reg_mem2",
  /*  443 */  "testL_reg_mem2_0",
  /*  444 */  "compUL_rReg",
  /*  445 */  "compUL_rReg_imm",
  /*  446 */  "compUL_rReg_mem",
  /*  447 */  "testUL_reg",
  /*  448 */  "compB_mem_imm",
  /*  449 */  "testUB_mem_imm",
  /*  450 */  "testB_mem_imm",
  /*  451 */  "cmpFastLock",
  /*  452 */  "cmpFastUnlock",
  /*  453 */  "cmpFastLockLightweight",
  /*  454 */  "cmpFastUnlockLightweight",
  /*  455 */  "tlsLoadP",
  /*  456 */  "absF_reg",
  /*  457 */  "absF_reg_reg",
  /*  458 */  "absD_reg",
  /*  459 */  "absD_reg_reg",
  /*  460 */  "negF_reg",
  /*  461 */  "negF_reg_reg",
  /*  462 */  "negD_reg",
  /*  463 */  "negD_reg_reg",
  /*  464 */  "vconvF2HF",
  /*  465 */  "convHF2F_reg_reg",
  /*  466 */  "vconvHF2F_reg_mem",
  /*  467 */  "vconvHF2F",
  /*  468 */  "reinterpret_mask",
  /*  469 */  "reinterpret",
  /*  470 */  "vreinterpret_expand4",
  /*  471 */  "vreinterpret_expand",
  /*  472 */  "reinterpret_shrink",
  /*  473 */  "vReplB_reg",
  /*  474 */  "ReplB_mem",
  /*  475 */  "vReplS_reg",
  /*  476 */  "ReplS_mem",
  /*  477 */  "ReplI_reg",
  /*  478 */  "ReplI_mem",
  /*  479 */  "ReplI_imm",
  /*  480 */  "ReplI_zero",
  /*  481 */  "ReplI_M1",
  /*  482 */  "ReplL_reg",
  /*  483 */  "ReplL_mem",
  /*  484 */  "ReplL_imm",
  /*  485 */  "ReplL_zero",
  /*  486 */  "ReplL_M1",
  /*  487 */  "vReplF_reg",
  /*  488 */  "ReplF_reg",
  /*  489 */  "ReplF_mem",
  /*  490 */  "ReplF_imm",
  /*  491 */  "ReplF_zero",
  /*  492 */  "vReplD_reg",
  /*  493 */  "ReplD_reg",
  /*  494 */  "ReplD_mem",
  /*  495 */  "ReplD_imm",
  /*  496 */  "ReplD_zero",
  /*  497 */  "vsqrtF_reg",
  /*  498 */  "vsqrtF_mem",
  /*  499 */  "vsqrtD_reg",
  /*  500 */  "vsqrtD_mem",
  /*  501 */  "vshiftcnt",
  /*  502 */  "vshiftcnt_0",
  /*  503 */  "vcastBtoX",
  /*  504 */  "vcastBtoD",
  /*  505 */  "castStoX",
  /*  506 */  "vcastStoX_evex",
  /*  507 */  "castItoX",
  /*  508 */  "vcastItoX_evex",
  /*  509 */  "vcastLtoBS",
  /*  510 */  "vcastLtoX_evex",
  /*  511 */  "vcastFtoD_reg",
  /*  512 */  "vcastDtoF_reg",
  /*  513 */  "vucast",
  /*  514 */  "vucast_0",
  /*  515 */  "vucast_1",
  /*  516 */  "vabsB_reg",
  /*  517 */  "vabsS_reg",
  /*  518 */  "vabsI_reg",
  /*  519 */  "vabsL_reg",
  /*  520 */  "vabsnegF",
  /*  521 */  "vabsnegF_0",
  /*  522 */  "vabsneg4F",
  /*  523 */  "vabsneg4F_0",
  /*  524 */  "vabsnegD",
  /*  525 */  "vabsnegD_0",
  /*  526 */  "vptest_lt16",
  /*  527 */  "vptest_ge16",
  /*  528 */  "ktest_alltrue_le8",
  /*  529 */  "ktest_anytrue_le8",
  /*  530 */  "ktest_ge8",
  /*  531 */  "vmaskcast_evex",
  /*  532 */  "vmaskcast",
  /*  533 */  "vmaskcast_avx",
  /*  534 */  "loadIotaIndices",
  /*  535 */  "loadShuffleB",
  /*  536 */  "loadShuffleS_evex",
  /*  537 */  "loadShuffleI_avx",
  /*  538 */  "loadShuffleL_evex",
  /*  539 */  "vpopcount_integral_reg_evex",
  /*  540 */  "vpopcount_integral_reg_evex_0",
  /*  541 */  "vcount_leading_zeros_IL_reg_evex",
  /*  542 */  "long_to_mask_evex",
  /*  543 */  "castMM",
  /*  544 */  "castVV",
  /*  545 */  "castVVLeg",
  /*  546 */  "zLoadPNullCheck",
  /*  547 */  "loadB",
  /*  548 */  "loadB2L",
  /*  549 */  "loadUB",
  /*  550 */  "loadUB2L",
  /*  551 */  "loadUB2L_immI",
  /*  552 */  "loadS",
  /*  553 */  "loadS2B",
  /*  554 */  "loadS2L",
  /*  555 */  "loadUS",
  /*  556 */  "loadUS2B",
  /*  557 */  "loadUS2L",
  /*  558 */  "loadUS2L_immI_255",
  /*  559 */  "loadUS2L_immI",
  /*  560 */  "loadI",
  /*  561 */  "loadI2B",
  /*  562 */  "loadI2UB",
  /*  563 */  "loadI2S",
  /*  564 */  "loadI2US",
  /*  565 */  "loadI2L",
  /*  566 */  "loadI2L_immI_255",
  /*  567 */  "loadI2L_immI_65535",
  /*  568 */  "loadI2L_immU31",
  /*  569 */  "loadUI2L",
  /*  570 */  "loadL",
  /*  571 */  "loadRange",
  /*  572 */  "loadP",
  /*  573 */  "loadN",
  /*  574 */  "loadKlass",
  /*  575 */  "loadNKlass",
  /*  576 */  "loadNKlassCompactHeaders",
  /*  577 */  "loadF",
  /*  578 */  "loadD_partial",
  /*  579 */  "loadD",
  /*  580 */  "maxF_reg",
  /*  581 */  "maxF_reduction_reg",
  /*  582 */  "maxD_reg",
  /*  583 */  "maxD_reduction_reg",
  /*  584 */  "minF_reg",
  /*  585 */  "minF_reduction_reg",
  /*  586 */  "minD_reg",
  /*  587 */  "minD_reduction_reg",
  /*  588 */  "prefetchAlloc",
  /*  589 */  "prefetchAllocNTA",
  /*  590 */  "prefetchAllocT0",
  /*  591 */  "prefetchAllocT2",
  /*  592 */  "storeB",
  /*  593 */  "storeC",
  /*  594 */  "storeI",
  /*  595 */  "storeL",
  /*  596 */  "storeP",
  /*  597 */  "storeImmP0",
  /*  598 */  "storeImmP",
  /*  599 */  "storeN",
  /*  600 */  "storeNKlass",
  /*  601 */  "storeImmN0",
  /*  602 */  "storeImmN",
  /*  603 */  "storeImmNKlass",
  /*  604 */  "storeImmI0",
  /*  605 */  "storeImmI",
  /*  606 */  "storeImmL0",
  /*  607 */  "storeImmL",
  /*  608 */  "storeImmC0",
  /*  609 */  "storeImmI16",
  /*  610 */  "storeImmB0",
  /*  611 */  "storeImmB",
  /*  612 */  "storeF",
  /*  613 */  "storeF0",
  /*  614 */  "storeF_imm",
  /*  615 */  "storeD",
  /*  616 */  "storeD0_imm",
  /*  617 */  "storeD0",
  /*  618 */  "cacheWB",
  /*  619 */  "cacheWBPreSync",
  /*  620 */  "cacheWBPostSync",
  /*  621 */  "bytes_reverse_int",
  /*  622 */  "bytes_reverse_long",
  /*  623 */  "bytes_reverse_unsigned_short",
  /*  624 */  "bytes_reverse_short",
  /*  625 */  "countLeadingZerosI",
  /*  626 */  "countLeadingZerosI_mem",
  /*  627 */  "countLeadingZerosI_bsr",
  /*  628 */  "countLeadingZerosL",
  /*  629 */  "countLeadingZerosL_mem",
  /*  630 */  "countLeadingZerosL_bsr",
  /*  631 */  "countTrailingZerosI",
  /*  632 */  "countTrailingZerosI_mem",
  /*  633 */  "countTrailingZerosI_bsf",
  /*  634 */  "countTrailingZerosL",
  /*  635 */  "countTrailingZerosL_mem",
  /*  636 */  "countTrailingZerosL_bsf",
  /*  637 */  "bytes_reversebit_int",
  /*  638 */  "bytes_reversebit_int_gfni",
  /*  639 */  "bytes_reversebit_long",
  /*  640 */  "bytes_reversebit_long_gfni",
  /*  641 */  "popCountI",
  /*  642 */  "popCountI_mem",
  /*  643 */  "popCountL",
  /*  644 */  "popCountL_mem",
  /*  645 */  "membar_acquire",
  /*  646 */  "membar_acquire_0",
  /*  647 */  "membar_acquire_lock",
  /*  648 */  "membar_release",
  /*  649 */  "membar_release_0",
  /*  650 */  "membar_release_lock",
  /*  651 */  "unnecessary_membar_volatile",
  /*  652 */  "membar_storestore",
  /*  653 */  "membar_storestore_0",
  /*  654 */  "convP2I",
  /*  655 */  "convN2I",
  /*  656 */  "encodeHeapOop",
  /*  657 */  "encodeHeapOop_not_null",
  /*  658 */  "decodeHeapOop",
  /*  659 */  "decodeHeapOop_not_null",
  /*  660 */  "encodeKlass_not_null",
  /*  661 */  "decodeKlass_not_null",
  /*  662 */  "jumpXtnd_offset",
  /*  663 */  "jumpXtnd_addr",
  /*  664 */  "jumpXtnd",
  /*  665 */  "cmovI_imm_01",
  /*  666 */  "cmovI_reg",
  /*  667 */  "cmovI_imm_01U",
  /*  668 */  "cmovI_regU",
  /*  669 */  "cmovI_imm_01UCF",
  /*  670 */  "cmovI_regUCF",
  /*  671 */  "cmovI_regUCF2_ne",
  /*  672 */  "cmovI_regUCF2_eq",
  /*  673 */  "cmovI_mem",
  /*  674 */  "cmovI_memU",
  /*  675 */  "cmovI_memUCF",
  /*  676 */  "cmovN_reg",
  /*  677 */  "cmovN_regU",
  /*  678 */  "cmovN_regUCF",
  /*  679 */  "cmovN_regUCF2_ne",
  /*  680 */  "cmovN_regUCF2_eq",
  /*  681 */  "cmovP_reg",
  /*  682 */  "cmovP_regU",
  /*  683 */  "cmovP_regUCF",
  /*  684 */  "cmovP_regUCF2_ne",
  /*  685 */  "cmovP_regUCF2_eq",
  /*  686 */  "cmovL_imm_01",
  /*  687 */  "cmovL_reg",
  /*  688 */  "cmovL_mem",
  /*  689 */  "cmovL_imm_01U",
  /*  690 */  "cmovL_regU",
  /*  691 */  "cmovL_imm_01UCF",
  /*  692 */  "cmovL_regUCF",
  /*  693 */  "cmovL_regUCF2_ne",
  /*  694 */  "cmovL_regUCF2_eq",
  /*  695 */  "cmovL_memU",
  /*  696 */  "cmovL_memUCF",
  /*  697 */  "cmovF_reg",
  /*  698 */  "cmovF_regU",
  /*  699 */  "cmovF_regUCF",
  /*  700 */  "cmovD_reg",
  /*  701 */  "cmovD_regU",
  /*  702 */  "cmovD_regUCF",
  /*  703 */  "addI_rReg",
  /*  704 */  "addI_rReg_imm",
  /*  705 */  "addI_rReg_mem",
  /*  706 */  "addI_rReg_mem_0",
  /*  707 */  "addI_mem_rReg",
  /*  708 */  "addI_mem_rReg_0",
  /*  709 */  "addI_mem_imm",
  /*  710 */  "incI_rReg",
  /*  711 */  "incI_mem",
  /*  712 */  "decI_rReg",
  /*  713 */  "decI_mem",
  /*  714 */  "leaI_rReg_immI2_immI",
  /*  715 */  "leaI_rReg_rReg_immI",
  /*  716 */  "leaI_rReg_rReg_immI2",
  /*  717 */  "leaI_rReg_rReg_immI2_0",
  /*  718 */  "leaI_rReg_rReg_immI2_immI",
  /*  719 */  "leaI_rReg_rReg_immI2_immI_0",
  /*  720 */  "addL_rReg",
  /*  721 */  "addL_rReg_imm",
  /*  722 */  "addL_rReg_mem",
  /*  723 */  "addL_rReg_mem_0",
  /*  724 */  "addL_mem_rReg",
  /*  725 */  "addL_mem_rReg_0",
  /*  726 */  "addL_mem_imm",
  /*  727 */  "incL_rReg",
  /*  728 */  "incL_mem",
  /*  729 */  "decL_rReg",
  /*  730 */  "decL_mem",
  /*  731 */  "leaL_rReg_immI2_immL32",
  /*  732 */  "leaL_rReg_rReg_immL32",
  /*  733 */  "leaL_rReg_rReg_immI2",
  /*  734 */  "leaL_rReg_rReg_immI2_0",
  /*  735 */  "leaL_rReg_rReg_immI2_immL32",
  /*  736 */  "leaL_rReg_rReg_immI2_immL32_0",
  /*  737 */  "addP_rReg",
  /*  738 */  "addP_rReg_imm",
  /*  739 */  "compareAndSwapP",
  /*  740 */  "compareAndSwapP_0",
  /*  741 */  "compareAndSwapL",
  /*  742 */  "compareAndSwapL_0",
  /*  743 */  "compareAndSwapI",
  /*  744 */  "compareAndSwapI_0",
  /*  745 */  "compareAndSwapB",
  /*  746 */  "compareAndSwapB_0",
  /*  747 */  "compareAndSwapS",
  /*  748 */  "compareAndSwapS_0",
  /*  749 */  "compareAndSwapN",
  /*  750 */  "compareAndSwapN_0",
  /*  751 */  "compareAndExchangeB",
  /*  752 */  "compareAndExchangeS",
  /*  753 */  "compareAndExchangeI",
  /*  754 */  "compareAndExchangeL",
  /*  755 */  "compareAndExchangeN",
  /*  756 */  "compareAndExchangeP",
  /*  757 */  "xaddB_reg_no_res",
  /*  758 */  "xaddB_imm_no_res",
  /*  759 */  "xaddB",
  /*  760 */  "xaddS_reg_no_res",
  /*  761 */  "xaddS_imm_no_res",
  /*  762 */  "xaddS",
  /*  763 */  "xaddI_reg_no_res",
  /*  764 */  "xaddI_imm_no_res",
  /*  765 */  "xaddI",
  /*  766 */  "xaddL_reg_no_res",
  /*  767 */  "xaddL_imm_no_res",
  /*  768 */  "xaddL",
  /*  769 */  "xchgB",
  /*  770 */  "xchgS",
  /*  771 */  "xchgI",
  /*  772 */  "xchgL",
  /*  773 */  "xchgP",
  /*  774 */  "xchgN",
  /*  775 */  "absI_rReg",
  /*  776 */  "absL_rReg",
  /*  777 */  "subI_rReg",
  /*  778 */  "subI_rReg_mem",
  /*  779 */  "subI_mem_rReg",
  /*  780 */  "subL_rReg",
  /*  781 */  "subL_rReg_mem",
  /*  782 */  "subL_mem_rReg",
  /*  783 */  "subP_rReg",
  /*  784 */  "negI_rReg",
  /*  785 */  "negI_rReg_2",
  /*  786 */  "negI_mem",
  /*  787 */  "negL_rReg",
  /*  788 */  "negL_rReg_2",
  /*  789 */  "negL_mem",
  /*  790 */  "mulI_rReg",
  /*  791 */  "mulI_rReg_imm",
  /*  792 */  "mulI_mem",
  /*  793 */  "mulI_mem_0",
  /*  794 */  "mulI_mem_imm",
  /*  795 */  "mulAddS2I_rReg",
  /*  796 */  "mulL_rReg",
  /*  797 */  "mulL_rReg_imm",
  /*  798 */  "mulL_mem",
  /*  799 */  "mulL_mem_0",
  /*  800 */  "mulL_mem_imm",
  /*  801 */  "mulHiL_rReg",
  /*  802 */  "umulHiL_rReg",
  /*  803 */  "divI_rReg",
  /*  804 */  "divL_rReg",
  /*  805 */  "udivI_rReg",
  /*  806 */  "udivL_rReg",
  /*  807 */  "divModI_rReg_divmod",
  /*  808 */  "divModL_rReg_divmod",
  /*  809 */  "udivModI_rReg_divmod",
  /*  810 */  "udivModL_rReg_divmod",
  /*  811 */  "modI_rReg",
  /*  812 */  "modL_rReg",
  /*  813 */  "umodI_rReg",
  /*  814 */  "umodL_rReg",
  /*  815 */  "salI_rReg_immI2",
  /*  816 */  "salI_rReg_imm",
  /*  817 */  "salI_mem_imm",
  /*  818 */  "salI_rReg_CL",
  /*  819 */  "salI_mem_CL",
  /*  820 */  "salI_rReg_rReg",
  /*  821 */  "salI_mem_rReg",
  /*  822 */  "sarI_rReg_imm",
  /*  823 */  "sarI_mem_imm",
  /*  824 */  "sarI_rReg_CL",
  /*  825 */  "sarI_mem_CL",
  /*  826 */  "sarI_rReg_rReg",
  /*  827 */  "sarI_mem_rReg",
  /*  828 */  "shrI_rReg_imm",
  /*  829 */  "shrI_mem_imm",
  /*  830 */  "shrI_rReg_CL",
  /*  831 */  "shrI_mem_CL",
  /*  832 */  "shrI_rReg_rReg",
  /*  833 */  "shrI_mem_rReg",
  /*  834 */  "salL_rReg_immI2",
  /*  835 */  "salL_rReg_imm",
  /*  836 */  "salL_mem_imm",
  /*  837 */  "salL_rReg_CL",
  /*  838 */  "salL_mem_CL",
  /*  839 */  "salL_rReg_rReg",
  /*  840 */  "salL_mem_rReg",
  /*  841 */  "sarL_rReg_imm",
  /*  842 */  "sarL_mem_imm",
  /*  843 */  "sarL_rReg_CL",
  /*  844 */  "sarL_mem_CL",
  /*  845 */  "sarL_rReg_rReg",
  /*  846 */  "sarL_mem_rReg",
  /*  847 */  "shrL_rReg_imm",
  /*  848 */  "shrL_mem_imm",
  /*  849 */  "shrL_rReg_CL",
  /*  850 */  "shrL_mem_CL",
  /*  851 */  "shrL_rReg_rReg",
  /*  852 */  "shrL_mem_rReg",
  /*  853 */  "i2b",
  /*  854 */  "i2s",
  /*  855 */  "rolI_immI8_legacy",
  /*  856 */  "rolI_immI8",
  /*  857 */  "rolI_mem_immI8",
  /*  858 */  "rolI_rReg_Var",
  /*  859 */  "rorI_immI8_legacy",
  /*  860 */  "rorI_immI8",
  /*  861 */  "rorI_mem_immI8",
  /*  862 */  "rorI_rReg_Var",
  /*  863 */  "rolL_immI8_legacy",
  /*  864 */  "rolL_immI8",
  /*  865 */  "rolL_mem_immI8",
  /*  866 */  "rolL_rReg_Var",
  /*  867 */  "rorL_immI8_legacy",
  /*  868 */  "rorL_immI8",
  /*  869 */  "rorL_mem_immI8",
  /*  870 */  "rorL_rReg_Var",
  /*  871 */  "compressBitsL_reg",
  /*  872 */  "expandBitsL_reg",
  /*  873 */  "compressBitsL_mem",
  /*  874 */  "expandBitsL_mem",
  /*  875 */  "andI_rReg",
  /*  876 */  "andI_rReg_imm255",
  /*  877 */  "andI2L_rReg_imm255",
  /*  878 */  "andI_rReg_imm65535",
  /*  879 */  "andI2L_rReg_imm65535",
  /*  880 */  "convI2LAndI_reg_immIbitmask",
  /*  881 */  "andI_rReg_imm",
  /*  882 */  "andI_rReg_mem",
  /*  883 */  "andI_rReg_mem_0",
  /*  884 */  "andB_mem_rReg",
  /*  885 */  "andB_mem_rReg_0",
  /*  886 */  "andI_mem_rReg",
  /*  887 */  "andI_mem_rReg_0",
  /*  888 */  "andI_mem_imm",
  /*  889 */  "andnI_rReg_rReg_mem",
  /*  890 */  "andnI_rReg_rReg_mem_0",
  /*  891 */  "andnI_rReg_rReg_rReg",
  /*  892 */  "andnI_rReg_rReg_rReg_0",
  /*  893 */  "blsiI_rReg_rReg",
  /*  894 */  "blsiI_rReg_rReg_0",
  /*  895 */  "blsiI_rReg_mem",
  /*  896 */  "blsiI_rReg_mem_0",
  /*  897 */  "blsmskI_rReg_mem",
  /*  898 */  "blsmskI_rReg_mem_0",
  /*  899 */  "blsmskI_rReg_rReg",
  /*  900 */  "blsmskI_rReg_rReg_0",
  /*  901 */  "blsrI_rReg_rReg",
  /*  902 */  "blsrI_rReg_rReg_0",
  /*  903 */  "blsrI_rReg_mem",
  /*  904 */  "blsrI_rReg_mem_0",
  /*  905 */  "orI_rReg",
  /*  906 */  "orI_rReg_imm",
  /*  907 */  "orI_rReg_mem",
  /*  908 */  "orI_rReg_mem_0",
  /*  909 */  "orB_mem_rReg",
  /*  910 */  "orB_mem_rReg_0",
  /*  911 */  "orI_mem_rReg",
  /*  912 */  "orI_mem_rReg_0",
  /*  913 */  "orI_mem_imm",
  /*  914 */  "xorI_rReg",
  /*  915 */  "xorI_rReg_im1",
  /*  916 */  "xorI_rReg_imm",
  /*  917 */  "xorI_rReg_mem",
  /*  918 */  "xorI_rReg_mem_0",
  /*  919 */  "xorB_mem_rReg",
  /*  920 */  "xorB_mem_rReg_0",
  /*  921 */  "xorI_mem_rReg",
  /*  922 */  "xorI_mem_rReg_0",
  /*  923 */  "xorI_mem_imm",
  /*  924 */  "andL_rReg",
  /*  925 */  "andL_rReg_imm255",
  /*  926 */  "andL_rReg_imm65535",
  /*  927 */  "andL_rReg_imm",
  /*  928 */  "andL_rReg_mem",
  /*  929 */  "andL_rReg_mem_0",
  /*  930 */  "andL_mem_rReg",
  /*  931 */  "andL_mem_rReg_0",
  /*  932 */  "andL_mem_imm",
  /*  933 */  "btrL_mem_imm",
  /*  934 */  "andnL_rReg_rReg_mem",
  /*  935 */  "andnL_rReg_rReg_mem_0",
  /*  936 */  "andnL_rReg_rReg_rReg",
  /*  937 */  "andnL_rReg_rReg_rReg_0",
  /*  938 */  "blsiL_rReg_rReg",
  /*  939 */  "blsiL_rReg_rReg_0",
  /*  940 */  "blsiL_rReg_mem",
  /*  941 */  "blsiL_rReg_mem_0",
  /*  942 */  "blsmskL_rReg_mem",
  /*  943 */  "blsmskL_rReg_mem_0",
  /*  944 */  "blsmskL_rReg_rReg",
  /*  945 */  "blsmskL_rReg_rReg_0",
  /*  946 */  "blsrL_rReg_rReg",
  /*  947 */  "blsrL_rReg_rReg_0",
  /*  948 */  "blsrL_rReg_mem",
  /*  949 */  "blsrL_rReg_mem_0",
  /*  950 */  "orL_rReg",
  /*  951 */  "orL_rReg_castP2X",
  /*  952 */  "orL_rReg_castP2X_0",
  /*  953 */  "orL_rReg_imm",
  /*  954 */  "orL_rReg_mem",
  /*  955 */  "orL_rReg_mem_0",
  /*  956 */  "orL_mem_rReg",
  /*  957 */  "orL_mem_rReg_0",
  /*  958 */  "orL_mem_imm",
  /*  959 */  "btsL_mem_imm",
  /*  960 */  "xorL_rReg",
  /*  961 */  "xorL_rReg_im1",
  /*  962 */  "xorL_rReg_imm",
  /*  963 */  "xorL_rReg_mem",
  /*  964 */  "xorL_rReg_mem_0",
  /*  965 */  "xorL_mem_rReg",
  /*  966 */  "xorL_mem_rReg_0",
  /*  967 */  "xorL_mem_imm",
  /*  968 */  "cmpLTMask",
  /*  969 */  "cmpLTMask0",
  /*  970 */  "cadd_cmpLTMask",
  /*  971 */  "cadd_cmpLTMask_1",
  /*  972 */  "cadd_cmpLTMask_0",
  /*  973 */  "cadd_cmpLTMask_2",
  /*  974 */  "and_cmpLTMask",
  /*  975 */  "and_cmpLTMask_0",
  /*  976 */  "cmpF_reg",
  /*  977 */  "cmpF_mem",
  /*  978 */  "cmpF_imm",
  /*  979 */  "cmpD_reg",
  /*  980 */  "cmpD_mem",
  /*  981 */  "cmpD_imm",
  /*  982 */  "convF2D_reg_reg",
  /*  983 */  "convF2D_reg_mem",
  /*  984 */  "convD2F_reg_reg",
  /*  985 */  "convD2F_reg_mem",
  /*  986 */  "convF2I_reg_reg",
  /*  987 */  "convF2L_reg_reg",
  /*  988 */  "convD2I_reg_reg",
  /*  989 */  "convD2L_reg_reg",
  /*  990 */  "round_double_reg",
  /*  991 */  "round_float_reg",
  /*  992 */  "convI2F_reg_reg",
  /*  993 */  "convI2F_reg_mem",
  /*  994 */  "convI2D_reg_reg",
  /*  995 */  "convI2D_reg_mem",
  /*  996 */  "convXI2F_reg",
  /*  997 */  "convXI2D_reg",
  /*  998 */  "convL2F_reg_reg",
  /*  999 */  "convL2F_reg_mem",
  /* 1000 */  "convL2D_reg_reg",
  /* 1001 */  "convL2D_reg_mem",
  /* 1002 */  "convI2L_reg_reg",
  /* 1003 */  "convI2L_reg_reg_zex",
  /* 1004 */  "convI2L_reg_mem_zex",
  /* 1005 */  "zerox_long_reg_reg",
  /* 1006 */  "convL2I_reg_reg",
  /* 1007 */  "MoveF2I_reg_stack",
  /* 1008 */  "MoveI2F_reg_stack",
  /* 1009 */  "MoveD2L_reg_stack",
  /* 1010 */  "MoveL2D_reg_stack",
  /* 1011 */  "rep_stos",
  /* 1012 */  "rep_stos_evex",
  /* 1013 */  "rep_stos_large",
  /* 1014 */  "rep_stos_large_evex",
  /* 1015 */  "rep_stos_im",
  /* 1016 */  "string_compareL",
  /* 1017 */  "string_compareL_evex",
  /* 1018 */  "string_compareU",
  /* 1019 */  "string_compareU_evex",
  /* 1020 */  "string_compareLU",
  /* 1021 */  "string_compareLU_evex",
  /* 1022 */  "string_compareUL",
  /* 1023 */  "string_compareUL_evex",
  /* 1024 */  "string_indexof_conL",
  /* 1025 */  "string_indexof_conU",
  /* 1026 */  "string_indexof_conUL",
  /* 1027 */  "string_indexofL",
  /* 1028 */  "string_indexofU",
  /* 1029 */  "string_indexofUL",
  /* 1030 */  "string_indexof_char",
  /* 1031 */  "stringL_indexof_char",
  /* 1032 */  "string_equals",
  /* 1033 */  "string_equals_evex",
  /* 1034 */  "array_equalsB",
  /* 1035 */  "array_equalsB_evex",
  /* 1036 */  "array_equalsC",
  /* 1037 */  "array_equalsC_evex",
  /* 1038 */  "arrays_hashcode",
  /* 1039 */  "count_positives",
  /* 1040 */  "count_positives_evex",
  /* 1041 */  "string_compress",
  /* 1042 */  "string_compress_evex",
  /* 1043 */  "string_inflate",
  /* 1044 */  "string_inflate_evex",
  /* 1045 */  "encode_iso_array",
  /* 1046 */  "encode_ascii_array",
  /* 1047 */  "cmpU3_reg_reg",
  /* 1048 */  "cmpL3_reg_reg",
  /* 1049 */  "cmpUL3_reg_reg",
  /* 1050 */  "cmovI_reg_g",
  /* 1051 */  "minI_rReg",
  /* 1052 */  "cmovI_reg_l",
  /* 1053 */  "maxI_rReg",
  /* 1054 */  "jmpDir",
  /* 1055 */  "jmpCon",
  /* 1056 */  "jmpLoopEnd",
  /* 1057 */  "jmpConU",
  /* 1058 */  "jmpConUCF",
  /* 1059 */  "jmpConUCF2",
  /* 1060 */  "partialSubtypeCheck",
  /* 1061 */  "partialSubtypeCheckVarSuper",
  /* 1062 */  "partialSubtypeCheckConstSuper",
  /* 1063 */  "jmpDir_short",
  /* 1064 */  "jmpCon_short",
  /* 1065 */  "jmpLoopEnd_short",
  /* 1066 */  "jmpConU_short",
  /* 1067 */  "jmpConUCF_short",
  /* 1068 */  "jmpConUCF2_short",
  /* 1069 */  "safePoint_poll_tls",
  /* 1070 */  "mask_all_evexL",
  /* 1071 */  "mask_all_evexI_GT32",
  /* 1072 */  "CallStaticJavaDirect",
  /* 1073 */  "CallDynamicJavaDirect",
  /* 1074 */  "CallRuntimeDirect",
  /* 1075 */  "CallLeafDirect",
  /* 1076 */  "CallLeafDirectVector",
  /* 1077 */  "CallLeafNoFPDirect",
  /* 1078 */  "Ret",
  /* 1079 */  "TailCalljmpInd",
  /* 1080 */  "tailjmpInd",
  /* 1081 */  "ForwardExceptionjmp",
  /* 1082 */  "CreateException",
  /* 1083 */  "RethrowException",
  /* 1084 */  "leaI_rReg_rReg_peep",
  /* 1085 */  "leaI_rReg_immI_peep",
  /* 1086 */  "leaI_rReg_immI2_peep",
  /* 1087 */  "leaL_rReg_rReg_peep",
  /* 1088 */  "leaL_rReg_immL32_peep",
  /* 1089 */  "leaL_rReg_immI2_peep",
  /* 1090 */  "ShouldNotReachHere",
  /* 1091 */  "addF_reg",
  /* 1092 */  "addF_mem",
  /* 1093 */  "addF_mem_0",
  /* 1094 */  "addF_imm",
  /* 1095 */  "addF_reg_reg",
  /* 1096 */  "addF_reg_mem",
  /* 1097 */  "addF_reg_mem_0",
  /* 1098 */  "addF_reg_imm",
  /* 1099 */  "addD_reg",
  /* 1100 */  "addD_mem",
  /* 1101 */  "addD_mem_0",
  /* 1102 */  "addD_imm",
  /* 1103 */  "addD_reg_reg",
  /* 1104 */  "addD_reg_mem",
  /* 1105 */  "addD_reg_mem_0",
  /* 1106 */  "addD_reg_imm",
  /* 1107 */  "subF_reg",
  /* 1108 */  "subF_mem",
  /* 1109 */  "subF_imm",
  /* 1110 */  "subF_reg_reg",
  /* 1111 */  "subF_reg_mem",
  /* 1112 */  "subF_reg_imm",
  /* 1113 */  "subD_reg",
  /* 1114 */  "subD_mem",
  /* 1115 */  "subD_imm",
  /* 1116 */  "subD_reg_reg",
  /* 1117 */  "subD_reg_mem",
  /* 1118 */  "subD_reg_imm",
  /* 1119 */  "mulF_reg",
  /* 1120 */  "mulF_mem",
  /* 1121 */  "mulF_mem_0",
  /* 1122 */  "mulF_imm",
  /* 1123 */  "mulF_reg_reg",
  /* 1124 */  "mulF_reg_mem",
  /* 1125 */  "mulF_reg_mem_0",
  /* 1126 */  "mulF_reg_imm",
  /* 1127 */  "mulD_reg",
  /* 1128 */  "mulD_mem",
  /* 1129 */  "mulD_mem_0",
  /* 1130 */  "mulD_imm",
  /* 1131 */  "mulD_reg_reg",
  /* 1132 */  "mulD_reg_mem",
  /* 1133 */  "mulD_reg_mem_0",
  /* 1134 */  "mulD_reg_imm",
  /* 1135 */  "divF_reg",
  /* 1136 */  "divF_mem",
  /* 1137 */  "divF_imm",
  /* 1138 */  "divF_reg_reg",
  /* 1139 */  "divF_reg_mem",
  /* 1140 */  "divF_reg_imm",
  /* 1141 */  "divD_reg",
  /* 1142 */  "divD_mem",
  /* 1143 */  "divD_imm",
  /* 1144 */  "divD_reg_reg",
  /* 1145 */  "divD_reg_mem",
  /* 1146 */  "divD_reg_imm",
  /* 1147 */  "sqrtF_reg",
  /* 1148 */  "sqrtD_reg",
  /* 1149 */  "convF2HF_reg_reg",
  /* 1150 */  "convF2HF_mem_reg",
  /* 1151 */  "vconvF2HF_mem_reg",
  /* 1152 */  "reinterpret_mask_W2B",
  /* 1153 */  "reinterpret_mask_D2B",
  /* 1154 */  "reinterpret_mask_Q2B",
  /* 1155 */  "reinterpret_expand",
  /* 1156 */  "roundD_reg",
  /* 1157 */  "roundD_imm",
  /* 1158 */  "vroundD_reg",
  /* 1159 */  "vround8D_reg",
  /* 1160 */  "vroundD_mem",
  /* 1161 */  "vround8D_mem",
  /* 1162 */  "onspinwait",
  /* 1163 */  "fmaD_reg",
  /* 1164 */  "fmaF_reg",
  /* 1165 */  "loadV",
  /* 1166 */  "storeV",
  /* 1167 */  "gather",
  /* 1168 */  "evgather",
  /* 1169 */  "evgather_masked",
  /* 1170 */  "vgather_subwordLE8B",
  /* 1171 */  "vgather_subwordGT8B",
  /* 1172 */  "vgather_subwordLE8B_off",
  /* 1173 */  "vgather_subwordGT8B_off",
  /* 1174 */  "vgather_masked_subwordLE8B_avx3",
  /* 1175 */  "vgather_masked_subwordGT8B_avx3",
  /* 1176 */  "vgather_masked_subwordLE8B_off_avx3",
  /* 1177 */  "vgather_masked_subwordGT8B_off_avx3",
  /* 1178 */  "vgather_masked_subwordLE8B_avx2",
  /* 1179 */  "vgather_masked_subwordGT8B_avx2",
  /* 1180 */  "vgather_masked_subwordLE8B_off_avx2",
  /* 1181 */  "vgather_masked_subwordGT8B_off_avx2",
  /* 1182 */  "scatter",
  /* 1183 */  "scatter_masked",
  /* 1184 */  "insert",
  /* 1185 */  "insert32",
  /* 1186 */  "insert64",
  /* 1187 */  "insert2L",
  /* 1188 */  "insert4L",
  /* 1189 */  "insert8L",
  /* 1190 */  "insertF",
  /* 1191 */  "vinsertF",
  /* 1192 */  "insert2D",
  /* 1193 */  "insert4D",
  /* 1194 */  "insert8D",
  /* 1195 */  "reductionI",
  /* 1196 */  "reductionI_0",
  /* 1197 */  "reductionI_1",
  /* 1198 */  "reductionI_2",
  /* 1199 */  "reductionI_3",
  /* 1200 */  "reductionI_4",
  /* 1201 */  "reductionI_5",
  /* 1202 */  "reductionL",
  /* 1203 */  "reductionL_0",
  /* 1204 */  "reductionL_1",
  /* 1205 */  "reductionL_2",
  /* 1206 */  "reductionL_3",
  /* 1207 */  "reductionL_4",
  /* 1208 */  "reductionL_5",
  /* 1209 */  "reductionL_avx512dq",
  /* 1210 */  "reductionL_avx512dq_0",
  /* 1211 */  "reductionL_avx512dq_1",
  /* 1212 */  "reductionL_avx512dq_2",
  /* 1213 */  "reductionL_avx512dq_3",
  /* 1214 */  "reductionL_avx512dq_4",
  /* 1215 */  "reductionL_avx512dq_5",
  /* 1216 */  "reductionF128",
  /* 1217 */  "reductionF128_0",
  /* 1218 */  "reduction8F",
  /* 1219 */  "reduction8F_0",
  /* 1220 */  "reduction16F",
  /* 1221 */  "reduction16F_0",
  /* 1222 */  "unordered_reduction2F",
  /* 1223 */  "unordered_reduction2F_0",
  /* 1224 */  "unordered_reduction4F",
  /* 1225 */  "unordered_reduction4F_0",
  /* 1226 */  "unordered_reduction8F",
  /* 1227 */  "unordered_reduction8F_0",
  /* 1228 */  "unordered_reduction16F",
  /* 1229 */  "unordered_reduction16F_0",
  /* 1230 */  "reduction2D",
  /* 1231 */  "reduction2D_0",
  /* 1232 */  "reduction4D",
  /* 1233 */  "reduction4D_0",
  /* 1234 */  "reduction8D",
  /* 1235 */  "reduction8D_0",
  /* 1236 */  "unordered_reduction2D",
  /* 1237 */  "unordered_reduction2D_0",
  /* 1238 */  "unordered_reduction4D",
  /* 1239 */  "unordered_reduction4D_0",
  /* 1240 */  "unordered_reduction8D",
  /* 1241 */  "unordered_reduction8D_0",
  /* 1242 */  "reductionB",
  /* 1243 */  "reductionB_0",
  /* 1244 */  "reductionB_1",
  /* 1245 */  "reductionB_2",
  /* 1246 */  "reductionB_3",
  /* 1247 */  "reductionB_4",
  /* 1248 */  "reductionB_avx512bw",
  /* 1249 */  "reductionB_avx512bw_0",
  /* 1250 */  "reductionB_avx512bw_1",
  /* 1251 */  "reductionB_avx512bw_2",
  /* 1252 */  "reductionB_avx512bw_3",
  /* 1253 */  "reductionB_avx512bw_4",
  /* 1254 */  "reductionS",
  /* 1255 */  "reductionS_0",
  /* 1256 */  "reductionS_1",
  /* 1257 */  "reductionS_2",
  /* 1258 */  "reductionS_3",
  /* 1259 */  "reductionS_4",
  /* 1260 */  "reductionS_5",
  /* 1261 */  "mul_reductionB",
  /* 1262 */  "mul_reduction64B",
  /* 1263 */  "minmax_reduction2F",
  /* 1264 */  "minmax_reduction2F_0",
  /* 1265 */  "minmax_reductionF",
  /* 1266 */  "minmax_reductionF_0",
  /* 1267 */  "minmax_reduction2F_av",
  /* 1268 */  "minmax_reduction2F_av_0",
  /* 1269 */  "minmax_reductionF_av",
  /* 1270 */  "minmax_reductionF_av_0",
  /* 1271 */  "minmax_reduction2D",
  /* 1272 */  "minmax_reduction2D_0",
  /* 1273 */  "minmax_reductionD",
  /* 1274 */  "minmax_reductionD_0",
  /* 1275 */  "minmax_reduction2D_av",
  /* 1276 */  "minmax_reduction2D_av_0",
  /* 1277 */  "minmax_reductionD_av",
  /* 1278 */  "minmax_reductionD_av_0",
  /* 1279 */  "vaddB",
  /* 1280 */  "vaddB_reg",
  /* 1281 */  "vaddB_mem",
  /* 1282 */  "vaddB_mem_0",
  /* 1283 */  "vaddS",
  /* 1284 */  "vaddS_reg",
  /* 1285 */  "vaddS_mem",
  /* 1286 */  "vaddS_mem_0",
  /* 1287 */  "vaddI",
  /* 1288 */  "vaddI_reg",
  /* 1289 */  "vaddI_mem",
  /* 1290 */  "vaddI_mem_0",
  /* 1291 */  "vaddL",
  /* 1292 */  "vaddL_reg",
  /* 1293 */  "vaddL_mem",
  /* 1294 */  "vaddL_mem_0",
  /* 1295 */  "vaddF",
  /* 1296 */  "vaddF_reg",
  /* 1297 */  "vaddF_mem",
  /* 1298 */  "vaddF_mem_0",
  /* 1299 */  "vaddD",
  /* 1300 */  "vaddD_reg",
  /* 1301 */  "vaddD_mem",
  /* 1302 */  "vaddD_mem_0",
  /* 1303 */  "vsubB",
  /* 1304 */  "vsubB_reg",
  /* 1305 */  "vsubB_mem",
  /* 1306 */  "vsubS",
  /* 1307 */  "vsubS_reg",
  /* 1308 */  "vsubS_mem",
  /* 1309 */  "vsubI",
  /* 1310 */  "vsubI_reg",
  /* 1311 */  "vsubI_mem",
  /* 1312 */  "vsubL",
  /* 1313 */  "vsubL_reg",
  /* 1314 */  "vsubL_mem",
  /* 1315 */  "vsubF",
  /* 1316 */  "vsubF_reg",
  /* 1317 */  "vsubF_mem",
  /* 1318 */  "vsubD",
  /* 1319 */  "vsubD_reg",
  /* 1320 */  "vsubD_mem",
  /* 1321 */  "vmul8B",
  /* 1322 */  "vmulB",
  /* 1323 */  "vmulB_reg",
  /* 1324 */  "vmulS",
  /* 1325 */  "vmulS_reg",
  /* 1326 */  "vmulS_mem",
  /* 1327 */  "vmulS_mem_0",
  /* 1328 */  "vmulI",
  /* 1329 */  "vmulI_reg",
  /* 1330 */  "vmulI_mem",
  /* 1331 */  "vmulI_mem_0",
  /* 1332 */  "evmulL_reg",
  /* 1333 */  "evmulL_mem",
  /* 1334 */  "evmulL_mem_0",
  /* 1335 */  "vmulL",
  /* 1336 */  "vmulL_reg",
  /* 1337 */  "vmuludq_reg",
  /* 1338 */  "vmuldq_reg",
  /* 1339 */  "vmulF",
  /* 1340 */  "vmulF_reg",
  /* 1341 */  "vmulF_mem",
  /* 1342 */  "vmulF_mem_0",
  /* 1343 */  "vmulD",
  /* 1344 */  "vmulD_reg",
  /* 1345 */  "vmulD_mem",
  /* 1346 */  "vmulD_mem_0",
  /* 1347 */  "vdivF",
  /* 1348 */  "vdivF_reg",
  /* 1349 */  "vdivF_mem",
  /* 1350 */  "vdivD",
  /* 1351 */  "vdivD_reg",
  /* 1352 */  "vdivD_mem",
  /* 1353 */  "minmax_reg_sse",
  /* 1354 */  "minmax_reg_sse_0",
  /* 1355 */  "vminmax_reg",
  /* 1356 */  "vminmax_reg_0",
  /* 1357 */  "minmaxL_reg_sse",
  /* 1358 */  "minmaxL_reg_sse_0",
  /* 1359 */  "vminmaxL_reg_avx",
  /* 1360 */  "vminmaxL_reg_avx_0",
  /* 1361 */  "vminmaxL_reg_evex",
  /* 1362 */  "vminmaxL_reg_evex_0",
  /* 1363 */  "minmaxFP_reg",
  /* 1364 */  "minmaxFP_reg_0",
  /* 1365 */  "evminmaxFP_reg_eavx",
  /* 1366 */  "evminmaxFP_reg_eavx_0",
  /* 1367 */  "vector_uminmax_reg",
  /* 1368 */  "vector_uminmax_reg_0",
  /* 1369 */  "vector_uminmax_mem",
  /* 1370 */  "vector_uminmax_mem_0",
  /* 1371 */  "vector_uminmaxq_reg",
  /* 1372 */  "vector_uminmaxq_reg_0",
  /* 1373 */  "vector_uminmax_reg_masked",
  /* 1374 */  "vector_uminmax_reg_masked_0",
  /* 1375 */  "vector_uminmax_mem_masked",
  /* 1376 */  "vector_uminmax_mem_masked_0",
  /* 1377 */  "signumF_reg",
  /* 1378 */  "signumD_reg",
  /* 1379 */  "signumV_reg_avx",
  /* 1380 */  "signumV_reg_avx_0",
  /* 1381 */  "signumV_reg_evex",
  /* 1382 */  "signumV_reg_evex_0",
  /* 1383 */  "copySignF_reg",
  /* 1384 */  "copySignD_imm",
  /* 1385 */  "compressBitsI_reg",
  /* 1386 */  "expandBitsI_reg",
  /* 1387 */  "compressBitsI_mem",
  /* 1388 */  "expandBitsI_mem",
  /* 1389 */  "vshiftB",
  /* 1390 */  "vshiftB_0",
  /* 1391 */  "vshiftB_1",
  /* 1392 */  "vshift16B",
  /* 1393 */  "vshift16B_0",
  /* 1394 */  "vshift16B_1",
  /* 1395 */  "vshift16B_avx",
  /* 1396 */  "vshift16B_avx_0",
  /* 1397 */  "vshift16B_avx_1",
  /* 1398 */  "vshift32B_avx",
  /* 1399 */  "vshift32B_avx_0",
  /* 1400 */  "vshift32B_avx_1",
  /* 1401 */  "vshift64B_avx",
  /* 1402 */  "vshift64B_avx_0",
  /* 1403 */  "vshift64B_avx_1",
  /* 1404 */  "vshiftS",
  /* 1405 */  "vshiftS_0",
  /* 1406 */  "vshiftS_1",
  /* 1407 */  "vshiftI",
  /* 1408 */  "vshiftI_0",
  /* 1409 */  "vshiftI_1",
  /* 1410 */  "vshiftI_imm",
  /* 1411 */  "vshiftI_imm_0",
  /* 1412 */  "vshiftI_imm_1",
  /* 1413 */  "vshiftL",
  /* 1414 */  "vshiftL_0",
  /* 1415 */  "vshiftL_imm",
  /* 1416 */  "vshiftL_imm_0",
  /* 1417 */  "vshiftL_arith_reg",
  /* 1418 */  "vshiftL_arith_reg_evex",
  /* 1419 */  "vshift8B_var_nobw",
  /* 1420 */  "vshift8B_var_nobw_0",
  /* 1421 */  "vshift8B_var_nobw_1",
  /* 1422 */  "vshift16B_var_nobw",
  /* 1423 */  "vshift16B_var_nobw_0",
  /* 1424 */  "vshift16B_var_nobw_1",
  /* 1425 */  "vshift32B_var_nobw",
  /* 1426 */  "vshift32B_var_nobw_0",
  /* 1427 */  "vshift32B_var_nobw_1",
  /* 1428 */  "vshiftB_var_evex_bw",
  /* 1429 */  "vshiftB_var_evex_bw_0",
  /* 1430 */  "vshiftB_var_evex_bw_1",
  /* 1431 */  "vshift64B_var_evex_bw",
  /* 1432 */  "vshift64B_var_evex_bw_0",
  /* 1433 */  "vshift64B_var_evex_bw_1",
  /* 1434 */  "vshift8S_var_nobw",
  /* 1435 */  "vshift8S_var_nobw_0",
  /* 1436 */  "vshift8S_var_nobw_1",
  /* 1437 */  "vshift16S_var_nobw",
  /* 1438 */  "vshift16S_var_nobw_0",
  /* 1439 */  "vshift16S_var_nobw_1",
  /* 1440 */  "vshift16S_var_evex_bw",
  /* 1441 */  "vshift16S_var_evex_bw_0",
  /* 1442 */  "vshift16S_var_evex_bw_1",
  /* 1443 */  "vshiftI_var",
  /* 1444 */  "vshiftI_var_0",
  /* 1445 */  "vshiftI_var_1",
  /* 1446 */  "vshiftL_var",
  /* 1447 */  "vshiftL_var_0",
  /* 1448 */  "vshiftL_arith_var",
  /* 1449 */  "vshiftL_arith_var_evex",
  /* 1450 */  "vand",
  /* 1451 */  "vand_reg",
  /* 1452 */  "vand_mem",
  /* 1453 */  "vand_mem_0",
  /* 1454 */  "vor",
  /* 1455 */  "vor_reg",
  /* 1456 */  "vor_mem",
  /* 1457 */  "vor_mem_0",
  /* 1458 */  "vxor",
  /* 1459 */  "vxor_reg",
  /* 1460 */  "vxor_mem",
  /* 1461 */  "vxor_mem_0",
  /* 1462 */  "vcastStoX",
  /* 1463 */  "vcastItoX",
  /* 1464 */  "castFtoX_reg_avx",
  /* 1465 */  "castFtoX_reg_evex",
  /* 1466 */  "castDtoX_reg_avx",
  /* 1467 */  "castDtoX_reg_evex",
  /* 1468 */  "vround_float_avx",
  /* 1469 */  "vround_float_evex",
  /* 1470 */  "vround_reg_evex",
  /* 1471 */  "vcmpFD",
  /* 1472 */  "evcmpFD64",
  /* 1473 */  "evcmpFD",
  /* 1474 */  "vcmp_direct",
  /* 1475 */  "vcmp_negate",
  /* 1476 */  "vcmpu",
  /* 1477 */  "vcmp64",
  /* 1478 */  "evcmp",
  /* 1479 */  "extractI",
  /* 1480 */  "extractI_0",
  /* 1481 */  "extractI_1",
  /* 1482 */  "vextractI",
  /* 1483 */  "vextractI_0",
  /* 1484 */  "vextractI_1",
  /* 1485 */  "extractL",
  /* 1486 */  "vextractL",
  /* 1487 */  "extractF",
  /* 1488 */  "vextractF",
  /* 1489 */  "extractD",
  /* 1490 */  "vextractD",
  /* 1491 */  "blendvp",
  /* 1492 */  "vblendvpI",
  /* 1493 */  "vblendvpFD",
  /* 1494 */  "vblendvp",
  /* 1495 */  "evblendvp64",
  /* 1496 */  "evblendvp64_masked",
  /* 1497 */  "loadMask",
  /* 1498 */  "loadMask64",
  /* 1499 */  "loadMask_evex",
  /* 1500 */  "vstoreMask1B",
  /* 1501 */  "vstoreMask2B",
  /* 1502 */  "vstoreMask4B",
  /* 1503 */  "storeMask8B",
  /* 1504 */  "storeMask8B_avx",
  /* 1505 */  "vstoreMask4B_evex_novectmask",
  /* 1506 */  "vstoreMask8B_evex_novectmask",
  /* 1507 */  "vstoreMask_evex_vectmask",
  /* 1508 */  "vstoreMask_evex",
  /* 1509 */  "VectorPopulateIndex",
  /* 1510 */  "VectorPopulateLIndex",
  /* 1511 */  "rearrangeB",
  /* 1512 */  "rearrangeB_avx",
  /* 1513 */  "rearrangeB_evex",
  /* 1514 */  "rearrangeB_evex_vbmi",
  /* 1515 */  "loadShuffleS",
  /* 1516 */  "rearrangeS",
  /* 1517 */  "rearrangeS_avx",
  /* 1518 */  "rearrangeS_evex",
  /* 1519 */  "loadShuffleI",
  /* 1520 */  "rearrangeI",
  /* 1521 */  "rearrangeI_avx",
  /* 1522 */  "loadShuffleL",
  /* 1523 */  "rearrangeL",
  /* 1524 */  "rearrangeL_evex",
  /* 1525 */  "vfmaF_reg",
  /* 1526 */  "vfmaF_mem",
  /* 1527 */  "vfmaD_reg",
  /* 1528 */  "vfmaD_mem",
  /* 1529 */  "vmuladdS2I_reg_sse",
  /* 1530 */  "vmuladdS2I_reg_avx",
  /* 1531 */  "vmuladdaddS2I_reg",
  /* 1532 */  "vmuladdaddS2I_reg_0",
  /* 1533 */  "vpopcount_integral_reg_evex_masked",
  /* 1534 */  "vpopcount_integral_reg_evex_masked_0",
  /* 1535 */  "vpopcount_avx_reg",
  /* 1536 */  "vpopcount_avx_reg_0",
  /* 1537 */  "vcount_trailing_zeros_reg_evex",
  /* 1538 */  "vcount_trailing_zeros_short_reg_evex",
  /* 1539 */  "vcount_trailing_zeros_byte_reg_evex",
  /* 1540 */  "vcount_trailing_zeros_reg_avx",
  /* 1541 */  "vpternlog",
  /* 1542 */  "vpternlog_mem",
  /* 1543 */  "vprotate_immI8",
  /* 1544 */  "vprotate_immI8_0",
  /* 1545 */  "vprorate",
  /* 1546 */  "vprorate_0",
  /* 1547 */  "vmasked_load_avx_non_subword",
  /* 1548 */  "vmasked_load_evex",
  /* 1549 */  "vmasked_store_avx_non_subword",
  /* 1550 */  "vmasked_store_evex",
  /* 1551 */  "verify_vector_alignment",
  /* 1552 */  "vmask_cmp_node",
  /* 1553 */  "vmask_gen",
  /* 1554 */  "vmask_gen_imm",
  /* 1555 */  "vmask_tolong_evex",
  /* 1556 */  "vmask_tolong_bool",
  /* 1557 */  "vmask_tolong_avx",
  /* 1558 */  "vmask_truecount_evex",
  /* 1559 */  "vmask_truecount_bool",
  /* 1560 */  "vmask_truecount_avx",
  /* 1561 */  "vmask_first_or_last_true_evex",
  /* 1562 */  "vmask_first_or_last_true_evex_0",
  /* 1563 */  "vmask_first_or_last_true_bool",
  /* 1564 */  "vmask_first_or_last_true_bool_0",
  /* 1565 */  "vmask_first_or_last_true_avx",
  /* 1566 */  "vmask_first_or_last_true_avx_0",
  /* 1567 */  "vcompress_reg_avx",
  /* 1568 */  "vcompress_reg_avx_0",
  /* 1569 */  "vcompress_expand_reg_evex",
  /* 1570 */  "vcompress_expand_reg_evex_0",
  /* 1571 */  "vcompress_mask_reg_evex",
  /* 1572 */  "vreverse_reg",
  /* 1573 */  "vreverse_reg_gfni",
  /* 1574 */  "vreverse_byte_reg",
  /* 1575 */  "vreverse_byte64_reg",
  /* 1576 */  "vcount_leading_zeros_IL_reg_evex_masked",
  /* 1577 */  "vcount_leading_zeros_short_reg_evex",
  /* 1578 */  "vcount_leading_zeros_byte_reg_evex",
  /* 1579 */  "vcount_leading_zeros_int_reg_avx",
  /* 1580 */  "vcount_leading_zeros_reg_avx",
  /* 1581 */  "vadd_reg_masked",
  /* 1582 */  "vadd_reg_masked_0",
  /* 1583 */  "vadd_reg_masked_1",
  /* 1584 */  "vadd_reg_masked_2",
  /* 1585 */  "vadd_reg_masked_3",
  /* 1586 */  "vadd_reg_masked_4",
  /* 1587 */  "vadd_mem_masked",
  /* 1588 */  "vadd_mem_masked_0",
  /* 1589 */  "vadd_mem_masked_1",
  /* 1590 */  "vadd_mem_masked_2",
  /* 1591 */  "vadd_mem_masked_3",
  /* 1592 */  "vadd_mem_masked_4",
  /* 1593 */  "vxor_reg_masked",
  /* 1594 */  "vxor_mem_masked",
  /* 1595 */  "vor_reg_masked",
  /* 1596 */  "vor_mem_masked",
  /* 1597 */  "vand_reg_masked",
  /* 1598 */  "vand_mem_masked",
  /* 1599 */  "vsub_reg_masked",
  /* 1600 */  "vsub_reg_masked_0",
  /* 1601 */  "vsub_reg_masked_1",
  /* 1602 */  "vsub_reg_masked_2",
  /* 1603 */  "vsub_reg_masked_3",
  /* 1604 */  "vsub_reg_masked_4",
  /* 1605 */  "vsub_mem_masked",
  /* 1606 */  "vsub_mem_masked_0",
  /* 1607 */  "vsub_mem_masked_1",
  /* 1608 */  "vsub_mem_masked_2",
  /* 1609 */  "vsub_mem_masked_3",
  /* 1610 */  "vsub_mem_masked_4",
  /* 1611 */  "vmul_reg_masked",
  /* 1612 */  "vmul_reg_masked_0",
  /* 1613 */  "vmul_reg_masked_1",
  /* 1614 */  "vmul_reg_masked_2",
  /* 1615 */  "vmul_reg_masked_3",
  /* 1616 */  "vmul_mem_masked",
  /* 1617 */  "vmul_mem_masked_0",
  /* 1618 */  "vmul_mem_masked_1",
  /* 1619 */  "vmul_mem_masked_2",
  /* 1620 */  "vmul_mem_masked_3",
  /* 1621 */  "vsqrt_reg_masked",
  /* 1622 */  "vsqrt_reg_masked_0",
  /* 1623 */  "vdiv_reg_masked",
  /* 1624 */  "vdiv_reg_masked_0",
  /* 1625 */  "vdiv_mem_masked",
  /* 1626 */  "vdiv_mem_masked_0",
  /* 1627 */  "vrol_imm_masked",
  /* 1628 */  "vrol_imm_masked_0",
  /* 1629 */  "vrol_reg_masked",
  /* 1630 */  "vrol_reg_masked_0",
  /* 1631 */  "vlshift_imm_masked",
  /* 1632 */  "vlshift_imm_masked_0",
  /* 1633 */  "vlshift_imm_masked_1",
  /* 1634 */  "vlshift_reg_masked",
  /* 1635 */  "vlshift_reg_masked_0",
  /* 1636 */  "vlshift_reg_masked_1",
  /* 1637 */  "vlshiftv_reg_masked",
  /* 1638 */  "vlshiftv_reg_masked_0",
  /* 1639 */  "vlshiftv_reg_masked_1",
  /* 1640 */  "vrshift_imm_masked",
  /* 1641 */  "vrshift_imm_masked_0",
  /* 1642 */  "vrshift_imm_masked_1",
  /* 1643 */  "vrshift_reg_masked",
  /* 1644 */  "vrshift_reg_masked_0",
  /* 1645 */  "vrshift_reg_masked_1",
  /* 1646 */  "vrshiftv_reg_masked",
  /* 1647 */  "vrshiftv_reg_masked_0",
  /* 1648 */  "vrshiftv_reg_masked_1",
  /* 1649 */  "vurshift_imm_masked",
  /* 1650 */  "vurshift_imm_masked_0",
  /* 1651 */  "vurshift_imm_masked_1",
  /* 1652 */  "vurshift_reg_masked",
  /* 1653 */  "vurshift_reg_masked_0",
  /* 1654 */  "vurshift_reg_masked_1",
  /* 1655 */  "vurshiftv_reg_masked",
  /* 1656 */  "vurshiftv_reg_masked_0",
  /* 1657 */  "vurshiftv_reg_masked_1",
  /* 1658 */  "vmaxv_reg_masked",
  /* 1659 */  "vmaxv_mem_masked",
  /* 1660 */  "vminv_reg_masked",
  /* 1661 */  "vminv_mem_masked",
  /* 1662 */  "vrearrangev_reg_masked",
  /* 1663 */  "vabs_masked",
  /* 1664 */  "vabs_masked_0",
  /* 1665 */  "vabs_masked_1",
  /* 1666 */  "vabs_masked_2",
  /* 1667 */  "vfma_reg_masked",
  /* 1668 */  "vfma_reg_masked_0",
  /* 1669 */  "vfma_mem_masked",
  /* 1670 */  "vfma_mem_masked_0",
  /* 1671 */  "evcmp_masked",
  /* 1672 */  "mask_all_evexI_LE32",
  /* 1673 */  "mask_not_immLT8",
  /* 1674 */  "mask_not_imm",
  /* 1675 */  "long_to_maskLE8_avx",
  /* 1676 */  "long_to_maskGT8_avx",
  /* 1677 */  "mask_opers_evex",
  /* 1678 */  "mask_opers_evex_0",
  /* 1679 */  "mask_opers_evex_1",
  /* 1680 */  "vternlog_reg_masked",
  /* 1681 */  "vternlogd_mem_masked",
  /* 1682 */  "FloatClassCheck_reg_reg_vfpclass",
  /* 1683 */  "DoubleClassCheck_reg_reg_vfpclass",
  /* 1684 */  "vector_addsub_saturating_subword_reg",
  /* 1685 */  "vector_addsub_saturating_subword_reg_0",
  /* 1686 */  "vector_addsub_saturating_unsigned_subword_reg",
  /* 1687 */  "vector_addsub_saturating_unsigned_subword_reg_0",
  /* 1688 */  "vector_addsub_saturating_reg_evex",
  /* 1689 */  "vector_addsub_saturating_reg_evex_0",
  /* 1690 */  "vector_addsub_saturating_reg_avx",
  /* 1691 */  "vector_addsub_saturating_reg_avx_0",
  /* 1692 */  "vector_add_saturating_unsigned_reg_evex",
  /* 1693 */  "vector_add_saturating_unsigned_reg_avx",
  /* 1694 */  "vector_sub_saturating_unsigned_reg_evex",
  /* 1695 */  "vector_sub_saturating_unsigned_reg_avx",
  /* 1696 */  "vector_addsub_saturating_subword_mem",
  /* 1697 */  "vector_addsub_saturating_subword_mem_0",
  /* 1698 */  "vector_addsub_saturating_unsigned_subword_mem",
  /* 1699 */  "vector_addsub_saturating_unsigned_subword_mem_0",
  /* 1700 */  "vector_addsub_saturating_subword_masked_reg",
  /* 1701 */  "vector_addsub_saturating_subword_masked_reg_0",
  /* 1702 */  "vector_addsub_saturating_unsigned_subword_masked_reg",
  /* 1703 */  "vector_addsub_saturating_unsigned_subword_masked_reg_0",
  /* 1704 */  "vector_addsub_saturating_subword_masked_mem",
  /* 1705 */  "vector_addsub_saturating_subword_masked_mem_0",
  /* 1706 */  "vector_addsub_saturating_unsigned_subword_masked_mem",
  /* 1707 */  "vector_addsub_saturating_unsigned_subword_masked_mem_0",
  /* 1708 */  "vector_selectfrom_twovectors_reg_evex",
  /* 1709 */  "compareAndSwapP_shenandoah",
  /* 1710 */  "compareAndSwapP_shenandoah_0",
  /* 1711 */  "compareAndSwapN_shenandoah",
  /* 1712 */  "compareAndSwapN_shenandoah_0",
  /* 1713 */  "compareAndExchangeN_shenandoah",
  /* 1714 */  "compareAndExchangeP_shenandoah",
  /* 1715 */  "zLoadP",
  /* 1716 */  "zStoreP",
  /* 1717 */  "zStorePNull",
  /* 1718 */  "zCompareAndExchangeP",
  /* 1719 */  "zCompareAndSwapP",
  /* 1720 */  "zCompareAndSwapP_0",
  /* 1721 */  "zXChgP",
  /* 1722 */  "g1StoreP",
  /* 1723 */  "g1StoreN",
  /* 1724 */  "g1EncodePAndStoreN",
  /* 1725 */  "g1CompareAndExchangeP",
  /* 1726 */  "g1CompareAndExchangeN",
  /* 1727 */  "g1CompareAndSwapP",
  /* 1728 */  "g1CompareAndSwapP_0",
  /* 1729 */  "g1CompareAndSwapN",
  /* 1730 */  "g1CompareAndSwapN_0",
  /* 1731 */  "g1GetAndSetP",
  /* 1732 */  "g1GetAndSetN",
  /* 1733 */  "g1LoadP",
  /* 1734 */  "g1LoadN",
  // last instruction
  "invalid rule name" // no trailing comma
};

const        bool  swallowed[] = {
  /*    0 */  false,
  /*    1 */  false,
  /*    2 */  false,
  /*    3 */  false,
  /*    4 */  false,
  /*    5 */  false,
  /*    6 */  false,
  /*    7 */  false,
  /*    8 */  true,
  /*    9 */  true,
  /*   10 */  true,
  /*   11 */  true,
  /*   12 */  true,
  /*   13 */  true,
  /*   14 */  true,
  /*   15 */  true,
  /*   16 */  true,
  /*   17 */  true,
  /*   18 */  true,
  /*   19 */  true,
  /*   20 */  true,
  /*   21 */  true,
  /*   22 */  true,
  /*   23 */  true,
  /*   24 */  true,
  /*   25 */  true,
  /*   26 */  true,
  /*   27 */  true,
  /*   28 */  true,
  /*   29 */  true,
  /*   30 */  true,
  /*   31 */  true,
  /*   32 */  true,
  /*   33 */  true,
  /*   34 */  true,
  /*   35 */  true,
  /*   36 */  true,
  /*   37 */  true,
  /*   38 */  true,
  /*   39 */  true,
  /*   40 */  true,
  /*   41 */  true,
  /*   42 */  true,
  /*   43 */  true,
  /*   44 */  true,
  /*   45 */  true,
  /*   46 */  true,
  /*   47 */  true,
  /*   48 */  false,
  /*   49 */  false,
  /*   50 */  false,
  /*   51 */  false,
  /*   52 */  false,
  /*   53 */  false,
  /*   54 */  false,
  /*   55 */  false,
  /*   56 */  false,
  /*   57 */  false,
  /*   58 */  false,
  /*   59 */  false,
  /*   60 */  false,
  /*   61 */  false,
  /*   62 */  false,
  /*   63 */  false,
  /*   64 */  false,
  /*   65 */  false,
  /*   66 */  false,
  /*   67 */  false,
  /*   68 */  false,
  /*   69 */  false,
  /*   70 */  false,
  /*   71 */  false,
  /*   72 */  false,
  /*   73 */  false,
  /*   74 */  false,
  /*   75 */  false,
  /*   76 */  false,
  /*   77 */  false,
  /*   78 */  false,
  /*   79 */  false,
  /*   80 */  false,
  /*   81 */  false,
  /*   82 */  false,
  /*   83 */  false,
  /*   84 */  false,
  /*   85 */  false,
  /*   86 */  false,
  /*   87 */  false,
  /*   88 */  false,
  /*   89 */  false,
  /*   90 */  false,
  /*   91 */  false,
  /*   92 */  false,
  /*   93 */  false,
  /*   94 */  false,
  /*   95 */  false,
  /*   96 */  false,
  /*   97 */  false,
  /*   98 */  false,
  /*   99 */  false,
  /*  100 */  false,
  /*  101 */  false,
  /*  102 */  false,
  /*  103 */  false,
  /*  104 */  false,
  /*  105 */  false,
  /*  106 */  false,
  /*  107 */  false,
  /*  108 */  false,
  /*  109 */  true,
  /*  110 */  true,
  /*  111 */  true,
  /*  112 */  true,
  /*  113 */  false,
  /*  114 */  false,
  /*  115 */  false,
  /*  116 */  false,
  /*  117 */  false,
  /*  118 */  false,
  /*  119 */  false,
  /*  120 */  false,
  /*  121 */  false,
  /*  122 */  false,
  /*  123 */  false,
  /*  124 */  false,
  /*  125 */  false,
  /*  126 */  false,
  // last operand
  /*  127 */  false,
  // last operand class
  /*  128 */  false,
  /*  129 */  false,
  /*  130 */  false,
  /*  131 */  false,
  /*  132 */  false,
  /*  133 */  false,
  /*  134 */  false,
  /*  135 */  false,
  /*  136 */  false,
  /*  137 */  false,
  /*  138 */  false,
  /*  139 */  false,
  /*  140 */  false,
  /*  141 */  false,
  /*  142 */  false,
  /*  143 */  false,
  /*  144 */  false,
  /*  145 */  false,
  /*  146 */  false,
  /*  147 */  false,
  /*  148 */  false,
  /*  149 */  false,
  /*  150 */  false,
  /*  151 */  false,
  /*  152 */  false,
  /*  153 */  false,
  /*  154 */  false,
  /*  155 */  false,
  /*  156 */  false,
  /*  157 */  false,
  /*  158 */  false,
  /*  159 */  false,
  /*  160 */  false,
  /*  161 */  false,
  /*  162 */  false,
  /*  163 */  false,
  /*  164 */  false,
  /*  165 */  false,
  /*  166 */  false,
  /*  167 */  false,
  /*  168 */  false,
  /*  169 */  false,
  /*  170 */  false,
  /*  171 */  false,
  /*  172 */  false,
  /*  173 */  false,
  /*  174 */  false,
  /*  175 */  false,
  /*  176 */  false,
  /*  177 */  false,
  /*  178 */  false,
  /*  179 */  false,
  /*  180 */  false,
  /*  181 */  false,
  /*  182 */  false,
  /*  183 */  false,
  /*  184 */  false,
  /*  185 */  false,
  /*  186 */  false,
  /*  187 */  false,
  /*  188 */  false,
  /*  189 */  false,
  /*  190 */  false,
  /*  191 */  false,
  /*  192 */  false,
  /*  193 */  false,
  /*  194 */  false,
  /*  195 */  false,
  /*  196 */  false,
  /*  197 */  false,
  /*  198 */  false,
  /*  199 */  false,
  /*  200 */  false,
  /*  201 */  false,
  /*  202 */  false,
  /*  203 */  false,
  /*  204 */  false,
  /*  205 */  false,
  /*  206 */  false,
  /*  207 */  false,
  /*  208 */  false,
  /*  209 */  false,
  /*  210 */  false,
  /*  211 */  false,
  /*  212 */  false,
  /*  213 */  false,
  /*  214 */  false,
  /*  215 */  false,
  /*  216 */  false,
  /*  217 */  false,
  /*  218 */  false,
  /*  219 */  false,
  /*  220 */  false,
  /*  221 */  false,
  /*  222 */  false,
  /*  223 */  false,
  /*  224 */  false,
  /*  225 */  false,
  /*  226 */  false,
  /*  227 */  false,
  /*  228 */  false,
  /*  229 */  false,
  /*  230 */  false,
  /*  231 */  false,
  /*  232 */  false,
  /*  233 */  false,
  /*  234 */  false,
  /*  235 */  false,
  /*  236 */  false,
  /*  237 */  false,
  /*  238 */  false,
  /*  239 */  false,
  /*  240 */  false,
  /*  241 */  false,
  /*  242 */  false,
  /*  243 */  false,
  /*  244 */  false,
  /*  245 */  false,
  /*  246 */  false,
  /*  247 */  false,
  /*  248 */  false,
  /*  249 */  false,
  /*  250 */  false,
  /*  251 */  false,
  /*  252 */  false,
  /*  253 */  false,
  /*  254 */  false,
  /*  255 */  false,
  /*  256 */  false,
  /*  257 */  false,
  /*  258 */  false,
  /*  259 */  false,
  /*  260 */  false,
  /*  261 */  false,
  /*  262 */  false,
  /*  263 */  false,
  /*  264 */  false,
  /*  265 */  false,
  /*  266 */  false,
  /*  267 */  false,
  /*  268 */  false,
  /*  269 */  false,
  /*  270 */  false,
  /*  271 */  false,
  /*  272 */  false,
  /*  273 */  false,
  /*  274 */  false,
  /*  275 */  false,
  /*  276 */  false,
  /*  277 */  false,
  /*  278 */  false,
  /*  279 */  false,
  /*  280 */  false,
  /*  281 */  false,
  /*  282 */  false,
  /*  283 */  false,
  /*  284 */  false,
  /*  285 */  false,
  /*  286 */  false,
  /*  287 */  false,
  /*  288 */  false,
  /*  289 */  false,
  /*  290 */  false,
  /*  291 */  false,
  /*  292 */  false,
  /*  293 */  false,
  /*  294 */  false,
  /*  295 */  false,
  /*  296 */  false,
  /*  297 */  false,
  /*  298 */  false,
  /*  299 */  false,
  /*  300 */  false,
  /*  301 */  false,
  /*  302 */  false,
  /*  303 */  false,
  /*  304 */  false,
  /*  305 */  false,
  /*  306 */  false,
  /*  307 */  false,
  /*  308 */  false,
  /*  309 */  false,
  /*  310 */  false,
  /*  311 */  false,
  /*  312 */  false,
  /*  313 */  false,
  /*  314 */  false,
  // last internally defined operand
  /*  315 */  false,
  /*  316 */  false,
  /*  317 */  false,
  /*  318 */  false,
  /*  319 */  false,
  /*  320 */  false,
  /*  321 */  false,
  /*  322 */  false,
  /*  323 */  false,
  /*  324 */  false,
  /*  325 */  false,
  /*  326 */  false,
  /*  327 */  false,
  /*  328 */  false,
  /*  329 */  false,
  /*  330 */  false,
  /*  331 */  false,
  /*  332 */  false,
  /*  333 */  false,
  /*  334 */  false,
  /*  335 */  false,
  /*  336 */  false,
  /*  337 */  false,
  /*  338 */  false,
  /*  339 */  false,
  /*  340 */  false,
  /*  341 */  false,
  /*  342 */  false,
  /*  343 */  false,
  /*  344 */  false,
  /*  345 */  false,
  /*  346 */  false,
  /*  347 */  false,
  /*  348 */  false,
  /*  349 */  false,
  /*  350 */  false,
  /*  351 */  false,
  /*  352 */  false,
  /*  353 */  false,
  /*  354 */  false,
  /*  355 */  false,
  /*  356 */  false,
  /*  357 */  false,
  /*  358 */  false,
  /*  359 */  false,
  /*  360 */  false,
  /*  361 */  false,
  /*  362 */  false,
  /*  363 */  false,
  /*  364 */  false,
  /*  365 */  false,
  /*  366 */  false,
  /*  367 */  false,
  /*  368 */  false,
  /*  369 */  false,
  /*  370 */  false,
  /*  371 */  false,
  /*  372 */  false,
  /*  373 */  false,
  /*  374 */  false,
  /*  375 */  false,
  /*  376 */  false,
  /*  377 */  false,
  /*  378 */  false,
  /*  379 */  false,
  /*  380 */  false,
  /*  381 */  false,
  /*  382 */  false,
  /*  383 */  false,
  /*  384 */  false,
  /*  385 */  false,
  /*  386 */  false,
  /*  387 */  false,
  /*  388 */  false,
  /*  389 */  false,
  /*  390 */  false,
  /*  391 */  false,
  /*  392 */  false,
  /*  393 */  false,
  /*  394 */  false,
  /*  395 */  false,
  /*  396 */  false,
  /*  397 */  false,
  /*  398 */  false,
  /*  399 */  false,
  /*  400 */  false,
  /*  401 */  false,
  /*  402 */  false,
  /*  403 */  false,
  /*  404 */  false,
  /*  405 */  false,
  /*  406 */  false,
  /*  407 */  false,
  /*  408 */  false,
  /*  409 */  false,
  /*  410 */  false,
  /*  411 */  false,
  /*  412 */  false,
  /*  413 */  false,
  /*  414 */  false,
  /*  415 */  false,
  /*  416 */  false,
  /*  417 */  false,
  /*  418 */  false,
  /*  419 */  false,
  /*  420 */  false,
  /*  421 */  false,
  /*  422 */  false,
  /*  423 */  false,
  /*  424 */  false,
  /*  425 */  false,
  /*  426 */  false,
  /*  427 */  false,
  /*  428 */  false,
  /*  429 */  false,
  /*  430 */  false,
  /*  431 */  false,
  /*  432 */  false,
  /*  433 */  false,
  /*  434 */  false,
  /*  435 */  false,
  /*  436 */  false,
  /*  437 */  false,
  /*  438 */  false,
  /*  439 */  false,
  /*  440 */  false,
  /*  441 */  false,
  /*  442 */  false,
  /*  443 */  false,
  /*  444 */  false,
  /*  445 */  false,
  /*  446 */  false,
  /*  447 */  false,
  /*  448 */  false,
  /*  449 */  false,
  /*  450 */  false,
  /*  451 */  false,
  /*  452 */  false,
  /*  453 */  false,
  /*  454 */  false,
  /*  455 */  false,
  /*  456 */  false,
  /*  457 */  false,
  /*  458 */  false,
  /*  459 */  false,
  /*  460 */  false,
  /*  461 */  false,
  /*  462 */  false,
  /*  463 */  false,
  /*  464 */  false,
  /*  465 */  false,
  /*  466 */  false,
  /*  467 */  false,
  /*  468 */  false,
  /*  469 */  false,
  /*  470 */  false,
  /*  471 */  false,
  /*  472 */  false,
  /*  473 */  false,
  /*  474 */  false,
  /*  475 */  false,
  /*  476 */  false,
  /*  477 */  false,
  /*  478 */  false,
  /*  479 */  false,
  /*  480 */  false,
  /*  481 */  false,
  /*  482 */  false,
  /*  483 */  false,
  /*  484 */  false,
  /*  485 */  false,
  /*  486 */  false,
  /*  487 */  false,
  /*  488 */  false,
  /*  489 */  false,
  /*  490 */  false,
  /*  491 */  false,
  /*  492 */  false,
  /*  493 */  false,
  /*  494 */  false,
  /*  495 */  false,
  /*  496 */  false,
  /*  497 */  false,
  /*  498 */  false,
  /*  499 */  false,
  /*  500 */  false,
  /*  501 */  false,
  /*  502 */  false,
  /*  503 */  false,
  /*  504 */  false,
  /*  505 */  false,
  /*  506 */  false,
  /*  507 */  false,
  /*  508 */  false,
  /*  509 */  false,
  /*  510 */  false,
  /*  511 */  false,
  /*  512 */  false,
  /*  513 */  false,
  /*  514 */  false,
  /*  515 */  false,
  /*  516 */  false,
  /*  517 */  false,
  /*  518 */  false,
  /*  519 */  false,
  /*  520 */  false,
  /*  521 */  false,
  /*  522 */  false,
  /*  523 */  false,
  /*  524 */  false,
  /*  525 */  false,
  /*  526 */  false,
  /*  527 */  false,
  /*  528 */  false,
  /*  529 */  false,
  /*  530 */  false,
  /*  531 */  false,
  /*  532 */  false,
  /*  533 */  false,
  /*  534 */  false,
  /*  535 */  false,
  /*  536 */  false,
  /*  537 */  false,
  /*  538 */  false,
  /*  539 */  false,
  /*  540 */  false,
  /*  541 */  false,
  /*  542 */  false,
  /*  543 */  false,
  /*  544 */  false,
  /*  545 */  false,
  /*  546 */  false,
  /*  547 */  false,
  /*  548 */  false,
  /*  549 */  false,
  /*  550 */  false,
  /*  551 */  false,
  /*  552 */  false,
  /*  553 */  false,
  /*  554 */  false,
  /*  555 */  false,
  /*  556 */  false,
  /*  557 */  false,
  /*  558 */  false,
  /*  559 */  false,
  /*  560 */  false,
  /*  561 */  false,
  /*  562 */  false,
  /*  563 */  false,
  /*  564 */  false,
  /*  565 */  false,
  /*  566 */  false,
  /*  567 */  false,
  /*  568 */  false,
  /*  569 */  false,
  /*  570 */  false,
  /*  571 */  false,
  /*  572 */  false,
  /*  573 */  false,
  /*  574 */  false,
  /*  575 */  false,
  /*  576 */  false,
  /*  577 */  false,
  /*  578 */  false,
  /*  579 */  false,
  /*  580 */  false,
  /*  581 */  false,
  /*  582 */  false,
  /*  583 */  false,
  /*  584 */  false,
  /*  585 */  false,
  /*  586 */  false,
  /*  587 */  false,
  /*  588 */  false,
  /*  589 */  false,
  /*  590 */  false,
  /*  591 */  false,
  /*  592 */  false,
  /*  593 */  false,
  /*  594 */  false,
  /*  595 */  false,
  /*  596 */  false,
  /*  597 */  false,
  /*  598 */  false,
  /*  599 */  false,
  /*  600 */  false,
  /*  601 */  false,
  /*  602 */  false,
  /*  603 */  false,
  /*  604 */  false,
  /*  605 */  false,
  /*  606 */  false,
  /*  607 */  false,
  /*  608 */  false,
  /*  609 */  false,
  /*  610 */  false,
  /*  611 */  false,
  /*  612 */  false,
  /*  613 */  false,
  /*  614 */  false,
  /*  615 */  false,
  /*  616 */  false,
  /*  617 */  false,
  /*  618 */  false,
  /*  619 */  false,
  /*  620 */  false,
  /*  621 */  false,
  /*  622 */  false,
  /*  623 */  false,
  /*  624 */  false,
  /*  625 */  false,
  /*  626 */  false,
  /*  627 */  false,
  /*  628 */  false,
  /*  629 */  false,
  /*  630 */  false,
  /*  631 */  false,
  /*  632 */  false,
  /*  633 */  false,
  /*  634 */  false,
  /*  635 */  false,
  /*  636 */  false,
  /*  637 */  false,
  /*  638 */  false,
  /*  639 */  false,
  /*  640 */  false,
  /*  641 */  false,
  /*  642 */  false,
  /*  643 */  false,
  /*  644 */  false,
  /*  645 */  false,
  /*  646 */  false,
  /*  647 */  false,
  /*  648 */  false,
  /*  649 */  false,
  /*  650 */  false,
  /*  651 */  false,
  /*  652 */  false,
  /*  653 */  false,
  /*  654 */  false,
  /*  655 */  false,
  /*  656 */  false,
  /*  657 */  false,
  /*  658 */  false,
  /*  659 */  false,
  /*  660 */  false,
  /*  661 */  false,
  /*  662 */  false,
  /*  663 */  false,
  /*  664 */  false,
  /*  665 */  false,
  /*  666 */  false,
  /*  667 */  false,
  /*  668 */  false,
  /*  669 */  false,
  /*  670 */  false,
  /*  671 */  false,
  /*  672 */  false,
  /*  673 */  false,
  /*  674 */  false,
  /*  675 */  false,
  /*  676 */  false,
  /*  677 */  false,
  /*  678 */  false,
  /*  679 */  false,
  /*  680 */  false,
  /*  681 */  false,
  /*  682 */  false,
  /*  683 */  false,
  /*  684 */  false,
  /*  685 */  false,
  /*  686 */  false,
  /*  687 */  false,
  /*  688 */  false,
  /*  689 */  false,
  /*  690 */  false,
  /*  691 */  false,
  /*  692 */  false,
  /*  693 */  false,
  /*  694 */  false,
  /*  695 */  false,
  /*  696 */  false,
  /*  697 */  false,
  /*  698 */  false,
  /*  699 */  false,
  /*  700 */  false,
  /*  701 */  false,
  /*  702 */  false,
  /*  703 */  false,
  /*  704 */  false,
  /*  705 */  false,
  /*  706 */  false,
  /*  707 */  false,
  /*  708 */  false,
  /*  709 */  false,
  /*  710 */  false,
  /*  711 */  false,
  /*  712 */  false,
  /*  713 */  false,
  /*  714 */  false,
  /*  715 */  false,
  /*  716 */  false,
  /*  717 */  false,
  /*  718 */  false,
  /*  719 */  false,
  /*  720 */  false,
  /*  721 */  false,
  /*  722 */  false,
  /*  723 */  false,
  /*  724 */  false,
  /*  725 */  false,
  /*  726 */  false,
  /*  727 */  false,
  /*  728 */  false,
  /*  729 */  false,
  /*  730 */  false,
  /*  731 */  false,
  /*  732 */  false,
  /*  733 */  false,
  /*  734 */  false,
  /*  735 */  false,
  /*  736 */  false,
  /*  737 */  false,
  /*  738 */  false,
  /*  739 */  false,
  /*  740 */  false,
  /*  741 */  false,
  /*  742 */  false,
  /*  743 */  false,
  /*  744 */  false,
  /*  745 */  false,
  /*  746 */  false,
  /*  747 */  false,
  /*  748 */  false,
  /*  749 */  false,
  /*  750 */  false,
  /*  751 */  false,
  /*  752 */  false,
  /*  753 */  false,
  /*  754 */  false,
  /*  755 */  false,
  /*  756 */  false,
  /*  757 */  false,
  /*  758 */  false,
  /*  759 */  false,
  /*  760 */  false,
  /*  761 */  false,
  /*  762 */  false,
  /*  763 */  false,
  /*  764 */  false,
  /*  765 */  false,
  /*  766 */  false,
  /*  767 */  false,
  /*  768 */  false,
  /*  769 */  false,
  /*  770 */  false,
  /*  771 */  false,
  /*  772 */  false,
  /*  773 */  false,
  /*  774 */  false,
  /*  775 */  false,
  /*  776 */  false,
  /*  777 */  false,
  /*  778 */  false,
  /*  779 */  false,
  /*  780 */  false,
  /*  781 */  false,
  /*  782 */  false,
  /*  783 */  false,
  /*  784 */  false,
  /*  785 */  false,
  /*  786 */  false,
  /*  787 */  false,
  /*  788 */  false,
  /*  789 */  false,
  /*  790 */  false,
  /*  791 */  false,
  /*  792 */  false,
  /*  793 */  false,
  /*  794 */  false,
  /*  795 */  false,
  /*  796 */  false,
  /*  797 */  false,
  /*  798 */  false,
  /*  799 */  false,
  /*  800 */  false,
  /*  801 */  false,
  /*  802 */  false,
  /*  803 */  false,
  /*  804 */  false,
  /*  805 */  false,
  /*  806 */  false,
  /*  807 */  false,
  /*  808 */  false,
  /*  809 */  false,
  /*  810 */  false,
  /*  811 */  false,
  /*  812 */  false,
  /*  813 */  false,
  /*  814 */  false,
  /*  815 */  false,
  /*  816 */  false,
  /*  817 */  false,
  /*  818 */  false,
  /*  819 */  false,
  /*  820 */  false,
  /*  821 */  false,
  /*  822 */  false,
  /*  823 */  false,
  /*  824 */  false,
  /*  825 */  false,
  /*  826 */  false,
  /*  827 */  false,
  /*  828 */  false,
  /*  829 */  false,
  /*  830 */  false,
  /*  831 */  false,
  /*  832 */  false,
  /*  833 */  false,
  /*  834 */  false,
  /*  835 */  false,
  /*  836 */  false,
  /*  837 */  false,
  /*  838 */  false,
  /*  839 */  false,
  /*  840 */  false,
  /*  841 */  false,
  /*  842 */  false,
  /*  843 */  false,
  /*  844 */  false,
  /*  845 */  false,
  /*  846 */  false,
  /*  847 */  false,
  /*  848 */  false,
  /*  849 */  false,
  /*  850 */  false,
  /*  851 */  false,
  /*  852 */  false,
  /*  853 */  false,
  /*  854 */  false,
  /*  855 */  false,
  /*  856 */  false,
  /*  857 */  false,
  /*  858 */  false,
  /*  859 */  false,
  /*  860 */  false,
  /*  861 */  false,
  /*  862 */  false,
  /*  863 */  false,
  /*  864 */  false,
  /*  865 */  false,
  /*  866 */  false,
  /*  867 */  false,
  /*  868 */  false,
  /*  869 */  false,
  /*  870 */  false,
  /*  871 */  false,
  /*  872 */  false,
  /*  873 */  false,
  /*  874 */  false,
  /*  875 */  false,
  /*  876 */  false,
  /*  877 */  false,
  /*  878 */  false,
  /*  879 */  false,
  /*  880 */  false,
  /*  881 */  false,
  /*  882 */  false,
  /*  883 */  false,
  /*  884 */  false,
  /*  885 */  false,
  /*  886 */  false,
  /*  887 */  false,
  /*  888 */  false,
  /*  889 */  false,
  /*  890 */  false,
  /*  891 */  false,
  /*  892 */  false,
  /*  893 */  false,
  /*  894 */  false,
  /*  895 */  false,
  /*  896 */  false,
  /*  897 */  false,
  /*  898 */  false,
  /*  899 */  false,
  /*  900 */  false,
  /*  901 */  false,
  /*  902 */  false,
  /*  903 */  false,
  /*  904 */  false,
  /*  905 */  false,
  /*  906 */  false,
  /*  907 */  false,
  /*  908 */  false,
  /*  909 */  false,
  /*  910 */  false,
  /*  911 */  false,
  /*  912 */  false,
  /*  913 */  false,
  /*  914 */  false,
  /*  915 */  false,
  /*  916 */  false,
  /*  917 */  false,
  /*  918 */  false,
  /*  919 */  false,
  /*  920 */  false,
  /*  921 */  false,
  /*  922 */  false,
  /*  923 */  false,
  /*  924 */  false,
  /*  925 */  false,
  /*  926 */  false,
  /*  927 */  false,
  /*  928 */  false,
  /*  929 */  false,
  /*  930 */  false,
  /*  931 */  false,
  /*  932 */  false,
  /*  933 */  false,
  /*  934 */  false,
  /*  935 */  false,
  /*  936 */  false,
  /*  937 */  false,
  /*  938 */  false,
  /*  939 */  false,
  /*  940 */  false,
  /*  941 */  false,
  /*  942 */  false,
  /*  943 */  false,
  /*  944 */  false,
  /*  945 */  false,
  /*  946 */  false,
  /*  947 */  false,
  /*  948 */  false,
  /*  949 */  false,
  /*  950 */  false,
  /*  951 */  false,
  /*  952 */  false,
  /*  953 */  false,
  /*  954 */  false,
  /*  955 */  false,
  /*  956 */  false,
  /*  957 */  false,
  /*  958 */  false,
  /*  959 */  false,
  /*  960 */  false,
  /*  961 */  false,
  /*  962 */  false,
  /*  963 */  false,
  /*  964 */  false,
  /*  965 */  false,
  /*  966 */  false,
  /*  967 */  false,
  /*  968 */  false,
  /*  969 */  false,
  /*  970 */  false,
  /*  971 */  false,
  /*  972 */  false,
  /*  973 */  false,
  /*  974 */  false,
  /*  975 */  false,
  /*  976 */  false,
  /*  977 */  false,
  /*  978 */  false,
  /*  979 */  false,
  /*  980 */  false,
  /*  981 */  false,
  /*  982 */  false,
  /*  983 */  false,
  /*  984 */  false,
  /*  985 */  false,
  /*  986 */  false,
  /*  987 */  false,
  /*  988 */  false,
  /*  989 */  false,
  /*  990 */  false,
  /*  991 */  false,
  /*  992 */  false,
  /*  993 */  false,
  /*  994 */  false,
  /*  995 */  false,
  /*  996 */  false,
  /*  997 */  false,
  /*  998 */  false,
  /*  999 */  false,
  /* 1000 */  false,
  /* 1001 */  false,
  /* 1002 */  false,
  /* 1003 */  false,
  /* 1004 */  false,
  /* 1005 */  false,
  /* 1006 */  false,
  /* 1007 */  false,
  /* 1008 */  false,
  /* 1009 */  false,
  /* 1010 */  false,
  /* 1011 */  false,
  /* 1012 */  false,
  /* 1013 */  false,
  /* 1014 */  false,
  /* 1015 */  false,
  /* 1016 */  false,
  /* 1017 */  false,
  /* 1018 */  false,
  /* 1019 */  false,
  /* 1020 */  false,
  /* 1021 */  false,
  /* 1022 */  false,
  /* 1023 */  false,
  /* 1024 */  false,
  /* 1025 */  false,
  /* 1026 */  false,
  /* 1027 */  false,
  /* 1028 */  false,
  /* 1029 */  false,
  /* 1030 */  false,
  /* 1031 */  false,
  /* 1032 */  false,
  /* 1033 */  false,
  /* 1034 */  false,
  /* 1035 */  false,
  /* 1036 */  false,
  /* 1037 */  false,
  /* 1038 */  false,
  /* 1039 */  false,
  /* 1040 */  false,
  /* 1041 */  false,
  /* 1042 */  false,
  /* 1043 */  false,
  /* 1044 */  false,
  /* 1045 */  false,
  /* 1046 */  false,
  /* 1047 */  false,
  /* 1048 */  false,
  /* 1049 */  false,
  /* 1050 */  false,
  /* 1051 */  false,
  /* 1052 */  false,
  /* 1053 */  false,
  /* 1054 */  false,
  /* 1055 */  false,
  /* 1056 */  false,
  /* 1057 */  false,
  /* 1058 */  false,
  /* 1059 */  false,
  /* 1060 */  false,
  /* 1061 */  false,
  /* 1062 */  false,
  /* 1063 */  false,
  /* 1064 */  false,
  /* 1065 */  false,
  /* 1066 */  false,
  /* 1067 */  false,
  /* 1068 */  false,
  /* 1069 */  false,
  /* 1070 */  false,
  /* 1071 */  false,
  /* 1072 */  false,
  /* 1073 */  false,
  /* 1074 */  false,
  /* 1075 */  false,
  /* 1076 */  false,
  /* 1077 */  false,
  /* 1078 */  false,
  /* 1079 */  false,
  /* 1080 */  false,
  /* 1081 */  false,
  /* 1082 */  false,
  /* 1083 */  false,
  /* 1084 */  false,
  /* 1085 */  false,
  /* 1086 */  false,
  /* 1087 */  false,
  /* 1088 */  false,
  /* 1089 */  false,
  /* 1090 */  false,
  /* 1091 */  false,
  /* 1092 */  false,
  /* 1093 */  false,
  /* 1094 */  false,
  /* 1095 */  false,
  /* 1096 */  false,
  /* 1097 */  false,
  /* 1098 */  false,
  /* 1099 */  false,
  /* 1100 */  false,
  /* 1101 */  false,
  /* 1102 */  false,
  /* 1103 */  false,
  /* 1104 */  false,
  /* 1105 */  false,
  /* 1106 */  false,
  /* 1107 */  false,
  /* 1108 */  false,
  /* 1109 */  false,
  /* 1110 */  false,
  /* 1111 */  false,
  /* 1112 */  false,
  /* 1113 */  false,
  /* 1114 */  false,
  /* 1115 */  false,
  /* 1116 */  false,
  /* 1117 */  false,
  /* 1118 */  false,
  /* 1119 */  false,
  /* 1120 */  false,
  /* 1121 */  false,
  /* 1122 */  false,
  /* 1123 */  false,
  /* 1124 */  false,
  /* 1125 */  false,
  /* 1126 */  false,
  /* 1127 */  false,
  /* 1128 */  false,
  /* 1129 */  false,
  /* 1130 */  false,
  /* 1131 */  false,
  /* 1132 */  false,
  /* 1133 */  false,
  /* 1134 */  false,
  /* 1135 */  false,
  /* 1136 */  false,
  /* 1137 */  false,
  /* 1138 */  false,
  /* 1139 */  false,
  /* 1140 */  false,
  /* 1141 */  false,
  /* 1142 */  false,
  /* 1143 */  false,
  /* 1144 */  false,
  /* 1145 */  false,
  /* 1146 */  false,
  /* 1147 */  false,
  /* 1148 */  false,
  /* 1149 */  false,
  /* 1150 */  false,
  /* 1151 */  false,
  /* 1152 */  false,
  /* 1153 */  false,
  /* 1154 */  false,
  /* 1155 */  false,
  /* 1156 */  false,
  /* 1157 */  false,
  /* 1158 */  false,
  /* 1159 */  false,
  /* 1160 */  false,
  /* 1161 */  false,
  /* 1162 */  false,
  /* 1163 */  false,
  /* 1164 */  false,
  /* 1165 */  false,
  /* 1166 */  false,
  /* 1167 */  false,
  /* 1168 */  false,
  /* 1169 */  false,
  /* 1170 */  false,
  /* 1171 */  false,
  /* 1172 */  false,
  /* 1173 */  false,
  /* 1174 */  false,
  /* 1175 */  false,
  /* 1176 */  false,
  /* 1177 */  false,
  /* 1178 */  false,
  /* 1179 */  false,
  /* 1180 */  false,
  /* 1181 */  false,
  /* 1182 */  false,
  /* 1183 */  false,
  /* 1184 */  false,
  /* 1185 */  false,
  /* 1186 */  false,
  /* 1187 */  false,
  /* 1188 */  false,
  /* 1189 */  false,
  /* 1190 */  false,
  /* 1191 */  false,
  /* 1192 */  false,
  /* 1193 */  false,
  /* 1194 */  false,
  /* 1195 */  false,
  /* 1196 */  false,
  /* 1197 */  false,
  /* 1198 */  false,
  /* 1199 */  false,
  /* 1200 */  false,
  /* 1201 */  false,
  /* 1202 */  false,
  /* 1203 */  false,
  /* 1204 */  false,
  /* 1205 */  false,
  /* 1206 */  false,
  /* 1207 */  false,
  /* 1208 */  false,
  /* 1209 */  false,
  /* 1210 */  false,
  /* 1211 */  false,
  /* 1212 */  false,
  /* 1213 */  false,
  /* 1214 */  false,
  /* 1215 */  false,
  /* 1216 */  false,
  /* 1217 */  false,
  /* 1218 */  false,
  /* 1219 */  false,
  /* 1220 */  false,
  /* 1221 */  false,
  /* 1222 */  false,
  /* 1223 */  false,
  /* 1224 */  false,
  /* 1225 */  false,
  /* 1226 */  false,
  /* 1227 */  false,
  /* 1228 */  false,
  /* 1229 */  false,
  /* 1230 */  false,
  /* 1231 */  false,
  /* 1232 */  false,
  /* 1233 */  false,
  /* 1234 */  false,
  /* 1235 */  false,
  /* 1236 */  false,
  /* 1237 */  false,
  /* 1238 */  false,
  /* 1239 */  false,
  /* 1240 */  false,
  /* 1241 */  false,
  /* 1242 */  false,
  /* 1243 */  false,
  /* 1244 */  false,
  /* 1245 */  false,
  /* 1246 */  false,
  /* 1247 */  false,
  /* 1248 */  false,
  /* 1249 */  false,
  /* 1250 */  false,
  /* 1251 */  false,
  /* 1252 */  false,
  /* 1253 */  false,
  /* 1254 */  false,
  /* 1255 */  false,
  /* 1256 */  false,
  /* 1257 */  false,
  /* 1258 */  false,
  /* 1259 */  false,
  /* 1260 */  false,
  /* 1261 */  false,
  /* 1262 */  false,
  /* 1263 */  false,
  /* 1264 */  false,
  /* 1265 */  false,
  /* 1266 */  false,
  /* 1267 */  false,
  /* 1268 */  false,
  /* 1269 */  false,
  /* 1270 */  false,
  /* 1271 */  false,
  /* 1272 */  false,
  /* 1273 */  false,
  /* 1274 */  false,
  /* 1275 */  false,
  /* 1276 */  false,
  /* 1277 */  false,
  /* 1278 */  false,
  /* 1279 */  false,
  /* 1280 */  false,
  /* 1281 */  false,
  /* 1282 */  false,
  /* 1283 */  false,
  /* 1284 */  false,
  /* 1285 */  false,
  /* 1286 */  false,
  /* 1287 */  false,
  /* 1288 */  false,
  /* 1289 */  false,
  /* 1290 */  false,
  /* 1291 */  false,
  /* 1292 */  false,
  /* 1293 */  false,
  /* 1294 */  false,
  /* 1295 */  false,
  /* 1296 */  false,
  /* 1297 */  false,
  /* 1298 */  false,
  /* 1299 */  false,
  /* 1300 */  false,
  /* 1301 */  false,
  /* 1302 */  false,
  /* 1303 */  false,
  /* 1304 */  false,
  /* 1305 */  false,
  /* 1306 */  false,
  /* 1307 */  false,
  /* 1308 */  false,
  /* 1309 */  false,
  /* 1310 */  false,
  /* 1311 */  false,
  /* 1312 */  false,
  /* 1313 */  false,
  /* 1314 */  false,
  /* 1315 */  false,
  /* 1316 */  false,
  /* 1317 */  false,
  /* 1318 */  false,
  /* 1319 */  false,
  /* 1320 */  false,
  /* 1321 */  false,
  /* 1322 */  false,
  /* 1323 */  false,
  /* 1324 */  false,
  /* 1325 */  false,
  /* 1326 */  false,
  /* 1327 */  false,
  /* 1328 */  false,
  /* 1329 */  false,
  /* 1330 */  false,
  /* 1331 */  false,
  /* 1332 */  false,
  /* 1333 */  false,
  /* 1334 */  false,
  /* 1335 */  false,
  /* 1336 */  false,
  /* 1337 */  false,
  /* 1338 */  false,
  /* 1339 */  false,
  /* 1340 */  false,
  /* 1341 */  false,
  /* 1342 */  false,
  /* 1343 */  false,
  /* 1344 */  false,
  /* 1345 */  false,
  /* 1346 */  false,
  /* 1347 */  false,
  /* 1348 */  false,
  /* 1349 */  false,
  /* 1350 */  false,
  /* 1351 */  false,
  /* 1352 */  false,
  /* 1353 */  false,
  /* 1354 */  false,
  /* 1355 */  false,
  /* 1356 */  false,
  /* 1357 */  false,
  /* 1358 */  false,
  /* 1359 */  false,
  /* 1360 */  false,
  /* 1361 */  false,
  /* 1362 */  false,
  /* 1363 */  false,
  /* 1364 */  false,
  /* 1365 */  false,
  /* 1366 */  false,
  /* 1367 */  false,
  /* 1368 */  false,
  /* 1369 */  false,
  /* 1370 */  false,
  /* 1371 */  false,
  /* 1372 */  false,
  /* 1373 */  false,
  /* 1374 */  false,
  /* 1375 */  false,
  /* 1376 */  false,
  /* 1377 */  false,
  /* 1378 */  false,
  /* 1379 */  false,
  /* 1380 */  false,
  /* 1381 */  false,
  /* 1382 */  false,
  /* 1383 */  false,
  /* 1384 */  false,
  /* 1385 */  false,
  /* 1386 */  false,
  /* 1387 */  false,
  /* 1388 */  false,
  /* 1389 */  false,
  /* 1390 */  false,
  /* 1391 */  false,
  /* 1392 */  false,
  /* 1393 */  false,
  /* 1394 */  false,
  /* 1395 */  false,
  /* 1396 */  false,
  /* 1397 */  false,
  /* 1398 */  false,
  /* 1399 */  false,
  /* 1400 */  false,
  /* 1401 */  false,
  /* 1402 */  false,
  /* 1403 */  false,
  /* 1404 */  false,
  /* 1405 */  false,
  /* 1406 */  false,
  /* 1407 */  false,
  /* 1408 */  false,
  /* 1409 */  false,
  /* 1410 */  false,
  /* 1411 */  false,
  /* 1412 */  false,
  /* 1413 */  false,
  /* 1414 */  false,
  /* 1415 */  false,
  /* 1416 */  false,
  /* 1417 */  false,
  /* 1418 */  false,
  /* 1419 */  false,
  /* 1420 */  false,
  /* 1421 */  false,
  /* 1422 */  false,
  /* 1423 */  false,
  /* 1424 */  false,
  /* 1425 */  false,
  /* 1426 */  false,
  /* 1427 */  false,
  /* 1428 */  false,
  /* 1429 */  false,
  /* 1430 */  false,
  /* 1431 */  false,
  /* 1432 */  false,
  /* 1433 */  false,
  /* 1434 */  false,
  /* 1435 */  false,
  /* 1436 */  false,
  /* 1437 */  false,
  /* 1438 */  false,
  /* 1439 */  false,
  /* 1440 */  false,
  /* 1441 */  false,
  /* 1442 */  false,
  /* 1443 */  false,
  /* 1444 */  false,
  /* 1445 */  false,
  /* 1446 */  false,
  /* 1447 */  false,
  /* 1448 */  false,
  /* 1449 */  false,
  /* 1450 */  false,
  /* 1451 */  false,
  /* 1452 */  false,
  /* 1453 */  false,
  /* 1454 */  false,
  /* 1455 */  false,
  /* 1456 */  false,
  /* 1457 */  false,
  /* 1458 */  false,
  /* 1459 */  false,
  /* 1460 */  false,
  /* 1461 */  false,
  /* 1462 */  false,
  /* 1463 */  false,
  /* 1464 */  false,
  /* 1465 */  false,
  /* 1466 */  false,
  /* 1467 */  false,
  /* 1468 */  false,
  /* 1469 */  false,
  /* 1470 */  false,
  /* 1471 */  false,
  /* 1472 */  false,
  /* 1473 */  false,
  /* 1474 */  false,
  /* 1475 */  false,
  /* 1476 */  false,
  /* 1477 */  false,
  /* 1478 */  false,
  /* 1479 */  false,
  /* 1480 */  false,
  /* 1481 */  false,
  /* 1482 */  false,
  /* 1483 */  false,
  /* 1484 */  false,
  /* 1485 */  false,
  /* 1486 */  false,
  /* 1487 */  false,
  /* 1488 */  false,
  /* 1489 */  false,
  /* 1490 */  false,
  /* 1491 */  false,
  /* 1492 */  false,
  /* 1493 */  false,
  /* 1494 */  false,
  /* 1495 */  false,
  /* 1496 */  false,
  /* 1497 */  false,
  /* 1498 */  false,
  /* 1499 */  false,
  /* 1500 */  false,
  /* 1501 */  false,
  /* 1502 */  false,
  /* 1503 */  false,
  /* 1504 */  false,
  /* 1505 */  false,
  /* 1506 */  false,
  /* 1507 */  false,
  /* 1508 */  false,
  /* 1509 */  false,
  /* 1510 */  false,
  /* 1511 */  false,
  /* 1512 */  false,
  /* 1513 */  false,
  /* 1514 */  false,
  /* 1515 */  false,
  /* 1516 */  false,
  /* 1517 */  false,
  /* 1518 */  false,
  /* 1519 */  false,
  /* 1520 */  false,
  /* 1521 */  false,
  /* 1522 */  false,
  /* 1523 */  false,
  /* 1524 */  false,
  /* 1525 */  false,
  /* 1526 */  false,
  /* 1527 */  false,
  /* 1528 */  false,
  /* 1529 */  false,
  /* 1530 */  false,
  /* 1531 */  false,
  /* 1532 */  false,
  /* 1533 */  false,
  /* 1534 */  false,
  /* 1535 */  false,
  /* 1536 */  false,
  /* 1537 */  false,
  /* 1538 */  false,
  /* 1539 */  false,
  /* 1540 */  false,
  /* 1541 */  false,
  /* 1542 */  false,
  /* 1543 */  false,
  /* 1544 */  false,
  /* 1545 */  false,
  /* 1546 */  false,
  /* 1547 */  false,
  /* 1548 */  false,
  /* 1549 */  false,
  /* 1550 */  false,
  /* 1551 */  false,
  /* 1552 */  false,
  /* 1553 */  false,
  /* 1554 */  false,
  /* 1555 */  false,
  /* 1556 */  false,
  /* 1557 */  false,
  /* 1558 */  false,
  /* 1559 */  false,
  /* 1560 */  false,
  /* 1561 */  false,
  /* 1562 */  false,
  /* 1563 */  false,
  /* 1564 */  false,
  /* 1565 */  false,
  /* 1566 */  false,
  /* 1567 */  false,
  /* 1568 */  false,
  /* 1569 */  false,
  /* 1570 */  false,
  /* 1571 */  false,
  /* 1572 */  false,
  /* 1573 */  false,
  /* 1574 */  false,
  /* 1575 */  false,
  /* 1576 */  false,
  /* 1577 */  false,
  /* 1578 */  false,
  /* 1579 */  false,
  /* 1580 */  false,
  /* 1581 */  false,
  /* 1582 */  false,
  /* 1583 */  false,
  /* 1584 */  false,
  /* 1585 */  false,
  /* 1586 */  false,
  /* 1587 */  false,
  /* 1588 */  false,
  /* 1589 */  false,
  /* 1590 */  false,
  /* 1591 */  false,
  /* 1592 */  false,
  /* 1593 */  false,
  /* 1594 */  false,
  /* 1595 */  false,
  /* 1596 */  false,
  /* 1597 */  false,
  /* 1598 */  false,
  /* 1599 */  false,
  /* 1600 */  false,
  /* 1601 */  false,
  /* 1602 */  false,
  /* 1603 */  false,
  /* 1604 */  false,
  /* 1605 */  false,
  /* 1606 */  false,
  /* 1607 */  false,
  /* 1608 */  false,
  /* 1609 */  false,
  /* 1610 */  false,
  /* 1611 */  false,
  /* 1612 */  false,
  /* 1613 */  false,
  /* 1614 */  false,
  /* 1615 */  false,
  /* 1616 */  false,
  /* 1617 */  false,
  /* 1618 */  false,
  /* 1619 */  false,
  /* 1620 */  false,
  /* 1621 */  false,
  /* 1622 */  false,
  /* 1623 */  false,
  /* 1624 */  false,
  /* 1625 */  false,
  /* 1626 */  false,
  /* 1627 */  false,
  /* 1628 */  false,
  /* 1629 */  false,
  /* 1630 */  false,
  /* 1631 */  false,
  /* 1632 */  false,
  /* 1633 */  false,
  /* 1634 */  false,
  /* 1635 */  false,
  /* 1636 */  false,
  /* 1637 */  false,
  /* 1638 */  false,
  /* 1639 */  false,
  /* 1640 */  false,
  /* 1641 */  false,
  /* 1642 */  false,
  /* 1643 */  false,
  /* 1644 */  false,
  /* 1645 */  false,
  /* 1646 */  false,
  /* 1647 */  false,
  /* 1648 */  false,
  /* 1649 */  false,
  /* 1650 */  false,
  /* 1651 */  false,
  /* 1652 */  false,
  /* 1653 */  false,
  /* 1654 */  false,
  /* 1655 */  false,
  /* 1656 */  false,
  /* 1657 */  false,
  /* 1658 */  false,
  /* 1659 */  false,
  /* 1660 */  false,
  /* 1661 */  false,
  /* 1662 */  false,
  /* 1663 */  false,
  /* 1664 */  false,
  /* 1665 */  false,
  /* 1666 */  false,
  /* 1667 */  false,
  /* 1668 */  false,
  /* 1669 */  false,
  /* 1670 */  false,
  /* 1671 */  false,
  /* 1672 */  false,
  /* 1673 */  false,
  /* 1674 */  false,
  /* 1675 */  false,
  /* 1676 */  false,
  /* 1677 */  false,
  /* 1678 */  false,
  /* 1679 */  false,
  /* 1680 */  false,
  /* 1681 */  false,
  /* 1682 */  false,
  /* 1683 */  false,
  /* 1684 */  false,
  /* 1685 */  false,
  /* 1686 */  false,
  /* 1687 */  false,
  /* 1688 */  false,
  /* 1689 */  false,
  /* 1690 */  false,
  /* 1691 */  false,
  /* 1692 */  false,
  /* 1693 */  false,
  /* 1694 */  false,
  /* 1695 */  false,
  /* 1696 */  false,
  /* 1697 */  false,
  /* 1698 */  false,
  /* 1699 */  false,
  /* 1700 */  false,
  /* 1701 */  false,
  /* 1702 */  false,
  /* 1703 */  false,
  /* 1704 */  false,
  /* 1705 */  false,
  /* 1706 */  false,
  /* 1707 */  false,
  /* 1708 */  false,
  /* 1709 */  false,
  /* 1710 */  false,
  /* 1711 */  false,
  /* 1712 */  false,
  /* 1713 */  false,
  /* 1714 */  false,
  /* 1715 */  false,
  /* 1716 */  false,
  /* 1717 */  false,
  /* 1718 */  false,
  /* 1719 */  false,
  /* 1720 */  false,
  /* 1721 */  false,
  /* 1722 */  false,
  /* 1723 */  false,
  /* 1724 */  false,
  /* 1725 */  false,
  /* 1726 */  false,
  /* 1727 */  false,
  /* 1728 */  false,
  /* 1729 */  false,
  /* 1730 */  false,
  /* 1731 */  false,
  /* 1732 */  false,
  /* 1733 */  false,
  /* 1734 */  false,
  // last instruction
  false // no trailing comma
};

// Mapping from machine-independent opcode to boolean
const        char must_clone[] = {
  0, // Node: 0
  0, // Set: 1
  0, // RegN: 2
  0, // RegI: 3
  0, // RegP: 4
  0, // RegF: 5
  0, // RegD: 6
  0, // RegL: 7
  0, // VecA: 8
  0, // VecS: 9
  0, // VecD: 10
  0, // VecX: 11
  0, // VecY: 12
  0, // VecZ: 13
  0, // RegVectMask: 14
  0, // RegFlags: 15
  0, // _last_machine_leaf: 16
  0, // AbsD: 17
  0, // AbsF: 18
  0, // AbsI: 19
  0, // AbsL: 20
  0, // AddD: 21
  0, // AddF: 22
  0, // AddI: 23
  0, // AddL: 24
  0, // AddP: 25
  0, // Allocate: 26
  0, // AllocateArray: 27
  0, // AndI: 28
  0, // AndL: 29
  0, // ArrayCopy: 30
  0, // AryEq: 31
  0, // AtanD: 32
  1, // Binary: 33
  0, // Blackhole: 34
  1, // Bool: 35
  0, // BoxLock: 36
  0, // ReverseBytesI: 37
  0, // ReverseBytesL: 38
  0, // ReverseBytesUS: 39
  0, // ReverseBytesS: 40
  0, // ReverseBytesV: 41
  0, // CProj: 42
  0, // CacheWB: 43
  0, // CacheWBPreSync: 44
  0, // CacheWBPostSync: 45
  0, // CallDynamicJava: 46
  0, // CallJava: 47
  0, // CallLeaf: 48
  0, // CallLeafNoFP: 49
  0, // CallLeafVector: 50
  0, // CallRuntime: 51
  0, // CallStaticJava: 52
  0, // CastDD: 53
  0, // CastFF: 54
  0, // CastII: 55
  0, // CastLL: 56
  0, // CastVV: 57
  0, // CastX2P: 58
  0, // CastP2X: 59
  0, // CastPP: 60
  0, // Catch: 61
  0, // CatchProj: 62
  0, // CheckCastPP: 63
  0, // ClearArray: 64
  0, // CompressBits: 65
  0, // ExpandBits: 66
  0, // CompressBitsV: 67
  0, // ExpandBitsV: 68
  0, // ConstraintCast: 69
  0, // CMoveD: 70
  0, // CMoveF: 71
  0, // CMoveI: 72
  0, // CMoveL: 73
  0, // CMoveP: 74
  0, // CMoveN: 75
  1, // CmpN: 76
  1, // CmpD: 77
  0, // CmpD3: 78
  1, // CmpF: 79
  0, // CmpF3: 80
  1, // CmpI: 81
  1, // CmpL: 82
  0, // CmpL3: 83
  0, // CmpLTMask: 84
  1, // CmpP: 85
  1, // CmpU: 86
  0, // CmpU3: 87
  1, // CmpUL: 88
  0, // CmpUL3: 89
  0, // CompareAndSwapB: 90
  0, // CompareAndSwapS: 91
  0, // CompareAndSwapI: 92
  0, // CompareAndSwapL: 93
  0, // CompareAndSwapP: 94
  0, // CompareAndSwapN: 95
  0, // WeakCompareAndSwapB: 96
  0, // WeakCompareAndSwapS: 97
  0, // WeakCompareAndSwapI: 98
  0, // WeakCompareAndSwapL: 99
  0, // WeakCompareAndSwapP: 100
  0, // WeakCompareAndSwapN: 101
  0, // CompareAndExchangeB: 102
  0, // CompareAndExchangeS: 103
  0, // CompareAndExchangeI: 104
  0, // CompareAndExchangeL: 105
  0, // CompareAndExchangeP: 106
  0, // CompareAndExchangeN: 107
  0, // GetAndAddB: 108
  0, // GetAndAddS: 109
  0, // GetAndAddI: 110
  0, // GetAndAddL: 111
  0, // GetAndSetB: 112
  0, // GetAndSetS: 113
  0, // GetAndSetI: 114
  0, // GetAndSetL: 115
  0, // GetAndSetP: 116
  0, // GetAndSetN: 117
  0, // Con: 118
  0, // ConN: 119
  0, // ConNKlass: 120
  0, // ConD: 121
  0, // ConF: 122
  0, // ConI: 123
  0, // ConL: 124
  0, // ConP: 125
  0, // Conv2B: 126
  0, // ConvD2F: 127
  0, // ConvD2I: 128
  0, // ConvD2L: 129
  0, // ConvF2D: 130
  0, // ConvF2I: 131
  0, // ConvF2L: 132
  0, // ConvI2D: 133
  0, // ConvI2F: 134
  0, // ConvI2L: 135
  0, // ConvL2D: 136
  0, // ConvL2F: 137
  0, // ConvL2I: 138
  0, // ConvF2HF: 139
  0, // ConvHF2F: 140
  0, // CountedLoop: 141
  0, // CountedLoopEnd: 142
  0, // OuterStripMinedLoop: 143
  0, // OuterStripMinedLoopEnd: 144
  0, // LongCountedLoop: 145
  0, // LongCountedLoopEnd: 146
  0, // CountLeadingZerosI: 147
  0, // CountLeadingZerosL: 148
  0, // CountLeadingZerosV: 149
  0, // CountTrailingZerosI: 150
  0, // CountTrailingZerosL: 151
  0, // CountTrailingZerosV: 152
  0, // CreateEx: 153
  0, // DecodeN: 154
  0, // DecodeNKlass: 155
  0, // DivD: 156
  0, // DivF: 157
  0, // DivI: 158
  0, // DivL: 159
  0, // UDivI: 160
  0, // UDivL: 161
  0, // DivMod: 162
  0, // DivModI: 163
  0, // DivModL: 164
  0, // UDivModI: 165
  0, // UDivModL: 166
  0, // EncodeISOArray: 167
  0, // EncodeP: 168
  0, // EncodePKlass: 169
  1, // FastLock: 170
  1, // FastUnlock: 171
  0, // FmaD: 172
  0, // FmaF: 173
  0, // ForwardException: 174
  0, // Goto: 175
  0, // Halt: 176
  0, // CountPositives: 177
  0, // If: 178
  0, // RangeCheck: 179
  0, // IfFalse: 180
  0, // IfTrue: 181
  0, // Initialize: 182
  0, // JProj: 183
  0, // Jump: 184
  0, // JumpProj: 185
  0, // LShiftI: 186
  0, // LShiftL: 187
  0, // LoadB: 188
  0, // LoadUB: 189
  0, // LoadUS: 190
  0, // LoadD: 191
  0, // LoadD_unaligned: 192
  0, // LoadF: 193
  0, // LoadI: 194
  0, // LoadKlass: 195
  0, // LoadNKlass: 196
  0, // LoadL: 197
  0, // LoadL_unaligned: 198
  0, // LoadP: 199
  0, // LoadN: 200
  0, // LoadRange: 201
  0, // LoadS: 202
  0, // Lock: 203
  0, // Loop: 204
  0, // LoopLimit: 205
  0, // Mach: 206
  0, // MachNullCheck: 207
  0, // MachProj: 208
  0, // MulAddS2I: 209
  0, // MaxI: 210
  0, // MaxL: 211
  0, // MaxD: 212
  0, // MaxF: 213
  0, // MemBarAcquire: 214
  0, // LoadFence: 215
  0, // MemBarAcquireLock: 216
  0, // MemBarCPUOrder: 217
  0, // MemBarRelease: 218
  0, // StoreFence: 219
  0, // StoreStoreFence: 220
  0, // MemBarReleaseLock: 221
  0, // MemBarVolatile: 222
  0, // MemBarStoreStore: 223
  0, // MergeMem: 224
  0, // MinI: 225
  0, // MinL: 226
  0, // MinF: 227
  0, // MinD: 228
  0, // ModD: 229
  0, // ModF: 230
  0, // ModI: 231
  0, // ModL: 232
  0, // UModI: 233
  0, // UModL: 234
  0, // MoveI2F: 235
  0, // MoveF2I: 236
  0, // MoveL2D: 237
  0, // MoveD2L: 238
  0, // IsInfiniteF: 239
  0, // IsFiniteF: 240
  0, // IsInfiniteD: 241
  0, // IsFiniteD: 242
  0, // MulD: 243
  0, // MulF: 244
  0, // MulHiL: 245
  0, // UMulHiL: 246
  0, // MulI: 247
  0, // MulL: 248
  0, // Multi: 249
  0, // NegI: 250
  0, // NegL: 251
  0, // NegD: 252
  0, // NegF: 253
  0, // NeverBranch: 254
  0, // OnSpinWait: 255
  0, // Opaque1: 256
  0, // OpaqueLoopInit: 257
  0, // OpaqueLoopStride: 258
  0, // OpaqueZeroTripGuard: 259
  0, // OpaqueNotNull: 260
  0, // OpaqueInitializedAssertionPredicate: 261
  0, // OpaqueTemplateAssertionPredicate: 262
  0, // ProfileBoolean: 263
  0, // OrI: 264
  0, // OrL: 265
  1, // OverflowAddI: 266
  1, // OverflowSubI: 267
  1, // OverflowMulI: 268
  1, // OverflowAddL: 269
  1, // OverflowSubL: 270
  1, // OverflowMulL: 271
  0, // PCTable: 272
  0, // Parm: 273
  0, // ParsePredicate: 274
  0, // PartialSubtypeCheck: 275
  0, // SubTypeCheck: 276
  0, // Phi: 277
  0, // PopCountI: 278
  0, // PopCountL: 279
  0, // PopCountVI: 280
  0, // PopCountVL: 281
  0, // PopulateIndex: 282
  0, // PrefetchAllocation: 283
  0, // Proj: 284
  0, // RShiftI: 285
  0, // RShiftL: 286
  0, // Region: 287
  0, // Rethrow: 288
  0, // Return: 289
  0, // ReverseI: 290
  0, // ReverseL: 291
  0, // ReverseV: 292
  0, // Root: 293
  0, // RoundDouble: 294
  0, // RoundDoubleMode: 295
  0, // RoundDoubleModeV: 296
  0, // RoundFloat: 297
  0, // RotateLeft: 298
  0, // RotateLeftV: 299
  0, // RotateRight: 300
  0, // RotateRightV: 301
  0, // SafePoint: 302
  0, // SafePointScalarObject: 303
  0, // SafePointScalarMerge: 304
  0, // ShenandoahCompareAndExchangeP: 305
  0, // ShenandoahCompareAndExchangeN: 306
  0, // ShenandoahCompareAndSwapN: 307
  0, // ShenandoahCompareAndSwapP: 308
  0, // ShenandoahWeakCompareAndSwapN: 309
  0, // ShenandoahWeakCompareAndSwapP: 310
  0, // ShenandoahLoadReferenceBarrier: 311
  0, // SCMemProj: 312
  0, // CopySignD: 313
  0, // CopySignF: 314
  0, // SaturatingAddV: 315
  0, // SaturatingSubV: 316
  0, // SignumD: 317
  0, // SignumF: 318
  0, // SignumVF: 319
  0, // SignumVD: 320
  0, // SqrtD: 321
  0, // SqrtF: 322
  0, // RoundF: 323
  0, // RoundD: 324
  0, // Start: 325
  0, // StartOSR: 326
  0, // StoreB: 327
  0, // StoreC: 328
  0, // StoreD: 329
  0, // StoreF: 330
  0, // StoreI: 331
  0, // StoreL: 332
  0, // StoreP: 333
  0, // StoreN: 334
  0, // StoreNKlass: 335
  0, // StrComp: 336
  0, // StrCompressedCopy: 337
  0, // StrEquals: 338
  0, // StrIndexOf: 339
  0, // StrIndexOfChar: 340
  0, // StrInflatedCopy: 341
  0, // SubD: 342
  0, // SubF: 343
  0, // SubI: 344
  0, // SubL: 345
  0, // TailCall: 346
  0, // TailJump: 347
  0, // MacroLogicV: 348
  0, // ThreadLocal: 349
  0, // Unlock: 350
  0, // URShiftB: 351
  0, // URShiftS: 352
  0, // URShiftI: 353
  0, // URShiftL: 354
  0, // XorI: 355
  0, // XorL: 356
  0, // Vector: 357
  0, // AddVB: 358
  0, // AddVS: 359
  0, // AddVI: 360
  0, // AddReductionVI: 361
  0, // AddVL: 362
  0, // AddReductionVL: 363
  0, // AddVF: 364
  0, // AddReductionVF: 365
  0, // AddVD: 366
  0, // AddReductionVD: 367
  0, // SubVB: 368
  0, // SubVS: 369
  0, // SubVI: 370
  0, // SubVL: 371
  0, // SubVF: 372
  0, // SubVD: 373
  0, // MulVB: 374
  0, // MulVS: 375
  0, // MulVI: 376
  0, // MulReductionVI: 377
  0, // MulVL: 378
  0, // MulReductionVL: 379
  0, // MulVF: 380
  0, // MulReductionVF: 381
  0, // MulVD: 382
  0, // MulReductionVD: 383
  0, // MulAddVS2VI: 384
  0, // FmaVD: 385
  0, // FmaVF: 386
  0, // DivVF: 387
  0, // DivVD: 388
  0, // AbsVB: 389
  0, // AbsVS: 390
  0, // AbsVI: 391
  0, // AbsVL: 392
  0, // AbsVF: 393
  0, // AbsVD: 394
  0, // NegVI: 395
  0, // NegVL: 396
  0, // NegVF: 397
  0, // NegVD: 398
  0, // SqrtVD: 399
  0, // SqrtVF: 400
  0, // LShiftCntV: 401
  0, // RShiftCntV: 402
  0, // LShiftVB: 403
  0, // LShiftVS: 404
  0, // LShiftVI: 405
  0, // LShiftVL: 406
  0, // RShiftVB: 407
  0, // RShiftVS: 408
  0, // RShiftVI: 409
  0, // RShiftVL: 410
  0, // URShiftVB: 411
  0, // URShiftVS: 412
  0, // URShiftVI: 413
  0, // URShiftVL: 414
  0, // AndV: 415
  0, // AndReductionV: 416
  0, // OrV: 417
  0, // OrReductionV: 418
  0, // XorV: 419
  0, // XorReductionV: 420
  0, // MinV: 421
  0, // MaxV: 422
  0, // UMinV: 423
  0, // UMaxV: 424
  0, // MinReductionV: 425
  0, // MaxReductionV: 426
  0, // CompressV: 427
  0, // CompressM: 428
  0, // ExpandV: 429
  0, // LoadVector: 430
  0, // LoadVectorGather: 431
  0, // LoadVectorGatherMasked: 432
  0, // StoreVector: 433
  0, // StoreVectorScatter: 434
  0, // StoreVectorScatterMasked: 435
  0, // LoadVectorMasked: 436
  0, // StoreVectorMasked: 437
  0, // VerifyVectorAlignment: 438
  0, // VectorCmpMasked: 439
  0, // VectorMaskGen: 440
  0, // VectorMaskOp: 441
  0, // VectorMaskTrueCount: 442
  0, // VectorMaskFirstTrue: 443
  0, // VectorMaskLastTrue: 444
  0, // VectorMaskToLong: 445
  0, // VectorLongToMask: 446
  0, // Pack: 447
  0, // PackB: 448
  0, // PackS: 449
  0, // PackI: 450
  0, // PackL: 451
  0, // PackF: 452
  0, // PackD: 453
  0, // Pack2L: 454
  0, // Pack2D: 455
  0, // Replicate: 456
  0, // RoundVF: 457
  0, // RoundVD: 458
  0, // Extract: 459
  0, // ExtractB: 460
  0, // ExtractUB: 461
  0, // ExtractC: 462
  0, // ExtractS: 463
  0, // ExtractI: 464
  0, // ExtractL: 465
  0, // ExtractF: 466
  0, // ExtractD: 467
  0, // Digit: 468
  0, // LowerCase: 469
  0, // UpperCase: 470
  0, // Whitespace: 471
  0, // SelectFromTwoVector: 472
  0, // VectorBox: 473
  0, // VectorBoxAllocate: 474
  0, // VectorUnbox: 475
  0, // VectorMaskWrapper: 476
  0, // VectorMaskCmp: 477
  0, // VectorMaskCast: 478
  1, // VectorTest: 479
  0, // VectorBlend: 480
  0, // VectorRearrange: 481
  0, // VectorLoadMask: 482
  0, // VectorLoadShuffle: 483
  0, // VectorLoadConst: 484
  0, // VectorStoreMask: 485
  0, // VectorReinterpret: 486
  0, // VectorCast: 487
  0, // VectorCastB2X: 488
  0, // VectorCastS2X: 489
  0, // VectorCastI2X: 490
  0, // VectorCastL2X: 491
  0, // VectorCastF2X: 492
  0, // VectorCastD2X: 493
  0, // VectorCastF2HF: 494
  0, // VectorCastHF2F: 495
  0, // VectorUCastB2X: 496
  0, // VectorUCastS2X: 497
  0, // VectorUCastI2X: 498
  0, // VectorizedHashCode: 499
  0, // VectorInsert: 500
  0, // MaskAll: 501
  0, // AndVMask: 502
  0, // OrVMask: 503
  0 // no trailing comma // XorVMask: 504
};
//  The following instructions can cisc-spill
//  MoveVL2F can cisc-spill operand 1 to loadF
//  MoveLEG2F can cisc-spill operand 1 to loadF
//  MoveVL2D can cisc-spill operand 1 to loadSSD
//  MoveLEG2D can cisc-spill operand 1 to loadSSD
//  countLeadingZerosI can cisc-spill operand 1 to countLeadingZerosI_mem
//  countLeadingZerosL can cisc-spill operand 1 to countLeadingZerosL_mem
//  countTrailingZerosI can cisc-spill operand 1 to countTrailingZerosI_mem
//  countTrailingZerosL can cisc-spill operand 1 to countTrailingZerosL_mem
//  popCountI can cisc-spill operand 1 to popCountI_mem
//  popCountL can cisc-spill operand 1 to popCountL_mem
//  cmovI_reg can cisc-spill operand 4 to cmovI_mem
//  cmovI_regU can cisc-spill operand 4 to cmovI_memU
//  cmovI_regUCF can cisc-spill operand 4 to cmovI_memUCF
//  cmovL_reg can cisc-spill operand 4 to cmovL_mem
//  cmovL_regU can cisc-spill operand 4 to cmovL_memU
//  cmovL_regUCF can cisc-spill operand 4 to cmovL_memUCF
//  addI_rReg can cisc-spill operand 2 to addI_rReg_mem
//  addL_rReg can cisc-spill operand 2 to addL_rReg_mem
//  subI_rReg can cisc-spill operand 2 to subI_rReg_mem
//  subL_rReg can cisc-spill operand 2 to subL_rReg_mem
//  mulI_rReg can cisc-spill operand 2 to mulI_mem
//  mulI_rReg_imm can cisc-spill operand 1 to mulI_mem_imm
//  mulL_rReg can cisc-spill operand 2 to mulL_mem
//  mulL_rReg_imm can cisc-spill operand 1 to mulL_mem_imm
//  salI_rReg_rReg can cisc-spill operand 1 to salI_mem_rReg
//  sarI_rReg_rReg can cisc-spill operand 1 to sarI_mem_rReg
//  shrI_rReg_rReg can cisc-spill operand 1 to shrI_mem_rReg
//  salL_rReg_rReg can cisc-spill operand 1 to salL_mem_rReg
//  sarL_rReg_rReg can cisc-spill operand 1 to sarL_mem_rReg
//  shrL_rReg_rReg can cisc-spill operand 1 to shrL_mem_rReg
//  i2b can cisc-spill operand 1 to loadI2B
//  i2s can cisc-spill operand 1 to loadI2S
//  rolI_immI8 can cisc-spill operand 1 to rolI_mem_immI8
//  rorI_immI8 can cisc-spill operand 1 to rorI_mem_immI8
//  rolL_immI8 can cisc-spill operand 1 to rolL_mem_immI8
//  rorL_immI8 can cisc-spill operand 1 to rorL_mem_immI8
//  compressBitsL_reg can cisc-spill operand 2 to compressBitsL_mem
//  expandBitsL_reg can cisc-spill operand 2 to expandBitsL_mem
//  andI_rReg can cisc-spill operand 2 to andI_rReg_mem
//  andI_rReg_imm255 can cisc-spill operand 1 to loadI2UB
//  andI2L_rReg_imm255 can cisc-spill operand 1 to loadI2L_immI_255
//  andI_rReg_imm65535 can cisc-spill operand 1 to loadI2US
//  andI2L_rReg_imm65535 can cisc-spill operand 1 to loadI2L_immI_65535
//  andnI_rReg_rReg_rReg can cisc-spill operand 3 to andnI_rReg_rReg_mem
//  andnI_rReg_rReg_rReg_0 can cisc-spill operand 1 to andnI_rReg_rReg_mem_0
//  orI_rReg can cisc-spill operand 2 to orI_rReg_mem
//  xorI_rReg can cisc-spill operand 2 to xorI_rReg_mem
//  andL_rReg can cisc-spill operand 2 to andL_rReg_mem
//  andnL_rReg_rReg_rReg can cisc-spill operand 3 to andnL_rReg_rReg_mem
//  andnL_rReg_rReg_rReg_0 can cisc-spill operand 1 to andnL_rReg_rReg_mem_0
//  orL_rReg can cisc-spill operand 2 to orL_rReg_mem
//  xorL_rReg can cisc-spill operand 2 to xorL_rReg_mem
//  cmpF_cc_reg_CF can cisc-spill operand 2 to cmpF_cc_memCF
//  cmpD_cc_reg_CF can cisc-spill operand 2 to cmpD_cc_memCF
//  cmpF_reg can cisc-spill operand 2 to cmpF_mem
//  cmpD_reg can cisc-spill operand 2 to cmpD_mem
//  convI2L_reg_reg can cisc-spill operand 1 to loadI2L
//  convI2L_reg_reg_zex can cisc-spill operand 1 to loadUI2L
//  MoveF2I_reg_reg can cisc-spill operand 1 to MoveF2I_stack_reg
//  MoveD2L_reg_reg can cisc-spill operand 1 to MoveD2L_stack_reg
//  MoveI2F_reg_reg can cisc-spill operand 1 to MoveI2F_stack_reg
//  compI_rReg can cisc-spill operand 2 to compI_rReg_mem
//  testI_reg_reg can cisc-spill operand 2 to testI_reg_mem
//  compU_rReg can cisc-spill operand 2 to compU_rReg_mem
//  compL_rReg can cisc-spill operand 2 to compL_rReg_mem
//  testL_reg_reg can cisc-spill operand 2 to testL_reg_mem
//  compUL_rReg can cisc-spill operand 2 to compUL_rReg_mem
//  addF_reg can cisc-spill operand 2 to addF_mem
//  addF_reg_reg can cisc-spill operand 2 to addF_reg_mem
//  addD_reg can cisc-spill operand 2 to addD_mem
//  addD_reg_reg can cisc-spill operand 2 to addD_reg_mem
//  subF_reg can cisc-spill operand 2 to subF_mem
//  subF_reg_reg can cisc-spill operand 2 to subF_reg_mem
//  subD_reg can cisc-spill operand 2 to subD_mem
//  subD_reg_reg can cisc-spill operand 2 to subD_reg_mem
//  mulF_reg can cisc-spill operand 2 to mulF_mem
//  mulF_reg_reg can cisc-spill operand 2 to mulF_reg_mem
//  mulD_reg can cisc-spill operand 2 to mulD_mem
//  mulD_reg_reg can cisc-spill operand 2 to mulD_reg_mem
//  divF_reg can cisc-spill operand 2 to divF_mem
//  divF_reg_reg can cisc-spill operand 2 to divF_reg_mem
//  divD_reg can cisc-spill operand 2 to divD_mem
//  divD_reg_reg can cisc-spill operand 2 to divD_reg_mem
//  ReplI_reg can cisc-spill operand 1 to ReplI_mem
//  ReplL_reg can cisc-spill operand 1 to ReplL_mem
//  vReplF_reg can cisc-spill operand 1 to ReplF_mem
//  vReplD_reg can cisc-spill operand 1 to ReplD_mem
//  compressBitsI_reg can cisc-spill operand 2 to compressBitsI_mem
//  expandBitsI_reg can cisc-spill operand 2 to expandBitsI_mem



// An array of character pointers to machine register names.
const char *Matcher::regName[REG_COUNT] = {
  "R10",
  "R10_H",
  "R11",
  "R11_H",
  "R8",
  "R8_H",
  "R9",
  "R9_H",
  "R12",
  "R12_H",
  "RCX",
  "RCX_H",
  "RBX",
  "RBX_H",
  "RDI",
  "RDI_H",
  "RDX",
  "RDX_H",
  "RSI",
  "RSI_H",
  "RAX",
  "RAX_H",
  "RBP",
  "RBP_H",
  "R13",
  "R13_H",
  "R14",
  "R14_H",
  "R15",
  "R15_H",
  "R16",
  "R16_H",
  "R17",
  "R17_H",
  "R18",
  "R18_H",
  "R19",
  "R19_H",
  "R20",
  "R20_H",
  "R21",
  "R21_H",
  "R22",
  "R22_H",
  "R23",
  "R23_H",
  "R24",
  "R24_H",
  "R25",
  "R25_H",
  "R26",
  "R26_H",
  "R27",
  "R27_H",
  "R28",
  "R28_H",
  "R29",
  "R29_H",
  "R30",
  "R30_H",
  "R31",
  "R31_H",
  "RSP",
  "RSP_H",
  "XMM0",
  "XMM0b",
  "XMM0c",
  "XMM0d",
  "XMM0e",
  "XMM0f",
  "XMM0g",
  "XMM0h",
  "XMM0i",
  "XMM0j",
  "XMM0k",
  "XMM0l",
  "XMM0m",
  "XMM0n",
  "XMM0o",
  "XMM0p",
  "XMM1",
  "XMM1b",
  "XMM1c",
  "XMM1d",
  "XMM1e",
  "XMM1f",
  "XMM1g",
  "XMM1h",
  "XMM1i",
  "XMM1j",
  "XMM1k",
  "XMM1l",
  "XMM1m",
  "XMM1n",
  "XMM1o",
  "XMM1p",
  "XMM2",
  "XMM2b",
  "XMM2c",
  "XMM2d",
  "XMM2e",
  "XMM2f",
  "XMM2g",
  "XMM2h",
  "XMM2i",
  "XMM2j",
  "XMM2k",
  "XMM2l",
  "XMM2m",
  "XMM2n",
  "XMM2o",
  "XMM2p",
  "XMM3",
  "XMM3b",
  "XMM3c",
  "XMM3d",
  "XMM3e",
  "XMM3f",
  "XMM3g",
  "XMM3h",
  "XMM3i",
  "XMM3j",
  "XMM3k",
  "XMM3l",
  "XMM3m",
  "XMM3n",
  "XMM3o",
  "XMM3p",
  "XMM4",
  "XMM4b",
  "XMM4c",
  "XMM4d",
  "XMM4e",
  "XMM4f",
  "XMM4g",
  "XMM4h",
  "XMM4i",
  "XMM4j",
  "XMM4k",
  "XMM4l",
  "XMM4m",
  "XMM4n",
  "XMM4o",
  "XMM4p",
  "XMM5",
  "XMM5b",
  "XMM5c",
  "XMM5d",
  "XMM5e",
  "XMM5f",
  "XMM5g",
  "XMM5h",
  "XMM5i",
  "XMM5j",
  "XMM5k",
  "XMM5l",
  "XMM5m",
  "XMM5n",
  "XMM5o",
  "XMM5p",
  "XMM6",
  "XMM6b",
  "XMM6c",
  "XMM6d",
  "XMM6e",
  "XMM6f",
  "XMM6g",
  "XMM6h",
  "XMM6i",
  "XMM6j",
  "XMM6k",
  "XMM6l",
  "XMM6m",
  "XMM6n",
  "XMM6o",
  "XMM6p",
  "XMM7",
  "XMM7b",
  "XMM7c",
  "XMM7d",
  "XMM7e",
  "XMM7f",
  "XMM7g",
  "XMM7h",
  "XMM7i",
  "XMM7j",
  "XMM7k",
  "XMM7l",
  "XMM7m",
  "XMM7n",
  "XMM7o",
  "XMM7p",
  "XMM8",
  "XMM8b",
  "XMM8c",
  "XMM8d",
  "XMM8e",
  "XMM8f",
  "XMM8g",
  "XMM8h",
  "XMM8i",
  "XMM8j",
  "XMM8k",
  "XMM8l",
  "XMM8m",
  "XMM8n",
  "XMM8o",
  "XMM8p",
  "XMM9",
  "XMM9b",
  "XMM9c",
  "XMM9d",
  "XMM9e",
  "XMM9f",
  "XMM9g",
  "XMM9h",
  "XMM9i",
  "XMM9j",
  "XMM9k",
  "XMM9l",
  "XMM9m",
  "XMM9n",
  "XMM9o",
  "XMM9p",
  "XMM10",
  "XMM10b",
  "XMM10c",
  "XMM10d",
  "XMM10e",
  "XMM10f",
  "XMM10g",
  "XMM10h",
  "XMM10i",
  "XMM10j",
  "XMM10k",
  "XMM10l",
  "XMM10m",
  "XMM10n",
  "XMM10o",
  "XMM10p",
  "XMM11",
  "XMM11b",
  "XMM11c",
  "XMM11d",
  "XMM11e",
  "XMM11f",
  "XMM11g",
  "XMM11h",
  "XMM11i",
  "XMM11j",
  "XMM11k",
  "XMM11l",
  "XMM11m",
  "XMM11n",
  "XMM11o",
  "XMM11p",
  "XMM12",
  "XMM12b",
  "XMM12c",
  "XMM12d",
  "XMM12e",
  "XMM12f",
  "XMM12g",
  "XMM12h",
  "XMM12i",
  "XMM12j",
  "XMM12k",
  "XMM12l",
  "XMM12m",
  "XMM12n",
  "XMM12o",
  "XMM12p",
  "XMM13",
  "XMM13b",
  "XMM13c",
  "XMM13d",
  "XMM13e",
  "XMM13f",
  "XMM13g",
  "XMM13h",
  "XMM13i",
  "XMM13j",
  "XMM13k",
  "XMM13l",
  "XMM13m",
  "XMM13n",
  "XMM13o",
  "XMM13p",
  "XMM14",
  "XMM14b",
  "XMM14c",
  "XMM14d",
  "XMM14e",
  "XMM14f",
  "XMM14g",
  "XMM14h",
  "XMM14i",
  "XMM14j",
  "XMM14k",
  "XMM14l",
  "XMM14m",
  "XMM14n",
  "XMM14o",
  "XMM14p",
  "XMM15",
  "XMM15b",
  "XMM15c",
  "XMM15d",
  "XMM15e",
  "XMM15f",
  "XMM15g",
  "XMM15h",
  "XMM15i",
  "XMM15j",
  "XMM15k",
  "XMM15l",
  "XMM15m",
  "XMM15n",
  "XMM15o",
  "XMM15p",
  "XMM16",
  "XMM16b",
  "XMM16c",
  "XMM16d",
  "XMM16e",
  "XMM16f",
  "XMM16g",
  "XMM16h",
  "XMM16i",
  "XMM16j",
  "XMM16k",
  "XMM16l",
  "XMM16m",
  "XMM16n",
  "XMM16o",
  "XMM16p",
  "XMM17",
  "XMM17b",
  "XMM17c",
  "XMM17d",
  "XMM17e",
  "XMM17f",
  "XMM17g",
  "XMM17h",
  "XMM17i",
  "XMM17j",
  "XMM17k",
  "XMM17l",
  "XMM17m",
  "XMM17n",
  "XMM17o",
  "XMM17p",
  "XMM18",
  "XMM18b",
  "XMM18c",
  "XMM18d",
  "XMM18e",
  "XMM18f",
  "XMM18g",
  "XMM18h",
  "XMM18i",
  "XMM18j",
  "XMM18k",
  "XMM18l",
  "XMM18m",
  "XMM18n",
  "XMM18o",
  "XMM18p",
  "XMM19",
  "XMM19b",
  "XMM19c",
  "XMM19d",
  "XMM19e",
  "XMM19f",
  "XMM19g",
  "XMM19h",
  "XMM19i",
  "XMM19j",
  "XMM19k",
  "XMM19l",
  "XMM19m",
  "XMM19n",
  "XMM19o",
  "XMM19p",
  "XMM20",
  "XMM20b",
  "XMM20c",
  "XMM20d",
  "XMM20e",
  "XMM20f",
  "XMM20g",
  "XMM20h",
  "XMM20i",
  "XMM20j",
  "XMM20k",
  "XMM20l",
  "XMM20m",
  "XMM20n",
  "XMM20o",
  "XMM20p",
  "XMM21",
  "XMM21b",
  "XMM21c",
  "XMM21d",
  "XMM21e",
  "XMM21f",
  "XMM21g",
  "XMM21h",
  "XMM21i",
  "XMM21j",
  "XMM21k",
  "XMM21l",
  "XMM21m",
  "XMM21n",
  "XMM21o",
  "XMM21p",
  "XMM22",
  "XMM22b",
  "XMM22c",
  "XMM22d",
  "XMM22e",
  "XMM22f",
  "XMM22g",
  "XMM22h",
  "XMM22i",
  "XMM22j",
  "XMM22k",
  "XMM22l",
  "XMM22m",
  "XMM22n",
  "XMM22o",
  "XMM22p",
  "XMM23",
  "XMM23b",
  "XMM23c",
  "XMM23d",
  "XMM23e",
  "XMM23f",
  "XMM23g",
  "XMM23h",
  "XMM23i",
  "XMM23j",
  "XMM23k",
  "XMM23l",
  "XMM23m",
  "XMM23n",
  "XMM23o",
  "XMM23p",
  "XMM24",
  "XMM24b",
  "XMM24c",
  "XMM24d",
  "XMM24e",
  "XMM24f",
  "XMM24g",
  "XMM24h",
  "XMM24i",
  "XMM24j",
  "XMM24k",
  "XMM24l",
  "XMM24m",
  "XMM24n",
  "XMM24o",
  "XMM24p",
  "XMM25",
  "XMM25b",
  "XMM25c",
  "XMM25d",
  "XMM25e",
  "XMM25f",
  "XMM25g",
  "XMM25h",
  "XMM25i",
  "XMM25j",
  "XMM25k",
  "XMM25l",
  "XMM25m",
  "XMM25n",
  "XMM25o",
  "XMM25p",
  "XMM26",
  "XMM26b",
  "XMM26c",
  "XMM26d",
  "XMM26e",
  "XMM26f",
  "XMM26g",
  "XMM26h",
  "XMM26i",
  "XMM26j",
  "XMM26k",
  "XMM26l",
  "XMM26m",
  "XMM26n",
  "XMM26o",
  "XMM26p",
  "XMM27",
  "XMM27b",
  "XMM27c",
  "XMM27d",
  "XMM27e",
  "XMM27f",
  "XMM27g",
  "XMM27h",
  "XMM27i",
  "XMM27j",
  "XMM27k",
  "XMM27l",
  "XMM27m",
  "XMM27n",
  "XMM27o",
  "XMM27p",
  "XMM28",
  "XMM28b",
  "XMM28c",
  "XMM28d",
  "XMM28e",
  "XMM28f",
  "XMM28g",
  "XMM28h",
  "XMM28i",
  "XMM28j",
  "XMM28k",
  "XMM28l",
  "XMM28m",
  "XMM28n",
  "XMM28o",
  "XMM28p",
  "XMM29",
  "XMM29b",
  "XMM29c",
  "XMM29d",
  "XMM29e",
  "XMM29f",
  "XMM29g",
  "XMM29h",
  "XMM29i",
  "XMM29j",
  "XMM29k",
  "XMM29l",
  "XMM29m",
  "XMM29n",
  "XMM29o",
  "XMM29p",
  "XMM30",
  "XMM30b",
  "XMM30c",
  "XMM30d",
  "XMM30e",
  "XMM30f",
  "XMM30g",
  "XMM30h",
  "XMM30i",
  "XMM30j",
  "XMM30k",
  "XMM30l",
  "XMM30m",
  "XMM30n",
  "XMM30o",
  "XMM30p",
  "XMM31",
  "XMM31b",
  "XMM31c",
  "XMM31d",
  "XMM31e",
  "XMM31f",
  "XMM31g",
  "XMM31h",
  "XMM31i",
  "XMM31j",
  "XMM31k",
  "XMM31l",
  "XMM31m",
  "XMM31n",
  "XMM31o",
  "XMM31p",
  "K7",
  "K7_H",
  "K6",
  "K6_H",
  "K5",
  "K5_H",
  "K4",
  "K4_H",
  "K3",
  "K3_H",
  "K2",
  "K2_H",
  "K1",
  "K1_H",
  "RFLAGS" // no trailing comma
};

// An array of character pointers to machine register names.
const VMReg OptoReg::opto2vm[REG_COUNT] = {
	r10->as_VMReg(),
	r10->as_VMReg()->next(),
	r11->as_VMReg(),
	r11->as_VMReg()->next(),
	r8->as_VMReg(),
	r8->as_VMReg()->next(),
	r9->as_VMReg(),
	r9->as_VMReg()->next(),
	r12->as_VMReg(),
	r12->as_VMReg()->next(),
	rcx->as_VMReg(),
	rcx->as_VMReg()->next(),
	rbx->as_VMReg(),
	rbx->as_VMReg()->next(),
	rdi->as_VMReg(),
	rdi->as_VMReg()->next(),
	rdx->as_VMReg(),
	rdx->as_VMReg()->next(),
	rsi->as_VMReg(),
	rsi->as_VMReg()->next(),
	rax->as_VMReg(),
	rax->as_VMReg()->next(),
	rbp->as_VMReg(),
	rbp->as_VMReg()->next(),
	r13->as_VMReg(),
	r13->as_VMReg()->next(),
	r14->as_VMReg(),
	r14->as_VMReg()->next(),
	r15->as_VMReg(),
	r15->as_VMReg()->next(),
	r16->as_VMReg(),
	r16->as_VMReg()->next(),
	r17->as_VMReg(),
	r17->as_VMReg()->next(),
	r18->as_VMReg(),
	r18->as_VMReg()->next(),
	r19->as_VMReg(),
	r19->as_VMReg()->next(),
	r20->as_VMReg(),
	r20->as_VMReg()->next(),
	r21->as_VMReg(),
	r21->as_VMReg()->next(),
	r22->as_VMReg(),
	r22->as_VMReg()->next(),
	r23->as_VMReg(),
	r23->as_VMReg()->next(),
	r24->as_VMReg(),
	r24->as_VMReg()->next(),
	r25->as_VMReg(),
	r25->as_VMReg()->next(),
	r26->as_VMReg(),
	r26->as_VMReg()->next(),
	r27->as_VMReg(),
	r27->as_VMReg()->next(),
	r28->as_VMReg(),
	r28->as_VMReg()->next(),
	r29->as_VMReg(),
	r29->as_VMReg()->next(),
	r30->as_VMReg(),
	r30->as_VMReg()->next(),
	r31->as_VMReg(),
	r31->as_VMReg()->next(),
	rsp->as_VMReg(),
	rsp->as_VMReg()->next(),
	xmm0->as_VMReg(),
	xmm0->as_VMReg()->next(1),
	xmm0->as_VMReg()->next(2),
	xmm0->as_VMReg()->next(3),
	xmm0->as_VMReg()->next(4),
	xmm0->as_VMReg()->next(5),
	xmm0->as_VMReg()->next(6),
	xmm0->as_VMReg()->next(7),
	xmm0->as_VMReg()->next(8),
	xmm0->as_VMReg()->next(9),
	xmm0->as_VMReg()->next(10),
	xmm0->as_VMReg()->next(11),
	xmm0->as_VMReg()->next(12),
	xmm0->as_VMReg()->next(13),
	xmm0->as_VMReg()->next(14),
	xmm0->as_VMReg()->next(15),
	xmm1->as_VMReg(),
	xmm1->as_VMReg()->next(1),
	xmm1->as_VMReg()->next(2),
	xmm1->as_VMReg()->next(3),
	xmm1->as_VMReg()->next(4),
	xmm1->as_VMReg()->next(5),
	xmm1->as_VMReg()->next(6),
	xmm1->as_VMReg()->next(7),
	xmm1->as_VMReg()->next(8),
	xmm1->as_VMReg()->next(9),
	xmm1->as_VMReg()->next(10),
	xmm1->as_VMReg()->next(11),
	xmm1->as_VMReg()->next(12),
	xmm1->as_VMReg()->next(13),
	xmm1->as_VMReg()->next(14),
	xmm1->as_VMReg()->next(15),
	xmm2->as_VMReg(),
	xmm2->as_VMReg()->next(1),
	xmm2->as_VMReg()->next(2),
	xmm2->as_VMReg()->next(3),
	xmm2->as_VMReg()->next(4),
	xmm2->as_VMReg()->next(5),
	xmm2->as_VMReg()->next(6),
	xmm2->as_VMReg()->next(7),
	xmm2->as_VMReg()->next(8),
	xmm2->as_VMReg()->next(9),
	xmm2->as_VMReg()->next(10),
	xmm2->as_VMReg()->next(11),
	xmm2->as_VMReg()->next(12),
	xmm2->as_VMReg()->next(13),
	xmm2->as_VMReg()->next(14),
	xmm2->as_VMReg()->next(15),
	xmm3->as_VMReg(),
	xmm3->as_VMReg()->next(1),
	xmm3->as_VMReg()->next(2),
	xmm3->as_VMReg()->next(3),
	xmm3->as_VMReg()->next(4),
	xmm3->as_VMReg()->next(5),
	xmm3->as_VMReg()->next(6),
	xmm3->as_VMReg()->next(7),
	xmm3->as_VMReg()->next(8),
	xmm3->as_VMReg()->next(9),
	xmm3->as_VMReg()->next(10),
	xmm3->as_VMReg()->next(11),
	xmm3->as_VMReg()->next(12),
	xmm3->as_VMReg()->next(13),
	xmm3->as_VMReg()->next(14),
	xmm3->as_VMReg()->next(15),
	xmm4->as_VMReg(),
	xmm4->as_VMReg()->next(1),
	xmm4->as_VMReg()->next(2),
	xmm4->as_VMReg()->next(3),
	xmm4->as_VMReg()->next(4),
	xmm4->as_VMReg()->next(5),
	xmm4->as_VMReg()->next(6),
	xmm4->as_VMReg()->next(7),
	xmm4->as_VMReg()->next(8),
	xmm4->as_VMReg()->next(9),
	xmm4->as_VMReg()->next(10),
	xmm4->as_VMReg()->next(11),
	xmm4->as_VMReg()->next(12),
	xmm4->as_VMReg()->next(13),
	xmm4->as_VMReg()->next(14),
	xmm4->as_VMReg()->next(15),
	xmm5->as_VMReg(),
	xmm5->as_VMReg()->next(1),
	xmm5->as_VMReg()->next(2),
	xmm5->as_VMReg()->next(3),
	xmm5->as_VMReg()->next(4),
	xmm5->as_VMReg()->next(5),
	xmm5->as_VMReg()->next(6),
	xmm5->as_VMReg()->next(7),
	xmm5->as_VMReg()->next(8),
	xmm5->as_VMReg()->next(9),
	xmm5->as_VMReg()->next(10),
	xmm5->as_VMReg()->next(11),
	xmm5->as_VMReg()->next(12),
	xmm5->as_VMReg()->next(13),
	xmm5->as_VMReg()->next(14),
	xmm5->as_VMReg()->next(15),
	xmm6->as_VMReg(),
	xmm6->as_VMReg()->next(1),
	xmm6->as_VMReg()->next(2),
	xmm6->as_VMReg()->next(3),
	xmm6->as_VMReg()->next(4),
	xmm6->as_VMReg()->next(5),
	xmm6->as_VMReg()->next(6),
	xmm6->as_VMReg()->next(7),
	xmm6->as_VMReg()->next(8),
	xmm6->as_VMReg()->next(9),
	xmm6->as_VMReg()->next(10),
	xmm6->as_VMReg()->next(11),
	xmm6->as_VMReg()->next(12),
	xmm6->as_VMReg()->next(13),
	xmm6->as_VMReg()->next(14),
	xmm6->as_VMReg()->next(15),
	xmm7->as_VMReg(),
	xmm7->as_VMReg()->next(1),
	xmm7->as_VMReg()->next(2),
	xmm7->as_VMReg()->next(3),
	xmm7->as_VMReg()->next(4),
	xmm7->as_VMReg()->next(5),
	xmm7->as_VMReg()->next(6),
	xmm7->as_VMReg()->next(7),
	xmm7->as_VMReg()->next(8),
	xmm7->as_VMReg()->next(9),
	xmm7->as_VMReg()->next(10),
	xmm7->as_VMReg()->next(11),
	xmm7->as_VMReg()->next(12),
	xmm7->as_VMReg()->next(13),
	xmm7->as_VMReg()->next(14),
	xmm7->as_VMReg()->next(15),
	xmm8->as_VMReg(),
	xmm8->as_VMReg()->next(1),
	xmm8->as_VMReg()->next(2),
	xmm8->as_VMReg()->next(3),
	xmm8->as_VMReg()->next(4),
	xmm8->as_VMReg()->next(5),
	xmm8->as_VMReg()->next(6),
	xmm8->as_VMReg()->next(7),
	xmm8->as_VMReg()->next(8),
	xmm8->as_VMReg()->next(9),
	xmm8->as_VMReg()->next(10),
	xmm8->as_VMReg()->next(11),
	xmm8->as_VMReg()->next(12),
	xmm8->as_VMReg()->next(13),
	xmm8->as_VMReg()->next(14),
	xmm8->as_VMReg()->next(15),
	xmm9->as_VMReg(),
	xmm9->as_VMReg()->next(1),
	xmm9->as_VMReg()->next(2),
	xmm9->as_VMReg()->next(3),
	xmm9->as_VMReg()->next(4),
	xmm9->as_VMReg()->next(5),
	xmm9->as_VMReg()->next(6),
	xmm9->as_VMReg()->next(7),
	xmm9->as_VMReg()->next(8),
	xmm9->as_VMReg()->next(9),
	xmm9->as_VMReg()->next(10),
	xmm9->as_VMReg()->next(11),
	xmm9->as_VMReg()->next(12),
	xmm9->as_VMReg()->next(13),
	xmm9->as_VMReg()->next(14),
	xmm9->as_VMReg()->next(15),
	xmm10->as_VMReg(),
	xmm10->as_VMReg()->next(1),
	xmm10->as_VMReg()->next(2),
	xmm10->as_VMReg()->next(3),
	xmm10->as_VMReg()->next(4),
	xmm10->as_VMReg()->next(5),
	xmm10->as_VMReg()->next(6),
	xmm10->as_VMReg()->next(7),
	xmm10->as_VMReg()->next(8),
	xmm10->as_VMReg()->next(9),
	xmm10->as_VMReg()->next(10),
	xmm10->as_VMReg()->next(11),
	xmm10->as_VMReg()->next(12),
	xmm10->as_VMReg()->next(13),
	xmm10->as_VMReg()->next(14),
	xmm10->as_VMReg()->next(15),
	xmm11->as_VMReg(),
	xmm11->as_VMReg()->next(1),
	xmm11->as_VMReg()->next(2),
	xmm11->as_VMReg()->next(3),
	xmm11->as_VMReg()->next(4),
	xmm11->as_VMReg()->next(5),
	xmm11->as_VMReg()->next(6),
	xmm11->as_VMReg()->next(7),
	xmm11->as_VMReg()->next(8),
	xmm11->as_VMReg()->next(9),
	xmm11->as_VMReg()->next(10),
	xmm11->as_VMReg()->next(11),
	xmm11->as_VMReg()->next(12),
	xmm11->as_VMReg()->next(13),
	xmm11->as_VMReg()->next(14),
	xmm11->as_VMReg()->next(15),
	xmm12->as_VMReg(),
	xmm12->as_VMReg()->next(1),
	xmm12->as_VMReg()->next(2),
	xmm12->as_VMReg()->next(3),
	xmm12->as_VMReg()->next(4),
	xmm12->as_VMReg()->next(5),
	xmm12->as_VMReg()->next(6),
	xmm12->as_VMReg()->next(7),
	xmm12->as_VMReg()->next(8),
	xmm12->as_VMReg()->next(9),
	xmm12->as_VMReg()->next(10),
	xmm12->as_VMReg()->next(11),
	xmm12->as_VMReg()->next(12),
	xmm12->as_VMReg()->next(13),
	xmm12->as_VMReg()->next(14),
	xmm12->as_VMReg()->next(15),
	xmm13->as_VMReg(),
	xmm13->as_VMReg()->next(1),
	xmm13->as_VMReg()->next(2),
	xmm13->as_VMReg()->next(3),
	xmm13->as_VMReg()->next(4),
	xmm13->as_VMReg()->next(5),
	xmm13->as_VMReg()->next(6),
	xmm13->as_VMReg()->next(7),
	xmm13->as_VMReg()->next(8),
	xmm13->as_VMReg()->next(9),
	xmm13->as_VMReg()->next(10),
	xmm13->as_VMReg()->next(11),
	xmm13->as_VMReg()->next(12),
	xmm13->as_VMReg()->next(13),
	xmm13->as_VMReg()->next(14),
	xmm13->as_VMReg()->next(15),
	xmm14->as_VMReg(),
	xmm14->as_VMReg()->next(1),
	xmm14->as_VMReg()->next(2),
	xmm14->as_VMReg()->next(3),
	xmm14->as_VMReg()->next(4),
	xmm14->as_VMReg()->next(5),
	xmm14->as_VMReg()->next(6),
	xmm14->as_VMReg()->next(7),
	xmm14->as_VMReg()->next(8),
	xmm14->as_VMReg()->next(9),
	xmm14->as_VMReg()->next(10),
	xmm14->as_VMReg()->next(11),
	xmm14->as_VMReg()->next(12),
	xmm14->as_VMReg()->next(13),
	xmm14->as_VMReg()->next(14),
	xmm14->as_VMReg()->next(15),
	xmm15->as_VMReg(),
	xmm15->as_VMReg()->next(1),
	xmm15->as_VMReg()->next(2),
	xmm15->as_VMReg()->next(3),
	xmm15->as_VMReg()->next(4),
	xmm15->as_VMReg()->next(5),
	xmm15->as_VMReg()->next(6),
	xmm15->as_VMReg()->next(7),
	xmm15->as_VMReg()->next(8),
	xmm15->as_VMReg()->next(9),
	xmm15->as_VMReg()->next(10),
	xmm15->as_VMReg()->next(11),
	xmm15->as_VMReg()->next(12),
	xmm15->as_VMReg()->next(13),
	xmm15->as_VMReg()->next(14),
	xmm15->as_VMReg()->next(15),
	xmm16->as_VMReg(),
	xmm16->as_VMReg()->next(1),
	xmm16->as_VMReg()->next(2),
	xmm16->as_VMReg()->next(3),
	xmm16->as_VMReg()->next(4),
	xmm16->as_VMReg()->next(5),
	xmm16->as_VMReg()->next(6),
	xmm16->as_VMReg()->next(7),
	xmm16->as_VMReg()->next(8),
	xmm16->as_VMReg()->next(9),
	xmm16->as_VMReg()->next(10),
	xmm16->as_VMReg()->next(11),
	xmm16->as_VMReg()->next(12),
	xmm16->as_VMReg()->next(13),
	xmm16->as_VMReg()->next(14),
	xmm16->as_VMReg()->next(15),
	xmm17->as_VMReg(),
	xmm17->as_VMReg()->next(1),
	xmm17->as_VMReg()->next(2),
	xmm17->as_VMReg()->next(3),
	xmm17->as_VMReg()->next(4),
	xmm17->as_VMReg()->next(5),
	xmm17->as_VMReg()->next(6),
	xmm17->as_VMReg()->next(7),
	xmm17->as_VMReg()->next(8),
	xmm17->as_VMReg()->next(9),
	xmm17->as_VMReg()->next(10),
	xmm17->as_VMReg()->next(11),
	xmm17->as_VMReg()->next(12),
	xmm17->as_VMReg()->next(13),
	xmm17->as_VMReg()->next(14),
	xmm17->as_VMReg()->next(15),
	xmm18->as_VMReg(),
	xmm18->as_VMReg()->next(1),
	xmm18->as_VMReg()->next(2),
	xmm18->as_VMReg()->next(3),
	xmm18->as_VMReg()->next(4),
	xmm18->as_VMReg()->next(5),
	xmm18->as_VMReg()->next(6),
	xmm18->as_VMReg()->next(7),
	xmm18->as_VMReg()->next(8),
	xmm18->as_VMReg()->next(9),
	xmm18->as_VMReg()->next(10),
	xmm18->as_VMReg()->next(11),
	xmm18->as_VMReg()->next(12),
	xmm18->as_VMReg()->next(13),
	xmm18->as_VMReg()->next(14),
	xmm18->as_VMReg()->next(15),
	xmm19->as_VMReg(),
	xmm19->as_VMReg()->next(1),
	xmm19->as_VMReg()->next(2),
	xmm19->as_VMReg()->next(3),
	xmm19->as_VMReg()->next(4),
	xmm19->as_VMReg()->next(5),
	xmm19->as_VMReg()->next(6),
	xmm19->as_VMReg()->next(7),
	xmm19->as_VMReg()->next(8),
	xmm19->as_VMReg()->next(9),
	xmm19->as_VMReg()->next(10),
	xmm19->as_VMReg()->next(11),
	xmm19->as_VMReg()->next(12),
	xmm19->as_VMReg()->next(13),
	xmm19->as_VMReg()->next(14),
	xmm19->as_VMReg()->next(15),
	xmm20->as_VMReg(),
	xmm20->as_VMReg()->next(1),
	xmm20->as_VMReg()->next(2),
	xmm20->as_VMReg()->next(3),
	xmm20->as_VMReg()->next(4),
	xmm20->as_VMReg()->next(5),
	xmm20->as_VMReg()->next(6),
	xmm20->as_VMReg()->next(7),
	xmm20->as_VMReg()->next(8),
	xmm20->as_VMReg()->next(9),
	xmm20->as_VMReg()->next(10),
	xmm20->as_VMReg()->next(11),
	xmm20->as_VMReg()->next(12),
	xmm20->as_VMReg()->next(13),
	xmm20->as_VMReg()->next(14),
	xmm20->as_VMReg()->next(15),
	xmm21->as_VMReg(),
	xmm21->as_VMReg()->next(1),
	xmm21->as_VMReg()->next(2),
	xmm21->as_VMReg()->next(3),
	xmm21->as_VMReg()->next(4),
	xmm21->as_VMReg()->next(5),
	xmm21->as_VMReg()->next(6),
	xmm21->as_VMReg()->next(7),
	xmm21->as_VMReg()->next(8),
	xmm21->as_VMReg()->next(9),
	xmm21->as_VMReg()->next(10),
	xmm21->as_VMReg()->next(11),
	xmm21->as_VMReg()->next(12),
	xmm21->as_VMReg()->next(13),
	xmm21->as_VMReg()->next(14),
	xmm21->as_VMReg()->next(15),
	xmm22->as_VMReg(),
	xmm22->as_VMReg()->next(1),
	xmm22->as_VMReg()->next(2),
	xmm22->as_VMReg()->next(3),
	xmm22->as_VMReg()->next(4),
	xmm22->as_VMReg()->next(5),
	xmm22->as_VMReg()->next(6),
	xmm22->as_VMReg()->next(7),
	xmm22->as_VMReg()->next(8),
	xmm22->as_VMReg()->next(9),
	xmm22->as_VMReg()->next(10),
	xmm22->as_VMReg()->next(11),
	xmm22->as_VMReg()->next(12),
	xmm22->as_VMReg()->next(13),
	xmm22->as_VMReg()->next(14),
	xmm22->as_VMReg()->next(15),
	xmm23->as_VMReg(),
	xmm23->as_VMReg()->next(1),
	xmm23->as_VMReg()->next(2),
	xmm23->as_VMReg()->next(3),
	xmm23->as_VMReg()->next(4),
	xmm23->as_VMReg()->next(5),
	xmm23->as_VMReg()->next(6),
	xmm23->as_VMReg()->next(7),
	xmm23->as_VMReg()->next(8),
	xmm23->as_VMReg()->next(9),
	xmm23->as_VMReg()->next(10),
	xmm23->as_VMReg()->next(11),
	xmm23->as_VMReg()->next(12),
	xmm23->as_VMReg()->next(13),
	xmm23->as_VMReg()->next(14),
	xmm23->as_VMReg()->next(15),
	xmm24->as_VMReg(),
	xmm24->as_VMReg()->next(1),
	xmm24->as_VMReg()->next(2),
	xmm24->as_VMReg()->next(3),
	xmm24->as_VMReg()->next(4),
	xmm24->as_VMReg()->next(5),
	xmm24->as_VMReg()->next(6),
	xmm24->as_VMReg()->next(7),
	xmm24->as_VMReg()->next(8),
	xmm24->as_VMReg()->next(9),
	xmm24->as_VMReg()->next(10),
	xmm24->as_VMReg()->next(11),
	xmm24->as_VMReg()->next(12),
	xmm24->as_VMReg()->next(13),
	xmm24->as_VMReg()->next(14),
	xmm24->as_VMReg()->next(15),
	xmm25->as_VMReg(),
	xmm25->as_VMReg()->next(1),
	xmm25->as_VMReg()->next(2),
	xmm25->as_VMReg()->next(3),
	xmm25->as_VMReg()->next(4),
	xmm25->as_VMReg()->next(5),
	xmm25->as_VMReg()->next(6),
	xmm25->as_VMReg()->next(7),
	xmm25->as_VMReg()->next(8),
	xmm25->as_VMReg()->next(9),
	xmm25->as_VMReg()->next(10),
	xmm25->as_VMReg()->next(11),
	xmm25->as_VMReg()->next(12),
	xmm25->as_VMReg()->next(13),
	xmm25->as_VMReg()->next(14),
	xmm25->as_VMReg()->next(15),
	xmm26->as_VMReg(),
	xmm26->as_VMReg()->next(1),
	xmm26->as_VMReg()->next(2),
	xmm26->as_VMReg()->next(3),
	xmm26->as_VMReg()->next(4),
	xmm26->as_VMReg()->next(5),
	xmm26->as_VMReg()->next(6),
	xmm26->as_VMReg()->next(7),
	xmm26->as_VMReg()->next(8),
	xmm26->as_VMReg()->next(9),
	xmm26->as_VMReg()->next(10),
	xmm26->as_VMReg()->next(11),
	xmm26->as_VMReg()->next(12),
	xmm26->as_VMReg()->next(13),
	xmm26->as_VMReg()->next(14),
	xmm26->as_VMReg()->next(15),
	xmm27->as_VMReg(),
	xmm27->as_VMReg()->next(1),
	xmm27->as_VMReg()->next(2),
	xmm27->as_VMReg()->next(3),
	xmm27->as_VMReg()->next(4),
	xmm27->as_VMReg()->next(5),
	xmm27->as_VMReg()->next(6),
	xmm27->as_VMReg()->next(7),
	xmm27->as_VMReg()->next(8),
	xmm27->as_VMReg()->next(9),
	xmm27->as_VMReg()->next(10),
	xmm27->as_VMReg()->next(11),
	xmm27->as_VMReg()->next(12),
	xmm27->as_VMReg()->next(13),
	xmm27->as_VMReg()->next(14),
	xmm27->as_VMReg()->next(15),
	xmm28->as_VMReg(),
	xmm28->as_VMReg()->next(1),
	xmm28->as_VMReg()->next(2),
	xmm28->as_VMReg()->next(3),
	xmm28->as_VMReg()->next(4),
	xmm28->as_VMReg()->next(5),
	xmm28->as_VMReg()->next(6),
	xmm28->as_VMReg()->next(7),
	xmm28->as_VMReg()->next(8),
	xmm28->as_VMReg()->next(9),
	xmm28->as_VMReg()->next(10),
	xmm28->as_VMReg()->next(11),
	xmm28->as_VMReg()->next(12),
	xmm28->as_VMReg()->next(13),
	xmm28->as_VMReg()->next(14),
	xmm28->as_VMReg()->next(15),
	xmm29->as_VMReg(),
	xmm29->as_VMReg()->next(1),
	xmm29->as_VMReg()->next(2),
	xmm29->as_VMReg()->next(3),
	xmm29->as_VMReg()->next(4),
	xmm29->as_VMReg()->next(5),
	xmm29->as_VMReg()->next(6),
	xmm29->as_VMReg()->next(7),
	xmm29->as_VMReg()->next(8),
	xmm29->as_VMReg()->next(9),
	xmm29->as_VMReg()->next(10),
	xmm29->as_VMReg()->next(11),
	xmm29->as_VMReg()->next(12),
	xmm29->as_VMReg()->next(13),
	xmm29->as_VMReg()->next(14),
	xmm29->as_VMReg()->next(15),
	xmm30->as_VMReg(),
	xmm30->as_VMReg()->next(1),
	xmm30->as_VMReg()->next(2),
	xmm30->as_VMReg()->next(3),
	xmm30->as_VMReg()->next(4),
	xmm30->as_VMReg()->next(5),
	xmm30->as_VMReg()->next(6),
	xmm30->as_VMReg()->next(7),
	xmm30->as_VMReg()->next(8),
	xmm30->as_VMReg()->next(9),
	xmm30->as_VMReg()->next(10),
	xmm30->as_VMReg()->next(11),
	xmm30->as_VMReg()->next(12),
	xmm30->as_VMReg()->next(13),
	xmm30->as_VMReg()->next(14),
	xmm30->as_VMReg()->next(15),
	xmm31->as_VMReg(),
	xmm31->as_VMReg()->next(1),
	xmm31->as_VMReg()->next(2),
	xmm31->as_VMReg()->next(3),
	xmm31->as_VMReg()->next(4),
	xmm31->as_VMReg()->next(5),
	xmm31->as_VMReg()->next(6),
	xmm31->as_VMReg()->next(7),
	xmm31->as_VMReg()->next(8),
	xmm31->as_VMReg()->next(9),
	xmm31->as_VMReg()->next(10),
	xmm31->as_VMReg()->next(11),
	xmm31->as_VMReg()->next(12),
	xmm31->as_VMReg()->next(13),
	xmm31->as_VMReg()->next(14),
	xmm31->as_VMReg()->next(15),
	k7->as_VMReg(),
	k7->as_VMReg()->next(),
	k6->as_VMReg(),
	k6->as_VMReg()->next(),
	k5->as_VMReg(),
	k5->as_VMReg()->next(),
	k4->as_VMReg(),
	k4->as_VMReg()->next(),
	k3->as_VMReg(),
	k3->as_VMReg()->next(),
	k2->as_VMReg(),
	k2->as_VMReg()->next(),
	k1->as_VMReg(),
	k1->as_VMReg()->next(),
	VMRegImpl::Bad() // no trailing comma
	};

 OptoReg::Name OptoReg::vm2opto[ConcreteRegisterImpl::number_of_registers];

// An array of the machine register encode values
const unsigned char Matcher::_regEncode[REG_COUNT] = {
  (unsigned char)'\xA',  // R10
  (unsigned char)'\xA',  // R10_H
  (unsigned char)'\xB',  // R11
  (unsigned char)'\xB',  // R11_H
  (unsigned char)'\x8',  // R8
  (unsigned char)'\x8',  // R8_H
  (unsigned char)'\x9',  // R9
  (unsigned char)'\x9',  // R9_H
  (unsigned char)'\xC',  // R12
  (unsigned char)'\xC',  // R12_H
  (unsigned char)'\x1',  // RCX
  (unsigned char)'\x1',  // RCX_H
  (unsigned char)'\x3',  // RBX
  (unsigned char)'\x3',  // RBX_H
  (unsigned char)'\x7',  // RDI
  (unsigned char)'\x7',  // RDI_H
  (unsigned char)'\x2',  // RDX
  (unsigned char)'\x2',  // RDX_H
  (unsigned char)'\x6',  // RSI
  (unsigned char)'\x6',  // RSI_H
  (unsigned char)'\x0',  // RAX
  (unsigned char)'\x0',  // RAX_H
  (unsigned char)'\x5',  // RBP
  (unsigned char)'\x5',  // RBP_H
  (unsigned char)'\xD',  // R13
  (unsigned char)'\xD',  // R13_H
  (unsigned char)'\xE',  // R14
  (unsigned char)'\xE',  // R14_H
  (unsigned char)'\xF',  // R15
  (unsigned char)'\xF',  // R15_H
  (unsigned char)'\x10',  // R16
  (unsigned char)'\x10',  // R16_H
  (unsigned char)'\x11',  // R17
  (unsigned char)'\x11',  // R17_H
  (unsigned char)'\x12',  // R18
  (unsigned char)'\x12',  // R18_H
  (unsigned char)'\x13',  // R19
  (unsigned char)'\x13',  // R19_H
  (unsigned char)'\x14',  // R20
  (unsigned char)'\x14',  // R20_H
  (unsigned char)'\x15',  // R21
  (unsigned char)'\x15',  // R21_H
  (unsigned char)'\x16',  // R22
  (unsigned char)'\x16',  // R22_H
  (unsigned char)'\x17',  // R23
  (unsigned char)'\x17',  // R23_H
  (unsigned char)'\x18',  // R24
  (unsigned char)'\x18',  // R24_H
  (unsigned char)'\x19',  // R25
  (unsigned char)'\x19',  // R25_H
  (unsigned char)'\x1A',  // R26
  (unsigned char)'\x1A',  // R26_H
  (unsigned char)'\x1B',  // R27
  (unsigned char)'\x1B',  // R27_H
  (unsigned char)'\x1C',  // R28
  (unsigned char)'\x1C',  // R28_H
  (unsigned char)'\x1D',  // R29
  (unsigned char)'\x1D',  // R29_H
  (unsigned char)'\x1E',  // R30
  (unsigned char)'\x1E',  // R30_H
  (unsigned char)'\x1F',  // R31
  (unsigned char)'\x1F',  // R31_H
  (unsigned char)'\x4',  // RSP
  (unsigned char)'\x4',  // RSP_H
  (unsigned char)'\x0',  // XMM0
  (unsigned char)'\x0',  // XMM0b
  (unsigned char)'\x0',  // XMM0c
  (unsigned char)'\x0',  // XMM0d
  (unsigned char)'\x0',  // XMM0e
  (unsigned char)'\x0',  // XMM0f
  (unsigned char)'\x0',  // XMM0g
  (unsigned char)'\x0',  // XMM0h
  (unsigned char)'\x0',  // XMM0i
  (unsigned char)'\x0',  // XMM0j
  (unsigned char)'\x0',  // XMM0k
  (unsigned char)'\x0',  // XMM0l
  (unsigned char)'\x0',  // XMM0m
  (unsigned char)'\x0',  // XMM0n
  (unsigned char)'\x0',  // XMM0o
  (unsigned char)'\x0',  // XMM0p
  (unsigned char)'\x1',  // XMM1
  (unsigned char)'\x1',  // XMM1b
  (unsigned char)'\x1',  // XMM1c
  (unsigned char)'\x1',  // XMM1d
  (unsigned char)'\x1',  // XMM1e
  (unsigned char)'\x1',  // XMM1f
  (unsigned char)'\x1',  // XMM1g
  (unsigned char)'\x1',  // XMM1h
  (unsigned char)'\x1',  // XMM1i
  (unsigned char)'\x1',  // XMM1j
  (unsigned char)'\x1',  // XMM1k
  (unsigned char)'\x1',  // XMM1l
  (unsigned char)'\x1',  // XMM1m
  (unsigned char)'\x1',  // XMM1n
  (unsigned char)'\x1',  // XMM1o
  (unsigned char)'\x1',  // XMM1p
  (unsigned char)'\x2',  // XMM2
  (unsigned char)'\x2',  // XMM2b
  (unsigned char)'\x2',  // XMM2c
  (unsigned char)'\x2',  // XMM2d
  (unsigned char)'\x2',  // XMM2e
  (unsigned char)'\x2',  // XMM2f
  (unsigned char)'\x2',  // XMM2g
  (unsigned char)'\x2',  // XMM2h
  (unsigned char)'\x2',  // XMM2i
  (unsigned char)'\x2',  // XMM2j
  (unsigned char)'\x2',  // XMM2k
  (unsigned char)'\x2',  // XMM2l
  (unsigned char)'\x2',  // XMM2m
  (unsigned char)'\x2',  // XMM2n
  (unsigned char)'\x2',  // XMM2o
  (unsigned char)'\x2',  // XMM2p
  (unsigned char)'\x3',  // XMM3
  (unsigned char)'\x3',  // XMM3b
  (unsigned char)'\x3',  // XMM3c
  (unsigned char)'\x3',  // XMM3d
  (unsigned char)'\x3',  // XMM3e
  (unsigned char)'\x3',  // XMM3f
  (unsigned char)'\x3',  // XMM3g
  (unsigned char)'\x3',  // XMM3h
  (unsigned char)'\x3',  // XMM3i
  (unsigned char)'\x3',  // XMM3j
  (unsigned char)'\x3',  // XMM3k
  (unsigned char)'\x3',  // XMM3l
  (unsigned char)'\x3',  // XMM3m
  (unsigned char)'\x3',  // XMM3n
  (unsigned char)'\x3',  // XMM3o
  (unsigned char)'\x3',  // XMM3p
  (unsigned char)'\x4',  // XMM4
  (unsigned char)'\x4',  // XMM4b
  (unsigned char)'\x4',  // XMM4c
  (unsigned char)'\x4',  // XMM4d
  (unsigned char)'\x4',  // XMM4e
  (unsigned char)'\x4',  // XMM4f
  (unsigned char)'\x4',  // XMM4g
  (unsigned char)'\x4',  // XMM4h
  (unsigned char)'\x4',  // XMM4i
  (unsigned char)'\x4',  // XMM4j
  (unsigned char)'\x4',  // XMM4k
  (unsigned char)'\x4',  // XMM4l
  (unsigned char)'\x4',  // XMM4m
  (unsigned char)'\x4',  // XMM4n
  (unsigned char)'\x4',  // XMM4o
  (unsigned char)'\x4',  // XMM4p
  (unsigned char)'\x5',  // XMM5
  (unsigned char)'\x5',  // XMM5b
  (unsigned char)'\x5',  // XMM5c
  (unsigned char)'\x5',  // XMM5d
  (unsigned char)'\x5',  // XMM5e
  (unsigned char)'\x5',  // XMM5f
  (unsigned char)'\x5',  // XMM5g
  (unsigned char)'\x5',  // XMM5h
  (unsigned char)'\x5',  // XMM5i
  (unsigned char)'\x5',  // XMM5j
  (unsigned char)'\x5',  // XMM5k
  (unsigned char)'\x5',  // XMM5l
  (unsigned char)'\x5',  // XMM5m
  (unsigned char)'\x5',  // XMM5n
  (unsigned char)'\x5',  // XMM5o
  (unsigned char)'\x5',  // XMM5p
  (unsigned char)'\x6',  // XMM6
  (unsigned char)'\x6',  // XMM6b
  (unsigned char)'\x6',  // XMM6c
  (unsigned char)'\x6',  // XMM6d
  (unsigned char)'\x6',  // XMM6e
  (unsigned char)'\x6',  // XMM6f
  (unsigned char)'\x6',  // XMM6g
  (unsigned char)'\x6',  // XMM6h
  (unsigned char)'\x6',  // XMM6i
  (unsigned char)'\x6',  // XMM6j
  (unsigned char)'\x6',  // XMM6k
  (unsigned char)'\x6',  // XMM6l
  (unsigned char)'\x6',  // XMM6m
  (unsigned char)'\x6',  // XMM6n
  (unsigned char)'\x6',  // XMM6o
  (unsigned char)'\x6',  // XMM6p
  (unsigned char)'\x7',  // XMM7
  (unsigned char)'\x7',  // XMM7b
  (unsigned char)'\x7',  // XMM7c
  (unsigned char)'\x7',  // XMM7d
  (unsigned char)'\x7',  // XMM7e
  (unsigned char)'\x7',  // XMM7f
  (unsigned char)'\x7',  // XMM7g
  (unsigned char)'\x7',  // XMM7h
  (unsigned char)'\x7',  // XMM7i
  (unsigned char)'\x7',  // XMM7j
  (unsigned char)'\x7',  // XMM7k
  (unsigned char)'\x7',  // XMM7l
  (unsigned char)'\x7',  // XMM7m
  (unsigned char)'\x7',  // XMM7n
  (unsigned char)'\x7',  // XMM7o
  (unsigned char)'\x7',  // XMM7p
  (unsigned char)'\x8',  // XMM8
  (unsigned char)'\x8',  // XMM8b
  (unsigned char)'\x8',  // XMM8c
  (unsigned char)'\x8',  // XMM8d
  (unsigned char)'\x8',  // XMM8e
  (unsigned char)'\x8',  // XMM8f
  (unsigned char)'\x8',  // XMM8g
  (unsigned char)'\x8',  // XMM8h
  (unsigned char)'\x8',  // XMM8i
  (unsigned char)'\x8',  // XMM8j
  (unsigned char)'\x8',  // XMM8k
  (unsigned char)'\x8',  // XMM8l
  (unsigned char)'\x8',  // XMM8m
  (unsigned char)'\x8',  // XMM8n
  (unsigned char)'\x8',  // XMM8o
  (unsigned char)'\x8',  // XMM8p
  (unsigned char)'\x9',  // XMM9
  (unsigned char)'\x9',  // XMM9b
  (unsigned char)'\x9',  // XMM9c
  (unsigned char)'\x9',  // XMM9d
  (unsigned char)'\x9',  // XMM9e
  (unsigned char)'\x9',  // XMM9f
  (unsigned char)'\x9',  // XMM9g
  (unsigned char)'\x9',  // XMM9h
  (unsigned char)'\x9',  // XMM9i
  (unsigned char)'\x9',  // XMM9j
  (unsigned char)'\x9',  // XMM9k
  (unsigned char)'\x9',  // XMM9l
  (unsigned char)'\x9',  // XMM9m
  (unsigned char)'\x9',  // XMM9n
  (unsigned char)'\x9',  // XMM9o
  (unsigned char)'\x9',  // XMM9p
  (unsigned char)'\xA',  // XMM10
  (unsigned char)'\xA',  // XMM10b
  (unsigned char)'\xA',  // XMM10c
  (unsigned char)'\xA',  // XMM10d
  (unsigned char)'\xA',  // XMM10e
  (unsigned char)'\xA',  // XMM10f
  (unsigned char)'\xA',  // XMM10g
  (unsigned char)'\xA',  // XMM10h
  (unsigned char)'\xA',  // XMM10i
  (unsigned char)'\xA',  // XMM10j
  (unsigned char)'\xA',  // XMM10k
  (unsigned char)'\xA',  // XMM10l
  (unsigned char)'\xA',  // XMM10m
  (unsigned char)'\xA',  // XMM10n
  (unsigned char)'\xA',  // XMM10o
  (unsigned char)'\xA',  // XMM10p
  (unsigned char)'\xB',  // XMM11
  (unsigned char)'\xB',  // XMM11b
  (unsigned char)'\xB',  // XMM11c
  (unsigned char)'\xB',  // XMM11d
  (unsigned char)'\xB',  // XMM11e
  (unsigned char)'\xB',  // XMM11f
  (unsigned char)'\xB',  // XMM11g
  (unsigned char)'\xB',  // XMM11h
  (unsigned char)'\xB',  // XMM11i
  (unsigned char)'\xB',  // XMM11j
  (unsigned char)'\xB',  // XMM11k
  (unsigned char)'\xB',  // XMM11l
  (unsigned char)'\xB',  // XMM11m
  (unsigned char)'\xB',  // XMM11n
  (unsigned char)'\xB',  // XMM11o
  (unsigned char)'\xB',  // XMM11p
  (unsigned char)'\xC',  // XMM12
  (unsigned char)'\xC',  // XMM12b
  (unsigned char)'\xC',  // XMM12c
  (unsigned char)'\xC',  // XMM12d
  (unsigned char)'\xC',  // XMM12e
  (unsigned char)'\xC',  // XMM12f
  (unsigned char)'\xC',  // XMM12g
  (unsigned char)'\xC',  // XMM12h
  (unsigned char)'\xC',  // XMM12i
  (unsigned char)'\xC',  // XMM12j
  (unsigned char)'\xC',  // XMM12k
  (unsigned char)'\xC',  // XMM12l
  (unsigned char)'\xC',  // XMM12m
  (unsigned char)'\xC',  // XMM12n
  (unsigned char)'\xC',  // XMM12o
  (unsigned char)'\xC',  // XMM12p
  (unsigned char)'\xD',  // XMM13
  (unsigned char)'\xD',  // XMM13b
  (unsigned char)'\xD',  // XMM13c
  (unsigned char)'\xD',  // XMM13d
  (unsigned char)'\xD',  // XMM13e
  (unsigned char)'\xD',  // XMM13f
  (unsigned char)'\xD',  // XMM13g
  (unsigned char)'\xD',  // XMM13h
  (unsigned char)'\xD',  // XMM13i
  (unsigned char)'\xD',  // XMM13j
  (unsigned char)'\xD',  // XMM13k
  (unsigned char)'\xD',  // XMM13l
  (unsigned char)'\xD',  // XMM13m
  (unsigned char)'\xD',  // XMM13n
  (unsigned char)'\xD',  // XMM13o
  (unsigned char)'\xD',  // XMM13p
  (unsigned char)'\xE',  // XMM14
  (unsigned char)'\xE',  // XMM14b
  (unsigned char)'\xE',  // XMM14c
  (unsigned char)'\xE',  // XMM14d
  (unsigned char)'\xE',  // XMM14e
  (unsigned char)'\xE',  // XMM14f
  (unsigned char)'\xE',  // XMM14g
  (unsigned char)'\xE',  // XMM14h
  (unsigned char)'\xE',  // XMM14i
  (unsigned char)'\xE',  // XMM14j
  (unsigned char)'\xE',  // XMM14k
  (unsigned char)'\xE',  // XMM14l
  (unsigned char)'\xE',  // XMM14m
  (unsigned char)'\xE',  // XMM14n
  (unsigned char)'\xE',  // XMM14o
  (unsigned char)'\xE',  // XMM14p
  (unsigned char)'\xF',  // XMM15
  (unsigned char)'\xF',  // XMM15b
  (unsigned char)'\xF',  // XMM15c
  (unsigned char)'\xF',  // XMM15d
  (unsigned char)'\xF',  // XMM15e
  (unsigned char)'\xF',  // XMM15f
  (unsigned char)'\xF',  // XMM15g
  (unsigned char)'\xF',  // XMM15h
  (unsigned char)'\xF',  // XMM15i
  (unsigned char)'\xF',  // XMM15j
  (unsigned char)'\xF',  // XMM15k
  (unsigned char)'\xF',  // XMM15l
  (unsigned char)'\xF',  // XMM15m
  (unsigned char)'\xF',  // XMM15n
  (unsigned char)'\xF',  // XMM15o
  (unsigned char)'\xF',  // XMM15p
  (unsigned char)'\x10',  // XMM16
  (unsigned char)'\x10',  // XMM16b
  (unsigned char)'\x10',  // XMM16c
  (unsigned char)'\x10',  // XMM16d
  (unsigned char)'\x10',  // XMM16e
  (unsigned char)'\x10',  // XMM16f
  (unsigned char)'\x10',  // XMM16g
  (unsigned char)'\x10',  // XMM16h
  (unsigned char)'\x10',  // XMM16i
  (unsigned char)'\x10',  // XMM16j
  (unsigned char)'\x10',  // XMM16k
  (unsigned char)'\x10',  // XMM16l
  (unsigned char)'\x10',  // XMM16m
  (unsigned char)'\x10',  // XMM16n
  (unsigned char)'\x10',  // XMM16o
  (unsigned char)'\x10',  // XMM16p
  (unsigned char)'\x11',  // XMM17
  (unsigned char)'\x11',  // XMM17b
  (unsigned char)'\x11',  // XMM17c
  (unsigned char)'\x11',  // XMM17d
  (unsigned char)'\x11',  // XMM17e
  (unsigned char)'\x11',  // XMM17f
  (unsigned char)'\x11',  // XMM17g
  (unsigned char)'\x11',  // XMM17h
  (unsigned char)'\x11',  // XMM17i
  (unsigned char)'\x11',  // XMM17j
  (unsigned char)'\x11',  // XMM17k
  (unsigned char)'\x11',  // XMM17l
  (unsigned char)'\x11',  // XMM17m
  (unsigned char)'\x11',  // XMM17n
  (unsigned char)'\x11',  // XMM17o
  (unsigned char)'\x11',  // XMM17p
  (unsigned char)'\x12',  // XMM18
  (unsigned char)'\x12',  // XMM18b
  (unsigned char)'\x12',  // XMM18c
  (unsigned char)'\x12',  // XMM18d
  (unsigned char)'\x12',  // XMM18e
  (unsigned char)'\x12',  // XMM18f
  (unsigned char)'\x12',  // XMM18g
  (unsigned char)'\x12',  // XMM18h
  (unsigned char)'\x12',  // XMM18i
  (unsigned char)'\x12',  // XMM18j
  (unsigned char)'\x12',  // XMM18k
  (unsigned char)'\x12',  // XMM18l
  (unsigned char)'\x12',  // XMM18m
  (unsigned char)'\x12',  // XMM18n
  (unsigned char)'\x12',  // XMM18o
  (unsigned char)'\x12',  // XMM18p
  (unsigned char)'\x13',  // XMM19
  (unsigned char)'\x13',  // XMM19b
  (unsigned char)'\x13',  // XMM19c
  (unsigned char)'\x13',  // XMM19d
  (unsigned char)'\x13',  // XMM19e
  (unsigned char)'\x13',  // XMM19f
  (unsigned char)'\x13',  // XMM19g
  (unsigned char)'\x13',  // XMM19h
  (unsigned char)'\x13',  // XMM19i
  (unsigned char)'\x13',  // XMM19j
  (unsigned char)'\x13',  // XMM19k
  (unsigned char)'\x13',  // XMM19l
  (unsigned char)'\x13',  // XMM19m
  (unsigned char)'\x13',  // XMM19n
  (unsigned char)'\x13',  // XMM19o
  (unsigned char)'\x13',  // XMM19p
  (unsigned char)'\x14',  // XMM20
  (unsigned char)'\x14',  // XMM20b
  (unsigned char)'\x14',  // XMM20c
  (unsigned char)'\x14',  // XMM20d
  (unsigned char)'\x14',  // XMM20e
  (unsigned char)'\x14',  // XMM20f
  (unsigned char)'\x14',  // XMM20g
  (unsigned char)'\x14',  // XMM20h
  (unsigned char)'\x14',  // XMM20i
  (unsigned char)'\x14',  // XMM20j
  (unsigned char)'\x14',  // XMM20k
  (unsigned char)'\x14',  // XMM20l
  (unsigned char)'\x14',  // XMM20m
  (unsigned char)'\x14',  // XMM20n
  (unsigned char)'\x14',  // XMM20o
  (unsigned char)'\x14',  // XMM20p
  (unsigned char)'\x15',  // XMM21
  (unsigned char)'\x15',  // XMM21b
  (unsigned char)'\x15',  // XMM21c
  (unsigned char)'\x15',  // XMM21d
  (unsigned char)'\x15',  // XMM21e
  (unsigned char)'\x15',  // XMM21f
  (unsigned char)'\x15',  // XMM21g
  (unsigned char)'\x15',  // XMM21h
  (unsigned char)'\x15',  // XMM21i
  (unsigned char)'\x15',  // XMM21j
  (unsigned char)'\x15',  // XMM21k
  (unsigned char)'\x15',  // XMM21l
  (unsigned char)'\x15',  // XMM21m
  (unsigned char)'\x15',  // XMM21n
  (unsigned char)'\x15',  // XMM21o
  (unsigned char)'\x15',  // XMM21p
  (unsigned char)'\x16',  // XMM22
  (unsigned char)'\x16',  // XMM22b
  (unsigned char)'\x16',  // XMM22c
  (unsigned char)'\x16',  // XMM22d
  (unsigned char)'\x16',  // XMM22e
  (unsigned char)'\x16',  // XMM22f
  (unsigned char)'\x16',  // XMM22g
  (unsigned char)'\x16',  // XMM22h
  (unsigned char)'\x16',  // XMM22i
  (unsigned char)'\x16',  // XMM22j
  (unsigned char)'\x16',  // XMM22k
  (unsigned char)'\x16',  // XMM22l
  (unsigned char)'\x16',  // XMM22m
  (unsigned char)'\x16',  // XMM22n
  (unsigned char)'\x16',  // XMM22o
  (unsigned char)'\x16',  // XMM22p
  (unsigned char)'\x17',  // XMM23
  (unsigned char)'\x17',  // XMM23b
  (unsigned char)'\x17',  // XMM23c
  (unsigned char)'\x17',  // XMM23d
  (unsigned char)'\x17',  // XMM23e
  (unsigned char)'\x17',  // XMM23f
  (unsigned char)'\x17',  // XMM23g
  (unsigned char)'\x17',  // XMM23h
  (unsigned char)'\x17',  // XMM23i
  (unsigned char)'\x17',  // XMM23j
  (unsigned char)'\x17',  // XMM23k
  (unsigned char)'\x17',  // XMM23l
  (unsigned char)'\x17',  // XMM23m
  (unsigned char)'\x17',  // XMM23n
  (unsigned char)'\x17',  // XMM23o
  (unsigned char)'\x17',  // XMM23p
  (unsigned char)'\x18',  // XMM24
  (unsigned char)'\x18',  // XMM24b
  (unsigned char)'\x18',  // XMM24c
  (unsigned char)'\x18',  // XMM24d
  (unsigned char)'\x18',  // XMM24e
  (unsigned char)'\x18',  // XMM24f
  (unsigned char)'\x18',  // XMM24g
  (unsigned char)'\x18',  // XMM24h
  (unsigned char)'\x18',  // XMM24i
  (unsigned char)'\x18',  // XMM24j
  (unsigned char)'\x18',  // XMM24k
  (unsigned char)'\x18',  // XMM24l
  (unsigned char)'\x18',  // XMM24m
  (unsigned char)'\x18',  // XMM24n
  (unsigned char)'\x18',  // XMM24o
  (unsigned char)'\x18',  // XMM24p
  (unsigned char)'\x19',  // XMM25
  (unsigned char)'\x19',  // XMM25b
  (unsigned char)'\x19',  // XMM25c
  (unsigned char)'\x19',  // XMM25d
  (unsigned char)'\x19',  // XMM25e
  (unsigned char)'\x19',  // XMM25f
  (unsigned char)'\x19',  // XMM25g
  (unsigned char)'\x19',  // XMM25h
  (unsigned char)'\x19',  // XMM25i
  (unsigned char)'\x19',  // XMM25j
  (unsigned char)'\x19',  // XMM25k
  (unsigned char)'\x19',  // XMM25l
  (unsigned char)'\x19',  // XMM25m
  (unsigned char)'\x19',  // XMM25n
  (unsigned char)'\x19',  // XMM25o
  (unsigned char)'\x19',  // XMM25p
  (unsigned char)'\x1A',  // XMM26
  (unsigned char)'\x1A',  // XMM26b
  (unsigned char)'\x1A',  // XMM26c
  (unsigned char)'\x1A',  // XMM26d
  (unsigned char)'\x1A',  // XMM26e
  (unsigned char)'\x1A',  // XMM26f
  (unsigned char)'\x1A',  // XMM26g
  (unsigned char)'\x1A',  // XMM26h
  (unsigned char)'\x1A',  // XMM26i
  (unsigned char)'\x1A',  // XMM26j
  (unsigned char)'\x1A',  // XMM26k
  (unsigned char)'\x1A',  // XMM26l
  (unsigned char)'\x1A',  // XMM26m
  (unsigned char)'\x1A',  // XMM26n
  (unsigned char)'\x1A',  // XMM26o
  (unsigned char)'\x1A',  // XMM26p
  (unsigned char)'\x1B',  // XMM27
  (unsigned char)'\x1B',  // XMM27b
  (unsigned char)'\x1B',  // XMM27c
  (unsigned char)'\x1B',  // XMM27d
  (unsigned char)'\x1B',  // XMM27e
  (unsigned char)'\x1B',  // XMM27f
  (unsigned char)'\x1B',  // XMM27g
  (unsigned char)'\x1B',  // XMM27h
  (unsigned char)'\x1B',  // XMM27i
  (unsigned char)'\x1B',  // XMM27j
  (unsigned char)'\x1B',  // XMM27k
  (unsigned char)'\x1B',  // XMM27l
  (unsigned char)'\x1B',  // XMM27m
  (unsigned char)'\x1B',  // XMM27n
  (unsigned char)'\x1B',  // XMM27o
  (unsigned char)'\x1B',  // XMM27p
  (unsigned char)'\x1C',  // XMM28
  (unsigned char)'\x1C',  // XMM28b
  (unsigned char)'\x1C',  // XMM28c
  (unsigned char)'\x1C',  // XMM28d
  (unsigned char)'\x1C',  // XMM28e
  (unsigned char)'\x1C',  // XMM28f
  (unsigned char)'\x1C',  // XMM28g
  (unsigned char)'\x1C',  // XMM28h
  (unsigned char)'\x1C',  // XMM28i
  (unsigned char)'\x1C',  // XMM28j
  (unsigned char)'\x1C',  // XMM28k
  (unsigned char)'\x1C',  // XMM28l
  (unsigned char)'\x1C',  // XMM28m
  (unsigned char)'\x1C',  // XMM28n
  (unsigned char)'\x1C',  // XMM28o
  (unsigned char)'\x1C',  // XMM28p
  (unsigned char)'\x1D',  // XMM29
  (unsigned char)'\x1D',  // XMM29b
  (unsigned char)'\x1D',  // XMM29c
  (unsigned char)'\x1D',  // XMM29d
  (unsigned char)'\x1D',  // XMM29e
  (unsigned char)'\x1D',  // XMM29f
  (unsigned char)'\x1D',  // XMM29g
  (unsigned char)'\x1D',  // XMM29h
  (unsigned char)'\x1D',  // XMM29i
  (unsigned char)'\x1D',  // XMM29j
  (unsigned char)'\x1D',  // XMM29k
  (unsigned char)'\x1D',  // XMM29l
  (unsigned char)'\x1D',  // XMM29m
  (unsigned char)'\x1D',  // XMM29n
  (unsigned char)'\x1D',  // XMM29o
  (unsigned char)'\x1D',  // XMM29p
  (unsigned char)'\x1E',  // XMM30
  (unsigned char)'\x1E',  // XMM30b
  (unsigned char)'\x1E',  // XMM30c
  (unsigned char)'\x1E',  // XMM30d
  (unsigned char)'\x1E',  // XMM30e
  (unsigned char)'\x1E',  // XMM30f
  (unsigned char)'\x1E',  // XMM30g
  (unsigned char)'\x1E',  // XMM30h
  (unsigned char)'\x1E',  // XMM30i
  (unsigned char)'\x1E',  // XMM30j
  (unsigned char)'\x1E',  // XMM30k
  (unsigned char)'\x1E',  // XMM30l
  (unsigned char)'\x1E',  // XMM30m
  (unsigned char)'\x1E',  // XMM30n
  (unsigned char)'\x1E',  // XMM30o
  (unsigned char)'\x1E',  // XMM30p
  (unsigned char)'\x1F',  // XMM31
  (unsigned char)'\x1F',  // XMM31b
  (unsigned char)'\x1F',  // XMM31c
  (unsigned char)'\x1F',  // XMM31d
  (unsigned char)'\x1F',  // XMM31e
  (unsigned char)'\x1F',  // XMM31f
  (unsigned char)'\x1F',  // XMM31g
  (unsigned char)'\x1F',  // XMM31h
  (unsigned char)'\x1F',  // XMM31i
  (unsigned char)'\x1F',  // XMM31j
  (unsigned char)'\x1F',  // XMM31k
  (unsigned char)'\x1F',  // XMM31l
  (unsigned char)'\x1F',  // XMM31m
  (unsigned char)'\x1F',  // XMM31n
  (unsigned char)'\x1F',  // XMM31o
  (unsigned char)'\x1F',  // XMM31p
  (unsigned char)'\x7',  // K7
  (unsigned char)'\x7',  // K7_H
  (unsigned char)'\x6',  // K6
  (unsigned char)'\x6',  // K6_H
  (unsigned char)'\x5',  // K5
  (unsigned char)'\x5',  // K5_H
  (unsigned char)'\x4',  // K4
  (unsigned char)'\x4',  // K4_H
  (unsigned char)'\x3',  // K3
  (unsigned char)'\x3',  // K3_H
  (unsigned char)'\x2',  // K2
  (unsigned char)'\x2',  // K2_H
  (unsigned char)'\x1',  // K1
  (unsigned char)'\x1',  // K1_H
  (unsigned char)'\x10' // no trailing comma  // RFLAGS
};


//------------------Define classes derived from MachOper---------------------
MachOper  *labelOper::clone() const {
  return  new labelOper(_label, _block_num);
}
uint labelOper::opcode() const { return LABEL; }

const RegMask *sRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *sRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

MachOper  *methodOper::clone() const {
  return  new methodOper(_method);
}
uint methodOper::opcode() const { return METHOD; }

const RegMask *kRegOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTMASK_REG_mask();
}

const RegMask *rRegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *rax_RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_RAX_REG_mask();
}

const RegMask *rbx_RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_RBX_REG_mask();
}

const RegMask *rcx_RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_RCX_REG_mask();
}

const RegMask *rdx_RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_RDX_REG_mask();
}

const RegMask *rdi_RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_RDI_REG_mask();
}

const RegMask *no_rax_rdx_RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_NO_RAX_RDX_REG_mask();
}

const RegMask *no_rbp_r13_RegIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_NO_RBP_R13_REG_mask();
}

const RegMask *any_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG_mask();
}

const RegMask *rRegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *rRegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *no_rbp_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_NO_RBP_mask();
}

const RegMask *rax_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_RAX_REG_mask();
}

const RegMask *rax_RegNOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_RAX_REG_mask();
}

const RegMask *rbx_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_RBX_REG_mask();
}

const RegMask *rsi_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_RSI_REG_mask();
}

const RegMask *rbp_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_RBP_REG_mask();
}

const RegMask *rdi_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_RDI_REG_mask();
}

const RegMask *r15_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_R15_REG_mask();
}

const RegMask *rRegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &LONG_REG_mask();
}

const RegMask *no_rax_rdx_RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &LONG_NO_RAX_RDX_REG_mask();
}

const RegMask *rax_RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &LONG_RAX_REG_mask();
}

const RegMask *rcx_RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &LONG_RCX_REG_mask();
}

const RegMask *rdx_RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &LONG_RDX_REG_mask();
}

const RegMask *r11_RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &LONG_R11_REG_mask();
}

const RegMask *no_rbp_r13_RegLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &LONG_NO_RBP_R13_REG_mask();
}

const RegMask *rFlagsRegOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask();
}

const RegMask *rFlagsRegUOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask();
}

const RegMask *rFlagsRegUCFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_FLAGS_mask();
}

const RegMask *regFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FLOAT_REG_mask();
}

const RegMask *legRegFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FLOAT_REG_LEGACY_mask();
}

const RegMask *vlRegFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &FLOAT_REG_VL_mask();
}

const RegMask *regDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &DOUBLE_REG_mask();
}

const RegMask *legRegDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &DOUBLE_REG_LEGACY_mask();
}

const RegMask *vlRegDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &DOUBLE_REG_VL_mask();
}

const RegMask *indirectOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_REG_mask();
}

const RegMask *indOffset8Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG_mask();
}

const RegMask *indOffset32Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &ANY_REG_mask();
}

const RegMask *indIndexOffsetOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG_mask();
  case 1: return &LONG_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indIndexOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG_mask();
  case 1: return &LONG_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indIndexScaleOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG_mask();
  case 1: return &LONG_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indPosIndexScaleOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG_mask();
  case 1: return &INT_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indIndexScaleOffsetOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG_mask();
  case 1: return &LONG_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indPosIndexOffsetOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG_mask();
  case 1: return &INT_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indPosIndexScaleOffsetOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &ANY_REG_mask();
  case 1: return &INT_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indCompressedOopOffsetOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *indirectNarrowOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *indOffset8NarrowOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *indOffset32NarrowOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &INT_REG_mask();
}

const RegMask *indIndexOffsetNarrowOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &INT_REG_mask();
  case 1: return &LONG_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indIndexNarrowOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &INT_REG_mask();
  case 1: return &LONG_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indIndexScaleNarrowOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &INT_REG_mask();
  case 1: return &LONG_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indIndexScaleOffsetNarrowOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  switch (index) {
  case 0: return &INT_REG_mask();
  case 1: return &LONG_REG_mask();
  }
  ShouldNotReachHere();
  return nullptr;
}

const RegMask *indPosIndexOffsetNarrowOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &INT_REG_mask();
}

const RegMask *indPosIndexScaleOffsetNarrowOper::in_RegMask(int index) const {
  assert(0 <= index && index < 2, "index out of range");
  return &INT_REG_mask();
}

const RegMask *stackSlotPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotIOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotFOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *stackSlotLOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &(Compile::current()->FIRST_STACK_mask());
}

const RegMask *rxmm0Oper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &XMM0_REG_mask();
}

const RegMask *vecOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &RegMask::Empty;
}

const RegMask *legVecOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &RegMask::Empty;
}

const RegMask *vecSOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORS_REG_VLBWDQ_mask();
}

const RegMask *legVecSOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORS_REG_LEGACY_mask();
}

const RegMask *vecDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORD_REG_VLBWDQ_mask();
}

const RegMask *legVecDOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORD_REG_LEGACY_mask();
}

const RegMask *vecXOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORX_REG_VLBWDQ_mask();
}

const RegMask *legVecXOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORX_REG_LEGACY_mask();
}

const RegMask *vecYOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORY_REG_VLBWDQ_mask();
}

const RegMask *legVecYOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORY_REG_LEGACY_mask();
}

const RegMask *vecZOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORZ_REG_mask();
}

const RegMask *legVecZOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &VECTORZ_REG_LEGACY_mask();
}

const RegMask *no_rax_RegPOper::in_RegMask(int index) const {
  assert(0 <= index && index < 1, "index out of range");
  return &PTR_NO_RAX_REG_mask();
}

//------------------Define members for classes derived from MachNode----------

void MoveVL2FNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_VL_mask();
}

// Build CISC version of this instruction
MachNode *MoveVL2FNode::cisc_version(int offset) {
  loadFNode *node = new loadFNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void MoveLEG2FNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_LEGACY_mask();
}

// Build CISC version of this instruction
MachNode *MoveLEG2FNode::cisc_version(int offset) {
  loadFNode *node = new loadFNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void MoveVL2DNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_VL_mask();
}

// Build CISC version of this instruction
MachNode *MoveVL2DNode::cisc_version(int offset) {
  loadSSDNode *node = new loadSSDNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void MoveLEG2DNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_LEGACY_mask();
}

// Build CISC version of this instruction
MachNode *MoveLEG2DNode::cisc_version(int offset) {
  loadSSDNode *node = new loadSSDNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void countLeadingZerosINode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *countLeadingZerosINode::cisc_version(int offset) {
  countLeadingZerosI_memNode *node = new countLeadingZerosI_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void countLeadingZerosLNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *countLeadingZerosLNode::cisc_version(int offset) {
  countLeadingZerosL_memNode *node = new countLeadingZerosL_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void countTrailingZerosINode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *countTrailingZerosINode::cisc_version(int offset) {
  countTrailingZerosI_memNode *node = new countTrailingZerosI_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void countTrailingZerosLNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *countTrailingZerosLNode::cisc_version(int offset) {
  countTrailingZerosL_memNode *node = new countTrailingZerosL_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void popCountINode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *popCountINode::cisc_version(int offset) {
  popCountI_memNode *node = new popCountI_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void popCountLNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *popCountLNode::cisc_version(int offset) {
  popCountL_memNode *node = new popCountL_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void cmovI_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmovI_regNode::cisc_version(int offset) {
  cmovI_memNode *node = new cmovI_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void cmovI_regUNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmovI_regUNode::cisc_version(int offset) {
  cmovI_memUNode *node = new cmovI_memUNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void cmovI_regUCFNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmovI_regUCFNode::cisc_version(int offset) {
  cmovI_memUCFNode *node = new cmovI_memUCFNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void cmovL_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmovL_regNode::cisc_version(int offset) {
  cmovL_memNode *node = new cmovL_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void cmovL_regUNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmovL_regUNode::cisc_version(int offset) {
  cmovL_memUNode *node = new cmovL_memUNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void cmovL_regUCFNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmovL_regUCFNode::cisc_version(int offset) {
  cmovL_memUCFNode *node = new cmovL_memUCFNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void addI_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *addI_rRegNode::cisc_version(int offset) {
  addI_rReg_memNode *node = new addI_rReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void addL_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *addL_rRegNode::cisc_version(int offset) {
  addL_rReg_memNode *node = new addL_rReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void subI_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *subI_rRegNode::cisc_version(int offset) {
  subI_rReg_memNode *node = new subI_rReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void subL_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *subL_rRegNode::cisc_version(int offset) {
  subL_rReg_memNode *node = new subL_rReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void mulI_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulI_rRegNode::cisc_version(int offset) {
  mulI_memNode *node = new mulI_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void mulI_rReg_immNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulI_rReg_immNode::cisc_version(int offset) {
  mulI_mem_immNode *node = new mulI_mem_immNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void mulL_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulL_rRegNode::cisc_version(int offset) {
  mulL_memNode *node = new mulL_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void mulL_rReg_immNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulL_rReg_immNode::cisc_version(int offset) {
  mulL_mem_immNode *node = new mulL_mem_immNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void salI_rReg_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *salI_rReg_rRegNode::cisc_version(int offset) {
  salI_mem_rRegNode *node = new salI_mem_rRegNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void sarI_rReg_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *sarI_rReg_rRegNode::cisc_version(int offset) {
  sarI_mem_rRegNode *node = new sarI_mem_rRegNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void shrI_rReg_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *shrI_rReg_rRegNode::cisc_version(int offset) {
  shrI_mem_rRegNode *node = new shrI_mem_rRegNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void salL_rReg_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *salL_rReg_rRegNode::cisc_version(int offset) {
  salL_mem_rRegNode *node = new salL_mem_rRegNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void sarL_rReg_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *sarL_rReg_rRegNode::cisc_version(int offset) {
  sarL_mem_rRegNode *node = new sarL_mem_rRegNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void shrL_rReg_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *shrL_rReg_rRegNode::cisc_version(int offset) {
  shrL_mem_rRegNode *node = new shrL_mem_rRegNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void i2bNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *i2bNode::cisc_version(int offset) {
  loadI2BNode *node = new loadI2BNode();
  node->_num_opnds = 3;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void i2sNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *i2sNode::cisc_version(int offset) {
  loadI2SNode *node = new loadI2SNode();
  node->_num_opnds = 3;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void rolI_immI8Node::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *rolI_immI8Node::cisc_version(int offset) {
  rolI_mem_immI8Node *node = new rolI_mem_immI8Node();
  node->_bottom_type = bottom_type();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void rorI_immI8Node::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *rorI_immI8Node::cisc_version(int offset) {
  rorI_mem_immI8Node *node = new rorI_mem_immI8Node();
  node->_bottom_type = bottom_type();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void rolL_immI8Node::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *rolL_immI8Node::cisc_version(int offset) {
  rolL_mem_immI8Node *node = new rolL_mem_immI8Node();
  node->_bottom_type = bottom_type();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void rorL_immI8Node::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *rorL_immI8Node::cisc_version(int offset) {
  rorL_mem_immI8Node *node = new rorL_mem_immI8Node();
  node->_bottom_type = bottom_type();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void compressBitsL_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *compressBitsL_regNode::cisc_version(int offset) {
  compressBitsL_memNode *node = new compressBitsL_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void expandBitsL_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *expandBitsL_regNode::cisc_version(int offset) {
  expandBitsL_memNode *node = new expandBitsL_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void andI_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *andI_rRegNode::cisc_version(int offset) {
  andI_rReg_memNode *node = new andI_rReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void andI_rReg_imm255Node::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *andI_rReg_imm255Node::cisc_version(int offset) {
  loadI2UBNode *node = new loadI2UBNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void andI2L_rReg_imm255Node::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *andI2L_rReg_imm255Node::cisc_version(int offset) {
  loadI2L_immI_255Node *node = new loadI2L_immI_255Node();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void andI_rReg_imm65535Node::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *andI_rReg_imm65535Node::cisc_version(int offset) {
  loadI2USNode *node = new loadI2USNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void andI2L_rReg_imm65535Node::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *andI2L_rReg_imm65535Node::cisc_version(int offset) {
  loadI2L_immI_65535Node *node = new loadI2L_immI_65535Node();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void andnI_rReg_rReg_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *andnI_rReg_rReg_rRegNode::cisc_version(int offset) {
  andnI_rReg_rReg_memNode *node = new andnI_rReg_rReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void andnI_rReg_rReg_rReg_0Node::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *andnI_rReg_rReg_rReg_0Node::cisc_version(int offset) {
  andnI_rReg_rReg_mem_0Node *node = new andnI_rReg_rReg_mem_0Node();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void orI_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *orI_rRegNode::cisc_version(int offset) {
  orI_rReg_memNode *node = new orI_rReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void xorI_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *xorI_rRegNode::cisc_version(int offset) {
  xorI_rReg_memNode *node = new xorI_rReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void andL_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *andL_rRegNode::cisc_version(int offset) {
  andL_rReg_memNode *node = new andL_rReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void andnL_rReg_rReg_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *andnL_rReg_rReg_rRegNode::cisc_version(int offset) {
  andnL_rReg_rReg_memNode *node = new andnL_rReg_rReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void andnL_rReg_rReg_rReg_0Node::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *andnL_rReg_rReg_rReg_0Node::cisc_version(int offset) {
  andnL_rReg_rReg_mem_0Node *node = new andnL_rReg_rReg_mem_0Node();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void orL_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *orL_rRegNode::cisc_version(int offset) {
  orL_rReg_memNode *node = new orL_rReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void xorL_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *xorL_rRegNode::cisc_version(int offset) {
  xorL_rReg_memNode *node = new xorL_rReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void cmpF_cc_reg_CFNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmpF_cc_reg_CFNode::cisc_version(int offset) {
  cmpF_cc_memCFNode *node = new cmpF_cc_memCFNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void cmpD_cc_reg_CFNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmpD_cc_reg_CFNode::cisc_version(int offset) {
  cmpD_cc_memCFNode *node = new cmpD_cc_memCFNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void cmpF_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmpF_regNode::cisc_version(int offset) {
  cmpF_memNode *node = new cmpF_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void cmpD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *cmpD_regNode::cisc_version(int offset) {
  cmpD_memNode *node = new cmpD_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void convI2L_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *convI2L_reg_regNode::cisc_version(int offset) {
  loadI2LNode *node = new loadI2LNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void convI2L_reg_reg_zexNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *convI2L_reg_reg_zexNode::cisc_version(int offset) {
  loadUI2LNode *node = new loadUI2LNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void MoveF2I_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *MoveF2I_reg_regNode::cisc_version(int offset) {
  MoveF2I_stack_regNode *node = new MoveF2I_stack_regNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void MoveD2L_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *MoveD2L_reg_regNode::cisc_version(int offset) {
  MoveD2L_stack_regNode *node = new MoveD2L_stack_regNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void MoveI2F_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *MoveI2F_reg_regNode::cisc_version(int offset) {
  MoveI2F_stack_regNode *node = new MoveI2F_stack_regNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void compI_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *compI_rRegNode::cisc_version(int offset) {
  compI_rReg_memNode *node = new compI_rReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void testI_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *testI_reg_regNode::cisc_version(int offset) {
  testI_reg_memNode *node = new testI_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void compU_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *compU_rRegNode::cisc_version(int offset) {
  compU_rReg_memNode *node = new compU_rReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void compL_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *compL_rRegNode::cisc_version(int offset) {
  compL_rReg_memNode *node = new compL_rReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void testL_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *testL_reg_regNode::cisc_version(int offset) {
  testL_reg_memNode *node = new testL_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void compUL_rRegNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *compUL_rRegNode::cisc_version(int offset) {
  compUL_rReg_memNode *node = new compUL_rReg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}

// Build short branch version of this instruction
MachNode *jmpDirNode::short_branch_version() {
  jmpDir_shortNode *node = new jmpDir_shortNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpConNode::short_branch_version() {
  jmpCon_shortNode *node = new jmpCon_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpLoopEndNode::short_branch_version() {
  jmpLoopEnd_shortNode *node = new jmpLoopEnd_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpConUNode::short_branch_version() {
  jmpConU_shortNode *node = new jmpConU_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpConUCFNode::short_branch_version() {
  jmpConUCF_shortNode *node = new jmpConUCF_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}

// Build short branch version of this instruction
MachNode *jmpConUCF2Node::short_branch_version() {
  jmpConUCF2_shortNode *node = new jmpConUCF2_shortNode();
  node->_prob = _prob;
  node->_fcnt = _fcnt;

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  return node;
}


void addF_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *addF_regNode::cisc_version(int offset) {
  addF_memNode *node = new addF_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void addF_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *addF_reg_regNode::cisc_version(int offset) {
  addF_reg_memNode *node = new addF_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void addD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *addD_regNode::cisc_version(int offset) {
  addD_memNode *node = new addD_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void addD_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *addD_reg_regNode::cisc_version(int offset) {
  addD_reg_memNode *node = new addD_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void subF_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *subF_regNode::cisc_version(int offset) {
  subF_memNode *node = new subF_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void subF_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *subF_reg_regNode::cisc_version(int offset) {
  subF_reg_memNode *node = new subF_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void subD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *subD_regNode::cisc_version(int offset) {
  subD_memNode *node = new subD_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void subD_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *subD_reg_regNode::cisc_version(int offset) {
  subD_reg_memNode *node = new subD_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void mulF_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulF_regNode::cisc_version(int offset) {
  mulF_memNode *node = new mulF_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void mulF_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulF_reg_regNode::cisc_version(int offset) {
  mulF_reg_memNode *node = new mulF_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void mulD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulD_regNode::cisc_version(int offset) {
  mulD_memNode *node = new mulD_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void mulD_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *mulD_reg_regNode::cisc_version(int offset) {
  mulD_reg_memNode *node = new mulD_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void divF_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *divF_regNode::cisc_version(int offset) {
  divF_memNode *node = new divF_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void divF_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_mask();
}

// Build CISC version of this instruction
MachNode *divF_reg_regNode::cisc_version(int offset) {
  divF_reg_memNode *node = new divF_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void divD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *divD_regNode::cisc_version(int offset) {
  divD_memNode *node = new divD_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void divD_reg_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_mask();
}

// Build CISC version of this instruction
MachNode *divD_reg_regNode::cisc_version(int offset) {
  divD_reg_memNode *node = new divD_reg_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void ReplI_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *ReplI_regNode::cisc_version(int offset) {
  ReplI_memNode *node = new ReplI_memNode();
  node->_bottom_type = bottom_type();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void ReplL_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_LONG_REG_mask();
}

// Build CISC version of this instruction
MachNode *ReplL_regNode::cisc_version(int offset) {
  ReplL_memNode *node = new ReplL_memNode();
  node->_bottom_type = bottom_type();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void vReplF_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_FLOAT_REG_VL_mask();
}

// Build CISC version of this instruction
MachNode *vReplF_regNode::cisc_version(int offset) {
  ReplF_memNode *node = new ReplF_memNode();
  node->_bottom_type = bottom_type();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void vReplD_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_DOUBLE_REG_VL_mask();
}

// Build CISC version of this instruction
MachNode *vReplD_regNode::cisc_version(int offset) {
  ReplD_memNode *node = new ReplD_memNode();
  node->_bottom_type = bottom_type();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void compressBitsI_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *compressBitsI_regNode::cisc_version(int offset) {
  compressBitsI_memNode *node = new compressBitsI_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}


void expandBitsI_regNode::use_cisc_RegMask() {
  _cisc_RegMask = &STACK_OR_INT_REG_mask();
}

// Build CISC version of this instruction
MachNode *expandBitsI_regNode::cisc_version(int offset) {
  expandBitsI_memNode *node = new expandBitsI_memNode();

  // Copy _idx, inputs and operands to new node
  fill_new_machnode(node);
  // Construct operand to access [stack_pointer + offset]
  node->set_opnd_array(cisc_operand(), new indOffset32Oper(offset));

  return node;
}

void jmpDirNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpDirNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpConNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpConNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpLoopEndNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpLoopEndNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpConUNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpConUNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpConUCFNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpConUCFNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpConUCF2Node::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpConUCF2Node::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpDir_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpDir_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(1));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpCon_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpCon_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpLoopEnd_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpLoopEnd_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpConU_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpConU_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpConUCF_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpConUCF_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void jmpConUCF2_shortNode::label_set( Label* label, uint block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  oper->_label     = label;
  oper->_block_num = block_num;
}
void jmpConUCF2_shortNode::save_label( Label** label, uint* block_num ) {
  labelOper* oper  = (labelOper*)(opnd_array(3));
  *label = oper->_label;
  *block_num = oper->_block_num;
}
void CallStaticJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallDynamicJavaDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallRuntimeDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafDirectVectorNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

void CallLeafNoFPDirectNode::method_set( intptr_t method ) {
  ((methodOper*)opnd_array(1))->_method = method;
}

int loadBNode::reloc() const {
  return 1;
}

int loadB2LNode::reloc() const {
  return 1;
}

int loadUBNode::reloc() const {
  return 1;
}

int loadUB2LNode::reloc() const {
  return 1;
}

int loadUB2L_immINode::reloc() const {
  return 1;
}

int loadSNode::reloc() const {
  return 1;
}

int loadS2BNode::reloc() const {
  return 1;
}

int loadS2LNode::reloc() const {
  return 1;
}

int loadUSNode::reloc() const {
  return 1;
}

int loadUS2BNode::reloc() const {
  return 1;
}

int loadUS2LNode::reloc() const {
  return 1;
}

int loadUS2L_immI_255Node::reloc() const {
  return 1;
}

int loadUS2L_immINode::reloc() const {
  return 1;
}

int loadINode::reloc() const {
  return 1;
}

int loadI2BNode::reloc() const {
  return 1;
}

int loadI2UBNode::reloc() const {
  return 1;
}

int loadI2SNode::reloc() const {
  return 1;
}

int loadI2USNode::reloc() const {
  return 1;
}

int loadI2LNode::reloc() const {
  return 1;
}

int loadI2L_immI_255Node::reloc() const {
  return 1;
}

int loadI2L_immI_65535Node::reloc() const {
  return 1;
}

int loadI2L_immU31Node::reloc() const {
  return 1;
}

int loadUI2LNode::reloc() const {
  return 1;
}

int loadLNode::reloc() const {
  return 1;
}

int loadRangeNode::reloc() const {
  return 1;
}

int loadPNode::reloc() const {
  return 1;
}

int loadNNode::reloc() const {
  return 1;
}

int loadKlassNode::reloc() const {
  return 1;
}

int loadNKlassNode::reloc() const {
  return 1;
}

int loadNKlassCompactHeadersNode::reloc() const {
  return 1;
}

int loadFNode::reloc() const {
  return 1;
}

int loadD_partialNode::reloc() const {
  return 1;
}

int loadDNode::reloc() const {
  return 1;
}

int loadConPNode::reloc() const {
  return 1;
}

int loadConP0Node::reloc() const {
  return 1;
}

int loadConP31Node::reloc() const {
  return 1;
}

int loadConFNode::reloc() const {
  return 2;
}

int loadConF0Node::reloc() const {
  return 2;
}

int loadConDNode::reloc() const {
  return 2;
}

int loadConD0Node::reloc() const {
  return 2;
}

int prefetchAllocNode::reloc() const {
  return 1;
}

int prefetchAllocNTANode::reloc() const {
  return 1;
}

int prefetchAllocT0Node::reloc() const {
  return 1;
}

int prefetchAllocT2Node::reloc() const {
  return 1;
}

int storeBNode::reloc() const {
  return 2;
}

int storeCNode::reloc() const {
  return 2;
}

int storeINode::reloc() const {
  return 2;
}

int storeLNode::reloc() const {
  return 2;
}

int storePNode::reloc() const {
  return 2;
}

int storeImmP0Node::reloc() const {
  return 3;
}

int storeImmPNode::reloc() const {
  return 3;
}

int storeNNode::reloc() const {
  return 2;
}

int storeNKlassNode::reloc() const {
  return 2;
}

int storeImmN0Node::reloc() const {
  return 2;
}

int storeImmNNode::reloc() const {
  return 2;
}

int storeImmNKlassNode::reloc() const {
  return 2;
}

int storeImmI0Node::reloc() const {
  return 2;
}

int storeImmINode::reloc() const {
  return 2;
}

int storeImmL0Node::reloc() const {
  return 2;
}

int storeImmLNode::reloc() const {
  return 2;
}

int storeImmC0Node::reloc() const {
  return 2;
}

int storeImmI16Node::reloc() const {
  return 2;
}

int storeImmB0Node::reloc() const {
  return 2;
}

int storeImmBNode::reloc() const {
  return 2;
}

int storeFNode::reloc() const {
  return 2;
}

int storeF0Node::reloc() const {
  return 3;
}

int storeF_immNode::reloc() const {
  return 3;
}

int storeDNode::reloc() const {
  return 2;
}

int storeD0_immNode::reloc() const {
  return 3;
}

int storeD0Node::reloc() const {
  return 3;
}

int countLeadingZerosI_memNode::reloc() const {
  return 1;
}

int countLeadingZerosL_memNode::reloc() const {
  return 1;
}

int countTrailingZerosI_memNode::reloc() const {
  return 1;
}

int countTrailingZerosL_memNode::reloc() const {
  return 1;
}

int popCountI_memNode::reloc() const {
  return 1;
}

int popCountL_memNode::reloc() const {
  return 1;
}

int cmovI_memNode::reloc() const {
  return 1;
}

int cmovI_memUNode::reloc() const {
  return 1;
}

int cmovI_memUCFNode::reloc() const {
  return 1;
}

int cmovL_memNode::reloc() const {
  return 1;
}

int cmovL_memUNode::reloc() const {
  return 1;
}

int cmovL_memUCFNode::reloc() const {
  return 1;
}

int addI_rReg_memNode::reloc() const {
  return 1;
}

int addI_rReg_mem_0Node::reloc() const {
  return 1;
}

int addI_mem_rRegNode::reloc() const {
  return 3;
}

int addI_mem_rReg_0Node::reloc() const {
  return 3;
}

int addI_mem_immNode::reloc() const {
  return 3;
}

int incI_memNode::reloc() const {
  return 3;
}

int decI_memNode::reloc() const {
  return 3;
}

int addL_rReg_memNode::reloc() const {
  return 1;
}

int addL_rReg_mem_0Node::reloc() const {
  return 1;
}

int addL_mem_rRegNode::reloc() const {
  return 3;
}

int addL_mem_rReg_0Node::reloc() const {
  return 3;
}

int addL_mem_immNode::reloc() const {
  return 3;
}

int incL_memNode::reloc() const {
  return 3;
}

int decL_memNode::reloc() const {
  return 3;
}

int compareAndSwapPNode::reloc() const {
  return 1;
}

int compareAndSwapP_0Node::reloc() const {
  return 1;
}

int compareAndSwapLNode::reloc() const {
  return 1;
}

int compareAndSwapL_0Node::reloc() const {
  return 1;
}

int compareAndSwapINode::reloc() const {
  return 1;
}

int compareAndSwapI_0Node::reloc() const {
  return 1;
}

int compareAndSwapBNode::reloc() const {
  return 1;
}

int compareAndSwapB_0Node::reloc() const {
  return 1;
}

int compareAndSwapSNode::reloc() const {
  return 1;
}

int compareAndSwapS_0Node::reloc() const {
  return 1;
}

int compareAndSwapNNode::reloc() const {
  return 1;
}

int compareAndSwapN_0Node::reloc() const {
  return 1;
}

int compareAndExchangeBNode::reloc() const {
  return 1;
}

int compareAndExchangeSNode::reloc() const {
  return 1;
}

int compareAndExchangeINode::reloc() const {
  return 1;
}

int compareAndExchangeLNode::reloc() const {
  return 1;
}

int compareAndExchangeNNode::reloc() const {
  return 1;
}

int compareAndExchangePNode::reloc() const {
  return 1;
}

int xaddB_reg_no_resNode::reloc() const {
  return 1;
}

int xaddB_imm_no_resNode::reloc() const {
  return 1;
}

int xaddBNode::reloc() const {
  return 1;
}

int xaddS_reg_no_resNode::reloc() const {
  return 1;
}

int xaddS_imm_no_resNode::reloc() const {
  return 1;
}

int xaddSNode::reloc() const {
  return 1;
}

int xaddI_reg_no_resNode::reloc() const {
  return 1;
}

int xaddI_imm_no_resNode::reloc() const {
  return 1;
}

int xaddINode::reloc() const {
  return 1;
}

int xaddL_reg_no_resNode::reloc() const {
  return 1;
}

int xaddL_imm_no_resNode::reloc() const {
  return 1;
}

int xaddLNode::reloc() const {
  return 1;
}

int xchgBNode::reloc() const {
  return 1;
}

int xchgSNode::reloc() const {
  return 1;
}

int xchgINode::reloc() const {
  return 1;
}

int xchgLNode::reloc() const {
  return 1;
}

int xchgPNode::reloc() const {
  return 1;
}

int xchgNNode::reloc() const {
  return 1;
}

int subI_rReg_memNode::reloc() const {
  return 1;
}

int subI_mem_rRegNode::reloc() const {
  return 3;
}

int subL_rReg_memNode::reloc() const {
  return 1;
}

int subL_mem_rRegNode::reloc() const {
  return 3;
}

int negI_memNode::reloc() const {
  return 3;
}

int negL_memNode::reloc() const {
  return 3;
}

int mulI_memNode::reloc() const {
  return 1;
}

int mulI_mem_0Node::reloc() const {
  return 1;
}

int mulI_mem_immNode::reloc() const {
  return 1;
}

int mulL_memNode::reloc() const {
  return 1;
}

int mulL_mem_0Node::reloc() const {
  return 1;
}

int mulL_mem_immNode::reloc() const {
  return 1;
}

int salI_mem_immNode::reloc() const {
  return 3;
}

int salI_mem_CLNode::reloc() const {
  return 3;
}

int salI_mem_rRegNode::reloc() const {
  return 1;
}

int sarI_mem_immNode::reloc() const {
  return 3;
}

int sarI_mem_CLNode::reloc() const {
  return 3;
}

int sarI_mem_rRegNode::reloc() const {
  return 1;
}

int shrI_mem_immNode::reloc() const {
  return 3;
}

int shrI_mem_CLNode::reloc() const {
  return 3;
}

int shrI_mem_rRegNode::reloc() const {
  return 1;
}

int salL_mem_immNode::reloc() const {
  return 3;
}

int salL_mem_CLNode::reloc() const {
  return 3;
}

int salL_mem_rRegNode::reloc() const {
  return 1;
}

int sarL_mem_immNode::reloc() const {
  return 3;
}

int sarL_mem_CLNode::reloc() const {
  return 3;
}

int sarL_mem_rRegNode::reloc() const {
  return 1;
}

int shrL_mem_immNode::reloc() const {
  return 3;
}

int shrL_mem_CLNode::reloc() const {
  return 3;
}

int shrL_mem_rRegNode::reloc() const {
  return 1;
}

int rolI_mem_immI8Node::reloc() const {
  return 1;
}

int rorI_mem_immI8Node::reloc() const {
  return 1;
}

int rolL_mem_immI8Node::reloc() const {
  return 1;
}

int rorL_mem_immI8Node::reloc() const {
  return 1;
}

int compressBitsL_memNode::reloc() const {
  return 1;
}

int expandBitsL_memNode::reloc() const {
  return 1;
}

int andI_rReg_memNode::reloc() const {
  return 1;
}

int andI_rReg_mem_0Node::reloc() const {
  return 1;
}

int andB_mem_rRegNode::reloc() const {
  return 3;
}

int andB_mem_rReg_0Node::reloc() const {
  return 3;
}

int andI_mem_rRegNode::reloc() const {
  return 3;
}

int andI_mem_rReg_0Node::reloc() const {
  return 3;
}

int andI_mem_immNode::reloc() const {
  return 3;
}

int andnI_rReg_rReg_memNode::reloc() const {
  return 1;
}

int andnI_rReg_rReg_mem_0Node::reloc() const {
  return 1;
}

int blsiI_rReg_memNode::reloc() const {
  return 2;
}

int blsiI_rReg_mem_0Node::reloc() const {
  return 2;
}

int blsmskI_rReg_memNode::reloc() const {
  return 2;
}

int blsmskI_rReg_mem_0Node::reloc() const {
  return 2;
}

int blsrI_rReg_memNode::reloc() const {
  return 2;
}

int blsrI_rReg_mem_0Node::reloc() const {
  return 2;
}

int orI_rReg_memNode::reloc() const {
  return 1;
}

int orI_rReg_mem_0Node::reloc() const {
  return 1;
}

int orB_mem_rRegNode::reloc() const {
  return 3;
}

int orB_mem_rReg_0Node::reloc() const {
  return 3;
}

int orI_mem_rRegNode::reloc() const {
  return 3;
}

int orI_mem_rReg_0Node::reloc() const {
  return 3;
}

int orI_mem_immNode::reloc() const {
  return 3;
}

int xorI_rReg_memNode::reloc() const {
  return 1;
}

int xorI_rReg_mem_0Node::reloc() const {
  return 1;
}

int xorB_mem_rRegNode::reloc() const {
  return 3;
}

int xorB_mem_rReg_0Node::reloc() const {
  return 3;
}

int xorI_mem_rRegNode::reloc() const {
  return 3;
}

int xorI_mem_rReg_0Node::reloc() const {
  return 3;
}

int xorI_mem_immNode::reloc() const {
  return 3;
}

int andL_rReg_memNode::reloc() const {
  return 1;
}

int andL_rReg_mem_0Node::reloc() const {
  return 1;
}

int andL_mem_rRegNode::reloc() const {
  return 3;
}

int andL_mem_rReg_0Node::reloc() const {
  return 3;
}

int andL_mem_immNode::reloc() const {
  return 3;
}

int btrL_mem_immNode::reloc() const {
  return 3;
}

int andnL_rReg_rReg_memNode::reloc() const {
  return 1;
}

int andnL_rReg_rReg_mem_0Node::reloc() const {
  return 1;
}

int blsiL_rReg_memNode::reloc() const {
  return 2;
}

int blsiL_rReg_mem_0Node::reloc() const {
  return 2;
}

int blsmskL_rReg_memNode::reloc() const {
  return 2;
}

int blsmskL_rReg_mem_0Node::reloc() const {
  return 2;
}

int blsrL_rReg_memNode::reloc() const {
  return 2;
}

int blsrL_rReg_mem_0Node::reloc() const {
  return 2;
}

int orL_rReg_memNode::reloc() const {
  return 1;
}

int orL_rReg_mem_0Node::reloc() const {
  return 1;
}

int orL_mem_rRegNode::reloc() const {
  return 3;
}

int orL_mem_rReg_0Node::reloc() const {
  return 3;
}

int orL_mem_immNode::reloc() const {
  return 3;
}

int btsL_mem_immNode::reloc() const {
  return 3;
}

int xorL_rReg_memNode::reloc() const {
  return 1;
}

int xorL_rReg_mem_0Node::reloc() const {
  return 1;
}

int xorL_mem_rRegNode::reloc() const {
  return 3;
}

int xorL_mem_rReg_0Node::reloc() const {
  return 3;
}

int xorL_mem_immNode::reloc() const {
  return 3;
}

int cmpF_cc_memCFNode::reloc() const {
  return 1;
}

int cmpF_cc_immCFNode::reloc() const {
  return 1;
}

int cmpD_cc_memCFNode::reloc() const {
  return 1;
}

int cmpD_cc_immCFNode::reloc() const {
  return 1;
}

int cmpF_memNode::reloc() const {
  return 1;
}

int cmpF_immNode::reloc() const {
  return 1;
}

int cmpD_memNode::reloc() const {
  return 1;
}

int cmpD_immNode::reloc() const {
  return 1;
}

int convF2D_reg_memNode::reloc() const {
  return 1;
}

int convD2F_reg_memNode::reloc() const {
  return 1;
}

int convI2F_reg_memNode::reloc() const {
  return 1;
}

int convI2D_reg_memNode::reloc() const {
  return 1;
}

int convL2F_reg_memNode::reloc() const {
  return 1;
}

int convL2D_reg_memNode::reloc() const {
  return 1;
}

int convI2L_reg_mem_zexNode::reloc() const {
  return 1;
}

int compI_rReg_memNode::reloc() const {
  return 1;
}

int testI_reg_memNode::reloc() const {
  return 1;
}

int testI_reg_mem_0Node::reloc() const {
  return 1;
}

int compU_rReg_memNode::reloc() const {
  return 1;
}

int compP_rReg_memNode::reloc() const {
  return 1;
}

int compP_mem_rRegNode::reloc() const {
  return 1;
}

int testP_regNode::reloc() const {
  return 1;
}

int testP_memNode::reloc() const {
  return 2;
}

int testP_mem_reg0Node::reloc() const {
  return 2;
}

int compN_rReg_memNode::reloc() const {
  return 1;
}

int compN_mem_immNode::reloc() const {
  return 1;
}

int compN_mem_imm_klassNode::reloc() const {
  return 1;
}

int testN_memNode::reloc() const {
  return 1;
}

int testN_mem_reg0Node::reloc() const {
  return 1;
}

int compL_rReg_memNode::reloc() const {
  return 1;
}

int testL_reg_memNode::reloc() const {
  return 1;
}

int testL_reg_mem_0Node::reloc() const {
  return 1;
}

int testL_reg_mem2Node::reloc() const {
  return 1;
}

int testL_reg_mem2_0Node::reloc() const {
  return 1;
}

int compUL_rReg_memNode::reloc() const {
  return 1;
}

int compB_mem_immNode::reloc() const {
  return 1;
}

int testUB_mem_immNode::reloc() const {
  return 1;
}

int testB_mem_immNode::reloc() const {
  return 1;
}

int partialSubtypeCheckConstSuperNode::reloc() const {
  return 1;
}

int safePoint_poll_tlsNode::reloc() const {
  return 1;
}

int CallStaticJavaDirectNode::reloc() const {
  return 1;
}

int CallDynamicJavaDirectNode::reloc() const {
  return 1;
}

int CallRuntimeDirectNode::reloc() const {
  return 1;
}

int CallLeafDirectNode::reloc() const {
  return 1;
}

int CallLeafDirectVectorNode::reloc() const {
  return 1;
}

int CallLeafNoFPDirectNode::reloc() const {
  return 1;
}

int RetNode::reloc() const {
  return 1;
}

int TailCalljmpIndNode::reloc() const {
  return 1;
}

int tailjmpIndNode::reloc() const {
  return 1;
}

int ForwardExceptionjmpNode::reloc() const {
  return 1;
}

int RethrowExceptionNode::reloc() const {
  return 1;
}

int addF_memNode::reloc() const {
  return 1;
}

int addF_mem_0Node::reloc() const {
  return 1;
}

int addF_immNode::reloc() const {
  return 1;
}

int addF_reg_memNode::reloc() const {
  return 1;
}

int addF_reg_mem_0Node::reloc() const {
  return 1;
}

int addF_reg_immNode::reloc() const {
  return 1;
}

int addD_memNode::reloc() const {
  return 1;
}

int addD_mem_0Node::reloc() const {
  return 1;
}

int addD_immNode::reloc() const {
  return 1;
}

int addD_reg_memNode::reloc() const {
  return 1;
}

int addD_reg_mem_0Node::reloc() const {
  return 1;
}

int addD_reg_immNode::reloc() const {
  return 1;
}

int subF_memNode::reloc() const {
  return 1;
}

int subF_immNode::reloc() const {
  return 1;
}

int subF_reg_memNode::reloc() const {
  return 1;
}

int subF_reg_immNode::reloc() const {
  return 1;
}

int subD_memNode::reloc() const {
  return 1;
}

int subD_immNode::reloc() const {
  return 1;
}

int subD_reg_memNode::reloc() const {
  return 1;
}

int subD_reg_immNode::reloc() const {
  return 1;
}

int mulF_memNode::reloc() const {
  return 1;
}

int mulF_mem_0Node::reloc() const {
  return 1;
}

int mulF_immNode::reloc() const {
  return 1;
}

int mulF_reg_memNode::reloc() const {
  return 1;
}

int mulF_reg_mem_0Node::reloc() const {
  return 1;
}

int mulF_reg_immNode::reloc() const {
  return 1;
}

int mulD_memNode::reloc() const {
  return 1;
}

int mulD_mem_0Node::reloc() const {
  return 1;
}

int mulD_immNode::reloc() const {
  return 1;
}

int mulD_reg_memNode::reloc() const {
  return 1;
}

int mulD_reg_mem_0Node::reloc() const {
  return 1;
}

int mulD_reg_immNode::reloc() const {
  return 1;
}

int divF_memNode::reloc() const {
  return 1;
}

int divF_immNode::reloc() const {
  return 1;
}

int divF_reg_memNode::reloc() const {
  return 1;
}

int divF_reg_immNode::reloc() const {
  return 1;
}

int divD_memNode::reloc() const {
  return 1;
}

int divD_immNode::reloc() const {
  return 1;
}

int divD_reg_memNode::reloc() const {
  return 1;
}

int divD_reg_immNode::reloc() const {
  return 1;
}

int convF2HF_mem_regNode::reloc() const {
  return 2;
}

int vconvF2HF_mem_regNode::reloc() const {
  return 2;
}

int vconvHF2F_reg_memNode::reloc() const {
  return 1;
}

int roundD_immNode::reloc() const {
  return 1;
}

int vroundD_memNode::reloc() const {
  return 1;
}

int vround8D_memNode::reloc() const {
  return 1;
}

int loadVNode::reloc() const {
  return 1;
}

int storeVNode::reloc() const {
  return 2;
}

int gatherNode::reloc() const {
  return 1;
}

int evgatherNode::reloc() const {
  return 1;
}

int evgather_maskedNode::reloc() const {
  return 1;
}

int vgather_subwordLE8BNode::reloc() const {
  return 1;
}

int vgather_subwordGT8BNode::reloc() const {
  return 1;
}

int vgather_subwordLE8B_offNode::reloc() const {
  return 1;
}

int vgather_subwordGT8B_offNode::reloc() const {
  return 1;
}

int vgather_masked_subwordLE8B_avx3Node::reloc() const {
  return 1;
}

int vgather_masked_subwordGT8B_avx3Node::reloc() const {
  return 1;
}

int vgather_masked_subwordLE8B_off_avx3Node::reloc() const {
  return 1;
}

int vgather_masked_subwordGT8B_off_avx3Node::reloc() const {
  return 1;
}

int vgather_masked_subwordLE8B_avx2Node::reloc() const {
  return 1;
}

int vgather_masked_subwordGT8B_avx2Node::reloc() const {
  return 1;
}

int vgather_masked_subwordLE8B_off_avx2Node::reloc() const {
  return 1;
}

int vgather_masked_subwordGT8B_off_avx2Node::reloc() const {
  return 1;
}

int scatterNode::reloc() const {
  return 2;
}

int scatter_maskedNode::reloc() const {
  return 2;
}

int ReplB_memNode::reloc() const {
  return 1;
}

int ReplS_memNode::reloc() const {
  return 1;
}

int ReplI_memNode::reloc() const {
  return 1;
}

int ReplL_memNode::reloc() const {
  return 1;
}

int ReplF_memNode::reloc() const {
  return 1;
}

int ReplF_immNode::reloc() const {
  return 1;
}

int ReplF_zeroNode::reloc() const {
  return 1;
}

int ReplD_memNode::reloc() const {
  return 1;
}

int ReplD_immNode::reloc() const {
  return 1;
}

int ReplD_zeroNode::reloc() const {
  return 1;
}

int minmax_reduction2FNode::reloc() const {
  return 1;
}

int minmax_reduction2F_0Node::reloc() const {
  return 1;
}

int minmax_reductionFNode::reloc() const {
  return 1;
}

int minmax_reductionF_0Node::reloc() const {
  return 1;
}

int minmax_reduction2DNode::reloc() const {
  return 1;
}

int minmax_reduction2D_0Node::reloc() const {
  return 1;
}

int minmax_reductionDNode::reloc() const {
  return 1;
}

int minmax_reductionD_0Node::reloc() const {
  return 1;
}

int vaddB_memNode::reloc() const {
  return 1;
}

int vaddB_mem_0Node::reloc() const {
  return 1;
}

int vaddS_memNode::reloc() const {
  return 1;
}

int vaddS_mem_0Node::reloc() const {
  return 1;
}

int vaddI_memNode::reloc() const {
  return 1;
}

int vaddI_mem_0Node::reloc() const {
  return 1;
}

int vaddL_memNode::reloc() const {
  return 1;
}

int vaddL_mem_0Node::reloc() const {
  return 1;
}

int vaddF_memNode::reloc() const {
  return 1;
}

int vaddF_mem_0Node::reloc() const {
  return 1;
}

int vaddD_memNode::reloc() const {
  return 1;
}

int vaddD_mem_0Node::reloc() const {
  return 1;
}

int vsubB_memNode::reloc() const {
  return 1;
}

int vsubS_memNode::reloc() const {
  return 1;
}

int vsubI_memNode::reloc() const {
  return 1;
}

int vsubL_memNode::reloc() const {
  return 1;
}

int vsubF_memNode::reloc() const {
  return 1;
}

int vsubD_memNode::reloc() const {
  return 1;
}

int vmulS_memNode::reloc() const {
  return 1;
}

int vmulS_mem_0Node::reloc() const {
  return 1;
}

int vmulI_memNode::reloc() const {
  return 1;
}

int vmulI_mem_0Node::reloc() const {
  return 1;
}

int evmulL_memNode::reloc() const {
  return 1;
}

int evmulL_mem_0Node::reloc() const {
  return 1;
}

int vmulF_memNode::reloc() const {
  return 1;
}

int vmulF_mem_0Node::reloc() const {
  return 1;
}

int vmulD_memNode::reloc() const {
  return 1;
}

int vmulD_mem_0Node::reloc() const {
  return 1;
}

int vdivF_memNode::reloc() const {
  return 1;
}

int vdivD_memNode::reloc() const {
  return 1;
}

int vector_uminmax_memNode::reloc() const {
  return 1;
}

int vector_uminmax_mem_0Node::reloc() const {
  return 1;
}

int vector_uminmax_mem_maskedNode::reloc() const {
  return 1;
}

int vector_uminmax_mem_masked_0Node::reloc() const {
  return 1;
}

int copySignD_immNode::reloc() const {
  return 1;
}

int compressBitsI_memNode::reloc() const {
  return 1;
}

int expandBitsI_memNode::reloc() const {
  return 1;
}

int vsqrtF_memNode::reloc() const {
  return 1;
}

int vsqrtD_memNode::reloc() const {
  return 1;
}

int vand_memNode::reloc() const {
  return 1;
}

int vand_mem_0Node::reloc() const {
  return 1;
}

int vor_memNode::reloc() const {
  return 1;
}

int vor_mem_0Node::reloc() const {
  return 1;
}

int vxor_memNode::reloc() const {
  return 1;
}

int vxor_mem_0Node::reloc() const {
  return 1;
}

int vfmaF_memNode::reloc() const {
  return 1;
}

int vfmaD_memNode::reloc() const {
  return 1;
}

int vpternlog_memNode::reloc() const {
  return 1;
}

int vmasked_load_avx_non_subwordNode::reloc() const {
  return 1;
}

int vmasked_load_evexNode::reloc() const {
  return 1;
}

int vmasked_store_avx_non_subwordNode::reloc() const {
  return 2;
}

int vmasked_store_evexNode::reloc() const {
  return 2;
}

int vadd_mem_maskedNode::reloc() const {
  return 1;
}

int vadd_mem_masked_0Node::reloc() const {
  return 1;
}

int vadd_mem_masked_1Node::reloc() const {
  return 1;
}

int vadd_mem_masked_2Node::reloc() const {
  return 1;
}

int vadd_mem_masked_3Node::reloc() const {
  return 1;
}

int vadd_mem_masked_4Node::reloc() const {
  return 1;
}

int vxor_mem_maskedNode::reloc() const {
  return 1;
}

int vor_mem_maskedNode::reloc() const {
  return 1;
}

int vand_mem_maskedNode::reloc() const {
  return 1;
}

int vsub_mem_maskedNode::reloc() const {
  return 1;
}

int vsub_mem_masked_0Node::reloc() const {
  return 1;
}

int vsub_mem_masked_1Node::reloc() const {
  return 1;
}

int vsub_mem_masked_2Node::reloc() const {
  return 1;
}

int vsub_mem_masked_3Node::reloc() const {
  return 1;
}

int vsub_mem_masked_4Node::reloc() const {
  return 1;
}

int vmul_mem_maskedNode::reloc() const {
  return 1;
}

int vmul_mem_masked_0Node::reloc() const {
  return 1;
}

int vmul_mem_masked_1Node::reloc() const {
  return 1;
}

int vmul_mem_masked_2Node::reloc() const {
  return 1;
}

int vmul_mem_masked_3Node::reloc() const {
  return 1;
}

int vdiv_mem_maskedNode::reloc() const {
  return 1;
}

int vdiv_mem_masked_0Node::reloc() const {
  return 1;
}

int vmaxv_mem_maskedNode::reloc() const {
  return 1;
}

int vminv_mem_maskedNode::reloc() const {
  return 1;
}

int vfma_mem_maskedNode::reloc() const {
  return 1;
}

int vfma_mem_masked_0Node::reloc() const {
  return 1;
}

int vternlogd_mem_maskedNode::reloc() const {
  return 1;
}

int vector_addsub_saturating_subword_memNode::reloc() const {
  return 1;
}

int vector_addsub_saturating_subword_mem_0Node::reloc() const {
  return 1;
}

int vector_addsub_saturating_unsigned_subword_memNode::reloc() const {
  return 1;
}

int vector_addsub_saturating_unsigned_subword_mem_0Node::reloc() const {
  return 1;
}

int vector_addsub_saturating_subword_masked_memNode::reloc() const {
  return 1;
}

int vector_addsub_saturating_subword_masked_mem_0Node::reloc() const {
  return 1;
}

int vector_addsub_saturating_unsigned_subword_masked_memNode::reloc() const {
  return 1;
}

int vector_addsub_saturating_unsigned_subword_masked_mem_0Node::reloc() const {
  return 1;
}

int compareAndSwapP_shenandoahNode::reloc() const {
  return 1;
}

int compareAndSwapP_shenandoah_0Node::reloc() const {
  return 1;
}

int compareAndSwapN_shenandoahNode::reloc() const {
  return 1;
}

int compareAndSwapN_shenandoah_0Node::reloc() const {
  return 1;
}

int compareAndExchangeN_shenandoahNode::reloc() const {
  return 1;
}

int compareAndExchangeP_shenandoahNode::reloc() const {
  return 1;
}

int zLoadPNode::reloc() const {
  return 1;
}

int zLoadPNullCheckNode::reloc() const {
  return 2;
}

int zStorePNode::reloc() const {
  return 2;
}

int zStorePNullNode::reloc() const {
  return 3;
}

int g1StorePNode::reloc() const {
  return 2;
}

int g1StoreNNode::reloc() const {
  return 2;
}

int g1EncodePAndStoreNNode::reloc() const {
  return 2;
}

int g1LoadPNode::reloc() const {
  return 1;
}

int g1LoadNNode::reloc() const {
  return 1;
}


void MoveF2VLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3887 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    ShouldNotReachHere();
  
#line 19918 "ad_x86.cpp"
  }
}

void MoveF2LEGNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3897 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    ShouldNotReachHere();
  
#line 19932 "ad_x86.cpp"
  }
}

void MoveVL2FNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3907 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    ShouldNotReachHere();
  
#line 19946 "ad_x86.cpp"
  }
}

void MoveLEG2FNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3917 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    ShouldNotReachHere();
  
#line 19960 "ad_x86.cpp"
  }
}

void MoveD2VLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3927 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    ShouldNotReachHere();
  
#line 19974 "ad_x86.cpp"
  }
}

void MoveD2LEGNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3937 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    ShouldNotReachHere();
  
#line 19988 "ad_x86.cpp"
  }
}

void MoveVL2DNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3947 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    ShouldNotReachHere();
  
#line 20002 "ad_x86.cpp"
  }
}

void MoveLEG2DNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3957 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    ShouldNotReachHere();
  
#line 20016 "ad_x86.cpp"
  }
}

void loadBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3974 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movsbl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20030 "ad_x86.cpp"
  }
}

void loadB2LNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3989 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movsbq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20044 "ad_x86.cpp"
  }
}

void loadUBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4004 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movzbl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20058 "ad_x86.cpp"
  }
}

void loadUB2LNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4019 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movzbq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20072 "ad_x86.cpp"
  }
}

void loadUB2L_immINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 4033 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ movzbq(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ andl(Rdst, opnd_array(2)->constant()& right_n_bits(8));
  
#line 20089 "ad_x86.cpp"
  }
}

void loadSNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4049 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movswl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20103 "ad_x86.cpp"
  }
}

void loadS2BNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// twentyfour
  {

#line 4062 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movsbl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20118 "ad_x86.cpp"
  }
}

void loadS2LNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4076 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movswq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20132 "ad_x86.cpp"
  }
}

void loadUSNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4091 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movzwl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20146 "ad_x86.cpp"
  }
}

void loadUS2BNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// twentyfour
  {

#line 4104 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movsbl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20161 "ad_x86.cpp"
  }
}

void loadUS2LNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4118 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movzwq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20175 "ad_x86.cpp"
  }
}

void loadUS2L_immI_255Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 4130 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movzbq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20190 "ad_x86.cpp"
  }
}

void loadUS2L_immINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 4143 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ movzwq(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ andl(Rdst, opnd_array(2)->constant()& right_n_bits(16));
  
#line 20207 "ad_x86.cpp"
  }
}

void loadINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4159 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20221 "ad_x86.cpp"
  }
}

void loadI2BNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// twentyfour
  {

#line 4172 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movsbl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20236 "ad_x86.cpp"
  }
}

void loadI2UBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 4184 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movzbl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20251 "ad_x86.cpp"
  }
}

void loadI2SNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// sixteen
  {

#line 4196 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movswl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20266 "ad_x86.cpp"
  }
}

void loadI2USNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 4208 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movzwl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20281 "ad_x86.cpp"
  }
}

void loadI2LNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4222 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movslq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20295 "ad_x86.cpp"
  }
}

void loadI2L_immI_255Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 4234 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movzbq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20310 "ad_x86.cpp"
  }
}

void loadI2L_immI_65535Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 4245 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movzwq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20325 "ad_x86.cpp"
  }
}

void loadI2L_immU31Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 4258 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    __ movl(Rdst, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ andl(Rdst, opnd_array(2)->constant());
  
#line 20342 "ad_x86.cpp"
  }
}

void loadUI2LNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 4274 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20357 "ad_x86.cpp"
  }
}

void loadLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4289 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20371 "ad_x86.cpp"
  }
}

void loadRangeNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4303 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20385 "ad_x86.cpp"
  }
}

void loadPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4317 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20399 "ad_x86.cpp"
  }
}

void loadNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4331 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

     __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
   
#line 20413 "ad_x86.cpp"
  }
}

void loadKlassNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4345 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20427 "ad_x86.cpp"
  }
}

void loadNKlassNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4359 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20441 "ad_x86.cpp"
  }
}

void loadNKlassCompactHeadersNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4375 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ shrl(opnd_array(0)->as_Register(ra_,this)/* dst */, markWord::klass_shift_at_offset);
  
#line 20456 "ad_x86.cpp"
  }
}

void loadFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4389 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movflt(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20470 "ad_x86.cpp"
  }
}

void loadD_partialNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4403 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movdbl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20484 "ad_x86.cpp"
  }
}

void loadDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4416 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movdbl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20498 "ad_x86.cpp"
  }
}

void maxF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// a
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// b
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// atmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// btmp
  {

#line 4428 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ vminmax_fp(Op_MaxV, T_FLOAT, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* a */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* b */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* atmp */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* btmp */, Assembler::AVX_128bit);
  
#line 20516 "ad_x86.cpp"
  }
}

void maxF_reduction_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// a
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// b
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rtmp
  {

#line 4440 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    emit_fp_min_max(masm, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* a */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* b */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp */, opnd_array(4)->as_Register(ra_,this,idx4)/* rtmp */,
                    false /*min*/, true /*single*/);
  
#line 20534 "ad_x86.cpp"
  }
}

void maxD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// a
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// b
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// atmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// btmp
  {

#line 4453 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ vminmax_fp(Op_MaxV, T_DOUBLE, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* a */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* b */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* atmp */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* btmp */, Assembler::AVX_128bit);
  
#line 20552 "ad_x86.cpp"
  }
}

void maxD_reduction_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// a
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// b
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rtmp
  {

#line 4465 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    emit_fp_min_max(masm, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* a */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* b */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp */, opnd_array(4)->as_Register(ra_,this,idx4)/* rtmp */,
                    false /*min*/, false /*single*/);
  
#line 20570 "ad_x86.cpp"
  }
}

void minF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// a
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// b
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// atmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// btmp
  {

#line 4478 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ vminmax_fp(Op_MinV, T_FLOAT, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* a */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* b */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* atmp */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* btmp */, Assembler::AVX_128bit);
  
#line 20588 "ad_x86.cpp"
  }
}

void minF_reduction_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// a
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// b
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rtmp
  {

#line 4490 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    emit_fp_min_max(masm, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* a */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* b */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp */, opnd_array(4)->as_Register(ra_,this,idx4)/* rtmp */,
                    true /*min*/, true /*single*/);
  
#line 20606 "ad_x86.cpp"
  }
}

void minD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// a
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// b
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// atmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// btmp
  {

#line 4503 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ vminmax_fp(Op_MinV, T_DOUBLE, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* a */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* b */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* atmp */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* btmp */, Assembler::AVX_128bit);
  
#line 20624 "ad_x86.cpp"
  }
}

void minD_reduction_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// a
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// b
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rtmp
  {

#line 4515 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    emit_fp_min_max(masm, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* a */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* b */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp */, opnd_array(4)->as_Register(ra_,this,idx4)/* rtmp */,
                    true /*min*/, false /*single*/);
  
#line 20642 "ad_x86.cpp"
  }
}

void leaP8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4529 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20656 "ad_x86.cpp"
  }
}

void leaP32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4541 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20670 "ad_x86.cpp"
  }
}

void leaPIdxOffNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4553 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20684 "ad_x86.cpp"
  }
}

void leaPIdxScaleNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4565 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20698 "ad_x86.cpp"
  }
}

void leaPPosIdxScaleNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4577 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20712 "ad_x86.cpp"
  }
}

void leaPIdxScaleOffNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4589 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20726 "ad_x86.cpp"
  }
}

void leaPPosIdxOffNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4601 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20740 "ad_x86.cpp"
  }
}

void leaPPosIdxScaleOffNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4613 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20754 "ad_x86.cpp"
  }
}

void leaPCompressedOopOffsetNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4627 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20768 "ad_x86.cpp"
  }
}

void leaP8NarrowNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4640 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20782 "ad_x86.cpp"
  }
}

void leaP32NarrowNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4653 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20796 "ad_x86.cpp"
  }
}

void leaPIdxOffNarrowNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4666 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20810 "ad_x86.cpp"
  }
}

void leaPIdxScaleNarrowNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4679 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20824 "ad_x86.cpp"
  }
}

void leaPIdxScaleOffNarrowNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4692 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20838 "ad_x86.cpp"
  }
}

void leaPPosIdxOffNarrowNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4705 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20852 "ad_x86.cpp"
  }
}

void leaPPosIdxScaleOffNarrowNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4718 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 20866 "ad_x86.cpp"
  }
}

void loadConINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4729 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->constant());
  
#line 20880 "ad_x86.cpp"
  }
}

void loadConI0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4742 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 20894 "ad_x86.cpp"
  }
}

void loadConLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4754 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ mov64(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->constantL());
  
#line 20908 "ad_x86.cpp"
  }
}

void loadConL0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4767 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 20922 "ad_x86.cpp"
  }
}

void loadConUL32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4779 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->constantL());
  
#line 20936 "ad_x86.cpp"
  }
}

void loadConL32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4791 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->constantL());
  
#line 20950 "ad_x86.cpp"
  }
}

void loadConPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 4801 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ mov64(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->constant(), opnd_array(1)->constant_reloc(), RELOC_IMM64);
  
#line 20964 "ad_x86.cpp"
  }
}

void loadConP0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4814 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 20978 "ad_x86.cpp"
  }
}

void loadConP31Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4827 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->constant());
  
#line 20992 "ad_x86.cpp"
  }
}

void loadConFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 4837 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movflt(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 21006 "ad_x86.cpp"
  }
}

void loadConFNode::eval_constant(Compile* C) {
  {

#line 4838 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(1));
#line 21015 "ad_x86.cpp"
  }
}
void loadConN0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4847 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 21028 "ad_x86.cpp"
  }
}

void loadConNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4858 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    address con = (address)opnd_array(1)->constant();
    if (con == nullptr) {
      ShouldNotReachHere();
    } else {
      __ set_narrow_oop(opnd_array(0)->as_Register(ra_,this)/* dst */, (jobject)opnd_array(1)->constant());
    }
  
#line 21047 "ad_x86.cpp"
  }
}

void loadConNKlassNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4874 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    address con = (address)opnd_array(1)->constant();
    if (con == nullptr) {
      ShouldNotReachHere();
    } else {
      __ set_narrow_klass(opnd_array(0)->as_Register(ra_,this)/* dst */, (Klass*)opnd_array(1)->constant());
    }
  
#line 21066 "ad_x86.cpp"
  }
}

void loadConF0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4891 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 21080 "ad_x86.cpp"
  }
}

void loadConDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 4902 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movdbl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 21094 "ad_x86.cpp"
  }
}

void loadConDNode::eval_constant(Compile* C) {
  {

#line 4903 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(1));
#line 21103 "ad_x86.cpp"
  }
}
void loadConD0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4914 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 21116 "ad_x86.cpp"
  }
}

void loadSSINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4926 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 21130 "ad_x86.cpp"
  }
}

void loadSSLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4938 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 21144 "ad_x86.cpp"
  }
}

void loadSSPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4950 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 21158 "ad_x86.cpp"
  }
}

void loadSSFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4962 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movflt(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address(rsp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 21172 "ad_x86.cpp"
  }
}

void loadSSDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4975 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movdbl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address(rsp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 21186 "ad_x86.cpp"
  }
}

void prefetchAllocNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {

#line 4990 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ prefetchw(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 21200 "ad_x86.cpp"
  }
}

void prefetchAllocNTANode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {

#line 5002 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ prefetchnta(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 21214 "ad_x86.cpp"
  }
}

void prefetchAllocT0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {

#line 5014 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ prefetcht0(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 21228 "ad_x86.cpp"
  }
}

void prefetchAllocT2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {

#line 5026 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ prefetcht2(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 21242 "ad_x86.cpp"
  }
}

void storeBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5041 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movb(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 21257 "ad_x86.cpp"
  }
}

void storeCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5054 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movw(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 21272 "ad_x86.cpp"
  }
}

void storeINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5067 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 21287 "ad_x86.cpp"
  }
}

void storeLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5080 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 21302 "ad_x86.cpp"
  }
}

void storePNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5094 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 21317 "ad_x86.cpp"
  }
}

void storeImmP0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 5107 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), r12);
  
#line 21332 "ad_x86.cpp"
  }
}

void storeImmPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5121 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
  
#line 21347 "ad_x86.cpp"
  }
}

void storeNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5135 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 21362 "ad_x86.cpp"
  }
}

void storeNKlassNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5147 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 21377 "ad_x86.cpp"
  }
}

void storeImmN0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 5160 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), r12);
  
#line 21392 "ad_x86.cpp"
  }
}

void storeImmNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5173 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    address con = (address)opnd_array(2)->constant();
    if (con == nullptr) {
      __ movl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), 0);
    } else {
      __ set_narrow_oop(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), (jobject)opnd_array(2)->constant());
    }
  
#line 21412 "ad_x86.cpp"
  }
}

void storeImmNKlassNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5190 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ set_narrow_klass(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), (Klass*)opnd_array(2)->constant());
  
#line 21427 "ad_x86.cpp"
  }
}

void storeImmI0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 5204 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), r12);
  
#line 21442 "ad_x86.cpp"
  }
}

void storeImmINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5216 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
  
#line 21457 "ad_x86.cpp"
  }
}

void storeImmL0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 5230 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), r12);
  
#line 21472 "ad_x86.cpp"
  }
}

void storeImmLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5242 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constantL());
  
#line 21487 "ad_x86.cpp"
  }
}

void storeImmC0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 5256 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movw(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), r12);
  
#line 21502 "ad_x86.cpp"
  }
}

void storeImmI16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5269 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movw(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
  
#line 21517 "ad_x86.cpp"
  }
}

void storeImmB0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 5283 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movb(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), r12);
  
#line 21532 "ad_x86.cpp"
  }
}

void storeImmBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5295 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movb(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
  
#line 21547 "ad_x86.cpp"
  }
}

void storeFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5308 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movflt(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 21562 "ad_x86.cpp"
  }
}

void storeF0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 5322 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), r12);
  
#line 21577 "ad_x86.cpp"
  }
}

void storeF_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5334 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), jint_cast(opnd_array(2)->constantF()));
  
#line 21592 "ad_x86.cpp"
  }
}

void storeDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5347 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movdbl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 21607 "ad_x86.cpp"
  }
}

void storeD0_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5361 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constantD());
  
#line 21622 "ad_x86.cpp"
  }
}

void storeD0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 5374 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), r12);
  
#line 21637 "ad_x86.cpp"
  }
}

void storeSSINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5386 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(Address::make_raw(opnd_array(0)->base(ra_,this,idx0), opnd_array(0)->index(ra_,this,idx0), opnd_array(0)->scale(), opnd_array(0)->disp(ra_,this,0), opnd_array(0)->disp_reloc()), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21651 "ad_x86.cpp"
  }
}

void storeSSLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5398 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movq(Address::make_raw(opnd_array(0)->base(ra_,this,idx0), opnd_array(0)->index(ra_,this,idx0), opnd_array(0)->scale(), opnd_array(0)->disp(ra_,this,0), opnd_array(0)->disp_reloc()), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21665 "ad_x86.cpp"
  }
}

void storeSSPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5410 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movq(Address::make_raw(opnd_array(0)->base(ra_,this,idx0), opnd_array(0)->index(ra_,this,idx0), opnd_array(0)->scale(), opnd_array(0)->disp(ra_,this,0), opnd_array(0)->disp_reloc()), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21679 "ad_x86.cpp"
  }
}

void storeSSFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5422 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movflt(Address(rsp, opnd_array(0)->disp(ra_,this,0)), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
  
#line 21693 "ad_x86.cpp"
  }
}

void storeSSDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5434 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movdbl(Address(rsp, opnd_array(0)->disp(ra_,this,0)), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
  
#line 21707 "ad_x86.cpp"
  }
}

void cacheWBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {

#line 5447 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    assert(opnd_array(1)->index_position() < 0, "should be");
    assert(opnd_array(1)->disp(ra_,this,idx1)== 0, "should be");
    __ cache_wb(Address(as_Register(opnd_array(1)->base(ra_,this,idx1)), 0));
  
#line 21723 "ad_x86.cpp"
  }
}

void cacheWBPreSyncNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {

#line 5462 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cache_wbsync(true);
  
#line 21737 "ad_x86.cpp"
  }
}

void cacheWBPostSyncNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// 
  {

#line 5475 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cache_wbsync(false);
  
#line 21751 "ad_x86.cpp"
  }
}

void bytes_reverse_intNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 5486 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ bswapl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 21765 "ad_x86.cpp"
  }
}

void bytes_reverse_longNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 5496 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ bswapq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 21779 "ad_x86.cpp"
  }
}

void bytes_reverse_unsigned_shortNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 5508 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ bswapl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
    __ shrl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, 16);
  
#line 21794 "ad_x86.cpp"
  }
}

void bytes_reverse_shortNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 5521 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ bswapl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
    __ sarl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, 16);
  
#line 21809 "ad_x86.cpp"
  }
}

void countLeadingZerosINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5536 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lzcntl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21823 "ad_x86.cpp"
  }
}

void countLeadingZerosI_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  {

#line 5548 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lzcntl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 21837 "ad_x86.cpp"
  }
}

void countLeadingZerosI_bsrNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5565 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register Rsrc = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Label skip;
    __ bsrl(Rdst, Rsrc);
    __ jccb(Assembler::notZero, skip);
    __ movl(Rdst, -1);
    __ bind(skip);
    __ negl(Rdst);
    __ addl(Rdst, BitsPerInt - 1);
  
#line 21859 "ad_x86.cpp"
  }
}

void countLeadingZerosLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5585 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lzcntq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21873 "ad_x86.cpp"
  }
}

void countLeadingZerosL_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  {

#line 5597 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lzcntq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 21887 "ad_x86.cpp"
  }
}

void countLeadingZerosL_bsrNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5614 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register Rsrc = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Label skip;
    __ bsrq(Rdst, Rsrc);
    __ jccb(Assembler::notZero, skip);
    __ movl(Rdst, -1);
    __ bind(skip);
    __ negl(Rdst);
    __ addl(Rdst, BitsPerLong - 1);
  
#line 21909 "ad_x86.cpp"
  }
}

void countTrailingZerosINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5634 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ tzcntl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21923 "ad_x86.cpp"
  }
}

void countTrailingZerosI_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  {

#line 5646 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ tzcntl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 21937 "ad_x86.cpp"
  }
}

void countTrailingZerosI_bsfNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5661 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Label done;
    __ bsfl(Rdst, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ jccb(Assembler::notZero, done);
    __ movl(Rdst, BitsPerInt);
    __ bind(done);
  
#line 21956 "ad_x86.cpp"
  }
}

void countTrailingZerosLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5678 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ tzcntq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 21970 "ad_x86.cpp"
  }
}

void countTrailingZerosL_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  {

#line 5690 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ tzcntq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 21984 "ad_x86.cpp"
  }
}

void countTrailingZerosL_bsfNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5705 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Register Rdst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Label done;
    __ bsfq(Rdst, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ jccb(Assembler::notZero, done);
    __ movl(Rdst, BitsPerLong);
    __ bind(done);
  
#line 22003 "ad_x86.cpp"
  }
}

void bytes_reversebit_intNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rtmp
  {

#line 5722 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ reverseI(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, xnoreg, xnoreg, opnd_array(3)->as_Register(ra_,this,idx3)/* rtmp */);
  
#line 22019 "ad_x86.cpp"
  }
}

void bytes_reversebit_int_gfniNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// rtmp
  {

#line 5733 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ reverseI(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* rtmp */);
  
#line 22037 "ad_x86.cpp"
  }
}

void bytes_reversebit_longNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rtmp2
  {

#line 5744 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ reverseL(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, xnoreg, xnoreg, opnd_array(3)->as_Register(ra_,this,idx3)/* rtmp1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* rtmp2 */);
  
#line 22054 "ad_x86.cpp"
  }
}

void bytes_reversebit_long_gfniNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// rtmp
  {

#line 5755 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ reverseL(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* rtmp */, noreg);
  
#line 22072 "ad_x86.cpp"
  }
}

void popCountINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5769 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ popcntl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 22086 "ad_x86.cpp"
  }
}

void popCountI_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 5781 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ popcntl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 22100 "ad_x86.cpp"
  }
}

void popCountLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5794 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ popcntq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 22114 "ad_x86.cpp"
  }
}

void popCountL_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 5807 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ popcntq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 22128 "ad_x86.cpp"
  }
}

void membar_acquireNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_acquireNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_acquire_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_acquire_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_acquire_lockNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_acquire_lockNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_releaseNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_releaseNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_release_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_release_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_release_lockNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_release_lockNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_volatileNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 5872 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ membar(Assembler::StoreLoad);
  
#line 22214 "ad_x86.cpp"
  }
}

void unnecessary_membar_volatileNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint unnecessary_membar_volatileNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_storestoreNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_storestoreNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void membar_storestore_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint membar_storestore_0Node::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castX2PNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5908 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    if (opnd_array(0)->reg(ra_,this)/* dst */!= opnd_array(1)->reg(ra_,this,idx1)/* src */) {
      __ movptr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    }
  
#line 22266 "ad_x86.cpp"
  }
}

void castP2XNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5921 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    if (opnd_array(0)->reg(ra_,this)/* dst */!= opnd_array(1)->reg(ra_,this,idx1)/* src */) {
      __ movptr(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    }
  
#line 22282 "ad_x86.cpp"
  }
}

void convP2INode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5935 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 22296 "ad_x86.cpp"
  }
}

void convN2INode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5949 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 22310 "ad_x86.cpp"
  }
}

void encodeHeapOopNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5961 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    if (s != d) {
      __ movq(d, s);
    }
    __ encode_heap_oop(d);
  
#line 22329 "ad_x86.cpp"
  }
}

void encodeHeapOop_not_nullNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5977 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ encode_heap_oop_not_null(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 22343 "ad_x86.cpp"
  }
}

void decodeHeapOopNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 5989 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    if (s != d) {
      __ movq(d, s);
    }
    __ decode_heap_oop(d);
  
#line 22362 "ad_x86.cpp"
  }
}

void decodeHeapOop_not_nullNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 6006 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Register s = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    Register d = opnd_array(0)->as_Register(ra_,this)/* dst */;
    if (s != d) {
      __ decode_heap_oop_not_null(d, s);
    } else {
      __ decode_heap_oop_not_null(d);
    }
  
#line 22382 "ad_x86.cpp"
  }
}

void encodeKlass_not_nullNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 6022 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ encode_and_move_klass_not_null(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 22397 "ad_x86.cpp"
  }
}

void decodeKlass_not_nullNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 6032 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ decode_and_move_klass_not_null(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 22412 "ad_x86.cpp"
  }
}

void jumpXtnd_offsetNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  ra_->C->output()->constant_table().fill_jump_table(masm, (MachConstantNode*) this, _index2label);
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// shift
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dest
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 6049 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    // We could use jump(ArrayAddress) except that the macro assembler needs to use r10
    // to do that and the compiler is using that register as one it can allocate.
    // So we build it all by hand.
    // Address index(noreg, switch_reg, (Address::ScaleFactor)$shift$$constant);
    // ArrayAddress dispatch(table, index);
    Address dispatch(opnd_array(3)->as_Register(ra_,this,idx3)/* dest */, opnd_array(1)->as_Register(ra_,this,idx1)/* switch_val */, (Address::ScaleFactor) opnd_array(2)->constant());
    __ lea(opnd_array(3)->as_Register(ra_,this,idx3)/* dest */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ jmp(dispatch);
  
#line 22436 "ad_x86.cpp"
  }
}

void jumpXtnd_offsetNode::eval_constant(Compile* C) {
  _constant = C->output()->constant_table().add_jump_table(this);
  // User did not define an encode section.
}
void jumpXtnd_addrNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  ra_->C->output()->constant_table().fill_jump_table(masm, (MachConstantNode*) this, _index2label);
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// shift
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// offset
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dest
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// 
  {

#line 6069 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    // We could use jump(ArrayAddress) except that the macro assembler needs to use r10
    // to do that and the compiler is using that register as one it can allocate.
    // So we build it all by hand.
    // Address index(noreg, switch_reg, (Address::ScaleFactor) $shift$$constant, (int) $offset$$constant);
    // ArrayAddress dispatch(table, index);
    Address dispatch(opnd_array(4)->as_Register(ra_,this,idx4)/* dest */, opnd_array(1)->as_Register(ra_,this,idx1)/* switch_val */, (Address::ScaleFactor) opnd_array(2)->constant(), (int) opnd_array(3)->constantL());
    __ lea(opnd_array(4)->as_Register(ra_,this,idx4)/* dest */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ jmp(dispatch);
  
#line 22465 "ad_x86.cpp"
  }
}

void jumpXtnd_addrNode::eval_constant(Compile* C) {
  _constant = C->output()->constant_table().add_jump_table(this);
  // User did not define an encode section.
}
void jumpXtndNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  ra_->C->output()->constant_table().fill_jump_table(masm, (MachConstantNode*) this, _index2label);
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dest
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {

#line 6089 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    // We could use jump(ArrayAddress) except that the macro assembler needs to use r10
    // to do that and the compiler is using that register as one it can allocate.
    // So we build it all by hand.
    // Address index(noreg, switch_reg, Address::times_1);
    // ArrayAddress dispatch(table, index);
    Address dispatch(opnd_array(2)->as_Register(ra_,this,idx2)/* dest */, opnd_array(1)->as_Register(ra_,this,idx1)/* switch_val */, Address::times_1);
    __ lea(opnd_array(2)->as_Register(ra_,this,idx2)/* dest */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    __ jmp(dispatch);
  
#line 22492 "ad_x86.cpp"
  }
}

void jumpXtndNode::eval_constant(Compile* C) {
  _constant = C->output()->constant_table().add_jump_table(this);
  // User did not define an encode section.
}
void cmovI_imm_01Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {

#line 6110 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Assembler::Condition cond = (Assembler::Condition)(opnd_array(1)->ccode());
    __ setb(MacroAssembler::negate_condition(cond), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */);
  
#line 22514 "ad_x86.cpp"
  }
}

void cmovI_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 6123 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovl((Assembler::Condition)(opnd_array(1)->ccode()), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* src */);
  
#line 22531 "ad_x86.cpp"
  }
}

void cmovI_imm_01UNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {

#line 6136 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Assembler::Condition cond = (Assembler::Condition)(opnd_array(1)->ccode());
    __ setb(MacroAssembler::negate_condition(cond), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */);
  
#line 22549 "ad_x86.cpp"
  }
}

void cmovI_regUNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 6148 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovl((Assembler::Condition)(opnd_array(1)->ccode()), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* src */);
  
#line 22566 "ad_x86.cpp"
  }
}

void cmovI_imm_01UCFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {

#line 6161 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Assembler::Condition cond = (Assembler::Condition)(opnd_array(1)->ccode());
    __ setb(MacroAssembler::negate_condition(cond), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */);
  
#line 22584 "ad_x86.cpp"
  }
}

void cmovI_regUCF2_neNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 6183 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovl(Assembler::parity, opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* src */);
    __ cmovl(Assembler::notEqual, opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* src */);
  
#line 22602 "ad_x86.cpp"
  }
}

void cmovI_regUCF2_eqNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {

#line 6199 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovl(Assembler::parity, opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* src */);
    __ cmovl(Assembler::notEqual, opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* src */);
  
#line 22620 "ad_x86.cpp"
  }
}

void cmovI_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 6212 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovl((Assembler::Condition)(opnd_array(1)->ccode()), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, Address::make_raw(opnd_array(4)->base(ra_,this,idx4), opnd_array(4)->index(ra_,this,idx4), opnd_array(4)->scale(), opnd_array(4)->disp(ra_,this,idx4), opnd_array(4)->disp_reloc()));
  
#line 22637 "ad_x86.cpp"
  }
}

void cmovI_memUNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 6225 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovl((Assembler::Condition)(opnd_array(1)->ccode()), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, Address::make_raw(opnd_array(4)->base(ra_,this,idx4), opnd_array(4)->index(ra_,this,idx4), opnd_array(4)->scale(), opnd_array(4)->disp(ra_,this,idx4), opnd_array(4)->disp_reloc()));
  
#line 22654 "ad_x86.cpp"
  }
}

void cmovN_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 6246 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovl((Assembler::Condition)(opnd_array(1)->ccode()), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* src */);
  
#line 22671 "ad_x86.cpp"
  }
}

void cmovN_regUNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 6259 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovl((Assembler::Condition)(opnd_array(1)->ccode()), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* src */);
  
#line 22688 "ad_x86.cpp"
  }
}

void cmovN_regUCF2_neNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 6280 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovl(Assembler::parity, opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* src */);
    __ cmovl(Assembler::notEqual, opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* src */);
  
#line 22706 "ad_x86.cpp"
  }
}

void cmovN_regUCF2_eqNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {

#line 6296 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovl(Assembler::parity, opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* src */);
    __ cmovl(Assembler::notEqual, opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* src */);
  
#line 22724 "ad_x86.cpp"
  }
}

void cmovP_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 6310 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovq((Assembler::Condition)(opnd_array(1)->ccode()), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* src */);
  
#line 22741 "ad_x86.cpp"
  }
}

void cmovP_regUNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 6323 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovq((Assembler::Condition)(opnd_array(1)->ccode()), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* src */);
  
#line 22758 "ad_x86.cpp"
  }
}

void cmovP_regUCF2_neNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 6344 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovq(Assembler::parity, opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* src */);
    __ cmovq(Assembler::notEqual, opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* src */);
  
#line 22776 "ad_x86.cpp"
  }
}

void cmovP_regUCF2_eqNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {

#line 6360 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovq(Assembler::parity, opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* src */);
    __ cmovq(Assembler::notEqual, opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* src */);
  
#line 22794 "ad_x86.cpp"
  }
}

void cmovL_imm_01Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {

#line 6374 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Assembler::Condition cond = (Assembler::Condition)(opnd_array(1)->ccode());
    __ setb(MacroAssembler::negate_condition(cond), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */);
  
#line 22812 "ad_x86.cpp"
  }
}

void cmovL_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 6387 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovq((Assembler::Condition)(opnd_array(1)->ccode()), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* src */);
  
#line 22829 "ad_x86.cpp"
  }
}

void cmovL_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 6399 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovq((Assembler::Condition)(opnd_array(1)->ccode()), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, Address::make_raw(opnd_array(4)->base(ra_,this,idx4), opnd_array(4)->index(ra_,this,idx4), opnd_array(4)->scale(), opnd_array(4)->disp(ra_,this,idx4), opnd_array(4)->disp_reloc()));
  
#line 22846 "ad_x86.cpp"
  }
}

void cmovL_imm_01UNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {

#line 6412 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Assembler::Condition cond = (Assembler::Condition)(opnd_array(1)->ccode());
    __ setb(MacroAssembler::negate_condition(cond), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */);
  
#line 22864 "ad_x86.cpp"
  }
}

void cmovL_regUNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 6425 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovq((Assembler::Condition)(opnd_array(1)->ccode()), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* src */);
  
#line 22881 "ad_x86.cpp"
  }
}

void cmovL_imm_01UCFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {

#line 6438 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Assembler::Condition cond = (Assembler::Condition)(opnd_array(1)->ccode());
    __ setb(MacroAssembler::negate_condition(cond), opnd_array(4)->as_Register(ra_,this,idx4)/* dst */);
  
#line 22899 "ad_x86.cpp"
  }
}

void cmovL_regUCF2_neNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 6460 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovq(Assembler::parity, opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* src */);
    __ cmovq(Assembler::notEqual, opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* src */);
  
#line 22917 "ad_x86.cpp"
  }
}

void cmovL_regUCF2_eqNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  {

#line 6476 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovq(Assembler::parity, opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* src */);
    __ cmovq(Assembler::notEqual, opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* src */);
  
#line 22935 "ad_x86.cpp"
  }
}

void cmovL_memUNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 6489 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovq((Assembler::Condition)(opnd_array(1)->ccode()), opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, Address::make_raw(opnd_array(4)->base(ra_,this,idx4), opnd_array(4)->index(ra_,this,idx4), opnd_array(4)->scale(), opnd_array(4)->disp(ra_,this,idx4), opnd_array(4)->disp_reloc()));
  
#line 22952 "ad_x86.cpp"
  }
}

void cmovF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 6511 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Label Lskip;
    // Invert sense of branch from sense of CMOV
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()^1), Lskip);
    __ movflt(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* src */);
    __ bind(Lskip);
  
#line 22973 "ad_x86.cpp"
  }
}

void cmovF_regUNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 6529 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Label Lskip;
    // Invert sense of branch from sense of CMOV
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()^1), Lskip);
    __ movflt(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* src */);
    __ bind(Lskip);
  
#line 22994 "ad_x86.cpp"
  }
}

void cmovD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 6555 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Label Lskip;
    // Invert sense of branch from sense of CMOV
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()^1), Lskip);
    __ movdbl(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* src */);
    __ bind(Lskip);
  
#line 23015 "ad_x86.cpp"
  }
}

void cmovD_regUNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// src
  {

#line 6573 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Label Lskip;
    // Invert sense of branch from sense of CMOV
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()^1), Lskip);
    __ movdbl(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* src */);
    __ bind(Lskip);
  
#line 23036 "ad_x86.cpp"
  }
}

void addI_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6600 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ addl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 23051 "ad_x86.cpp"
  }
}

void addI_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6613 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ addl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constant());
  
#line 23066 "ad_x86.cpp"
  }
}

void addI_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6627 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ addl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 23081 "ad_x86.cpp"
  }
}

void addI_rReg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 6627 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ addl(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 23096 "ad_x86.cpp"
  }
}

void addI_mem_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6641 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ addl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 23111 "ad_x86.cpp"
  }
}

void addI_mem_rReg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6641 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ addl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 23126 "ad_x86.cpp"
  }
}

void addI_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6656 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ addl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
  
#line 23141 "ad_x86.cpp"
  }
}

void incI_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6669 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ incrementl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 23156 "ad_x86.cpp"
  }
}

void incI_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6683 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ incrementl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 23171 "ad_x86.cpp"
  }
}

void decI_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6697 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ decrementl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 23186 "ad_x86.cpp"
  }
}

void decI_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6712 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ decrementl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 23201 "ad_x86.cpp"
  }
}

void leaI_rReg_immI2_immINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// index
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// scale
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// disp
  {

#line 6724 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Address::ScaleFactor scale = static_cast<Address::ScaleFactor>(opnd_array(2)->constant());
    __ leal(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(noreg, opnd_array(1)->as_Register(ra_,this,idx1)/* index */, scale, opnd_array(3)->constant()));
  
#line 23218 "ad_x86.cpp"
  }
}

void leaI_rReg_rReg_immINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// base
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// index
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// disp
  {

#line 6737 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ leal(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* base */, opnd_array(2)->as_Register(ra_,this,idx2)/* index */, Address::times_1, opnd_array(3)->constant()));
  
#line 23234 "ad_x86.cpp"
  }
}

void leaI_rReg_rReg_immI2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// base
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// index
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// scale
  {

#line 6749 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Address::ScaleFactor scale = static_cast<Address::ScaleFactor>(opnd_array(3)->constant());
    __ leal(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* base */, opnd_array(2)->as_Register(ra_,this,idx2)/* index */, scale));
  
#line 23251 "ad_x86.cpp"
  }
}

void leaI_rReg_rReg_immI2_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// index
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// scale
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// base
  {

#line 6749 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Address::ScaleFactor scale = static_cast<Address::ScaleFactor>(opnd_array(2)->constant());
    __ leal(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(opnd_array(3)->as_Register(ra_,this,idx3)/* base */, opnd_array(1)->as_Register(ra_,this,idx1)/* index */, scale));
  
#line 23268 "ad_x86.cpp"
  }
}

void leaI_rReg_rReg_immI2_immINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// base
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// index
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// scale
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// disp
  {

#line 6762 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Address::ScaleFactor scale = static_cast<Address::ScaleFactor>(opnd_array(3)->constant());
    __ leal(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* base */, opnd_array(2)->as_Register(ra_,this,idx2)/* index */, scale, opnd_array(4)->constant()));
  
#line 23286 "ad_x86.cpp"
  }
}

void leaI_rReg_rReg_immI2_immI_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// index
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// scale
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// base
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// disp
  {

#line 6762 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Address::ScaleFactor scale = static_cast<Address::ScaleFactor>(opnd_array(2)->constant());
    __ leal(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(opnd_array(3)->as_Register(ra_,this,idx3)/* base */, opnd_array(1)->as_Register(ra_,this,idx1)/* index */, scale, opnd_array(4)->constant()));
  
#line 23304 "ad_x86.cpp"
  }
}

void addL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6776 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ addq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 23319 "ad_x86.cpp"
  }
}

void addL_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6789 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ addq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constantL());
  
#line 23334 "ad_x86.cpp"
  }
}

void addL_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6803 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ addq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 23349 "ad_x86.cpp"
  }
}

void addL_rReg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 6803 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ addq(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 23364 "ad_x86.cpp"
  }
}

void addL_mem_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6817 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ addq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 23379 "ad_x86.cpp"
  }
}

void addL_mem_rReg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6817 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ addq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 23394 "ad_x86.cpp"
  }
}

void addL_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6831 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ addq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constantL());
  
#line 23409 "ad_x86.cpp"
  }
}

void incL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6844 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ incrementq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 23424 "ad_x86.cpp"
  }
}

void incL_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6858 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ incrementq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 23439 "ad_x86.cpp"
  }
}

void decL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6872 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ decrementq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 23454 "ad_x86.cpp"
  }
}

void decL_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6887 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ decrementq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 23469 "ad_x86.cpp"
  }
}

void leaL_rReg_immI2_immL32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// index
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// scale
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// disp
  {

#line 6899 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Address::ScaleFactor scale = static_cast<Address::ScaleFactor>(opnd_array(2)->constant());
    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(noreg, opnd_array(1)->as_Register(ra_,this,idx1)/* index */, scale, opnd_array(3)->constantL()));
  
#line 23486 "ad_x86.cpp"
  }
}

void leaL_rReg_rReg_immL32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// base
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// index
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// disp
  {

#line 6912 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* base */, opnd_array(2)->as_Register(ra_,this,idx2)/* index */, Address::times_1, opnd_array(3)->constantL()));
  
#line 23502 "ad_x86.cpp"
  }
}

void leaL_rReg_rReg_immI2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// base
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// index
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// scale
  {

#line 6924 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Address::ScaleFactor scale = static_cast<Address::ScaleFactor>(opnd_array(3)->constant());
    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* base */, opnd_array(2)->as_Register(ra_,this,idx2)/* index */, scale));
  
#line 23519 "ad_x86.cpp"
  }
}

void leaL_rReg_rReg_immI2_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// index
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// scale
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// base
  {

#line 6924 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Address::ScaleFactor scale = static_cast<Address::ScaleFactor>(opnd_array(2)->constant());
    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(opnd_array(3)->as_Register(ra_,this,idx3)/* base */, opnd_array(1)->as_Register(ra_,this,idx1)/* index */, scale));
  
#line 23536 "ad_x86.cpp"
  }
}

void leaL_rReg_rReg_immI2_immL32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// base
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// index
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// scale
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// disp
  {

#line 6937 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Address::ScaleFactor scale = static_cast<Address::ScaleFactor>(opnd_array(3)->constant());
    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* base */, opnd_array(2)->as_Register(ra_,this,idx2)/* index */, scale, opnd_array(4)->constantL()));
  
#line 23554 "ad_x86.cpp"
  }
}

void leaL_rReg_rReg_immI2_immL32_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// index
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// scale
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// base
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// disp
  {

#line 6937 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Address::ScaleFactor scale = static_cast<Address::ScaleFactor>(opnd_array(2)->constant());
    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(opnd_array(3)->as_Register(ra_,this,idx3)/* base */, opnd_array(1)->as_Register(ra_,this,idx1)/* index */, scale, opnd_array(4)->constantL()));
  
#line 23572 "ad_x86.cpp"
  }
}

void addP_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6951 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ addq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 23587 "ad_x86.cpp"
  }
}

void addP_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6964 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ addq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constantL());
  
#line 23602 "ad_x86.cpp"
  }
}

void checkCastPPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint checkCastPPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castPPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castPPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castIINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castIINode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castLLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castLLNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castFFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castFFNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castDDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castDDNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void compareAndSwapPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 7050 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ cmpxchgq(opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ setcc(Assembler::equal, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 23692 "ad_x86.cpp"
  }
}

void compareAndSwapP_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 7050 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ cmpxchgq(opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ setcc(Assembler::equal, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 23710 "ad_x86.cpp"
  }
}

void compareAndSwapLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 7070 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ cmpxchgq(opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ setcc(Assembler::equal, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 23728 "ad_x86.cpp"
  }
}

void compareAndSwapL_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 7070 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ cmpxchgq(opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ setcc(Assembler::equal, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 23746 "ad_x86.cpp"
  }
}

void compareAndSwapINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 7090 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ cmpxchgl(opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ setcc(Assembler::equal, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 23764 "ad_x86.cpp"
  }
}

void compareAndSwapI_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 7090 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ cmpxchgl(opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ setcc(Assembler::equal, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 23782 "ad_x86.cpp"
  }
}

void compareAndSwapBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 7110 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ cmpxchgb(opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ setcc(Assembler::equal, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 23800 "ad_x86.cpp"
  }
}

void compareAndSwapB_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 7110 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ cmpxchgb(opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ setcc(Assembler::equal, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 23818 "ad_x86.cpp"
  }
}

void compareAndSwapSNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 7130 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ cmpxchgw(opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ setcc(Assembler::equal, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 23836 "ad_x86.cpp"
  }
}

void compareAndSwapS_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 7130 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ cmpxchgw(opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ setcc(Assembler::equal, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 23854 "ad_x86.cpp"
  }
}

void compareAndSwapNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 7150 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ cmpxchgl(opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ setcc(Assembler::equal, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 23872 "ad_x86.cpp"
  }
}

void compareAndSwapN_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 7150 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ cmpxchgl(opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ setcc(Assembler::equal, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 23890 "ad_x86.cpp"
  }
}

void compareAndExchangeBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 7168 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ cmpxchgb(opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 23907 "ad_x86.cpp"
  }
}

void compareAndExchangeSNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 7185 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ cmpxchgw(opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 23924 "ad_x86.cpp"
  }
}

void compareAndExchangeINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 7202 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ cmpxchgl(opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 23941 "ad_x86.cpp"
  }
}

void compareAndExchangeLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 7219 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ cmpxchgq(opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 23958 "ad_x86.cpp"
  }
}

void compareAndExchangeNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 7236 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ cmpxchgl(opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 23975 "ad_x86.cpp"
  }
}

void compareAndExchangePNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  {

#line 7254 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ cmpxchgq(opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 23992 "ad_x86.cpp"
  }
}

void xaddB_reg_no_resNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// add
  {

#line 7266 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ addb(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* add */);
  
#line 24008 "ad_x86.cpp"
  }
}

void xaddB_imm_no_resNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// add
  {

#line 7278 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ addb(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
  
#line 24024 "ad_x86.cpp"
  }
}

void xaddBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newval
  {

#line 7290 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ xaddb(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* newval */);
  
#line 24040 "ad_x86.cpp"
  }
}

void xaddS_reg_no_resNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// add
  {

#line 7302 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ addw(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* add */);
  
#line 24056 "ad_x86.cpp"
  }
}

void xaddS_imm_no_resNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// add
  {

#line 7314 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ addw(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
  
#line 24072 "ad_x86.cpp"
  }
}

void xaddSNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newval
  {

#line 7326 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ xaddw(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* newval */);
  
#line 24088 "ad_x86.cpp"
  }
}

void xaddI_reg_no_resNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// add
  {

#line 7338 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ addl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* add */);
  
#line 24104 "ad_x86.cpp"
  }
}

void xaddI_imm_no_resNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// add
  {

#line 7350 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ addl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
  
#line 24120 "ad_x86.cpp"
  }
}

void xaddINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newval
  {

#line 7362 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ xaddl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* newval */);
  
#line 24136 "ad_x86.cpp"
  }
}

void xaddL_reg_no_resNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// add
  {

#line 7374 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ addq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* add */);
  
#line 24152 "ad_x86.cpp"
  }
}

void xaddL_imm_no_resNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// add
  {

#line 7386 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ addq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constantL());
  
#line 24168 "ad_x86.cpp"
  }
}

void xaddLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newval
  {

#line 7398 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lock();
    __ xaddq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* newval */);
  
#line 24184 "ad_x86.cpp"
  }
}

void xchgBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newval
  {

#line 7408 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xchgb(opnd_array(2)->as_Register(ra_,this,idx2)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 24199 "ad_x86.cpp"
  }
}

void xchgSNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newval
  {

#line 7417 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xchgw(opnd_array(2)->as_Register(ra_,this,idx2)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 24214 "ad_x86.cpp"
  }
}

void xchgINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newval
  {

#line 7426 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xchgl(opnd_array(2)->as_Register(ra_,this,idx2)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 24229 "ad_x86.cpp"
  }
}

void xchgLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newval
  {

#line 7435 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xchgq(opnd_array(2)->as_Register(ra_,this,idx2)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 24244 "ad_x86.cpp"
  }
}

void xchgPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newval
  {

#line 7445 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xchgq(opnd_array(2)->as_Register(ra_,this,idx2)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 24259 "ad_x86.cpp"
  }
}

void xchgNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newval
  {

#line 7455 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xchgl(opnd_array(2)->as_Register(ra_,this,idx2)/* newval */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 24274 "ad_x86.cpp"
  }
}

void absI_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 7471 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorl(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */);
    __ subl(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ cmovl(Assembler::less, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 24291 "ad_x86.cpp"
  }
}

void absL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 7488 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorl(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */);
    __ subq(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ cmovq(Assembler::less, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 24308 "ad_x86.cpp"
  }
}

void subI_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7507 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ subl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 24323 "ad_x86.cpp"
  }
}

void subI_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7521 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ subl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 24338 "ad_x86.cpp"
  }
}

void subI_mem_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7535 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ subl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 24353 "ad_x86.cpp"
  }
}

void subL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7548 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ subq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 24368 "ad_x86.cpp"
  }
}

void subL_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7562 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ subq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 24383 "ad_x86.cpp"
  }
}

void subL_mem_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7576 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ subq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 24398 "ad_x86.cpp"
  }
}

void subP_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src
  {

#line 7590 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ subq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* src */);
  
#line 24414 "ad_x86.cpp"
  }
}

void negI_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 7603 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ negl(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */);
  
#line 24429 "ad_x86.cpp"
  }
}

void negI_rReg_2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 7616 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ negl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 24443 "ad_x86.cpp"
  }
}

void negI_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 7629 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ negl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 24458 "ad_x86.cpp"
  }
}

void negL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 7642 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ negq(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */);
  
#line 24473 "ad_x86.cpp"
  }
}

void negL_rReg_2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 7655 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ negq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 24487 "ad_x86.cpp"
  }
}

void negL_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 7668 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ negq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 24502 "ad_x86.cpp"
  }
}

void mulI_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7685 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ imull(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 24517 "ad_x86.cpp"
  }
}

void mulI_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {

#line 7698 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ imull(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 24532 "ad_x86.cpp"
  }
}

void mulI_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7711 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ imull(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 24547 "ad_x86.cpp"
  }
}

void mulI_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 7711 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ imull(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 24562 "ad_x86.cpp"
  }
}

void mulI_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {

#line 7724 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ imull(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
  
#line 24577 "ad_x86.cpp"
  }
}

void mulL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7747 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ imulq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 24592 "ad_x86.cpp"
  }
}

void mulL_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {

#line 7760 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ imulq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->constantL());
  
#line 24607 "ad_x86.cpp"
  }
}

void mulL_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7773 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ imulq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 24622 "ad_x86.cpp"
  }
}

void mulL_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 7773 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ imulq(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 24637 "ad_x86.cpp"
  }
}

void mulL_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {

#line 7786 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ imulq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constantL());
  
#line 24652 "ad_x86.cpp"
  }
}

void mulHiL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rax
  {

#line 7799 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ imulq(opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 24667 "ad_x86.cpp"
  }
}

void umulHiL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rax
  {

#line 7812 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ mulq(opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 24682 "ad_x86.cpp"
  }
}

void divI_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// rax
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div
  {

#line 1722 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    // Full implementation of Java idiv and irem; checks for
    // special case as described in JVM spec., p.243 & p.271.
    //
    //         normal case                           special case
    //
    // input : rax: dividend                         min_int
    //         reg: divisor                          -1
    //
    // output: rax: quotient  (= rax idiv reg)       min_int
    //         rdx: remainder (= rax irem reg)       0
    //
    //  Code sequnce:
    //
    //    0:   3d 00 00 00 80          cmp    $0x80000000,%eax
    //    5:   75 07/08                jne    e <normal>
    //    7:   33 d2                   xor    %edx,%edx
    //  [div >= 8 -> offset + 1]
    //  [REX_B]
    //    9:   83 f9 ff                cmp    $0xffffffffffffffff,$div
    //    c:   74 03/04                je     11 <done>
    // 000000000000000e <normal>:
    //    e:   99                      cltd
    //  [div >= 8 -> offset + 1]
    //  [REX_B]
    //    f:   f7 f9                   idiv   $div
    // 0000000000000011 <done>:
    Label normal;
    Label done;

    // cmp    $0x80000000,%eax
    __ cmpl(as_Register(RAX_enc), 0x80000000);

    // jne    e <normal>
    __ jccb(Assembler::notEqual, normal);

    // xor    %edx,%edx
    __ xorl(as_Register(RDX_enc), as_Register(RDX_enc));

    // cmp    $0xffffffffffffffff,%ecx
    __ cmpl(opnd_array(2)->as_Register(ra_,this,idx2)/* div */, -1);

    // je     11 <done>
    __ jccb(Assembler::equal, done);

    // <normal>
    // cltd
    __ bind(normal);
    __ cdql();

    // idivl
    // <done>
    __ idivl(opnd_array(2)->as_Register(ra_,this,idx2)/* div */);
    __ bind(done);
  
#line 24749 "ad_x86.cpp"
  }
}

void divL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// rax
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div
  {

#line 1779 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    // Full implementation of Java ldiv and lrem; checks for
    // special case as described in JVM spec., p.243 & p.271.
    //
    //         normal case                           special case
    //
    // input : rax: dividend                         min_long
    //         reg: divisor                          -1
    //
    // output: rax: quotient  (= rax idiv reg)       min_long
    //         rdx: remainder (= rax irem reg)       0
    //
    //  Code sequnce:
    //
    //    0:   48 ba 00 00 00 00 00    mov    $0x8000000000000000,%rdx
    //    7:   00 00 80
    //    a:   48 39 d0                cmp    %rdx,%rax
    //    d:   75 08                   jne    17 <normal>
    //    f:   33 d2                   xor    %edx,%edx
    //   11:   48 83 f9 ff             cmp    $0xffffffffffffffff,$div
    //   15:   74 05                   je     1c <done>
    // 0000000000000017 <normal>:
    //   17:   48 99                   cqto
    //   19:   48 f7 f9                idiv   $div
    // 000000000000001c <done>:
    Label normal;
    Label done;

    // mov    $0x8000000000000000,%rdx
    __ mov64(as_Register(RDX_enc), 0x8000000000000000);

    // cmp    %rdx,%rax
    __ cmpq(as_Register(RAX_enc), as_Register(RDX_enc));

    // jne    17 <normal>
    __ jccb(Assembler::notEqual, normal);

    // xor    %edx,%edx
    __ xorl(as_Register(RDX_enc), as_Register(RDX_enc));

    // cmp    $0xffffffffffffffff,$div
    __ cmpq(opnd_array(2)->as_Register(ra_,this,idx2)/* div */, -1);

    // je     1e <done>
    __ jccb(Assembler::equal, done);

    // <normal>
    // cqto
    __ bind(normal);
    __ cdqq();

    // idivq (note: must be emitted by the user of this rule)
    // <done>
    __ idivq(opnd_array(2)->as_Register(ra_,this,idx2)/* div */);
    __ bind(done);
  
#line 24817 "ad_x86.cpp"
  }
}

void udivI_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// rax
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div
  {

#line 7864 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ udivI(opnd_array(1)->as_Register(ra_,this,idx1)/* rax */, opnd_array(2)->as_Register(ra_,this,idx2)/* div */, as_Register(RDX_enc));
  
#line 24832 "ad_x86.cpp"
  }
}

void udivL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// rax
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div
  {

#line 7877 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

     __ udivL(opnd_array(1)->as_Register(ra_,this,idx1)/* rax */, opnd_array(2)->as_Register(ra_,this,idx2)/* div */, as_Register(RDX_enc));
  
#line 24847 "ad_x86.cpp"
  }
}

void divModI_rReg_divmodNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// div
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rdx
  {

#line 1722 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    // Full implementation of Java idiv and irem; checks for
    // special case as described in JVM spec., p.243 & p.271.
    //
    //         normal case                           special case
    //
    // input : rax: dividend                         min_int
    //         reg: divisor                          -1
    //
    // output: rax: quotient  (= rax idiv reg)       min_int
    //         rdx: remainder (= rax irem reg)       0
    //
    //  Code sequnce:
    //
    //    0:   3d 00 00 00 80          cmp    $0x80000000,%eax
    //    5:   75 07/08                jne    e <normal>
    //    7:   33 d2                   xor    %edx,%edx
    //  [div >= 8 -> offset + 1]
    //  [REX_B]
    //    9:   83 f9 ff                cmp    $0xffffffffffffffff,$div
    //    c:   74 03/04                je     11 <done>
    // 000000000000000e <normal>:
    //    e:   99                      cltd
    //  [div >= 8 -> offset + 1]
    //  [REX_B]
    //    f:   f7 f9                   idiv   $div
    // 0000000000000011 <done>:
    Label normal;
    Label done;

    // cmp    $0x80000000,%eax
    __ cmpl(as_Register(RAX_enc), 0x80000000);

    // jne    e <normal>
    __ jccb(Assembler::notEqual, normal);

    // xor    %edx,%edx
    __ xorl(as_Register(RDX_enc), as_Register(RDX_enc));

    // cmp    $0xffffffffffffffff,%ecx
    __ cmpl(opnd_array(2)->as_Register(ra_,this,idx2)/* div */, -1);

    // je     11 <done>
    __ jccb(Assembler::equal, done);

    // <normal>
    // cltd
    __ bind(normal);
    __ cdql();

    // idivl
    // <done>
    __ idivl(opnd_array(2)->as_Register(ra_,this,idx2)/* div */);
    __ bind(done);
  
#line 24914 "ad_x86.cpp"
  }
}

void divModL_rReg_divmodNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// div
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rdx
  {

#line 1779 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    // Full implementation of Java ldiv and lrem; checks for
    // special case as described in JVM spec., p.243 & p.271.
    //
    //         normal case                           special case
    //
    // input : rax: dividend                         min_long
    //         reg: divisor                          -1
    //
    // output: rax: quotient  (= rax idiv reg)       min_long
    //         rdx: remainder (= rax irem reg)       0
    //
    //  Code sequnce:
    //
    //    0:   48 ba 00 00 00 00 00    mov    $0x8000000000000000,%rdx
    //    7:   00 00 80
    //    a:   48 39 d0                cmp    %rdx,%rax
    //    d:   75 08                   jne    17 <normal>
    //    f:   33 d2                   xor    %edx,%edx
    //   11:   48 83 f9 ff             cmp    $0xffffffffffffffff,$div
    //   15:   74 05                   je     1c <done>
    // 0000000000000017 <normal>:
    //   17:   48 99                   cqto
    //   19:   48 f7 f9                idiv   $div
    // 000000000000001c <done>:
    Label normal;
    Label done;

    // mov    $0x8000000000000000,%rdx
    __ mov64(as_Register(RDX_enc), 0x8000000000000000);

    // cmp    %rdx,%rax
    __ cmpq(as_Register(RAX_enc), as_Register(RDX_enc));

    // jne    17 <normal>
    __ jccb(Assembler::notEqual, normal);

    // xor    %edx,%edx
    __ xorl(as_Register(RDX_enc), as_Register(RDX_enc));

    // cmp    $0xffffffffffffffff,$div
    __ cmpq(opnd_array(2)->as_Register(ra_,this,idx2)/* div */, -1);

    // je     1e <done>
    __ jccb(Assembler::equal, done);

    // <normal>
    // cqto
    __ bind(normal);
    __ cdqq();

    // idivq (note: must be emitted by the user of this rule)
    // <done>
    __ idivq(opnd_array(2)->as_Register(ra_,this,idx2)/* div */);
    __ bind(done);
  
#line 24982 "ad_x86.cpp"
  }
}

void udivModI_rReg_divmodNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// div
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rdx
  {

#line 7935 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ udivmodI(opnd_array(1)->as_Register(ra_,this,idx1)/* rax */, opnd_array(2)->as_Register(ra_,this,idx2)/* div */, as_Register(RDX_enc), opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */);
  
#line 24998 "ad_x86.cpp"
  }
}

void udivModL_rReg_divmodNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// div
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rdx
  {

#line 7952 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ udivmodL(opnd_array(1)->as_Register(ra_,this,idx1)/* rax */, opnd_array(2)->as_Register(ra_,this,idx2)/* div */, as_Register(RDX_enc), opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */);
  
#line 25014 "ad_x86.cpp"
  }
}

void modI_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// rax
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div
  {

#line 1722 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    // Full implementation of Java idiv and irem; checks for
    // special case as described in JVM spec., p.243 & p.271.
    //
    //         normal case                           special case
    //
    // input : rax: dividend                         min_int
    //         reg: divisor                          -1
    //
    // output: rax: quotient  (= rax idiv reg)       min_int
    //         rdx: remainder (= rax irem reg)       0
    //
    //  Code sequnce:
    //
    //    0:   3d 00 00 00 80          cmp    $0x80000000,%eax
    //    5:   75 07/08                jne    e <normal>
    //    7:   33 d2                   xor    %edx,%edx
    //  [div >= 8 -> offset + 1]
    //  [REX_B]
    //    9:   83 f9 ff                cmp    $0xffffffffffffffff,$div
    //    c:   74 03/04                je     11 <done>
    // 000000000000000e <normal>:
    //    e:   99                      cltd
    //  [div >= 8 -> offset + 1]
    //  [REX_B]
    //    f:   f7 f9                   idiv   $div
    // 0000000000000011 <done>:
    Label normal;
    Label done;

    // cmp    $0x80000000,%eax
    __ cmpl(as_Register(RAX_enc), 0x80000000);

    // jne    e <normal>
    __ jccb(Assembler::notEqual, normal);

    // xor    %edx,%edx
    __ xorl(as_Register(RDX_enc), as_Register(RDX_enc));

    // cmp    $0xffffffffffffffff,%ecx
    __ cmpl(opnd_array(2)->as_Register(ra_,this,idx2)/* div */, -1);

    // je     11 <done>
    __ jccb(Assembler::equal, done);

    // <normal>
    // cltd
    __ bind(normal);
    __ cdql();

    // idivl
    // <done>
    __ idivl(opnd_array(2)->as_Register(ra_,this,idx2)/* div */);
    __ bind(done);
  
#line 25081 "ad_x86.cpp"
  }
}

void modL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// rax
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div
  {

#line 1779 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    // Full implementation of Java ldiv and lrem; checks for
    // special case as described in JVM spec., p.243 & p.271.
    //
    //         normal case                           special case
    //
    // input : rax: dividend                         min_long
    //         reg: divisor                          -1
    //
    // output: rax: quotient  (= rax idiv reg)       min_long
    //         rdx: remainder (= rax irem reg)       0
    //
    //  Code sequnce:
    //
    //    0:   48 ba 00 00 00 00 00    mov    $0x8000000000000000,%rdx
    //    7:   00 00 80
    //    a:   48 39 d0                cmp    %rdx,%rax
    //    d:   75 08                   jne    17 <normal>
    //    f:   33 d2                   xor    %edx,%edx
    //   11:   48 83 f9 ff             cmp    $0xffffffffffffffff,$div
    //   15:   74 05                   je     1c <done>
    // 0000000000000017 <normal>:
    //   17:   48 99                   cqto
    //   19:   48 f7 f9                idiv   $div
    // 000000000000001c <done>:
    Label normal;
    Label done;

    // mov    $0x8000000000000000,%rdx
    __ mov64(as_Register(RDX_enc), 0x8000000000000000);

    // cmp    %rdx,%rax
    __ cmpq(as_Register(RAX_enc), as_Register(RDX_enc));

    // jne    17 <normal>
    __ jccb(Assembler::notEqual, normal);

    // xor    %edx,%edx
    __ xorl(as_Register(RDX_enc), as_Register(RDX_enc));

    // cmp    $0xffffffffffffffff,$div
    __ cmpq(opnd_array(2)->as_Register(ra_,this,idx2)/* div */, -1);

    // je     1e <done>
    __ jccb(Assembler::equal, done);

    // <normal>
    // cqto
    __ bind(normal);
    __ cdqq();

    // idivq (note: must be emitted by the user of this rule)
    // <done>
    __ idivq(opnd_array(2)->as_Register(ra_,this,idx2)/* div */);
    __ bind(done);
  
#line 25149 "ad_x86.cpp"
  }
}

void umodI_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// rax
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div
  {

#line 8004 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ umodI(opnd_array(1)->as_Register(ra_,this,idx1)/* rax */, opnd_array(2)->as_Register(ra_,this,idx2)/* div */, opnd_array(0)->as_Register(ra_,this)/* rdx */);
  
#line 25164 "ad_x86.cpp"
  }
}

void umodL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// rax
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// div
  {

#line 8017 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ umodL(opnd_array(1)->as_Register(ra_,this,idx1)/* rax */, opnd_array(2)->as_Register(ra_,this,idx2)/* div */, opnd_array(0)->as_Register(ra_,this)/* rdx */);
  
#line 25179 "ad_x86.cpp"
  }
}

void salI_rReg_immI2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8031 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ sall(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constant());
  
#line 25194 "ad_x86.cpp"
  }
}

void salI_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8044 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ sall(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constant());
  
#line 25209 "ad_x86.cpp"
  }
}

void salI_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8057 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ sall(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
  
#line 25224 "ad_x86.cpp"
  }
}

void salI_rReg_CLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8071 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ sall(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 25239 "ad_x86.cpp"
  }
}

void salI_mem_CLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8085 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ sall(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 25254 "ad_x86.cpp"
  }
}

void salI_rReg_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8097 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ shlxl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
  
#line 25269 "ad_x86.cpp"
  }
}

void salI_mem_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8109 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ shlxl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
  
#line 25284 "ad_x86.cpp"
  }
}

void sarI_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8122 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ sarl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constant());
  
#line 25299 "ad_x86.cpp"
  }
}

void sarI_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8135 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ sarl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
  
#line 25314 "ad_x86.cpp"
  }
}

void sarI_rReg_CLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8149 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ sarl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 25329 "ad_x86.cpp"
  }
}

void sarI_mem_CLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8163 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ sarl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 25344 "ad_x86.cpp"
  }
}

void sarI_rReg_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8175 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ sarxl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
  
#line 25359 "ad_x86.cpp"
  }
}

void sarI_mem_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8187 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ sarxl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
  
#line 25374 "ad_x86.cpp"
  }
}

void shrI_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8200 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ shrl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constant());
  
#line 25389 "ad_x86.cpp"
  }
}

void shrI_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8213 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ shrl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
  
#line 25404 "ad_x86.cpp"
  }
}

void shrI_rReg_CLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8227 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ shrl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 25419 "ad_x86.cpp"
  }
}

void shrI_mem_CLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8241 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ shrl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 25434 "ad_x86.cpp"
  }
}

void shrI_rReg_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8253 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ shrxl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
  
#line 25449 "ad_x86.cpp"
  }
}

void shrI_mem_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8265 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ shrxl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
  
#line 25464 "ad_x86.cpp"
  }
}

void salL_rReg_immI2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8279 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ salq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constant());
  
#line 25479 "ad_x86.cpp"
  }
}

void salL_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8292 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ salq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constant());
  
#line 25494 "ad_x86.cpp"
  }
}

void salL_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8305 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ salq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
  
#line 25509 "ad_x86.cpp"
  }
}

void salL_rReg_CLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8319 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ salq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 25524 "ad_x86.cpp"
  }
}

void salL_mem_CLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8333 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ salq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 25539 "ad_x86.cpp"
  }
}

void salL_rReg_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8345 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ shlxq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
  
#line 25554 "ad_x86.cpp"
  }
}

void salL_mem_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8357 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ shlxq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
  
#line 25569 "ad_x86.cpp"
  }
}

void sarL_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8370 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ sarq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, (unsigned char)(opnd_array(2)->constant()& 0x3F));
  
#line 25584 "ad_x86.cpp"
  }
}

void sarL_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8383 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ sarq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), (unsigned char)(opnd_array(2)->constant()& 0x3F));
  
#line 25599 "ad_x86.cpp"
  }
}

void sarL_rReg_CLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8397 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ sarq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 25614 "ad_x86.cpp"
  }
}

void sarL_mem_CLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8411 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ sarq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 25629 "ad_x86.cpp"
  }
}

void sarL_rReg_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8423 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ sarxq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
  
#line 25644 "ad_x86.cpp"
  }
}

void sarL_mem_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8435 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ sarxq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
  
#line 25659 "ad_x86.cpp"
  }
}

void shrL_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8448 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ shrq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constant());
  
#line 25674 "ad_x86.cpp"
  }
}

void shrL_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8461 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ shrq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
  
#line 25689 "ad_x86.cpp"
  }
}

void shrL_rReg_CLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8475 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ shrq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 25704 "ad_x86.cpp"
  }
}

void shrL_mem_CLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8489 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ shrq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 25719 "ad_x86.cpp"
  }
}

void shrL_rReg_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8501 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ shrxq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
  
#line 25734 "ad_x86.cpp"
  }
}

void shrL_mem_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8513 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ shrxq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* shift */);
  
#line 25749 "ad_x86.cpp"
  }
}

void i2bNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// twentyfour
  {

#line 8526 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movsbl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 25764 "ad_x86.cpp"
  }
}

void i2sNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// sixteen
  {

#line 8539 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movswl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 25779 "ad_x86.cpp"
  }
}

void rolI_immI8_legacyNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8554 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ roll(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constant());
  
#line 25794 "ad_x86.cpp"
  }
}

void rolI_immI8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8565 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    int shift = 32 - (opnd_array(2)->constant()& 31);
    __ rorxl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, shift);
  
#line 25810 "ad_x86.cpp"
  }
}

void rolI_mem_immI8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8578 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    int shift = 32 - (opnd_array(2)->constant()& 31);
    __ rorxl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), shift);
  
#line 25826 "ad_x86.cpp"
  }
}

void rolI_rReg_VarNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8592 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ roll(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 25841 "ad_x86.cpp"
  }
}

void rorI_immI8_legacyNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8605 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ rorl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constant());
  
#line 25856 "ad_x86.cpp"
  }
}

void rorI_immI8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8617 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ rorxl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 25871 "ad_x86.cpp"
  }
}

void rorI_mem_immI8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8629 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ rorxl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
  
#line 25886 "ad_x86.cpp"
  }
}

void rorI_rReg_VarNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8642 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ rorl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 25901 "ad_x86.cpp"
  }
}

void rolL_immI8_legacyNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8655 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ rolq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constant());
  
#line 25916 "ad_x86.cpp"
  }
}

void rolL_immI8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8666 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    int shift = 64 - (opnd_array(2)->constant()& 63);
    __ rorxq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, shift);
  
#line 25932 "ad_x86.cpp"
  }
}

void rolL_mem_immI8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8679 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    int shift = 64 - (opnd_array(2)->constant()& 63);
    __ rorxq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), shift);
  
#line 25948 "ad_x86.cpp"
  }
}

void rolL_rReg_VarNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8693 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ rolq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 25963 "ad_x86.cpp"
  }
}

void rorL_immI8_legacyNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8706 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ rorq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constant());
  
#line 25978 "ad_x86.cpp"
  }
}

void rorL_immI8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8718 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ rorxq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 25993 "ad_x86.cpp"
  }
}

void rorL_mem_immI8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8730 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ rorxq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
  
#line 26008 "ad_x86.cpp"
  }
}

void rorL_rReg_VarNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 8743 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ rorq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 26023 "ad_x86.cpp"
  }
}

void compressBitsL_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 8755 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ pextq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* mask */);
  
#line 26038 "ad_x86.cpp"
  }
}

void expandBitsL_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 8765 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ pdepq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* mask */);
  
#line 26053 "ad_x86.cpp"
  }
}

void compressBitsL_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 8775 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ pextq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 26068 "ad_x86.cpp"
  }
}

void expandBitsL_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 8785 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ pdepq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 26083 "ad_x86.cpp"
  }
}

void andI_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 8805 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 26098 "ad_x86.cpp"
  }
}

void andI_rReg_imm255Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 8817 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movzbl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 26113 "ad_x86.cpp"
  }
}

void andI2L_rReg_imm255Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 8829 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movzbl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 26128 "ad_x86.cpp"
  }
}

void andI_rReg_imm65535Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 8841 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movzwl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 26143 "ad_x86.cpp"
  }
}

void andI2L_rReg_imm65535Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 8853 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movzwl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 26158 "ad_x86.cpp"
  }
}

void convI2LAndI_reg_immIbitmaskNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 8867 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, exact_log2(opnd_array(2)->constant()+ 1));
    __ bzhiq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */);
  
#line 26175 "ad_x86.cpp"
  }
}

void andI_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 8882 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constant());
  
#line 26190 "ad_x86.cpp"
  }
}

void andI_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 8897 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 26205 "ad_x86.cpp"
  }
}

void andI_rReg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 8897 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andl(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 26220 "ad_x86.cpp"
  }
}

void andB_mem_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 8912 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andb(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 26235 "ad_x86.cpp"
  }
}

void andB_mem_rReg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 8912 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andb(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 26250 "ad_x86.cpp"
  }
}

void andI_mem_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 8926 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 26265 "ad_x86.cpp"
  }
}

void andI_mem_rReg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 8926 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 26280 "ad_x86.cpp"
  }
}

void andI_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 8941 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
  
#line 26295 "ad_x86.cpp"
  }
}

void andnI_rReg_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 8957 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andnl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(3)->base(ra_,this,idx3), opnd_array(3)->index(ra_,this,idx3), opnd_array(3)->scale(), opnd_array(3)->disp(ra_,this,idx3), opnd_array(3)->disp_reloc()));
  
#line 26311 "ad_x86.cpp"
  }
}

void andnI_rReg_rReg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// minus_1
  {

#line 8957 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andnl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 26327 "ad_x86.cpp"
  }
}

void andnI_rReg_rReg_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 8971 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andnl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
  
#line 26343 "ad_x86.cpp"
  }
}

void andnI_rReg_rReg_rReg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// minus_1
  {

#line 8971 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andnl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(1)->as_Register(ra_,this,idx1)/* src2 */);
  
#line 26359 "ad_x86.cpp"
  }
}

void blsiI_rReg_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm_zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 8985 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsil(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 26374 "ad_x86.cpp"
  }
}

void blsiI_rReg_rReg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm_zero
  {

#line 8985 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsil(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 26389 "ad_x86.cpp"
  }
}

void blsiI_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// imm_zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9000 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsil(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 26404 "ad_x86.cpp"
  }
}

void blsiI_rReg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm_zero
  {

#line 9000 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsil(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 26419 "ad_x86.cpp"
  }
}

void blsmskI_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {

#line 9016 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsmskl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 26434 "ad_x86.cpp"
  }
}

void blsmskI_rReg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {

#line 9016 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsmskl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 26449 "ad_x86.cpp"
  }
}

void blsmskI_rReg_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {

#line 9031 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsmskl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 26464 "ad_x86.cpp"
  }
}

void blsmskI_rReg_rReg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {

#line 9031 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsmskl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 26479 "ad_x86.cpp"
  }
}

void blsrI_rReg_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {

#line 9047 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsrl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 26494 "ad_x86.cpp"
  }
}

void blsrI_rReg_rReg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {

#line 9047 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsrl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 26509 "ad_x86.cpp"
  }
}

void blsrI_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {

#line 9064 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsrl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 26524 "ad_x86.cpp"
  }
}

void blsrI_rReg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {

#line 9064 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsrl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 26539 "ad_x86.cpp"
  }
}

void orI_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9080 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ orl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 26554 "ad_x86.cpp"
  }
}

void orI_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9094 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ orl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constant());
  
#line 26569 "ad_x86.cpp"
  }
}

void orI_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9109 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ orl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 26584 "ad_x86.cpp"
  }
}

void orI_rReg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 9109 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ orl(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 26599 "ad_x86.cpp"
  }
}

void orB_mem_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9124 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ orb(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 26614 "ad_x86.cpp"
  }
}

void orB_mem_rReg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9124 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ orb(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 26629 "ad_x86.cpp"
  }
}

void orI_mem_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9138 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ orl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 26644 "ad_x86.cpp"
  }
}

void orI_mem_rReg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9138 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ orl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 26659 "ad_x86.cpp"
  }
}

void orI_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9153 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ orl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
  
#line 26674 "ad_x86.cpp"
  }
}

void xorI_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9168 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 26689 "ad_x86.cpp"
  }
}

void xorI_rReg_im1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {

#line 9179 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

     __ notl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 26704 "ad_x86.cpp"
  }
}

void xorI_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9193 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constant());
  
#line 26719 "ad_x86.cpp"
  }
}

void xorI_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9208 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 26734 "ad_x86.cpp"
  }
}

void xorI_rReg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 9208 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorl(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 26749 "ad_x86.cpp"
  }
}

void xorB_mem_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9223 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorb(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 26764 "ad_x86.cpp"
  }
}

void xorB_mem_rReg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9223 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorb(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 26779 "ad_x86.cpp"
  }
}

void xorI_mem_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9237 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 26794 "ad_x86.cpp"
  }
}

void xorI_mem_rReg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9237 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 26809 "ad_x86.cpp"
  }
}

void xorI_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9252 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant());
  
#line 26824 "ad_x86.cpp"
  }
}

void andL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9270 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 26839 "ad_x86.cpp"
  }
}

void andL_rReg_imm255Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 9282 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    // movzbl zeroes out the upper 32-bit and does not need REX.W
    __ movzbl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 26855 "ad_x86.cpp"
  }
}

void andL_rReg_imm65535Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 9295 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    // movzwl zeroes out the upper 32-bit and does not need REX.W
    __ movzwl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 26871 "ad_x86.cpp"
  }
}

void andL_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9310 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constantL());
  
#line 26886 "ad_x86.cpp"
  }
}

void andL_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9325 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 26901 "ad_x86.cpp"
  }
}

void andL_rReg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 9325 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andq(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 26916 "ad_x86.cpp"
  }
}

void andL_mem_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9340 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 26931 "ad_x86.cpp"
  }
}

void andL_mem_rReg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9340 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 26946 "ad_x86.cpp"
  }
}

void andL_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9355 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constantL());
  
#line 26961 "ad_x86.cpp"
  }
}

void btrL_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 9372 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ btrq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), log2i_exact((julong)~opnd_array(2)->constantL()));
  
#line 26976 "ad_x86.cpp"
  }
}

void andnL_rReg_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 9388 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andnq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(3)->base(ra_,this,idx3), opnd_array(3)->index(ra_,this,idx3), opnd_array(3)->scale(), opnd_array(3)->disp(ra_,this,idx3), opnd_array(3)->disp_reloc()));
  
#line 26992 "ad_x86.cpp"
  }
}

void andnL_rReg_rReg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// minus_1
  {

#line 9388 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ andnq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 27008 "ad_x86.cpp"
  }
}

void andnL_rReg_rReg_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 9402 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

  __ andnq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* src2 */);
  
#line 27024 "ad_x86.cpp"
  }
}

void andnL_rReg_rReg_rReg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// minus_1
  {

#line 9402 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

  __ andnq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src1 */, opnd_array(1)->as_Register(ra_,this,idx1)/* src2 */);
  
#line 27040 "ad_x86.cpp"
  }
}

void blsiL_rReg_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// imm_zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9416 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsiq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 27055 "ad_x86.cpp"
  }
}

void blsiL_rReg_rReg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm_zero
  {

#line 9416 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsiq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 27070 "ad_x86.cpp"
  }
}

void blsiL_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// imm_zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9431 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsiq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 27085 "ad_x86.cpp"
  }
}

void blsiL_rReg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm_zero
  {

#line 9431 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsiq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 27100 "ad_x86.cpp"
  }
}

void blsmskL_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {

#line 9447 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsmskq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 27115 "ad_x86.cpp"
  }
}

void blsmskL_rReg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {

#line 9447 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsmskq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 27130 "ad_x86.cpp"
  }
}

void blsmskL_rReg_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {

#line 9462 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsmskq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 27145 "ad_x86.cpp"
  }
}

void blsmskL_rReg_rReg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {

#line 9462 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsmskq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 27160 "ad_x86.cpp"
  }
}

void blsrL_rReg_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {

#line 9478 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsrq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 27175 "ad_x86.cpp"
  }
}

void blsrL_rReg_rReg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {

#line 9478 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsrq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 27190 "ad_x86.cpp"
  }
}

void blsrL_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {

#line 9495 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsrq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 27205 "ad_x86.cpp"
  }
}

void blsrL_rReg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// minus_1
  {

#line 9495 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ blsrq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 27220 "ad_x86.cpp"
  }
}

void orL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9511 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ orq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 27235 "ad_x86.cpp"
  }
}

void orL_rReg_castP2XNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9524 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ orq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 27250 "ad_x86.cpp"
  }
}

void orL_rReg_castP2X_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 9524 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ orq(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 27265 "ad_x86.cpp"
  }
}

void orL_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9539 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ orq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constantL());
  
#line 27280 "ad_x86.cpp"
  }
}

void orL_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9554 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ orq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 27295 "ad_x86.cpp"
  }
}

void orL_rReg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 9554 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ orq(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 27310 "ad_x86.cpp"
  }
}

void orL_mem_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9569 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ orq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 27325 "ad_x86.cpp"
  }
}

void orL_mem_rReg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9569 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ orq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 27340 "ad_x86.cpp"
  }
}

void orL_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9584 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ orq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constantL());
  
#line 27355 "ad_x86.cpp"
  }
}

void btsL_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 9601 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ btsq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), log2i_exact((julong)opnd_array(2)->constantL()));
  
#line 27370 "ad_x86.cpp"
  }
}

void xorL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9616 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 27385 "ad_x86.cpp"
  }
}

void xorL_rReg_im1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {

#line 9627 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

     __ notq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */);
  
#line 27400 "ad_x86.cpp"
  }
}

void xorL_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9641 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->constantL());
  
#line 27415 "ad_x86.cpp"
  }
}

void xorL_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9656 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorq(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 27430 "ad_x86.cpp"
  }
}

void xorL_rReg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 9656 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorq(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 27445 "ad_x86.cpp"
  }
}

void xorL_mem_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9671 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 27460 "ad_x86.cpp"
  }
}

void xorL_mem_rReg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9671 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 27475 "ad_x86.cpp"
  }
}

void xorL_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 9686 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ xorq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constantL());
  
#line 27490 "ad_x86.cpp"
  }
}

void cmpLTMaskNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// p
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// q
  {

#line 9701 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpl(opnd_array(1)->as_Register(ra_,this,idx1)/* p */, opnd_array(2)->as_Register(ra_,this,idx2)/* q */);
    __ setcc(Assembler::less, opnd_array(0)->as_Register(ra_,this)/* dst */);
    __ negl(opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 27507 "ad_x86.cpp"
  }
}

void cmpLTMask0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 9716 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ sarl(opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, 31);
  
#line 27522 "ad_x86.cpp"
  }
}

void cadd_cmpLTMaskNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// p
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// q
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// y
  {

#line 9732 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Register Rp = opnd_array(1)->as_Register(ra_,this,idx1)/* p */;
    Register Rq = opnd_array(2)->as_Register(ra_,this,idx2)/* q */;
    Register Ry = opnd_array(3)->as_Register(ra_,this,idx3)/* y */;
    Label done;
    __ subl(Rp, Rq);
    __ jccb(Assembler::greaterEqual, done);
    __ addl(Rp, Ry);
    __ bind(done);
  
#line 27545 "ad_x86.cpp"
  }
}

void cadd_cmpLTMask_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// p
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// q
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// y
  {

#line 9732 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Register Rp = opnd_array(1)->as_Register(ra_,this,idx1)/* p */;
    Register Rq = opnd_array(2)->as_Register(ra_,this,idx2)/* q */;
    Register Ry = opnd_array(3)->as_Register(ra_,this,idx3)/* y */;
    Label done;
    __ subl(Rp, Rq);
    __ jccb(Assembler::greaterEqual, done);
    __ addl(Rp, Ry);
    __ bind(done);
  
#line 27568 "ad_x86.cpp"
  }
}

void cadd_cmpLTMask_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// y
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// p
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// q
  {

#line 9732 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Register Rp = opnd_array(2)->as_Register(ra_,this,idx2)/* p */;
    Register Rq = opnd_array(3)->as_Register(ra_,this,idx3)/* q */;
    Register Ry = opnd_array(1)->as_Register(ra_,this,idx1)/* y */;
    Label done;
    __ subl(Rp, Rq);
    __ jccb(Assembler::greaterEqual, done);
    __ addl(Rp, Ry);
    __ bind(done);
  
#line 27591 "ad_x86.cpp"
  }
}

void cadd_cmpLTMask_2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// p
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// q
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// y
  {

#line 9732 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Register Rp = opnd_array(1)->as_Register(ra_,this,idx1)/* p */;
    Register Rq = opnd_array(2)->as_Register(ra_,this,idx2)/* q */;
    Register Ry = opnd_array(3)->as_Register(ra_,this,idx3)/* y */;
    Label done;
    __ subl(Rp, Rq);
    __ jccb(Assembler::greaterEqual, done);
    __ addl(Rp, Ry);
    __ bind(done);
  
#line 27614 "ad_x86.cpp"
  }
}

void and_cmpLTMaskNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// p
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// q
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// y
  {

#line 9757 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Register Rp = opnd_array(1)->as_Register(ra_,this,idx1)/* p */;
    Register Rq = opnd_array(2)->as_Register(ra_,this,idx2)/* q */;
    Register Ry = opnd_array(3)->as_Register(ra_,this,idx3)/* y */;
    Label done;
    __ cmpl(Rp, Rq);
    __ jccb(Assembler::less, done);
    __ xorl(Ry, Ry);
    __ bind(done);
  
#line 27637 "ad_x86.cpp"
  }
}

void and_cmpLTMask_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// y
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// p
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// q
  {

#line 9757 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Register Rp = opnd_array(2)->as_Register(ra_,this,idx2)/* p */;
    Register Rq = opnd_array(3)->as_Register(ra_,this,idx3)/* q */;
    Register Ry = opnd_array(1)->as_Register(ra_,this,idx1)/* y */;
    Label done;
    __ cmpl(Rp, Rq);
    __ jccb(Assembler::less, done);
    __ xorl(Ry, Ry);
    __ bind(done);
  
#line 27660 "ad_x86.cpp"
  }
}

void cmpF_cc_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 9785 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ ucomiss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
    emit_cmpfp_fixup(masm);
  
#line 27676 "ad_x86.cpp"
  }
}

void cmpF_cc_reg_CFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 9797 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ ucomiss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 27691 "ad_x86.cpp"
  }
}

void cmpF_cc_memCFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 9808 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ ucomiss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 27706 "ad_x86.cpp"
  }
}

void cmpF_cc_immCFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 9818 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ ucomiss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 27721 "ad_x86.cpp"
  }
}

void cmpF_cc_immCFNode::eval_constant(Compile* C) {
  {

#line 9819 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 27730 "ad_x86.cpp"
  }
}
void cmpD_cc_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 9836 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ ucomisd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
    emit_cmpfp_fixup(masm);
  
#line 27745 "ad_x86.cpp"
  }
}

void cmpD_cc_reg_CFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 9848 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ ucomisd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 27760 "ad_x86.cpp"
  }
}

void cmpD_cc_memCFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 9859 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ ucomisd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 27775 "ad_x86.cpp"
  }
}

void cmpD_cc_immCFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 9869 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ ucomisd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 27790 "ad_x86.cpp"
  }
}

void cmpD_cc_immCFNode::eval_constant(Compile* C) {
  {

#line 9870 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 27799 "ad_x86.cpp"
  }
}
void cmpF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 9889 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ ucomiss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
    emit_cmpfp3(masm, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 27814 "ad_x86.cpp"
  }
}

void cmpF_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 9910 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ ucomiss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
    emit_cmpfp3(masm, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 27830 "ad_x86.cpp"
  }
}

void cmpF_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 9930 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ ucomiss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    emit_cmpfp3(masm, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 27846 "ad_x86.cpp"
  }
}

void cmpF_immNode::eval_constant(Compile* C) {
  {

#line 9931 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 27855 "ad_x86.cpp"
  }
}
void cmpD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 9951 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ ucomisd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
    emit_cmpfp3(masm, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 27870 "ad_x86.cpp"
  }
}

void cmpD_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 9972 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ ucomisd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
    emit_cmpfp3(masm, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 27886 "ad_x86.cpp"
  }
}

void cmpD_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 9992 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ ucomisd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, InternalAddress(__ code()->consts()->start() + constant_offset()));
    emit_cmpfp3(masm, opnd_array(0)->as_Register(ra_,this)/* dst */);
  
#line 27902 "ad_x86.cpp"
  }
}

void cmpD_immNode::eval_constant(Compile* C) {
  {

#line 9993 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 27911 "ad_x86.cpp"
  }
}
void convF2D_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10006 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cvtss2sd (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
  
#line 27924 "ad_x86.cpp"
  }
}

void convF2D_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  {

#line 10018 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cvtss2sd (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 27938 "ad_x86.cpp"
  }
}

void convD2F_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10029 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cvtsd2ss (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
  
#line 27952 "ad_x86.cpp"
  }
}

void convD2F_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  {

#line 10041 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cvtsd2ss (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 27966 "ad_x86.cpp"
  }
}

void convF2I_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10053 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ convertF2I(T_INT, T_FLOAT, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
  
#line 27980 "ad_x86.cpp"
  }
}

void convF2L_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10064 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ convertF2I(T_LONG, T_FLOAT, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
  
#line 27994 "ad_x86.cpp"
  }
}

void convD2I_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10075 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ convertF2I(T_INT, T_DOUBLE, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
  
#line 28008 "ad_x86.cpp"
  }
}

void convD2L_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10086 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ convertF2I(T_LONG, T_DOUBLE, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
  
#line 28022 "ad_x86.cpp"
  }
}

void round_double_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rtmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rcx
  {

#line 10097 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ round_double(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_Register(ra_,this,idx3)/* rtmp */, opnd_array(4)->as_Register(ra_,this,idx4)/* rcx */);
  
#line 28039 "ad_x86.cpp"
  }
}

void round_float_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rtmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rcx
  {

#line 10108 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ round_float(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_Register(ra_,this,idx3)/* rtmp */, opnd_array(4)->as_Register(ra_,this,idx4)/* rcx */);
  
#line 28056 "ad_x86.cpp"
  }
}

void convI2F_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10120 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    if (UseAVX > 0) {
      __ pxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    }
    __ cvtsi2ssl (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 28073 "ad_x86.cpp"
  }
}

void convI2F_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  {

#line 10135 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cvtsi2ssl (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 28087 "ad_x86.cpp"
  }
}

void convI2D_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10147 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    if (UseAVX > 0) {
      __ pxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    }
    __ cvtsi2sdl (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 28104 "ad_x86.cpp"
  }
}

void convI2D_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  {

#line 10162 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cvtsi2sdl (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 28118 "ad_x86.cpp"
  }
}

void convXI2F_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10175 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ cvtdq2ps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 28133 "ad_x86.cpp"
  }
}

void convXI2D_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10189 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ cvtdq2pd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
  
#line 28148 "ad_x86.cpp"
  }
}

void convL2F_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10201 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    if (UseAVX > 0) {
      __ pxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    }
    __ cvtsi2ssq (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 28165 "ad_x86.cpp"
  }
}

void convL2F_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  {

#line 10216 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cvtsi2ssq (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 28179 "ad_x86.cpp"
  }
}

void convL2D_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10227 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    if (UseAVX > 0) {
      __ pxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    }
    __ cvtsi2sdq (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 28196 "ad_x86.cpp"
  }
}

void convL2D_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  {

#line 10242 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cvtsi2sdq (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 28210 "ad_x86.cpp"
  }
}

void convI2L_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10254 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movslq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 28224 "ad_x86.cpp"
  }
}

void convI2L_reg_reg_zexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 10266 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    if (opnd_array(0)->reg(ra_,this)/* dst */!= opnd_array(1)->reg(ra_,this,idx1)/* src */) {
      __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    }
  
#line 28241 "ad_x86.cpp"
  }
}

void convI2L_reg_mem_zexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 10280 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 28256 "ad_x86.cpp"
  }
}

void zerox_long_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 10291 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 28271 "ad_x86.cpp"
  }
}

void convL2I_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10302 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 28285 "ad_x86.cpp"
  }
}

void MoveF2I_stack_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10315 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(rsp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 28299 "ad_x86.cpp"
  }
}

void MoveI2F_stack_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10327 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movflt(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address(rsp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 28313 "ad_x86.cpp"
  }
}

void MoveD2L_stack_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10339 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(rsp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 28327 "ad_x86.cpp"
  }
}

void MoveL2D_stack_reg_partialNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10352 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movdbl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address(rsp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 28341 "ad_x86.cpp"
  }
}

void MoveL2D_stack_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10365 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movdbl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address(rsp, opnd_array(1)->disp(ra_,this,idx1)));
  
#line 28355 "ad_x86.cpp"
  }
}

void MoveF2I_reg_stackNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10378 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movflt(Address(rsp, opnd_array(0)->disp(ra_,this,0)), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
  
#line 28369 "ad_x86.cpp"
  }
}

void MoveI2F_reg_stackNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10390 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movl(Address(rsp, opnd_array(0)->disp(ra_,this,0)), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 28383 "ad_x86.cpp"
  }
}

void MoveD2L_reg_stackNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10402 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movdbl(Address(rsp, opnd_array(0)->disp(ra_,this,0)), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
  
#line 28397 "ad_x86.cpp"
  }
}

void MoveL2D_reg_stackNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10414 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movq(Address(rsp, opnd_array(0)->disp(ra_,this,0)), opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 28411 "ad_x86.cpp"
  }
}

void MoveF2I_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10425 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movdl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
  
#line 28425 "ad_x86.cpp"
  }
}

void MoveD2L_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10436 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movdq(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
  
#line 28439 "ad_x86.cpp"
  }
}

void MoveI2F_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10447 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 28453 "ad_x86.cpp"
  }
}

void MoveL2D_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10458 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

     __ movdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 28467 "ad_x86.cpp"
  }
}

void rep_stosNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 10518 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ clear_mem(opnd_array(2)->as_Register(ra_,this,idx2)/* base */, opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */, as_Register(RAX_enc),
                 opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */, false, knoreg);
  
#line 28484 "ad_x86.cpp"
  }
}

void rep_stos_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// ktmp
  {

#line 10579 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ clear_mem(opnd_array(2)->as_Register(ra_,this,idx2)/* base */, opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */, as_Register(RAX_enc),
                 opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */, false, opnd_array(4)->as_KRegister(ra_,this,idx4)/* ktmp */);
  
#line 28502 "ad_x86.cpp"
  }
}

void rep_stos_largeNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 10630 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ clear_mem(opnd_array(2)->as_Register(ra_,this,idx2)/* base */, opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */, as_Register(RAX_enc),
                 opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */, true, knoreg);
  
#line 28519 "ad_x86.cpp"
  }
}

void rep_stos_large_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// ktmp
  {

#line 10681 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ clear_mem(opnd_array(2)->as_Register(ra_,this,idx2)/* base */, opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */, as_Register(RAX_enc),
                 opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */, true, opnd_array(4)->as_KRegister(ra_,this,idx4)/* ktmp */);
  
#line 28537 "ad_x86.cpp"
  }
}

void rep_stos_imNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// cnt
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// zero
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// ktmp
  {

#line 10696 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

   __ clear_mem(opnd_array(2)->as_Register(ra_,this,idx2)/* base */, opnd_array(1)->constantL(), opnd_array(4)->as_Register(ra_,this,idx4)/* zero */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */, opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp */);
  
#line 28555 "ad_x86.cpp"
  }
}

void string_compareLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  {

#line 10710 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp1 */, StrIntrinsicNode::LL, knoreg);
  
#line 28575 "ad_x86.cpp"
  }
}

void string_compareL_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// ktmp
  {

#line 10726 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp1 */, StrIntrinsicNode::LL, opnd_array(6)->as_KRegister(ra_,this,idx6)/* ktmp */);
  
#line 28596 "ad_x86.cpp"
  }
}

void string_compareUNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  {

#line 10742 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp1 */, StrIntrinsicNode::UU, knoreg);
  
#line 28616 "ad_x86.cpp"
  }
}

void string_compareU_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// ktmp
  {

#line 10758 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp1 */, StrIntrinsicNode::UU, opnd_array(6)->as_KRegister(ra_,this,idx6)/* ktmp */);
  
#line 28637 "ad_x86.cpp"
  }
}

void string_compareLUNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  {

#line 10774 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp1 */, StrIntrinsicNode::LU, knoreg);
  
#line 28657 "ad_x86.cpp"
  }
}

void string_compareLU_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// ktmp
  {

#line 10790 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ string_compare(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp1 */, StrIntrinsicNode::LU, opnd_array(6)->as_KRegister(ra_,this,idx6)/* ktmp */);
  
#line 28678 "ad_x86.cpp"
  }
}

void string_compareULNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  {

#line 10806 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ string_compare(opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */, opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */,
                      opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp1 */, StrIntrinsicNode::UL, knoreg);
  
#line 28698 "ad_x86.cpp"
  }
}

void string_compareUL_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// ktmp
  {

#line 10822 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ string_compare(opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */, opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */,
                      opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */, opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp1 */, StrIntrinsicNode::UL, opnd_array(6)->as_KRegister(ra_,this,idx6)/* ktmp */);
  
#line 28719 "ad_x86.cpp"
  }
}

void string_indexof_conLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// int_cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp_vec
  {

#line 10839 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    int icnt2 = (int)opnd_array(4)->constant();
    if (icnt2 >= 16) {
      // IndexOf for constant substrings with size >= 16 elements
      // which don't need to be loaded through stack.
      __ string_indexofC8(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                          opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, as_Register(RAX_enc),
                          icnt2, opnd_array(0)->as_Register(ra_,this)/* result */,
                          opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp_vec */, as_Register(RCX_enc), StrIntrinsicNode::LL);
    } else {
      // Small strings are loaded through stack if they cross page boundary.
      __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                        opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, as_Register(RAX_enc),
                        icnt2, opnd_array(0)->as_Register(ra_,this)/* result */,
                        opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp_vec */, as_Register(RCX_enc), StrIntrinsicNode::LL);
    }
  
#line 28751 "ad_x86.cpp"
  }
}

void string_indexof_conUNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// int_cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp_vec
  {

#line 10868 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    int icnt2 = (int)opnd_array(4)->constant();
    if (icnt2 >= 8) {
      // IndexOf for constant substrings with size >= 8 elements
      // which don't need to be loaded through stack.
      __ string_indexofC8(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                          opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, as_Register(RAX_enc),
                          icnt2, opnd_array(0)->as_Register(ra_,this)/* result */,
                          opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp_vec */, as_Register(RCX_enc), StrIntrinsicNode::UU);
    } else {
      // Small strings are loaded through stack if they cross page boundary.
      __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                        opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, as_Register(RAX_enc),
                        icnt2, opnd_array(0)->as_Register(ra_,this)/* result */,
                        opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp_vec */, as_Register(RCX_enc), StrIntrinsicNode::UU);
    }
  
#line 28783 "ad_x86.cpp"
  }
}

void string_indexof_conULNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// int_cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp_vec
  {

#line 10897 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    int icnt2 = (int)opnd_array(4)->constant();
    if (icnt2 >= 8) {
      // IndexOf for constant substrings with size >= 8 elements
      // which don't need to be loaded through stack.
      __ string_indexofC8(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                          opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, as_Register(RAX_enc),
                          icnt2, opnd_array(0)->as_Register(ra_,this)/* result */,
                          opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp_vec */, as_Register(RCX_enc), StrIntrinsicNode::UL);
    } else {
      // Small strings are loaded through stack if they cross page boundary.
      __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                        opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, as_Register(RAX_enc),
                        icnt2, opnd_array(0)->as_Register(ra_,this)/* result */,
                        opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp_vec */, as_Register(RCX_enc), StrIntrinsicNode::UL);
    }
  
#line 28815 "ad_x86.cpp"
  }
}

void string_indexofLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp_vec
  {

#line 10925 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      (-1), opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp_vec */, as_Register(RCX_enc), StrIntrinsicNode::LL);
  
#line 28836 "ad_x86.cpp"
  }
}

void string_indexofUNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp_vec
  {

#line 10942 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      (-1), opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp_vec */, as_Register(RCX_enc), StrIntrinsicNode::UU);
  
#line 28857 "ad_x86.cpp"
  }
}

void string_indexofULNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// str2
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// cnt2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp_vec
  {

#line 10959 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ string_indexof(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* str2 */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* cnt2 */,
                      (-1), opnd_array(0)->as_Register(ra_,this)/* result */,
                      opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp_vec */, as_Register(RCX_enc), StrIntrinsicNode::UL);
  
#line 28878 "ad_x86.cpp"
  }
}

void string_indexof_charNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ch
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp_vec1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp_vec2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp_vec3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp
  {

#line 10975 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ string_indexof_char(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* ch */, opnd_array(0)->as_Register(ra_,this)/* result */,
                           opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp_vec1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp_vec2 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* tmp_vec3 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp */);
  
#line 28899 "ad_x86.cpp"
  }
}

void stringL_indexof_charNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ch
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp_vec1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp_vec2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp_vec3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp
  {

#line 10989 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ stringL_indexof_char(opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* ch */, opnd_array(0)->as_Register(ra_,this)/* result */,
                           opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp_vec1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp_vec2 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* tmp_vec3 */, opnd_array(7)->as_Register(ra_,this,idx7)/* tmp */);
  
#line 28920 "ad_x86.cpp"
  }
}

void string_equalsNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// str2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {

#line 11005 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ arrays_equals(false, opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* str2 */,
                     opnd_array(3)->as_Register(ra_,this,idx3)/* cnt */, opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(RBX_enc),
                     opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, false /* char */, knoreg);
  
#line 28940 "ad_x86.cpp"
  }
}

void string_equals_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// str1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// str2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cnt
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// ktmp
  {

#line 11021 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ arrays_equals(false, opnd_array(1)->as_Register(ra_,this,idx1)/* str1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* str2 */,
                     opnd_array(3)->as_Register(ra_,this,idx3)/* cnt */, opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(RBX_enc),
                     opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, false /* char */, opnd_array(6)->as_KRegister(ra_,this,idx6)/* ktmp */);
  
#line 28961 "ad_x86.cpp"
  }
}

void array_equalsBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ary2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {

#line 11038 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ arrays_equals(true, opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* ary2 */,
                     as_Register(RCX_enc), opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(RBX_enc),
                     opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp2 */, false /* char */, knoreg);
  
#line 28980 "ad_x86.cpp"
  }
}

void array_equalsB_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ary2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// ktmp
  {

#line 11054 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ arrays_equals(true, opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* ary2 */,
                     as_Register(RCX_enc), opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(RBX_enc),
                     opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp2 */, false /* char */, opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp */);
  
#line 29000 "ad_x86.cpp"
  }
}

void array_equalsCNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ary2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {

#line 11070 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ arrays_equals(true, opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* ary2 */,
                     as_Register(RCX_enc), opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(RBX_enc),
                     opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp2 */, true /* char */, knoreg);
  
#line 29019 "ad_x86.cpp"
  }
}

void array_equalsC_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ary2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// ktmp
  {

#line 11086 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ arrays_equals(true, opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* ary2 */,
                     as_Register(RCX_enc), opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(RBX_enc),
                     opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp2 */, true /* char */, opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp */);
  
#line 29039 "ad_x86.cpp"
  }
}

void arrays_hashcodeNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// result
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// basic_type
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp_vec1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp_vec2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp_vec3
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp_vec4
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// tmp_vec5
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// tmp_vec6
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// tmp_vec7
  unsigned idx12 = idx11 + opnd_array(11)->num_edges(); 	// tmp_vec8
  unsigned idx13 = idx12 + opnd_array(12)->num_edges(); 	// tmp_vec9
  unsigned idx14 = idx13 + opnd_array(13)->num_edges(); 	// tmp_vec10
  unsigned idx15 = idx14 + opnd_array(14)->num_edges(); 	// tmp_vec11
  unsigned idx16 = idx15 + opnd_array(15)->num_edges(); 	// tmp_vec12
  unsigned idx17 = idx16 + opnd_array(16)->num_edges(); 	// tmp_vec13
  unsigned idx18 = idx17 + opnd_array(17)->num_edges(); 	// tmp1
  unsigned idx19 = idx18 + opnd_array(18)->num_edges(); 	// tmp2
  unsigned idx20 = idx19 + opnd_array(19)->num_edges(); 	// tmp3
  {

#line 11108 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ arrays_hashcode(opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* cnt1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* result */,
                       opnd_array(18)->as_Register(ra_,this,idx18)/* tmp1 */, opnd_array(19)->as_Register(ra_,this,idx19)/* tmp2 */, opnd_array(20)->as_Register(ra_,this,idx20)/* tmp3 */,
                       opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp_vec1 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* tmp_vec2 */, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* tmp_vec3 */,
                       opnd_array(8)->as_XMMRegister(ra_,this,idx8)/* tmp_vec4 */, opnd_array(9)->as_XMMRegister(ra_,this,idx9)/* tmp_vec5 */, opnd_array(10)->as_XMMRegister(ra_,this,idx10)/* tmp_vec6 */,
                       opnd_array(11)->as_XMMRegister(ra_,this,idx11)/* tmp_vec7 */, opnd_array(12)->as_XMMRegister(ra_,this,idx12)/* tmp_vec8 */, opnd_array(13)->as_XMMRegister(ra_,this,idx13)/* tmp_vec9 */,
                       opnd_array(14)->as_XMMRegister(ra_,this,idx14)/* tmp_vec10 */, opnd_array(15)->as_XMMRegister(ra_,this,idx15)/* tmp_vec11 */, opnd_array(16)->as_XMMRegister(ra_,this,idx16)/* tmp_vec12 */,
                       opnd_array(17)->as_XMMRegister(ra_,this,idx17)/* tmp_vec13 */, (BasicType)opnd_array(4)->constant());
  
#line 29078 "ad_x86.cpp"
  }
}

void count_positivesNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// len
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {

#line 11128 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ count_positives(opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* len */,
                       opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(RBX_enc),
                       opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp2 */, knoreg, knoreg);
  
#line 29097 "ad_x86.cpp"
  }
}

void count_positives_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// ary1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// len
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// ktmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// ktmp2
  {

#line 11144 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ count_positives(opnd_array(1)->as_Register(ra_,this,idx1)/* ary1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* len */,
                       opnd_array(0)->as_Register(ra_,this)/* result */, as_Register(RBX_enc),
                       opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp2 */, opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp1 */, opnd_array(6)->as_KRegister(ra_,this,idx6)/* ktmp2 */);
  
#line 29118 "ad_x86.cpp"
  }
}

void string_compressNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {

#line 11161 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ char_array_compress(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                           opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* tmp3 */,
                           opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* tmp4 */, as_Register(RCX_enc), opnd_array(0)->as_Register(ra_,this)/* result */,
                           knoreg, knoreg);
  
#line 29141 "ad_x86.cpp"
  }
}

void string_compress_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// ktmp1
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// ktmp2
  {

#line 11178 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ char_array_compress(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                           opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* tmp3 */,
                           opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* tmp4 */, as_Register(RCX_enc), opnd_array(0)->as_Register(ra_,this)/* result */,
                           opnd_array(8)->as_KRegister(ra_,this,idx8)/* ktmp1 */, opnd_array(9)->as_KRegister(ra_,this,idx9)/* ktmp2 */);
  
#line 29166 "ad_x86.cpp"
  }
}

void string_inflateNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {

#line 11194 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ byte_array_inflate(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                          opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp2 */, knoreg);
  
#line 29185 "ad_x86.cpp"
  }
}

void string_inflate_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// ktmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  {

#line 11208 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ byte_array_inflate(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                          opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */, opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp */);
  
#line 29205 "ad_x86.cpp"
  }
}

void encode_iso_arrayNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {

#line 11224 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ encode_iso_array(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                        opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* tmp3 */,
                        opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* tmp4 */, as_Register(RCX_enc), opnd_array(0)->as_Register(ra_,this)/* result */, false);
  
#line 29227 "ad_x86.cpp"
  }
}

void encode_ascii_arrayNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// len
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {

#line 11241 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ encode_iso_array(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(3)->as_Register(ra_,this,idx3)/* len */,
                        opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* tmp3 */,
                        opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* tmp4 */, as_Register(RCX_enc), opnd_array(0)->as_Register(ra_,this)/* result */, true);
  
#line 29249 "ad_x86.cpp"
  }
}

void overflowAddI_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11258 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ addl(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 29264 "ad_x86.cpp"
  }
}

void overflowAddI_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11271 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ addl(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constant());
  
#line 29279 "ad_x86.cpp"
  }
}

void overflowAddL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11283 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ addq(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 29294 "ad_x86.cpp"
  }
}

void overflowAddL_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11295 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ addq(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constantL());
  
#line 29309 "ad_x86.cpp"
  }
}

void overflowSubI_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11306 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpl(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 29324 "ad_x86.cpp"
  }
}

void overflowSubI_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11317 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpl(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constant());
  
#line 29339 "ad_x86.cpp"
  }
}

void overflowSubL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11328 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpq(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 29354 "ad_x86.cpp"
  }
}

void overflowSubL_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11339 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpq(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constantL());
  
#line 29369 "ad_x86.cpp"
  }
}

void overflowNegI_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11351 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ negl(opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 29384 "ad_x86.cpp"
  }
}

void overflowNegL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11363 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ negq(opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 29399 "ad_x86.cpp"
  }
}

void overflowMulI_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11375 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ imull(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 29414 "ad_x86.cpp"
  }
}

void overflowMulI_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 11387 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ imull(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constant());
  
#line 29430 "ad_x86.cpp"
  }
}

void overflowMulL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11399 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ imulq(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 29445 "ad_x86.cpp"
  }
}

void overflowMulL_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 11411 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ imulq(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constantL());
  
#line 29461 "ad_x86.cpp"
  }
}

void compI_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11428 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpl(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 29476 "ad_x86.cpp"
  }
}

void compI_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11439 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpl(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constant());
  
#line 29491 "ad_x86.cpp"
  }
}

void compI_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11451 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpl(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 29506 "ad_x86.cpp"
  }
}

void testI_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 11462 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ testl(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 29521 "ad_x86.cpp"
  }
}

void testI_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 11473 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ testl(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 29537 "ad_x86.cpp"
  }
}

void testI_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 11484 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ testl(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
  
#line 29553 "ad_x86.cpp"
  }
}

void testI_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 11495 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ testl(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 29569 "ad_x86.cpp"
  }
}

void testI_reg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 11495 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ testl(opnd_array(2)->as_Register(ra_,this,idx2)/* src */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 29585 "ad_x86.cpp"
  }
}

void compU_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11508 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpl(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 29600 "ad_x86.cpp"
  }
}

void compU_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11519 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpl(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constant());
  
#line 29615 "ad_x86.cpp"
  }
}

void compU_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11531 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpl(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 29630 "ad_x86.cpp"
  }
}

void testU_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 11542 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ testl(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 29645 "ad_x86.cpp"
  }
}

void compP_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11553 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpq(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 29660 "ad_x86.cpp"
  }
}

void compP_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11566 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpq(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 29675 "ad_x86.cpp"
  }
}

void compP_mem_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11583 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpq(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 29690 "ad_x86.cpp"
  }
}

void testP_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 11596 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ testq(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 29705 "ad_x86.cpp"
  }
}

void testP_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// op
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 11612 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ testq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), 0xFFFFFFFF);
  
#line 29720 "ad_x86.cpp"
  }
}

void testP_mem_reg0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 11625 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpq(r12, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 29735 "ad_x86.cpp"
  }
}

void compN_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11636 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"
__ cmpl(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */); 
#line 29748 "ad_x86.cpp"
  }
}

void compN_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 11646 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpl(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 29763 "ad_x86.cpp"
  }
}

void compN_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11656 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmp_narrow_oop(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, (jobject)opnd_array(2)->constant());
  
#line 29778 "ad_x86.cpp"
  }
}

void compN_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 11668 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmp_narrow_oop(Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), (jobject)opnd_array(1)->constant());
  
#line 29793 "ad_x86.cpp"
  }
}

void compN_rReg_imm_klassNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11678 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmp_narrow_klass(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, (Klass*)opnd_array(2)->constant());
  
#line 29808 "ad_x86.cpp"
  }
}

void compN_mem_imm_klassNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 11690 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmp_narrow_klass(Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), (Klass*)opnd_array(1)->constant());
  
#line 29823 "ad_x86.cpp"
  }
}

void testN_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 11700 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"
__ testl(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */); 
#line 29836 "ad_x86.cpp"
  }
}

void testN_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 11712 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpl(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), (int)0xFFFFFFFF);
  
#line 29851 "ad_x86.cpp"
  }
}

void testN_mem_reg0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 11725 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpl(r12, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 29866 "ad_x86.cpp"
  }
}

void compL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11739 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpq(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 29881 "ad_x86.cpp"
  }
}

void compL_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11750 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpq(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constantL());
  
#line 29896 "ad_x86.cpp"
  }
}

void compL_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11761 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpq(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 29911 "ad_x86.cpp"
  }
}

void testL_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 11772 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ testq(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 29926 "ad_x86.cpp"
  }
}

void testL_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 11783 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ testq(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->constantL());
  
#line 29942 "ad_x86.cpp"
  }
}

void testL_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 11794 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ testq(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
  
#line 29958 "ad_x86.cpp"
  }
}

void testL_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 11805 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ testq(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 29974 "ad_x86.cpp"
  }
}

void testL_reg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 11805 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ testq(opnd_array(2)->as_Register(ra_,this,idx2)/* src */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 29990 "ad_x86.cpp"
  }
}

void testL_reg_mem2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 11816 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ testq(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 30006 "ad_x86.cpp"
  }
}

void testL_reg_mem2_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 11816 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ testq(opnd_array(2)->as_Register(ra_,this,idx2)/* src */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 30022 "ad_x86.cpp"
  }
}

void cmpU3_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 11835 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Label done;
    __ cmpl(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, -1);
    __ jccb(Assembler::below, done);
    __ setcc(Assembler::notZero, opnd_array(0)->as_Register(ra_,this)/* dst */);
    __ bind(done);
  
#line 30042 "ad_x86.cpp"
  }
}

void cmpL3_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 11859 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Label done;
    __ cmpq(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, -1);
    __ jccb(Assembler::less, done);
    __ setcc(Assembler::notZero, opnd_array(0)->as_Register(ra_,this)/* dst */);
    __ bind(done);
  
#line 30062 "ad_x86.cpp"
  }
}

void cmpUL3_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 11883 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Label done;
    __ cmpq(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */);
    __ movl(opnd_array(0)->as_Register(ra_,this)/* dst */, -1);
    __ jccb(Assembler::below, done);
    __ setcc(Assembler::notZero, opnd_array(0)->as_Register(ra_,this)/* dst */);
    __ bind(done);
  
#line 30082 "ad_x86.cpp"
  }
}

void compUL_rRegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11901 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpq(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* op2 */);
  
#line 30097 "ad_x86.cpp"
  }
}

void compUL_rReg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11912 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpq(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, opnd_array(2)->constantL());
  
#line 30112 "ad_x86.cpp"
  }
}

void compUL_rReg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// op1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// op2
  {

#line 11923 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmpq(opnd_array(1)->as_Register(ra_,this,idx1)/* op1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 30127 "ad_x86.cpp"
  }
}

void testUL_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 11934 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ testq(opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 30142 "ad_x86.cpp"
  }
}

void compB_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  {

#line 11946 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"
__ cmpb(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant()); 
#line 30155 "ad_x86.cpp"
  }
}

void testUB_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 11956 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"
__ testb(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant()); 
#line 30169 "ad_x86.cpp"
  }
}

void testB_mem_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// imm
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  {

#line 11966 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"
__ testb(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant()); 
#line 30183 "ad_x86.cpp"
  }
}

void cmovI_reg_gNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 11978 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovl(Assembler::greater, opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 30199 "ad_x86.cpp"
  }
}

void cmovI_reg_lNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cr
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 12002 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ cmovl(Assembler::less, opnd_array(1)->as_Register(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
  
#line 30215 "ad_x86.cpp"
  }
}

void jmpDirNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 12033 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Label* L = opnd_array(1)->label();
    __ jmp(*L, false); // Always long jump
  
#line 30230 "ad_x86.cpp"
  }
}

uint jmpDirNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 5, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 5);
}

void jmpConNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 12049 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Label* L = opnd_array(3)->label();
    __ jcc((Assembler::Condition)(opnd_array(1)->ccode()), *L, false); // Always long jump
  
#line 30252 "ad_x86.cpp"
  }
}

uint jmpConNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void jmpLoopEndNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 12065 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Label* L = opnd_array(3)->label();
    __ jcc((Assembler::Condition)(opnd_array(1)->ccode()), *L, false); // Always long jump
  
#line 30274 "ad_x86.cpp"
  }
}

uint jmpLoopEndNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void jmpConUNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 12080 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Label* L = opnd_array(3)->label();
    __ jcc((Assembler::Condition)(opnd_array(1)->ccode()), *L, false); // Always long jump
  
#line 30296 "ad_x86.cpp"
  }
}

uint jmpConUNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void jmpConUCFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 12094 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Label* L = opnd_array(3)->label();
    __ jcc((Assembler::Condition)(opnd_array(1)->ccode()), *L, false); // Always long jump
  
#line 30318 "ad_x86.cpp"
  }
}

uint jmpConUCFNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 6, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 6);
}

void jmpConUCF2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 12116 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Label* l = opnd_array(3)->label();
    if (opnd_array(1)->ccode()== Assembler::notEqual) {
      __ jcc(Assembler::parity, *l, false);
      __ jcc(Assembler::notEqual, *l, false);
    } else if (opnd_array(1)->ccode()== Assembler::equal) {
      Label done;
      __ jccb(Assembler::parity, done);
      __ jcc(Assembler::equal, *l, false);
      __ bind(done);
    } else {
       ShouldNotReachHere();
    }
  
#line 30350 "ad_x86.cpp"
  }
}

void partialSubtypeCheckNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super
  {

#line 12158 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Label miss;
    // NB: Callers may assume that, when $result is a valid register,
    // check_klass_subtype_slow_path_linear sets it to a nonzero
    // value.
    __ check_klass_subtype_slow_path_linear(opnd_array(1)->as_Register(ra_,this,idx1)/* sub */, opnd_array(2)->as_Register(ra_,this,idx2)/* super */,
                                            as_Register(RCX_enc), opnd_array(0)->as_Register(ra_,this)/* result */,
                                            nullptr, &miss,
                                            /*set_cond_codes:*/ true);
    __ xorptr(opnd_array(0)->as_Register(ra_,this)/* result */, opnd_array(0)->as_Register(ra_,this)/* result */);
    __ bind(miss);
  
#line 30374 "ad_x86.cpp"
  }
}

void partialSubtypeCheckVarSuperNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// temp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// temp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// temp3
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// temp4
  {

#line 12193 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ lookup_secondary_supers_table_var(opnd_array(1)->as_Register(ra_,this,idx1)/* sub */, opnd_array(2)->as_Register(ra_,this,idx2)/* super */, opnd_array(3)->as_Register(ra_,this,idx3)/* temp1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* temp2 */,
					 opnd_array(5)->as_Register(ra_,this,idx5)/* temp3 */, opnd_array(6)->as_Register(ra_,this,idx6)/* temp4 */, opnd_array(0)->as_Register(ra_,this)/* result */);
  
#line 30394 "ad_x86.cpp"
  }
}

void partialSubtypeCheckConstSuperNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// sub
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// super_reg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// super_con
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// temp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// temp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// temp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// temp4
  {

#line 12212 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    u1 super_klass_slot = ((Klass*)opnd_array(3)->constant())->hash_slot();
    if (InlineSecondarySupersTest) {
      __ lookup_secondary_supers_table_const(opnd_array(1)->as_Register(ra_,this,idx1)/* sub */, opnd_array(2)->as_Register(ra_,this,idx2)/* super_reg */, opnd_array(4)->as_Register(ra_,this,idx4)/* temp1 */, opnd_array(5)->as_Register(ra_,this,idx5)/* temp2 */,
                                       opnd_array(6)->as_Register(ra_,this,idx6)/* temp3 */, opnd_array(7)->as_Register(ra_,this,idx7)/* temp4 */, opnd_array(0)->as_Register(ra_,this)/* result */,
                                       super_klass_slot);
    } else {
      __ call(RuntimeAddress(StubRoutines::lookup_secondary_supers_table_stub(super_klass_slot)));
    }
  
#line 30421 "ad_x86.cpp"
  }
}

void jmpDir_shortNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 12246 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Label* L = opnd_array(1)->label();
    __ jmpb(*L);
  
#line 30436 "ad_x86.cpp"
  }
}

uint jmpDir_shortNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void jmpCon_shortNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 12262 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Label* L = opnd_array(3)->label();
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()), *L);
  
#line 30458 "ad_x86.cpp"
  }
}

uint jmpCon_shortNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void jmpLoopEnd_shortNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 12278 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Label* L = opnd_array(3)->label();
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()), *L);
  
#line 30480 "ad_x86.cpp"
  }
}

uint jmpLoopEnd_shortNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void jmpConU_shortNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 12294 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Label* L = opnd_array(3)->label();
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()), *L);
  
#line 30502 "ad_x86.cpp"
  }
}

uint jmpConU_shortNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void jmpConUCF_shortNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 12309 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Label* L = opnd_array(3)->label();
    __ jccb((Assembler::Condition)(opnd_array(1)->ccode()), *L);
  
#line 30524 "ad_x86.cpp"
  }
}

uint jmpConUCF_shortNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 2, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 2);
}

void jmpConUCF2_shortNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cmp
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// labl
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// 
  {

#line 12333 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Label* l = opnd_array(3)->label();
    if (opnd_array(1)->ccode()== Assembler::notEqual) {
      __ jccb(Assembler::parity, *l);
      __ jccb(Assembler::notEqual, *l);
    } else if (opnd_array(1)->ccode()== Assembler::equal) {
      Label done;
      __ jccb(Assembler::parity, done);
      __ jccb(Assembler::equal, *l);
      __ bind(done);
    } else {
       ShouldNotReachHere();
    }
  
#line 30556 "ad_x86.cpp"
  }
}

uint jmpConUCF2_shortNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 4, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 4);
}

void cmpFastLockNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// scr
  {

#line 12360 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ fast_lock(opnd_array(1)->as_Register(ra_,this,idx1)/* object */, opnd_array(2)->as_Register(ra_,this,idx2)/* box */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */,
                 opnd_array(4)->as_Register(ra_,this,idx4)/* scr */, noreg, noreg, r15_thread, nullptr);
  
#line 30579 "ad_x86.cpp"
  }
}

void cmpFastUnlockNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 12373 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ fast_unlock(opnd_array(1)->as_Register(ra_,this,idx1)/* object */, opnd_array(2)->as_Register(ra_,this,idx2)/* box */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */);
  
#line 30595 "ad_x86.cpp"
  }
}

void cmpFastLockLightweightNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// box
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rax_reg
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 12385 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ fast_lock_lightweight(opnd_array(1)->as_Register(ra_,this,idx1)/* object */, opnd_array(2)->as_Register(ra_,this,idx2)/* box */, opnd_array(3)->as_Register(ra_,this,idx3)/* rax_reg */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, r15_thread);
  
#line 30612 "ad_x86.cpp"
  }
}

void cmpFastUnlockLightweightNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// object
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rax_reg
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 12397 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ fast_unlock_lightweight(opnd_array(1)->as_Register(ra_,this,idx1)/* object */, opnd_array(2)->as_Register(ra_,this,idx2)/* rax_reg */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, r15_thread);
  
#line 30628 "ad_x86.cpp"
  }
}

void safePoint_poll_tlsNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// cr
  {

#line 12414 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ relocate(relocInfo::poll_type);
    address pre_pc = __ pc();
    __ testl(rax, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* poll */, 0));
    assert(nativeInstruction_at(pre_pc)->is_safepoint_poll(), "must emit test %%eax [reg]");
  
#line 30645 "ad_x86.cpp"
  }
}

void mask_all_evexLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 12426 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    int mask_len = Matcher::vector_length(this);
    __ vector_maskall_operation(opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, mask_len);
  
#line 30660 "ad_x86.cpp"
  }
}

void mask_all_evexI_GT32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {

#line 12438 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    int mask_len = Matcher::vector_length(this);
    __ movslq(opnd_array(2)->as_Register(ra_,this,idx2)/* tmp */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
    __ vector_maskall_operation(opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* tmp */, mask_len);
  
#line 30677 "ad_x86.cpp"
  }
}

void CallStaticJavaDirectNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 1836 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    debug_only(int off0 = __ offset());
    if (generate_vzeroupper(Compile::current())) {
      // Clear upper bits of YMM registers to avoid AVX <-> SSE transition penalty
      // Clear upper bits of YMM registers when current compiled code uses
      // wide vectors to avoid AVX <-> SSE transition penalty during call.
      __ vzeroupper();
    }
    debug_only(int off1 = __ offset());
    assert(off1 - off0 == clear_avx_size(), "correct size prediction");
  
#line 30699 "ad_x86.cpp"
  }
  {

#line 1856 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    // JAVA STATIC CALL
    // CALL to fixup routine.  Fixup routine uses ScopeDesc info to
    // determine who we intended to call.
    if (!_method) {
      __ call(RuntimeAddress(CAST_FROM_FN_PTR(address, opnd_array(1)->method())));
    } else if (_method->intrinsic_id() == vmIntrinsicID::_ensureMaterializedForStackWalk) {
      // The NOP here is purely to ensure that eliding a call to
      // JVM_EnsureMaterializedForStackWalk doesn't change the code size.
      __ addr_nop_5();
      __ block_comment("call JVM_EnsureMaterializedForStackWalk (elided)");
    } else {
      int method_index = resolved_method_index(masm);
      RelocationHolder rspec = _optimized_virtual ? opt_virtual_call_Relocation::spec(method_index)
                                                  : static_call_Relocation::spec(method_index);
      address mark = __ pc();
      int call_offset = __ offset();
      __ call(AddressLiteral(CAST_FROM_FN_PTR(address, opnd_array(1)->method()), rspec));
      if (CodeBuffer::supports_shared_stubs() && _method->can_be_statically_bound()) {
        // Calls of the same statically bound method can share
        // a stub to the interpreter.
        __ code()->shared_stub_to_interp_for(_method, call_offset);
      } else {
        // Emit stubs for static call.
        address stub = CompiledDirectCall::emit_to_interp_stub(masm, mark);
        __ clear_inst_mark();
        if (stub == nullptr) {
          ciEnv::current()->record_failure("CodeCache is full");
          return;
        }
      }
    }
    __ post_call_nop();
  
#line 30738 "ad_x86.cpp"
  }
  {

#line 2827 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    if (VerifyStackAtCalls) {
      // Check that stack depth is unchanged: find majik cookie on stack
      int framesize = ra_->reg2offset_unchecked(OptoReg::add(ra_->_matcher._old_SP, -3*VMRegImpl::slots_per_word));
      Label L;
      __ cmpptr(Address(rsp, framesize), (int32_t)0xbadb100d);
      __ jccb(Assembler::equal, L);
      // Die if stack mismatch
      __ int3();
      __ bind(L);
    }
  
#line 30755 "ad_x86.cpp"
  }
}

void CallDynamicJavaDirectNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 1836 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    debug_only(int off0 = __ offset());
    if (generate_vzeroupper(Compile::current())) {
      // Clear upper bits of YMM registers to avoid AVX <-> SSE transition penalty
      // Clear upper bits of YMM registers when current compiled code uses
      // wide vectors to avoid AVX <-> SSE transition penalty during call.
      __ vzeroupper();
    }
    debug_only(int off1 = __ offset());
    assert(off1 - off0 == clear_avx_size(), "correct size prediction");
  
#line 30777 "ad_x86.cpp"
  }
  {

#line 1891 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ ic_call((address)opnd_array(1)->method(), resolved_method_index(masm));
    __ post_call_nop();
  
#line 30786 "ad_x86.cpp"
  }
  {

#line 2827 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    if (VerifyStackAtCalls) {
      // Check that stack depth is unchanged: find majik cookie on stack
      int framesize = ra_->reg2offset_unchecked(OptoReg::add(ra_->_matcher._old_SP, -3*VMRegImpl::slots_per_word));
      Label L;
      __ cmpptr(Address(rsp, framesize), (int32_t)0xbadb100d);
      __ jccb(Assembler::equal, L);
      // Die if stack mismatch
      __ int3();
      __ bind(L);
    }
  
#line 30803 "ad_x86.cpp"
  }
}

void CallRuntimeDirectNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 1836 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    debug_only(int off0 = __ offset());
    if (generate_vzeroupper(Compile::current())) {
      // Clear upper bits of YMM registers to avoid AVX <-> SSE transition penalty
      // Clear upper bits of YMM registers when current compiled code uses
      // wide vectors to avoid AVX <-> SSE transition penalty during call.
      __ vzeroupper();
    }
    debug_only(int off1 = __ offset());
    assert(off1 - off0 == clear_avx_size(), "correct size prediction");
  
#line 30825 "ad_x86.cpp"
  }
  {

#line 1848 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    // No relocation needed
    __ mov64(r10, (int64_t) opnd_array(1)->method());
    __ call(r10);
    __ post_call_nop();
  
#line 30836 "ad_x86.cpp"
  }
}

void CallLeafDirectNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 1836 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    debug_only(int off0 = __ offset());
    if (generate_vzeroupper(Compile::current())) {
      // Clear upper bits of YMM registers to avoid AVX <-> SSE transition penalty
      // Clear upper bits of YMM registers when current compiled code uses
      // wide vectors to avoid AVX <-> SSE transition penalty during call.
      __ vzeroupper();
    }
    debug_only(int off1 = __ offset());
    assert(off1 - off0 == clear_avx_size(), "correct size prediction");
  
#line 30858 "ad_x86.cpp"
  }
  {

#line 1848 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    // No relocation needed
    __ mov64(r10, (int64_t) opnd_array(1)->method());
    __ call(r10);
    __ post_call_nop();
  
#line 30869 "ad_x86.cpp"
  }
}

void CallLeafDirectVectorNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 1848 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    // No relocation needed
    __ mov64(r10, (int64_t) opnd_array(1)->method());
    __ call(r10);
    __ post_call_nop();
  
#line 30886 "ad_x86.cpp"
  }
}

void CallLeafNoFPDirectNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 1836 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    debug_only(int off0 = __ offset());
    if (generate_vzeroupper(Compile::current())) {
      // Clear upper bits of YMM registers to avoid AVX <-> SSE transition penalty
      // Clear upper bits of YMM registers when current compiled code uses
      // wide vectors to avoid AVX <-> SSE transition penalty during call.
      __ vzeroupper();
    }
    debug_only(int off1 = __ offset());
    assert(off1 - off0 == clear_avx_size(), "correct size prediction");
  
#line 30908 "ad_x86.cpp"
  }
  {

#line 1848 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    // No relocation needed
    __ mov64(r10, (int64_t) opnd_array(1)->method());
    __ call(r10);
    __ post_call_nop();
  
#line 30919 "ad_x86.cpp"
  }
}

void RetNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 12536 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ ret(0);
  
#line 30933 "ad_x86.cpp"
  }
}

void TailCalljmpIndNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// method_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {

#line 12554 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ jmp(opnd_array(1)->as_Register(ra_,this,idx1)/* jump_target */);
  
#line 30948 "ad_x86.cpp"
  }
}

void tailjmpIndNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// ex_oop
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// 
  {

#line 12569 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ popq(as_Register(RDX_enc));
    __ jmp(opnd_array(1)->as_Register(ra_,this,idx1)/* jump_target */);
  
#line 30964 "ad_x86.cpp"
  }
}

void ForwardExceptionjmpNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 12582 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ jump(RuntimeAddress(StubRoutines::forward_exception_entry()), noreg);
  
#line 30978 "ad_x86.cpp"
  }
}

void CreateExceptionNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint CreateExceptionNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void RethrowExceptionNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 12611 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ jump(RuntimeAddress(OptoRuntime::rethrow_stub()), noreg);
  
#line 31004 "ad_x86.cpp"
  }
}

void tlsLoadPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  // User did not define which encode class to use.
}

uint tlsLoadPNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void leaI_rReg_rReg_peepNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 12738 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    if (src1 != rbp && src1 != r13) {
      __ leal(dst, Address(src1, src2, Address::times_1));
    } else {
      assert(src2 != rbp && src2 != r13, "");
      __ leal(dst, Address(src2, src1, Address::times_1));
    }
  
#line 31039 "ad_x86.cpp"
  }
}

void leaI_rReg_immI_peepNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 12757 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ leal(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->constant()));
  
#line 31054 "ad_x86.cpp"
  }
}

void leaI_rReg_immI2_peepNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 12768 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Address::ScaleFactor scale = static_cast<Address::ScaleFactor>(opnd_array(2)->constant());
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    if (scale == Address::times_2 && src != rbp && src != r13) {
      __ leal(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(src, src, Address::times_1));
    } else {
      __ leal(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(noreg, src, scale));
    }
  
#line 31075 "ad_x86.cpp"
  }
}

void leaL_rReg_rReg_peepNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 12785 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Register dst = opnd_array(0)->as_Register(ra_,this)/* dst */;
    Register src1 = opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */;
    Register src2 = opnd_array(2)->as_Register(ra_,this,idx2)/* src2 */;
    if (src1 != rbp && src1 != r13) {
      __ leaq(dst, Address(src1, src2, Address::times_1));
    } else {
      assert(src2 != rbp && src2 != r13, "");
      __ leaq(dst, Address(src2, src1, Address::times_1));
    }
  
#line 31098 "ad_x86.cpp"
  }
}

void leaL_rReg_immL32_peepNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 12804 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->constantL()));
  
#line 31113 "ad_x86.cpp"
  }
}

void leaL_rReg_immI2_peepNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 12815 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    Address::ScaleFactor scale = static_cast<Address::ScaleFactor>(opnd_array(2)->constant());
    Register src = opnd_array(1)->as_Register(ra_,this,idx1)/* src */;
    if (scale == Address::times_2 && src != rbp && src != r13) {
      __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(src, src, Address::times_1));
    } else {
      __ leaq(opnd_array(0)->as_Register(ra_,this)/* dst */, Address(noreg, src, scale));
    }
  
#line 31134 "ad_x86.cpp"
  }
}

void ShouldNotReachHereNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 5;
  unsigned idx1 = 5; 	// 
  {

#line 2984 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    if (is_reachable()) {
      __ stop(_halt_reason);
    }
  
#line 31150 "ad_x86.cpp"
  }
}

void addF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3000 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ addss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 31165 "ad_x86.cpp"
  }
}

void addF_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3012 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ addss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 31180 "ad_x86.cpp"
  }
}

void addF_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 3012 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ addss(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 31195 "ad_x86.cpp"
  }
}

void addF_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 3023 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ addss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31210 "ad_x86.cpp"
  }
}

void addF_immNode::eval_constant(Compile* C) {
  {

#line 3024 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 31219 "ad_x86.cpp"
  }
}
void addF_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3035 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vaddss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 31233 "ad_x86.cpp"
  }
}

void addF_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3047 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vaddss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 31248 "ad_x86.cpp"
  }
}

void addF_reg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {

#line 3047 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vaddss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src1 */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 31263 "ad_x86.cpp"
  }
}

void addF_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 3059 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vaddss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31278 "ad_x86.cpp"
  }
}

void addF_reg_immNode::eval_constant(Compile* C) {
  {

#line 3060 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 31287 "ad_x86.cpp"
  }
}
void addD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3071 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ addsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 31301 "ad_x86.cpp"
  }
}

void addD_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3083 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ addsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 31316 "ad_x86.cpp"
  }
}

void addD_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 3083 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ addsd(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 31331 "ad_x86.cpp"
  }
}

void addD_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 3094 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ addsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31346 "ad_x86.cpp"
  }
}

void addD_immNode::eval_constant(Compile* C) {
  {

#line 3095 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 31355 "ad_x86.cpp"
  }
}
void addD_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3106 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vaddsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 31369 "ad_x86.cpp"
  }
}

void addD_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3118 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vaddsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 31384 "ad_x86.cpp"
  }
}

void addD_reg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {

#line 3118 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vaddsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src1 */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 31399 "ad_x86.cpp"
  }
}

void addD_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 3130 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vaddsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31414 "ad_x86.cpp"
  }
}

void addD_reg_immNode::eval_constant(Compile* C) {
  {

#line 3131 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 31423 "ad_x86.cpp"
  }
}
void subF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3142 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ subss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 31437 "ad_x86.cpp"
  }
}

void subF_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3154 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ subss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 31452 "ad_x86.cpp"
  }
}

void subF_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 3165 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ subss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31467 "ad_x86.cpp"
  }
}

void subF_immNode::eval_constant(Compile* C) {
  {

#line 3166 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 31476 "ad_x86.cpp"
  }
}
void subF_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3177 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vsubss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 31490 "ad_x86.cpp"
  }
}

void subF_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3189 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vsubss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 31505 "ad_x86.cpp"
  }
}

void subF_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 3201 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vsubss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31520 "ad_x86.cpp"
  }
}

void subF_reg_immNode::eval_constant(Compile* C) {
  {

#line 3202 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 31529 "ad_x86.cpp"
  }
}
void subD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3213 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ subsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 31543 "ad_x86.cpp"
  }
}

void subD_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3225 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ subsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 31558 "ad_x86.cpp"
  }
}

void subD_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 3236 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ subsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31573 "ad_x86.cpp"
  }
}

void subD_immNode::eval_constant(Compile* C) {
  {

#line 3237 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 31582 "ad_x86.cpp"
  }
}
void subD_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3248 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vsubsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 31596 "ad_x86.cpp"
  }
}

void subD_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3260 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vsubsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 31611 "ad_x86.cpp"
  }
}

void subD_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 3272 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vsubsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31626 "ad_x86.cpp"
  }
}

void subD_reg_immNode::eval_constant(Compile* C) {
  {

#line 3273 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 31635 "ad_x86.cpp"
  }
}
void mulF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3284 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ mulss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 31649 "ad_x86.cpp"
  }
}

void mulF_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3296 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ mulss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 31664 "ad_x86.cpp"
  }
}

void mulF_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 3296 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ mulss(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 31679 "ad_x86.cpp"
  }
}

void mulF_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 3307 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ mulss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31694 "ad_x86.cpp"
  }
}

void mulF_immNode::eval_constant(Compile* C) {
  {

#line 3308 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 31703 "ad_x86.cpp"
  }
}
void mulF_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3319 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vmulss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 31717 "ad_x86.cpp"
  }
}

void mulF_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3331 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vmulss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 31732 "ad_x86.cpp"
  }
}

void mulF_reg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {

#line 3331 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vmulss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src1 */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 31747 "ad_x86.cpp"
  }
}

void mulF_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 3343 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vmulss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31762 "ad_x86.cpp"
  }
}

void mulF_reg_immNode::eval_constant(Compile* C) {
  {

#line 3344 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 31771 "ad_x86.cpp"
  }
}
void mulD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3355 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ mulsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 31785 "ad_x86.cpp"
  }
}

void mulD_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3367 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ mulsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 31800 "ad_x86.cpp"
  }
}

void mulD_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 3367 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ mulsd(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 31815 "ad_x86.cpp"
  }
}

void mulD_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 3378 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ mulsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31830 "ad_x86.cpp"
  }
}

void mulD_immNode::eval_constant(Compile* C) {
  {

#line 3379 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 31839 "ad_x86.cpp"
  }
}
void mulD_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3390 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vmulsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 31853 "ad_x86.cpp"
  }
}

void mulD_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3402 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vmulsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 31868 "ad_x86.cpp"
  }
}

void mulD_reg_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src2
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {

#line 3402 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vmulsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src1 */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
  
#line 31883 "ad_x86.cpp"
  }
}

void mulD_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 3414 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vmulsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31898 "ad_x86.cpp"
  }
}

void mulD_reg_immNode::eval_constant(Compile* C) {
  {

#line 3415 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 31907 "ad_x86.cpp"
  }
}
void divF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3426 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ divss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 31921 "ad_x86.cpp"
  }
}

void divF_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3438 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ divss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 31936 "ad_x86.cpp"
  }
}

void divF_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 3449 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ divss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 31951 "ad_x86.cpp"
  }
}

void divF_immNode::eval_constant(Compile* C) {
  {

#line 3450 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 31960 "ad_x86.cpp"
  }
}
void divF_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3461 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vdivss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 31974 "ad_x86.cpp"
  }
}

void divF_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3473 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vdivss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 31989 "ad_x86.cpp"
  }
}

void divF_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 3485 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vdivss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 32004 "ad_x86.cpp"
  }
}

void divF_reg_immNode::eval_constant(Compile* C) {
  {

#line 3486 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 32013 "ad_x86.cpp"
  }
}
void divD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3497 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ divsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 32027 "ad_x86.cpp"
  }
}

void divD_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3509 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ divsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 32042 "ad_x86.cpp"
  }
}

void divD_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 3520 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ divsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 32057 "ad_x86.cpp"
  }
}

void divD_immNode::eval_constant(Compile* C) {
  {

#line 3521 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 32066 "ad_x86.cpp"
  }
}
void divD_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3532 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vdivsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 32080 "ad_x86.cpp"
  }
}

void divD_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 3544 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vdivsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 32095 "ad_x86.cpp"
  }
}

void divD_reg_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// con
  {

#line 3556 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vdivsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, InternalAddress(__ code()->consts()->start() + constant_offset()));
  
#line 32110 "ad_x86.cpp"
  }
}

void divD_reg_immNode::eval_constant(Compile* C) {
  {

#line 3557 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(2));
#line 32119 "ad_x86.cpp"
  }
}
void absF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 3567 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ andps(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, ExternalAddress(float_signmask()));
  
#line 32132 "ad_x86.cpp"
  }
}

void absF_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3578 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = Assembler::AVX_128bit;
    __ vandps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */,
              ExternalAddress(float_signmask()), vlen_enc);
  
#line 32148 "ad_x86.cpp"
  }
}

void absD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 3592 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ andpd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, ExternalAddress(double_signmask()));
  
#line 32162 "ad_x86.cpp"
  }
}

void absD_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3604 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = Assembler::AVX_128bit;
    __ vandpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */,
              ExternalAddress(double_signmask()), vlen_enc);
  
#line 32178 "ad_x86.cpp"
  }
}

void negF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 3617 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ xorps(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, ExternalAddress(float_signflip()));
  
#line 32192 "ad_x86.cpp"
  }
}

void negF_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3628 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vnegatess(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */,
                 ExternalAddress(float_signflip()));
  
#line 32207 "ad_x86.cpp"
  }
}

void negD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 3641 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ xorpd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, ExternalAddress(double_signflip()));
  
#line 32221 "ad_x86.cpp"
  }
}

void negD_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3653 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vnegatesd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */,
                 ExternalAddress(double_signflip()));
  
#line 32236 "ad_x86.cpp"
  }
}

void sqrtF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 3666 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ sqrtss(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */);
  
#line 32250 "ad_x86.cpp"
  }
}

void sqrtD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 3678 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ sqrtsd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */);
  
#line 32264 "ad_x86.cpp"
  }
}

void convF2HF_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// tmp
  {

#line 3689 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ flt_to_flt16(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* tmp */);
  
#line 32279 "ad_x86.cpp"
  }
}

void convF2HF_mem_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ktmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rtmp
  {

#line 3700 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ movl(opnd_array(4)->as_Register(ra_,this,idx4)/* rtmp */, 0x1);
    __ kmovwl(opnd_array(3)->as_KRegister(ra_,this,idx3)/* ktmp */, opnd_array(4)->as_Register(ra_,this,idx4)/* rtmp */);
    __ evcvtps2ph(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(3)->as_KRegister(ra_,this,idx3)/* ktmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, 0x04, Assembler::AVX_128bit);
  
#line 32298 "ad_x86.cpp"
  }
}

void vconvF2HFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3711 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    __ vcvtps2ph(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0x04, vlen_enc);
  
#line 32313 "ad_x86.cpp"
  }
}

void vconvF2HF_mem_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 3722 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(2));
    __ vcvtps2ph(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, 0x04, vlen_enc);
  
#line 32329 "ad_x86.cpp"
  }
}

void convHF2F_reg_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3732 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ flt16_to_flt(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 32343 "ad_x86.cpp"
  }
}

void vconvHF2F_reg_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 3741 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vcvtph2ps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
  
#line 32358 "ad_x86.cpp"
  }
}

void vconvHF2FNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3752 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vcvtph2ps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
  
#line 32373 "ad_x86.cpp"
  }
}

void reinterpret_maskNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 3766 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    // empty
  
#line 32387 "ad_x86.cpp"
  }
}

void reinterpret_mask_W2BNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// xtmp
  {

#line 3781 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

     int src_sz = Matcher::vector_length(this, opnd_array(1))*type2aelembytes(T_SHORT);
     int dst_sz = Matcher::vector_length(this)*type2aelembytes(T_BYTE);
     assert(src_sz == dst_sz , "src and dst size mismatch");
     int vlen_enc = vector_length_encoding(src_sz);
     __  evpmovm2w(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* xtmp */, opnd_array(1)->as_KRegister(ra_,this,idx1)/* src */, vlen_enc);
     __  evpmovb2m(opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* xtmp */, vlen_enc);
  
#line 32407 "ad_x86.cpp"
  }
}

void reinterpret_mask_D2BNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// xtmp
  {

#line 3802 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

     int src_sz = Matcher::vector_length(this, opnd_array(1))*type2aelembytes(T_INT);
     int dst_sz = Matcher::vector_length(this)*type2aelembytes(T_BYTE);
     assert(src_sz == dst_sz , "src and dst size mismatch");
     int vlen_enc = vector_length_encoding(src_sz);
     __  evpmovm2d(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* xtmp */, opnd_array(1)->as_KRegister(ra_,this,idx1)/* src */, vlen_enc);
     __  evpmovb2m(opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* xtmp */, vlen_enc);
  
#line 32427 "ad_x86.cpp"
  }
}

void reinterpret_mask_Q2BNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// xtmp
  {

#line 3823 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

     int src_sz = Matcher::vector_length(this, opnd_array(1))*type2aelembytes(T_LONG);
     int dst_sz = Matcher::vector_length(this)*type2aelembytes(T_BYTE);
     assert(src_sz == dst_sz , "src and dst size mismatch");
     int vlen_enc = vector_length_encoding(src_sz);
     __  evpmovm2q(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* xtmp */, opnd_array(1)->as_KRegister(ra_,this,idx1)/* src */, vlen_enc);
     __  evpmovb2m(opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* xtmp */, vlen_enc);
  
#line 32447 "ad_x86.cpp"
  }
}

void reinterpretNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 3840 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    // empty
  
#line 32461 "ad_x86.cpp"
  }
}

void reinterpret_expandNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 3853 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(Matcher::vector_length_in_bytes(this)       <= 16, "required");
    assert(Matcher::vector_length_in_bytes(this, opnd_array(1)) <=  8, "required");

    int src_vlen_in_bytes = Matcher::vector_length_in_bytes(this, opnd_array(1));
    if (src_vlen_in_bytes == 4) {
      __ movdqu(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, ExternalAddress(vector_32_bit_mask()), noreg);
    } else {
      assert(src_vlen_in_bytes == 8, "");
      __ movdqu(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, ExternalAddress(vector_64_bit_mask()), noreg);
    }
    __ pand(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
  
#line 32486 "ad_x86.cpp"
  }
}

void vreinterpret_expand4Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3877 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vpand(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, ExternalAddress(vector_32_bit_mask()), 0, noreg);
  
#line 32500 "ad_x86.cpp"
  }
}

void vreinterpret_expandNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3892 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    switch (Matcher::vector_length_in_bytes(this, opnd_array(1))) {
      case  8: __ movq   (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */); break;
      case 16: __ movdqu (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */); break;
      case 32: __ vmovdqu(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */); break;
      default: ShouldNotReachHere();
    }
  
#line 32519 "ad_x86.cpp"
  }
}

void reinterpret_shrinkNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 3909 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    switch (Matcher::vector_length_in_bytes(this)) {
      case  4: __ movfltz(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */); break;
      case  8: __ movq   (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */); break;
      case 16: __ movdqu (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */); break;
      case 32: __ vmovdqu(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */); break;
      default: ShouldNotReachHere();
    }
  
#line 32539 "ad_x86.cpp"
  }
}

void roundD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rmode
  {

#line 3928 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE >= 4, "required");
    if ((UseAVX == 0) && (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */!= opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */)) {
      __ pxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    }
    __ roundsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 32558 "ad_x86.cpp"
  }
}

void roundD_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rmode
  {

#line 3942 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE >= 4, "required");
    __ roundsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, InternalAddress(__ code()->consts()->start() + constant_offset()), opnd_array(2)->constant(), noreg);
  
#line 32574 "ad_x86.cpp"
  }
}

void roundD_immNode::eval_constant(Compile* C) {
  {

#line 3944 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, opnd_array(1));
#line 32583 "ad_x86.cpp"
  }
}
void vroundD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rmode
  {

#line 3953 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "required");
    int vlen_enc = vector_length_encoding(this);
    __ vroundpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant(), vlen_enc);
  
#line 32599 "ad_x86.cpp"
  }
}

void vround8D_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rmode
  {

#line 3965 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");
    __ vrndscalepd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant(), Assembler::AVX_512bit);
  
#line 32615 "ad_x86.cpp"
  }
}

void vroundD_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rmode
  {

#line 3976 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "required");
    int vlen_enc = vector_length_encoding(this);
    __ vroundpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant(), vlen_enc);
  
#line 32632 "ad_x86.cpp"
  }
}

void vround8D_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rmode
  {

#line 3988 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");
    __ vrndscalepd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->constant(), Assembler::AVX_512bit);
  
#line 32648 "ad_x86.cpp"
  }
}

void onspinwaitNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// 
  {

#line 4004 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ pause();
  
#line 32662 "ad_x86.cpp"
  }
}

void fmaD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// c
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// a
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// b
  {

#line 4015 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ fmad(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* c */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* a */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* b */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* c */);
  
#line 32679 "ad_x86.cpp"
  }
}

void fmaF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// c
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// a
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// b
  {

#line 4027 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    __ fmaf(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* c */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* a */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* b */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* c */);
  
#line 32696 "ad_x86.cpp"
  }
}

void MoveVec2LegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4040 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    ShouldNotReachHere();
  
#line 32710 "ad_x86.cpp"
  }
}

void MoveLeg2VecNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4049 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    ShouldNotReachHere();
  
#line 32724 "ad_x86.cpp"
  }
}

void loadVNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4062 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ load_vector(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), Matcher::vector_length_in_bytes(this));
  
#line 32738 "ad_x86.cpp"
  }
}

void storeVNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 4073 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    switch (Matcher::vector_length_in_bytes(this, opnd_array(2))) {
      case  4: __ movdl    (Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */); break;
      case  8: __ movq     (Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */); break;
      case 16: __ movdqu   (Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */); break;
      case 32: __ vmovdqu  (Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */); break;
      case 64: __ evmovdqul(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, Assembler::AVX_512bit); break;
      default: ShouldNotReachHere();
    }
  
#line 32760 "ad_x86.cpp"
  }
}

void gatherNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// mask
  {

#line 4096 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    assert(!is_subword_type(elem_bt), "sanity"); // T_INT, T_LONG, T_FLOAT, T_DOUBLE
    __ vpcmpeqd(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* mask */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* mask */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* mask */, vlen_enc);
    __ lea(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ vgather(elem_bt, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* idx */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* mask */, vlen_enc);
  
#line 32783 "ad_x86.cpp"
  }
}

void evgatherNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// ktmp
  {

#line 4114 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ kxnorwl(opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp */, opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp */, opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp */);
    __ lea(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ evgather(elem_bt, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* idx */, vlen_enc);
  
#line 32805 "ad_x86.cpp"
  }
}

void evgather_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// ktmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp
  {

#line 4130 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "sanity");
    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    assert(!is_subword_type(elem_bt), "sanity"); // T_INT, T_LONG, T_FLOAT, T_DOUBLE
    // Note: Since gather instruction partially updates the opmask register used
    // for predication hense moving mask operand to a temporary.
    __ kmovwl(opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp */, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */);
    __ vpxor(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* dst */, vlen_enc);
    __ lea(opnd_array(6)->as_Register(ra_,this,idx6)/* tmp */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ evgather(elem_bt, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* dst */, opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* idx */, vlen_enc);
  
#line 32833 "ad_x86.cpp"
  }
}

void vgather_subwordLE8BNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx_base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// offset
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// rtmp
  {

#line 4150 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ lea(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ vgather8b_offset(elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* idx_base */, noreg, opnd_array(5)->as_Register(ra_,this,idx5)/* rtmp */, vlen_enc);
  
#line 32854 "ad_x86.cpp"
  }
}

void vgather_subwordGT8BNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx_base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// offset
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// idx_base_temp
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// xtmp1
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// xtmp2
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// xtmp3
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// rtmp
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// length
  {

#line 4165 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    int vector_len = Matcher::vector_length(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ lea(opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ movptr(opnd_array(6)->as_Register(ra_,this,idx6)/* idx_base_temp */, opnd_array(2)->as_Register(ra_,this,idx2)/* idx_base */);
    __ vgather_subword(elem_bt, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* dst */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* idx_base_temp */, noreg, noreg, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* xtmp1 */,
                       opnd_array(8)->as_XMMRegister(ra_,this,idx8)/* xtmp2 */, opnd_array(9)->as_XMMRegister(ra_,this,idx9)/* xtmp3 */, opnd_array(10)->as_Register(ra_,this,idx10)/* rtmp */, noreg, opnd_array(11)->as_Register(ra_,this,idx11)/* length */, vector_len, vlen_enc);
  
#line 32884 "ad_x86.cpp"
  }
}

void vgather_subwordLE8B_offNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx_base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// offset
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// rtmp
  {

#line 4182 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ lea(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ vgather8b_offset(elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* idx_base */, opnd_array(3)->as_Register(ra_,this,idx3)/* offset */, opnd_array(5)->as_Register(ra_,this,idx5)/* rtmp */, vlen_enc);
  
#line 32905 "ad_x86.cpp"
  }
}

void vgather_subwordGT8B_offNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx_base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// offset
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// idx_base_temp
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// xtmp1
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// xtmp2
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// xtmp3
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// rtmp
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// length
  {

#line 4198 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    int vector_len = Matcher::vector_length(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ lea(opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ movptr(opnd_array(6)->as_Register(ra_,this,idx6)/* idx_base_temp */, opnd_array(2)->as_Register(ra_,this,idx2)/* idx_base */);
    __ vgather_subword(elem_bt, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* dst */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp */, opnd_array(6)->as_Register(ra_,this,idx6)/* idx_base_temp */, opnd_array(3)->as_Register(ra_,this,idx3)/* offset */, noreg, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* xtmp1 */,
                       opnd_array(8)->as_XMMRegister(ra_,this,idx8)/* xtmp2 */, opnd_array(9)->as_XMMRegister(ra_,this,idx9)/* xtmp3 */, opnd_array(10)->as_Register(ra_,this,idx10)/* rtmp */, noreg, opnd_array(11)->as_Register(ra_,this,idx11)/* length */, vector_len, vlen_enc);
  
#line 32935 "ad_x86.cpp"
  }
}

void vgather_masked_subwordLE8B_avx3Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx_base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// offset
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// mask_idx
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// rtmp
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// rtmp2
  {

#line 4217 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ xorq(opnd_array(5)->as_Register(ra_,this,idx5)/* mask_idx */, opnd_array(5)->as_Register(ra_,this,idx5)/* mask_idx */);
    __ lea(opnd_array(6)->as_Register(ra_,this,idx6)/* tmp */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ kmovql(opnd_array(8)->as_Register(ra_,this,idx8)/* rtmp2 */, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */);
    __ vgather8b_masked_offset(elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* idx_base */, noreg, opnd_array(8)->as_Register(ra_,this,idx8)/* rtmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* mask_idx */, opnd_array(7)->as_Register(ra_,this,idx7)/* rtmp */, vlen_enc);
  
#line 32961 "ad_x86.cpp"
  }
}

void vgather_masked_subwordGT8B_avx3Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx_base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// offset
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// dst
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// idx_base_temp
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// xtmp1
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// xtmp2
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// xtmp3
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// rtmp
  unsigned idx12 = idx11 + opnd_array(11)->num_edges(); 	// rtmp2
  unsigned idx13 = idx12 + opnd_array(12)->num_edges(); 	// mask_idx
  unsigned idx14 = idx13 + opnd_array(13)->num_edges(); 	// length
  {

#line 4234 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    int vector_len = Matcher::vector_length(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ xorq(opnd_array(13)->as_Register(ra_,this,idx13)/* mask_idx */, opnd_array(13)->as_Register(ra_,this,idx13)/* mask_idx */);
    __ lea(opnd_array(6)->as_Register(ra_,this,idx6)/* tmp */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ movptr(opnd_array(7)->as_Register(ra_,this,idx7)/* idx_base_temp */, opnd_array(2)->as_Register(ra_,this,idx2)/* idx_base */);
    __ kmovql(opnd_array(12)->as_Register(ra_,this,idx12)/* rtmp2 */, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */);
    __ vgather_subword(elem_bt, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* dst */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp */, opnd_array(7)->as_Register(ra_,this,idx7)/* idx_base_temp */, noreg, opnd_array(12)->as_Register(ra_,this,idx12)/* rtmp2 */, opnd_array(8)->as_XMMRegister(ra_,this,idx8)/* xtmp1 */,
                       opnd_array(9)->as_XMMRegister(ra_,this,idx9)/* xtmp2 */, opnd_array(10)->as_XMMRegister(ra_,this,idx10)/* xtmp3 */, opnd_array(11)->as_Register(ra_,this,idx11)/* rtmp */, opnd_array(13)->as_Register(ra_,this,idx13)/* mask_idx */, opnd_array(14)->as_Register(ra_,this,idx14)/* length */, vector_len, vlen_enc);
  
#line 32996 "ad_x86.cpp"
  }
}

void vgather_masked_subwordLE8B_off_avx3Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx_base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// offset
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// mask_idx
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// rtmp
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// rtmp2
  {

#line 4253 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ xorq(opnd_array(5)->as_Register(ra_,this,idx5)/* mask_idx */, opnd_array(5)->as_Register(ra_,this,idx5)/* mask_idx */);
    __ lea(opnd_array(6)->as_Register(ra_,this,idx6)/* tmp */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ kmovql(opnd_array(8)->as_Register(ra_,this,idx8)/* rtmp2 */, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */);
    __ vgather8b_masked_offset(elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* idx_base */, opnd_array(4)->as_Register(ra_,this,idx4)/* offset */,
                                opnd_array(8)->as_Register(ra_,this,idx8)/* rtmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* mask_idx */, opnd_array(7)->as_Register(ra_,this,idx7)/* rtmp */, vlen_enc);
  
#line 33023 "ad_x86.cpp"
  }
}

void vgather_masked_subwordGT8B_off_avx3Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx_base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// offset
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// dst
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// idx_base_temp
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// xtmp1
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// xtmp2
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// xtmp3
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// rtmp
  unsigned idx12 = idx11 + opnd_array(11)->num_edges(); 	// rtmp2
  unsigned idx13 = idx12 + opnd_array(12)->num_edges(); 	// mask_idx
  unsigned idx14 = idx13 + opnd_array(13)->num_edges(); 	// length
  {

#line 4271 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    int vector_len = Matcher::vector_length(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ xorq(opnd_array(13)->as_Register(ra_,this,idx13)/* mask_idx */, opnd_array(13)->as_Register(ra_,this,idx13)/* mask_idx */);
    __ lea(opnd_array(6)->as_Register(ra_,this,idx6)/* tmp */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ movptr(opnd_array(7)->as_Register(ra_,this,idx7)/* idx_base_temp */, opnd_array(2)->as_Register(ra_,this,idx2)/* idx_base */);
    __ kmovql(opnd_array(12)->as_Register(ra_,this,idx12)/* rtmp2 */, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */);
    __ vgather_subword(elem_bt, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* dst */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp */, opnd_array(7)->as_Register(ra_,this,idx7)/* idx_base_temp */, opnd_array(4)->as_Register(ra_,this,idx4)/* offset */, opnd_array(12)->as_Register(ra_,this,idx12)/* rtmp2 */, opnd_array(8)->as_XMMRegister(ra_,this,idx8)/* xtmp1 */,
                       opnd_array(9)->as_XMMRegister(ra_,this,idx9)/* xtmp2 */, opnd_array(10)->as_XMMRegister(ra_,this,idx10)/* xtmp3 */, opnd_array(11)->as_Register(ra_,this,idx11)/* rtmp */, opnd_array(13)->as_Register(ra_,this,idx13)/* mask_idx */, opnd_array(14)->as_Register(ra_,this,idx14)/* length */, vector_len, vlen_enc);
  
#line 33058 "ad_x86.cpp"
  }
}

void vgather_masked_subwordLE8B_avx2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx_base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// offset
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// mask_idx
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// rtmp
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// rtmp2
  {

#line 4290 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ lea(opnd_array(6)->as_Register(ra_,this,idx6)/* tmp */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ vpmovmskb(opnd_array(8)->as_Register(ra_,this,idx8)/* rtmp2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* mask */, vlen_enc);
    if (elem_bt == T_SHORT) {
      __ movl(opnd_array(5)->as_Register(ra_,this,idx5)/* mask_idx */, 0x55555555);
      __ pextl(opnd_array(8)->as_Register(ra_,this,idx8)/* rtmp2 */, opnd_array(8)->as_Register(ra_,this,idx8)/* rtmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* mask_idx */);
    }
    __ xorl(opnd_array(5)->as_Register(ra_,this,idx5)/* mask_idx */, opnd_array(5)->as_Register(ra_,this,idx5)/* mask_idx */);
    __ vgather8b_masked_offset(elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* idx_base */, noreg, opnd_array(8)->as_Register(ra_,this,idx8)/* rtmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* mask_idx */, opnd_array(7)->as_Register(ra_,this,idx7)/* rtmp */, vlen_enc);
  
#line 33088 "ad_x86.cpp"
  }
}

void vgather_masked_subwordGT8B_avx2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx_base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// offset
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// dst
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// idx_base_temp
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// xtmp1
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// xtmp2
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// xtmp3
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// rtmp
  unsigned idx12 = idx11 + opnd_array(11)->num_edges(); 	// rtmp2
  unsigned idx13 = idx12 + opnd_array(12)->num_edges(); 	// mask_idx
  unsigned idx14 = idx13 + opnd_array(13)->num_edges(); 	// length
  {

#line 4311 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    int vector_len = Matcher::vector_length(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ lea(opnd_array(6)->as_Register(ra_,this,idx6)/* tmp */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ movptr(opnd_array(7)->as_Register(ra_,this,idx7)/* idx_base_temp */, opnd_array(2)->as_Register(ra_,this,idx2)/* idx_base */);
    __ vpmovmskb(opnd_array(12)->as_Register(ra_,this,idx12)/* rtmp2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* mask */, vlen_enc);
    if (elem_bt == T_SHORT) {
      __ movl(opnd_array(13)->as_Register(ra_,this,idx13)/* mask_idx */, 0x55555555);
      __ pextl(opnd_array(12)->as_Register(ra_,this,idx12)/* rtmp2 */, opnd_array(12)->as_Register(ra_,this,idx12)/* rtmp2 */, opnd_array(13)->as_Register(ra_,this,idx13)/* mask_idx */);
    }
    __ xorl(opnd_array(13)->as_Register(ra_,this,idx13)/* mask_idx */, opnd_array(13)->as_Register(ra_,this,idx13)/* mask_idx */);
    __ vgather_subword(elem_bt, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* dst */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp */, opnd_array(7)->as_Register(ra_,this,idx7)/* idx_base_temp */, noreg, opnd_array(12)->as_Register(ra_,this,idx12)/* rtmp2 */, opnd_array(8)->as_XMMRegister(ra_,this,idx8)/* xtmp1 */,
                       opnd_array(9)->as_XMMRegister(ra_,this,idx9)/* xtmp2 */, opnd_array(10)->as_XMMRegister(ra_,this,idx10)/* xtmp3 */, opnd_array(11)->as_Register(ra_,this,idx11)/* rtmp */, opnd_array(13)->as_Register(ra_,this,idx13)/* mask_idx */, opnd_array(14)->as_Register(ra_,this,idx14)/* length */, vector_len, vlen_enc);
  
#line 33127 "ad_x86.cpp"
  }
}

void vgather_masked_subwordLE8B_off_avx2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx_base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// offset
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// mask_idx
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// rtmp
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// rtmp2
  {

#line 4334 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ lea(opnd_array(6)->as_Register(ra_,this,idx6)/* tmp */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ vpmovmskb(opnd_array(8)->as_Register(ra_,this,idx8)/* rtmp2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* mask */, vlen_enc);
    if (elem_bt == T_SHORT) {
      __ movl(opnd_array(5)->as_Register(ra_,this,idx5)/* mask_idx */, 0x55555555);
      __ pextl(opnd_array(8)->as_Register(ra_,this,idx8)/* rtmp2 */, opnd_array(8)->as_Register(ra_,this,idx8)/* rtmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* mask_idx */);
    }
    __ xorl(opnd_array(5)->as_Register(ra_,this,idx5)/* mask_idx */, opnd_array(5)->as_Register(ra_,this,idx5)/* mask_idx */);
    __ vgather8b_masked_offset(elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* idx_base */, opnd_array(4)->as_Register(ra_,this,idx4)/* offset */,
                                opnd_array(8)->as_Register(ra_,this,idx8)/* rtmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* mask_idx */, opnd_array(7)->as_Register(ra_,this,idx7)/* rtmp */, vlen_enc);
  
#line 33158 "ad_x86.cpp"
  }
}

void vgather_masked_subwordGT8B_off_avx2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx_base
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// offset
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// dst
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// idx_base_temp
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// xtmp1
  unsigned idx9 = idx8 + opnd_array(8)->num_edges(); 	// xtmp2
  unsigned idx10 = idx9 + opnd_array(9)->num_edges(); 	// xtmp3
  unsigned idx11 = idx10 + opnd_array(10)->num_edges(); 	// rtmp
  unsigned idx12 = idx11 + opnd_array(11)->num_edges(); 	// rtmp2
  unsigned idx13 = idx12 + opnd_array(12)->num_edges(); 	// mask_idx
  unsigned idx14 = idx13 + opnd_array(13)->num_edges(); 	// length
  {

#line 4356 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    int vector_len = Matcher::vector_length(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ xorl(opnd_array(13)->as_Register(ra_,this,idx13)/* mask_idx */, opnd_array(13)->as_Register(ra_,this,idx13)/* mask_idx */);
    __ lea(opnd_array(6)->as_Register(ra_,this,idx6)/* tmp */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ movptr(opnd_array(7)->as_Register(ra_,this,idx7)/* idx_base_temp */, opnd_array(2)->as_Register(ra_,this,idx2)/* idx_base */);
    __ vpmovmskb(opnd_array(12)->as_Register(ra_,this,idx12)/* rtmp2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* mask */, vlen_enc);
    if (elem_bt == T_SHORT) {
      __ movl(opnd_array(13)->as_Register(ra_,this,idx13)/* mask_idx */, 0x55555555);
      __ pextl(opnd_array(12)->as_Register(ra_,this,idx12)/* rtmp2 */, opnd_array(12)->as_Register(ra_,this,idx12)/* rtmp2 */, opnd_array(13)->as_Register(ra_,this,idx13)/* mask_idx */);
    }
    __ xorl(opnd_array(13)->as_Register(ra_,this,idx13)/* mask_idx */, opnd_array(13)->as_Register(ra_,this,idx13)/* mask_idx */);
    __ vgather_subword(elem_bt, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* dst */, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp */, opnd_array(7)->as_Register(ra_,this,idx7)/* idx_base_temp */, opnd_array(4)->as_Register(ra_,this,idx4)/* offset */, opnd_array(12)->as_Register(ra_,this,idx12)/* rtmp2 */, opnd_array(8)->as_XMMRegister(ra_,this,idx8)/* xtmp1 */,
                       opnd_array(9)->as_XMMRegister(ra_,this,idx9)/* xtmp2 */, opnd_array(10)->as_XMMRegister(ra_,this,idx10)/* xtmp3 */, opnd_array(11)->as_Register(ra_,this,idx11)/* rtmp */, opnd_array(13)->as_Register(ra_,this,idx13)/* mask_idx */, opnd_array(14)->as_Register(ra_,this,idx14)/* length */, vector_len, vlen_enc);
  
#line 33198 "ad_x86.cpp"
  }
}

void scatterNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// ktmp
  {

#line 4385 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(2));
    BasicType elem_bt = Matcher::vector_element_basic_type(this, opnd_array(2));

    assert(Matcher::vector_length_in_bytes(this, opnd_array(2)) >= 16, "sanity");
    assert(!is_subword_type(elem_bt), "sanity"); // T_INT, T_LONG, T_FLOAT, T_DOUBLE

    __ kmovwl(opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp */, ExternalAddress(vector_all_bits_set()), noreg);
    __ lea(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ evscatter(elem_bt, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* idx */, opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, vlen_enc);
  
#line 33224 "ad_x86.cpp"
  }
}

void scatter_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// mask
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// ktmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp
  {

#line 4403 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(2));
    BasicType elem_bt = Matcher::vector_element_basic_type(this, opnd_array(2));
    assert(Matcher::vector_length_in_bytes(this, opnd_array(2)) >= 16, "sanity");
    assert(!is_subword_type(elem_bt), "sanity"); // T_INT, T_LONG, T_FLOAT, T_DOUBLE
    // Note: Since scatter instruction partially updates the opmask register used
    // for predication hense moving mask operand to a temporary.
    __ kmovwl(opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp */, opnd_array(4)->as_KRegister(ra_,this,idx4)/* mask */);
    __ lea(opnd_array(6)->as_Register(ra_,this,idx6)/* tmp */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ evscatter(elem_bt, opnd_array(6)->as_Register(ra_,this,idx6)/* tmp */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* idx */, opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, vlen_enc);
  
#line 33251 "ad_x86.cpp"
  }
}

void vReplB_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4424 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    uint vlen = Matcher::vector_length(this);
    if (UseAVX >= 2) {
      int vlen_enc = vector_length_encoding(this);
      if (vlen == 64 || VM_Version::supports_avx512vlbw()) { // AVX512VL for <512bit operands
        assert(VM_Version::supports_avx512bw(), "required"); // 512-bit byte vectors assume AVX512BW
        __ evpbroadcastb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, vlen_enc);
      } else {
        __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
        __ vpbroadcastb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vlen_enc);
      }
    } else {
       assert(UseAVX < 2, "");
      __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
      __ punpcklbw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
      __ pshuflw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 0x00);
      if (vlen >= 16) {
        assert(vlen == 16, "");
        __ punpcklqdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
      }
    }
  
#line 33284 "ad_x86.cpp"
  }
}

void ReplB_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4453 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpbroadcastb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
  
#line 33299 "ad_x86.cpp"
  }
}

void vReplS_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4466 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    uint vlen = Matcher::vector_length(this);
    int vlen_enc = vector_length_encoding(this);
    if (UseAVX >= 2) {
      if (vlen == 32 || VM_Version::supports_avx512vlbw()) { // AVX512VL for <512bit operands
        assert(VM_Version::supports_avx512bw(), "required"); // 512-bit short vectors assume AVX512BW
        __ evpbroadcastw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, vlen_enc);
      } else {
        __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
        __ vpbroadcastw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vlen_enc);
      }
    } else {
      assert(UseAVX < 2, "");
      __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
      __ pshuflw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 0x00);
      if (vlen >= 8) {
        assert(vlen == 8, "");
        __ punpcklqdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
      }
    }
  
#line 33331 "ad_x86.cpp"
  }
}

void ReplS_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4494 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpbroadcastw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
  
#line 33346 "ad_x86.cpp"
  }
}

void ReplI_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4507 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    uint vlen = Matcher::vector_length(this);
    int vlen_enc = vector_length_encoding(this);
    if (vlen == 16 || VM_Version::supports_avx512vl()) { // AVX512VL for <512bit operands
      __ evpbroadcastd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, vlen_enc);
    } else if (VM_Version::supports_avx2()) {
      __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
      __ vpbroadcastd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vlen_enc);
    } else {
      __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
      __ pshufd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 0x00);
    }
  
#line 33370 "ad_x86.cpp"
  }
}

void ReplI_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4527 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    if (VM_Version::supports_avx2()) {
      __ vpbroadcastd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
    } else if (VM_Version::supports_avx()) {
      __ vbroadcastss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
    } else {
      __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
      __ pshufd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 0x00);
    }
  
#line 33392 "ad_x86.cpp"
  }
}

void ReplI_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 4545 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    InternalAddress addr = InternalAddress(__ code()->consts()->start() + constant_offset());
    BasicType bt = Matcher::vector_element_basic_type(this);
    int vlen = Matcher::vector_length_in_bytes(this);
    __ load_constant_vector(bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, addr, vlen);
  
#line 33409 "ad_x86.cpp"
  }
}

void ReplI_immNode::eval_constant(Compile* C) {
  {

#line 4546 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, Matcher::vector_element_basic_type(this),
        vreplicate_imm(Matcher::vector_element_basic_type(this), opnd_array(1)->constant(),
            (VM_Version::supports_sse3() ? (VM_Version::supports_avx() ? 4 : 8) : 8) /
                type2aelembytes(Matcher::vector_element_basic_type(this))));
#line 33421 "ad_x86.cpp"
  }
}
void ReplI_zeroNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {

#line 4562 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    if (VM_Version::supports_evex() && !VM_Version::supports_avx512vl()) {
      __ vpxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vlen_enc);
    } else {
      __ pxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    }
  
#line 33439 "ad_x86.cpp"
  }
}

void ReplI_M1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 4577 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vector_len = vector_length_encoding(this);
    __ vallones(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vector_len);
  
#line 33454 "ad_x86.cpp"
  }
}

void ReplL_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4592 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen = Matcher::vector_length(this);
    int vlen_enc = vector_length_encoding(this);
    if (vlen == 8 || VM_Version::supports_avx512vl()) { // AVX512VL for <512bit operands
      __ evpbroadcastq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, vlen_enc);
    } else if (VM_Version::supports_avx2()) {
      __ movdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
      __ vpbroadcastq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vlen_enc);
    } else {
      __ movdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
      __ punpcklqdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    }
  
#line 33478 "ad_x86.cpp"
  }
}

void ReplL_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4667 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    if (VM_Version::supports_avx2()) {
      __ vpbroadcastq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
    } else if (VM_Version::supports_sse3()) {
      __ movddup(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    } else {
      __ movq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
      __ punpcklqdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    }
  
#line 33500 "ad_x86.cpp"
  }
}

void ReplL_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 4686 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    InternalAddress addr = InternalAddress(__ code()->consts()->start() + constant_offset());
    int vlen = Matcher::vector_length_in_bytes(this);
    __ load_constant_vector(T_LONG, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, addr, vlen);
  
#line 33516 "ad_x86.cpp"
  }
}

void ReplL_immNode::eval_constant(Compile* C) {
  {

#line 4687 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, T_LONG, vreplicate_imm(T_LONG, opnd_array(1)->constantL(), 1));
#line 33525 "ad_x86.cpp"
  }
}
void ReplL_zeroNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {

#line 4698 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    if (VM_Version::supports_evex() && !VM_Version::supports_avx512vl()) {
      __ vpxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vlen_enc);
    } else {
      __ pxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    }
  
#line 33543 "ad_x86.cpp"
  }
}

void ReplL_M1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 4713 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vector_len = vector_length_encoding(this);
    __ vallones(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vector_len);
  
#line 33558 "ad_x86.cpp"
  }
}

void vReplF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4726 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    uint vlen = Matcher::vector_length(this);
    int vlen_enc = vector_length_encoding(this);
    if (vlen <= 4) {
      __ vpermilps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0x00, Assembler::AVX_128bit);
    } else if (VM_Version::supports_avx2()) {
      __ vbroadcastss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc); // reg-to-reg variant requires AVX2
    } else {
      assert(vlen == 8, "sanity");
      __ vpermilps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0x00, Assembler::AVX_128bit);
      __ vinsertf128_high(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    }
  
#line 33582 "ad_x86.cpp"
  }
}

void ReplF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4746 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ pshufd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0x00);
  
#line 33596 "ad_x86.cpp"
  }
}

void ReplF_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4756 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vbroadcastss(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
  
#line 33611 "ad_x86.cpp"
  }
}

void ReplF_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 4768 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    InternalAddress addr = InternalAddress(__ code()->consts()->start() + constant_offset());
    int vlen = Matcher::vector_length_in_bytes(this);
    __ load_constant_vector(T_FLOAT, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, addr, vlen);
  
#line 33627 "ad_x86.cpp"
  }
}

void ReplF_immNode::eval_constant(Compile* C) {
  {

#line 4769 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, T_FLOAT, vreplicate_imm(T_FLOAT, opnd_array(1)->constantF(),
        VM_Version::supports_sse3() ? (VM_Version::supports_avx() ? 1 : 2) : 2));
#line 33637 "ad_x86.cpp"
  }
}
void ReplF_zeroNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {

#line 4781 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    if (VM_Version::supports_evex() && !VM_Version::supports_avx512vldq()) {
      __ vpxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vlen_enc);
    } else {
      __ xorps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    }
  
#line 33655 "ad_x86.cpp"
  }
}

void vReplD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4799 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    uint vlen = Matcher::vector_length(this);
    int vlen_enc = vector_length_encoding(this);
    if (vlen <= 2) {
      __ movddup(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    } else if (VM_Version::supports_avx2()) {
      __ vbroadcastsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc); // reg-to-reg variant requires AVX2
    } else {
      assert(vlen == 4, "sanity");
      __ movddup(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
      __ vinsertf128_high(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    }
  
#line 33679 "ad_x86.cpp"
  }
}

void ReplD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 4819 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ pshufd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0x44);
  
#line 33693 "ad_x86.cpp"
  }
}

void ReplD_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 4829 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    if (Matcher::vector_length(this) >= 4) {
      int vlen_enc = vector_length_encoding(this);
      __ vbroadcastsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
    } else {
      __ movddup(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    }
  
#line 33712 "ad_x86.cpp"
  }
}

void ReplD_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// con
  {

#line 4845 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    InternalAddress addr = InternalAddress(__ code()->consts()->start() + constant_offset());
    int vlen = Matcher::vector_length_in_bytes(this);
    __ load_constant_vector(T_DOUBLE, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, addr, vlen);
  
#line 33728 "ad_x86.cpp"
  }
}

void ReplD_immNode::eval_constant(Compile* C) {
  {

#line 4846 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, T_DOUBLE, vreplicate_imm(T_DOUBLE, opnd_array(1)->constantD(), 1));
#line 33737 "ad_x86.cpp"
  }
}
void ReplD_zeroNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// zero
  {

#line 4857 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    if (VM_Version::supports_evex() && !VM_Version::supports_avx512vldq()) {
      __ vpxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vlen_enc);
    } else {
      __ xorps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */);
    }
  
#line 33755 "ad_x86.cpp"
  }
}

void insertNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  {

#line 4874 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE >= 4, "required");
    assert(Matcher::vector_length_in_bytes(this) >= 8, "required");

    BasicType elem_bt = Matcher::vector_element_basic_type(this);

    assert(is_integral_type(elem_bt), "");
    assert(opnd_array(3)->constant()< (int)Matcher::vector_length(this), "out of bounds");

    __ insert(elem_bt, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* val */, opnd_array(3)->constant());
  
#line 33779 "ad_x86.cpp"
  }
}

void insert32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 4893 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = Assembler::AVX_256bit;
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    int elem_per_lane = 16/type2aelembytes(elem_bt);
    int log2epr = log2(elem_per_lane);

    assert(is_integral_type(elem_bt), "sanity");
    assert(opnd_array(3)->constant()< (int)Matcher::vector_length(this), "out of bounds");

    uint x_idx = opnd_array(3)->constant()& right_n_bits(log2epr);
    uint y_idx = (opnd_array(3)->constant()>> log2epr) & 1;
    __ vextracti128(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, y_idx);
    __ vinsert(elem_bt, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* val */, x_idx);
    __ vinserti128(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, y_idx);
  
#line 33808 "ad_x86.cpp"
  }
}

void insert64Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 4916 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "sanity");

    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    int elem_per_lane = 16/type2aelembytes(elem_bt);
    int log2epr = log2(elem_per_lane);

    assert(is_integral_type(elem_bt), "");
    assert(opnd_array(3)->constant()< (int)Matcher::vector_length(this), "out of bounds");

    uint x_idx = opnd_array(3)->constant()& right_n_bits(log2epr);
    uint y_idx = (opnd_array(3)->constant()>> log2epr) & 3;
    __ vextracti32x4(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, y_idx);
    __ vinsert(elem_bt, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* val */, x_idx);
    __ vinserti32x4(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, y_idx);
  
#line 33838 "ad_x86.cpp"
  }
}

void insert2LNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  {

#line 4940 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE >= 4, "required");
    assert(Matcher::vector_element_basic_type(this) == T_LONG, "");
    assert(opnd_array(3)->constant()< (int)Matcher::vector_length(this), "out of bounds");

    __ pinsrq(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* val */, opnd_array(3)->constant());
  
#line 33858 "ad_x86.cpp"
  }
}

void insert4LNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 4955 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(Matcher::vector_element_basic_type(this) == T_LONG, "");
    assert(opnd_array(3)->constant()< (int)Matcher::vector_length(this), "out of bounds");

    uint x_idx = opnd_array(3)->constant()& right_n_bits(1);
    uint y_idx = (opnd_array(3)->constant()>> 1) & 1;
    int vlen_enc = Assembler::AVX_256bit;
    __ vextracti128(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, y_idx);
    __ vpinsrq(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* val */, x_idx);
    __ vinserti128(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, y_idx);
  
#line 33883 "ad_x86.cpp"
  }
}

void insert8LNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 4974 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(Matcher::vector_element_basic_type(this) == T_LONG, "sanity");
    assert(opnd_array(3)->constant()< (int)Matcher::vector_length(this), "out of bounds");

    uint x_idx = opnd_array(3)->constant()& right_n_bits(1);
    uint y_idx = (opnd_array(3)->constant()>> 1) & 3;
    __ vextracti32x4(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, y_idx);
    __ vpinsrq(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(2)->as_Register(ra_,this,idx2)/* val */, x_idx);
    __ vinserti32x4(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, y_idx);
  
#line 33907 "ad_x86.cpp"
  }
}

void insertFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  {

#line 4992 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE >= 4, "sanity");

    assert(Matcher::vector_element_basic_type(this) == T_FLOAT, "sanity");
    assert(opnd_array(3)->constant()< (int)Matcher::vector_length(this), "out of bounds");

    uint x_idx = opnd_array(3)->constant()& right_n_bits(2);
    __ insertps(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* val */, x_idx << 4);
  
#line 33929 "ad_x86.cpp"
  }
}

void vinsertFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 5009 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(Matcher::vector_element_basic_type(this) == T_FLOAT, "sanity");
    assert(opnd_array(3)->constant()< (int)Matcher::vector_length(this), "out of bounds");

    int vlen = Matcher::vector_length(this);
    uint x_idx = opnd_array(3)->constant()& right_n_bits(2);
    if (vlen == 8) {
      uint y_idx = (opnd_array(3)->constant()>> 2) & 1;
      int vlen_enc = Assembler::AVX_256bit;
      __ vextracti128(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, y_idx);
      __ vinsertps(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* val */, x_idx << 4);
      __ vinserti128(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, y_idx);
    } else {
      assert(vlen == 16, "sanity");
      uint y_idx = (opnd_array(3)->constant()>> 2) & 3;
      __ vextracti32x4(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, y_idx);
      __ vinsertps(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* val */, x_idx << 4);
      __ vinserti32x4(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, y_idx);
    }
  
#line 33963 "ad_x86.cpp"
  }
}

void insert2DNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 5038 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE >= 4, "sanity");
    assert(Matcher::vector_element_basic_type(this) == T_DOUBLE, "sanity");
    assert(opnd_array(3)->constant()< (int)Matcher::vector_length(this), "out of bounds");

    __ movq(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* val */);
    __ pinsrq(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, opnd_array(3)->constant());
  
#line 33985 "ad_x86.cpp"
  }
}

void insert4DNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp
  {

#line 5054 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(Matcher::vector_element_basic_type(this) == T_DOUBLE, "sanity");
    assert(opnd_array(3)->constant()< (int)Matcher::vector_length(this), "out of bounds");

    uint x_idx = opnd_array(3)->constant()& right_n_bits(1);
    uint y_idx = (opnd_array(3)->constant()>> 1) & 1;
    int vlen_enc = Assembler::AVX_256bit;
    __ movq(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* val */);
    __ vextracti128(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, y_idx);
    __ vpinsrq(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, x_idx);
    __ vinserti128(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp */, y_idx);
  
#line 34012 "ad_x86.cpp"
  }
}

void insert8DNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// val
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// idx
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp
  {

#line 5074 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(Matcher::vector_element_basic_type(this) == T_DOUBLE, "sanity");
    assert(opnd_array(3)->constant()< (int)Matcher::vector_length(this), "out of bounds");

    uint x_idx = opnd_array(3)->constant()& right_n_bits(1);
    uint y_idx = (opnd_array(3)->constant()>> 1) & 3;
    __ movq(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* val */);
    __ vextracti32x4(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, y_idx);
    __ vpinsrq(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, x_idx);
    __ vinserti32x4(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp */, y_idx);
  
#line 34038 "ad_x86.cpp"
  }
}

void reductionINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5104 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceI(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34057 "ad_x86.cpp"
  }
}

void reductionI_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5104 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceI(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34076 "ad_x86.cpp"
  }
}

void reductionI_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5104 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceI(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34095 "ad_x86.cpp"
  }
}

void reductionI_2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5104 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceI(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34114 "ad_x86.cpp"
  }
}

void reductionI_3Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5104 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceI(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34133 "ad_x86.cpp"
  }
}

void reductionI_4Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5104 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceI(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34152 "ad_x86.cpp"
  }
}

void reductionI_5Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5104 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceI(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34171 "ad_x86.cpp"
  }
}

void reductionLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5126 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceL(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34190 "ad_x86.cpp"
  }
}

void reductionL_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5126 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceL(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34209 "ad_x86.cpp"
  }
}

void reductionL_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5126 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceL(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34228 "ad_x86.cpp"
  }
}

void reductionL_2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5126 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceL(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34247 "ad_x86.cpp"
  }
}

void reductionL_3Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5126 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceL(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34266 "ad_x86.cpp"
  }
}

void reductionL_4Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5126 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceL(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34285 "ad_x86.cpp"
  }
}

void reductionL_5Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5126 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceL(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34304 "ad_x86.cpp"
  }
}

void reductionL_avx512dqNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5145 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceL(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34323 "ad_x86.cpp"
  }
}

void reductionL_avx512dq_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5145 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceL(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34342 "ad_x86.cpp"
  }
}

void reductionL_avx512dq_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5145 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceL(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34361 "ad_x86.cpp"
  }
}

void reductionL_avx512dq_2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5145 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceL(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34380 "ad_x86.cpp"
  }
}

void reductionL_avx512dq_3Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5145 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceL(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34399 "ad_x86.cpp"
  }
}

void reductionL_avx512dq_4Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5145 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceL(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34418 "ad_x86.cpp"
  }
}

void reductionL_avx512dq_5Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5145 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceL(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34437 "ad_x86.cpp"
  }
}

void reductionF128Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp
  {

#line 5162 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduce_fp(opcode, vlen, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */);
  
#line 34455 "ad_x86.cpp"
  }
}

void reductionF128_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp
  {

#line 5162 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduce_fp(opcode, vlen, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */);
  
#line 34473 "ad_x86.cpp"
  }
}

void reduction8FNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5176 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduce_fp(opcode, vlen, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34492 "ad_x86.cpp"
  }
}

void reduction8F_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5176 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduce_fp(opcode, vlen, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34511 "ad_x86.cpp"
  }
}

void reduction16FNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5190 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduce_fp(opcode, vlen, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34530 "ad_x86.cpp"
  }
}

void reduction16F_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5190 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduce_fp(opcode, vlen, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34549 "ad_x86.cpp"
  }
}

void unordered_reduction2FNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {

#line 5208 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ unordered_reduce_fp(opcode, vlen, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 34567 "ad_x86.cpp"
  }
}

void unordered_reduction2F_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {

#line 5208 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ unordered_reduce_fp(opcode, vlen, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
  
#line 34585 "ad_x86.cpp"
  }
}

void unordered_reduction4FNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 5225 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ unordered_reduce_fp(opcode, vlen, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */);
  
#line 34604 "ad_x86.cpp"
  }
}

void unordered_reduction4F_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 5225 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ unordered_reduce_fp(opcode, vlen, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */);
  
#line 34623 "ad_x86.cpp"
  }
}

void unordered_reduction8FNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  {

#line 5242 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ unordered_reduce_fp(opcode, vlen, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */);
  
#line 34643 "ad_x86.cpp"
  }
}

void unordered_reduction8F_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  {

#line 5242 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ unordered_reduce_fp(opcode, vlen, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */);
  
#line 34663 "ad_x86.cpp"
  }
}

void unordered_reduction16FNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  {

#line 5259 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ unordered_reduce_fp(opcode, vlen, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */);
  
#line 34683 "ad_x86.cpp"
  }
}

void unordered_reduction16F_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  {

#line 5259 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ unordered_reduce_fp(opcode, vlen, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */);
  
#line 34703 "ad_x86.cpp"
  }
}

void reduction2DNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp
  {

#line 5275 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduce_fp(opcode, vlen, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */);

#line 34721 "ad_x86.cpp"
  }
}

void reduction2D_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp
  {

#line 5275 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduce_fp(opcode, vlen, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */);

#line 34739 "ad_x86.cpp"
  }
}

void reduction4DNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5289 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduce_fp(opcode, vlen, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34758 "ad_x86.cpp"
  }
}

void reduction4D_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5289 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduce_fp(opcode, vlen, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34777 "ad_x86.cpp"
  }
}

void reduction8DNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5303 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduce_fp(opcode, vlen, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34796 "ad_x86.cpp"
  }
}

void reduction8D_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5303 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduce_fp(opcode, vlen, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34815 "ad_x86.cpp"
  }
}

void unordered_reduction2DNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {

#line 5320 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ unordered_reduce_fp(opcode, vlen, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);

#line 34833 "ad_x86.cpp"
  }
}

void unordered_reduction2D_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {

#line 5320 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ unordered_reduce_fp(opcode, vlen, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);

#line 34851 "ad_x86.cpp"
  }
}

void unordered_reduction4DNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 5337 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ unordered_reduce_fp(opcode, vlen, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */);
  
#line 34870 "ad_x86.cpp"
  }
}

void unordered_reduction4D_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 5337 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ unordered_reduce_fp(opcode, vlen, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */);
  
#line 34889 "ad_x86.cpp"
  }
}

void unordered_reduction8DNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  {

#line 5354 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ unordered_reduce_fp(opcode, vlen, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */);
  
#line 34909 "ad_x86.cpp"
  }
}

void unordered_reduction8D_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  {

#line 5354 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ unordered_reduce_fp(opcode, vlen, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */);
  
#line 34929 "ad_x86.cpp"
  }
}

void reductionBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5375 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceB(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34948 "ad_x86.cpp"
  }
}

void reductionB_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5375 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceB(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34967 "ad_x86.cpp"
  }
}

void reductionB_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5375 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceB(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 34986 "ad_x86.cpp"
  }
}

void reductionB_2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5375 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceB(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 35005 "ad_x86.cpp"
  }
}

void reductionB_3Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5375 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceB(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 35024 "ad_x86.cpp"
  }
}

void reductionB_4Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5375 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceB(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 35043 "ad_x86.cpp"
  }
}

void reductionB_avx512bwNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5393 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceB(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 35062 "ad_x86.cpp"
  }
}

void reductionB_avx512bw_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5393 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceB(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 35081 "ad_x86.cpp"
  }
}

void reductionB_avx512bw_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5393 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceB(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 35100 "ad_x86.cpp"
  }
}

void reductionB_avx512bw_2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5393 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceB(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 35119 "ad_x86.cpp"
  }
}

void reductionB_avx512bw_3Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5393 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceB(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 35138 "ad_x86.cpp"
  }
}

void reductionB_avx512bw_4Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5393 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceB(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 35157 "ad_x86.cpp"
  }
}

void reductionSNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5415 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceS(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 35176 "ad_x86.cpp"
  }
}

void reductionS_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5415 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceS(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 35195 "ad_x86.cpp"
  }
}

void reductionS_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5415 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceS(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 35214 "ad_x86.cpp"
  }
}

void reductionS_2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5415 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceS(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 35233 "ad_x86.cpp"
  }
}

void reductionS_3Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5415 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceS(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 35252 "ad_x86.cpp"
  }
}

void reductionS_4Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5415 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceS(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 35271 "ad_x86.cpp"
  }
}

void reductionS_5Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp2
  {

#line 5415 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceS(opcode, vlen, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp2 */);
  
#line 35290 "ad_x86.cpp"
  }
}

void mul_reductionBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  {

#line 5431 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ mulreduceB(opcode, vlen, opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */);
  
#line 35310 "ad_x86.cpp"
  }
}

void mul_reduction64BNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  {

#line 5445 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ mulreduceB(opcode, vlen, opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */);
  
#line 35330 "ad_x86.cpp"
  }
}

void minmax_reduction2FNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// atmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// btmp
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// xmm_1
  {

#line 5465 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "sanity");

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceFloatMinMax(opcode, vlen, false, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */,
                         opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* atmp */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* btmp */, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* xmm_1 */);
  
#line 35355 "ad_x86.cpp"
  }
}

void minmax_reduction2F_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// atmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// btmp
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// xmm_1
  {

#line 5465 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "sanity");

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceFloatMinMax(opcode, vlen, false, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */,
                         opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* atmp */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* btmp */, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* xmm_1 */);
  
#line 35380 "ad_x86.cpp"
  }
}

void minmax_reductionFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// atmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// btmp
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// xmm_0
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// xmm_1
  {

#line 5486 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "sanity");

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceFloatMinMax(opcode, vlen, false, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */,
                         opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* atmp */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* btmp */, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* xmm_0 */, opnd_array(8)->as_XMMRegister(ra_,this,idx8)/* xmm_1 */);
  
#line 35406 "ad_x86.cpp"
  }
}

void minmax_reductionF_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// atmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// btmp
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// xmm_0
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// xmm_1
  {

#line 5486 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "sanity");

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceFloatMinMax(opcode, vlen, false, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */,
                         opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* atmp */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* btmp */, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* xmm_0 */, opnd_array(8)->as_XMMRegister(ra_,this,idx8)/* xmm_1 */);
  
#line 35432 "ad_x86.cpp"
  }
}

void minmax_reduction2F_avNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// atmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// btmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// xmm_1
  {

#line 5505 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "sanity");

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceFloatMinMax(opcode, vlen, true, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */,
                         opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* atmp */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* btmp */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* xmm_1 */);
  
#line 35456 "ad_x86.cpp"
  }
}

void minmax_reduction2F_av_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// atmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// btmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// xmm_1
  {

#line 5505 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "sanity");

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceFloatMinMax(opcode, vlen, true, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */,
                         opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* atmp */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* btmp */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* xmm_1 */);
  
#line 35480 "ad_x86.cpp"
  }
}

void minmax_reductionF_avNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// atmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// btmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// xmm_0
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// xmm_1
  {

#line 5525 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "sanity");

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceFloatMinMax(opcode, vlen, true, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */,
                         opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* atmp */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* btmp */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* xmm_0 */, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* xmm_1 */);
  
#line 35505 "ad_x86.cpp"
  }
}

void minmax_reductionF_av_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// atmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// btmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// xmm_0
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// xmm_1
  {

#line 5525 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "sanity");

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceFloatMinMax(opcode, vlen, true, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */,
                         opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* atmp */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* btmp */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* xmm_0 */, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* xmm_1 */);
  
#line 35530 "ad_x86.cpp"
  }
}

void minmax_reduction2DNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {

#line 5549 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "sanity");

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceDoubleMinMax(opcode, vlen, false, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */,
                          opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* tmp3 */, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* tmp4 */);
  
#line 35555 "ad_x86.cpp"
  }
}

void minmax_reduction2D_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  {

#line 5549 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "sanity");

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceDoubleMinMax(opcode, vlen, false, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */,
                          opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* tmp3 */, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* tmp4 */);
  
#line 35580 "ad_x86.cpp"
  }
}

void minmax_reductionDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp5
  {

#line 5571 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "sanity");

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceDoubleMinMax(opcode, vlen, false, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */,
                          opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* tmp3 */, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* tmp4 */, opnd_array(8)->as_XMMRegister(ra_,this,idx8)/* tmp5 */);
  
#line 35606 "ad_x86.cpp"
  }
}

void minmax_reductionD_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp4
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// tmp5
  {

#line 5571 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "sanity");

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceDoubleMinMax(opcode, vlen, false, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */,
                          opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* tmp3 */, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* tmp4 */, opnd_array(8)->as_XMMRegister(ra_,this,idx8)/* tmp5 */);
  
#line 35632 "ad_x86.cpp"
  }
}

void minmax_reduction2D_avNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp4
  {

#line 5592 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "sanity");

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceDoubleMinMax(opcode, vlen, true, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */,
                          opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp3 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* tmp4 */);
  
#line 35656 "ad_x86.cpp"
  }
}

void minmax_reduction2D_av_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp4
  {

#line 5592 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "sanity");

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceDoubleMinMax(opcode, vlen, true, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */,
                          opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp3 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* tmp4 */);
  
#line 35680 "ad_x86.cpp"
  }
}

void minmax_reductionD_avNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp4
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp5
  {

#line 5612 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "sanity");

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceDoubleMinMax(opcode, vlen, true, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */,
                          opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp3 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* tmp4 */, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* tmp5 */);
  
#line 35705 "ad_x86.cpp"
  }
}

void minmax_reductionD_av_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp4
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp5
  {

#line 5612 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "sanity");

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this, opnd_array(2));
    __ reduceDoubleMinMax(opcode, vlen, true, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */,
                          opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp3 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* tmp4 */, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* tmp5 */);
  
#line 35730 "ad_x86.cpp"
  }
}

void vaddBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5632 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ paddb(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 35745 "ad_x86.cpp"
  }
}

void vaddB_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 5642 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpaddb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 35761 "ad_x86.cpp"
  }
}

void vaddB_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 5654 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpaddb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 35777 "ad_x86.cpp"
  }
}

void vaddB_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5654 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpaddb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
  
#line 35793 "ad_x86.cpp"
  }
}

void vaddSNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5666 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ paddw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 35808 "ad_x86.cpp"
  }
}

void vaddS_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 5676 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpaddw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 35824 "ad_x86.cpp"
  }
}

void vaddS_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 5688 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpaddw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 35840 "ad_x86.cpp"
  }
}

void vaddS_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5688 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpaddw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
  
#line 35856 "ad_x86.cpp"
  }
}

void vaddINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5700 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ paddd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 35871 "ad_x86.cpp"
  }
}

void vaddI_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 5710 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpaddd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 35887 "ad_x86.cpp"
  }
}

void vaddI_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 5723 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpaddd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 35903 "ad_x86.cpp"
  }
}

void vaddI_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5723 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpaddd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
  
#line 35919 "ad_x86.cpp"
  }
}

void vaddLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5735 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ paddq(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 35934 "ad_x86.cpp"
  }
}

void vaddL_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 5745 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpaddq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 35950 "ad_x86.cpp"
  }
}

void vaddL_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 5757 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpaddq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 35966 "ad_x86.cpp"
  }
}

void vaddL_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5757 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpaddq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
  
#line 35982 "ad_x86.cpp"
  }
}

void vaddFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5769 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ addps(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 35997 "ad_x86.cpp"
  }
}

void vaddF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 5779 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vaddps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 36013 "ad_x86.cpp"
  }
}

void vaddF_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 5791 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vaddps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 36029 "ad_x86.cpp"
  }
}

void vaddF_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5791 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vaddps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
  
#line 36045 "ad_x86.cpp"
  }
}

void vaddDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5803 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ addpd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36060 "ad_x86.cpp"
  }
}

void vaddD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 5813 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vaddpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 36076 "ad_x86.cpp"
  }
}

void vaddD_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 5825 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vaddpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 36092 "ad_x86.cpp"
  }
}

void vaddD_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5825 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vaddpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
  
#line 36108 "ad_x86.cpp"
  }
}

void vsubBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5839 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ psubb(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36123 "ad_x86.cpp"
  }
}

void vsubB_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 5849 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpsubb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 36139 "ad_x86.cpp"
  }
}

void vsubB_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 5861 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpsubb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 36155 "ad_x86.cpp"
  }
}

void vsubSNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5873 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ psubw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36170 "ad_x86.cpp"
  }
}

void vsubS_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 5884 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpsubw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 36186 "ad_x86.cpp"
  }
}

void vsubS_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 5896 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpsubw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 36202 "ad_x86.cpp"
  }
}

void vsubINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5908 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ psubd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36217 "ad_x86.cpp"
  }
}

void vsubI_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 5918 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpsubd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 36233 "ad_x86.cpp"
  }
}

void vsubI_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 5930 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpsubd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 36249 "ad_x86.cpp"
  }
}

void vsubLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5942 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ psubq(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36264 "ad_x86.cpp"
  }
}

void vsubL_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 5952 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpsubq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 36280 "ad_x86.cpp"
  }
}

void vsubL_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 5965 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpsubq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 36296 "ad_x86.cpp"
  }
}

void vsubFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 5977 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ subps(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36311 "ad_x86.cpp"
  }
}

void vsubF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 5987 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vsubps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 36327 "ad_x86.cpp"
  }
}

void vsubF_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 5999 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vsubps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 36343 "ad_x86.cpp"
  }
}

void vsubDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6011 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ subpd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36358 "ad_x86.cpp"
  }
}

void vsubD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6021 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vsubpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 36374 "ad_x86.cpp"
  }
}

void vsubD_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 6033 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vsubpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 36390 "ad_x86.cpp"
  }
}

void vmul8BNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp
  {

#line 6048 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE > 3, "required");
    __ pmovsxbw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */);
    __ pmovsxbw(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
    __ pmullw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */);
    __ psllw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, 8);
    __ psrlw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, 8);
    __ packuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */);
  
#line 36413 "ad_x86.cpp"
  }
}

void vmulBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp
  {

#line 6065 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE > 3, "required");
    // Odd-index elements
    __ movdqu(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */);
    __ psrlw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, 8);
    __ movdqu(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
    __ psrlw(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */, 8);
    __ pmullw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */);
    __ psllw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, 8);
    // Even-index elements
    __ movdqu(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */);
    __ pmullw(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
    __ psllw(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */, 8);
    __ psrlw(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */, 8);
    // Combine
    __ por(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */);
  
#line 36444 "ad_x86.cpp"
  }
}

void vmulB_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  {

#line 6090 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    // Odd-index elements
    __ vpsrlw(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, 8, vlen_enc);
    __ vpsrlw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, 8, vlen_enc);
    __ vpmullw(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, vlen_enc);
    __ vpsllw(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, 8, vlen_enc);
    // Even-index elements
    __ vpmullw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
    __ vpsllw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */, 8, vlen_enc);
    __ vpsrlw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */, 8, vlen_enc);
    // Combine
    __ vpor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, vlen_enc);
  
#line 36472 "ad_x86.cpp"
  }
}

void vmulSNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6112 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ pmullw(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36487 "ad_x86.cpp"
  }
}

void vmulS_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6122 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpmullw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 36503 "ad_x86.cpp"
  }
}

void vmulS_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 6134 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpmullw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 36519 "ad_x86.cpp"
  }
}

void vmulS_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6134 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpmullw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
  
#line 36535 "ad_x86.cpp"
  }
}

void vmulINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6146 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE > 3, "required");
    __ pmulld(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36551 "ad_x86.cpp"
  }
}

void vmulI_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6157 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpmulld(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 36567 "ad_x86.cpp"
  }
}

void vmulI_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 6169 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpmulld(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 36583 "ad_x86.cpp"
  }
}

void vmulI_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6169 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpmulld(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
  
#line 36599 "ad_x86.cpp"
  }
}

void evmulL_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6184 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");
    int vlen_enc = vector_length_encoding(this);
    __ evpmullq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 36616 "ad_x86.cpp"
  }
}

void evmulL_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 6200 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");
    int vlen_enc = vector_length_encoding(this);
    __ evpmullq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 36633 "ad_x86.cpp"
  }
}

void evmulL_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6200 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");
    int vlen_enc = vector_length_encoding(this);
    __ evpmullq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
  
#line 36650 "ad_x86.cpp"
  }
}

void vmulLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp
  {

#line 6214 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(VM_Version::supports_sse4_1(), "required");
    // Get the lo-hi products, only the lower 32 bits is in concerns
    __ pshufd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, 0xB1);
    __ pmulld(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */);
    __ pshufd(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */, 0xB1);
    __ paddd(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */);
    __ psllq(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, 32);
    // Get the lo-lo products
    __ movdqu(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */);
    __ pmuludq(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */);
    __ paddq(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */);
  
#line 36677 "ad_x86.cpp"
  }
}

void vmulL_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  {

#line 6240 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    // Get the lo-hi products, only the lower 32 bits is in concerns
    __ vpshufd(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, 0xB1, vlen_enc);
    __ vpmulld(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */, vlen_enc);
    __ vpshufd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */, 0xB1, vlen_enc);
    __ vpaddd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */, vlen_enc);
    __ vpsllq(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, 32, vlen_enc);
    // Get the lo-lo products
    __ vpmuludq(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
    __ vpaddq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, vlen_enc);
  
#line 36703 "ad_x86.cpp"
  }
}

void vmuludq_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6260 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpmuludq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 36719 "ad_x86.cpp"
  }
}

void vmuldq_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6272 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpmuldq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 36735 "ad_x86.cpp"
  }
}

void vmulFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6284 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ mulps(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36750 "ad_x86.cpp"
  }
}

void vmulF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6294 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vmulps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 36766 "ad_x86.cpp"
  }
}

void vmulF_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 6306 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vmulps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 36782 "ad_x86.cpp"
  }
}

void vmulF_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6306 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vmulps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
  
#line 36798 "ad_x86.cpp"
  }
}

void vmulDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6318 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ mulpd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36813 "ad_x86.cpp"
  }
}

void vmulD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6328 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vmulpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 36829 "ad_x86.cpp"
  }
}

void vmulD_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 6340 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vmulpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 36845 "ad_x86.cpp"
  }
}

void vmulD_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6340 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vmulpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
  
#line 36861 "ad_x86.cpp"
  }
}

void vdivFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6354 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ divps(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36876 "ad_x86.cpp"
  }
}

void vdivF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6364 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vdivps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 36892 "ad_x86.cpp"
  }
}

void vdivF_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 6376 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vdivps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 36908 "ad_x86.cpp"
  }
}

void vdivDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6388 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ divpd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36923 "ad_x86.cpp"
  }
}

void vdivD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6398 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vdivpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 36939 "ad_x86.cpp"
  }
}

void vdivD_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 6410 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vdivpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 36955 "ad_x86.cpp"
  }
}

void minmax_reg_sseNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6426 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE >= 4, "required");

    int opcode = this->ideal_Opcode();
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ pminmax(opcode, elem_bt, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36974 "ad_x86.cpp"
  }
}

void minmax_reg_sse_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 6426 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE >= 4, "required");

    int opcode = this->ideal_Opcode();
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ pminmax(opcode, elem_bt, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 36993 "ad_x86.cpp"
  }
}

void vminmax_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6442 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);

    __ vpminmax(opcode, elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 37012 "ad_x86.cpp"
  }
}

void vminmax_reg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6442 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);

    __ vpminmax(opcode, elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 37031 "ad_x86.cpp"
  }
}

void minmaxL_reg_sseNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 6460 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE >= 4, "required");

    int opcode = this->ideal_Opcode();
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    assert(elem_bt == T_LONG, "sanity");

    __ pminmax(opcode, elem_bt, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */);
  
#line 37053 "ad_x86.cpp"
  }
}

void minmaxL_reg_sse_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 6460 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE >= 4, "required");

    int opcode = this->ideal_Opcode();
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    assert(elem_bt == T_LONG, "sanity");

    __ pminmax(opcode, elem_bt, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */);
  
#line 37075 "ad_x86.cpp"
  }
}

void vminmaxL_reg_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {

#line 6479 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    int opcode = this->ideal_Opcode();
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    assert(elem_bt == T_LONG, "sanity");

    __ vpminmax(opcode, elem_bt, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 37096 "ad_x86.cpp"
  }
}

void vminmaxL_reg_avx_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {

#line 6479 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    int opcode = this->ideal_Opcode();
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    assert(elem_bt == T_LONG, "sanity");

    __ vpminmax(opcode, elem_bt, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 37117 "ad_x86.cpp"
  }
}

void vminmaxL_reg_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6496 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");

    int vlen_enc = vector_length_encoding(this);
    int opcode = this->ideal_Opcode();
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    assert(elem_bt == T_LONG, "sanity");

    __ vpminmax(opcode, elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 37139 "ad_x86.cpp"
  }
}

void vminmaxL_reg_evex_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 6496 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");

    int vlen_enc = vector_length_encoding(this);
    int opcode = this->ideal_Opcode();
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    assert(elem_bt == T_LONG, "sanity");

    __ vpminmax(opcode, elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 37161 "ad_x86.cpp"
  }
}

void minmaxFP_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// a
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// b
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// atmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// btmp
  {

#line 6518 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);

    __ vminmax_fp(opcode, elem_bt,
                  opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* a */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* b */,
                  opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* atmp */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* btmp */, vlen_enc);
  
#line 37187 "ad_x86.cpp"
  }
}

void minmaxFP_reg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// a
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// b
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// atmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// btmp
  {

#line 6518 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);

    __ vminmax_fp(opcode, elem_bt,
                  opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* a */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* b */,
                  opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* atmp */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* btmp */, vlen_enc);
  
#line 37213 "ad_x86.cpp"
  }
}

void evminmaxFP_reg_eavxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// a
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// b
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// atmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// btmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// ktmp
  {

#line 6539 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);

    __ evminmax_fp(opcode, elem_bt,
                   opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* a */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* b */,
                   opnd_array(6)->as_KRegister(ra_,this,idx6)/* ktmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* atmp */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* btmp */, vlen_enc);
  
#line 37240 "ad_x86.cpp"
  }
}

void evminmaxFP_reg_eavx_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// a
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// b
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// atmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// btmp
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// ktmp
  {

#line 6539 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);

    __ evminmax_fp(opcode, elem_bt,
                   opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* a */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* b */,
                   opnd_array(6)->as_KRegister(ra_,this,idx6)/* ktmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* atmp */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* btmp */, vlen_enc);
  
#line 37267 "ad_x86.cpp"
  }
}

void vector_uminmax_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// a
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// b
  {

#line 6560 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    assert(is_integral_type(elem_bt), "");
    __ vpuminmax(opcode, elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* a */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* b */, vlen_enc);
  
#line 37286 "ad_x86.cpp"
  }
}

void vector_uminmax_reg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// a
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// b
  {

#line 6560 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    assert(is_integral_type(elem_bt), "");
    __ vpuminmax(opcode, elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* a */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* b */, vlen_enc);
  
#line 37305 "ad_x86.cpp"
  }
}

void vector_uminmax_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// a
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// b
  {

#line 6575 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    assert(is_integral_type(elem_bt), "");
    __ vpuminmax(opcode, elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* a */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 37324 "ad_x86.cpp"
  }
}

void vector_uminmax_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// a
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// b
  {

#line 6575 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    assert(is_integral_type(elem_bt), "");
    __ vpuminmax(opcode, elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* a */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 37343 "ad_x86.cpp"
  }
}

void vector_uminmaxq_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// a
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// b
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  {

#line 6591 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    __ vpuminmaxq(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* a */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* b */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, vlen_enc);
  
#line 37362 "ad_x86.cpp"
  }
}

void vector_uminmaxq_reg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// a
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// b
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  {

#line 6591 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    __ vpuminmaxq(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* a */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* b */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, vlen_enc);
  
#line 37381 "ad_x86.cpp"
  }
}

void vector_uminmax_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 6603 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 37401 "ad_x86.cpp"
  }
}

void vector_uminmax_reg_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 6603 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 37421 "ad_x86.cpp"
  }
}

void vector_uminmax_mem_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 6617 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 37441 "ad_x86.cpp"
  }
}

void vector_uminmax_mem_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 6617 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 37461 "ad_x86.cpp"
  }
}

void signumF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  {

#line 6633 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    __ signum_fp(opcode, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* zero */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* one */);
  
#line 37478 "ad_x86.cpp"
  }
}

void signumD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  {

#line 6644 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    __ signum_fp(opcode, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* zero */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* one */);
  
#line 37495 "ad_x86.cpp"
  }
}

void signumV_reg_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp1
  {

#line 6657 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vec_enc = vector_length_encoding(this);
    __ vector_signum_avx(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* zero */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* one */,
                         opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp1 */, vec_enc);
  
#line 37516 "ad_x86.cpp"
  }
}

void signumV_reg_avx_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp1
  {

#line 6657 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vec_enc = vector_length_encoding(this);
    __ vector_signum_avx(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* zero */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* one */,
                         opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp1 */, vec_enc);
  
#line 37537 "ad_x86.cpp"
  }
}

void signumV_reg_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// ktmp1
  {

#line 6672 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vec_enc = vector_length_encoding(this);
    __ vector_signum_evex(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* zero */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* one */,
                          opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp1 */, vec_enc);
  
#line 37558 "ad_x86.cpp"
  }
}

void signumV_reg_evex_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// one
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// ktmp1
  {

#line 6672 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vec_enc = vector_length_encoding(this);
    __ vector_signum_evex(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* zero */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* one */,
                          opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp1 */, vec_enc);
  
#line 37579 "ad_x86.cpp"
  }
}

void copySignF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {

#line 6706 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ movl(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */, 0x7FFFFFFF);
    __ movdl(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp1 */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);
    __ vpternlogd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, 0xE4, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* tmp1 */, Assembler::AVX_128bit);
  
#line 37598 "ad_x86.cpp"
  }
}

void copySignD_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// zero
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {

#line 6719 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ mov64(opnd_array(5)->as_Register(ra_,this,idx5)/* tmp2 */, 0x7FFFFFFFFFFFFFFF);
    __ movq(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp2 */);
    __ vpternlogq(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, 0xE4, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, Assembler::AVX_128bit);
  
#line 37618 "ad_x86.cpp"
  }
}

void compressBitsI_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 6735 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ pextl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* mask */);
  
#line 37633 "ad_x86.cpp"
  }
}

void expandBitsI_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 6745 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ pdepl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(2)->as_Register(ra_,this,idx2)/* mask */);
  
#line 37648 "ad_x86.cpp"
  }
}

void compressBitsI_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 6755 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ pextl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 37663 "ad_x86.cpp"
  }
}

void expandBitsI_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 6765 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ pdepl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()));
  
#line 37678 "ad_x86.cpp"
  }
}

void vsqrtF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 6776 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "required");
    int vlen_enc = vector_length_encoding(this);
    __ vsqrtps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
  
#line 37694 "ad_x86.cpp"
  }
}

void vsqrtF_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 6788 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "required");
    int vlen_enc = vector_length_encoding(this);
    __ vsqrtps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
  
#line 37710 "ad_x86.cpp"
  }
}

void vsqrtD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 6800 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "required");
    int vlen_enc = vector_length_encoding(this);
    __ vsqrtpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
  
#line 37726 "ad_x86.cpp"
  }
}

void vsqrtD_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  {

#line 6812 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "required");
    int vlen_enc = vector_length_encoding(this);
    __ vsqrtpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
  
#line 37742 "ad_x86.cpp"
  }
}

void vshiftcntNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cnt
  {

#line 6828 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */);
  
#line 37756 "ad_x86.cpp"
  }
}

void vshiftcnt_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// cnt
  {

#line 6828 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ movdl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* cnt */);
  
#line 37770 "ad_x86.cpp"
  }
}

void vshiftBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 6842 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE > 3, "required");
    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVB);
    __ vextendbw(sign, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ vshiftw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
    __ movdqu(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, ExternalAddress(vector_short_to_byte_mask()), noreg);
    __ pand(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */);
    __ packuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */);
  
#line 37794 "ad_x86.cpp"
  }
}

void vshiftB_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 6842 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE > 3, "required");
    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVB);
    __ vextendbw(sign, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ vshiftw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
    __ movdqu(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, ExternalAddress(vector_short_to_byte_mask()), noreg);
    __ pand(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */);
    __ packuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */);
  
#line 37818 "ad_x86.cpp"
  }
}

void vshiftB_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 6842 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE > 3, "required");
    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVB);
    __ vextendbw(sign, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ vshiftw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
    __ movdqu(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, ExternalAddress(vector_short_to_byte_mask()), noreg);
    __ pand(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */);
    __ packuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */);
  
#line 37842 "ad_x86.cpp"
  }
}

void vshift16BNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {

#line 6863 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE > 3, "required");
    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVB);
    __ vextendbw(sign, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ vshiftw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
    __ pshufd(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0xE);
    __ vextendbw(sign, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */);
    __ vshiftw(opcode, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
    __ movdqu(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, ExternalAddress(vector_short_to_byte_mask()), noreg);
    __ pand(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */);
    __ pand(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */);
    __ packuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */);
  
#line 37871 "ad_x86.cpp"
  }
}

void vshift16B_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {

#line 6863 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE > 3, "required");
    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVB);
    __ vextendbw(sign, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ vshiftw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
    __ pshufd(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0xE);
    __ vextendbw(sign, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */);
    __ vshiftw(opcode, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
    __ movdqu(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, ExternalAddress(vector_short_to_byte_mask()), noreg);
    __ pand(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */);
    __ pand(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */);
    __ packuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */);
  
#line 37900 "ad_x86.cpp"
  }
}

void vshift16B_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {

#line 6863 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE > 3, "required");
    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVB);
    __ vextendbw(sign, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ vshiftw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
    __ pshufd(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0xE);
    __ vextendbw(sign, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */);
    __ vshiftw(opcode, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
    __ movdqu(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, ExternalAddress(vector_short_to_byte_mask()), noreg);
    __ pand(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */);
    __ pand(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */);
    __ packuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */);
  
#line 37929 "ad_x86.cpp"
  }
}

void vshift16B_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 6888 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVB);
    int vlen_enc = Assembler::AVX_256bit;
    __ vextendbw(sign, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    __ vshiftw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    __ vpand(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, ExternalAddress(vector_short_to_byte_mask()), vlen_enc, noreg);
    __ vextracti128_high(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */);
    __ vpackuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, 0);
  
#line 37953 "ad_x86.cpp"
  }
}

void vshift16B_avx_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 6888 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVB);
    int vlen_enc = Assembler::AVX_256bit;
    __ vextendbw(sign, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    __ vshiftw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    __ vpand(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, ExternalAddress(vector_short_to_byte_mask()), vlen_enc, noreg);
    __ vextracti128_high(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */);
    __ vpackuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, 0);
  
#line 37977 "ad_x86.cpp"
  }
}

void vshift16B_avx_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 6888 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVB);
    int vlen_enc = Assembler::AVX_256bit;
    __ vextendbw(sign, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    __ vshiftw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    __ vpand(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, ExternalAddress(vector_short_to_byte_mask()), vlen_enc, noreg);
    __ vextracti128_high(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */);
    __ vpackuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, 0);
  
#line 38001 "ad_x86.cpp"
  }
}

void vshift32B_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 6908 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 1, "required");
    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVB);
    int vlen_enc = Assembler::AVX_256bit;
    __ vextracti128_high(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ vextendbw(sign, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, vlen_enc);
    __ vextendbw(sign, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    __ vshiftw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    __ vshiftw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    __ vpand(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, ExternalAddress(vector_short_to_byte_mask()), vlen_enc, noreg);
    __ vpand(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, ExternalAddress(vector_short_to_byte_mask()), vlen_enc, noreg);
    __ vpackuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, vlen_enc);
    __ vpermq(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, 0xD8, vlen_enc);
  
#line 38030 "ad_x86.cpp"
  }
}

void vshift32B_avx_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 6908 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 1, "required");
    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVB);
    int vlen_enc = Assembler::AVX_256bit;
    __ vextracti128_high(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ vextendbw(sign, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, vlen_enc);
    __ vextendbw(sign, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    __ vshiftw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    __ vshiftw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    __ vpand(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, ExternalAddress(vector_short_to_byte_mask()), vlen_enc, noreg);
    __ vpand(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, ExternalAddress(vector_short_to_byte_mask()), vlen_enc, noreg);
    __ vpackuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, vlen_enc);
    __ vpermq(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, 0xD8, vlen_enc);
  
#line 38059 "ad_x86.cpp"
  }
}

void vshift32B_avx_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 6908 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 1, "required");
    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVB);
    int vlen_enc = Assembler::AVX_256bit;
    __ vextracti128_high(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ vextendbw(sign, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, vlen_enc);
    __ vextendbw(sign, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    __ vshiftw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    __ vshiftw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    __ vpand(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, ExternalAddress(vector_short_to_byte_mask()), vlen_enc, noreg);
    __ vpand(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, ExternalAddress(vector_short_to_byte_mask()), vlen_enc, noreg);
    __ vpackuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, vlen_enc);
    __ vpermq(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, 0xD8, vlen_enc);
  
#line 38088 "ad_x86.cpp"
  }
}

void vshift64B_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {

#line 6933 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");
    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVB);
    int vlen_enc = Assembler::AVX_512bit;
    __ vextracti64x4(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 1);
    __ vextendbw(sign, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, vlen_enc);
    __ vextendbw(sign, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    __ vshiftw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    __ vshiftw(opcode, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    __ vmovdqu(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, ExternalAddress(vector_short_to_byte_mask()), noreg);
    __ vpbroadcastd(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
    __ vpand(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
    __ vpand(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
    __ vpackuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, vlen_enc);
    __ evmovdquq(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, ExternalAddress(vector_byte_perm_mask()), vlen_enc, noreg);
    __ vpermq(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
  
#line 38121 "ad_x86.cpp"
  }
}

void vshift64B_avx_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {

#line 6933 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");
    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVB);
    int vlen_enc = Assembler::AVX_512bit;
    __ vextracti64x4(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 1);
    __ vextendbw(sign, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, vlen_enc);
    __ vextendbw(sign, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    __ vshiftw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    __ vshiftw(opcode, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    __ vmovdqu(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, ExternalAddress(vector_short_to_byte_mask()), noreg);
    __ vpbroadcastd(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
    __ vpand(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
    __ vpand(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
    __ vpackuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, vlen_enc);
    __ evmovdquq(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, ExternalAddress(vector_byte_perm_mask()), vlen_enc, noreg);
    __ vpermq(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
  
#line 38154 "ad_x86.cpp"
  }
}

void vshift64B_avx_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {

#line 6933 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");
    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVB);
    int vlen_enc = Assembler::AVX_512bit;
    __ vextracti64x4(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 1);
    __ vextendbw(sign, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, vlen_enc);
    __ vextendbw(sign, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    __ vshiftw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    __ vshiftw(opcode, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    __ vmovdqu(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, ExternalAddress(vector_short_to_byte_mask()), noreg);
    __ vpbroadcastd(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
    __ vpand(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
    __ vpand(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
    __ vpackuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, vlen_enc);
    __ evmovdquq(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, ExternalAddress(vector_byte_perm_mask()), vlen_enc, noreg);
    __ vpermq(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* tmp2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
  
#line 38187 "ad_x86.cpp"
  }
}

void vshiftSNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {

#line 6966 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    if (UseAVX > 0) {
      int vlen_enc = vector_length_encoding(this);
      __ vshiftw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    } else {
      int vlen = Matcher::vector_length(this);
      if (vlen == 2) {
        __ movflt(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
      } else if (vlen == 4) {
        __ movdbl(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
      } else {
        assert (vlen == 8, "sanity");
        __ movdqu(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
      }
    }
  
#line 38220 "ad_x86.cpp"
  }
}

void vshiftS_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {

#line 6966 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    if (UseAVX > 0) {
      int vlen_enc = vector_length_encoding(this);
      __ vshiftw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    } else {
      int vlen = Matcher::vector_length(this);
      if (vlen == 2) {
        __ movflt(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
      } else if (vlen == 4) {
        __ movdbl(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
      } else {
        assert (vlen == 8, "sanity");
        __ movdqu(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
      }
    }
  
#line 38253 "ad_x86.cpp"
  }
}

void vshiftS_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {

#line 6966 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    if (UseAVX > 0) {
      int vlen_enc = vector_length_encoding(this);
      __ vshiftw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    } else {
      int vlen = Matcher::vector_length(this);
      if (vlen == 2) {
        __ movflt(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
      } else if (vlen == 4) {
        __ movdbl(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
      } else {
        assert (vlen == 8, "sanity");
        __ movdqu(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
      }
    }
  
#line 38286 "ad_x86.cpp"
  }
}

void vshiftINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {

#line 6997 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    if (UseAVX > 0) {
      int vlen_enc = vector_length_encoding(this);
      __ vshiftd(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    } else {
      int vlen = Matcher::vector_length(this);
      if (vlen == 2) {
        __ movdbl(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftd(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
      } else {
        assert(vlen == 4, "sanity");
        __ movdqu(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftd(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
      }
    }
  
#line 38316 "ad_x86.cpp"
  }
}

void vshiftI_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {

#line 6997 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    if (UseAVX > 0) {
      int vlen_enc = vector_length_encoding(this);
      __ vshiftd(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    } else {
      int vlen = Matcher::vector_length(this);
      if (vlen == 2) {
        __ movdbl(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftd(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
      } else {
        assert(vlen == 4, "sanity");
        __ movdqu(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftd(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
      }
    }
  
#line 38346 "ad_x86.cpp"
  }
}

void vshiftI_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {

#line 6997 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    if (UseAVX > 0) {
      int vlen_enc = vector_length_encoding(this);
      __ vshiftd(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    } else {
      int vlen = Matcher::vector_length(this);
      if (vlen == 2) {
        __ movdbl(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftd(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
      } else {
        assert(vlen == 4, "sanity");
        __ movdqu(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftd(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
      }
    }
  
#line 38376 "ad_x86.cpp"
  }
}

void vshiftI_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 7023 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    if (UseAVX > 0) {
      int vector_len = vector_length_encoding(this);
      __ vshiftd_imm(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant(), vector_len);
    } else {
      int vlen = Matcher::vector_length(this);
      if (vlen == 2) {
        __ movdbl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftd_imm(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->constant());
      } else {
        assert(vlen == 4, "sanity");
        __ movdqu(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftd_imm(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->constant());
      }
    }
  
#line 38405 "ad_x86.cpp"
  }
}

void vshiftI_imm_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 7023 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    if (UseAVX > 0) {
      int vector_len = vector_length_encoding(this);
      __ vshiftd_imm(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant(), vector_len);
    } else {
      int vlen = Matcher::vector_length(this);
      if (vlen == 2) {
        __ movdbl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftd_imm(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->constant());
      } else {
        assert(vlen == 4, "sanity");
        __ movdqu(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftd_imm(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->constant());
      }
    }
  
#line 38434 "ad_x86.cpp"
  }
}

void vshiftI_imm_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 7023 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    if (UseAVX > 0) {
      int vector_len = vector_length_encoding(this);
      __ vshiftd_imm(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant(), vector_len);
    } else {
      int vlen = Matcher::vector_length(this);
      if (vlen == 2) {
        __ movdbl(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftd_imm(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->constant());
      } else {
        assert(vlen == 4, "sanity");
        __ movdqu(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
        __ vshiftd_imm(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->constant());
      }
    }
  
#line 38463 "ad_x86.cpp"
  }
}

void vshiftLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {

#line 7050 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    if (UseAVX > 0) {
      int vlen_enc = vector_length_encoding(this);
      __ vshiftq(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    } else {
      assert(Matcher::vector_length(this) == 2, "");
      __ movdqu(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
      __ vshiftq(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
    }
  
#line 38487 "ad_x86.cpp"
  }
}

void vshiftL_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {

#line 7050 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    if (UseAVX > 0) {
      int vlen_enc = vector_length_encoding(this);
      __ vshiftq(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    } else {
      assert(Matcher::vector_length(this) == 2, "");
      __ movdqu(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
      __ vshiftq(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
    }
  
#line 38511 "ad_x86.cpp"
  }
}

void vshiftL_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 7069 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    if (UseAVX > 0) {
      int vector_len = vector_length_encoding(this);
      __ vshiftq_imm(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant(), vector_len);
    } else {
      assert(Matcher::vector_length(this) == 2, "");
      __ movdqu(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
      __ vshiftq_imm(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->constant());
    }
  
#line 38534 "ad_x86.cpp"
  }
}

void vshiftL_imm_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 7069 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    if (UseAVX > 0) {
      int vector_len = vector_length_encoding(this);
      __ vshiftq_imm(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant(), vector_len);
    } else {
      assert(Matcher::vector_length(this) == 2, "");
      __ movdqu(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
      __ vshiftq_imm(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->constant());
    }
  
#line 38557 "ad_x86.cpp"
  }
}

void vshiftL_arith_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 7090 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    uint vlen = Matcher::vector_length(this);
    if (vlen == 2) {
      assert(UseSSE >= 2, "required");
      __ movdqu(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
      __ psrlq(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
      __ movdqu(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, ExternalAddress(vector_long_sign_mask()), noreg);
      __ psrlq(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
      __ pxor(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */);
      __ psubq(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */);
    } else {
      assert(vlen == 4, "sanity");
      assert(UseAVX > 1, "required");
      int vlen_enc = Assembler::AVX_256bit;
      __ vpsrlq(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
      __ vmovdqu(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, ExternalAddress(vector_long_sign_mask()), noreg);
      __ vpsrlq(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
      __ vpxor(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, vlen_enc);
      __ vpsubq(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, vlen_enc);
    }
  
#line 38592 "ad_x86.cpp"
  }
}

void vshiftL_arith_reg_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 7118 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ evpsraq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
  
#line 38608 "ad_x86.cpp"
  }
}

void vshift8B_var_nobwNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 7136 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = Assembler::AVX_128bit;
    __ varshiftbw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */);
    __ vpackuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, 0);
  
#line 38630 "ad_x86.cpp"
  }
}

void vshift8B_var_nobw_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 7136 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = Assembler::AVX_128bit;
    __ varshiftbw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */);
    __ vpackuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, 0);
  
#line 38652 "ad_x86.cpp"
  }
}

void vshift8B_var_nobw_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 7136 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = Assembler::AVX_128bit;
    __ varshiftbw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */);
    __ vpackuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, 0);
  
#line 38674 "ad_x86.cpp"
  }
}

void vshift16B_var_nobwNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  {

#line 7156 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = Assembler::AVX_128bit;
    // Shift lower half and get word result in dst
    __ varshiftbw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */);

    // Shift upper half and get word result in vtmp1
    __ vpshufd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0xE, 0);
    __ vpshufd(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, 0xE, 0);
    __ varshiftbw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, vlen_enc, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */);

    // Merge and down convert the two word results to byte in dst
    __ vpackuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, 0);
  
#line 38705 "ad_x86.cpp"
  }
}

void vshift16B_var_nobw_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  {

#line 7156 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = Assembler::AVX_128bit;
    // Shift lower half and get word result in dst
    __ varshiftbw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */);

    // Shift upper half and get word result in vtmp1
    __ vpshufd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0xE, 0);
    __ vpshufd(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, 0xE, 0);
    __ varshiftbw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, vlen_enc, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */);

    // Merge and down convert the two word results to byte in dst
    __ vpackuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, 0);
  
#line 38736 "ad_x86.cpp"
  }
}

void vshift16B_var_nobw_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  {

#line 7156 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = Assembler::AVX_128bit;
    // Shift lower half and get word result in dst
    __ varshiftbw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */);

    // Shift upper half and get word result in vtmp1
    __ vpshufd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0xE, 0);
    __ vpshufd(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, 0xE, 0);
    __ varshiftbw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, vlen_enc, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */);

    // Merge and down convert the two word results to byte in dst
    __ vpackuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, 0);
  
#line 38767 "ad_x86.cpp"
  }
}

void vshift32B_var_nobwNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// vtmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// vtmp4
  {

#line 7184 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = Assembler::AVX_128bit;
    // Process lower 128 bits and get result in dst
    __ varshiftbw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */);
    __ vpshufd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0xE, 0);
    __ vpshufd(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, 0xE, 0);
    __ varshiftbw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, vlen_enc, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */);
    __ vpackuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, 0);

    // Process higher 128 bits and get result in vtmp3
    __ vextracti128_high(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ vextracti128_high(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
    __ varshiftbw(opcode, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* vtmp3 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, vlen_enc, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* vtmp4 */);
    __ vpshufd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, 0xE, 0);
    __ vpshufd(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, 0xE, 0);
    __ varshiftbw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, vlen_enc, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */);
    __ vpackuswb(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* vtmp3 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, 0);

    // Merge the two results in dst
    __ vinserti128(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, 0x1);
  
#line 38808 "ad_x86.cpp"
  }
}

void vshift32B_var_nobw_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// vtmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// vtmp4
  {

#line 7184 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = Assembler::AVX_128bit;
    // Process lower 128 bits and get result in dst
    __ varshiftbw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */);
    __ vpshufd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0xE, 0);
    __ vpshufd(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, 0xE, 0);
    __ varshiftbw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, vlen_enc, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */);
    __ vpackuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, 0);

    // Process higher 128 bits and get result in vtmp3
    __ vextracti128_high(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ vextracti128_high(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
    __ varshiftbw(opcode, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* vtmp3 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, vlen_enc, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* vtmp4 */);
    __ vpshufd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, 0xE, 0);
    __ vpshufd(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, 0xE, 0);
    __ varshiftbw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, vlen_enc, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */);
    __ vpackuswb(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* vtmp3 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, 0);

    // Merge the two results in dst
    __ vinserti128(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, 0x1);
  
#line 38849 "ad_x86.cpp"
  }
}

void vshift32B_var_nobw_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// vtmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// vtmp4
  {

#line 7184 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = Assembler::AVX_128bit;
    // Process lower 128 bits and get result in dst
    __ varshiftbw(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */);
    __ vpshufd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0xE, 0);
    __ vpshufd(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, 0xE, 0);
    __ varshiftbw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, vlen_enc, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */);
    __ vpackuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, 0);

    // Process higher 128 bits and get result in vtmp3
    __ vextracti128_high(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ vextracti128_high(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
    __ varshiftbw(opcode, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* vtmp3 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, vlen_enc, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* vtmp4 */);
    __ vpshufd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, 0xE, 0);
    __ vpshufd(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, 0xE, 0);
    __ varshiftbw(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, vlen_enc, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */);
    __ vpackuswb(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* vtmp3 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, 0);

    // Merge the two results in dst
    __ vinserti128(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, 0x1);
  
#line 38890 "ad_x86.cpp"
  }
}

void vshiftB_var_evex_bwNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 7220 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    __ evarshiftb(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */);
  
#line 38911 "ad_x86.cpp"
  }
}

void vshiftB_var_evex_bw_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 7220 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    __ evarshiftb(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */);
  
#line 38932 "ad_x86.cpp"
  }
}

void vshiftB_var_evex_bw_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 7220 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    __ evarshiftb(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */);
  
#line 38953 "ad_x86.cpp"
  }
}

void vshift64B_var_evex_bwNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  {

#line 7239 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = Assembler::AVX_256bit;
    __ evarshiftb(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */);
    __ vextracti64x4_high(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ vextracti64x4_high(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
    __ evarshiftb(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, vlen_enc, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */);
    __ vinserti64x4(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, 0x1);
  
#line 38979 "ad_x86.cpp"
  }
}

void vshift64B_var_evex_bw_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  {

#line 7239 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = Assembler::AVX_256bit;
    __ evarshiftb(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */);
    __ vextracti64x4_high(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ vextracti64x4_high(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
    __ evarshiftb(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, vlen_enc, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */);
    __ vinserti64x4(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, 0x1);
  
#line 39005 "ad_x86.cpp"
  }
}

void vshift64B_var_evex_bw_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  {

#line 7239 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = Assembler::AVX_256bit;
    __ evarshiftb(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */);
    __ vextracti64x4_high(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ vextracti64x4_high(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
    __ evarshiftb(opcode, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, vlen_enc, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */);
    __ vinserti64x4(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, 0x1);
  
#line 39031 "ad_x86.cpp"
  }
}

void vshift8S_var_nobwNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 7263 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVS);
    int vlen_enc = Assembler::AVX_256bit;
    __ vextendwd(sign, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 1);
    __ vpmovzxwd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, 1);
    __ varshiftd(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, vlen_enc);
    __ vpand(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, ExternalAddress(vector_int_to_short_mask()), vlen_enc, noreg);
    __ vextracti128_high(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */);
    __ vpackusdw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, 0);
  
#line 39058 "ad_x86.cpp"
  }
}

void vshift8S_var_nobw_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 7263 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVS);
    int vlen_enc = Assembler::AVX_256bit;
    __ vextendwd(sign, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 1);
    __ vpmovzxwd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, 1);
    __ varshiftd(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, vlen_enc);
    __ vpand(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, ExternalAddress(vector_int_to_short_mask()), vlen_enc, noreg);
    __ vextracti128_high(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */);
    __ vpackusdw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, 0);
  
#line 39085 "ad_x86.cpp"
  }
}

void vshift8S_var_nobw_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 7263 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVS);
    int vlen_enc = Assembler::AVX_256bit;
    __ vextendwd(sign, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 1);
    __ vpmovzxwd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, 1);
    __ varshiftd(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, vlen_enc);
    __ vpand(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, ExternalAddress(vector_int_to_short_mask()), vlen_enc, noreg);
    __ vextracti128_high(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */);
    __ vpackusdw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, 0);
  
#line 39112 "ad_x86.cpp"
  }
}

void vshift16S_var_nobwNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  {

#line 7288 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVS);
    int vlen_enc = Assembler::AVX_256bit;
    // Shift lower half, with result in vtmp2 using vtmp1 as TEMP
    __ vextendwd(sign, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    __ vpmovzxwd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    __ varshiftd(opcode, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, vlen_enc);
    __ vpand(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, ExternalAddress(vector_int_to_short_mask()), vlen_enc, noreg);

    // Shift upper half, with result in dst using vtmp1 as TEMP
    __ vextracti128_high(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ vextracti128_high(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
    __ vextendwd(sign, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
    __ vpmovzxwd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, vlen_enc);
    __ varshiftd(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, vlen_enc);
    __ vpand(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, ExternalAddress(vector_int_to_short_mask()), vlen_enc, noreg);

    // Merge lower and upper half result into dst
    __ vpackusdw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
    __ vpermq(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, 0xD8, vlen_enc);
  
#line 39151 "ad_x86.cpp"
  }
}

void vshift16S_var_nobw_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  {

#line 7288 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVS);
    int vlen_enc = Assembler::AVX_256bit;
    // Shift lower half, with result in vtmp2 using vtmp1 as TEMP
    __ vextendwd(sign, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    __ vpmovzxwd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    __ varshiftd(opcode, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, vlen_enc);
    __ vpand(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, ExternalAddress(vector_int_to_short_mask()), vlen_enc, noreg);

    // Shift upper half, with result in dst using vtmp1 as TEMP
    __ vextracti128_high(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ vextracti128_high(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
    __ vextendwd(sign, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
    __ vpmovzxwd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, vlen_enc);
    __ varshiftd(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, vlen_enc);
    __ vpand(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, ExternalAddress(vector_int_to_short_mask()), vlen_enc, noreg);

    // Merge lower and upper half result into dst
    __ vpackusdw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
    __ vpermq(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, 0xD8, vlen_enc);
  
#line 39190 "ad_x86.cpp"
  }
}

void vshift16S_var_nobw_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  {

#line 7288 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int opcode = this->ideal_Opcode();
    bool sign = (opcode != Op_URShiftVS);
    int vlen_enc = Assembler::AVX_256bit;
    // Shift lower half, with result in vtmp2 using vtmp1 as TEMP
    __ vextendwd(sign, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    __ vpmovzxwd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
    __ varshiftd(opcode, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, vlen_enc);
    __ vpand(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, ExternalAddress(vector_int_to_short_mask()), vlen_enc, noreg);

    // Shift upper half, with result in dst using vtmp1 as TEMP
    __ vextracti128_high(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ vextracti128_high(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */);
    __ vextendwd(sign, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
    __ vpmovzxwd(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, vlen_enc);
    __ varshiftd(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, vlen_enc);
    __ vpand(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, ExternalAddress(vector_int_to_short_mask()), vlen_enc, noreg);

    // Merge lower and upper half result into dst
    __ vpackusdw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
    __ vpermq(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, 0xD8, vlen_enc);
  
#line 39229 "ad_x86.cpp"
  }
}

void vshift16S_var_evex_bwNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 7322 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    if (!VM_Version::supports_avx512vl()) {
      vlen_enc = Assembler::AVX_512bit;
    }
    __ varshiftw(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
  
#line 39251 "ad_x86.cpp"
  }
}

void vshift16S_var_evex_bw_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 7322 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    if (!VM_Version::supports_avx512vl()) {
      vlen_enc = Assembler::AVX_512bit;
    }
    __ varshiftw(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
  
#line 39273 "ad_x86.cpp"
  }
}

void vshift16S_var_evex_bw_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 7322 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    if (!VM_Version::supports_avx512vl()) {
      vlen_enc = Assembler::AVX_512bit;
    }
    __ varshiftw(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
  
#line 39295 "ad_x86.cpp"
  }
}

void vshiftI_varNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 7342 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    __ varshiftd(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
  
#line 39314 "ad_x86.cpp"
  }
}

void vshiftI_var_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 7342 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    __ varshiftd(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
  
#line 39333 "ad_x86.cpp"
  }
}

void vshiftI_var_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 7342 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    __ varshiftd(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
  
#line 39352 "ad_x86.cpp"
  }
}

void vshiftL_varNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 7358 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    __ varshiftq(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
  
#line 39371 "ad_x86.cpp"
  }
}

void vshiftL_var_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 7358 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    __ varshiftq(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
  
#line 39390 "ad_x86.cpp"
  }
}

void vshiftL_arith_varNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 7376 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    __ varshiftq(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc,
                 opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */);
  
#line 39410 "ad_x86.cpp"
  }
}

void vshiftL_arith_var_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 7390 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    __ varshiftq(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vlen_enc);
  
#line 39427 "ad_x86.cpp"
  }
}

void vandNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7404 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ pand(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 39442 "ad_x86.cpp"
  }
}

void vand_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 7414 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpand(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 39458 "ad_x86.cpp"
  }
}

void vand_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 7426 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpand(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 39474 "ad_x86.cpp"
  }
}

void vand_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7426 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpand(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
  
#line 39490 "ad_x86.cpp"
  }
}

void vorNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7439 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ por(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 39505 "ad_x86.cpp"
  }
}

void vor_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 7449 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 39521 "ad_x86.cpp"
  }
}

void vor_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 7461 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 39537 "ad_x86.cpp"
  }
}

void vor_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7461 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
  
#line 39553 "ad_x86.cpp"
  }
}

void vxorNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7474 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ pxor(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */);
  
#line 39568 "ad_x86.cpp"
  }
}

void vxor_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 7484 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 39584 "ad_x86.cpp"
  }
}

void vxor_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mem
  {

#line 7496 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), vlen_enc);
  
#line 39600 "ad_x86.cpp"
  }
}

void vxor_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  {

#line 7496 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpxor(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), vlen_enc);
  
#line 39616 "ad_x86.cpp"
  }
}

void vcastBtoXNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7509 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    BasicType to_elem_bt = Matcher::vector_element_basic_type(this);
    int vlen_enc = vector_length_encoding(this);
    __ vconvert_b2x(to_elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
  
#line 39632 "ad_x86.cpp"
  }
}

void vcastBtoDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7521 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vconvert_b2x(T_DOUBLE, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
  
#line 39647 "ad_x86.cpp"
  }
}

void castStoXNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7534 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "required");

    __ vpand(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, ExternalAddress(vector_short_to_byte_mask()), 0, noreg);
    __ vpackuswb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 0);
  
#line 39664 "ad_x86.cpp"
  }
}

void vcastStoXNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp
  {

#line 7550 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "required");

    int vlen_enc = vector_length_encoding(Matcher::vector_length_in_bytes(this, opnd_array(1)));
    __ vpand(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, ExternalAddress(vector_short_to_byte_mask()), vlen_enc, noreg);
    __ vextracti128(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, 0x1);
    __ vpackuswb(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, 0);
  
#line 39685 "ad_x86.cpp"
  }
}

void vcastStoX_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7566 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    BasicType to_elem_bt = Matcher::vector_element_basic_type(this);
    int src_vlen_enc = vector_length_encoding(this, opnd_array(1));
    int vlen_enc = vector_length_encoding(this);
    switch (to_elem_bt) {
      case T_BYTE:
        if (!VM_Version::supports_avx512vl()) {
          vlen_enc = Assembler::AVX_512bit;
        }
        __ evpmovwb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, src_vlen_enc);
        break;
      case T_INT:
        __ vpmovsxwd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
        break;
      case T_FLOAT:
        __ vpmovsxwd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
        __ vcvtdq2ps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vlen_enc);
        break;
      case T_LONG:
        __ vpmovsxwq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
        break;
      case T_DOUBLE: {
        int mid_vlen_enc = (vlen_enc == Assembler::AVX_512bit) ? Assembler::AVX_256bit : Assembler::AVX_128bit;
        __ vpmovsxwd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, mid_vlen_enc);
        __ vcvtdq2pd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vlen_enc);
        break;
      }
      default:
        ShouldNotReachHere();
    }
  
#line 39727 "ad_x86.cpp"
  }
}

void castItoXNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7606 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "required");

    BasicType to_elem_bt = Matcher::vector_element_basic_type(this);
    int vlen_enc = vector_length_encoding(this, opnd_array(1));

    if (to_elem_bt == T_BYTE) {
      __ vpand(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, ExternalAddress(vector_int_to_byte_mask()), vlen_enc, noreg);
      __ vpackusdw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vlen_enc);
      __ vpackuswb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vlen_enc);
    } else {
      assert(to_elem_bt == T_SHORT, "%s", type2name(to_elem_bt));
      __ vpand(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, ExternalAddress(vector_int_to_short_mask()), vlen_enc, noreg);
      __ vpackusdw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vlen_enc);
    }
  
#line 39754 "ad_x86.cpp"
  }
}

void vcastItoXNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp
  {

#line 7632 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "required");

    BasicType to_elem_bt = Matcher::vector_element_basic_type(this);
    int vlen_enc = vector_length_encoding(this, opnd_array(1));

    if (to_elem_bt == T_BYTE) {
      __ vpand(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, ExternalAddress(vector_int_to_byte_mask()), vlen_enc, noreg);
      __ vextracti128(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, 0x1);
      __ vpackusdw(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, vlen_enc);
      __ vpackuswb(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, Assembler::AVX_128bit);
    } else {
      assert(to_elem_bt == T_SHORT, "%s", type2name(to_elem_bt));
      __ vpand(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, ExternalAddress(vector_int_to_short_mask()), vlen_enc, noreg);
      __ vextracti128(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, 0x1);
      __ vpackusdw(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, vlen_enc);
    }
  
#line 39785 "ad_x86.cpp"
  }
}

void vcastItoX_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7658 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "required");

    BasicType dst_elem_bt = Matcher::vector_element_basic_type(this);
    int src_vlen_enc = vector_length_encoding(this, opnd_array(1));
    int dst_vlen_enc = vector_length_encoding(this);
    switch (dst_elem_bt) {
      case T_BYTE:
        if (!VM_Version::supports_avx512vl()) {
          src_vlen_enc = Assembler::AVX_512bit;
        }
        __ evpmovdb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, src_vlen_enc);
        break;
      case T_SHORT:
        if (!VM_Version::supports_avx512vl()) {
          src_vlen_enc = Assembler::AVX_512bit;
        }
        __ evpmovdw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, src_vlen_enc);
        break;
      case T_FLOAT:
        __ vcvtdq2ps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, dst_vlen_enc);
        break;
      case T_LONG:
        __ vpmovsxdq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, dst_vlen_enc);
        break;
      case T_DOUBLE:
        __ vcvtdq2pd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, dst_vlen_enc);
        break;
      default:
        ShouldNotReachHere();
    }
  
#line 39828 "ad_x86.cpp"
  }
}

void vcastLtoBSNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7698 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "required");

    int vlen = Matcher::vector_length_in_bytes(this, opnd_array(1));
    BasicType to_elem_bt  = Matcher::vector_element_basic_type(this);
    AddressLiteral mask_addr = (to_elem_bt == T_BYTE) ? ExternalAddress(vector_int_to_byte_mask())
                                                      : ExternalAddress(vector_int_to_short_mask());
    if (vlen <= 16) {
      __ vpshufd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 8, Assembler::AVX_128bit);
      __ vpand(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, mask_addr, Assembler::AVX_128bit, noreg);
      __ vpackusdw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Assembler::AVX_128bit);
    } else {
      assert(vlen <= 32, "required");
      __ vpermilps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 8, Assembler::AVX_256bit);
      __ vpermpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 8, Assembler::AVX_256bit);
      __ vpand(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, mask_addr, Assembler::AVX_128bit, noreg);
      __ vpackusdw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Assembler::AVX_128bit);
    }
    if (to_elem_bt == T_BYTE) {
      __ vpackuswb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Assembler::AVX_128bit);
    }
  
#line 39861 "ad_x86.cpp"
  }
}

void vcastLtoX_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7730 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    BasicType to_elem_bt = Matcher::vector_element_basic_type(this);
    int vlen = Matcher::vector_length_in_bytes(this, opnd_array(1));
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    switch (to_elem_bt) {
      case T_BYTE:
        if (UseAVX > 2 && !VM_Version::supports_avx512vl()) {
          vlen_enc = Assembler::AVX_512bit;
        }
        __ evpmovqb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
        break;
      case T_SHORT:
        if (UseAVX > 2 && !VM_Version::supports_avx512vl()) {
          vlen_enc = Assembler::AVX_512bit;
        }
        __ evpmovqw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
        break;
      case T_INT:
        if (vlen == 8) {
          if (opnd_array(0)->as_XMMRegister(ra_,this)/* dst */!= opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */) {
            __ movflt(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
          }
        } else if (vlen == 16) {
          __ pshufd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 8);
        } else if (vlen == 32) {
          if (UseAVX > 2) {
            if (!VM_Version::supports_avx512vl()) {
              vlen_enc = Assembler::AVX_512bit;
            }
            __ evpmovqd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
          } else {
            __ vpermilps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 8, vlen_enc);
            __ vpermpd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, 8, vlen_enc);
          }
        } else { // vlen == 64
          __ evpmovqd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
        }
        break;
      case T_FLOAT:
        assert(UseAVX > 2 && VM_Version::supports_avx512dq(), "required");
        __ evcvtqq2ps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
        break;
      case T_DOUBLE:
        assert(UseAVX > 2 && VM_Version::supports_avx512dq(), "required");
        __ evcvtqq2pd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
        break;

      default: assert(false, "%s", type2name(to_elem_bt));
    }
  
#line 39922 "ad_x86.cpp"
  }
}

void vcastFtoD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7787 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vcvtps2pd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
  
#line 39937 "ad_x86.cpp"
  }
}

void castFtoX_reg_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp3
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// xtmp4
  {

#line 7801 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    BasicType to_elem_bt = Matcher::vector_element_basic_type(this);
    // JDK-8292878 removed the need for an explicit scratch register needed to load greater than
    // 32 bit addresses for register indirect addressing mode since stub constants
    // are part of code cache and there is a cap of 2G on ReservedCodeCacheSize currently.
    // However, targets are free to increase this limit, but having a large code cache size
    // greater than 2G looks unreasonable in practical scenario, on the hind side with given
    // cap we save a temporary register allocation which in limiting case can prevent
    // spilling in high register pressure blocks.
    __ vector_castF2X_avx(to_elem_bt, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */,
                          opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp3 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* xtmp4 */,
                          ExternalAddress(vector_float_signflip()), noreg, vlen_enc);
  
#line 39967 "ad_x86.cpp"
  }
}

void castFtoX_reg_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// ktmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// ktmp2
  {

#line 7824 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    BasicType to_elem_bt = Matcher::vector_element_basic_type(this);
    if (to_elem_bt == T_LONG) {
      int vlen_enc = vector_length_encoding(this);
      __ vector_castF2L_evex(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */,
                             opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp1 */, opnd_array(6)->as_KRegister(ra_,this,idx6)/* ktmp2 */,
                             ExternalAddress(vector_double_signflip()), noreg, vlen_enc);
    } else {
      int vlen_enc = vector_length_encoding(this, opnd_array(1));
      __ vector_castF2X_evex(to_elem_bt, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */,
                             opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp1 */, opnd_array(6)->as_KRegister(ra_,this,idx6)/* ktmp2 */,
                             ExternalAddress(vector_float_signflip()), noreg, vlen_enc);
    }
  
#line 39997 "ad_x86.cpp"
  }
}

void vcastDtoF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7845 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    __ vcvtpd2ps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
  
#line 40012 "ad_x86.cpp"
  }
}

void castDtoX_reg_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp3
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// xtmp4
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// xtmp5
  {

#line 7858 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    BasicType to_elem_bt = Matcher::vector_element_basic_type(this);
    __ vector_castD2X_avx(to_elem_bt, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */,
                          opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp3 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* xtmp4 */, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* xtmp5 */,
                          ExternalAddress(vector_float_signflip()), noreg, vlen_enc);
  
#line 40036 "ad_x86.cpp"
  }
}

void castDtoX_reg_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// ktmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// ktmp2
  {

#line 7874 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    BasicType to_elem_bt = Matcher::vector_element_basic_type(this);
    AddressLiteral signflip = VM_Version::supports_avx512dq() ? ExternalAddress(vector_double_signflip()) :
                              ExternalAddress(vector_float_signflip());
    __ vector_castD2X_evex(to_elem_bt, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */,
                           opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp1 */, opnd_array(6)->as_KRegister(ra_,this,idx6)/* ktmp2 */, signflip, noreg, vlen_enc);
  
#line 40060 "ad_x86.cpp"
  }
}

void vucastNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7890 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "required");

    BasicType from_elem_bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    BasicType to_elem_bt = Matcher::vector_element_basic_type(this);
    int vlen_enc = vector_length_encoding(this);
    __ vector_unsigned_cast(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc, from_elem_bt, to_elem_bt);
  
#line 40079 "ad_x86.cpp"
  }
}

void vucast_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7890 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "required");

    BasicType from_elem_bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    BasicType to_elem_bt = Matcher::vector_element_basic_type(this);
    int vlen_enc = vector_length_encoding(this);
    __ vector_unsigned_cast(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc, from_elem_bt, to_elem_bt);
  
#line 40098 "ad_x86.cpp"
  }
}

void vucast_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 7890 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 0, "required");

    BasicType from_elem_bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    BasicType to_elem_bt = Matcher::vector_element_basic_type(this);
    int vlen_enc = vector_length_encoding(this);
    __ vector_unsigned_cast(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc, from_elem_bt, to_elem_bt);
  
#line 40117 "ad_x86.cpp"
  }
}

void vround_float_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// xtmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// xtmp4
  {

#line 7909 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    InternalAddress new_mxcsr = InternalAddress(__ code()->consts()->start() + constant_offset());
    __ vector_round_float_avx(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */,
                              ExternalAddress(StubRoutines::x86::vector_float_sign_flip()), new_mxcsr, vlen_enc,
                              opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp2 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* xtmp3 */, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* xtmp4 */);
  
#line 40141 "ad_x86.cpp"
  }
}

void vround_float_avxNode::eval_constant(Compile* C) {
  {

#line 7911 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, (jint)(EnableX86ECoreOpts ? 0x3FBF : 0x3F80));
#line 40150 "ad_x86.cpp"
  }
}
void vround_float_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// ktmp1
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// ktmp2
  {

#line 7926 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    InternalAddress new_mxcsr = InternalAddress(__ code()->consts()->start() + constant_offset());
    __ vector_round_float_evex(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */,
                               ExternalAddress(StubRoutines::x86::vector_float_sign_flip()), new_mxcsr, vlen_enc,
                               opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp2 */, opnd_array(6)->as_KRegister(ra_,this,idx6)/* ktmp1 */, opnd_array(7)->as_KRegister(ra_,this,idx7)/* ktmp2 */);
  
#line 40173 "ad_x86.cpp"
  }
}

void vround_float_evexNode::eval_constant(Compile* C) {
  {

#line 7928 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, (jint)(EnableX86ECoreOpts ? 0x3FBF : 0x3F80));
#line 40182 "ad_x86.cpp"
  }
}
void vround_reg_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// ktmp1
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// ktmp2
  {

#line 7941 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    InternalAddress new_mxcsr = InternalAddress(__ code()->consts()->start() + constant_offset());
    __ vector_round_double_evex(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */,
                                ExternalAddress(StubRoutines::x86::vector_double_sign_flip()), new_mxcsr, vlen_enc,
                                opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp2 */, opnd_array(6)->as_KRegister(ra_,this,idx6)/* ktmp1 */, opnd_array(7)->as_KRegister(ra_,this,idx7)/* ktmp2 */);
  
#line 40205 "ad_x86.cpp"
  }
}

void vround_reg_evexNode::eval_constant(Compile* C) {
  {

#line 7943 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, (jint)(EnableX86ECoreOpts ? 0x3FBF : 0x3F80));
#line 40214 "ad_x86.cpp"
  }
}
void vcmpFDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {

#line 7962 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    Assembler::ComparisonPredicateFP cmp = booltest_pred_to_comparison_pred_fp(opnd_array(3)->constant());
    if (Matcher::vector_element_basic_type(this, opnd_array(1)) == T_FLOAT) {
      __ vcmpps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, cmp, vlen_enc);
    } else {
      __ vcmppd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, cmp, vlen_enc);
    }
  
#line 40235 "ad_x86.cpp"
  }
}

void evcmpFD64Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// ktmp
  {

#line 7981 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = Assembler::AVX_512bit;
    Assembler::ComparisonPredicateFP cmp = booltest_pred_to_comparison_pred_fp(opnd_array(3)->constant());
    KRegister mask = k0; // The comparison itself is not being masked.
    if (Matcher::vector_element_basic_type(this, opnd_array(1)) == T_FLOAT) {
      __ evcmpps(opnd_array(4)->as_KRegister(ra_,this,idx4)/* ktmp */, mask, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, cmp, vlen_enc);
      __ evmovdqul(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(4)->as_KRegister(ra_,this,idx4)/* ktmp */, ExternalAddress(vector_all_bits_set()), false, vlen_enc, noreg);
    } else {
      __ evcmppd(opnd_array(4)->as_KRegister(ra_,this,idx4)/* ktmp */, mask, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, cmp, vlen_enc);
      __ evmovdquq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(4)->as_KRegister(ra_,this,idx4)/* ktmp */, ExternalAddress(vector_all_bits_set()), false, vlen_enc, noreg);
    }
  
#line 40261 "ad_x86.cpp"
  }
}

void evcmpFDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {

#line 8001 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(bottom_type()->isa_vectmask(), "TypeVectMask expected");
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    Assembler::ComparisonPredicateFP cmp = booltest_pred_to_comparison_pred_fp(opnd_array(3)->constant());
    KRegister mask = k0; // The comparison itself is not being masked.
    if (Matcher::vector_element_basic_type(this, opnd_array(1)) == T_FLOAT) {
      __ evcmpps(opnd_array(0)->as_KRegister(ra_,this)/* dst */, mask, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, cmp, vlen_enc);
    } else {
      __ evcmppd(opnd_array(0)->as_KRegister(ra_,this)/* dst */, mask, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, cmp, vlen_enc);
    }
  
#line 40285 "ad_x86.cpp"
  }
}

void vcmp_directNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {

#line 8026 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    Assembler::ComparisonPredicate cmp = booltest_pred_to_comparison_pred(opnd_array(3)->constant());
    Assembler::Width ww = widthForType(Matcher::vector_element_basic_type(this, opnd_array(1)));
    __ vpcmpCCW(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, xnoreg, cmp, ww, vlen_enc);
  
#line 40304 "ad_x86.cpp"
  }
}

void vcmp_negateNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp
  {

#line 8047 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    Assembler::ComparisonPredicate cmp = booltest_pred_to_comparison_pred(opnd_array(3)->constant());
    Assembler::Width ww = widthForType(Matcher::vector_element_basic_type(this, opnd_array(1)));
    __ vpcmpCCW(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp */, cmp, ww, vlen_enc);
  
#line 40325 "ad_x86.cpp"
  }
}

void vcmpuNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp
  {

#line 8065 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    InternalAddress flip_bit = InternalAddress(__ code()->consts()->start() + constant_offset());
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    Assembler::ComparisonPredicate cmp = booltest_pred_to_comparison_pred(opnd_array(3)->constant());
    Assembler::Width ww = widthForType(Matcher::vector_element_basic_type(this, opnd_array(1)));

    if (vlen_enc == Assembler::AVX_128bit) {
      __ vmovddup(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp */, flip_bit, vlen_enc, noreg);
    } else {
      __ vbroadcastsd(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp */, flip_bit, vlen_enc, noreg);
    }
    __ vpxor(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* dst */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, vlen_enc);
    __ vpxor(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
    __ vpcmpCCW(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* dst */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp */, cmp, ww, vlen_enc);
  
#line 40355 "ad_x86.cpp"
  }
}

void vcmpuNode::eval_constant(Compile* C) {
  {

#line 8066 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, high_bit_set(Matcher::vector_element_basic_type(this, opnd_array(1))));
#line 40364 "ad_x86.cpp"
  }
}
void vcmp64Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// ktmp
  {

#line 8090 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    Assembler::ComparisonPredicate cmp = booltest_pred_to_comparison_pred(opnd_array(3)->constant());
    bool is_unsigned = Matcher::is_unsigned_booltest_pred(opnd_array(3)->constant());
    KRegister mask = k0; // The comparison itself is not being masked.
    bool merge = false;
    BasicType src1_elem_bt = Matcher::vector_element_basic_type(this, opnd_array(1));

    switch (src1_elem_bt) {
      case T_INT: {
        __ evpcmpd(opnd_array(4)->as_KRegister(ra_,this,idx4)/* ktmp */, mask, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, cmp, !is_unsigned, vlen_enc);
        __ evmovdqul(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(4)->as_KRegister(ra_,this,idx4)/* ktmp */, ExternalAddress(vector_all_bits_set()), merge, vlen_enc, noreg);
        break;
      }
      case T_LONG: {
        __ evpcmpq(opnd_array(4)->as_KRegister(ra_,this,idx4)/* ktmp */, mask, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, cmp, !is_unsigned, vlen_enc);
        __ evmovdquq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(4)->as_KRegister(ra_,this,idx4)/* ktmp */, ExternalAddress(vector_all_bits_set()), merge, vlen_enc, noreg);
        break;
      }
      default: assert(false, "%s", type2name(src1_elem_bt));
    }
  
#line 40401 "ad_x86.cpp"
  }
}

void evcmpNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  {

#line 8123 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");
    assert(bottom_type()->isa_vectmask(), "TypeVectMask expected");

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    Assembler::ComparisonPredicate cmp = booltest_pred_to_comparison_pred(opnd_array(3)->constant());
    bool is_unsigned = Matcher::is_unsigned_booltest_pred(opnd_array(3)->constant());
    BasicType src1_elem_bt = Matcher::vector_element_basic_type(this, opnd_array(1));

    // Comparison i
    switch (src1_elem_bt) {
      case T_BYTE: {
        __ evpcmpb(opnd_array(0)->as_KRegister(ra_,this)/* dst */, k0, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, cmp, !is_unsigned, vlen_enc);
        break;
      }
      case T_SHORT: {
        __ evpcmpw(opnd_array(0)->as_KRegister(ra_,this)/* dst */, k0, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, cmp, !is_unsigned, vlen_enc);
        break;
      }
      case T_INT: {
        __ evpcmpd(opnd_array(0)->as_KRegister(ra_,this)/* dst */, k0, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, cmp, !is_unsigned, vlen_enc);
        break;
      }
      case T_LONG: {
        __ evpcmpq(opnd_array(0)->as_KRegister(ra_,this)/* dst */, k0, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, cmp, !is_unsigned, vlen_enc);
        break;
      }
      default: assert(false, "%s", type2name(src1_elem_bt));
    }
  
#line 40444 "ad_x86.cpp"
  }
}

void extractINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  {

#line 8166 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(opnd_array(2)->constant()< (int)Matcher::vector_length(this, opnd_array(1)), "out of bounds");

    BasicType elem_bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ get_elem(elem_bt, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 40462 "ad_x86.cpp"
  }
}

void extractI_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  {

#line 8166 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(opnd_array(2)->constant()< (int)Matcher::vector_length(this, opnd_array(1)), "out of bounds");

    BasicType elem_bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ get_elem(elem_bt, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 40480 "ad_x86.cpp"
  }
}

void extractI_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  {

#line 8166 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(opnd_array(2)->constant()< (int)Matcher::vector_length(this, opnd_array(1)), "out of bounds");

    BasicType elem_bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ get_elem(elem_bt, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 40498 "ad_x86.cpp"
  }
}

void vextractINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp
  {

#line 8185 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(opnd_array(2)->constant()< (int)Matcher::vector_length(this, opnd_array(1)), "out of bounds");

    BasicType elem_bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    XMMRegister lane_xmm = __ get_lane(elem_bt, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
    __ get_elem(elem_bt, opnd_array(0)->as_Register(ra_,this)/* dst */, lane_xmm, opnd_array(2)->constant());
  
#line 40518 "ad_x86.cpp"
  }
}

void vextractI_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp
  {

#line 8185 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(opnd_array(2)->constant()< (int)Matcher::vector_length(this, opnd_array(1)), "out of bounds");

    BasicType elem_bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    XMMRegister lane_xmm = __ get_lane(elem_bt, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
    __ get_elem(elem_bt, opnd_array(0)->as_Register(ra_,this)/* dst */, lane_xmm, opnd_array(2)->constant());
  
#line 40538 "ad_x86.cpp"
  }
}

void vextractI_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp
  {

#line 8185 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(opnd_array(2)->constant()< (int)Matcher::vector_length(this, opnd_array(1)), "out of bounds");

    BasicType elem_bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    XMMRegister lane_xmm = __ get_lane(elem_bt, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
    __ get_elem(elem_bt, opnd_array(0)->as_Register(ra_,this)/* dst */, lane_xmm, opnd_array(2)->constant());
  
#line 40558 "ad_x86.cpp"
  }
}

void extractLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  {

#line 8200 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE >= 4, "required");
    assert(opnd_array(2)->constant()< (int)Matcher::vector_length(this, opnd_array(1)), "out of bounds");

    __ get_elem(T_LONG, opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 40576 "ad_x86.cpp"
  }
}

void vextractLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp
  {

#line 8215 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(opnd_array(2)->constant()< (int)Matcher::vector_length(this, opnd_array(1)), "out of bounds");

    XMMRegister lane_reg = __ get_lane(T_LONG, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
    __ get_elem(T_LONG, opnd_array(0)->as_Register(ra_,this)/* dst */, lane_reg, opnd_array(2)->constant());
  
#line 40595 "ad_x86.cpp"
  }
}

void extractFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 8230 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(opnd_array(2)->constant()< (int)Matcher::vector_length(this, opnd_array(1)), "out of bounds");

    __ get_elem(T_FLOAT, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant(), opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */);
  
#line 40614 "ad_x86.cpp"
  }
}

void vextractFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp
  {

#line 8244 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(opnd_array(2)->constant()< (int)Matcher::vector_length(this, opnd_array(1)), "out of bounds");

    XMMRegister lane_reg = __ get_lane(T_FLOAT, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
    __ get_elem(T_FLOAT, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, lane_reg, opnd_array(2)->constant());
  
#line 40633 "ad_x86.cpp"
  }
}

void extractDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  {

#line 8257 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(opnd_array(2)->constant()< (int)Matcher::vector_length(this, opnd_array(1)), "out of bounds");

    __ get_elem(T_DOUBLE, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
  
#line 40650 "ad_x86.cpp"
  }
}

void vextractDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// idx
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp
  {

#line 8271 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(opnd_array(2)->constant()< (int)Matcher::vector_length(this, opnd_array(1)), "out of bounds");

    XMMRegister lane_reg = __ get_lane(T_DOUBLE, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant());
    __ get_elem(T_DOUBLE, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, lane_reg, opnd_array(2)->constant());
  
#line 40669 "ad_x86.cpp"
  }
}

void blendvpNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 8287 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE >= 4, "required");

    if (opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* mask */!= opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */) {
      __ movdqu(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* tmp */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* mask */);
    }
    __ pblendvb(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */); // uses xmm0 as mask
  
#line 40691 "ad_x86.cpp"
  }
}

void vblendvpINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 8305 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpblendvb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* mask */, vlen_enc);
  
#line 40708 "ad_x86.cpp"
  }
}

void vblendvpFDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 8319 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vblendvps(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* mask */, vlen_enc);
  
#line 40725 "ad_x86.cpp"
  }
}

void vblendvpNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp
  {

#line 8333 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpandn(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, vlen_enc);
    __ vpand (opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* dst */,  opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* mask */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
    __ vpor  (opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* dst */,  opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* dst */,  opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp */, vlen_enc);
  
#line 40746 "ad_x86.cpp"
  }
}

void evblendvp64Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// ktmp
  {

#line 8348 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

     int vlen_enc = Assembler::AVX_512bit;
     BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ evpcmp(elem_bt, opnd_array(4)->as_KRegister(ra_,this,idx4)/* ktmp */, k0, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* mask */, ExternalAddress(vector_all_bits_set()), Assembler::eq, vlen_enc, noreg);
    __ evpblend(elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(4)->as_KRegister(ra_,this,idx4)/* ktmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 40766 "ad_x86.cpp"
  }
}

void evblendvp64_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 8364 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ evpblend(elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 40784 "ad_x86.cpp"
  }
}

void vabsB_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 8377 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    uint vlen = Matcher::vector_length(this);
    if (vlen <= 16) {
      __ pabsb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    } else {
      int vlen_enc = vector_length_encoding(this);
      __ vpabsb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    }
  
#line 40804 "ad_x86.cpp"
  }
}

void vabsS_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 8392 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    uint vlen = Matcher::vector_length(this);
    if (vlen <= 8) {
      __ pabsw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    } else {
      int vlen_enc = vector_length_encoding(this);
      __ vpabsw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    }
  
#line 40824 "ad_x86.cpp"
  }
}

void vabsI_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 8407 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    uint vlen = Matcher::vector_length(this);
    if (vlen <= 4) {
      __ pabsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    } else {
      int vlen_enc = vector_length_encoding(this);
      __ vpabsd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    }
  
#line 40844 "ad_x86.cpp"
  }
}

void vabsL_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 8422 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");
    int vlen_enc = vector_length_encoding(this);
    if (!VM_Version::supports_avx512vl()) {
      vlen_enc = Assembler::AVX_512bit;
    }
    __ evpabsq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
  
#line 40863 "ad_x86.cpp"
  }
}

void vabsnegFNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 8441 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this);
    if (vlen == 2) {
      __ vabsnegf(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    } else {
      assert(vlen == 8 || vlen == 16, "required");
      int vlen_enc = vector_length_encoding(this);
      __ vabsnegf(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    }
  
#line 40885 "ad_x86.cpp"
  }
}

void vabsnegF_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 8441 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen = Matcher::vector_length(this);
    if (vlen == 2) {
      __ vabsnegf(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    } else {
      assert(vlen == 8 || vlen == 16, "required");
      int vlen_enc = vector_length_encoding(this);
      __ vabsnegf(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    }
  
#line 40907 "ad_x86.cpp"
  }
}

void vabsneg4FNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 8461 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    __ vabsnegf(opcode, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */);
  
#line 40922 "ad_x86.cpp"
  }
}

void vabsneg4F_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 8461 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    __ vabsnegf(opcode, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */);
  
#line 40937 "ad_x86.cpp"
  }
}

void vabsnegDNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 8472 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    uint vlen = Matcher::vector_length(this);
    if (vlen == 2) {
      assert(UseSSE >= 2, "required");
      __ vabsnegd(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    } else {
      int vlen_enc = vector_length_encoding(this);
      __ vabsnegd(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    }
  
#line 40959 "ad_x86.cpp"
  }
}

void vabsnegD_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 8472 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    uint vlen = Matcher::vector_length(this);
    if (vlen == 2) {
      assert(UseSSE >= 2, "required");
      __ vabsnegd(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    } else {
      int vlen_enc = vector_length_encoding(this);
      __ vabsnegd(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    }
  
#line 40981 "ad_x86.cpp"
  }
}

void vptest_lt16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp
  {

#line 8494 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    int vlen = Matcher::vector_length_in_bytes(this, opnd_array(1));
    __ vectortest(bt, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, vlen);
  
#line 40999 "ad_x86.cpp"
  }
}

void vptest_ge16Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8506 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    int vlen = Matcher::vector_length_in_bytes(this, opnd_array(1));
    __ vectortest(bt, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, xnoreg, vlen);
  
#line 41016 "ad_x86.cpp"
  }
}

void ktest_alltrue_le8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 8521 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    uint masklen = Matcher::vector_length(this, opnd_array(1));
    __ kmovwl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, opnd_array(1)->as_KRegister(ra_,this,idx1)/* src1 */);
    __ andl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, (1 << masklen) - 1);
    __ cmpl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, (1 << masklen) - 1);
  
#line 41035 "ad_x86.cpp"
  }
}

void ktest_anytrue_le8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 8537 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    uint masklen = Matcher::vector_length(this, opnd_array(1));
    __ kmovwl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, opnd_array(1)->as_KRegister(ra_,this,idx1)/* src1 */);
    __ andl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, (1 << masklen) - 1);
  
#line 41053 "ad_x86.cpp"
  }
}

void ktest_ge8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 8550 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    uint masklen = Matcher::vector_length(this, opnd_array(1));
    __ kortest(masklen, opnd_array(1)->as_KRegister(ra_,this,idx1)/* src1 */, opnd_array(1)->as_KRegister(ra_,this,idx1)/* src1 */);
  
#line 41069 "ad_x86.cpp"
  }
}

void loadMaskNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 8565 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_in_bytes = Matcher::vector_length_in_bytes(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ load_vector_mask(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_in_bytes, elem_bt, true);
  
#line 41086 "ad_x86.cpp"
  }
}

void loadMask64Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// xtmp
  {

#line 8578 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ load_vector_mask(opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* xtmp */,
                        true, Assembler::AVX_512bit);
  
#line 41102 "ad_x86.cpp"
  }
}

void loadMask_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// xtmp
  {

#line 8590 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(in(1));
    __ load_vector_mask(opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* xtmp */,
                        false, vlen_enc);
  
#line 41119 "ad_x86.cpp"
  }
}

void vstoreMask1BNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  {

#line 8604 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen = Matcher::vector_length(this);
    if (vlen <= 16 && UseAVX <= 2) {
      assert(UseSSE >= 3, "required");
      __ pabsb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    } else {
      assert(UseAVX > 0, "required");
      int src_vlen_enc = vector_length_encoding(this, opnd_array(1));
      __ vpabsb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, src_vlen_enc);
    }
  
#line 41142 "ad_x86.cpp"
  }
}

void vstoreMask2BNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp
  {

#line 8623 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = Assembler::AVX_128bit;
    int vlen = Matcher::vector_length(this);
    if (vlen <= 8) {
      assert(UseSSE >= 3, "required");
      __ pxor(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */);
      __ pabsw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
      __ packuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */);
    } else {
      assert(UseAVX > 0, "required");
      __ vextracti128(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0x1);
      __ vpacksswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
      __ vpabsb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
    }
  
#line 41171 "ad_x86.cpp"
  }
}

void vstoreMask4BNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp
  {

#line 8646 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = Assembler::AVX_128bit;
    int vlen = Matcher::vector_length(this);
    if (vlen <= 4) {
      assert(UseSSE >= 3, "required");
      __ pxor(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */);
      __ pabsd(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
      __ packusdw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */);
      __ packuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */);
    } else {
      assert(UseAVX > 0, "required");
      __ vpxor(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */, vlen_enc);
      __ vextracti128(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0x1);
      __ vpackssdw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
      __ vpacksswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */, vlen_enc);
      __ vpabsb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
    }
  
#line 41203 "ad_x86.cpp"
  }
}

void storeMask8BNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp
  {

#line 8672 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE >= 3, "required");
    __ pxor(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */);
    __ pshufd(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0x8);
    __ pabsd(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */);
    __ packusdw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */);
    __ packuswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */);
  
#line 41225 "ad_x86.cpp"
  }
}

void storeMask8B_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 8688 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = Assembler::AVX_128bit;
    __ vshufps(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0x88, Assembler::AVX_256bit);
    __ vextracti128(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, 0x1);
    __ vblendps(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, 0xC, vlen_enc);
    __ vpxor(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, vlen_enc);
    __ vpackssdw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, vlen_enc);
    __ vpacksswb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, vlen_enc);
    __ vpabsb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_enc);
  
#line 41249 "ad_x86.cpp"
  }
}

void vstoreMask4B_evex_novectmaskNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  {

#line 8705 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int src_vlen_enc = vector_length_encoding(this, opnd_array(1));
    int dst_vlen_enc = vector_length_encoding(this);
    if (!VM_Version::supports_avx512vl()) {
      src_vlen_enc = Assembler::AVX_512bit;
    }
    __ evpmovdb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, src_vlen_enc);
    __ vpabsb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, dst_vlen_enc);
  
#line 41270 "ad_x86.cpp"
  }
}

void vstoreMask8B_evex_novectmaskNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  {

#line 8721 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int src_vlen_enc = vector_length_encoding(this, opnd_array(1));
    int dst_vlen_enc = vector_length_encoding(this);
    if (!VM_Version::supports_avx512vl()) {
      src_vlen_enc = Assembler::AVX_512bit;
    }
    __ evpmovqb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, src_vlen_enc);
    __ vpabsb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, dst_vlen_enc);
  
#line 41291 "ad_x86.cpp"
  }
}

void vstoreMask_evex_vectmaskNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// mask
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {

#line 8738 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(Matcher::vector_length_in_bytes(this, opnd_array(1)) == 64, "");
    __ evmovdqul(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_KRegister(ra_,this,idx1)/* mask */, ExternalAddress(vector_int_mask_cmp_bits()),
                 false, Assembler::AVX_512bit, noreg);
    __ evpmovdb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, Assembler::AVX_512bit);
  
#line 41310 "ad_x86.cpp"
  }
}

void vstoreMask_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// mask
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {

#line 8752 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int dst_vlen_enc = vector_length_encoding(this);
    __ evpmovm2b(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_KRegister(ra_,this,idx1)/* mask */, dst_vlen_enc);
    __ vpabsb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, dst_vlen_enc);
  
#line 41328 "ad_x86.cpp"
  }
}

void vmaskcast_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 8764 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    // empty
  
#line 41342 "ad_x86.cpp"
  }
}

void vmaskcastNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 8775 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    // empty
  
#line 41356 "ad_x86.cpp"
  }
}

void vmaskcast_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 8785 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen = Matcher::vector_length(this);
    BasicType src_bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    BasicType dst_bt = Matcher::vector_element_basic_type(this);
    __ vector_mask_cast(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, dst_bt, src_bt, vlen);
  
#line 41373 "ad_x86.cpp"
  }
}

void loadIotaIndicesNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 8799 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

     int vlen_in_bytes = Matcher::vector_length_in_bytes(this);
     BasicType bt = Matcher::vector_element_basic_type(this);
     __ load_iota_indices(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, vlen_in_bytes, bt);
  
#line 41389 "ad_x86.cpp"
  }
}

void VectorPopulateIndexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 8812 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

     assert(opnd_array(2)->constant()== 1, "required");
     int vlen_in_bytes = Matcher::vector_length_in_bytes(this);
     int vlen_enc = vector_length_encoding(this);
     BasicType elem_bt = Matcher::vector_element_basic_type(this);
     __ vpbroadcast(elem_bt, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, vlen_enc);
     __ load_iota_indices(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_in_bytes, elem_bt);
     __ vpadd(elem_bt, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, vlen_enc);
  
#line 41412 "ad_x86.cpp"
  }
}

void VectorPopulateLIndexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp
  {

#line 8828 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

     assert(opnd_array(2)->constant()== 1, "required");
     int vlen_in_bytes = Matcher::vector_length_in_bytes(this);
     int vlen_enc = vector_length_encoding(this);
     BasicType elem_bt = Matcher::vector_element_basic_type(this);
     __ vpbroadcast(elem_bt, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, opnd_array(1)->as_Register(ra_,this,idx1)/* src1 */, vlen_enc);
     __ load_iota_indices(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, vlen_in_bytes, elem_bt);
     __ vpadd(elem_bt, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp */, vlen_enc);
  
#line 41435 "ad_x86.cpp"
  }
}

void loadShuffleBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  {

#line 8848 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    // empty
  
#line 41449 "ad_x86.cpp"
  }
}

void rearrangeBNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shuffle
  {

#line 8859 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE >= 4, "required");
    __ pshufb(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shuffle */);
  
#line 41465 "ad_x86.cpp"
  }
}

void rearrangeB_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shuffle
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  {

#line 8872 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");
    // Swap src into vtmp1
    __ vperm2i128(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 1);
    // Shuffle swapped src to get entries from other 128 bit lane
    __ vpshufb(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shuffle */, Assembler::AVX_256bit);
    // Shuffle original src to get entries from self 128 bit lane
    __ vpshufb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shuffle */, Assembler::AVX_256bit);
    // Create a blend mask by setting high bits for entries coming from other lane in shuffle
    __ vpaddb(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shuffle */, ExternalAddress(vector_byte_shufflemask()), Assembler::AVX_256bit, noreg);
    // Perform the blend
    __ vpblendvb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, Assembler::AVX_256bit);
  
#line 41493 "ad_x86.cpp"
  }
}

void rearrangeB_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shuffle
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// xtmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// ktmp
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// rtmp
  {

#line 8895 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ rearrange_bytes(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shuffle */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */,
                       opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp2 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* xtmp3 */,
                       opnd_array(8)->as_Register(ra_,this,idx8)/* rtmp */, opnd_array(7)->as_KRegister(ra_,this,idx7)/* ktmp */, vlen_enc);
  
#line 41517 "ad_x86.cpp"
  }
}

void rearrangeB_evex_vbmiNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shuffle
  {

#line 8909 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpermb(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shuffle */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
  
#line 41533 "ad_x86.cpp"
  }
}

void loadShuffleSNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp
  {

#line 8924 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    // Create a byte shuffle mask from short shuffle mask
    // only byte shuffle instruction available on these platforms
    int vlen_in_bytes = Matcher::vector_length_in_bytes(this);
    if (UseAVX == 0) {
      assert(vlen_in_bytes <= 16, "required");
      // Multiply each shuffle by two to get byte index
      __ pmovzxbw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
      __ psllw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, 1);

      // Duplicate to create 2 copies of byte index
      __ movdqu(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */);
      __ psllw(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, 8);
      __ por(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */);

      // Add one to get alternate byte index
      __ movdqu(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, ExternalAddress(vector_short_shufflemask()), noreg);
      __ paddb(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */);
    } else {
      assert(UseAVX > 1 || vlen_in_bytes <= 16, "required");
      int vlen_enc = vector_length_encoding(this);
      // Multiply each shuffle by two to get byte index
      __ vpmovzxbw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
      __ vpsllw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, 1, vlen_enc);

      // Duplicate to create 2 copies of byte index
      __ vpsllw(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */,  8, vlen_enc);
      __ vpor(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, vlen_enc);

      // Add one to get alternate byte index
      __ vpaddb(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, ExternalAddress(vector_short_shufflemask()), vlen_enc, noreg);
    }
  
#line 41579 "ad_x86.cpp"
  }
}

void rearrangeSNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shuffle
  {

#line 8965 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE >= 4, "required");
    __ pshufb(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shuffle */);
  
#line 41595 "ad_x86.cpp"
  }
}

void rearrangeS_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shuffle
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// vtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// vtmp2
  {

#line 8978 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");
    // Swap src into vtmp1
    __ vperm2i128(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 1);
    // Shuffle swapped src to get entries from other 128 bit lane
    __ vpshufb(opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shuffle */, Assembler::AVX_256bit);
    // Shuffle original src to get entries from self 128 bit lane
    __ vpshufb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shuffle */, Assembler::AVX_256bit);
    // Create a blend mask by setting high bits for entries coming from other lane in shuffle
    __ vpaddb(opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shuffle */, ExternalAddress(vector_byte_shufflemask()), Assembler::AVX_256bit, noreg);
    // Perform the blend
    __ vpblendvb(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* vtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* vtmp2 */, Assembler::AVX_256bit);
  
#line 41623 "ad_x86.cpp"
  }
}

void loadShuffleS_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 8999 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    if (!VM_Version::supports_avx512vl()) {
      vlen_enc = Assembler::AVX_512bit;
    }
    __ vpmovzxbw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
  
#line 41641 "ad_x86.cpp"
  }
}

void rearrangeS_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shuffle
  {

#line 9014 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    if (!VM_Version::supports_avx512vl()) {
      vlen_enc = Assembler::AVX_512bit;
    }
    __ vpermw(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shuffle */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
  
#line 41660 "ad_x86.cpp"
  }
}

void loadShuffleINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp
  {

#line 9032 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE >= 4, "required");

    // Create a byte shuffle mask from int shuffle mask
    // only byte shuffle instruction available on these platforms

    // Duplicate and multiply each shuffle by 4
    __ pmovzxbd(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */);
    __ pshuflw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, 0xA0);
    __ pshufhw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, 0xA0);
    __ psllw(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, 2);

    // Duplicate again to create 4 copies of byte index
    __ movdqu(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */);
    __ psllw(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, 8);
    __ por(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */);

    // Add 3,2,1,0 to get alternate byte index
    __ movdqu(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, ExternalAddress(vector_int_shufflemask()), noreg);
    __ paddb(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */);
  
#line 41694 "ad_x86.cpp"
  }
}

void rearrangeINode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shuffle
  {

#line 9061 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseSSE >= 4, "required");
    __ pshufb(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shuffle */);
  
#line 41710 "ad_x86.cpp"
  }
}

void loadShuffleI_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 9073 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpmovzxbd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
  
#line 41725 "ad_x86.cpp"
  }
}

void rearrangeI_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shuffle
  {

#line 9085 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vector_rearrange_int_float(bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shuffle */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
  
#line 41742 "ad_x86.cpp"
  }
}

void loadShuffleLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// vtmp
  {

#line 9101 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int vlen_enc = vector_length_encoding(this);
    // Create a double word shuffle mask from long shuffle mask
    // only double word shuffle instruction available on these platforms

    // Multiply each shuffle by two to get double word index
    __ vpmovzxbq(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    __ vpsllq(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, 1, vlen_enc);

    // Duplicate each double word shuffle
    __ vpsllq(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, 32, vlen_enc);
    __ vpor(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* vtmp */, vlen_enc);

    // Add one to get alternate double word index
    __ vpaddd(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, ExternalAddress(vector_long_shufflemask()), vlen_enc, noreg);
  
#line 41773 "ad_x86.cpp"
  }
}

void rearrangeLNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shuffle
  {

#line 9127 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX >= 2, "required");

    int vlen_enc = vector_length_encoding(this);
    __ vpermd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shuffle */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
  
#line 41791 "ad_x86.cpp"
  }
}

void loadShuffleL_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 9141 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");

    int vlen_enc = vector_length_encoding(this);
    __ vpmovzxbq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
  
#line 41808 "ad_x86.cpp"
  }
}

void rearrangeL_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shuffle
  {

#line 9155 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");

    int vlen_enc = vector_length_encoding(this);
    if (vlen_enc == Assembler::AVX_128bit) {
      vlen_enc = Assembler::AVX_256bit;
    }
    __ vpermq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shuffle */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
  
#line 41829 "ad_x86.cpp"
  }
}

void vfmaF_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// c
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// a
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// b
  {

#line 9174 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseFMA, "not enabled");
    int vlen_enc = vector_length_encoding(this);
    __ vfmaf(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* c */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* a */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* b */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* c */, vlen_enc);
  
#line 41847 "ad_x86.cpp"
  }
}

void vfmaF_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// c
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// a
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// b
  {

#line 9187 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseFMA, "not enabled");
    int vlen_enc = vector_length_encoding(this);
    __ vfmaf(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* c */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* a */, Address::make_raw(opnd_array(3)->base(ra_,this,idx3), opnd_array(3)->index(ra_,this,idx3), opnd_array(3)->scale(), opnd_array(3)->disp(ra_,this,idx3), opnd_array(3)->disp_reloc()), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* c */, vlen_enc);
  
#line 41865 "ad_x86.cpp"
  }
}

void vfmaD_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// c
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// a
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// b
  {

#line 9199 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseFMA, "not enabled");
    int vlen_enc = vector_length_encoding(this);
    __ vfmad(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* c */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* a */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* b */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* c */, vlen_enc);
  
#line 41883 "ad_x86.cpp"
  }
}

void vfmaD_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// c
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// a
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// b
  {

#line 9212 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseFMA, "not enabled");
    int vlen_enc = vector_length_encoding(this);
    __ vfmad(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* c */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* a */, Address::make_raw(opnd_array(3)->base(ra_,this,idx3), opnd_array(3)->index(ra_,this,idx3), opnd_array(3)->scale(), opnd_array(3)->disp(ra_,this,idx3), opnd_array(3)->disp_reloc()), opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* c */, vlen_enc);
  
#line 41901 "ad_x86.cpp"
  }
}

void vmuladdS2I_reg_sseNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  {

#line 9226 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ pmaddwd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src1 */);
  
#line 41916 "ad_x86.cpp"
  }
}

void vmuladdS2I_reg_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 9236 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    __ vpmaddwd(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 41932 "ad_x86.cpp"
  }
}

void vmuladdaddS2I_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  {

#line 9249 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");
    int vlen_enc = vector_length_encoding(this);
    __ evpdpwssd(opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, vlen_enc);
  
#line 41950 "ad_x86.cpp"
  }
}

void vmuladdaddS2I_reg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 9249 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseAVX > 2, "required");
    int vlen_enc = vector_length_encoding(this);
    __ evpdpwssd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* src2 */, vlen_enc);
  
#line 41968 "ad_x86.cpp"
  }
}

void vpopcount_integral_reg_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 9265 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ vector_popcount_integral_evex(bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, k0, true, vlen_enc);
  
#line 41985 "ad_x86.cpp"
  }
}

void vpopcount_integral_reg_evex_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 9265 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ vector_popcount_integral_evex(bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, k0, true, vlen_enc);
  
#line 42002 "ad_x86.cpp"
  }
}

void vpopcount_integral_reg_evex_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 9279 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ evmovdquq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    __ vector_popcount_integral_evex(bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_KRegister(ra_,this,idx2)/* mask */, true, vlen_enc);
  
#line 42020 "ad_x86.cpp"
  }
}

void vpopcount_integral_reg_evex_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 9279 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ evmovdquq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    __ vector_popcount_integral_evex(bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_KRegister(ra_,this,idx2)/* mask */, true, vlen_enc);
  
#line 42038 "ad_x86.cpp"
  }
}

void vpopcount_avx_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// rtmp
  {

#line 9294 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ vector_popcount_integral(bt, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */,
                                opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* rtmp */, vlen_enc);
  
#line 42060 "ad_x86.cpp"
  }
}

void vpopcount_avx_reg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// rtmp
  {

#line 9294 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ vector_popcount_integral(bt, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */,
                                opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* rtmp */, vlen_enc);
  
#line 42082 "ad_x86.cpp"
  }
}

void vcount_trailing_zeros_reg_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rtmp
  {

#line 9313 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ vector_count_trailing_zeros_evex(bt, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, xnoreg,
                                        xnoreg, xnoreg, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp */, k0, opnd_array(4)->as_Register(ra_,this,idx4)/* rtmp */, vlen_enc);
  
#line 42102 "ad_x86.cpp"
  }
}

void vcount_trailing_zeros_short_reg_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp3
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// rtmp
  {

#line 9330 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ vector_count_trailing_zeros_evex(bt, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */,
                                        opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, xnoreg, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp3 */, k0, opnd_array(6)->as_Register(ra_,this,idx6)/* rtmp */, vlen_enc);
  
#line 42124 "ad_x86.cpp"
  }
}

void vcount_trailing_zeros_byte_reg_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp3
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// xtmp4
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// ktmp
  unsigned idx8 = idx7 + opnd_array(7)->num_edges(); 	// rtmp
  {

#line 9345 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ vector_count_trailing_zeros_evex(bt, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */,
                                        opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp3 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* xtmp4 */,
                                        opnd_array(7)->as_KRegister(ra_,this,idx7)/* ktmp */, opnd_array(8)->as_Register(ra_,this,idx8)/* rtmp */, vlen_enc);
  
#line 42149 "ad_x86.cpp"
  }
}

void vcount_trailing_zeros_reg_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp3
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// rtmp
  {

#line 9360 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ vector_count_trailing_zeros_avx(bt, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */,
                                       opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp3 */, opnd_array(6)->as_Register(ra_,this,idx6)/* rtmp */, vlen_enc);
  
#line 42171 "ad_x86.cpp"
  }
}

void vpternlogNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// func
  {

#line 9376 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vector_len = vector_length_encoding(this);
    __ vpternlogd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(4)->constant(), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* src3 */, vector_len);
  
#line 42189 "ad_x86.cpp"
  }
}

void vpternlog_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// func
  {

#line 9388 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vector_len = vector_length_encoding(this);
    __ vpternlogd(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(4)->constant(), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, Address::make_raw(opnd_array(3)->base(ra_,this,idx3), opnd_array(3)->index(ra_,this,idx3), opnd_array(3)->scale(), opnd_array(3)->disp(ra_,this,idx3), opnd_array(3)->disp_reloc()), vector_len);
  
#line 42207 "ad_x86.cpp"
  }
}

void vprotate_immI8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 9400 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode      = this->ideal_Opcode();
    int vector_len  = vector_length_encoding(this);
    BasicType etype = this->bottom_type()->is_vect()->element_basic_type();
    __ vprotate_imm(opcode, etype, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant(), vector_len);
  
#line 42225 "ad_x86.cpp"
  }
}

void vprotate_immI8_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 9400 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode      = this->ideal_Opcode();
    int vector_len  = vector_length_encoding(this);
    BasicType etype = this->bottom_type()->is_vect()->element_basic_type();
    __ vprotate_imm(opcode, etype, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->constant(), vector_len);
  
#line 42243 "ad_x86.cpp"
  }
}

void vprorateNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 9413 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode      = this->ideal_Opcode();
    int vector_len  = vector_length_encoding(this);
    BasicType etype = this->bottom_type()->is_vect()->element_basic_type();
    __ vprotate_var(opcode, etype, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector_len);
  
#line 42261 "ad_x86.cpp"
  }
}

void vprorate_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  {

#line 9413 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode      = this->ideal_Opcode();
    int vector_len  = vector_length_encoding(this);
    BasicType etype = this->bottom_type()->is_vect()->element_basic_type();
    __ vprotate_var(opcode, etype, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* shift */, vector_len);
  
#line 42279 "ad_x86.cpp"
  }
}

void vmasked_load_avx_non_subwordNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 9427 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    BasicType elmType = this->bottom_type()->is_vect()->element_basic_type();
    int vlen_enc = vector_length_encoding(this);
    __ vmovmask(elmType, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* mask */, vlen_enc);
  
#line 42296 "ad_x86.cpp"
  }
}

void vmasked_load_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 9440 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    BasicType elmType =  this->bottom_type()->is_vect()->element_basic_type();
    int vector_len = vector_length_encoding(this);
    __ evmovdqu(elmType, opnd_array(2)->as_KRegister(ra_,this,idx2)/* mask */, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), false, vector_len);
  
#line 42313 "ad_x86.cpp"
  }
}

void vmasked_store_avx_non_subwordNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 9452 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    const MachNode* src_node = static_cast<const MachNode*>(this->in(this->operand_index(opnd_array(2))));
    int vlen_enc = vector_length_encoding(src_node);
    BasicType elmType =  src_node->bottom_type()->is_vect()->element_basic_type();
    __ vmovmask(elmType, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* mask */, vlen_enc);
  
#line 42332 "ad_x86.cpp"
  }
}

void vmasked_store_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 9465 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    const MachNode* src_node = static_cast<const MachNode*>(this->in(this->operand_index(opnd_array(2))));
    BasicType elmType =  src_node->bottom_type()->is_vect()->element_basic_type();
    int vlen_enc = vector_length_encoding(src_node);
    __ evmovdqu(elmType, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, true, vlen_enc);
  
#line 42351 "ad_x86.cpp"
  }
}

void verify_vector_alignmentNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// addr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 9479 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    Label Lskip;
    // check if masked bits of addr are zero
    __ testq(opnd_array(1)->as_Register(ra_,this,idx1)/* addr */, opnd_array(2)->constantL());
    __ jccb(Assembler::equal, Lskip);
    __ stop("verify_vector_alignment found a misaligned vector memory access");
    __ bind(Lskip);
  
#line 42371 "ad_x86.cpp"
  }
}

void vmask_cmp_nodeNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// dst
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// ktmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// ktmp2
  {

#line 9494 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(vector_length_encoding(this, opnd_array(1)) == vector_length_encoding(this, opnd_array(2)), "mismatch");
    assert(Matcher::vector_element_basic_type(this, opnd_array(1)) == Matcher::vector_element_basic_type(this, opnd_array(2)), "mismatch");

    Label DONE;
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    BasicType elem_bt = Matcher::vector_element_basic_type(this, opnd_array(1));

    __ knotql(opnd_array(6)->as_KRegister(ra_,this,idx6)/* ktmp2 */, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */);
    __ mov64(opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, -1L);
    __ evpcmp(elem_bt, opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp1 */, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, Assembler::eq, vlen_enc);
    __ kortestql(opnd_array(6)->as_KRegister(ra_,this,idx6)/* ktmp2 */, opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp1 */);
    __ jccb(Assembler::carrySet, DONE);
    __ kmovql(opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp1 */);
    __ notq(opnd_array(4)->as_Register(ra_,this,idx4)/* dst */);
    __ tzcntq(opnd_array(4)->as_Register(ra_,this,idx4)/* dst */, opnd_array(4)->as_Register(ra_,this,idx4)/* dst */);
    __ bind(DONE);
  
#line 42405 "ad_x86.cpp"
  }
}

void vmask_genNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// len
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// temp
  {

#line 9520 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ genmask(opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* len */, opnd_array(2)->as_Register(ra_,this,idx2)/* temp */);
  
#line 42420 "ad_x86.cpp"
  }
}

void vmask_gen_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// len
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// temp
  {

#line 9530 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ mov64(opnd_array(2)->as_Register(ra_,this,idx2)/* temp */, (0xFFFFFFFFFFFFFFFFUL >> (64 -opnd_array(1)->constantL())));
    __ kmovql(opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(2)->as_Register(ra_,this,idx2)/* temp */);
  
#line 42436 "ad_x86.cpp"
  }
}

void vmask_tolong_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// mask
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 9542 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    BasicType mbt = Matcher::vector_element_basic_type(this, opnd_array(1));
    int mask_len = Matcher::vector_length(this, opnd_array(1));
    int mask_size = mask_len * type2aelembytes(mbt);
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    __ vector_mask_operation(opcode, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_KRegister(ra_,this,idx1)/* mask */,
                             opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, mask_len, mask_size, vlen_enc);
  
#line 42457 "ad_x86.cpp"
  }
}

void vmask_tolong_boolNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// mask
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp
  {

#line 9559 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    BasicType mbt = Matcher::vector_element_basic_type(this, opnd_array(1));
    int mask_len = Matcher::vector_length(this, opnd_array(1));
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    __ vector_mask_operation(opcode, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* mask */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp */,
                             opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, mask_len, mbt, vlen_enc);
  
#line 42478 "ad_x86.cpp"
  }
}

void vmask_tolong_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// mask
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp
  {

#line 9575 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    BasicType mbt = Matcher::vector_element_basic_type(this, opnd_array(1));
    int mask_len = Matcher::vector_length(this, opnd_array(1));
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    __ vector_mask_operation(opcode, opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* mask */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */,
                             opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, mask_len, mbt, vlen_enc);
  
#line 42500 "ad_x86.cpp"
  }
}

void vmask_truecount_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// mask
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 9591 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    BasicType mbt = Matcher::vector_element_basic_type(this, opnd_array(1));
    int mask_len = Matcher::vector_length(this, opnd_array(1));
    int mask_size = mask_len * type2aelembytes(mbt);
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    __ vector_mask_operation(opcode, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_KRegister(ra_,this,idx1)/* mask */,
                             opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, mask_len, mask_size, vlen_enc);
  
#line 42522 "ad_x86.cpp"
  }
}

void vmask_truecount_boolNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// mask
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp
  {

#line 9608 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    BasicType mbt = Matcher::vector_element_basic_type(this, opnd_array(1));
    int mask_len = Matcher::vector_length(this, opnd_array(1));
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    __ vector_mask_operation(opcode, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* mask */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */,
                             opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, mask_len, mbt, vlen_enc);
  
#line 42544 "ad_x86.cpp"
  }
}

void vmask_truecount_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// mask
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp
  {

#line 9624 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    BasicType mbt = Matcher::vector_element_basic_type(this, opnd_array(1));
    int mask_len = Matcher::vector_length(this, opnd_array(1));
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    __ vector_mask_operation(opcode, opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* mask */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp */,
                             opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, mask_len, mbt, vlen_enc);
  
#line 42567 "ad_x86.cpp"
  }
}

void vmask_first_or_last_true_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// mask
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 9641 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    BasicType mbt = Matcher::vector_element_basic_type(this, opnd_array(1));
    int mask_len = Matcher::vector_length(this, opnd_array(1));
    int mask_size = mask_len * type2aelembytes(mbt);
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    __ vector_mask_operation(opcode, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_KRegister(ra_,this,idx1)/* mask */,
                             opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, mask_len, mask_size, vlen_enc);
  
#line 42589 "ad_x86.cpp"
  }
}

void vmask_first_or_last_true_evex_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// mask
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 9641 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    BasicType mbt = Matcher::vector_element_basic_type(this, opnd_array(1));
    int mask_len = Matcher::vector_length(this, opnd_array(1));
    int mask_size = mask_len * type2aelembytes(mbt);
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    __ vector_mask_operation(opcode, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_KRegister(ra_,this,idx1)/* mask */,
                             opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, mask_len, mask_size, vlen_enc);
  
#line 42611 "ad_x86.cpp"
  }
}

void vmask_first_or_last_true_boolNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// mask
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp
  {

#line 9659 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    BasicType mbt = Matcher::vector_element_basic_type(this, opnd_array(1));
    int mask_len = Matcher::vector_length(this, opnd_array(1));
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    __ vector_mask_operation(opcode, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* mask */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */,
                             opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, mask_len, mbt, vlen_enc);
  
#line 42633 "ad_x86.cpp"
  }
}

void vmask_first_or_last_true_bool_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// mask
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp
  {

#line 9659 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    BasicType mbt = Matcher::vector_element_basic_type(this, opnd_array(1));
    int mask_len = Matcher::vector_length(this, opnd_array(1));
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    __ vector_mask_operation(opcode, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* mask */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp */,
                             opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, mask_len, mbt, vlen_enc);
  
#line 42655 "ad_x86.cpp"
  }
}

void vmask_first_or_last_true_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// mask
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp
  {

#line 9676 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    BasicType mbt = Matcher::vector_element_basic_type(this, opnd_array(1));
    int mask_len = Matcher::vector_length(this, opnd_array(1));
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    __ vector_mask_operation(opcode, opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* mask */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp */,
                             opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, mask_len, mbt, vlen_enc);
  
#line 42678 "ad_x86.cpp"
  }
}

void vmask_first_or_last_true_avx_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// mask
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// size
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp
  {

#line 9676 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    BasicType mbt = Matcher::vector_element_basic_type(this, opnd_array(1));
    int mask_len = Matcher::vector_length(this, opnd_array(1));
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    __ vector_mask_operation(opcode, opnd_array(3)->as_Register(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* mask */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp */,
                             opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, mask_len, mbt, vlen_enc);
  
#line 42701 "ad_x86.cpp"
  }
}

void vcompress_reg_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rtmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// rscratch
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// perm
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// xtmp
  {

#line 9695 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    BasicType bt  = Matcher::vector_element_basic_type(this);
    __ vector_compress_expand_avx2(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* mask */, opnd_array(4)->as_Register(ra_,this,idx4)/* rtmp */,
                                   opnd_array(5)->as_Register(ra_,this,idx5)/* rscratch */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* perm */, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* xtmp */, bt, vlen_enc);
  
#line 42725 "ad_x86.cpp"
  }
}

void vcompress_reg_avx_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rtmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// rscratch
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// perm
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// xtmp
  {

#line 9695 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vlen_enc = vector_length_encoding(this);
    BasicType bt  = Matcher::vector_element_basic_type(this);
    __ vector_compress_expand_avx2(opcode, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* mask */, opnd_array(4)->as_Register(ra_,this,idx4)/* rtmp */,
                                   opnd_array(5)->as_Register(ra_,this,idx5)/* rscratch */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* perm */, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* xtmp */, bt, vlen_enc);
  
#line 42749 "ad_x86.cpp"
  }
}

void vcompress_expand_reg_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 9711 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vector_len = vector_length_encoding(this);
    BasicType bt  = Matcher::vector_element_basic_type(this);
    __ vector_compress_expand(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_KRegister(ra_,this,idx2)/* mask */, false, bt, vector_len);
  
#line 42767 "ad_x86.cpp"
  }
}

void vcompress_expand_reg_evex_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 9711 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int opcode = this->ideal_Opcode();
    int vector_len = vector_length_encoding(this);
    BasicType bt  = Matcher::vector_element_basic_type(this);
    __ vector_compress_expand(opcode, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(2)->as_KRegister(ra_,this,idx2)/* mask */, false, bt, vector_len);
  
#line 42785 "ad_x86.cpp"
  }
}

void vcompress_mask_reg_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// mask
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// rtmp1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rtmp2
  {

#line 9724 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(this->in(1)->bottom_type()->isa_vectmask(), "");
    int mask_len = Matcher::vector_length(this);
    __ vector_mask_compress(opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(1)->as_KRegister(ra_,this,idx1)/* mask */, opnd_array(2)->as_Register(ra_,this,idx2)/* rtmp1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* rtmp2 */, mask_len);
  
#line 42803 "ad_x86.cpp"
  }
}

void vreverse_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// rtmp
  {

#line 9741 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vec_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vector_reverse_bit(bt, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */,
                          opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* rtmp */, vec_enc);
  
#line 42824 "ad_x86.cpp"
  }
}

void vreverse_reg_gfniNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp
  {

#line 9755 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vec_enc = vector_length_encoding(this);
    BasicType bt  = Matcher::vector_element_basic_type(this);
    InternalAddress addr = InternalAddress(__ code()->consts()->start() + constant_offset());
    __ vector_reverse_bit_gfni(bt, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, addr, vec_enc,
                               opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp */);
  
#line 42844 "ad_x86.cpp"
  }
}

void vreverse_reg_gfniNode::eval_constant(Compile* C) {
  {

#line 9758 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"
    _constant = C->output()->constant_table().add(this, T_LONG, vreplicate_imm(T_LONG, 0x8040201008040201L, 1));
#line 42853 "ad_x86.cpp"
  }
}
void vreverse_byte_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 9770 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vec_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vector_reverse_byte(bt, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vec_enc);
  
#line 42869 "ad_x86.cpp"
  }
}

void vreverse_byte64_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// rtmp
  {

#line 9783 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vec_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ vector_reverse_byte64(bt, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */,
                             opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(5)->as_Register(ra_,this,idx5)/* rtmp */, vec_enc);
  
#line 42890 "ad_x86.cpp"
  }
}

void vcount_leading_zeros_IL_reg_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 9799 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

     int vlen_enc = vector_length_encoding(this, opnd_array(1));
     BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
     __ vector_count_leading_zeros_evex(bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, xnoreg,
                                        xnoreg, xnoreg, k0, noreg, true, vlen_enc);
  
#line 42907 "ad_x86.cpp"
  }
}

void vcount_leading_zeros_IL_reg_evex_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 9813 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ evmovdquq(opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, vlen_enc);
    __ vector_count_leading_zeros_evex(bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, xnoreg, xnoreg,
                                       xnoreg, opnd_array(2)->as_KRegister(ra_,this,idx2)/* mask */, noreg, true, vlen_enc);
  
#line 42926 "ad_x86.cpp"
  }
}

void vcount_leading_zeros_short_reg_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  {

#line 9830 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ vector_count_leading_zeros_evex(bt, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */,
                                       opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, xnoreg, k0, noreg, true, vlen_enc);
  
#line 42946 "ad_x86.cpp"
  }
}

void vcount_leading_zeros_byte_reg_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp3
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// ktmp
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// rtmp
  {

#line 9844 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ vector_count_leading_zeros_evex(bt, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */,
                                       opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp3 */, opnd_array(6)->as_KRegister(ra_,this,idx6)/* ktmp */,
                                       opnd_array(7)->as_Register(ra_,this,idx7)/* rtmp */, true, vlen_enc);
  
#line 42970 "ad_x86.cpp"
  }
}

void vcount_leading_zeros_int_reg_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp3
  {

#line 9860 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ vector_count_leading_zeros_avx(bt, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */,
                                      opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp3 */, noreg, vlen_enc);
  
#line 42991 "ad_x86.cpp"
  }
}

void vcount_leading_zeros_reg_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// xtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp3
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// rtmp
  {

#line 9875 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    BasicType bt = Matcher::vector_element_basic_type(this, opnd_array(1));
    __ vector_count_leading_zeros_avx(bt, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* xtmp1 */,
                                      opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp3 */, opnd_array(6)->as_Register(ra_,this,idx6)/* rtmp */, vlen_enc);
  
#line 43013 "ad_x86.cpp"
  }
}

void vadd_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 9894 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43033 "ad_x86.cpp"
  }
}

void vadd_reg_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 9894 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43053 "ad_x86.cpp"
  }
}

void vadd_reg_masked_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 9894 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43073 "ad_x86.cpp"
  }
}

void vadd_reg_masked_2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 9894 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43093 "ad_x86.cpp"
  }
}

void vadd_reg_masked_3Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 9894 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43113 "ad_x86.cpp"
  }
}

void vadd_reg_masked_4Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 9894 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43133 "ad_x86.cpp"
  }
}

void vadd_mem_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 9912 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43153 "ad_x86.cpp"
  }
}

void vadd_mem_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 9912 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43173 "ad_x86.cpp"
  }
}

void vadd_mem_masked_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 9912 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43193 "ad_x86.cpp"
  }
}

void vadd_mem_masked_2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 9912 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43213 "ad_x86.cpp"
  }
}

void vadd_mem_masked_3Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 9912 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43233 "ad_x86.cpp"
  }
}

void vadd_mem_masked_4Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 9912 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43253 "ad_x86.cpp"
  }
}

void vxor_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 9925 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43273 "ad_x86.cpp"
  }
}

void vxor_mem_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 9938 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43293 "ad_x86.cpp"
  }
}

void vor_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 9951 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43313 "ad_x86.cpp"
  }
}

void vor_mem_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 9964 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43333 "ad_x86.cpp"
  }
}

void vand_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 9977 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43353 "ad_x86.cpp"
  }
}

void vand_mem_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 9990 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43373 "ad_x86.cpp"
  }
}

void vsub_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10008 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43393 "ad_x86.cpp"
  }
}

void vsub_reg_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10008 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43413 "ad_x86.cpp"
  }
}

void vsub_reg_masked_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10008 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43433 "ad_x86.cpp"
  }
}

void vsub_reg_masked_2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10008 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43453 "ad_x86.cpp"
  }
}

void vsub_reg_masked_3Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10008 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43473 "ad_x86.cpp"
  }
}

void vsub_reg_masked_4Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10008 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43493 "ad_x86.cpp"
  }
}

void vsub_mem_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10026 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43513 "ad_x86.cpp"
  }
}

void vsub_mem_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10026 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43533 "ad_x86.cpp"
  }
}

void vsub_mem_masked_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10026 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43553 "ad_x86.cpp"
  }
}

void vsub_mem_masked_2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10026 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43573 "ad_x86.cpp"
  }
}

void vsub_mem_masked_3Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10026 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43593 "ad_x86.cpp"
  }
}

void vsub_mem_masked_4Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10026 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43613 "ad_x86.cpp"
  }
}

void vmul_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10043 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43633 "ad_x86.cpp"
  }
}

void vmul_reg_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10043 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43653 "ad_x86.cpp"
  }
}

void vmul_reg_masked_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10043 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43673 "ad_x86.cpp"
  }
}

void vmul_reg_masked_2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10043 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43693 "ad_x86.cpp"
  }
}

void vmul_reg_masked_3Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10043 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43713 "ad_x86.cpp"
  }
}

void vmul_mem_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10060 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43733 "ad_x86.cpp"
  }
}

void vmul_mem_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10060 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43753 "ad_x86.cpp"
  }
}

void vmul_mem_masked_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10060 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43773 "ad_x86.cpp"
  }
}

void vmul_mem_masked_2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10060 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43793 "ad_x86.cpp"
  }
}

void vmul_mem_masked_3Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10060 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43813 "ad_x86.cpp"
  }
}

void vsqrt_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 10074 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(2)->as_KRegister(ra_,this,idx2)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, true, vlen_enc);
  
#line 43832 "ad_x86.cpp"
  }
}

void vsqrt_reg_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 10074 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(2)->as_KRegister(ra_,this,idx2)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, true, vlen_enc);
  
#line 43851 "ad_x86.cpp"
  }
}

void vdiv_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10088 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43871 "ad_x86.cpp"
  }
}

void vdiv_reg_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10088 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43891 "ad_x86.cpp"
  }
}

void vdiv_mem_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10102 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43911 "ad_x86.cpp"
  }
}

void vdiv_mem_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10102 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 43931 "ad_x86.cpp"
  }
}

void vrol_imm_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10117 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->constant(), true, vlen_enc);
  
#line 43951 "ad_x86.cpp"
  }
}

void vrol_imm_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10117 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->constant(), true, vlen_enc);
  
#line 43971 "ad_x86.cpp"
  }
}

void vrol_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10131 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 43991 "ad_x86.cpp"
  }
}

void vrol_reg_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10131 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 44011 "ad_x86.cpp"
  }
}

void vlshift_imm_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10146 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->constant(), true, vlen_enc);
  
#line 44031 "ad_x86.cpp"
  }
}

void vlshift_imm_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10146 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->constant(), true, vlen_enc);
  
#line 44051 "ad_x86.cpp"
  }
}

void vlshift_imm_masked_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10146 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->constant(), true, vlen_enc);
  
#line 44071 "ad_x86.cpp"
  }
}

void vlshift_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10162 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc, false);
  
#line 44091 "ad_x86.cpp"
  }
}

void vlshift_reg_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10162 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc, false);
  
#line 44111 "ad_x86.cpp"
  }
}

void vlshift_reg_masked_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10162 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc, false);
  
#line 44131 "ad_x86.cpp"
  }
}

void vlshiftv_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10178 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc, true);
  
#line 44151 "ad_x86.cpp"
  }
}

void vlshiftv_reg_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10178 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc, true);
  
#line 44171 "ad_x86.cpp"
  }
}

void vlshiftv_reg_masked_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10178 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc, true);
  
#line 44191 "ad_x86.cpp"
  }
}

void vrshift_imm_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10193 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->constant(), true, vlen_enc);
  
#line 44211 "ad_x86.cpp"
  }
}

void vrshift_imm_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10193 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->constant(), true, vlen_enc);
  
#line 44231 "ad_x86.cpp"
  }
}

void vrshift_imm_masked_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10193 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->constant(), true, vlen_enc);
  
#line 44251 "ad_x86.cpp"
  }
}

void vrshift_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10209 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc, false);
  
#line 44271 "ad_x86.cpp"
  }
}

void vrshift_reg_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10209 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc, false);
  
#line 44291 "ad_x86.cpp"
  }
}

void vrshift_reg_masked_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10209 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc, false);
  
#line 44311 "ad_x86.cpp"
  }
}

void vrshiftv_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10225 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc, true);
  
#line 44331 "ad_x86.cpp"
  }
}

void vrshiftv_reg_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10225 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc, true);
  
#line 44351 "ad_x86.cpp"
  }
}

void vrshiftv_reg_masked_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10225 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc, true);
  
#line 44371 "ad_x86.cpp"
  }
}

void vurshift_imm_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10240 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->constant(), true, vlen_enc);
  
#line 44391 "ad_x86.cpp"
  }
}

void vurshift_imm_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10240 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->constant(), true, vlen_enc);
  
#line 44411 "ad_x86.cpp"
  }
}

void vurshift_imm_masked_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// shift
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10240 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->constant(), true, vlen_enc);
  
#line 44431 "ad_x86.cpp"
  }
}

void vurshift_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10256 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc, false);
  
#line 44451 "ad_x86.cpp"
  }
}

void vurshift_reg_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10256 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc, false);
  
#line 44471 "ad_x86.cpp"
  }
}

void vurshift_reg_masked_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10256 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc, false);
  
#line 44491 "ad_x86.cpp"
  }
}

void vurshiftv_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10272 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc, true);
  
#line 44511 "ad_x86.cpp"
  }
}

void vurshiftv_reg_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10272 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc, true);
  
#line 44531 "ad_x86.cpp"
  }
}

void vurshiftv_reg_masked_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10272 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc, true);
  
#line 44551 "ad_x86.cpp"
  }
}

void vmaxv_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10285 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 44571 "ad_x86.cpp"
  }
}

void vmaxv_mem_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10298 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 44591 "ad_x86.cpp"
  }
}

void vminv_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10311 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 44611 "ad_x86.cpp"
  }
}

void vminv_mem_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10324 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 44631 "ad_x86.cpp"
  }
}

void vrearrangev_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10337 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, false, vlen_enc);
  
#line 44651 "ad_x86.cpp"
  }
}

void vabs_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 10353 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(2)->as_KRegister(ra_,this,idx2)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, true, vlen_enc);
  
#line 44670 "ad_x86.cpp"
  }
}

void vabs_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 10353 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(2)->as_KRegister(ra_,this,idx2)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, true, vlen_enc);
  
#line 44689 "ad_x86.cpp"
  }
}

void vabs_masked_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 10353 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(2)->as_KRegister(ra_,this,idx2)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, true, vlen_enc);
  
#line 44708 "ad_x86.cpp"
  }
}

void vabs_masked_2Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// mask
  {

#line 10353 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(2)->as_KRegister(ra_,this,idx2)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, true, vlen_enc);
  
#line 44727 "ad_x86.cpp"
  }
}

void vfma_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// mask
  {

#line 10367 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(4)->as_KRegister(ra_,this,idx4)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* src3 */, true, vlen_enc);
  
#line 44749 "ad_x86.cpp"
  }
}

void vfma_reg_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// mask
  {

#line 10367 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(4)->as_KRegister(ra_,this,idx4)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* src3 */, true, vlen_enc);
  
#line 44771 "ad_x86.cpp"
  }
}

void vfma_mem_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// mask
  {

#line 10382 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(4)->as_KRegister(ra_,this,idx4)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, Address::make_raw(opnd_array(3)->base(ra_,this,idx3), opnd_array(3)->index(ra_,this,idx3), opnd_array(3)->scale(), opnd_array(3)->disp(ra_,this,idx3), opnd_array(3)->disp_reloc()), true, vlen_enc);
  
#line 44793 "ad_x86.cpp"
  }
}

void vfma_mem_masked_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// mask
  {

#line 10382 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(UseFMA, "Needs FMA instructions support.");
    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    int opc = this->ideal_Opcode();
    __ evmasked_op(opc, bt, opnd_array(4)->as_KRegister(ra_,this,idx4)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                   opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, Address::make_raw(opnd_array(3)->base(ra_,this,idx3), opnd_array(3)->index(ra_,this,idx3), opnd_array(3)->scale(), opnd_array(3)->disp(ra_,this,idx3), opnd_array(3)->disp_reloc()), true, vlen_enc);
  
#line 44815 "ad_x86.cpp"
  }
}

void evcmp_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// cond
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// mask
  {

#line 10396 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    assert(bottom_type()->isa_vectmask(), "TypeVectMask expected");
    int vlen_enc = vector_length_encoding(this, opnd_array(1));
    BasicType src1_elem_bt = Matcher::vector_element_basic_type(this, opnd_array(1));

    // Comparison i
    switch (src1_elem_bt) {
      case T_BYTE: {
        bool is_unsigned = Matcher::is_unsigned_booltest_pred(opnd_array(3)->constant());
        Assembler::ComparisonPredicate cmp = booltest_pred_to_comparison_pred(opnd_array(3)->constant());
        __ evpcmpb(opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(4)->as_KRegister(ra_,this,idx4)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, cmp, !is_unsigned, vlen_enc);
        break;
      }
      case T_SHORT: {
        bool is_unsigned = Matcher::is_unsigned_booltest_pred(opnd_array(3)->constant());
        Assembler::ComparisonPredicate cmp = booltest_pred_to_comparison_pred(opnd_array(3)->constant());
        __ evpcmpw(opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(4)->as_KRegister(ra_,this,idx4)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, cmp, !is_unsigned, vlen_enc);
        break;
      }
      case T_INT: {
        bool is_unsigned = Matcher::is_unsigned_booltest_pred(opnd_array(3)->constant());
        Assembler::ComparisonPredicate cmp = booltest_pred_to_comparison_pred(opnd_array(3)->constant());
        __ evpcmpd(opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(4)->as_KRegister(ra_,this,idx4)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, cmp, !is_unsigned, vlen_enc);
        break;
      }
      case T_LONG: {
        bool is_unsigned = Matcher::is_unsigned_booltest_pred(opnd_array(3)->constant());
        Assembler::ComparisonPredicate cmp = booltest_pred_to_comparison_pred(opnd_array(3)->constant());
        __ evpcmpq(opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(4)->as_KRegister(ra_,this,idx4)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, cmp, !is_unsigned, vlen_enc);
        break;
      }
      case T_FLOAT: {
        Assembler::ComparisonPredicateFP cmp = booltest_pred_to_comparison_pred_fp(opnd_array(3)->constant());
        __ evcmpps(opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(4)->as_KRegister(ra_,this,idx4)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, cmp, vlen_enc);
        break;
      }
      case T_DOUBLE: {
        Assembler::ComparisonPredicateFP cmp = booltest_pred_to_comparison_pred_fp(opnd_array(3)->constant());
        __ evcmppd(opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(4)->as_KRegister(ra_,this,idx4)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, cmp, vlen_enc);
        break;
      }
      default: assert(false, "%s", type2name(src1_elem_bt)); break;
    }
  
#line 44873 "ad_x86.cpp"
  }
}

void mask_all_evexI_LE32Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10447 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int mask_len = Matcher::vector_length(this);
    __ vector_maskall_operation(opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, mask_len);
  
#line 44888 "ad_x86.cpp"
  }
}

void mask_not_immLT8Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rtmp
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// ktmp
  {

#line 10460 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    uint masklen = Matcher::vector_length(this);
    __ knot(masklen, opnd_array(3)->as_KRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_KRegister(ra_,this,idx1)/* src */, opnd_array(5)->as_KRegister(ra_,this,idx5)/* ktmp */, opnd_array(4)->as_Register(ra_,this,idx4)/* rtmp */);
  
#line 44907 "ad_x86.cpp"
  }
}

void mask_not_immNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// cnt
  {

#line 10473 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    uint masklen = Matcher::vector_length(this);
    __ knot(masklen, opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(1)->as_KRegister(ra_,this,idx1)/* src */);
  
#line 44923 "ad_x86.cpp"
  }
}

void long_to_maskLE8_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rtmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp
  {

#line 10485 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int mask_len = Matcher::vector_length(this);
    int vec_enc  = vector_length_encoding(mask_len);
    __ vector_long_to_maskvec(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(3)->as_Register(ra_,this,idx3)/* rtmp1 */,
                              opnd_array(4)->as_Register(ra_,this,idx4)/* rtmp2 */, xnoreg, mask_len, vec_enc);
  
#line 44944 "ad_x86.cpp"
  }
}

void long_to_maskGT8_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// rtmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// rtmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp1
  {

#line 10500 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int mask_len = Matcher::vector_length(this);
    assert(mask_len <= 32, "invalid mask length");
    int vec_enc  = vector_length_encoding(mask_len);
    __ vector_long_to_maskvec(opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */, opnd_array(3)->as_Register(ra_,this,idx3)/* rtmp1 */,
                              opnd_array(4)->as_Register(ra_,this,idx4)/* rtmp2 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp1 */, mask_len, vec_enc);
  
#line 44966 "ad_x86.cpp"
  }
}

void long_to_mask_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  {

#line 10514 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ kmov(opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(1)->as_Register(ra_,this,idx1)/* src */);
  
#line 44980 "ad_x86.cpp"
  }
}

void mask_opers_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// kscratch
  {

#line 10527 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    const MachNode* mask1 = static_cast<const MachNode*>(this->in(this->operand_index(opnd_array(1))));
    const MachNode* mask2 = static_cast<const MachNode*>(this->in(this->operand_index(opnd_array(2))));
    assert(Type::equals(mask1->bottom_type(), mask2->bottom_type()), "Mask types must be equal");
    uint masklen = Matcher::vector_length(this);
    masklen = (masklen < 16 && !VM_Version::supports_avx512dq()) ? 16 : masklen;
    __ masked_op(this->ideal_Opcode(), masklen, opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(1)->as_KRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_KRegister(ra_,this,idx2)/* src2 */);
  
#line 45001 "ad_x86.cpp"
  }
}

void mask_opers_evex_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// kscratch
  {

#line 10527 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    const MachNode* mask1 = static_cast<const MachNode*>(this->in(this->operand_index(opnd_array(1))));
    const MachNode* mask2 = static_cast<const MachNode*>(this->in(this->operand_index(opnd_array(2))));
    assert(Type::equals(mask1->bottom_type(), mask2->bottom_type()), "Mask types must be equal");
    uint masklen = Matcher::vector_length(this);
    masklen = (masklen < 16 && !VM_Version::supports_avx512dq()) ? 16 : masklen;
    __ masked_op(this->ideal_Opcode(), masklen, opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(1)->as_KRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_KRegister(ra_,this,idx2)/* src2 */);
  
#line 45022 "ad_x86.cpp"
  }
}

void mask_opers_evex_1Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// kscratch
  {

#line 10527 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    const MachNode* mask1 = static_cast<const MachNode*>(this->in(this->operand_index(opnd_array(1))));
    const MachNode* mask2 = static_cast<const MachNode*>(this->in(this->operand_index(opnd_array(2))));
    assert(Type::equals(mask1->bottom_type(), mask2->bottom_type()), "Mask types must be equal");
    uint masklen = Matcher::vector_length(this);
    masklen = (masklen < 16 && !VM_Version::supports_avx512dq()) ? 16 : masklen;
    __ masked_op(this->ideal_Opcode(), masklen, opnd_array(0)->as_KRegister(ra_,this)/* dst */, opnd_array(1)->as_KRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_KRegister(ra_,this,idx2)/* src2 */);
  
#line 45043 "ad_x86.cpp"
  }
}

void vternlog_reg_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// func
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// mask
  {

#line 10541 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ evpternlog(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(4)->constant(), opnd_array(5)->as_KRegister(ra_,this,idx5)/* mask */,
                  opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* src3 */, true, bt, vlen_enc);
  
#line 45064 "ad_x86.cpp"
  }
}

void vternlogd_mem_maskedNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src3
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// func
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// mask
  {

#line 10553 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ evpternlog(opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(4)->constant(), opnd_array(5)->as_KRegister(ra_,this,idx5)/* mask */,
                  opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, Address::make_raw(opnd_array(3)->base(ra_,this,idx3), opnd_array(3)->index(ra_,this,idx3), opnd_array(3)->scale(), opnd_array(3)->disp(ra_,this,idx3), opnd_array(3)->disp_reloc()), true, bt, vlen_enc);
  
#line 45085 "ad_x86.cpp"
  }
}

void castMMNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castMMNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castVVNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castVVNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void castVVLegNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  // User did not define which encode class to use.
}

uint castVVLegNode::size(PhaseRegAlloc *ra_) const {
  assert(VerifyOops || MachNode::size(ra_) <= 0, "bad fixed size");
  return (VerifyOops ? MachNode::size(ra_) : 0);
}

void FloatClassCheck_reg_reg_vfpclassNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ktmp
  {

#line 10600 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vfpclassss(opnd_array(2)->as_KRegister(ra_,this,idx2)/* ktmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0x18);
    __ kmovbl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_KRegister(ra_,this,idx2)/* ktmp */);
  
#line 45137 "ad_x86.cpp"
  }
}

void DoubleClassCheck_reg_reg_vfpclassNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// ktmp
  {

#line 10612 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    __ vfpclasssd(opnd_array(2)->as_KRegister(ra_,this,idx2)/* ktmp */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src */, 0x18);
    __ kmovbl(opnd_array(0)->as_Register(ra_,this)/* dst */, opnd_array(2)->as_KRegister(ra_,this,idx2)/* ktmp */);
  
#line 45153 "ad_x86.cpp"
  }
}

void vector_addsub_saturating_subword_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 10626 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ vector_saturating_op(this->ideal_Opcode(), elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */,
                            opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, false, vlen_enc);
  
#line 45171 "ad_x86.cpp"
  }
}

void vector_addsub_saturating_subword_reg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 10626 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ vector_saturating_op(this->ideal_Opcode(), elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */,
                            opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, false, vlen_enc);
  
#line 45189 "ad_x86.cpp"
  }
}

void vector_addsub_saturating_unsigned_subword_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 10642 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ vector_saturating_op(this->ideal_Opcode(), elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */,
                            opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 45207 "ad_x86.cpp"
  }
}

void vector_addsub_saturating_unsigned_subword_reg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 10642 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ vector_saturating_op(this->ideal_Opcode(), elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */,
                            opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, true, vlen_enc);
  
#line 45225 "ad_x86.cpp"
  }
}

void vector_addsub_saturating_reg_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// ktmp1
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// ktmp2
  {

#line 10660 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ vector_addsub_dq_saturating_evex(this->ideal_Opcode(), elem_bt, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */,
                                        opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */,
                                        opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp2 */,
                                        opnd_array(6)->as_KRegister(ra_,this,idx6)/* ktmp1 */, opnd_array(7)->as_KRegister(ra_,this,idx7)/* ktmp2 */, vlen_enc);
  
#line 45250 "ad_x86.cpp"
  }
}

void vector_addsub_saturating_reg_evex_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// ktmp1
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// ktmp2
  {

#line 10660 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ vector_addsub_dq_saturating_evex(this->ideal_Opcode(), elem_bt, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */,
                                        opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */,
                                        opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp2 */,
                                        opnd_array(6)->as_KRegister(ra_,this,idx6)/* ktmp1 */, opnd_array(7)->as_KRegister(ra_,this,idx7)/* ktmp2 */, vlen_enc);
  
#line 45275 "ad_x86.cpp"
  }
}

void vector_addsub_saturating_reg_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// xtmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// xtmp4
  {

#line 10680 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ vector_addsub_dq_saturating_avx(this->ideal_Opcode(), elem_bt, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */,
                                       opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp2 */,
                                       opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* xtmp3 */, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* xtmp4 */, vlen_enc);
  
#line 45299 "ad_x86.cpp"
  }
}

void vector_addsub_saturating_reg_avx_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// xtmp3
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// xtmp4
  {

#line 10680 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ vector_addsub_dq_saturating_avx(this->ideal_Opcode(), elem_bt, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */,
                                       opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp2 */,
                                       opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* xtmp3 */, opnd_array(7)->as_XMMRegister(ra_,this,idx7)/* xtmp4 */, vlen_enc);
  
#line 45323 "ad_x86.cpp"
  }
}

void vector_add_saturating_unsigned_reg_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// ktmp
  {

#line 10698 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ vector_add_dq_saturating_unsigned_evex(elem_bt, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */,
                                              opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp2 */, opnd_array(6)->as_KRegister(ra_,this,idx6)/* ktmp */, vlen_enc);
  
#line 45345 "ad_x86.cpp"
  }
}

void vector_add_saturating_unsigned_reg_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// xtmp3
  {

#line 10715 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ vector_add_dq_saturating_unsigned_avx(elem_bt, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */,
                                             opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp2 */, opnd_array(6)->as_XMMRegister(ra_,this,idx6)/* xtmp3 */, vlen_enc);
  
#line 45367 "ad_x86.cpp"
  }
}

void vector_sub_saturating_unsigned_reg_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// ktmp
  {

#line 10732 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ vector_sub_dq_saturating_unsigned_evex(elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */,
                                              opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */, opnd_array(3)->as_KRegister(ra_,this,idx3)/* ktmp */, vlen_enc);
  
#line 45386 "ad_x86.cpp"
  }
}

void vector_sub_saturating_unsigned_reg_avxNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// dst
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// xtmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// xtmp2
  {

#line 10749 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ vector_sub_dq_saturating_unsigned_avx(elem_bt, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* dst */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src2 */,
                                             opnd_array(4)->as_XMMRegister(ra_,this,idx4)/* xtmp1 */, opnd_array(5)->as_XMMRegister(ra_,this,idx5)/* xtmp2 */, vlen_enc);
  
#line 45407 "ad_x86.cpp"
  }
}

void vector_addsub_saturating_subword_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 10765 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ vector_saturating_op(this->ideal_Opcode(), elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */,
                            opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), false, vlen_enc);
  
#line 45425 "ad_x86.cpp"
  }
}

void vector_addsub_saturating_subword_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 10765 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ vector_saturating_op(this->ideal_Opcode(), elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */,
                            opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), false, vlen_enc);
  
#line 45443 "ad_x86.cpp"
  }
}

void vector_addsub_saturating_unsigned_subword_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 10781 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ vector_saturating_op(this->ideal_Opcode(), elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */,
                            opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 45461 "ad_x86.cpp"
  }
}

void vector_addsub_saturating_unsigned_subword_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// src1
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src2
  {

#line 10781 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ vector_saturating_op(this->ideal_Opcode(), elem_bt, opnd_array(0)->as_XMMRegister(ra_,this)/* dst */,
                            opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* src1 */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, vlen_enc);
  
#line 45479 "ad_x86.cpp"
  }
}

void vector_addsub_saturating_subword_masked_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10796 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ evmasked_saturating_op(this->ideal_Opcode(), elem_bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                              opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, false, true, vlen_enc);
  
#line 45498 "ad_x86.cpp"
  }
}

void vector_addsub_saturating_subword_masked_reg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10796 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ evmasked_saturating_op(this->ideal_Opcode(), elem_bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                              opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, false, true, vlen_enc);
  
#line 45517 "ad_x86.cpp"
  }
}

void vector_addsub_saturating_unsigned_subword_masked_regNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10811 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ evmasked_saturating_op(this->ideal_Opcode(), elem_bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                              opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, true, true, vlen_enc);
  
#line 45536 "ad_x86.cpp"
  }
}

void vector_addsub_saturating_unsigned_subword_masked_reg_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10811 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ evmasked_saturating_op(this->ideal_Opcode(), elem_bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                              opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src */, true, true, vlen_enc);
  
#line 45555 "ad_x86.cpp"
  }
}

void vector_addsub_saturating_subword_masked_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10826 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ evmasked_saturating_op(this->ideal_Opcode(), elem_bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                              opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), false, true, vlen_enc);
  
#line 45574 "ad_x86.cpp"
  }
}

void vector_addsub_saturating_subword_masked_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10826 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ evmasked_saturating_op(this->ideal_Opcode(), elem_bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                              opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), false, true, vlen_enc);
  
#line 45593 "ad_x86.cpp"
  }
}

void vector_addsub_saturating_unsigned_subword_masked_memNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10841 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ evmasked_saturating_op(this->ideal_Opcode(), elem_bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                              opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, true, vlen_enc);
  
#line 45612 "ad_x86.cpp"
  }
}

void vector_addsub_saturating_unsigned_subword_masked_mem_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// dst
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// mask
  {

#line 10841 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType elem_bt = Matcher::vector_element_basic_type(this);
    __ evmasked_saturating_op(this->ideal_Opcode(), elem_bt, opnd_array(3)->as_KRegister(ra_,this,idx3)/* mask */, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */,
                              opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* dst */, Address::make_raw(opnd_array(2)->base(ra_,this,idx2), opnd_array(2)->index(ra_,this,idx2), opnd_array(2)->scale(), opnd_array(2)->disp(ra_,this,idx2), opnd_array(2)->disp_reloc()), true, true, vlen_enc);
  
#line 45631 "ad_x86.cpp"
  }
}

void vector_selectfrom_twovectors_reg_evexNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 1;
  unsigned idx1 = 1; 	// index
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src1
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// src2
  {

#line 10854 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86.ad"

    int vlen_enc = vector_length_encoding(this);
    BasicType bt = Matcher::vector_element_basic_type(this);
    __ select_from_two_vectors_evex(bt, opnd_array(1)->as_XMMRegister(ra_,this,idx1)/* index */, opnd_array(2)->as_XMMRegister(ra_,this,idx2)/* src1 */, opnd_array(3)->as_XMMRegister(ra_,this,idx3)/* src2 */, vlen_enc);
  
#line 45649 "ad_x86.cpp"
  }
}

void compareAndSwapP_shenandoahNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {

#line 42 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/shenandoah/shenandoah_x86_64.ad"

    ShenandoahBarrierSet::assembler()->cmpxchg_oop(masm,
                                                   opnd_array(0)->as_Register(ra_,this)/* res */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   false, // swap
                                                   opnd_array(4)->as_Register(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp2 */);
  
#line 45670 "ad_x86.cpp"
  }
}

void compareAndSwapP_shenandoah_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {

#line 42 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/shenandoah/shenandoah_x86_64.ad"

    ShenandoahBarrierSet::assembler()->cmpxchg_oop(masm,
                                                   opnd_array(0)->as_Register(ra_,this)/* res */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   false, // swap
                                                   opnd_array(4)->as_Register(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp2 */);
  
#line 45691 "ad_x86.cpp"
  }
}

void compareAndSwapN_shenandoahNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {

#line 63 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/shenandoah/shenandoah_x86_64.ad"

    ShenandoahBarrierSet::assembler()->cmpxchg_oop(masm,
                                                   opnd_array(0)->as_Register(ra_,this)/* res */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   false, // swap
                                                   opnd_array(4)->as_Register(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp2 */);
  
#line 45712 "ad_x86.cpp"
  }
}

void compareAndSwapN_shenandoah_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {

#line 63 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/shenandoah/shenandoah_x86_64.ad"

    ShenandoahBarrierSet::assembler()->cmpxchg_oop(masm,
                                                   opnd_array(0)->as_Register(ra_,this)/* res */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   false, // swap
                                                   opnd_array(4)->as_Register(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp2 */);
  
#line 45733 "ad_x86.cpp"
  }
}

void compareAndExchangeN_shenandoahNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {

#line 82 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/shenandoah/shenandoah_x86_64.ad"

    ShenandoahBarrierSet::assembler()->cmpxchg_oop(masm,
                                                   noreg, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   true, // exchange
                                                   opnd_array(4)->as_Register(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp2 */);
  
#line 45754 "ad_x86.cpp"
  }
}

void compareAndExchangeP_shenandoahNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem_ptr
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  {

#line 103 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/shenandoah/shenandoah_x86_64.ad"

    ShenandoahBarrierSet::assembler()->cmpxchg_oop(masm,
                                                   noreg, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */,
                                                   true,  // exchange
                                                   opnd_array(4)->as_Register(ra_,this,idx4)/* tmp1 */, opnd_array(5)->as_Register(ra_,this,idx5)/* tmp2 */);
  
#line 45775 "ad_x86.cpp"
  }
}

void zLoadPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  {

#line 126 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/z/z_x86_64.ad"

    __ movptr(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    z_load_barrier(masm, this, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* dst */);
  
#line 45791 "ad_x86.cpp"
  }
}

void zLoadPNullCheckNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// op
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  {

#line 142 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/z/z_x86_64.ad"

    // A null pointer will have all address bits 0. This mask sign extends
    // all address bits, so we can test if the address is 0.
    __ testq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), ZBarrierSetAssembler::ZPointerAddressMask);
  
#line 45808 "ad_x86.cpp"
  }
}

void zStorePNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 159 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/z/z_x86_64.ad"

    z_store_barrier(masm, this, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(2)->as_Register(ra_,this,idx2)/* src */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, false /* is_atomic */);
    __ movq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */);
  
#line 45825 "ad_x86.cpp"
  }
}

void zStorePNullNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// zero
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 175 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/z/z_x86_64.ad"

    z_store_barrier(masm, this, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), noreg, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, false /* is_atomic */);
    // Store a colored null - barrier code above does not need to color
    __ movq(Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()), barrier_Relocation::unpatched);
    // The relocation cant be fully after the mov, as that is the beginning of a random subsequent
    // instruction, which violates assumptions made by unrelated code. Hence the end() - 1
    __ code_section()->relocate(__ code_section()->end() - 1, barrier_Relocation::spec(), ZBarrierRelocationFormatStoreGoodAfterMov);
  
#line 45846 "ad_x86.cpp"
  }
}

void zCompareAndExchangePNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 194 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/z/z_x86_64.ad"

    assert_different_registers(opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    assert_different_registers(opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */);
    const Address mem_addr = Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, 0);
    z_store_barrier(masm, this, mem_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, true /* is_atomic */);
    z_color(masm, this, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    __ lock();
    __ cmpxchgptr(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, mem_addr);
    z_uncolor(masm, this, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
  
#line 45870 "ad_x86.cpp"
  }
}

void zCompareAndSwapPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 218 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/z/z_x86_64.ad"

    assert_different_registers(opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    const Address mem_addr = Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, 0);
    z_store_barrier(masm, this, mem_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, true /* is_atomic */);
    z_color(masm, this, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    __ lock();
    __ cmpxchgptr(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, mem_addr);
    __ setcc(Assembler::equal, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 45893 "ad_x86.cpp"
  }
}

void zCompareAndSwapP_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp
  {

#line 218 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/z/z_x86_64.ad"

    assert_different_registers(opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    const Address mem_addr = Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, 0);
    z_store_barrier(masm, this, mem_addr, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, true /* is_atomic */);
    z_color(masm, this, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */);
    __ lock();
    __ cmpxchgptr(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp */, mem_addr);
    __ setcc(Assembler::equal, opnd_array(0)->as_Register(ra_,this)/* res */);
  
#line 45916 "ad_x86.cpp"
  }
}

void zXChgPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 238 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/z/z_x86_64.ad"

    assert_different_registers(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* newval */);
    const Address mem_addr = Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, 0);
    z_store_barrier(masm, this, mem_addr, opnd_array(2)->as_Register(ra_,this,idx2)/* newval */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */, true /* is_atomic */);
    __ movptr(opnd_array(2)->as_Register(ra_,this,idx2)/* newval */, opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */);
    __ xchgptr(opnd_array(2)->as_Register(ra_,this,idx2)/* newval */, mem_addr);
    z_uncolor(masm, this, opnd_array(2)->as_Register(ra_,this,idx2)/* newval */);
  
#line 45937 "ad_x86.cpp"
  }
}

void g1StorePNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  {

#line 82 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/g1/g1_x86_64.ad"

    // Materialize the store address internally (as opposed to defining 'mem' as
    // an indirect memory operand) to reduce the overhead of LCM when processing
    // large basic blocks with many stores. Such basic blocks arise, for
    // instance, from static initializations of large String arrays.
    // The same holds for g1StoreN and g1EncodePAndStoreN.
    __ lea(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    write_barrier_pre(masm, this,
                      opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */,
                      opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp3 */,
                      RegSet::of(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */) /* preserve */);
    __ movq(Address(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, 0), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
    write_barrier_post(masm, this,
                       opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */,
                       opnd_array(2)->as_Register(ra_,this,idx2)/* src */,
                       opnd_array(5)->as_Register(ra_,this,idx5)/* tmp3 */,
                       opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);
  
#line 45971 "ad_x86.cpp"
  }
}

void g1StoreNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  {

#line 111 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/g1/g1_x86_64.ad"

    __ lea(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    write_barrier_pre(masm, this,
                      opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */,
                      opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp3 */,
                      RegSet::of(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */) /* preserve */);
    __ movl(Address(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, 0), opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
    if ((barrier_data() & G1C2BarrierPost) != 0) {
      __ movl(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
      if ((barrier_data() & G1C2BarrierPostNotNull) == 0) {
        __ decode_heap_oop(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);
      } else {
        __ decode_heap_oop_not_null(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);
      }
    }
    write_barrier_post(masm, this,
                       opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */,
                       opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */,
                       opnd_array(5)->as_Register(ra_,this,idx5)/* tmp3 */,
                       opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);
  
#line 46008 "ad_x86.cpp"
  }
}

void g1EncodePAndStoreNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// src
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  {

#line 144 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/g1/g1_x86_64.ad"

    __ lea(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    write_barrier_pre(masm, this,
                      opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */,
                      opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp3 */,
                      RegSet::of(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */) /* preserve */);
    __ movq(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */, opnd_array(2)->as_Register(ra_,this,idx2)/* src */);
    if ((barrier_data() & G1C2BarrierPostNotNull) == 0) {
      __ encode_heap_oop(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);
    } else {
      __ encode_heap_oop_not_null(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);
    }
    __ movl(Address(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, 0), opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);
    write_barrier_post(masm, this,
                       opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */,
                       opnd_array(2)->as_Register(ra_,this,idx2)/* src */,
                       opnd_array(5)->as_Register(ra_,this,idx5)/* tmp3 */,
                       opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);
  
#line 46043 "ad_x86.cpp"
  }
}

void g1CompareAndExchangePNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  {

#line 174 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/g1/g1_x86_64.ad"

    assert_different_registers(opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    // Pass $oldval to the pre-barrier (instead of loading from $mem), because
    // $oldval is the only value that can be overwritten.
    // The same holds for g1CompareAndSwapP.
    write_barrier_pre(masm, this,
                      noreg /* obj */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */,
                      opnd_array(6)->as_Register(ra_,this,idx6)/* tmp3 */,
                      RegSet::of(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */) /* preserve */);
    __ movq(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */);
    __ lock();
    __ cmpxchgq(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp1 */, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, 0));
    write_barrier_post(masm, this,
                       opnd_array(1)->as_Register(ra_,this,idx1)/* mem */,
                       opnd_array(4)->as_Register(ra_,this,idx4)/* tmp1 */,
                       opnd_array(5)->as_Register(ra_,this,idx5)/* tmp2 */,
                       opnd_array(6)->as_Register(ra_,this,idx6)/* tmp3 */);
  
#line 46078 "ad_x86.cpp"
  }
}

void g1CompareAndExchangeNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp1
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp2
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp3
  {

#line 203 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/g1/g1_x86_64.ad"

    assert_different_registers(opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    write_barrier_pre(masm, this,
                      opnd_array(1)->as_Register(ra_,this,idx1)/* mem */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp2 */,
                      opnd_array(6)->as_Register(ra_,this,idx6)/* tmp3 */,
                      RegSet::of(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */) /* preserve */);
    __ movl(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */);
    __ lock();
    __ cmpxchgl(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp1 */, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, 0));
    __ decode_heap_oop(opnd_array(4)->as_Register(ra_,this,idx4)/* tmp1 */);
    write_barrier_post(masm, this,
                       opnd_array(1)->as_Register(ra_,this,idx1)/* mem */,
                       opnd_array(4)->as_Register(ra_,this,idx4)/* tmp1 */,
                       opnd_array(5)->as_Register(ra_,this,idx5)/* tmp2 */,
                       opnd_array(6)->as_Register(ra_,this,idx6)/* tmp3 */);
  
#line 46111 "ad_x86.cpp"
  }
}

void g1CompareAndSwapPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {

#line 233 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/g1/g1_x86_64.ad"

    assert_different_registers(opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    write_barrier_pre(masm, this,
                      noreg /* obj */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */,
                      RegSet::of(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */) /* preserve */,
                      RegSet::of(opnd_array(4)->as_Register(ra_,this,idx4)/* res */) /* no_preserve */);
    __ movq(opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */);
    __ lock();
    __ cmpxchgq(opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, 0));
    __ setb(Assembler::equal, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    __ movzbl(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    write_barrier_post(masm, this,
                       opnd_array(1)->as_Register(ra_,this,idx1)/* mem */,
                       opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */,
                       opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                       opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */);
  
#line 46147 "ad_x86.cpp"
  }
}

void g1CompareAndSwapP_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {

#line 233 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/g1/g1_x86_64.ad"

    assert_different_registers(opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    write_barrier_pre(masm, this,
                      noreg /* obj */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */,
                      RegSet::of(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */) /* preserve */,
                      RegSet::of(opnd_array(4)->as_Register(ra_,this,idx4)/* res */) /* no_preserve */);
    __ movq(opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */);
    __ lock();
    __ cmpxchgq(opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, 0));
    __ setb(Assembler::equal, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    __ movzbl(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    write_barrier_post(masm, this,
                       opnd_array(1)->as_Register(ra_,this,idx1)/* mem */,
                       opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */,
                       opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                       opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */);
  
#line 46183 "ad_x86.cpp"
  }
}

void g1CompareAndSwapNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {

#line 265 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/g1/g1_x86_64.ad"

    assert_different_registers(opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    write_barrier_pre(masm, this,
                      opnd_array(1)->as_Register(ra_,this,idx1)/* mem */,
                      opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */,
                      RegSet::of(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */) /* preserve */,
                      RegSet::of(opnd_array(4)->as_Register(ra_,this,idx4)/* res */) /* no_preserve */);
    __ movl(opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */);
    __ lock();
    __ cmpxchgl(opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, 0));
    __ setb(Assembler::equal, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    __ movzbl(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    __ decode_heap_oop(opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */);
    write_barrier_post(masm, this,
                       opnd_array(1)->as_Register(ra_,this,idx1)/* mem */,
                       opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */,
                       opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                       opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */);
  
#line 46220 "ad_x86.cpp"
  }
}

void g1CompareAndSwapN_0Node::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// oldval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// newval
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// res
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp1
  unsigned idx6 = idx5 + opnd_array(5)->num_edges(); 	// tmp2
  unsigned idx7 = idx6 + opnd_array(6)->num_edges(); 	// tmp3
  {

#line 265 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/g1/g1_x86_64.ad"

    assert_different_registers(opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */, opnd_array(1)->as_Register(ra_,this,idx1)/* mem */);
    write_barrier_pre(masm, this,
                      opnd_array(1)->as_Register(ra_,this,idx1)/* mem */,
                      opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                      opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */,
                      RegSet::of(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */, opnd_array(2)->as_Register(ra_,this,idx2)/* oldval */) /* preserve */,
                      RegSet::of(opnd_array(4)->as_Register(ra_,this,idx4)/* res */) /* no_preserve */);
    __ movl(opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, opnd_array(3)->as_Register(ra_,this,idx3)/* newval */);
    __ lock();
    __ cmpxchgl(opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, 0));
    __ setb(Assembler::equal, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    __ movzbl(opnd_array(4)->as_Register(ra_,this,idx4)/* res */, opnd_array(4)->as_Register(ra_,this,idx4)/* res */);
    __ decode_heap_oop(opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */);
    write_barrier_post(masm, this,
                       opnd_array(1)->as_Register(ra_,this,idx1)/* mem */,
                       opnd_array(5)->as_Register(ra_,this,idx5)/* tmp1 */,
                       opnd_array(6)->as_Register(ra_,this,idx6)/* tmp2 */,
                       opnd_array(7)->as_Register(ra_,this,idx7)/* tmp3 */);
  
#line 46257 "ad_x86.cpp"
  }
}

void g1GetAndSetPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  {

#line 294 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/g1/g1_x86_64.ad"

    assert_different_registers(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* newval */);
    write_barrier_pre(masm, this,
                      opnd_array(1)->as_Register(ra_,this,idx1)/* mem */,
                      opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp3 */,
                      RegSet::of(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* newval */) /* preserve */);
    __ movq(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* newval */);
    __ xchgq(opnd_array(2)->as_Register(ra_,this,idx2)/* newval */, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, 0));
    write_barrier_post(masm, this,
                       opnd_array(1)->as_Register(ra_,this,idx1)/* mem */,
                       opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */,
                       opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */,
                       opnd_array(5)->as_Register(ra_,this,idx5)/* tmp3 */);
  
#line 46287 "ad_x86.cpp"
  }
}

void g1GetAndSetNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// newval
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  unsigned idx5 = idx4 + opnd_array(4)->num_edges(); 	// tmp3
  {

#line 318 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/g1/g1_x86_64.ad"

    assert_different_registers(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* newval */);
    write_barrier_pre(masm, this,
                      opnd_array(1)->as_Register(ra_,this,idx1)/* mem */,
                      opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */,
                      opnd_array(5)->as_Register(ra_,this,idx5)/* tmp3 */,
                      RegSet::of(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, opnd_array(2)->as_Register(ra_,this,idx2)/* newval */) /* preserve */);
    __ movl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* newval */);
    __ decode_heap_oop(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */);
    __ xchgl(opnd_array(2)->as_Register(ra_,this,idx2)/* newval */, Address(opnd_array(1)->as_Register(ra_,this,idx1)/* mem */, 0));
    write_barrier_post(masm, this,
                       opnd_array(1)->as_Register(ra_,this,idx1)/* mem */,
                       opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */,
                       opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */,
                       opnd_array(5)->as_Register(ra_,this,idx5)/* tmp3 */);
  
#line 46318 "ad_x86.cpp"
  }
}

void g1LoadPNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp
  {

#line 344 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/g1/g1_x86_64.ad"

    __ movq(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    write_barrier_pre(masm, this,
                      noreg /* obj */,
                      opnd_array(2)->as_Register(ra_,this,idx2)/* dst */,
                      opnd_array(3)->as_Register(ra_,this,idx3)/* tmp */);
  
#line 46338 "ad_x86.cpp"
  }
}

void g1LoadNNode::emit(C2_MacroAssembler* masm, PhaseRegAlloc* ra_) const {
  // Start at oper_input_base() and count operands
  unsigned idx0 = 2;
  unsigned idx1 = 2; 	// mem
  unsigned idx2 = idx1 + opnd_array(1)->num_edges(); 	// dst
  unsigned idx3 = idx2 + opnd_array(2)->num_edges(); 	// tmp1
  unsigned idx4 = idx3 + opnd_array(3)->num_edges(); 	// tmp2
  {

#line 361 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/gc/g1/g1_x86_64.ad"

    __ movl(opnd_array(2)->as_Register(ra_,this,idx2)/* dst */, Address::make_raw(opnd_array(1)->base(ra_,this,idx1), opnd_array(1)->index(ra_,this,idx1), opnd_array(1)->scale(), opnd_array(1)->disp(ra_,this,idx1), opnd_array(1)->disp_reloc()));
    __ movl(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */, opnd_array(2)->as_Register(ra_,this,idx2)/* dst */);
    __ decode_heap_oop(opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */);
    write_barrier_pre(masm, this,
                      noreg /* obj */,
                      opnd_array(3)->as_Register(ra_,this,idx3)/* tmp1 */,
                      opnd_array(4)->as_Register(ra_,this,idx4)/* tmp2 */);
  
#line 46361 "ad_x86.cpp"
  }
}

const MachOper* loadBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadB2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUB2L_immINode::memory_operand() const { return _opnds[1]; }
const MachOper* loadSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS2BNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadS2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUSNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2BNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2L_immI_255Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadUS2L_immINode::memory_operand() const { return _opnds[1]; }
const MachOper* loadINode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2BNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2UBNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2SNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2USNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2L_immI_255Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2L_immI_65535Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadI2L_immU31Node::memory_operand() const { return _opnds[1]; }
const MachOper* loadUI2LNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadLNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadRangeNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadNKlassCompactHeadersNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadFNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadD_partialNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadDNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchAllocNode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchAllocNTANode::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchAllocT0Node::memory_operand() const { return _opnds[1]; }
const MachOper* prefetchAllocT2Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeBNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeCNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeINode::memory_operand() const { return _opnds[1]; }
const MachOper* storeLNode::memory_operand() const { return _opnds[1]; }
const MachOper* storePNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmP0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmPNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeNNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmN0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmNNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmNKlassNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmI0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmINode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmL0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmLNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmC0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmI16Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmB0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeImmBNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeFNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeF0Node::memory_operand() const { return _opnds[1]; }
const MachOper* storeF_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeDNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeD0_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeD0Node::memory_operand() const { return _opnds[1]; }
const MachOper* cacheWBNode::memory_operand() const { return _opnds[1]; }
const MachOper* countLeadingZerosI_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* countLeadingZerosL_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* countTrailingZerosI_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* countTrailingZerosL_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* popCountI_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* popCountL_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* cmovI_memNode::memory_operand() const { return _opnds[4]; }
const MachOper* cmovI_memUNode::memory_operand() const { return _opnds[4]; }
const MachOper* cmovI_memUCFNode::memory_operand() const { return _opnds[4]; }
const MachOper* cmovL_memNode::memory_operand() const { return _opnds[4]; }
const MachOper* cmovL_memUNode::memory_operand() const { return _opnds[4]; }
const MachOper* cmovL_memUCFNode::memory_operand() const { return _opnds[4]; }
const MachOper* addI_rReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addI_rReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addI_mem_rRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* addI_mem_rReg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* incI_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* decI_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* addL_rReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addL_rReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addL_mem_rRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* addL_mem_rReg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addL_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* incL_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* decL_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapPNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapP_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapLNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapL_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapINode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapI_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapBNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapB_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapSNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapS_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapNNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapN_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeBNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeSNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeINode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeLNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeNNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangePNode::memory_operand() const { return _opnds[1]; }
const MachOper* xaddB_reg_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* xaddB_imm_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* xaddBNode::memory_operand() const { return _opnds[1]; }
const MachOper* xaddS_reg_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* xaddS_imm_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* xaddSNode::memory_operand() const { return _opnds[1]; }
const MachOper* xaddI_reg_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* xaddI_imm_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* xaddINode::memory_operand() const { return _opnds[1]; }
const MachOper* xaddL_reg_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* xaddL_imm_no_resNode::memory_operand() const { return _opnds[1]; }
const MachOper* xaddLNode::memory_operand() const { return _opnds[1]; }
const MachOper* xchgBNode::memory_operand() const { return _opnds[1]; }
const MachOper* xchgSNode::memory_operand() const { return _opnds[1]; }
const MachOper* xchgINode::memory_operand() const { return _opnds[1]; }
const MachOper* xchgLNode::memory_operand() const { return _opnds[1]; }
const MachOper* xchgPNode::memory_operand() const { return _opnds[1]; }
const MachOper* xchgNNode::memory_operand() const { return _opnds[1]; }
const MachOper* subI_rReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* subI_mem_rRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* subL_rReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* subL_mem_rRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* negI_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* negL_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* mulI_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulI_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* mulI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* mulL_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulL_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* mulL_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* salI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* salI_mem_CLNode::memory_operand() const { return _opnds[1]; }
const MachOper* salI_mem_rRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* sarI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* sarI_mem_CLNode::memory_operand() const { return _opnds[1]; }
const MachOper* sarI_mem_rRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* shrI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* shrI_mem_CLNode::memory_operand() const { return _opnds[1]; }
const MachOper* shrI_mem_rRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* salL_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* salL_mem_CLNode::memory_operand() const { return _opnds[1]; }
const MachOper* salL_mem_rRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* sarL_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* sarL_mem_CLNode::memory_operand() const { return _opnds[1]; }
const MachOper* sarL_mem_rRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* shrL_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* shrL_mem_CLNode::memory_operand() const { return _opnds[1]; }
const MachOper* shrL_mem_rRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* rolI_mem_immI8Node::memory_operand() const { return _opnds[1]; }
const MachOper* rorI_mem_immI8Node::memory_operand() const { return _opnds[1]; }
const MachOper* rolL_mem_immI8Node::memory_operand() const { return _opnds[1]; }
const MachOper* rorL_mem_immI8Node::memory_operand() const { return _opnds[1]; }
const MachOper* compressBitsL_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* expandBitsL_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* andI_rReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* andI_rReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* andB_mem_rRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* andB_mem_rReg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* andI_mem_rRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* andI_mem_rReg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* andI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* andnI_rReg_rReg_memNode::memory_operand() const { return _opnds[3]; }
const MachOper* andnI_rReg_rReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* blsiI_rReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* blsiI_rReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* blsmskI_rReg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* blsmskI_rReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* blsrI_rReg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* blsrI_rReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* orI_rReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* orI_rReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* orB_mem_rRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* orB_mem_rReg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* orI_mem_rRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* orI_mem_rReg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* orI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* xorI_rReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* xorI_rReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* xorB_mem_rRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* xorB_mem_rReg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* xorI_mem_rRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* xorI_mem_rReg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* xorI_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* andL_rReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* andL_rReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* andL_mem_rRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* andL_mem_rReg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* andL_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* btrL_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* andnL_rReg_rReg_memNode::memory_operand() const { return _opnds[3]; }
const MachOper* andnL_rReg_rReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* blsiL_rReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* blsiL_rReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* blsmskL_rReg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* blsmskL_rReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* blsrL_rReg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* blsrL_rReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* orL_rReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* orL_rReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* orL_mem_rRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* orL_mem_rReg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* orL_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* btsL_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* xorL_rReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* xorL_rReg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* xorL_mem_rRegNode::memory_operand() const { return _opnds[1]; }
const MachOper* xorL_mem_rReg_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* xorL_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* cmpF_cc_memCFNode::memory_operand() const { return _opnds[2]; }
const MachOper* cmpD_cc_memCFNode::memory_operand() const { return _opnds[2]; }
const MachOper* cmpF_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* cmpD_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* convF2D_reg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* convD2F_reg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* convI2F_reg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* convI2D_reg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* convL2F_reg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* convL2D_reg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* convI2L_reg_mem_zexNode::memory_operand() const { return _opnds[1]; }
const MachOper* compI_rReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* testI_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* testI_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* compU_rReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* compP_rReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* compP_mem_rRegNode::memory_operand() const { return _opnds[2]; }
const MachOper* testP_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* testP_mem_reg0Node::memory_operand() const { return _opnds[1]; }
const MachOper* compN_rReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* compN_mem_immNode::memory_operand() const { return _opnds[2]; }
const MachOper* compN_mem_imm_klassNode::memory_operand() const { return _opnds[2]; }
const MachOper* testN_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* testN_mem_reg0Node::memory_operand() const { return _opnds[1]; }
const MachOper* compL_rReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* testL_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* testL_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* testL_reg_mem2Node::memory_operand() const { return _opnds[2]; }
const MachOper* testL_reg_mem2_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* compUL_rReg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* compB_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* testUB_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* testB_mem_immNode::memory_operand() const { return _opnds[1]; }
const MachOper* addF_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addF_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addF_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addF_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addD_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addD_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* addD_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* addD_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* subF_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* subF_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* subD_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* subD_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulF_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulF_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* mulF_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulF_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* mulD_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulD_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* mulD_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* mulD_reg_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* divF_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* divF_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* divD_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* divD_reg_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* convF2HF_mem_regNode::memory_operand() const { return _opnds[1]; }
const MachOper* vconvF2HF_mem_regNode::memory_operand() const { return _opnds[1]; }
const MachOper* vconvHF2F_reg_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* vroundD_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* vround8D_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* loadVNode::memory_operand() const { return _opnds[1]; }
const MachOper* storeVNode::memory_operand() const { return _opnds[1]; }
const MachOper* gatherNode::memory_operand() const { return _opnds[1]; }
const MachOper* evgatherNode::memory_operand() const { return _opnds[1]; }
const MachOper* evgather_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* vgather_subwordLE8BNode::memory_operand() const { return _opnds[1]; }
const MachOper* vgather_subwordGT8BNode::memory_operand() const { return _opnds[1]; }
const MachOper* vgather_subwordLE8B_offNode::memory_operand() const { return _opnds[1]; }
const MachOper* vgather_subwordGT8B_offNode::memory_operand() const { return _opnds[1]; }
const MachOper* vgather_masked_subwordLE8B_avx3Node::memory_operand() const { return _opnds[1]; }
const MachOper* vgather_masked_subwordGT8B_avx3Node::memory_operand() const { return _opnds[1]; }
const MachOper* vgather_masked_subwordLE8B_off_avx3Node::memory_operand() const { return _opnds[1]; }
const MachOper* vgather_masked_subwordGT8B_off_avx3Node::memory_operand() const { return _opnds[1]; }
const MachOper* vgather_masked_subwordLE8B_avx2Node::memory_operand() const { return _opnds[1]; }
const MachOper* vgather_masked_subwordGT8B_avx2Node::memory_operand() const { return _opnds[1]; }
const MachOper* vgather_masked_subwordLE8B_off_avx2Node::memory_operand() const { return _opnds[1]; }
const MachOper* vgather_masked_subwordGT8B_off_avx2Node::memory_operand() const { return _opnds[1]; }
const MachOper* scatterNode::memory_operand() const { return _opnds[1]; }
const MachOper* scatter_maskedNode::memory_operand() const { return _opnds[1]; }
const MachOper* ReplB_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* ReplS_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* ReplI_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* ReplL_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* ReplF_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* ReplD_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* vaddB_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vaddB_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* vaddS_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vaddS_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* vaddI_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vaddI_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* vaddL_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vaddL_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* vaddF_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vaddF_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* vaddD_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vaddD_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* vsubB_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vsubS_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vsubI_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vsubL_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vsubF_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vsubD_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vmulS_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vmulS_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* vmulI_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vmulI_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* evmulL_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* evmulL_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* vmulF_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vmulF_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* vmulD_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vmulD_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* vdivF_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vdivD_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vector_uminmax_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vector_uminmax_mem_0Node::memory_operand() const { return _opnds[2]; }
const MachOper* vector_uminmax_mem_maskedNode::memory_operand() const { return _opnds[2]; }
const MachOper* vector_uminmax_mem_masked_0Node::memory_operand() const { return _opnds[2]; }
const MachOper* compressBitsI_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* expandBitsI_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vsqrtF_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* vsqrtD_memNode::memory_operand() const { return _opnds[1]; }
const MachOper* vand_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vand_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* vor_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vor_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* vxor_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vxor_mem_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* vfmaF_memNode::memory_operand() const { return _opnds[3]; }
const MachOper* vfmaD_memNode::memory_operand() const { return _opnds[3]; }
const MachOper* vpternlog_memNode::memory_operand() const { return _opnds[3]; }
const MachOper* vmasked_load_avx_non_subwordNode::memory_operand() const { return _opnds[1]; }
const MachOper* vmasked_load_evexNode::memory_operand() const { return _opnds[1]; }
const MachOper* vmasked_store_avx_non_subwordNode::memory_operand() const { return _opnds[1]; }
const MachOper* vmasked_store_evexNode::memory_operand() const { return _opnds[1]; }
const MachOper* vadd_mem_maskedNode::memory_operand() const { return _opnds[2]; }
const MachOper* vadd_mem_masked_0Node::memory_operand() const { return _opnds[2]; }
const MachOper* vadd_mem_masked_1Node::memory_operand() const { return _opnds[2]; }
const MachOper* vadd_mem_masked_2Node::memory_operand() const { return _opnds[2]; }
const MachOper* vadd_mem_masked_3Node::memory_operand() const { return _opnds[2]; }
const MachOper* vadd_mem_masked_4Node::memory_operand() const { return _opnds[2]; }
const MachOper* vxor_mem_maskedNode::memory_operand() const { return _opnds[2]; }
const MachOper* vor_mem_maskedNode::memory_operand() const { return _opnds[2]; }
const MachOper* vand_mem_maskedNode::memory_operand() const { return _opnds[2]; }
const MachOper* vsub_mem_maskedNode::memory_operand() const { return _opnds[2]; }
const MachOper* vsub_mem_masked_0Node::memory_operand() const { return _opnds[2]; }
const MachOper* vsub_mem_masked_1Node::memory_operand() const { return _opnds[2]; }
const MachOper* vsub_mem_masked_2Node::memory_operand() const { return _opnds[2]; }
const MachOper* vsub_mem_masked_3Node::memory_operand() const { return _opnds[2]; }
const MachOper* vsub_mem_masked_4Node::memory_operand() const { return _opnds[2]; }
const MachOper* vmul_mem_maskedNode::memory_operand() const { return _opnds[2]; }
const MachOper* vmul_mem_masked_0Node::memory_operand() const { return _opnds[2]; }
const MachOper* vmul_mem_masked_1Node::memory_operand() const { return _opnds[2]; }
const MachOper* vmul_mem_masked_2Node::memory_operand() const { return _opnds[2]; }
const MachOper* vmul_mem_masked_3Node::memory_operand() const { return _opnds[2]; }
const MachOper* vdiv_mem_maskedNode::memory_operand() const { return _opnds[2]; }
const MachOper* vdiv_mem_masked_0Node::memory_operand() const { return _opnds[2]; }
const MachOper* vmaxv_mem_maskedNode::memory_operand() const { return _opnds[2]; }
const MachOper* vminv_mem_maskedNode::memory_operand() const { return _opnds[2]; }
const MachOper* vfma_mem_maskedNode::memory_operand() const { return _opnds[3]; }
const MachOper* vfma_mem_masked_0Node::memory_operand() const { return _opnds[3]; }
const MachOper* vternlogd_mem_maskedNode::memory_operand() const { return _opnds[3]; }
const MachOper* vector_addsub_saturating_subword_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vector_addsub_saturating_subword_mem_0Node::memory_operand() const { return _opnds[2]; }
const MachOper* vector_addsub_saturating_unsigned_subword_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vector_addsub_saturating_unsigned_subword_mem_0Node::memory_operand() const { return _opnds[2]; }
const MachOper* vector_addsub_saturating_subword_masked_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vector_addsub_saturating_subword_masked_mem_0Node::memory_operand() const { return _opnds[2]; }
const MachOper* vector_addsub_saturating_unsigned_subword_masked_memNode::memory_operand() const { return _opnds[2]; }
const MachOper* vector_addsub_saturating_unsigned_subword_masked_mem_0Node::memory_operand() const { return _opnds[2]; }
const MachOper* compareAndSwapP_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapP_shenandoah_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapN_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndSwapN_shenandoah_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeN_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* compareAndExchangeP_shenandoahNode::memory_operand() const { return _opnds[1]; }
const MachOper* zLoadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* zLoadPNullCheckNode::memory_operand() const { return _opnds[1]; }
const MachOper* zStorePNode::memory_operand() const { return _opnds[1]; }
const MachOper* zStorePNullNode::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndExchangePNode::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndSwapPNode::memory_operand() const { return _opnds[1]; }
const MachOper* zCompareAndSwapP_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* zXChgPNode::memory_operand() const { return _opnds[1]; }
const MachOper* g1StorePNode::memory_operand() const { return _opnds[1]; }
const MachOper* g1StoreNNode::memory_operand() const { return _opnds[1]; }
const MachOper* g1EncodePAndStoreNNode::memory_operand() const { return _opnds[1]; }
const MachOper* g1CompareAndExchangePNode::memory_operand() const { return _opnds[1]; }
const MachOper* g1CompareAndExchangeNNode::memory_operand() const { return _opnds[1]; }
const MachOper* g1CompareAndSwapPNode::memory_operand() const { return _opnds[1]; }
const MachOper* g1CompareAndSwapP_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* g1CompareAndSwapNNode::memory_operand() const { return _opnds[1]; }
const MachOper* g1CompareAndSwapN_0Node::memory_operand() const { return _opnds[1]; }
const MachOper* g1GetAndSetPNode::memory_operand() const { return _opnds[1]; }
const MachOper* g1GetAndSetNNode::memory_operand() const { return _opnds[1]; }
const MachOper* g1LoadPNode::memory_operand() const { return _opnds[1]; }
const MachOper* g1LoadNNode::memory_operand() const { return _opnds[1]; }


bool Matcher::has_match_rule(int opcode) {
  assert(_last_machine_leaf < opcode && opcode < _last_opcode, "opcode in range");
  return _hasMatchRule[opcode];
}

const bool Matcher::_hasMatchRule[_last_opcode] = {
    false,  // Node
    false,  // Set
    false,  // RegN
    false,  // RegI
    false,  // RegP
    false,  // RegF
    false,  // RegD
    false,  // RegL
    false,  // VecA
    false,  // VecS
    false,  // VecD
    false,  // VecX
    false,  // VecY
    false,  // VecZ
    false,  // RegVectMask
    false,  // RegFlags
    false,  // _last_machine_leaf
    true ,  // AbsD
    true ,  // AbsF
    true ,  // AbsI
    true ,  // AbsL
    true ,  // AddD
    true ,  // AddF
    true ,  // AddI
    true ,  // AddL
    true ,  // AddP
    false,  // Allocate
    false,  // AllocateArray
    true ,  // AndI
    true ,  // AndL
    false,  // ArrayCopy
    true ,  // AryEq
    false,  // AtanD
    true ,  // Binary
    false,  // Blackhole
    true ,  // Bool
    false,  // BoxLock
    true ,  // ReverseBytesI
    true ,  // ReverseBytesL
    true ,  // ReverseBytesUS
    true ,  // ReverseBytesS
    true ,  // ReverseBytesV
    false,  // CProj
    true ,  // CacheWB
    true ,  // CacheWBPreSync
    true ,  // CacheWBPostSync
    true ,  // CallDynamicJava
    false,  // CallJava
    true ,  // CallLeaf
    true ,  // CallLeafNoFP
    true ,  // CallLeafVector
    true ,  // CallRuntime
    true ,  // CallStaticJava
    true ,  // CastDD
    true ,  // CastFF
    true ,  // CastII
    true ,  // CastLL
    true ,  // CastVV
    true ,  // CastX2P
    true ,  // CastP2X
    true ,  // CastPP
    false,  // Catch
    false,  // CatchProj
    true ,  // CheckCastPP
    true ,  // ClearArray
    true ,  // CompressBits
    true ,  // ExpandBits
    false,  // CompressBitsV
    false,  // ExpandBitsV
    false,  // ConstraintCast
    true ,  // CMoveD
    true ,  // CMoveF
    true ,  // CMoveI
    true ,  // CMoveL
    true ,  // CMoveP
    true ,  // CMoveN
    true ,  // CmpN
    true ,  // CmpD
    true ,  // CmpD3
    true ,  // CmpF
    true ,  // CmpF3
    true ,  // CmpI
    true ,  // CmpL
    true ,  // CmpL3
    true ,  // CmpLTMask
    true ,  // CmpP
    true ,  // CmpU
    true ,  // CmpU3
    true ,  // CmpUL
    true ,  // CmpUL3
    true ,  // CompareAndSwapB
    true ,  // CompareAndSwapS
    true ,  // CompareAndSwapI
    true ,  // CompareAndSwapL
    true ,  // CompareAndSwapP
    true ,  // CompareAndSwapN
    true ,  // WeakCompareAndSwapB
    true ,  // WeakCompareAndSwapS
    true ,  // WeakCompareAndSwapI
    true ,  // WeakCompareAndSwapL
    true ,  // WeakCompareAndSwapP
    true ,  // WeakCompareAndSwapN
    true ,  // CompareAndExchangeB
    true ,  // CompareAndExchangeS
    true ,  // CompareAndExchangeI
    true ,  // CompareAndExchangeL
    true ,  // CompareAndExchangeP
    true ,  // CompareAndExchangeN
    true ,  // GetAndAddB
    true ,  // GetAndAddS
    true ,  // GetAndAddI
    true ,  // GetAndAddL
    true ,  // GetAndSetB
    true ,  // GetAndSetS
    true ,  // GetAndSetI
    true ,  // GetAndSetL
    true ,  // GetAndSetP
    true ,  // GetAndSetN
    false,  // Con
    true ,  // ConN
    true ,  // ConNKlass
    true ,  // ConD
    true ,  // ConF
    true ,  // ConI
    true ,  // ConL
    true ,  // ConP
    false,  // Conv2B
    true ,  // ConvD2F
    true ,  // ConvD2I
    true ,  // ConvD2L
    true ,  // ConvF2D
    true ,  // ConvF2I
    true ,  // ConvF2L
    true ,  // ConvI2D
    true ,  // ConvI2F
    true ,  // ConvI2L
    true ,  // ConvL2D
    true ,  // ConvL2F
    true ,  // ConvL2I
    true ,  // ConvF2HF
    true ,  // ConvHF2F
    false,  // CountedLoop
    true ,  // CountedLoopEnd
    false,  // OuterStripMinedLoop
    false,  // OuterStripMinedLoopEnd
    false,  // LongCountedLoop
    false,  // LongCountedLoopEnd
    true ,  // CountLeadingZerosI
    true ,  // CountLeadingZerosL
    true ,  // CountLeadingZerosV
    true ,  // CountTrailingZerosI
    true ,  // CountTrailingZerosL
    true ,  // CountTrailingZerosV
    true ,  // CreateEx
    true ,  // DecodeN
    true ,  // DecodeNKlass
    true ,  // DivD
    true ,  // DivF
    true ,  // DivI
    true ,  // DivL
    true ,  // UDivI
    true ,  // UDivL
    false,  // DivMod
    true ,  // DivModI
    true ,  // DivModL
    true ,  // UDivModI
    true ,  // UDivModL
    true ,  // EncodeISOArray
    true ,  // EncodeP
    true ,  // EncodePKlass
    true ,  // FastLock
    true ,  // FastUnlock
    true ,  // FmaD
    true ,  // FmaF
    true ,  // ForwardException
    true ,  // Goto
    true ,  // Halt
    true ,  // CountPositives
    true ,  // If
    false,  // RangeCheck
    false,  // IfFalse
    false,  // IfTrue
    false,  // Initialize
    false,  // JProj
    true ,  // Jump
    false,  // JumpProj
    true ,  // LShiftI
    true ,  // LShiftL
    true ,  // LoadB
    true ,  // LoadUB
    true ,  // LoadUS
    true ,  // LoadD
    false,  // LoadD_unaligned
    true ,  // LoadF
    true ,  // LoadI
    true ,  // LoadKlass
    true ,  // LoadNKlass
    true ,  // LoadL
    false,  // LoadL_unaligned
    true ,  // LoadP
    true ,  // LoadN
    true ,  // LoadRange
    true ,  // LoadS
    false,  // Lock
    false,  // Loop
    false,  // LoopLimit
    false,  // Mach
    false,  // MachNullCheck
    false,  // MachProj
    true ,  // MulAddS2I
    true ,  // MaxI
    false,  // MaxL
    true ,  // MaxD
    true ,  // MaxF
    true ,  // MemBarAcquire
    true ,  // LoadFence
    true ,  // MemBarAcquireLock
    false,  // MemBarCPUOrder
    true ,  // MemBarRelease
    true ,  // StoreFence
    true ,  // StoreStoreFence
    true ,  // MemBarReleaseLock
    true ,  // MemBarVolatile
    true ,  // MemBarStoreStore
    false,  // MergeMem
    true ,  // MinI
    false,  // MinL
    true ,  // MinF
    true ,  // MinD
    false,  // ModD
    false,  // ModF
    true ,  // ModI
    true ,  // ModL
    true ,  // UModI
    true ,  // UModL
    true ,  // MoveI2F
    true ,  // MoveF2I
    true ,  // MoveL2D
    true ,  // MoveD2L
    true ,  // IsInfiniteF
    false,  // IsFiniteF
    true ,  // IsInfiniteD
    false,  // IsFiniteD
    true ,  // MulD
    true ,  // MulF
    true ,  // MulHiL
    true ,  // UMulHiL
    true ,  // MulI
    true ,  // MulL
    false,  // Multi
    true ,  // NegI
    true ,  // NegL
    true ,  // NegD
    true ,  // NegF
    false,  // NeverBranch
    true ,  // OnSpinWait
    false,  // Opaque1
    false,  // OpaqueLoopInit
    false,  // OpaqueLoopStride
    false,  // OpaqueZeroTripGuard
    false,  // OpaqueNotNull
    false,  // OpaqueInitializedAssertionPredicate
    false,  // OpaqueTemplateAssertionPredicate
    false,  // ProfileBoolean
    true ,  // OrI
    true ,  // OrL
    true ,  // OverflowAddI
    true ,  // OverflowSubI
    true ,  // OverflowMulI
    true ,  // OverflowAddL
    true ,  // OverflowSubL
    true ,  // OverflowMulL
    false,  // PCTable
    false,  // Parm
    false,  // ParsePredicate
    true ,  // PartialSubtypeCheck
    false,  // SubTypeCheck
    false,  // Phi
    true ,  // PopCountI
    true ,  // PopCountL
    true ,  // PopCountVI
    true ,  // PopCountVL
    true ,  // PopulateIndex
    true ,  // PrefetchAllocation
    false,  // Proj
    true ,  // RShiftI
    true ,  // RShiftL
    false,  // Region
    true ,  // Rethrow
    true ,  // Return
    true ,  // ReverseI
    true ,  // ReverseL
    true ,  // ReverseV
    false,  // Root
    false,  // RoundDouble
    true ,  // RoundDoubleMode
    true ,  // RoundDoubleModeV
    false,  // RoundFloat
    true ,  // RotateLeft
    true ,  // RotateLeftV
    true ,  // RotateRight
    true ,  // RotateRightV
    true ,  // SafePoint
    false,  // SafePointScalarObject
    false,  // SafePointScalarMerge
    true ,  // ShenandoahCompareAndExchangeP
    true ,  // ShenandoahCompareAndExchangeN
    true ,  // ShenandoahCompareAndSwapN
    true ,  // ShenandoahCompareAndSwapP
    true ,  // ShenandoahWeakCompareAndSwapN
    true ,  // ShenandoahWeakCompareAndSwapP
    false,  // ShenandoahLoadReferenceBarrier
    false,  // SCMemProj
    true ,  // CopySignD
    true ,  // CopySignF
    true ,  // SaturatingAddV
    true ,  // SaturatingSubV
    true ,  // SignumD
    true ,  // SignumF
    true ,  // SignumVF
    true ,  // SignumVD
    true ,  // SqrtD
    true ,  // SqrtF
    true ,  // RoundF
    true ,  // RoundD
    false,  // Start
    false,  // StartOSR
    true ,  // StoreB
    true ,  // StoreC
    true ,  // StoreD
    true ,  // StoreF
    true ,  // StoreI
    true ,  // StoreL
    true ,  // StoreP
    true ,  // StoreN
    true ,  // StoreNKlass
    true ,  // StrComp
    true ,  // StrCompressedCopy
    true ,  // StrEquals
    true ,  // StrIndexOf
    true ,  // StrIndexOfChar
    true ,  // StrInflatedCopy
    true ,  // SubD
    true ,  // SubF
    true ,  // SubI
    true ,  // SubL
    true ,  // TailCall
    true ,  // TailJump
    true ,  // MacroLogicV
    true ,  // ThreadLocal
    false,  // Unlock
    false,  // URShiftB
    false,  // URShiftS
    true ,  // URShiftI
    true ,  // URShiftL
    true ,  // XorI
    true ,  // XorL
    false,  // Vector
    true ,  // AddVB
    true ,  // AddVS
    true ,  // AddVI
    true ,  // AddReductionVI
    true ,  // AddVL
    true ,  // AddReductionVL
    true ,  // AddVF
    true ,  // AddReductionVF
    true ,  // AddVD
    true ,  // AddReductionVD
    true ,  // SubVB
    true ,  // SubVS
    true ,  // SubVI
    true ,  // SubVL
    true ,  // SubVF
    true ,  // SubVD
    true ,  // MulVB
    true ,  // MulVS
    true ,  // MulVI
    true ,  // MulReductionVI
    true ,  // MulVL
    true ,  // MulReductionVL
    true ,  // MulVF
    true ,  // MulReductionVF
    true ,  // MulVD
    true ,  // MulReductionVD
    true ,  // MulAddVS2VI
    true ,  // FmaVD
    true ,  // FmaVF
    true ,  // DivVF
    true ,  // DivVD
    true ,  // AbsVB
    true ,  // AbsVS
    true ,  // AbsVI
    true ,  // AbsVL
    true ,  // AbsVF
    true ,  // AbsVD
    false,  // NegVI
    false,  // NegVL
    true ,  // NegVF
    true ,  // NegVD
    true ,  // SqrtVD
    true ,  // SqrtVF
    true ,  // LShiftCntV
    true ,  // RShiftCntV
    true ,  // LShiftVB
    true ,  // LShiftVS
    true ,  // LShiftVI
    true ,  // LShiftVL
    true ,  // RShiftVB
    true ,  // RShiftVS
    true ,  // RShiftVI
    true ,  // RShiftVL
    true ,  // URShiftVB
    true ,  // URShiftVS
    true ,  // URShiftVI
    true ,  // URShiftVL
    true ,  // AndV
    true ,  // AndReductionV
    true ,  // OrV
    true ,  // OrReductionV
    true ,  // XorV
    true ,  // XorReductionV
    true ,  // MinV
    true ,  // MaxV
    true ,  // UMinV
    true ,  // UMaxV
    true ,  // MinReductionV
    true ,  // MaxReductionV
    true ,  // CompressV
    true ,  // CompressM
    true ,  // ExpandV
    true ,  // LoadVector
    true ,  // LoadVectorGather
    true ,  // LoadVectorGatherMasked
    true ,  // StoreVector
    true ,  // StoreVectorScatter
    true ,  // StoreVectorScatterMasked
    true ,  // LoadVectorMasked
    true ,  // StoreVectorMasked
    true ,  // VerifyVectorAlignment
    true ,  // VectorCmpMasked
    true ,  // VectorMaskGen
    false,  // VectorMaskOp
    true ,  // VectorMaskTrueCount
    true ,  // VectorMaskFirstTrue
    true ,  // VectorMaskLastTrue
    true ,  // VectorMaskToLong
    true ,  // VectorLongToMask
    false,  // Pack
    false,  // PackB
    false,  // PackS
    false,  // PackI
    false,  // PackL
    false,  // PackF
    false,  // PackD
    false,  // Pack2L
    false,  // Pack2D
    true ,  // Replicate
    true ,  // RoundVF
    true ,  // RoundVD
    false,  // Extract
    true ,  // ExtractB
    false,  // ExtractUB
    false,  // ExtractC
    true ,  // ExtractS
    true ,  // ExtractI
    true ,  // ExtractL
    true ,  // ExtractF
    true ,  // ExtractD
    false,  // Digit
    false,  // LowerCase
    false,  // UpperCase
    false,  // Whitespace
    true ,  // SelectFromTwoVector
    false,  // VectorBox
    false,  // VectorBoxAllocate
    false,  // VectorUnbox
    false,  // VectorMaskWrapper
    true ,  // VectorMaskCmp
    true ,  // VectorMaskCast
    true ,  // VectorTest
    true ,  // VectorBlend
    true ,  // VectorRearrange
    true ,  // VectorLoadMask
    true ,  // VectorLoadShuffle
    true ,  // VectorLoadConst
    true ,  // VectorStoreMask
    true ,  // VectorReinterpret
    false,  // VectorCast
    true ,  // VectorCastB2X
    true ,  // VectorCastS2X
    true ,  // VectorCastI2X
    true ,  // VectorCastL2X
    true ,  // VectorCastF2X
    true ,  // VectorCastD2X
    true ,  // VectorCastF2HF
    true ,  // VectorCastHF2F
    true ,  // VectorUCastB2X
    true ,  // VectorUCastS2X
    true ,  // VectorUCastI2X
    true ,  // VectorizedHashCode
    true ,  // VectorInsert
    true ,  // MaskAll
    true ,  // AndVMask
    true ,  // OrVMask
    true    // XorVMask
};


int Compile::sync_stack_slots() const { return 2; }

uint Matcher::stack_alignment_in_bytes() { return StackAlignmentInBytes; }

OptoReg::Name Matcher::return_addr() const { return OptoReg::stack2reg(- 2 +
              align_up((Compile::current()->in_preserve_stack_slots() +
                        Compile::current()->fixed_slots()),
                       stack_alignment_in_slots())); }

uint Compile::varargs_C_out_slots_killed() const { return frame::arg_reg_save_area_bytes/BytesPerInt; }

OptoRegPair Matcher::return_value(uint ideal_reg) {

#line 1998 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    assert(ideal_reg >= Op_RegI && ideal_reg <= Op_RegL,
           "only return normal values");

    static const int lo[Op_RegL + 1] = {
      0,
      0,
      RAX_num,  // Op_RegN
      RAX_num,  // Op_RegI
      RAX_num,  // Op_RegP
      XMM0_num, // Op_RegF
      XMM0_num, // Op_RegD
      RAX_num   // Op_RegL
    };
    static const int hi[Op_RegL + 1] = {
      0,
      0,
      OptoReg::Bad, // Op_RegN
      OptoReg::Bad, // Op_RegI
      RAX_H_num,    // Op_RegP
      OptoReg::Bad, // Op_RegF
      XMM0b_num,    // Op_RegD
      RAX_H_num     // Op_RegL
    };
    // Excluded flags and vector registers.
    assert(ARRAY_SIZE(hi) == _last_machine_leaf - 8, "missing type");
    return OptoRegPair(hi[ideal_reg], lo[ideal_reg]);
  
#line 47339 "ad_x86.cpp"

}

OptoRegPair Matcher::c_return_value(uint ideal_reg) {

#line 1998 "/home/iurt/rpmbuild/BUILD/java-latest-openjdk-24.0.1.0.9-build/java-24-openjdk-24.0.1.0.9-1.rolling.1.mga10.x86_64/openjdk/src/hotspot/cpu/x86/x86_64.ad"

    assert(ideal_reg >= Op_RegI && ideal_reg <= Op_RegL,
           "only return normal values");

    static const int lo[Op_RegL + 1] = {
      0,
      0,
      RAX_num,  // Op_RegN
      RAX_num,  // Op_RegI
      RAX_num,  // Op_RegP
      XMM0_num, // Op_RegF
      XMM0_num, // Op_RegD
      RAX_num   // Op_RegL
    };
    static const int hi[Op_RegL + 1] = {
      0,
      0,
      OptoReg::Bad, // Op_RegN
      OptoReg::Bad, // Op_RegI
      RAX_H_num,    // Op_RegP
      OptoReg::Bad, // Op_RegF
      XMM0b_num,    // Op_RegD
      RAX_H_num     // Op_RegL
    };
    // Excluded flags and vector registers.
    assert(ARRAY_SIZE(hi) == _last_machine_leaf - 8, "missing type");
    return OptoRegPair(hi[ideal_reg], lo[ideal_reg]);
  
#line 47374 "ad_x86.cpp"

}

OptoReg::Name Matcher::inline_cache_reg() { return OptoReg::Name(RAX_num); }

int Matcher::inline_cache_reg_encode() { return _regEncode[inline_cache_reg()]; }

OptoReg::Name Matcher::interpreter_frame_pointer_reg() { return OptoReg::Name(RBP_num); }

OptoReg::Name Matcher::c_frame_pointer() const { return OptoReg::Name(RSP_num); }

// Number of callee-save + always-save registers
int  Matcher::number_of_saved_registers() {
  return 0;
};

bool Compile::needs_deep_clone_jvms() { return false; }

// Check consistency of C++ compilation with ADLC options:
// Check adlc -DLINUX=1
#ifndef LINUX
#  error "LINUX must be defined"
#endif // LINUX
// Check adlc -D_GNU_SOURCE=1
#ifndef _GNU_SOURCE
#  error "_GNU_SOURCE must be defined"
#endif // _GNU_SOURCE
// Check adlc -DAMD64=1
#ifndef AMD64
#  error "AMD64 must be defined"
#endif // AMD64
// Check adlc -D_LP64=1
#ifndef _LP64
#  error "_LP64 must be defined"
#endif // _LP64
// Check adlc -DASSERT=1
#ifndef ASSERT
#  error "ASSERT must be defined"
#endif // ASSERT
